IMPLEMENTATION MODULE AssFuncs;

FROM SYSTEM IMPORT ADDRESS, ASSEMBLER;

IMPORT MagicStrings;

CONST   CR      = 15C;
        LF      = 12C;
        TAB     = 11C;

(*$L-,R-,S-,Z+*)

(* Fr Editbase *)
PROCEDURE findLineEnd (buf : ADDRESS; startIdx : LONGCARD; max : LONGCARD) : LONGCARD;
BEGIN
  ASSEMBLER
    MOVE.L      -(A3),D1
    MOVE.L      -(A3),D0        ; startIdx
    MOVE.L      -(A3),A0
    ADDA.L      D0,A0
loop:
    CMP.L       D1,D0
    BGT.S       found
    MOVE.B      (A0)+,D2
    BEQ.S       found
    CMPI.B      #CR,D2
    BEQ.S       found
    CMPI.B      #LF,D2
    BEQ.S       found
;    CMPI.B      #$1A,D2
;    BEQ.S       found
; gendert: Keine Wandlung mehr von irgendwelchen Zeichen
;    CMPI.B      #$1F,D2
;    BGT.S       goon
;    CMPI.B      #0,D2
;    BLE.S       goon
;    ; Zeichen < 32 werden in Spaces gewandelt 
;    CMPI.B      #$10,D2
;    BEQ.S       goon
;    CMPI.B      #TAB,D2
;    BEQ.S       goon        ; TAB nicht wandeln!
;    MOVE.B      #' ',-1(A0)
goon:
    ADDQ.L      #1,D0
    BRA.S       loop
found:
;    CMPI.B      #$1A,D2
;    BNE.S       exit
;    MOVE.B      #0,-1(A0)
exit:
  END;
END findLineEnd;

(* Fr Case-Insensitive Stringvergleiche *)
PROCEDURE StrIequal (REF s1, s2 : ARRAY OF CHAR): BOOLEAN;
BEGIN
  ASSEMBLER
;        MOVEM.L D3-D7,-(SP)
        MOVE    -(A3),D0
        MOVE.L  -(A3),A0
        MOVE.W  -(A3),D1
        MOVE.L  -(A3),A1
        LEA     tab(PC),A2
        CLR.W   D2

l       MOVE.B  (A0)+,D2
        BEQ.S   equ1
        SWAP    D1
        CLR.W   D1
        MOVE.B  0(A2,D2.W),D2
        MOVE.B  (A1)+,D1
        CMP.B   0(A2,D1.W),D2
        BNE.S   ne
        SWAP    D1
        SUBQ.W  #1,D0
        BCS.S   e
        DBRA    D1,l

        ; str1 zu Ende, str0 aber nicht
        TST.B   (A0)+
        BEQ.S   equ0
        BRA.S   ne

equ1    ; str0 zu Ende, str1 prfen
        TST.B   (A1)+
        BEQ     equ0

ne      CLR     D0
;        MOVEM.L (SP)+,D3-D7
        RTS

e       ; str0 zu Ende, str1 prfen
        TST.W   D1
        BEQ.S   equ0
        TST.B   (A1)+
        BNE.S   ne

equ0    MOVE    #1,D0
;        MOVEM.L (SP)+,D3-D7
        RTS

  tab:  DC.B $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F
        DC.B $10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F
        DC.B ' ','!','"','#','$','%','&',$27,'(',')','*','+',',','-','.','/'
        DC.B '0','1','2','3','4','5','6','7','8','9',':',';','<','=','>','?'
        DC.B '@','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O'
        DC.B 'P','Q','R','S','T','U','V','W','X','Y','Z','[','\',']','^','_'
        DC.B '`','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O'
        DC.B 'P','Q','R','S','T','U','V','W','X','Y','Z','{','|','}','~',''
        DC.B '','','','A','','','','','E','E','E','I','I','I','',''
        DC.B '','','','O','','O','U','U','','','','','','','',''
        DC.B 'A','I','O','U','','','','','','','','','','','',''
        DC.B '','','','','','','','','','','','','','','',''
        DC.B '','','','','','','','','','','','','','','',''
        DC.B '','','','','','','','','','','','','','','',''
        DC.B '','','','','','','','','','','','','','','',''
        DC.B '','','','','','','','','','','','','','','',''
  END
END StrIequal;

PROCEDURE StrICompare (REF str0,str1: ARRAY OF CHAR) : MagicStrings.Relation;
  BEGIN
    ASSEMBLER
;        MOVEM.L D3-D7,-(SP)
        MOVE.W  -(A3),D0    ; HIGH (str1)
        MOVE.L  -(A3),A0    ; ADR (str1)
        MOVE.W  -(A3),D1    ; HIGH (str0)
        MOVE.L  -(A3),A1    ; ADR (str0)

        (*
        MOVEM.L D0-D7/A0-A6,-(SP)
        LEA     str(PC),A2
        MOVE.L  A0,-(SP)
        MOVE.L  A1,-(SP)
        MOVE.L  A2,-(SP)
        MOVE.W  #4201,-(SP)     ; sysprintf
        TRAP    #1
        ADDA.L  #14,SP
        MOVEM.L (SP)+,D0-D7/A0-A6
        *)

        CLR.W   D2
        LEA     tab(PC),A2

l       MOVE.B  (A0)+,D2
        BEQ.S   equ1
        MOVE.B  0(A2,D2.W),D2   ; tab[str1[i]] in D2
        SWAP    D1
        CLR.W   D1
        MOVE.B  (A1)+,D1        ;str2[i] in D1
        CMP.B   0(A2,D1.W),D2
        BNE.S   ne
        SWAP    D1
        SUBQ.W  #1,D0
        BCS.S   e
        DBRA    D1,l

        ; str1 zu Ende, str0 aber nicht
        TST.B   (A0)+
        BEQ.S   equ0
        BRA.S   hi

equ1    ; str0 zu Ende, str1 prfen
        TST.B   (A1)+
        BEQ.S   equ0
        BRA.S   low

ne      CLR.W   D2
        MOVE.B  -(A0),D2
        MOVE.B  0(A2,D2.W),D1
        CLR.W   D0
        MOVE.B  -(A1),D0
        CMP.B   0(A2,D0.W),D1
        BHI.S   hi
        BCS.S   low
        CMP.B   D0,D2   ; wenn Umlaute gleich, dann ASCII-Wert vergleichen
        BHI.S   hi
        BRA.S   low

e       ; str0 zu Ende, str1 prfen
        TST.W   D1
        BEQ.S   equ0
        TST.B   (A1)+
        BNE.S   low

equ0    MOVE    #MagicStrings.equal,D0
        BRA.S   end
hi      MOVE    #MagicStrings.less,D0
        BRA.S   end
low     MOVE    #MagicStrings.greater,D0
end     ; MOVEM.L (SP)+,D3-D7

        (*
        MOVEM.L D0-D7/A0-A6,-(SP)
        LEA     str2(PC),A2
        MOVE.W  D0,-(SP)
        MOVE.L  A2,-(SP)
        MOVE.W  #4201,-(SP)     ; sysprintf
        TRAP    #1
        ADDQ.L  #8,SP
        MOVEM.L (SP)+,D0-D7/A0-A6
        *)

        RTS

(*
  tab:  DC.B $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F
        DC.B $10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F
        DC.B ' ','!','"','#','$','%','&',$27,'(',')','*','+',',','-','.','/'
        DC.B '0','1','2','3','4','5','6','7','8','9',':',';','<','=','>','?'
        DC.B '@','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O'
        DC.B 'P','Q','R','S','T','U','V','W','X','Y','Z','[','\',']','^','_'
        DC.B '`','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O'
        DC.B 'P','Q','R','S','T','U','V','W','X','Y','Z','{','|','}','~',''

        DC.B    'C','U','E','A','A','A','A','C','E','E','E','I','I','I','A','A'
        DC.B    'E','A','A','O','O','O','U','U','Y','O','U',$9B,$9C,$9D,'S',$9F
        DC.B    'A','I','I','U','N','N','A','O',$A8,$A9,$AA,$AB,$AC,$AD,$AE,$AF
        DC.B    'A','O','O','O','O','O','A','A','O',$B9,$BA,$BB,$BC,$BD,$BE,$BF
        DC.B    'I','I',$C2,$C3,$C4,$C5,$C6,$C7,$C8,$C9,$CA,$CB,$CC,$CD,$CE,$CF

;        DC.B '','','','A','','','','','E','E','E','I','I','I','',''
;        DC.B '','','','O','','O','U','U','','','','','','','',''
;        DC.B 'A','I','O','U','','','','','','','','','','','',''
;        DC.B '','','','','','','','','','','','','','','',''
;        DC.B '','','','','','','','','','','','','','','',''
        DC.B '','','','','','','','','','','','','','','',''
        DC.B '','','','','','','','','','','','','','','',''
        DC.B '','','','','','','','','','','','','','','',''
*)
str:    ACZ    "iComp: %s with %s"
        SYNC
str2:   ACZ    "res: %d "
        SYNC
tab     DC.B    $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F
        DC.B    $10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F
        DC.B    $20,$21,$22,$23,$24,$25,$26,$27,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F
        DC.B    $30,$31,$32,$33,$34,$35,$36,$37,$38,$39,$3A,$3B,$3C,$3D,$3E,$3F
        DC.B    $40,$41,$42,$43,$44,$45,$46,$47,$48,$49,$4A,$4B,$4C,$4D,$4E,$4F
        DC.B    $50,$51,$52,$53,$54,$55,$56,$57,$58,$59,$5A,$5B,$5C,$5D,$5E,$5F

        DC.B    $60,$41,$42,$43,$44,$45,$46,$47,$48,$49,$4A,$4B,$4C,$4D,$4E,$4F
        DC.B    $50,$51,$52,$53,$54,$55,$56,$57,$58,$59,$5A,$7B,$7C,$7D,$7E,$7F

        DC.B    'C','U','E','A','A','A','A','C','E','E','E','I','I','I','A','A'
        DC.B    'E','A','A','O','O','O','U','U','Y','O','U',$9B,$9C,$9D,'s',$9F
        DC.B    'A','I','I','U','N','N','A','O',$A8,$A9,$AA,$AB,$AC,$AD,$AE,$AF
        DC.B    'A','O','O','O','O','O','A','A','O',$B9,$BA,$BB,$BC,$BD,$BE,$BF
        DC.B    'I','I',$C2,$C3,$C4,$C5,$C6,$C7,$C8,$C9,$CA,$CB,$CC,$CD,$CE,$CF
        DC.B    $D0,$D1,$D2,$D3,$D4,$D5,$D6,$D7,$D8,$D9,$DA,$DB,$DC,$DD,$DE,$DF
        DC.B    $E0,$E1,$E2,$E3,$E4,$E5,$E6,$E7,$E8,$E9,$EA,$EB,$EC,$ED,$EE,$EF
        DC.B    $F0,$F1,$F2,$F3,$F4,$F5,$F6,$F7,$F8,$F9,$FA,$FB,$FC,$FD,$FE,$FF
    END
  END StrICompare;

PROCEDURE CopyId (REF source: ARRAY OF CHAR; VAR dest: ARRAY OF CHAR): CARDINAL;
(* Kopiert eine ID, wandelt dabei den domain-part (alles nach @) in Upcase
 * und liefert die Lnge zurck
 *)
BEGIN
  ASSEMBLER
        MOVE.W  -(A3),D0    ; HIGH (dest)
        MOVE.L  -(A3),A0    ; ADR (dest)
        MOVE.W  -(A3),D1    ; HIGH (src)
        MOVE.L  -(A3),A1    ; ADR (src)
        MOVEQ   #1,D2       ; Lngenzhler initialisieren
        LEA     tab(PC),A2
        
        MOVEQ   #'@',D3     ; Begrenzungszeichen 
        BRA.S   nameentry

nameloop:
        ADDQ.W  #1,D2       ; Ein Zeichen mehr
        SUBQ    #1,D0
        BCS     ok2         ; Highmarke erreicht
nameentry:
        MOVE.B  (A1)+,D4
        MOVE.B  D4,(A0)+    ; Nach Zielstring
        BEQ     end
        CMP.B   D3,D4       ; '@' gefunden?
        BEQ.S   caseentry
        DBRA  D1,nameloop
        BRA.S   end
caseentry:
        MOVEQ   #0,D3
        BRA.S   caseentry2
caseloop:
        SUBQ    #1,D0
        BCS     ok2         ; Highmarke erreicht
caseentry2:
        ADDQ.W  #1,D2       ; Ein Zeichen mehr
        MOVE.B  (A1)+,D3
        MOVE.B  0(A2,D3.W),(A0)+
        DBEQ    D1,caseloop
        BEQ     end         ; Ende der Source wurde mitkopiert

ok2:    CLR.B   (A0)+       ; Noch terminieren
end:
        MOVE.W  D2,D0       ; Lnge zurckgeben
        SUBQ.W  #1,D0       ; ist ein Zeichen zu viel!
        RTS
        
; Tabelle fr Upcase
  tab:  DC.B $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F
        DC.B $10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F
        DC.B ' ','!','"','#','$','%','&',$27,'(',')','*','+',',','-','.','/'
        DC.B '0','1','2','3','4','5','6','7','8','9',':',';','<','=','>','?'
        DC.B '@','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O'
        DC.B 'P','Q','R','S','T','U','V','W','X','Y','Z','[','\',']','^','_'
        DC.B '`','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O'
        DC.B 'P','Q','R','S','T','U','V','W','X','Y','Z','{','|','}','~',''
        DC.B '','','','A','','','','','E','E','E','I','I','I','',''
        DC.B '','','','O','','O','U','U','','','','','','','',''
        DC.B 'A','I','O','U','','','','','','','','','','','',''
        DC.B '','','','','','','','','','','','','','','',''
        DC.B '','','','','','','','','','','','','','','',''
        DC.B '','','','','','','','','','','','','','','',''
        DC.B '','','','','','','','','','','','','','','',''
        DC.B '','','','','','','','','','','','','','','',''
  END;
END CopyId;

PROCEDURE CmpId (REF str1, str2 : ARRAY OF CHAR): BOOLEAN;
(* Vergleicht zwei IDs miteinander, wobei der domain-part case-insensitiv
 * behandelt wird.
 *)
BEGIN
  ASSEMBLER
;        MOVEM.L D3-D7,-(SP)
        MOVE    -(A3),D0
        MOVE.L  -(A3),A0
        MOVE.W  -(A3),D1
        MOVE.L  -(A3),A1
        LEA     tab(PC),A2
        CLR.W   D2
        MOVEQ   #'@',D3

nocase  MOVE.B  (A0)+,D2
        BEQ.S   equ1
        CMP.B   (A1)+,D2
        BNE.S   ne
        SUBQ.W  #1,D0
        BCS.S   e
        CMP.B   D3,D2   ; '@' gefunden?
        BNE.S   cont    ; nein, normal weiter
        SUBQ    #1,D1
        BRA.S   case
cont:
        DBRA    D1,nocase
        BRA     str1end
    
case    MOVE.B  (A0)+,D2
        BEQ.S   equ1
        SWAP    D1
        CLR.W   D1
        MOVE.B  0(A2,D2.W),D2
        MOVE.B  (A1)+,D1
        CMP.B   0(A2,D1.W),D2
        BNE.S   ne
        SWAP    D1
        SUBQ.W  #1,D0
        BCS.S   e
        DBRA    D1,case

str1end:
        ; str1 zu Ende, str0 aber nicht
        TST.B   (A0)+
        BEQ.S   equ0
        BRA.S   ne

equ1    ; str0 zu Ende, str1 prfen
        TST.B   (A1)+
        BEQ     equ0

ne      CLR     D0
;        MOVEM.L (SP)+,D3-D7
        RTS

e       ; str0 zu Ende, str1 prfen
        TST.W   D1
        BEQ.S   equ0
        TST.B   (A1)+
        BNE.S   ne

equ0    MOVE    #1,D0
;        MOVEM.L (SP)+,D3-D7
        RTS

  tab:  DC.B $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F
        DC.B $10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F
        DC.B ' ','!','"','#','$','%','&',$27,'(',')','*','+',',','-','.','/'
        DC.B '0','1','2','3','4','5','6','7','8','9',':',';','<','=','>','?'
        DC.B '@','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O'
        DC.B 'P','Q','R','S','T','U','V','W','X','Y','Z','[','\',']','^','_'
        DC.B '`','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O'
        DC.B 'P','Q','R','S','T','U','V','W','X','Y','Z','{','|','}','~',''
        DC.B '','','','A','','','','','E','E','E','I','I','I','',''
        DC.B '','','','O','','O','U','U','','','','','','','',''
        DC.B 'A','I','O','U','','','','','','','','','','','',''
        DC.B '','','','','','','','','','','','','','','',''
        DC.B '','','','','','','','','','','','','','','',''
        DC.B '','','','','','','','','','','','','','','',''
        DC.B '','','','','','','','','','','','','','','',''
        DC.B '','','','','','','','','','','','','','','',''
  END
END CmpId;

PROCEDURE WandleIso (str: ADDRESS; strLen: CARDINAL);
(* Wandelt den String von ISO-8859-1 nach ST-Zeichensatz um
 *)
BEGIN
  ASSEMBLER
        MOVE.W  -(A3),D0        ; Lnge
        MOVE.L  -(A3),A0        ; ADR(str)
        LEA     tab(PC),A1
        SUBQ.W  #1,D0           ; -1 fr DBRA
loop:   MOVE.B  (A0),D1
        MOVE.B  0(A1,D1.W),(A0)+
        DBRA    D0,loop
ende:   RTS

tab:    DC.B $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F
        DC.B $10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F
        DC.B $20,$21,$22,$23,$24,$25,$26,$27,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F
        DC.B $30,$31,$32,$33,$34,$35,$36,$37,$38,$39,$3A,$3B,$3C,$3D,$3E,$3F
        DC.B $40,$41,$42,$43,$44,$45,$46,$47,$48,$49,$4A,$4B,$4C,$4D,$4E,$4F
        DC.B $50,$51,$52,$53,$54,$55,$56,$57,$58,$59,$5A,$5B,$5C,$5D,$5E,$5F
        DC.B $60,$61,$62,$63,$64,$65,$66,$67,$68,$69,$6A,$6B,$6C,$6D,$6E,$6F
        DC.B $70,$71,$72,$73,$74,$75,$76,$77,$78,$79,$7A,$7B,$7C,$7D,$7E,$7F

(* Neue Tabelle aus GNU recode *)
        DC.B 199, 252, 233, 226, 228, 224, 229, 231 (* 128 - 135 *)
        DC.B 234, 235, 232, 239, 238, 236, 196, 197 (* 136 - 143 *)
        DC.B 201, 230, 198, 244, 247, 242, 251, 249 (* 144 - 151 *)
        DC.B 187, 214, 220, 243, 195, 209, 223, 159 (* 152 - 159 *)
        DC.B 225, 173, 155, 156, 245, 157, 192, 221 (* 160 - 167 *)
        DC.B 185, 189, 166, 174, 170, 237, 190, 255 (* 168 - 175 *)
        DC.B 227, 241, 253, 254, 186, 181, 188, 250 (* 176 - 183 *)
        DC.B 213, 191, 167, 175, 172, 171, 169, 168 (* 184 - 191 *)
        DC.B 182, 193, 194, 183, 142, 143, 146, 128 (* 192 - 199 *)
        DC.B 200, 144, 202, 203, 204, 205, 206, 207 (* 200 - 207 *)
        DC.B 208, 165, 210, 211, 212, 184, 153, 215 (* 208 - 215 *)
        DC.B 178, 217, 218, 219, 154, 180, 222, 158 (* 216 - 223 *)
        DC.B 133, 160, 131, 176, 132, 134, 145, 135 (* 224 - 231 *)
        DC.B 138, 130, 136, 137, 141, 161, 140, 139 (* 232 - 239 *)
        DC.B 240, 164, 149, 162, 147, 177, 148, 246 (* 240 - 247 *)
        DC.B 179, 151, 163, 150, 129, 216, 248, 152 (* 248 - 255 *)

(* Alte Tabelle
        DC.B 128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143
        DC.B 144,145,146,147,148,149,150,151,152,153,154,155,156,157,225,159
        DC.B  32,173,155,156,120,157,124,221, 34, 67,166,174,170, 45, 82,223
        DC.B 248,241,253,252, 39,230,227,249, 44, 49,167,175,172,171, 47,168
        DC.B 133,160,131, 65,142,143,146,128,138,144,136,137,141,161,140,139
        DC.B  68,165,149,162,147,111,153,120,237,151,163,150,154,121, 80,158
        DC.B 133,160,131, 97,132,134,145,135,138,130,136,137,141,161,140,139
        DC.B 100,164,149,162,147,111,148,246,237,151,163,150,129,121,112,152
*)
  END;
END WandleIso;


END AssFuncs.

