IMPLEMENTATION MODULE CatEdit;
(*$Z+*) (* In diesem Modul immer Ergebnisrckgabe ber D0 *)
(*$Y+*) (* Mu hier gesetzt sein, damit man auf die Shell-Variablen zugreifen kann 
         * und damit der Compiler auf meine Variablen zugreifen kann!
         *)

FROM SYSTEM     IMPORT  ADDRESS, ADR, TSIZE, CADR, LOC, LONGWORD, WORD, ASSEMBLER, CAST, CALLSYS, BYTE;

(* Megamax-Lib *)

FROM Storage    IMPORT ALLOCATE, DEALLOCATE, Inconsistent;

FROM GrafBase   IMPORT LongRect, Rectangle, Point;

IMPORT Storage, Strings, BinOps, Block, StrConv, 
       MOSGlobals, Keyboard, Characters, Lists;

FROM Keyboard  IMPORT SpecialCode;

(* MagicLib *)
IMPORT MagicAES, MagicVDI, MagicDOS, MagicBIOS, MagicSys, MagicFSM, 
       mtAlerts, mtAppl, mtDials, mtUtils, MagicStrings, mtTextfiles,
       MintUtil, Mintbind;

FROM MagicVDI   IMPORT VDIIntIn, VDIPtsIn, VDIControl;

(* CAT Module *)
IMPORT CatFiles, MTE, CatGlobal, Clip;

FROM Void       IMPORT v;

IMPORT FontSelect;

(* Editor  *)
FROM EditTypes  IMPORT EDITPTR, EDITOR, aLinePtr, aLineDesc, aLine, textPtr, bigTextPtr, 
                       aMark, userProcType, userGetRectProc, drawUserProc, userCloseProc, 
                       deskSize, pixOff, undoType, SuchFlags, SuchModus, searchDir, 
                       searchPos, searchCount, CAT, CharSet, TrennSet, UmbruchSet,
                       userKeyProc, userTopProc, userUntopProc, userPrePrintProc, 
                       userListProc, theDrawLine, aBufferPtr, aBuffer, LFIRST, LNEXT,
                       cursorHandle, maxBlocks;

IMPORT EditTypes;

FROM EditGlobals        IMPORT  InqTextextend, ClipWork, 
                                MouseArrow, MouseBusy, MouseHand,
                                HideMouse, ShowMouse, HideCursor, 
                                ShowCursor, ForceCursor, drawCursor, RowToIndex, 
                                SetDocument, CursorIsOn;
FROM EditTools          IMPORT  SetInfoLine, SetEditTitle, ShowFileChanged, 
                                SetCurrLine, SetStartLine, getCharPos, 
                                SaveLine, SaveOp, DeleteLine, 
                                Undo, NewBlockToUndoBuffer,  
                                SetBlockstart, SetBlockend,
                                GetClickLineAndRow, TestBlockMarksAndSwap, ToWordEnd,
                                ToWordStart, ToLineStart, ToLineEnd, MarkLine, MarkBlock, 
                                ToBlockmark, SearchWord, ReplaceWord, FreeUndoBuffer;
                                
                                
FROM EditDraw           IMPORT  drawLine, redrawLine, 
                                redrawLines, redrawWdw,
                                redrawLineArea, scrollRegion, CenterCurrline,
                                GetBlockRects; 
IMPORT EditBase, EditFuncs, EditGlobals, EditTools, EditUtil;
IMPORT WdwManager;
IMPORT ConfVars;
IMPORT Printer;
IMPORT Varnames;
IMPORT RectFuncs;
IMPORT AssFuncs;
IMPORT UUDecode;

(*
FROM InOut     IMPORT WriteString, WriteLn, WriteLHex, ReadLInt;
*)
        
(*$? NOT CAT:
(* Fr Compilierung im Speicher *)
IMPORT Loader, Directory, Paths, ShellMsg, PathEnv;
*)
IMPORT FileNames;

(*$? CAT:
IMPORT Protokoll;
*)

CONST   Debug    = FALSE;

(*$? CAT:
CONST   progName = 'CAT:';
*)
(*$? NOT CAT:
CONST   progName = 'Fred:';
*)

CONST   
        memFault = '[1]['+progName+'|Speicherverwaltung|inkonsistent!!][[Ok]';

        blockPrint  = '[2]['+progName+'|Wollen Sie den Block drucken?|]';
        printAll    = '[2]['+progName+'|Wollen Sie den gesamten|Text wirklich drucken?|]';
        blockBut    = '[[Ja|:[Nein]';
        blockButF   = '[[Mit Feed|[Ja|:[Nein]';
        printBusy   = '[2]['+progName+'|Der Drucker ist|nicht ansprechbar.|Ist er auch|angeschaltet?][[Weiter|:[Abbruch]';
        printCancel = '[1]['+progName+'|Der Druckvorgang|wurde abgebrochen.][[Ok]';
        printDOSErr = '[3]['+progName+'|Kann Druckkanal nicht ffnen.|Der Druckvorgang|wird abgebrochen.][[Abbruch]';
        editAbandon = "[2]["+progName+"|Soll der Text durch die|zuletzt gesicherte Version|ersetzt werden?][ber[laden|:[Abbruch]";

        textChanged = '[2]['+progName+'|Sollen die nderungen in|&|noch gesichert werden?][[Ja|[Nein|:[Abbruch]';
        textNotSaved = '[2]['+progName+'|Sollen die nderungen in|&|vorher gesichert werden? Falls sie|nicht gesichert werden, gehen alle|nderungen an dem Text verloren!][[Ja|:[Nein]';

        noEditOpen  = "[3]["+progName+"|Der Editor kann nicht|geffnet werden, da kein|Fenster oder keine|VDI-Workstation mehr frei ist][:[Abbruch]";
        noBuffOpen  = "[3]["+progName+"|Das Anzeigefenster kann nicht|geffnet werden, da kein|Fenster oder keine|VDI-Workstation mehr frei ist][:[Abbruch]";
        
        txtExt  = '*.*';
        
        cNoname = 'namenlos.txt';
                       
        ScrapName = 'SCRAP.TXT';
        
        CR      = 15C;
        LF      = 12C;
        TAB     = 11C;

TYPE
     Str128     = ARRAY [0..127] OF CHAR;
     numSet     = SET OF [0..255];

VAR lastOpWasCtrlY : BOOLEAN;
    nums           : numSet;


(*$? Debug:
(*$L-*)
PROCEDURE Sys4 (REF s1 : ARRAY OF CHAR; str : ADDRESS; val1, val2, val3, val4 : WORD);
BEGIN
  ASSEMBLER
    MOVE.W      -(A3),-(SP)
    MOVE.W      -(A3),-(SP)
    MOVE.W      -(A3),-(SP)
    MOVE.W      -(A3),-(SP)
    MOVE.L      -(A3),-(SP)
    SUBQ.L      #2,A3
    MOVE.L      -(A3),-(SP)
    MOVE.W      #4201,-(SP)
    TRAP        #1
    LEA         18(SP),SP
  END;
END Sys4;
(*$L+*)

(*$W-*)
PROCEDURE dumpRect(REF name : ARRAY OF CHAR; r : Rectangle);
BEGIN
  Sys4 ("Var: %s, r.x=%d, r.y=%d, r.w=%d, r.h=%d", ADR(name), r.x, r.y, r.w, r.h);
END dumpRect;
(*$W=*)

(*$L-*)
PROCEDURE Sys (REF s : ARRAY OF CHAR; val : LONGWORD);
BEGIN
  ASSEMBLER
    MOVE.L      -(A3),-(SP)
    SUBQ.L      #2,A3
    MOVE.L      -(A3),-(SP)
    MOVE.W      #4201,-(SP)
    TRAP        #1
    LEA         10(SP),SP
  END;
END Sys;

PROCEDURE Sys2 (REF s : ARRAY OF CHAR; val1, val2, val3 : LONGWORD);
BEGIN
  ASSEMBLER
    MOVE.L      -(A3),-(SP)
    MOVE.L      -(A3),-(SP)
    MOVE.L      -(A3),-(SP)
    SUBQ.L      #2,A3
    MOVE.L      -(A3),-(SP)
    MOVE.W      #4201,-(SP)
    TRAP        #1
    LEA         18(SP),SP
  END;
END Sys2;

PROCEDURE SysBreak ();
BEGIN
  ASSEMBLER
    MOVE.W      #4200,-(SP)
    TRAP        #1
    ADDQ.L      #2,SP
  END;
END SysBreak;

PROCEDURE validAdr (adr : ADDRESS) : BOOLEAN;
BEGIN
  ASSEMBLER
                MOVE.W  D7,-(SP)
                MOVE.L  A6,-(SP)

                MOVE.L   -(A3),A6
                BRA.S    CONT_TEST
                
BUSERR_C:       MOVE.L  A1,$08
                MOVEA.L D1,SP

                MOVE    D0,SR

                TRAP    #$01            ;SUPER( OLD );
                ADDQ.L  #$06,SP

                MOVE.W  D7,D0

                MOVEA.L (SP)+,A6
                MOVE.W  (SP)+,D7
                RTS

CONT_TEST:      CLR.W   D7

                CLR.L   -(SP)
                MOVE.W  #$20,-(SP)
                TRAP    #$01            ;SUPER( 0L );
                ADDQ.L  #$06,SP

                MOVE.L  D0,-(SP)
                MOVE.W  #$20,-(SP)

                MOVE    SR,D0           ;D0 = SR
                ORI     #$2700,SR       ;IPL 7

                MOVE.L  SP,D1           ;D1 = SP
                MOVEA.L $08,A1          ;A1 = BE VEC
                LEA     BUSERR_C(PC),A0
                MOVE.L  A0,$08

                TST.B   (A6)
                ST      D7
                BRA.S   BUSERR_C

  END;
END validAdr;
(*$L=*)

PROCEDURE DumpVars (ed : EDITPTR);
BEGIN
  WITH ed^ DO
  (*
    Sys ("currLineNr: %ld", currLineNr);
    Sys ("totalLineNr: %ld", totalLineNr);
    Sys ("CurrentBuff^.used: %ld", currentBuff^.usedMem);
    RETURN;
    
    Sys ("CurrRow: %ld", currRow);
    Sys ("cursor: %ld", cursor);
    Sys ("isFSM: %ld", CAST (CARDINAL, isFSM));
 *)
    Sys ("editChanged: %ld", editChanged);
    Sys ("editLen: %ld", editLen);
    Sys ("editLine.length: %ld", editLine.length);
    Sys ("editLine.text: %s",editLine.text);
    Sys ("LENGTH(editLine): %ld", LENGTH (editLine.text^));
  END;
END DumpVars;

PROCEDURE TestStructure (ed : EDITPTR);
  VAR buf : aBufferPtr;
      bufNum : INTEGER;
      used   : INTEGER;
      i      : INTEGER;
BEGIN
  WITH ed^ DO
    Sys ("Teste Struktur und Fllungsgrad ...", 0);
    buf := firstBuff;
    bufNum := 1;
    WHILE buf # NIL DO
      WITH buf^ DO
        used := 0;
        FOR i := 0 TO SHORT(toLine - fromLine) DO
          INC (used, lines^[i]);
        END;
        Sys ("Buffer Nummer: %ld", bufNum);
        Sys ("usedMem: %ld", usedMem);
        Sys ("used by count: %ld", used);
        Sys ("MaxLines: %ld", maxLine);
        Sys ("fromLine: %ld", fromLine);
        Sys ("toLine: %ld", toLine);
        Sys ("usedLines: %ld", toLine - fromLine + 1);
      END;
      buf := buf^.next;
      INC (bufNum);
    END;
  END;
END TestStructure;

(*
PROCEDURE doDump (ed : EDITPTR);
  VAR fromLine, toLine, cLine : LONGINT;
      cRow : INTEGER;
      lines, l2 : LONGINT;
BEGIN
  WITH ed^ DO
    cLine := currLineNr;
    cRow := currRow;
    fromLine := 0;
    toLine := totalLineNr-1;
    SetCurrLine (ed, fromLine);
    fromLine := currLineNr;
    WHILE (fromLine <= toLine) & (fromLine = currLineNr) & (currLine # NIL) DO 
      (* Zeile testen *)
      IF INTEGER((*SYSTEM.*)LENGTH (currLine^.zeile.text^)) >= currLine^.zeile.length
      THEN
        Sys ("Zeile zu lang: %ld",currLineNr);
        Sys (currLine^.zeile.text^,0);
        SysBreak();
      END;
      SetCurrLine (ed, fromLine+1);
      INC (fromLine);
    END;
    Sys ("Von unten nach oben: %ld lines", fromLine);
    l2 := fromLine;
    fromLine := 0;
    toLine := totalLineNr -1;
    SetCurrLine (ed, toLine);
    lines := 0;
    WHILE (toLine >= fromLine) & (toLine = currLineNr) & (currLine # NIL) DO
      SetCurrLine (ed, toLine-1);
      DEC (toLine);
      INC (lines);
    END;
    Sys ("Von oben nach unten: %ld lines", lines);
    IF l2 # lines THEN SysBreak() END;
    IF Inconsistent()
    THEN
      Sys ("Speicherverwaltung inkonsistent!",0);
      SysBreak()
    END;
    SetCurrLine (ed, cLine);
    currRow := cRow;
  END;
END doDump;
*)
*)

PROCEDURE FindNum () : INTEGER;
  VAR i : INTEGER;
BEGIN
  FOR i := 0 TO 255 DO
    IF ~(i IN nums) THEN INCL (nums, i); RETURN i; END;
  END;
END FindNum;

PROCEDURE ClearNum (num : INTEGER);
BEGIN
  EXCL (nums, num);
END ClearNum;

PROCEDURE GetEditNumber (wdw : INTEGER) : INTEGER;
BEGIN
  RETURN EditFuncs.GetEditNumber (wdw);
END GetEditNumber;

(*$? NOT CAT:
PROCEDURE ReadShortkeyFile(REF fname: ARRAY OF CHAR);
(* Liest eine Krzeldatei ein 
 *)
BEGIN
  EditFuncs.ReadShortkeyFile (fname);
END ReadShortkeyFile;

PROCEDURE FreeShortkeyList ();
(* Gibt eine Krzeldatei wieder frei 
 *)
BEGIN
  EditFuncs.FreeShortkeyList();
END FreeShortkeyList;
*)

PROCEDURE EditSaveWdwPos (wdw : INTEGER);
(* Sichert die Position des Editors in den 
 * Configvariablen
 *)
BEGIN
  EditUtil.EditSaveWdwPos(wdw);
END EditSaveWdwPos;

PROCEDURE EditSavePos();
(* Sichert die Position und den Inhalt aller offenen Editorfenster
 * (nicht ReadOnly-Fenster 
 *)
BEGIN
  EditUtil.EditSavePos();
END EditSavePos;

PROCEDURE EditRestorePos();
(* Restauriert den Inhalt und die Position der EditorFenster
 *)
  VAR varName : ARRAY [0..255] OF CHAR;
      margin  : INTEGER;
      info, 
      umbruch : BOOLEAN;
      fullname, 
      path    : ARRAY [0..255] OF CHAR;
      name    : ARRAY [0..15] OF CHAR;
      i       : INTEGER;
BEGIN
  FOR i := 0 TO 255 DO 
    Strings.Concat (cEditFile, StrConv.IntToStr (i, 0), varName, v.bool);
    IF ConfVars.GetConfigString (varName, fullname)
    THEN
      ConfVars.DeleteConfigVar (varName);
      (* Name splitten *)
      FileNames.SplitPath (fullname, path, name);
      Strings.Concat (cEditMargin, StrConv.IntToStr (i, 0), varName, v.bool);
      ConfVars.GetConfDefInt (varName, margin, 80);
      ConfVars.DeleteConfigVar (varName);
      Strings.Concat (cEditInfo, StrConv.IntToStr (i, 0), varName, v.bool);
      ConfVars.GetConfDefBool (varName, info, TRUE);
      ConfVars.DeleteConfigVar (varName);
      Strings.Concat (cEditWrap, StrConv.IntToStr (i, 0), varName, v.bool);
      ConfVars.GetConfDefBool (varName, umbruch, FALSE);
      ConfVars.DeleteConfigVar (varName);
      IF ~OpenEditor (path, name, FALSE, FALSE, 
                     NIL, NIL, NIL, NIL, NIL, NIL, NIL, NIL,
                     margin, info, umbruch, i, v.int)
      THEN
        RETURN
      END;
    END;
  END;
END EditRestorePos;

PROCEDURE Search (wdw : INTEGER; w : ARRAY OF CHAR; pos : searchPos; 
                  direction : searchDir; count : searchCount; 
                  num (* wird nur bei count = nmal benutzt *) : INTEGER;
                  ignoreCase : BOOLEAN; onlyWord : BOOLEAN; 
                  again : BOOLEAN): BOOLEAN;

  VAR r : ARRAY [0..3] OF CHAR;
      ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    RETURN EditFuncs.searchAndReplace (ed, w, r, pos, direction, count, num,
                             ignoreCase, onlyWord, FALSE, TRUE, again, TRUE);
  END;
  RETURN FALSE;
END Search;  

PROCEDURE SearchAndReplace (wdw : INTEGER; w, r : ARRAY OF CHAR; pos : searchPos; 
                  direction : searchDir; count : searchCount; 
                  num (* wird nur bei count = nmal benutzt *) : INTEGER;
                  ignoreCase : BOOLEAN; onlyWord : BOOLEAN; 
                  ask: BOOLEAN; again : BOOLEAN) : BOOLEAN;
  VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    RETURN EditFuncs.searchAndReplace (ed, w, r, pos, direction, count, num,
                             ignoreCase, onlyWord, TRUE, ask, again, TRUE);
  END;
  RETURN FALSE;
END SearchAndReplace;

PROCEDURE IndentBlock (wdw : INTEGER);
BEGIN
  EditUtil.IndentBlock (wdw);
END IndentBlock;

PROCEDURE EditCut (wdw : INTEGER): BOOLEAN;
  VAR ed : EDITPTR;
      cLine : aLinePtr;
      l     : LONGINT;
      clNr  : LONGINT;
      res   : BOOLEAN;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL THEN
    HideMouse();
    HideCursor (ed);
    res := EditFuncs.cutEdit (ed, TRUE);
    ShowCursor (ed);
    ShowMouse (FALSE);
    RETURN res;
  END (* IF ed # NIL *);
  RETURN FALSE;
END EditCut;
 
PROCEDURE EditPasteFile (wdw: INTEGER; isFilter: BOOLEAN; REF path, name: ARRAY OF CHAR);
(* Fgt einen Text mit Filename ein 
 *)
BEGIN
  EditUtil.EditPasteFile (wdw, isFilter, path, name);
END EditPasteFile;

PROCEDURE EditPaste(wdw : INTEGER);
  VAR ed: EDITPTR;
      ScrapPath  : ARRAY [0..255] OF CHAR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    IF ed^.readOnly THEN RETURN END;
    IF ~Clip.GetScrap (ScrapPath) THEN RETURN END;
    EditPasteFile (wdw, FALSE, ScrapPath, ScrapName);
  END;
END EditPaste;

PROCEDURE EditCopy(wdw : INTEGER): BOOLEAN;
  VAR append    : BOOLEAN;
      state     : BITSET;
      fullName  : ARRAY [0..255] OF CHAR;
      fHdl      : INTEGER;
      ed        : EDITPTR;
      ScrapPath : ARRAY [0..255] OF CHAR;
      i         : INTEGER;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL THEN
    WITH ed^ DO
      IF ~Clip.GetScrap (ScrapPath) THEN RETURN FALSE END;
      MagicAES.GrafMkstate(v.int, v.int, v.bset, state);
      append := CatGlobal.WithShift (state);
      Strings.Concat (ScrapPath, ScrapName, fullName, v.bool);
      IF append
      THEN
        (* Anhngen *)
        fHdl := MagicDOS.Fopen (fullName, {MagicDOS.Write});
        IF fHdl < MagicDOS.EOK
        THEN
          Clip.ScrapClear("", "");
          fHdl := MagicDOS.Fcreate (fullName, {});
          IF fHdl < MagicDOS.EOK
          THEN
            MTE.info (MTE.NoScrap);
            RETURN FALSE
          END;
        ELSE
          Clip.ScrapClear("", ScrapName);
        END;
        v.lcard := MagicDOS.Fseek (0, fHdl, MagicDOS.SeekEnd);
      ELSE
        Clip.ScrapClear("", "");
        fHdl := MagicDOS.Fcreate (fullName, {});
        IF fHdl < MagicDOS.EOK
        THEN
          MTE.info (MTE.NoScrap);
          RETURN FALSE
        END;
      END;
      (* Nun ist das Clipboardfile offen *)
      IF block
      THEN
        FOR i := 0 TO maxBlocks - 1 DO
          WITH blocks[i] DO
            IF (blockStart.line >= 0) & (blockEnd.line >= 0)
            THEN
              v.bool := EditFuncs.outputText (ed, blockStart.line, blockStart.row,
                                              blockEnd.line, blockEnd.row, fHdl, umbruch, FALSE);
            END;
          END;
        END;
      ELSE
        v.bool := EditFuncs.outputText (ed, 0, 0,
                                        -1, 0, fHdl, umbruch, FALSE);
      END;
      v.int := MagicDOS.Fclose (fHdl);
      (* Clipboard-Modul Bescheid geben, das was drin ist *)
      Clip.ScrapWritten({MagicAES.SCFTEXT}, ".TXT");
      (*$? CAT:
      Protokoll.SendPathUpdate (ScrapPath);
      *)
    END (* WITH ed^ DO *)
  END (* IF ed # NIL *);
  RETURN TRUE;
END EditCopy;

PROCEDURE PrinterErrorProc (errCode : Printer.tResponse): BOOLEAN;
  VAR cont : BOOLEAN;
BEGIN
  Printer.Response := errCode;
  cont := TRUE;
  CASE errCode OF
    Printer.done            : |
    Printer.notdone         : cont := FALSE; |
    Printer.noMemory        : EditFuncs.OutOfMem(); |
    Printer.CFGnotFound     : | (* werden woanders behandelt *)
    Printer.wrongIdent      : | (* werden woanders behandelt *)
    Printer.ErrorInStreams  : MTE.info (printDOSErr); cont := FALSE; |
    Printer.Cancelled       : MTE.info (printCancel); cont := FALSE; |
    Printer.PrnDeviceBusy,
    Printer.AuxDeviceBusy,
    Printer.ConDeviceBusy   : cont := mtAlerts.Alert (1, printBusy) = 1; |
  ELSE
  END;
  RETURN cont;
END PrinterErrorProc;
 
PROCEDURE EditPrint(wdw : INTEGER; prBlock : BOOLEAN);
(* Druckt entweder den ganzen Text oder nur den markierten Block *)
  VAR ed : EDITPTR;
      fHdl : INTEGER;
      alt  : ARRAY [0..79] OF CHAR;
      val  : INTEGER;
      effects : BITSET;
      formFeed,
      boolVal : BOOLEAN;
      s       : ARRAY [0..255] OF CHAR;
      margin  : INTEGER;
      marginStr : ARRAY [0..12] OF CHAR;
      i       : INTEGER;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    IF prBlock 
    THEN Strings.Assign (blockPrint, alt, v.bool);
    ELSE Strings.Assign (printAll, alt, v.bool);
    END;
    ConfVars.GetConfDefBool (cPrtFF, formFeed, FALSE);
    IF ~formFeed
    THEN
      Strings.Append (blockButF, alt, v.bool);
      v.int := mtAlerts.Alert (2, alt);
    ELSE
      Strings.Append (blockBut, alt, v.bool);
      v.int := mtAlerts.Alert (1, alt);
    END;
    IF (formFeed & (v.int = 2)) 
    OR (~formFeed & (v.int = 3)) THEN RETURN END;
    IF ~formFeed & (v.int = 1) THEN formFeed := TRUE; END;
    mtAppl.MouseBusy();
    WITH ed^ DO
      (* Drucker ffnen *)
      ConfVars.GetConfDefInt (cPrtPort, val, 0);
      IF val = 0
      THEN
        Printer.Open (Printer.cPrn);
      ELSE
        Printer.Open (Printer.cAux);
      END;
      ConfVars.GetConfDefBool (cPrtNlq, boolVal, FALSE);
      IF Printer.Response = Printer.done THEN Printer.SendInit (boolVal, formFeed); END;
      ConfVars.GetConfDefInt (cPrtStyle, val, 0);
      Printer.SetMode (val);
      (* Nun ist der Drucker offen *)
      (* Jetzt den Text drucken *)
      IF prBlock
      THEN
        effects := {0};
        IF Printer.Response = Printer.done THEN Printer.Effect (effects, TRUE); END;
        IF Printer.Response = Printer.done THEN Printer.Effect (effects, FALSE); END;
        FOR i := 0 TO maxBlocks - 1 DO
          WITH blocks[i] DO
            IF (blockStart.line >= 0) & (blockEnd.line >= 0)
            THEN
    
              v.bool := EditFuncs.outputText (ed, blockStart.line, blockStart.row,
                              blockEnd.line, blockEnd.row, fHdl, FALSE, TRUE);
            END;
          END;
        END;
      ELSE
        (* Header nur drucken, wenn alles gedruckt wird *)
        (* Init fr Header durchfhren *)
        effects := {};
        ConfVars.GetConfDefInt (cPrtHeader, val, 0);
        CASE val OF
          0 : |
          1 : INCL (effects, 0); |
        ELSE
          INCL (effects, val);
        END;
        IF Printer.Response = Printer.done THEN Printer.Effect (effects, TRUE); END;
        (* erste Zeile ausgeben *)
        IF (ADDRESS(userPrint) # NIL)
           & userPrint (wdw, LFIRST, s)
        THEN
          ConfVars.GetConfDefInt (cPrtMargin, margin, 0);
          IF margin > 0 THEN
            Strings.Assign (Strings.Space (margin), marginStr, v.bool);
          END;
          REPEAT
            IF margin > 0 
            THEN
              IF Printer.Response = Printer.done THEN Printer.WriteString (marginStr); END;
            END;
            IF Printer.Response = Printer.done THEN Printer.WriteString (s); END; 
            IF Printer.Response = Printer.done THEN Printer.WriteLn(); END;
          UNTIL ~userPrint (wdw, LNEXT, s);
        END;
        (* Texteffekte zurcksetzen *)
        IF Printer.Response = Printer.done THEN Printer.Effect (effects, FALSE); END;
        v.bool := EditFuncs.outputText (ed, 0, 0, -1, 0, fHdl, FALSE, TRUE);
      END;
      IF formFeed THEN 
        IF Printer.Response = Printer.done THEN Printer.FormFeed(); END;
        IF Printer.Response = Printer.done THEN Printer.SendExit(); END;
      ELSE
        ConfVars.GetConfDefInt (cPrtLines, margin, 0);
        FOR val := 1 TO margin DO
          IF Printer.Response = Printer.done THEN Printer.WriteLn(); END;
        END;
      END;
      Printer.Close ();
    END;
    mtAppl.MouseArrow();
  END;  
END EditPrint;
 
PROCEDURE EditClear (wdw : INTEGER);
  VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    HideMouse ();
    HideCursor (ed);
    EditTools.ClearBlock (ed);
    ShowCursor (ed);
    ShowMouse (FALSE);
  END;
END EditClear;
 
PROCEDURE handleUpdate (wdw, vdiH : INTEGER; special : ADDRESS; update : BOOLEAN);
  VAR ed : EDITPTR;
BEGIN
  ed := EDITPTR (special);
  IF update
  THEN
    HideMouse();
    HideCursor (ed);
  ELSE
    ShowCursor (ed);
    ShowMouse (FALSE);
  END;
END handleUpdate;
 
PROCEDURE docChanged (wdw, vdiH : INTEGER; special : ADDRESS; doc : LongRect; slided : BOOLEAN);
  VAR ed : EDITPTR;
      oldLine : LONGINT;
BEGIN
  ed := EDITPTR (special);
  WITH ed^ DO
    IF doc.y < 0 THEN doc.y := 0; (* HALT *) END;
    oldLine := StartLine;
    leftOffset := SHORT(doc.x);
    SetStartLine (ed, doc.y, FALSE);
    IF slided THEN 
      SetCurrLine (ed, currLineNr + (StartLine-oldLine));
      currRow := BinOps.LowerInt(currRow, editLen);
      EditGlobals.FixCursorPos (ed);
    END;
  END;
END docChanged;
 
PROCEDURE getScrollRect (wdw, vdiH : INTEGER; special : ADDRESS; VAR work : Rectangle);
  VAR ed : EDITPTR;
      full    : Rectangle;
      fullRedraw: BOOLEAN;
      varName : ARRAY [0..255] OF CHAR;
BEGIN
  ed := EDITPTR (special);
  WITH ed^ DO
    IF hasUserProc THEN 
      ed^.getUserRect (wdw, work, userRect, editWork);
      (* Ist etwas unsauber, da angenommen wird, da das UserRect am oberen Rand ist! *)
      hOffset := (userRect.y - editWork.y) MOD charHeight;
      (* Hier mu nicht gesnapt werden, das wird in WindowSnap gemacht! *)
      work := editWork;
    ELSE editWork := work END;
    WITH work DO
      windLines := (BinOps.LowerInt(y+h-1, INTEGER(mtAppl.MaxHeight-1)) - y+1) DIV charHeight; 
      WdwManager.SetScrollParms (wdw, editWork.w-charWidth, windLines-1, charWidth, 1);
    END;
    (* Umbruch *)
    IF wdwIsOpen & readOnly
    THEN 
      fullRedraw := EditUtil.WrapText (ed, isEnriched);
    ELSE
      fullRedraw := FALSE;
    END;
    (* Parameter fr Cursor setzen *)
    IF wdw = WdwManager.theTopWindow THEN WdwManager.SetClip (cursorHandle, work, TRUE) END;
    WdwManager.SetClip (vdiH, work, TRUE);
    SetDocument (ed);
    IF ~alienCoords & (wdw >= 0)
    THEN
      Strings.Concat (cEditWindow, StrConv.IntToStr (number, 0), varName, v.bool);
      WdwManager.GetWdwSize (wdw, full);                 (* Gre des Fensters abfragen *)
      v.bool := ConfVars.SetConfigRect (varName, full);
    END;
    IF fullRedraw
    THEN
      WdwManager.FullRedrawWdw (wdw);
    END;
  END;
END getScrollRect;
 
PROCEDURE snapWindow (wdw, vdiH : INTEGER; special : ADDRESS; VAR work : Rectangle);
  CONST minWindWidth = 80;
        minWindHeight = 80;
  VAR ed : EDITPTR;
BEGIN
  ed := EDITPTR (special);
  WITH ed^ DO
    IF hasUserProc THEN
      ed^.getUserRect (wdw, work, userRect, editWork);
      (* Ist etwas unsauber, da angenommen wird, da das UserRect am oberen Rand ist! *)
      hOffset := (userRect.y - editWork.y) MOD charHeight;
    ELSE
      hOffset := 0;
    END;
    (* snappen *)
    WITH work DO
      INC (h, charHeight DIV 2); 
      INC (w, charWidth DIV 2);         (* Um Rundungsfehler zu vermeiden *)
      DEC (h, ABS(hOffset));
      DEC (w, pixOff);
      h := (h DIV charHeight) * charHeight + ABS(hOffset);
      w := (w DIV charWidth) * charWidth + pixOff;
      WHILE w < minWindWidth DO INC(w, charWidth) END;
      WHILE h < minWindHeight DO INC(h, charHeight) END;
    END;
    IF hasUserProc THEN
      ed^.getUserRect (wdw, work, userRect, editWork);
    ELSE
      editWork := work;
    END;
    (*
    work.x := ((work.x + pixOff) DIV 8) * 8;
    IF work.x < 0 THEN INC (work.x, 8) END;
    *)
    IF wdw = WdwManager.theTopWindow THEN WdwManager.SetClip (cursorHandle, work, TRUE) END;
    WITH editWork DO
      windLines := (BinOps.LowerInt(y+h-1, INTEGER(mtAppl.MaxHeight-1)) - y+1) DIV charHeight;
      WdwManager.SetScrollParms (wdw, editWork.w-charWidth, windLines-1, charWidth, 1);
    END;
  END;
END snapWindow;
 
PROCEDURE topEditor (wdw, vdiH : INTEGER; special : ADDRESS) : BOOLEAN;
  VAR ed : EDITPTR;
BEGIN
  ed := EDITPTR (special);
  WITH ed^ DO 
    IF isHidden THEN RETURN TRUE END;
    WdwManager.SetClip (cursorHandle, ed^.editWork, TRUE);
    ClipWork (ed);
    HideMouse();
    ForceCursor (ed);
    ShowMouse (FALSE);
    IF hasUserProc & (userTop # userTopProc (NIL))
    THEN
      ed^.userTop (wdw);
    END;
  END;
  RETURN TRUE;
END topEditor;
 
PROCEDURE untopEditor (wdw, vdiH : INTEGER; special : ADDRESS);
  VAR ed : EDITPTR;
BEGIN
  ed := EDITPTR (special);
  WITH ed^ DO
    IF isHidden THEN RETURN END;
    IF CursorIsOn (ed)
    THEN
      HideMouse();
      HideCursor (ed);
      ShowMouse (FALSE);
    END;
    WdwManager.SetClip (cursorHandle, deskSize, TRUE);
    IF hasUserProc & (userUntop # userUntopProc (NIL))
    THEN
      ed^.userUntop (wdw);
    END;
  END;
END untopEditor;

PROCEDURE timerEditor (wdw, vdiH : INTEGER; special: ADDRESS): BOOLEAN;
(* Ein Timerevent fr dieses Fenster ist aufgetreten *)
  VAR ed : EDITPTR;
BEGIN
  ed := EDITPTR (special);
  IF ed^.isHidden THEN RETURN FALSE END;
  IF ed^.showInfo & (wdw = WdwManager.ownTopWindow)
  THEN
    SetInfoLine (ed);
    RETURN TRUE;
  END;
  RETURN FALSE
END timerEditor;

PROCEDURE hideEditor (wdw, vdiH : INTEGER; special : ADDRESS; hide : BOOLEAN);
(* Das Fenster wird evtl. versteckt *)
  VAR ed : EDITPTR;
BEGIN
  ed := EDITPTR (special);
  ed^.isHidden := hide;
END hideEditor;

PROCEDURE closeEditor (wdw, vdiH : INTEGER; special : ADDRESS; force : BOOLEAN) : BOOLEAN; FORWARD;

(* Drag & Drop Support *)

TYPE editExtsType   = ARRAY [0..7] OF ARRAY [0..3] OF CHAR;

CONST editExts = editExtsType{'.ASC','.TXT','.CSV','ARGS',
                              0C+0C+0C+0C BY 4};
      maxSendExts   = 2;
      maxUserExts   = 6;

VAR   ddMaxSendExts : INTEGER;

PROCEDURE editGetExts (wdw: INTEGER; special: ADDRESS; VAR exts: ARRAY OF CHAR);
  VAR ed: EDITPTR;
      i, 
      max: INTEGER;
      supportedExts: editExtsType;
      mode: INTEGER;
      additional: INTEGER;
      theExts   : textPtr;
BEGIN
  ed := EDITPTR (special);
  WITH ed^ DO
    max := BinOps.LowerInt (SHORT(MagicAES.DD_EXTSIZE)-1, HIGH (exts)-1);
    supportedExts := editExts;
    IF userDD
    THEN
      additional := userDDGetMaxExts(wdw);
      additional := BinOps.LowerInt (maxUserExts, additional);
      mode := WdwManager.HDRFIRST;
      FOR i := ddMaxSendExts TO ddMaxSendExts + additional - 1 DO
        v.bool := userDDGetExt (wdw, mode, supportedExts[i]);
        mode := WdwManager.HDRNEXT;
      END;
    END;
    theExts := ADR (supportedExts);
    FOR i := 0 TO max DO
      exts[i] := theExts^[i];
    END;
  END;
END editGetExts;

PROCEDURE editAcceptData (wdw: INTEGER; special: ADDRESS; hdr: ADDRESS): BOOLEAN;
  VAR ed: EDITPTR;
      header: POINTER TO RECORD
                dtype : ARRAY [0..3] OF CHAR;
                dlen  : LONGCARD;
                dname : ARRAY [0..2047] OF CHAR;
              END;
      i : INTEGER;
BEGIN
  ed := EDITPTR (special);
  header := hdr;
  WITH ed^ DO
    (* Mal nachsehen, ob die Daten in dem von uns untersttzen Format vorhanden 
     * sind
     *)
    i := 0;
    WHILE (i < 8) & ~Strings.StrEqual (header^.dtype, editExts[i]) DO INC (i) END;
  END;
  RETURN i < 8; 
END editAcceptData;

PROCEDURE editWriteData (wdw: INTEGER; special: ADDRESS; VAR data: ADDRESS; dlen: LONGCARD);
  VAR ed: EDITPTR;
      wasBlock : BOOLEAN;
      err      : EditFuncs.ErrReason;
      ch       : POINTER TO ARRAY [0..1] OF CHAR;
BEGIN
  ed := EDITPTR (special);
  WITH ed^ DO
    (*
    IF dlen > MAX (CARDINAL) THEN dlen := MAX (CARDINAL) END;
    v.bool := QuoteSomething (wdw, '', data, SHORT (dlen), -1);
    *)
    wasBlock := block;
    IF block THEN 
      SaveOp (ed, blockPaste, FALSE); 
      v.bool := EditFuncs.cutBlock (ed, FALSE, FALSE); 
      blocks[0].blockStart.line := currLineNr;
      blocks[0].blockStart.row := currRow;
      block := TRUE; 
    ELSE
      SetBlockstart (ed);
      SaveOp (ed, normalPaste, FALSE);
      block := TRUE;
    END;
    ch := data + ADDRESS(dlen-1);
    IF (ch^[1] = LF) & (ch^[0] # CR)
    THEN
      (* Ein einzelnes LF am Ende *)
      DEC (dlen);
    ELSIF (ch^[1] = 0C)
    THEN
      DEC (ch);
      IF (ch^[1] = LF) & (ch^[0] # CR)
      THEN
        (* Ein einzelnes LF am Ende *)
        DEC (dlen, 2);
      END;
    END;
    IF ~EditFuncs.ReadBuffer (ed, data, dlen, TRUE, err)
    THEN
      IF err = EditFuncs.memError
      THEN
        EditFuncs.OutOfMem();
      END;
    END;
    ShowFileChanged (ed); 
    NewBlockToUndoBuffer (ed);
    (* Jetzt Cursorposition anpassen an Ende des gepasteten Stcks 
     *)
    SetCurrLine (ed, blocks[0].blockEnd.line);
    currRow := blocks[0].blockEnd.row;
    SetDocument (ed);
    IF ~wasBlock THEN 
      (* normal Paste *) 
      block := FALSE; 
      blocks[0].blockStart.line := -1; 
      blocks[0].blockEnd.line := -1; 
    END;
    IF showInfo THEN SetInfoLine (ed) END;
    WdwManager.FullRedrawWdw (wdw);
  END;
END editWriteData;

PROCEDURE editGetHeader (wdw: INTEGER; special: ADDRESS; mode: INTEGER;
                         VAR ext, name: ARRAY OF CHAR; VAR size: LONGCARD): BOOLEAN;
(*$? CAT:
CONST   cBlockName  = 'CAT Editorblock';
*)
(*$? NOT CAT:
CONST   cBlockName  = 'FRED Editorblock';
*)

  VAR ed            : EDITPTR;
      data          : ADDRESS;
      supportedExts : editExtsType;
      userMode      : INTEGER;
      additional    : INTEGER;
      i             : INTEGER;
BEGIN
  ed := EDITPTR (special);
  WITH ed^ DO
    IF ~block THEN 
      IF ~userDD
      THEN 
        RETURN FALSE 
      ELSE
        ddMaxSendExts := 0;
      END;
    ELSE
      ddMaxSendExts := maxSendExts;
    END;
    IF mode = WdwManager.HDRFIRST
    THEN
      currentExt := 0;
    ELSE
      INC (currentExt);
    END;
    IF currentExt >= ddMaxSendExts THEN 
      IF userDD
      THEN
        additional := userDDGetMaxExts(wdw);
        additional := BinOps.LowerInt (maxUserExts, additional);
        IF currentExt >= ddMaxSendExts + additional
        THEN
          RETURN FALSE;
        END;
        userMode := WdwManager.HDRFIRST;
        FOR i := ddMaxSendExts TO ddMaxSendExts + additional - 1 DO
          v.bool := userDDGetExt (wdw, userMode, supportedExts[i]);
          userMode := WdwManager.HDRNEXT;
        END;
        Strings.Assign (supportedExts[currentExt], ext, v.bool);
        userDDGetExtName (wdw, currentExt - ddMaxSendExts, name);
        userDDGetSize (wdw, currentExt - ddMaxSendExts, size);
        RETURN TRUE;
      ELSE
        RETURN FALSE 
      END;
    END;
    Strings.Assign (editExts[currentExt], ext, v.bool);
    Strings.Assign (cBlockName, name, v.bool);
    IF ~GetBlock (wdw, currentExt = 0, currentExt=1, data, size) THEN RETURN FALSE END;
    DEALLOCATE (data, 0);
    RETURN TRUE;
  END;
END editGetHeader;

PROCEDURE editReadData (wdw: INTEGER; special: ADDRESS; VAR data: ADDRESS);
  VAR ed: EDITPTR;
BEGIN
  ed := EDITPTR (special);
  WITH ed^ DO
    IF currentExt < ddMaxSendExts
    THEN
      v.bool := GetBlock (wdw, currentExt = 0, currentExt=1, data, v.lcard);
    ELSE
      IF userDD
      THEN
        userDDGetData (wdw, currentExt - ddMaxSendExts, data);
      END;
    END;
  END;
END editReadData;

 
PROCEDURE SetFont (VAR ed : EDITPTR; font, fontSiz : INTEGER); FORWARD;
        (* Basisfunktionen *)
 
PROCEDURE OpenEditor (REF path, FileName : ARRAY OF CHAR; New : BOOLEAN;
                      (* User-Proc Parameter *)
                      useUserProc : BOOLEAN; 
                      theUserProc, theUserRectProc,
                      theDrawUserProc, theCloseProc,
                      theKeyProc, theTopProc, 
                      theUntopProc, thePrePrintProc : ADDRESS; (*!! Hier aufpassen!*)
                      (* Edit-Parameter *)
                      right : INTEGER;
                      showInfoLine : BOOLEAN;
                      wrap : BOOLEAN;
                      num  : INTEGER;
                      VAR wdwHandle : INTEGER) : BOOLEAN;
(* ffnet einen Editor im Fenster. Font und Fontsize und gewnschte
 * Workarea mssen bergeben werden, wdwHandle dieses Editors wird 
 * im Erfolgsfall zurckgeliefert.
 *)
 VAR fn         : aLineDesc;
     fHdl       : INTEGER;
     flen       : LONGCARD;
     memSize    : LONGCARD;
     ed         : EDITPTR;
     wdwH       : INTEGER;
     outSize    : Rectangle;
     comps      : BITSET;
     voidBuf    : ADDRESS;
     readBuf    : POINTER TO ARRAY [0L..$FFFFFFFF] OF CHAR;
     bufSize    : LONGCARD;
     fastRead   : BOOLEAN;
     readBytes  : LONGCARD;
     varName    : Strings.String;
     edFont,
     edFontSize : INTEGER;
     full       : Rectangle;
     cLine      : LONGINT;
     i          : INTEGER;
     
  PROCEDURE FreeStuff();
  (* Dealloziert allozierte Pointer und gibt sonstiges Zeugs frei
   *)
  BEGIN
    IF wdwH >= 0 THEN v.bool := WdwManager.CloseWindow (wdwH, TRUE) 
    ELSIF ed # NIL THEN EditFuncs.KillEditor (ed) END;
    IF readBuf # NIL THEN DEALLOCATE (readBuf, 0) END;
    IF voidBuf # NIL THEN DEALLOCATE (voidBuf, 0) END;
    IF fHdl > 0  THEN v.int := MagicDOS.Fclose (fHdl); CatFiles.ErrorAlert (v.int) END;
    IF fn.text # NIL THEN DEALLOCATE (fn.text, 0) END;
  END FreeStuff;
 
BEGIN
  (* Variablen initialisieren, damit FreeStuff auch funktioniert! *)
  ed := NIL;
  readBuf := NIL;
  voidBuf := NIL;
  fn.text := NIL;
  wdwH := -1;
  fHdl := -1;
  flen := 0;
  (* Filenamen basteln, Datei ffnen und Lnge feststellen *)
  IF ~EditUtil.getFileParms (path, FileName, New, TRUE, fn, flen, fHdl)
  THEN 
    FreeStuff;
    RETURN FALSE
  END;
  IF flen = 0 THEN New := TRUE END;
  (* Speicher feststellen und auf flen testen *)
  IF ~EditUtil.testMem(flen, memSize, fastRead)
  THEN
    FreeStuff;
    RETURN FALSE
  END;
  (* Fensterkomponenten bestimmen *)
  comps := {MagicAES.NAME..MagicAES.HSLIDE};
  IF ~showInfoLine
  THEN
    EXCL (comps, MagicAES.INFO);
  END;
  (* Editor erstellen *)
  IF ~EditFuncs.CreateEditor (ed)
  THEN
    (* Fehlermeldung: not enough memory *)
    FreeStuff;
    EditFuncs.OutOfMem();
    RETURN FALSE
  END;
  (* Dateipuffer anlegen *)
  IF flen # 0 THEN
    IF ~EditUtil.getReadBuff (memSize, flen, readBuf)
    THEN
      FreeStuff;
      RETURN FALSE;
    END;
  END;
  WITH ed^ DO 
    (* Configvariablen lesen *)
    IF (num >= 0) & ~(num IN nums)
    THEN
      INCL (nums, num);
      number := num;
    ELSE
      number      := FindNum ();
    END;
    Strings.Concat (cEditWindow, StrConv.IntToStr (number, 0), varName, v.bool);
    IF ~ConfVars.GetConfigRect (varName, full) 
    THEN
      num := BinOps.HigherInt (number-1, 0);
      Strings.Concat (cEditWindow, StrConv.IntToStr (num, 0), varName, v.bool);
      ConfVars.GetConfDefRect (varName, full, deskSize);
      IF (number>0) &  ~RectFuncs.RectEqual (full, deskSize)
      THEN
        INC (full.x, 2*mtAppl.CharWidth);
        INC (full.y, mtAppl.CharHeight);
      END;
      Strings.Concat (cEditFont, StrConv.IntToStr (num, 0), varName, v.bool);
      ConfVars.GetConfDefInt (varName, edFont, 1);
      Strings.Concat (cEditSize, StrConv.IntToStr (num, 0), varName, v.bool);
      ConfVars.GetConfDefInt (varName, edFontSize, 10);
    ELSE
      Strings.Concat (cEditFont, StrConv.IntToStr (number, 0), varName, v.bool);
      ConfVars.GetConfDefInt (varName, edFont, 1);
      Strings.Concat (cEditSize, StrConv.IntToStr (number, 0), varName, v.bool);
      ConfVars.GetConfDefInt (varName, edFontSize, 10);
    END;
    (* Editorvariablen setzen *)
    fileName    := fn;
    changed     := FALSE;
    new         := New;
    rightMargin := right;
    leftOffset  := 0;
    showInfo    := showInfoLine;
    readOnly    := FALSE;
    alienCoords := FALSE;
    insertMode  := TRUE;
    ConfVars.GetConfDefBool (cAutoIndent, autoIndent, TRUE);
    ConfVars.GetConfDefBool (cRealTabs, realTabs, FALSE);
    cursor      := 1;
    block       := FALSE;
    blockIndent := FALSE;
    ConfVars.GetConfDefBool (cShowCr, showCR, TRUE);
    currLineNr  := 0;
    StartLine   := 0;
    FOR i := 0 TO maxBlocks - 1 DO
      WITH blocks[i] DO
        blockStart.line := -1;
        blockEnd.line := -1;
      END;
    END;
    backup      := FALSE;
    (* Error-Parameter setzen *)
    errLine     := -1;
    errRow      := 0;
    errMsg      := "Kein Fehler aufgetreten";
    (* Jetzt noch die User-Parameter *)
    hasUserProc := useUserProc;
    userProc    := userProcType (theUserProc);
    getUserRect := userGetRectProc (theUserRectProc);
    drawUserArea:= drawUserProc (theDrawUserProc);
    userClose   := userCloseProc (theCloseProc);
    userKey     := userKeyProc (theKeyProc);
    userTop     := userTopProc (theTopProc);
    userUntop   := userUntopProc (theUntopProc);
    userPrint   := userPrePrintProc (thePrePrintProc);
    listModeProc:= userListProc (NIL);
    listMode    := FALSE;
    hOffset     := 0;
    charHeight  := 16;
    charWidth   := 8;
    maxWidth    := 0;
    wasOpen     := FALSE; 
    wdwIsOpen   := FALSE;
  END;
  (* Fenster mit Window Library ffnen *)
  IF ~WdwManager.OpenWindow (ClickInEditWindow, EditChar, timerEditor,
              deskSize, full, comps, TRUE, "", "",
              snapWindow, closeEditor, redrawWdw, topEditor,
              untopEditor, handleUpdate, docChanged, getScrollRect,
              hideEditor, 
              pixOff, ed, FALSE, TRUE, TRUE, TRUE, wdwH, ed^.hdl)
  THEN
    (* Kein Fenster oder keine Workstation mehr frei! *)
    MTE.info (noEditOpen);
    ClearNum (ed^.number);
    FreeStuff();
    RETURN FALSE
  END;
  (* VDI-Operationen fr neuen Editor *)
  WITH ed^ DO
    wdw         := wdwH;
    isHidden    := FALSE;
    (* Text einlesen *)
    umbruch     := wrap;
    IF (flen # 0) THEN
      currRow := 0;
      cursor := 1;
      IF ~EditFuncs.readText (ed, fastRead, flen, fHdl, right, readBuf, FALSE, TRUE)
      THEN
        ClearNum (ed^.number);
        FreeStuff;
        RETURN FALSE
      END;
    ELSE
      (* neuen Text anlegen *)
      IF ~EditBase.GetBuffer (ed, 0)
      THEN
        ClearNum (ed^.number);
        FreeStuff;
        EditFuncs.OutOfMem();
        RETURN FALSE
      END;
      ALLOCATE (firstBuff^.lines, 200L * TSIZE (INTEGER));
      IF firstBuff^.lines = NIL
      THEN
        ClearNum (ed^.number);
        FreeStuff;
        EditFuncs.OutOfMem();
        RETURN FALSE
      ELSE
        WITH firstBuff^ DO
          Block.Clear (lines, 200*TSIZE(INTEGER));
          maxLine := 200;
          fromLine := 0;
          toLine := 0;
        END;
      END;
      totalLineNr := 1;
      editLine.text^[0] := CR;
      editLine.text^[1] := LF;
      editLine.text^[2] := 0C;
      editLen := 2;
      editChanged := TRUE;
      currLineNr := 0;
      v.bool := EditBase.PutCurrLine (ed);
    END;
    (* Wenn wir bis hierhin gekommen sind, dann kann man auch editieren. *) 
    (* Fonts laden *)
    FontSelect.LoadFonts (hdl, v.int);
    (* Font setzen *)
    SetFont (ed, edFont, edFontSize);
    font        := edFont;
    fontSize    := edFontSize;
    wasOpen     := TRUE; 
    v.int := MagicVDI.SetFillstyle (hdl, MagicVDI.Full);
    v.int := MagicVDI.SetFillinterior (hdl, MagicVDI.Full);
(*    v.int := MagicVDI.SetFillcolor (hdl, MagicAES.WHITE); *)
    (* Schreibmodus setzen *)
    v.int := MagicVDI.SetWritemode (hdl, MagicVDI.REPLACE);
    editChanged := FALSE;
    (* Und jetzt noch eventuell vorhandene Configvariablen wieder einlesen *)
    Strings.Concat (cEditTabs, StrConv.IntToStr (number, 0), varName, v.bool);
    ConfVars.GetConfDefBool (varName, realTabs, realTabs);
    ConfVars.DeleteConfigVar (varName);
    Strings.Concat (cEditShowCr, StrConv.IntToStr (number, 0), varName, v.bool);
    ConfVars.GetConfDefBool (varName, showCR, showCR);
    ConfVars.DeleteConfigVar (varName);
    Strings.Concat (cEditTabSize, StrConv.IntToStr (number, 0), varName, v.bool);
    ConfVars.GetConfDefInt (varName, tabSize, 4);
    ConfVars.DeleteConfigVar (varName);
    Strings.Concat (cEditZeile, StrConv.IntToStr (number, 0), varName, v.bool);
    ConfVars.GetConfDefLongInt (varName, currLineNr, currLineNr);
    ConfVars.DeleteConfigVar (varName);
    Strings.Concat (cEditRow, StrConv.IntToStr (number, 0), varName, v.bool);
    ConfVars.GetConfDefInt (varName, currRow, currRow);
    ConfVars.DeleteConfigVar (varName);
    cLine := BinOps.LowerLInt (currLineNr, totalLineNr - 1);
    cLine := BinOps.HigherLInt (cLine, 0);
    currLineNr  := -1;
    SetCurrLine (ed, cLine);
    cursor := 1;
    currRow := BinOps.HigherInt (BinOps.LowerInt (currRow, editLen), 0);
    EditGlobals.FixCursorPos (ed);

    (* Drag und Drop Support einschalten *)
    WdwManager.WdwInstallDDClient (wdw, editGetExts, editAcceptData, editWriteData);
    WdwManager.WdwInstallDDServer (wdw, editGetHeader, editReadData);
  END;
  (* Fensterinhalte setzen *)
  SetEditTitle (ed);
  IF showInfoLine THEN SetInfoLine (ed); END;
  WITH ed^ DO
    (* Fenstergre berechnen *)
    WdwManager.SetWdwSize (wdw, full);
    wdwHandle := wdw;
    WdwManager.SetDocumentParms (wdw, 1, charHeight);
    WdwManager.SetScrollParms (wdw, editWork.w-charWidth, windLines-1, charWidth, 1);
  END (* WITH ed *);
  (* Document fr Window setzen *)
  SetDocument (ed);
  (* Clipping setzen fr Cursorworkstation *)
  WdwManager.SetClip (cursorHandle, ed^.editWork, TRUE);
  (* Cursor anzeigen *)
  CenterCurrline (ed);
  ShowCursor (ed);
  ed^.wdwIsOpen := TRUE;
  RETURN TRUE;
END OpenEditor;

PROCEDURE InstallUserDD (wdw: INTEGER;
                         userDDGetMaxExts    : EditTypes.userDDGetMaxExtProc;
                         userDDGetExt        : EditTypes.userDDGetExtProc;
                         userDDGetExtName    : EditTypes.userDDGetExtNameProc;
                         userDDGetSize       : EditTypes.userDDGetSizeProc;
                         userDDGetData       : EditTypes.userDDGetDataProc);
(* Installiert den DD-Server der Userprozedur 
 *)
VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    ed^.userDD := TRUE;
    ed^.userDDGetMaxExts    := userDDGetMaxExts;
    ed^.userDDGetExt        := userDDGetExt;
    ed^.userDDGetExtName    := userDDGetExtName;
    ed^.userDDGetSize       := userDDGetSize;
    ed^.userDDGetData       := userDDGetData;
  END;
END InstallUserDD;

PROCEDURE EditAbandonText (wdw : INTEGER);
VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    v.int := mtAlerts.Alert (2, editAbandon);
    IF v.int = 2 THEN RETURN END;
    EditReloadText (wdw);
  END;
END EditAbandonText;

PROCEDURE EditReloadText (wdw : INTEGER);
(* Fragt nach, ob die letzte Fassung des Textes geladen werden soll und macht das 
 * dann
 *)
VAR ed : EDITPTR;
    path, name : ARRAY [0..255] OF CHAR;

VAR  flen       : LONGCARD;
     memSize    : LONGCARD;
     readBuf    : POINTER TO ARRAY [0L..$FFFFFFFF] OF CHAR;
     bufSize    : LONGCARD;
     fastRead   : BOOLEAN;
     fn         : aLineDesc;
     fHdl       : INTEGER;
     i          : INTEGER;
 
  PROCEDURE FreeStuff();
  (* Dealloziert allozierte Pointer und gibt sonstiges Zeugs frei
   *)
  BEGIN
    IF readBuf # NIL THEN DEALLOCATE (readBuf, 0) END;
    IF fHdl > 0  THEN v.int := MagicDOS.Fclose (fHdl); CatFiles.ErrorAlert (v.int) END;
    IF fn.text # NIL THEN DEALLOCATE (fn.text, 0) END;
  END FreeStuff;

BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    IF ed^.fileName.text = NIL THEN RETURN END;
(*    HideMouse();
    HideCursor (ed); *)
    WITH ed^ DO
      FileNames.SplitPath (fileName.text^, path, name);
      WHILE firstBuff # NIL DO
        currentBuff := firstBuff;
        EditBase.FreeBuffer (ed);
      END;
      DEALLOCATE (fileName.text, 0);
    END; (* WITH ed *)
    ed^.changed := FALSE;
    ed^.editChanged := FALSE;
    IF NOT ( (* Dateinamen basteln, Datei ffnen und Lnge feststellen *)
            EditUtil.getFileParms (path, name, FALSE, FALSE, fn, flen, fHdl) & 
            (* Speicher feststellen und auf flen testen *)
            EditUtil.testMem(flen, memSize, fastRead) & 
            (* Lesebuffer allozieren *)
            EditUtil.getReadBuff (memSize, flen, readBuf) & 
            (* Text einlesen und einfgen *)
            EditFuncs.readText (ed, fastRead, flen, fHdl, ed^.rightMargin, readBuf, FALSE, TRUE)
           )
    THEN
      FreeStuff;
      EditFuncs.OutOfMem();
      v.bool := WdwManager.CloseWindow (ed^.wdw, FALSE);
      ShowCursor (ed);
      ShowMouse (FALSE);
      RETURN
    END;
    WITH ed^ DO
      changed := FALSE;
      fileName := fn;
      currLineNr  := -1;
      editChanged := FALSE;
      StartLine   := 0;
      SetCurrLine (ed, 0);
      currRow := 0;
      leftOffset := 0;
      maxWidth := 0;
      FOR i := 0 TO maxBlocks - 1 DO
        WITH blocks[i] DO
          blockStart.line := -1;
          blockEnd.line := -1;
        END;
      END;
      block := FALSE;
    END;
(*    ShowCursor (ed);
    ShowMouse (FALSE); *)
    SetEditTitle (ed);
    SetInfoLine (ed);
    WITH ed^ DO
      WdwManager.SetNewDocument (wdw, LongRect{LONG(leftOffset), StartLine, LONG(maxWidth), totalLineNr-1}, TRUE);
    END;
    CenterCurrline (ed);
    WdwManager.FullRedrawWdw (ed^.wdw);
  END;
END EditReloadText;

PROCEDURE EditMerge(wdw : INTEGER; REF path, name : ARRAY OF CHAR);
 VAR fn         : aLineDesc;
     fHdl       : INTEGER;
     flen       : LONGCARD;
     memSize    : LONGCARD;
     ed         : EDITPTR;
     readBuf    : POINTER TO ARRAY [0L..$FFFFFFFF] OF CHAR;
     bufSize    : LONGCARD;
     fastRead   : BOOLEAN;
     scrLine    : INTEGER;
 
  PROCEDURE FreeStuff();
  (* Dealloziert allozierte Pointer und gibt sonstiges Zeugs frei
   *)
  BEGIN
    IF readBuf # NIL THEN DEALLOCATE (readBuf, 0) END;
    IF fHdl > 0  THEN v.int := MagicDOS.Fclose (fHdl); CatFiles.ErrorAlert (v.int) END;
    IF fn.text # NIL THEN DEALLOCATE (fn.text, 0) END;
  END FreeStuff;
 
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    IF ed^.block THEN EditTools.ClearBlock (ed) END;
    EditPasteFile (wdw, FALSE, path, name);
  END; (* WITH ed^ DO *)
END EditMerge;
 
PROCEDURE EditSave(wdw : INTEGER;REF path, FileName : ARRAY OF CHAR; takeName: BOOLEAN);
(* nachfragen, wenn File schon vorhanden *)
VAR ed : EDITPTR;
    saveas : BOOLEAN;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    saveas := (path[0] # 0C) & (FileName[0] # 0C);
    IF ~(saveas OR ed^.readOnly) & ~ed^.changed THEN RETURN END;
    v.bool := EditUtil.SaveText (ed, saveas OR ed^.readOnly, takeName, path, FileName);
  END;
END EditSave;

PROCEDURE askForSave (ed : EDITPTR; mayCancel : BOOLEAN): INTEGER;
 VAR changedAlt : ARRAY [0..255] OF CHAR;
     tmp        : ARRAY [0..30] OF CHAR;
     p          : CARDINAL;
BEGIN
  WITH ed^ DO
    IF mayCancel
    THEN
      Strings.Assign (textChanged, changedAlt, v.bool);
    ELSE
      Strings.Assign (textNotSaved, changedAlt, v.bool);
    END;
    p := Strings.Pos ('&',changedAlt, 0);
    Strings.Delete (changedAlt, p, 1, v.bool);
    IF fileName.length > 30
    THEN
      Strings.Insert ('...', p, changedAlt, v.bool);
      Strings.Copy (fileName.text^, (*SYSTEM.*)LENGTH (fileName.text^)-25, 25, tmp, v.bool);
      Strings.Insert (tmp, p+3, changedAlt, v.bool);
    ELSE
      IF fileName.length = 0
      THEN
        Strings.Insert (cNoname, p, changedAlt, v.bool);
      ELSE
        Strings.Insert (fileName.text^, p, changedAlt, v.bool);
      END;
    END;
    v.int := mtAlerts.Alert (1, changedAlt);
  END;
  RETURN v.int;
END askForSave;

PROCEDURE AskForSave (wdw : INTEGER);
(* Fragt nach, falls der Text verndert wurde, ob dieser gesichert 
 * werden soll.
 *)
 VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    IF ed^.changed
    THEN
      v.int := askForSave (ed, FALSE);
      IF v.int = 1 THEN
        (* Text noch speichern *)
        v.bool := EditUtil.SaveText (ed, ed^.fileName.length = 0, FALSE, "", "");
      END;
    END;
  END;
END AskForSave;

PROCEDURE closeEditor (wdw, vdiH : INTEGER; special : ADDRESS; force : BOOLEAN) : BOOLEAN;
 VAR ed : EDITPTR;
     varName    : Strings.String;
     full       : Rectangle;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed = NIL THEN RETURN TRUE END;
  WITH ed^ DO
    IF changed
    THEN
      IF ~force 
      THEN
      (*
        Strings.Assign (textChanged, changedAlt, v.bool);
        p := Strings.Pos ('&',changedAlt, 0);
        Strings.Delete (changedAlt, p, 1, v.bool);
        IF fileName.length > 29
        THEN
          Strings.Insert ('...', p, changedAlt, v.bool);
          Strings.Copy (fileName.text^, (*SYSTEM.*)LENGTH (fileName.text^)-25, 25, tmp, v.bool);
          Strings.Insert (tmp, p+3, changedAlt, v.bool);
        ELSE
          IF fileName.length = 0
          THEN
            Strings.Insert (cNoname, p, changedAlt, v.bool);
          ELSE
            Strings.Insert (fileName.text^, p, changedAlt, v.bool);
          END;
        END;
        v.int := mtAlerts.Alert (1, changedAlt);
        *)
        v.int := askForSave (ed, TRUE);
      ELSE 
        (* force mode *)
        backup := TRUE;
        IF ~CAT 
        THEN 
          v.int := 2;
        ELSE
          v.int := 1;
        END;
      END;
      IF v.int = 3 THEN (* Abbruch gewhlt *) RETURN FALSE END;
      IF v.int = 1 THEN 
        (* Text noch speichern *)
        IF ~EditUtil.SaveText (ed, fileName.length = 0, FALSE, "", "") & ~force
        THEN
          RETURN FALSE
        END;
      END;
    END;
    (* Hier wird jetzt definitiv das Fenster geschlossen und der Editor gelscht! *)
    IF ADDRESS (ed^.userClose) # NIL
    THEN
      IF ~ed^.userClose (wdw)
      THEN
        RETURN FALSE
      END;
    END;
    IF ~alienCoords & wasOpen
    THEN
      (* Parameter noch sichern *)
      Strings.Concat (cEditWindow, StrConv.IntToStr (number, 0), varName, v.bool);
      WdwManager.GetWdwSize (wdw, full);                 (* Gre des Fensters abfragen *)
      v.bool := ConfVars.SetConfigRect (varName, full);
      Strings.Concat (cEditFont, StrConv.IntToStr (number, 0), varName, v.bool);
      v.bool := ConfVars.SetConfigInt (varName, font);
      Strings.Concat (cEditSize, StrConv.IntToStr (number, 0), varName, v.bool);
      v.bool := ConfVars.SetConfigInt (varName, fontSize);
      ClearNum (number);
    END;
    WdwManager.SetClip (cursorHandle, deskSize, TRUE);
    FontSelect.UnloadFonts (vdiH);
    EditFuncs.KillEditor (ed);
    EditTools.CheckAndFreeUndo (wdw);
    RETURN TRUE
  END; 
  RETURN FALSE;
END closeEditor;
 
PROCEDURE CloseEditor (wdw : INTEGER; force : BOOLEAN) : BOOLEAN;
BEGIN
  RETURN WdwManager.CloseWindow (wdw, force);
END CloseEditor;

VAR debugMode : BOOLEAN;
 
PROCEDURE EditChar(wdw, vdiH : INTEGER; special : ADDRESS; taste: INTEGER; char, scan : CHAR; kstate : BITSET) : BOOLEAN;

 (* Wertet alle Tastendrcke aus und fgt ggf. Zeichen ein. *)
  CONST Chars = CharSet{' '..'~', '', '', '', '', '', '', '', '', 341C};
  VAR ed : EDITPTR;
      gemCh : CARDINAL;
      key   : MOSGlobals.Key;
      ctrl  : BOOLEAN;
      done  : BOOLEAN;
      moreChars : BOOLEAN;
      insMod    : BOOLEAN;
      done2 : BOOLEAN;
BEGIN
  ed := EDITPTR (special); (* ed := EditFuncs.FindEditor (wdw); *)
  IF WdwManager.WindowIsShaded (wdw) THEN RETURN FALSE END;
  IF ed # NIL THEN
    WITH ed^ DO
(*      IF ~validAdr (currLine) THEN HALT END;
      IF ~validAdr (currLine^.zeile.text) THEN HALT END;
      IF ~validAdr (currLine^.next) THEN HALT END;
      IF ~validAdr (currLine^.prev) THEN HALT END;
*)
      LOOP
        moreChars := FALSE;
        gemCh := ORD(scan) * 256 + ORD(char);

        Keyboard.GemCharToKey (gemCh,  SHORT (INTEGER(kstate)), key);
        IF (userKey # userKeyProc (NIL))
        THEN
          IF userKey (wdw, scan, char, kstate, moreChars)
          THEN
            RETURN TRUE
          END;
        END;
        ctrl := CatGlobal.WithCtrl (kstate);
        done := TRUE;
        IF Keyboard.IsSpecial (key)
        THEN
          HideMouse();
          CASE Keyboard.SpecialKey (key) OF
            left, 
            wdLeft,
            soln          : EditFuncs.CursorLeft (ed, kstate); |
            right, 
            wdRight, 
            eoln          : EditFuncs.CursorRight (ed, kstate); |
            up            : EditFuncs.CursorUp (ed, ctrl);   |
            down          : EditFuncs.CursorDown (ed, ctrl); |
            pgUp          : WdwManager.PageUp (ed^.wdw);     |
            pgDown        : WdwManager.PageDown (ed^.wdw);   |
            home          : EditFuncs.Home (ed, FALSE); |
            clr           : EditFuncs.Home (ed, TRUE);  |
            (*
            ctrlH         : ToggleMode (ed^.wdw, roMode); WdwManager.FullRedrawWdw (ed^.wdw); |
            *)
          ELSE
            done := FALSE;
          END;
          IF ed^.readOnly THEN 
            IF ~done THEN 
              IF Keyboard.SpecialKey (key) = backspace
              THEN
                EditTools.ClearBlock (ed);
                done := TRUE;
              END;
            END;
            IF showInfo THEN SetInfoLine (ed); END;
            ShowMouse(FALSE); 
            RETURN done; 
          END;
          CenterCurrline (ed); 
          (* ClipWork (ed); *)
          done2 := TRUE;
          CASE Keyboard.SpecialKey (key) OF
            esc           : (*$? CAT:
                            v.bool := EditBase.PutCurrLine (ed); 
                            WdwManager.FullRedrawWdw (wdw); 
                            *)
                            (*$? NOT CAT:
                            (* Nur fr FRED: Krzel suchen und auswerten *)
                            IF ~ed^.block
                            THEN
                              HideCursor (ed);
                              EditFuncs.InsertShortkey (ed);
                              ForceCursor (ed);
                            END;
                            *)
                            |
            undo          : lastOpWasCtrlY := FALSE;
                            Undo (ed); |
            insert        : IF ctrl
                            THEN
                              autoIndent := ~autoIndent;
                            ELSE  
                              HideCursor (ed); insertMode := ~insertMode; ShowCursor (ed);
                            END; |
            insLine       : IF block THEN ShowMouse (FALSE); RETURN done END; 
                            lastOpWasCtrlY := FALSE;
                            IF (MagicAES.KRSHIFT IN kstate) & 
                               (MagicAES.KLSHIFT IN kstate) 
                            THEN 
                              EditFuncs.Format0 (ed, FALSE) 
                            ELSIF CatGlobal.WithShift (kstate) &
                                  CatGlobal.WithCtrl (kstate)
                            THEN
                              ShowMouse(FALSE); 
                              insMod := mtDials.DialCharTable (char);
                              HideMouse();
                              IF insMod  & (char # CR) & (char # LF)
                              THEN
                                lastOpWasCtrlY := FALSE;
                                EditFuncs.Insert(ed, char); 
                              END;
                            ELSIF CatGlobal.WithShift (kstate) 
                            THEN 
                              EditFuncs.DupLine (ed) 
                            END; |
            backspace     : lastOpWasCtrlY := FALSE;
                            IF insertMode
                            THEN
                              HideCursor (ed); 
                              EditFuncs.Backspace (ed, CatGlobal.WithCtrl(kstate)); 
                              ShowCursor (ed);
                            ELSE
                              EditFuncs.CursorLeft (ed, kstate);
                            END; |
            delete        : HideCursor(ed);
                            IF CatGlobal.WithShift(kstate)
                            THEN
                              IF block THEN 
                                lastOpWasCtrlY := FALSE;
                                EditTools.ClearBlock (ed);
                              END;
                              v.bool := EditBase.PutCurrLine (ed);
                              MarkLine (ed);
                              SaveOp (ed, blockCut, FALSE); 
                              v.bool := EditFuncs.cutEdit (ed, FALSE);
                              ShowCursor (ed);
                              lastOpWasCtrlY := TRUE;
                            ELSIF ctrl
                            THEN
                              lastOpWasCtrlY := FALSE;
                              IF block THEN ShowMouse (FALSE); RETURN done END; 
                              EditFuncs.Delete (ed, TRUE, TRUE);
                            ELSE
                              lastOpWasCtrlY := FALSE;
                              EditFuncs.Delete (ed, FALSE, TRUE);
                            END; 
                            ShowCursor(ed); |
            delLine       : (* Ctrl-Delete *)
                            lastOpWasCtrlY := FALSE;
                            IF block THEN ShowMouse (FALSE); RETURN done END; 
                            EditFuncs.Delete (ed, TRUE, TRUE); |
            tab           : lastOpWasCtrlY := FALSE;
                            EditFuncs.Tab (ed, FALSE); |
            return,
            enter         : lastOpWasCtrlY := FALSE;
                            HideCursor(ed);
                            IF block THEN 
                              SaveOp (ed, blockToChar, FALSE); 
                              v.bool := EditFuncs.cutEdit (ed, FALSE);
                            END;
                            IF insertMode OR (currLineNr = totalLineNr - 1)
                            THEN
                              insMod := insertMode;
                              insertMode := TRUE;
                              EditFuncs.Insert (ed, CR);
                              EditFuncs.Insert (ed, LF);
                              EditFuncs.InsertCR(ed);
                              currRow := 0;
                              IF autoIndent & ~CatGlobal.WithCtrl (kstate) 
                              THEN 
                                EditFuncs.Tab (ed, TRUE); 
                              END;
                              insertMode := insMod;
                            ELSE
                              SetCurrLine (ed, currLineNr+1);
                              IF ed^.autoIndent & ~CatGlobal.WithCtrl (kstate)
                              THEN 
                                WITH ed^ DO 
                                  currRow := 0;
                                  WHILE (editLine.text^[currRow] = ' ') 
                                      & (ORD(editLine.text^[currRow]) < 32) DO 
                                    INC (currRow) 
                                  END;
                                END;
                              ELSE 
                                ed^.currRow := 0; 
                              END;
                            END;
                            ShowCursor(ed) |
            (*$? Debug: 
            ctrlH         : TestStructure (ed); done := FALSE;|
            ctrlD         : v.bool := EditBase.CompactBuffer (ed); done := FALSE; |
            *)
            ctrlJ         : lastOpWasCtrlY := FALSE;
                            HideCursor (ed); 
                            SetBlockstart (ed); 
                            ed^.block := BlockIsMarked (ed^.wdw); 
                            ShowCursor (ed); |
            ctrlK         : lastOpWasCtrlY := FALSE;
                            HideCursor (ed); 
                            SetBlockend (ed); 
                            ed^.block := BlockIsMarked (ed^.wdw);
                            ShowCursor (ed); |
(*            ctrlZ         : debugMode := ~ debugMode;
                            TOSDebug.Active := debugMode;
                            TOSDebug.Continuous := ~debugMode; | *)
            ctrlY         : HideCursor (ed);
                            IF block THEN 
                              lastOpWasCtrlY := FALSE;
                              EditTools.ClearBlock (ed);
                            END;
                            v.bool := EditBase.PutCurrLine (ed);
                            MarkLine (ed);
(*                            SaveOp (ed, lineDel, lastOpWasCtrlY); *)
                            v.bool := EditFuncs.cutEdit (ed, TRUE);
                            ShowCursor (ed);
                            lastOpWasCtrlY := TRUE; |
          ELSE
            done2 := FALSE;
          END;
          done := done OR done2;
          ShowMouse (FALSE);
          (*
        ELSIF ctrl & (scan # 71C) & (scan # 53C)
        THEN
          done := TRUE;
          CASE CAP(char) OF
            "J"           : lastOpWasCtrlY := FALSE;
                            HideCursor (ed); 
                            SetBlockstart (ed); 
                            ed^.block := BlockIsMarked (ed^.wdw); 
                            ShowCursor (ed); |
            "K"           : lastOpWasCtrlY := FALSE;
                            HideCursor (ed); 
                            SetBlockend (ed); 
                            ed^.block := BlockIsMarked (ed^.wdw);
                            ShowCursor (ed); |
            "Y"           : HideCursor (ed);
                            IF block THEN 
                              lastOpWasCtrlY := FALSE;
                              EditTools.ClearBlock (ed);
                            END;
                            v.bool := EditBase.PutCurrLine (ed);
                            MarkLine (ed);
                            v.bool := EditFuncs.cutEdit (ed, TRUE);
                            ShowCursor (ed);
                            lastOpWasCtrlY := TRUE; |
          ELSE
            done := FALSE;
          END;
          *)
        ELSIF ed^.readOnly THEN 
          (* Keine Textvernderung bei Read-Only Texten *)
          ShowMouse(FALSE); 
          IF showInfo THEN SetInfoLine (ed); END;
          RETURN FALSE
        ELSIF (scan = 71C) & ctrl & ~block THEN 
          (* control space! *)
          HideMouse(); HideCursor (ed); drawCursor (ed, TRUE); ShowCursor (ed); ShowMouse (FALSE);
        ELSIF (scan = 53C) & (ctrl OR CatGlobal.WithAlt (kstate))
        THEN
          EditFuncs.SwapLines (ed, ctrl);
        ELSIF (char # 0C) &  ~ctrl THEN 
          lastOpWasCtrlY := FALSE;
          EditFuncs.Insert (ed, char); 
        ELSE
          done := FALSE;
        END;
        CenterCurrline (ed);
        IF showInfo THEN SetInfoLine (ed); END;
        ed^.block := BlockIsMarked (wdw);
        IF ~moreChars THEN EXIT END;
      END;
    END (* WITH ed^ *);
    RETURN done;
  END; (* IF ed # NIL *)
  RETURN FALSE;
END EditChar;


PROCEDURE PutLine(wdw : INTEGER; adr : ADDRESS; len : CARDINAL) : BOOLEAN;
(* Fgt einen Text an adr an die aktuelle Position ein! 
 *)
 VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    RETURN EditFuncs.putLineInEditor (ed, adr, len, TRUE);
  END;
  RETURN TRUE
END PutLine;

PROCEDURE QuoteSomething (wdw : INTEGER; REF pre : ARRAY OF CHAR; adr : ADDRESS; 
                          len : CARDINAL; width: INTEGER) : BOOLEAN;
(* Fr Quoten und anderes.
 * Fgt einen Text an adr an die aktuelle Position ein! pre wird vor jede Zeile
 * gesetzt. 
 * width: Maximale Lnge einer Zeile, bei der umbebrochen werden soll. 
 * -1: Einstellung aus Editor bernehmen
 *)
 VAR ed : EDITPTR;
     txt : textPtr;
     scrLine : INTEGER;
     
     theLine : aLineDesc;
     startIdx, next,
     idx,
     li,
     preLen  : CARDINAL;
     ch      : CHAR;
     insPre  : BOOLEAN;
     clNr    : LONGINT;
     clRow   : INTEGER;
     rMg     : INTEGER;
     allocLen: INTEGER;
     wasBlock: BOOLEAN;

  PROCEDURE maySplit (row : INTEGER): BOOLEAN;
  BEGIN
    RETURN (txt^[row] IN CharSet{'(','[','{',')',']','}','"',"'"})
  END maySplit; 

BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
  
    WITH ed^ DO 
      SaveOp (ed, normalPaste, FALSE);
      SetBlockstart (ed);

      IF (width < 10) THEN rMg := rightMargin ELSE rMg := width END;
      IF readOnly OR (len=0) THEN RETURN TRUE END;
      IF rightMargin > width
      THEN
        allocLen := rightMargin + 5;
      ELSE
        allocLen := width + 5;
      END;
      ALLOCATE (theLine.text, allocLen);
      IF theLine.text = NIL THEN RETURN FALSE END;
      clRow := currRow;
      theLine.length := allocLen;
      scrLine := SHORT(currLineNr - StartLine);
      txt := adr;
      HideMouse();
      HideCursor (ed);
      v.bool := EditBase.PutCurrLine (ed);
      insPre := TRUE;
      IF currRow # 0
      THEN
        clNr := currLineNr;
        SetCurrLine (ed, currLineNr+1);
        IF clNr = currLineNr THEN insPre := FALSE; END;
      END;
      preLen := (*SYSTEM.*)LENGTH (pre);
      idx := 0;
      len := BinOps.LowerCard (len, (*SYSTEM.*)LENGTH (txt^));
      WHILE idx < len DO
        li := preLen;
        startIdx := idx;
        REPEAT 
          next := EditFuncs.findNext (txt, idx, len, UmbruchSet);
          ch := txt^[next];
          IF next-startIdx+preLen < CARDINAL(rMg) THEN idx := next END;
        UNTIL (next >= len) OR ((next-startIdx)+preLen >= CARDINAL(rMg)) OR (ch=CR) OR (ch = LF) OR (ch = 0C);
        (* Jetzt noch testen, ob irgendwelche Klammern, Anfhrungszeichen oder sonstiges 
         * verletzt wird und solange dekrementieren 
         *)
        IF (idx > startIdx) & (txt^[idx] # CR) & (txt^[idx] # LF)
        THEN
          next := idx;
          WHILE ( next>= startIdx) & maySplit (idx) DO
            next := EditFuncs.findLast (txt, idx, UmbruchSet);
            IF next >= startIdx THEN idx := next; END;
          END;
          (* Jetzt noch testen, ob Effekte verletzt werden *)
          IF (idx > 0) & ~(txt^[idx] IN TrennSet) & (txt^[idx-1] IN CharSet{'_','*','/'})
          THEN
            (* Effektzeichen mit umbrechen *)
            DEC (idx);
          END;
        END;
        IF (idx = startIdx) & (txt^[idx] # CR) & (txt^[idx] # LF)
        THEN
          (* Wort lnger als Umbruchabstand!! *)
          idx := BinOps.LowerInt (startIdx+CARDINAL(rMg)-preLen, len);
        END;
        Strings.Copy (txt^, startIdx, idx-startIdx, theLine.text^, v.bool);
        (*
        IF (txt^[idx] # CR) & (txt^[idx] # LF)
        THEN
          (* Umbruch erfolgt *)
          Strings.DelLeadingBlanks (theLine.text^);
        END;
        *)
        Strings.DelTrailingBlanks (theLine.text^);
        Strings.Insert (pre, 0, theLine.text^, v.bool);
        ch := txt^[idx];
        IF (ch = CR) OR (ch = LF) 
        THEN
          INC (idx);
          IF ((txt^[idx] = CR) OR (txt^[idx] = LF)) & (ch # txt^[idx]) THEN INC (idx) END;
        END;
        li := (*SYSTEM.*)LENGTH (theLine.text^);
        WHILE (li > 0) & ((theLine.text^[li-1] = CR) OR (theLine.text^[li-1] = LF)) DO DEC (li); END;
        theLine.text^[li] := CR;
        theLine.text^[li+1] := LF;
        theLine.text^[li+2] := 0C;
        v.bool := EditBase.InsertLine (ed, currLineNr, theLine.text^, insPre, li+2);
        SetCurrLine (ed, currLineNr +1 );
      END;
      blocks[0].blockEnd.line := currLineNr;
      blocks[0].blockEnd.row  := currRow;
      NewBlockToUndoBuffer (ed);
      (* Und Block wieder lschen *)
      blocks[0].blockStart.line := -1;
      blocks[0].blockEnd.line := -1;
      block := FALSE;
(*        
      IF ~EditFuncs.ReadEditBuffer (ed, adr, len, FALSE, pre)
      THEN
        DEALLOCATE (adr, 0);
        ShowCursor (ed);
        ShowMouse (FALSE);
        RETURN FALSE
      END;
*)     
      SetDocument (ed);
      SetCurrLine (ed, currLineNr);
      currRow := clRow; 
      EditGlobals.FixCursorPos (ed);
      ShowFileChanged (ed);
      redrawLines (ed, scrLine);
      CenterCurrline (ed);
      IF showInfo THEN SetInfoLine (ed) END;
      ShowCursor (ed);
      ShowMouse (FALSE);
    END;
  END;
  RETURN TRUE
END QuoteSomething;

PROCEDURE GetBlock (wdw : INTEGER; unChanged: BOOLEAN; withCrs : BOOLEAN; VAR adr : ADDRESS; VAR buffLen : LONGCARD) : BOOLEAN;
(* Kopiert den gesamten Block an einem Stck 
 * in einen Speicherbereich. 
 * Dieser Bereich wird von dieser Routine angelegt und mu
 * bei Nichtgebrauch wieder freigegeben werden
 * Wenn withCrs = TRUE ist, dann werden die vorhandenen Zeilenumbrche 
 * bernommen, andernfalls werden die Abstze umgebrochen, soweit es geht.
 * 
 *)
 CONST threeLines = CR+LF+CR+LF+CR+LF;
 VAR text : POINTER TO ARRAY[0..MAX(LONGCARD)] OF CHAR;
     ed   : EDITPTR; 
     absatzEnde : BOOLEAN;
     pos        : LONGCARD;
     bLen       : LONGCARD;
     blockLen   : LONGCARD;
     saveLine   : LONGINT;
     saveRow    : INTEGER;
     i          : LONGINT;
     len        : INTEGER;
     len2       : INTEGER;
     writeAdr   : ADDRESS;
     text2      : POINTER TO ARRAY[0..MAX(LONGCARD)] OF CHAR;
     tBuf       : POINTER TO ARRAY[0..MAX(LONGCARD)] OF CHAR;
     z          : INTEGER;
     bl         : INTEGER;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  adr := NIL;
  IF ed # NIL
  THEN
    v.bool := EditBase.PutCurrLine (ed);
    WITH ed^ DO 
      IF ~block THEN RETURN FALSE END;
      blockLen := 0;
      FOR bl := 0 TO maxBlocks - 1 DO
        WITH blocks[bl] DO
          IF (blockStart.line >= 0) & (blockEnd.line >= 0)
          THEN
            EditBase.CountBytes (ed, blockStart.line, blockStart.row, 
                                     blockEnd.line, blockEnd.row, bLen);
          ELSE
            bLen := 0;
          END;
        END;
        IF bLen > 0 THEN INC (bLen, 8); END;
        INC (blockLen, bLen);
      END;
      IF blockLen = 0 THEN RETURN FALSE END;
      INC (blockLen, $100); (* Sicherheitsgrenze *)
      ALLOCATE (text, blockLen);
      (*
      blockLen := $8000;
      text := NIL;
      WHILE (text = NIL) & (blockLen > 0) DO
        ALLOCATE (text, blockLen);
        IF text = NIL THEN DEC (blockLen, $200); END;
      END;
      *)
      IF text = NIL THEN RETURN FALSE END;
      
      (* Bereich lschen *)
      Block.Clear (text, blockLen);
      
      saveLine := currLineNr;
      saveRow := currRow;
      pos := 0;

      FOR bl := 0 TO maxBlocks - 1 DO 
      
        WITH blocks[bl] DO
      
          IF (blockStart.line >= 0) & (blockEnd.line >= 0)
          THEN
          
            IF bl > 0
            THEN
              (* Noch drei Leerzeilen in den Buffer einfgen *)
              Block.Copy (CADR(threeLines), 6, ADR(text^[pos]));
              INC (pos, 6);
            END;
      
            SetCurrLine (ed, blockStart.line);
            i := currLineNr;
            WHILE (i <= blockEnd.line) & (pos < blockLen) DO
              v.bool := EditBase.GetLineAdr (ed, currLineNr, text2, len2);
              len := len2;
       
              absatzEnde := (len <= 2);
              IF blockEnd.line > blockStart.line 
              THEN
                IF (currLineNr < totalLineNr - 1) & ~absatzEnde
                THEN
                  v.bool :=EditBase.GetLineAdr (ed, currLineNr+1, tBuf, z);
                  IF ~unChanged
                  THEN
                    DEC (z);
                    WHILE (z > 0) & ((tBuf^[z] = CR) OR (tBuf^[z] = LF)) DO DEC (z) END;
                    absatzEnde := TRUE;
                    WHILE (z > 0) & absatzEnde DO
                      absatzEnde := tBuf^[z] = ' ';
                      DEC (z);
                    END;
                  END;
                END;
              END;
              
              writeAdr := text2;
              IF i = blockStart.line 
              THEN
                len := BinOps.HigherInt ( 0, len-blockStart.row);
                INC (writeAdr, blockStart.row);
              END;
              IF i = blockEnd.line
              THEN
                DEC (len, len2 - blockEnd.row);
                IF len < 0 THEN len := 0 END;
              END;
              tBuf := writeAdr;
              IF ~unChanged
              THEN
                WHILE (len > 0) & ((tBuf^[len-1] = CR) OR (tBuf^[len-1] = LF)) DO DEC (len); END;
                IF ~withCrs
                THEN
                  WHILE (len > 0) & (tBuf^[0] = ' ') DO DEC (len); INC (tBuf); END;
                END;
              END;
              writeAdr := tBuf;
       
              (* Zeile ausgeben *)
              IF LONGCARD(LONG(len)) + pos > blockLen
              THEN
                Block.Copy (writeAdr, blockLen-pos-1, ADR(text^[pos]));
              ELSE
                Block.Copy (writeAdr, LONGCARD(LONG(len)), ADR(text^[pos]));
              END;
              INC (pos, len);
              
              (* Bei Absatz noch CR/LF ausgeben *)
              IF ~unChanged
              THEN
                IF ~((i=blockEnd.line) & (blockEnd.row=0))
                THEN
                  IF ((absatzEnde & (pos < blockLen-2)) OR withCrs) 
                  THEN
                    text^[pos] := CR;
                    INC (pos);
                    text^[pos] := LF;
                    INC (pos);
                  ELSE
                    IF (pos > 0) & (text^[pos-1] # ' ') & (text^[pos-1] # CR) THEN
                      text^[pos] := ' ';
                      INC (pos);
                    END;
                  END;
                END;
              END;
      (*        text^[pos] := LF;
              INC (pos); *)
              SetCurrLine (ed, currLineNr+1);
              INC(i);
            END; (* WHILE line # NIL *)
          END;
        END;
      
      END;
      IF pos < blockLen THEN
        text^[pos] := 0C;
        buffLen := pos - 1;
      ELSE
        text^[blockLen-1] := 0C;
        buffLen := blockLen - 2;
      END;
      IF text^[pos-1] = ' '
      THEN
        text^[pos-1] := 0C;
        buffLen := pos - 2;
      END;
      INC (buffLen);    (* da pos ab -1 geht *)
      
      (* Hier noch Speicherblock verkleinern *)
      DEALLOCATE (text, blockLen-pos-1);
      SetCurrLine (ed, saveLine);
      currRow := saveRow;
      EditGlobals.FixCursorPos (ed);
      adr := ADDRESS(text);
      (*
      IF ~withCrs
      THEN
        Strings.DelLeadingBlanks (text^);
      END;
      Strings.DelTrailingBlanks (text^);
      *)
      RETURN TRUE;
    END;
  END;
  RETURN FALSE;
END GetBlock;

PROCEDURE ClickIsInBlock (wdw : INTEGER; x, y: INTEGER) : BOOLEAN;
(* Gibt zurck, ob die Position x, y im Blockbereich liegt
 *)
BEGIN
  RETURN EditUtil.ClickIsInBlock (wdw, x, y);
END ClickIsInBlock;

PROCEDURE ClickInEditWindow(win, vdiH : INTEGER; special : ADDRESS; x,y : INTEGER; kstate, buts : BITSET; clicks : INTEGER): BOOLEAN;
  VAR ed : EDITPTR;
      work      : Rectangle;
      clLine    : LONGINT;
      clRow     : INTEGER;
      i         : LONGINT;
      mx, my    : INTEGER;
      but       : BITSET;
      kshift    : BITSET;
      oLine     : LONGINT;
      oRow      : INTEGER;
      init,
      whichMark : BOOLEAN;
      currSize  : Rectangle;
BEGIN
  ed := EditFuncs.FindEditor (win);
  IF ed # NIL
  THEN
(*    doDump (ed); 
    IF Inconsistent() THEN v.int := mtAlerts.Alert (1,memFault); END;
*)
    WITH ed^ DO
      IF ~(0 IN buts) THEN RETURN FALSE END;
      block := BlockIsMarked (wdw);
      oRow := currRow;
      oLine := currLineNr;
      WdwManager.GetWdwWork (wdw, work);
      WdwManager.GetWdwSize (wdw, currSize);
      IF hasUserProc & RectFuncs.IsInRect (x, y, userRect)
      THEN
        ed^.userProc (win, hdl, x, y, kstate, work);
        lastOpWasCtrlY := FALSE;
        ClipWork (ed);
        RETURN TRUE
      END;
      IF RectFuncs.IsInRect (x, y, editWork)
      THEN
        (* Listwindow im Editor nur in FRED *)
        (*$? ~CAT:
        IF listMode
        THEN
          EditTools.ClearBlock (ed);
          (* Jetzt Zeile und Spalte bestimmen *)
          GetClickLineAndRow (ed, x, y, clLine, clRow);
          SetCurrLine (ed, clLine);
          IF clicks > 1
          THEN
            (* Jetzt die Zeile markieren, die selektiert wurde *)
            MarkLine (ed);
            IF ADDRESS(listModeProc) # NIL
            THEN
              (* Prozedur aufrufen mit dem Inhalt der Zeile *)
              listModeProc (wdw, editLine.text^);
            END;
          END;
          IF showInfo THEN SetInfoLine (ed) END;
        ELSE
        *)
          (* Cursor ausschalten *)
          HideMouse ();
          HideCursor (ed);
          (* Jetzt Zeile und Spalte bestimmen *)
          GetClickLineAndRow (ed, x, y, clLine, clRow);
          (* Jetzt nachsehen, ob die Maustaste noch gedrckt ist *)
          MagicAES.GrafMkstate (mx, my, but, kshift);
          IF CatGlobal.WithShift (kstate)
          THEN
            lastOpWasCtrlY := FALSE;
            IF block THEN
              (* Block ist markiert, Markierung erweitern *)
              (* Wenn es ein Klick in den Block ist und die Maustaste 
               * festgehalten wird, dann ist es Drag & Drop! 
               *)
              IF (currLineNr < blocks[0].blockStart.line) OR 
                 ((currLineNr = blocks[0].blockStart.line) & (currRow < blocks[0].blockStart.row))
              THEN
                IF wordBlock THEN 
                  currRow := ToWordStart (ed, currLineNr, currRow); 
                ELSIF lineBlock THEN
                  currRow := ToLineStart (ed, currLineNr); 
                END;
                SetBlockstart (ed);
                whichMark := TRUE;
              ELSE 
                IF wordBlock THEN 
                  currRow := ToWordEnd (ed, currLineNr, currRow); 
                ELSIF lineBlock THEN
                  IF currLineNr < totalLineNr - 1 
                  THEN
                    INC (currLineNr);
                    SetCurrLine (ed, currLineNr);
                    currRow := ToLineStart (ed, currLineNr); 
                  ELSE
                    currRow := ToLineEnd (ed, currLineNr); 
                  END;
                END;
                IF (currRow > 0) & (editLine.text^[currRow-1] = CR)
                THEN
                  DEC (currRow);
                END;
                SetBlockend (ed);
                whichMark := FALSE;
              END;
            ELSE
              (* noch keiner markiert, also jetzt markieren *)
              IF (currLineNr > oLine) OR ((currLineNr = oLine) & (currRow > oRow))
              THEN
                whichMark := FALSE;
                SetBlockend (ed);
                SetCurrLine (ed, oLine);
                currLineNr := oLine;
                currRow := oRow;
                SetBlockstart (ed);
                SetCurrLine (ed, clLine);
                currLineNr := clLine;
                currRow := clRow;
              ELSE
                whichMark := TRUE;
                SetBlockstart (ed);
                SetCurrLine (ed, oLine);
                currLineNr := oLine;
                currRow := oRow;
                SetBlockend (ed);
                SetCurrLine (ed, clLine);
                currLineNr := clLine;
                currRow := clRow;
              END;
              block := TRUE;
            END;
          END;
          IF MagicSys.Bit0 IN but
          THEN 
            (* Wenn es ein Klick in den Blockbereich ist und die 
             * Shift-Taste nicht gedrckt ist, dann ist es eine Drag & Drop Action
             *)
            IF block & 
              ~CatGlobal.WithShift (kstate) &
              ( (currLineNr > blocks[0].blockStart.line) OR 
                ((currLineNr = blocks[0].blockStart.line) & (currRow >= blocks[0].blockStart.row)) ) & 
              ( (currLineNr < blocks[0].blockEnd.line) OR
                ((currLineNr = blocks[0].blockEnd.line) & (currRow <= blocks[0].blockEnd.row)) )
            THEN
              (* click ist in Block und nicht mit Shift! 
               * Nur in dem Fall ist es Drag & Drop
               *)
              EditUtil.PerformDragDrop (ed, x, y, kstate, buts);
            ELSE
              lastOpWasCtrlY := FALSE;
              (* Taste noch gedrckt, in Blockmarkmodus gehen *)
              IF ~CatGlobal.WithShift (kstate)
              THEN
                (* eventuell vorhandenen Block lschen *)
                EditTools.ClearBlock (ed);
              END;
              init := ~block;
              IF ~block THEN
                wordBlock := (clicks = 2) & ~CatGlobal.WithCtrl (kstate);
                lineBlock := (clicks > 2) OR ((clicks = 2) & CatGlobal.WithCtrl (kstate));
                IF wordBlock 
                THEN
                  EditTools.MarkWord (ed); 
                  whichMark := FALSE;
                ELSIF lineBlock 
                THEN
                  MarkLine (ed); 
                  whichMark := FALSE;
                ELSE
                  SetBlockstart (ed); SetBlockend (ed); whichMark := FALSE 
                END;
              END;
              MarkBlock (ed, x, y, init, ~whichMark);
              TestBlockMarksAndSwap (ed);
              block := BlockIsMarked (wdw);
            END;
          ELSE
            IF ~CatGlobal.WithShift (kstate)
            THEN 
              lastOpWasCtrlY := FALSE;
              IF block THEN 
                EditTools.ClearBlock (ed); 
              ELSE
                blocks[0].blockStart.line := -1;
                blocks[0].blockEnd.line := -1;
              END;
              wordBlock := (clicks = 2) & ~CatGlobal.WithCtrl (kstate);
              lineBlock := (clicks > 2) OR ((clicks = 2) & CatGlobal.WithCtrl (kstate));
              IF wordBlock THEN 
                EditTools.MarkWord (ed); 
              ELSIF lineBlock
              THEN
                MarkLine (ed);
              END;
            END;
            block := BlockIsMarked (wdw);
          END;
          ShowCursor (ed);
          ShowMouse (FALSE);
          IF showInfo THEN SetInfoLine (ed) END;
        (*$? ~CAT:
        END;
        *)
        RETURN TRUE;
      ELSE
        (* War falscher Aufruf *)
        RETURN FALSE
      END; 
    END (* WITH ed^ *)
  END;
  RETURN FALSE;
END ClickInEditWindow;
 
        (* Font-Funktionen      *)
PROCEDURE SetFont (VAR ed : EDITPTR; fnt, fntSiz : INTEGER);
  VAR varName : ARRAY [0..255] OF CHAR;
BEGIN
  WITH ed^ DO
    font := fnt;
    fontSize := fntSiz;
    cursPos.row := -1;
    FontSelect.SetFont (hdl, font, fontSize, FALSE, monoSpaced, isFSM, charWidth, charHeight);
    maxWidth := 0;
    IF ~alienCoords 
    THEN
      Strings.Concat (cEditFont, StrConv.IntToStr (number, 0), varName, v.bool);
      v.bool := ConfVars.SetConfigInt (varName, font);
      Strings.Concat (cEditSize, StrConv.IntToStr (number, 0), varName, v.bool);
      v.bool := ConfVars.SetConfigInt (varName, fontSize);
    END;
  END
END SetFont;
 
PROCEDURE SelectEditFont (wdw : INTEGER; font, fontSiz : INTEGER);
(* Setzt den neuen Font fr den Editor 
 *)
VAR ed  : EDITPTR;
    r           : Rectangle;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    SetFont (ed, font, fontSiz);
    WITH ed^ DO
      (* Jetzt ist der Font gesetzt. Jetzt noch Window snappen und dann neu
       * zeichnen lassen 
       *)
      WdwManager.SetDocumentParms (wdw, 1, charHeight);
      WdwManager.SnapWdw (wdw);
      WdwManager.SetClip (cursorHandle, ed^.editWork, TRUE);
      WdwManager.RedrawWdw (wdw, editWork);
    END; (* WITH ed^ DO *)
  END (* IF ed # NIL *);
END SelectEditFont;
 
        (* Nachfrage-Funktionen *)
 
PROCEDURE IsEditTop(wdw : INTEGER): BOOLEAN;
(* fragt nach, ob ein Editor das Top-Window hat
 *)
 VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  RETURN (ed # NIL) & ~(ed^.isHidden)
END IsEditTop;
 
PROCEDURE BlockIsMarked(wdw : INTEGER) : BOOLEAN;
(* Gibt zurck, ob ein Block markiert ist oder nicht 
 *)
VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    WITH ed^ DO 
      RETURN (blocks[0].blockStart.line >= 0) & (blocks[0].blockEnd.line >= 0) & 
             ( ((blocks[0].blockStart.line = blocks[0].blockEnd.line) 
               & (blocks[0].blockEnd.row > blocks[0].blockStart.row))
            OR (blocks[0].blockStart.line < blocks[0].blockEnd.line));
    END;
  END;
  RETURN FALSE;
END BlockIsMarked;
 
PROCEDURE GetEditVDIHandle (wdw : INTEGER; VAR hdl : INTEGER);
(* Liefert Handle der Workstation des Fensters *)
  VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    hdl := ed^.hdl;
  ELSE
    hdl := -1
  END;
END GetEditVDIHandle;
 
(* Anzeige-Funktionen des Editors! *)
PROCEDURE OpenEditBuffer (REF title, infoline : ARRAY OF CHAR;
                          showInfoLine : BOOLEAN;
                          buff : ADDRESS; buffLen : LONGCARD; 
                          freeBuffer: BOOLEAN;
                          txtIsEnriched: BOOLEAN;
                          edFont, edFontSize : INTEGER; full : Rectangle;
                          (* User-Proc Parameter *)
                          useUserProc : BOOLEAN; 
                          theUserProc, theUserRectProc,
                          theDrawUserProc, theCloseProc, theKeyProc, 
                          theTopProc, theUntopProc, thePrePrintProc : ADDRESS; (*!! Hier aufpassen!*)
                          (* Edit-Parameter *)
                      VAR wdwHandle : INTEGER) : BOOLEAN;
(* ffnet einen Editor und liest Text aus Buffer
 *)
 VAR 
     ed         : EDITPTR;
     wdwH       : INTEGER;
     outSize    : Rectangle;
     comps      : BITSET;
     err        : EditFuncs.ErrReason;
     i          : INTEGER;
     bits       : INTEGER;
     
  PROCEDURE FreeStuff();
  (* Dealloziert allozierte Pointer und gibt sonstiges Zeugs frei
   *)
  BEGIN
    IF wdwH >= 0 THEN v.bool := WdwManager.CloseWindow (wdwH, TRUE) 
    ELSIF ed # NIL THEN EditFuncs.KillEditor (ed) END;
  END FreeStuff;
 
BEGIN
  (* Variablen initialisieren, damit FreeStuff auch funktioniert! *)
  ed := NIL;
  wdwH := -1;
  (* Fensterkomponenten bestimmen *)
  comps := {MagicAES.NAME..MagicAES.HSLIDE};
  IF ~showInfoLine
  THEN
    EXCL (comps, MagicAES.INFO);
  END;
  IF ConfVars.GetConfigBool (cMsgWithoutHScroll, v.bool) & v.bool
  THEN
    comps := comps - {MagicAES.LFARROW..MagicAES.HSLIDE};
  END;

  (* Editor erstellen *)
  IF ~EditFuncs.CreateEditor (ed) 
  THEN
    (* Fehlermeldung: not enough memory *)
    FreeStuff;
    EditFuncs.OutOfMem();
    RETURN FALSE
  END;
  WITH ed^ DO 
    (* Editorvariablen setzen *)
    ConfVars.GetConfDefBool (cParseEffects, parseEffects, TRUE);
    isEnriched  := txtIsEnriched;
    wdwIsOpen   := FALSE;
    wasOpen     := FALSE;
    fileName.text := NIL;
    fileName.length := 0;
    changed     := FALSE;
    leftOffset  := 0;
    showInfo    := showInfoLine;
    readOnly    := TRUE;
    alienCoords := TRUE;
    insertMode  := TRUE;
    autoIndent  := TRUE;
    realTabs    := TRUE;
    tabSize     := 8;
    windComps   := comps;
    cursor      := 1;
    block       := FALSE;
    blockIndent := FALSE;
    currLineNr  := 0;
    StartLine   := 0;
    FOR i := 0 TO maxBlocks - 1 DO
      WITH blocks[i] DO
        blockStart.line := -1;
        blockEnd.line := -1;
      END;
    END;
    backup      := FALSE;
    (* Strings bernehmen *)
    Strings.Assign (title, WindowTitle, v.bool);
    Strings.Assign (infoline, WindowInfo, v.bool);
    (* Jetzt noch die User-Parameter *)
    hasUserProc := useUserProc;
    userProc    := userProcType (theUserProc);
    getUserRect := userGetRectProc (theUserRectProc);
    drawUserArea:= drawUserProc (theDrawUserProc);
    userClose   := userCloseProc (theCloseProc);
    userKey     := userKeyProc (theKeyProc);
    userTop     := userTopProc (theTopProc);
    userUntop   := userUntopProc (theUntopProc);
    userPrint   := userPrePrintProc (thePrePrintProc);
    listModeProc:= userListProc (NIL);
    listMode    := FALSE;
    hOffset     := 0;
    charHeight  := 16;
    charWidth   := 8;
    maxWidth    := 0;
    currRow     := 0;
  END;
  (* Fenster mit Window Library ffnen *)
  IF ~WdwManager.OpenWindow (ClickInEditWindow, EditChar, WdwManager.handleTimerProc (NIL),
              deskSize, full, comps, TRUE, "", "",
              snapWindow, closeEditor, redrawWdw, topEditor, 
              untopEditor, handleUpdate, docChanged, getScrollRect, hideEditor,
              pixOff, ed, FALSE, TRUE, TRUE, TRUE, wdwH, ed^.hdl)
  THEN
    (* Kein Fenster oder keine Workstation mehr frei! *)
    FreeStuff();
    MTE.info (noBuffOpen);
    RETURN FALSE
  END;
  IF ConfVars.GetConfigBool (cMsgUseBEvent, v.bool) & v.bool
  THEN
    IF (MagicAES.ApplGetinfo (MagicAES.AEWINDOWS, bits, v.int, v.int, v.int) = 1)
     & (MagicSys.Bit5 IN BITSET (bits))
    THEN
      (* Nicht schn, aber selten *)
      v.r[0] := 1; v.r[1] := 0; v.r[2] := 0; v.r[3] := 0;
      MagicAES.WindSet (wdwH, MagicAES.WFBEVENT, v.r);
    END;
  END;
 
  WITH ed^ DO
    wdw         := wdwH;
    isHidden    := FALSE;
    (* Text einlesen *)
    currRow := 0;
    rightMargin := MAX(INTEGER);
    umbruch := FALSE;
    (* Text einlesen *)
    IF ~EditFuncs.ReadBuffer (ed, buff, buffLen, freeBuffer, err)
    THEN
      (* Fehlermeldung kam schon, nur alles wieder freigeben *)
      IF err = EditFuncs.memError
      THEN
        EditFuncs.OutOfMem();
      END;
      FreeStuff;
      RETURN FALSE
    END;
    editWork := deskSize;
    wasOpen     := TRUE; 
 
    editChanged := FALSE;
    currLineNr  := -1;
    SetCurrLine (ed, 0);

    (* Pointer noch richtig setzen *)
    currentBuff := firstBuff;
    currLineNr := 0;
    currRow := 0;
    (* Als Drag & Drop Server installieren *)
    WdwManager.WdwInstallDDServer (wdw, editGetHeader, editReadData);
    (* Fonts laden *)
    FontSelect.LoadFonts (hdl, v.int);
    (* Font setzen *)
    SetFont (ed, edFont, edFontSize);
    font        := edFont;
    (* Fllparameter setzen *)
    v.int := MagicVDI.SetFillstyle (hdl, MagicVDI.Full);
    v.int := MagicVDI.SetFillinterior (hdl, MagicVDI.Full);
(*    v.int := MagicVDI.SetFillcolor (hdl, MagicAES.WHITE); *)
    (* Schreibmodus setzen *)
    v.int := MagicVDI.SetWritemode (hdl, MagicVDI.REPLACE);
    (* Umbruchbreite zurcksetzen *)
    lastWrapWidth := 0;
  END;
  (* Fensterinhalte setzen *)
  SetEditTitle (ed);
  IF showInfoLine THEN SetInfoLine (ed); END;
  WITH ed^ DO
    (* Fenstergre berechnen *)
    WdwManager.SetWdwSize (wdw, full);
    (* Text umbrechen *)
    v.bool := EditUtil.WrapText (ed, isEnriched);
    wdwHandle := wdw;
    WdwManager.SetDocumentParms (wdw, 1, charHeight);
    WdwManager.SetScrollParms (wdw, editWork.w-charWidth, windLines-1, charWidth, 1);
  END (* WITH ed *);
  (* Document fr Window setzen *)
  SetDocument (ed);
  (* Cursor anzeigen *)
  ShowCursor (ed);
  ed^.wdwIsOpen := TRUE;
  RETURN TRUE;
END OpenEditBuffer;
 
PROCEDURE CloseEditBuffer (wdw : INTEGER);
(* Schliet Nachrichtenfenster *)
 VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    WITH ed^ DO
      ed^.changed := FALSE;
      v.bool := CloseEditor (wdw, FALSE);
    END; 
  END;
END CloseEditBuffer;
 
PROCEDURE ShowNewBuffer (wdw : INTEGER; 
                         REF title, infoline : ARRAY OF CHAR;
                         buff : ADDRESS; buffLen : LONGCARD;
                         freeBuffer: BOOLEAN;
                         txtIsEnriched: BOOLEAN);
(* Zeigt neuen Text im Anzeigefenster an! *)
  VAR ed : EDITPTR;
      line : aLinePtr;
      rect : Rectangle;
      err  : EditFuncs.ErrReason;
      i    : INTEGER;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    WITH ed^ DO 
      WHILE firstBuff # NIL DO
        currentBuff := firstBuff;
        EditBase.FreeBuffer (ed);
      END;
      ConfVars.GetConfDefBool (cParseEffects, parseEffects, TRUE);
      isEnriched  := txtIsEnriched;
      editChanged := FALSE;
      editLine.text^ := '';
      currRow := 0;
      totalLineNr := 0;
      currLineNr := 0;
      readOnly    := TRUE;
      IF ~EditFuncs.ReadBuffer (ed, buff, buffLen, freeBuffer, err)
      THEN
        (* Fehlermeldung kam schon, nur alles wieder freigeben *)
        IF err = EditFuncs.memError
        THEN
          EditFuncs.OutOfMem();
        END;
        RETURN 
      END;
      currentBuff := firstBuff;
      block       := FALSE;
      alienCoords := TRUE;
      currRow     := 0;
      StartLine   := 0;
      FOR i := 0 TO maxBlocks - 1 DO
        WITH blocks[i] DO
          blockStart.line := -1;
          blockEnd.line := -1;
        END;
      END;
      leftOffset  := 0;
      maxWidth    := 0;
      editChanged := FALSE;
      currLineNr  := -1;
      SetCurrLine (ed, 0);
      Strings.Assign (title, WindowTitle, v.bool);
      Strings.Assign (infoline, WindowInfo, v.bool);
      (* neu zeichnen und Slider setzen *)  
      IF showInfo THEN SetInfoLine (ed); END;
      SetEditTitle (ed);
      (* Umbruchbreite zurcksetzen *)
      lastWrapWidth := 0;
      (* Text umbrechen *)
      v.bool := EditUtil.WrapText (ed, isEnriched);
      WdwManager.SetNewDocument (wdw, LongRect{LONG(leftOffset), StartLine, LONG(maxWidth), totalLineNr-1}, TRUE);
    END;
  END;
END ShowNewBuffer;
 
PROCEDURE CloseAllEditors (force : BOOLEAN) : BOOLEAN;
(* schliet alle Editoren, gibt TRUE zurck, falls
 * erfolgreich 
 *)
 VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.editList;
  WHILE ed # NIL DO
    ShowMouse (TRUE);
    IF ~CloseEditor (ed^.wdw, force) THEN RETURN FALSE END;
    ed := ed^.nextEdit;
  END;
  RETURN TRUE;
END CloseAllEditors;
 
 
PROCEDURE DoUndo (wdw : INTEGER); 
(* Fhrt Undo durch *)
  VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    HideMouse ();
    HideCursor (ed);
    lastOpWasCtrlY := FALSE;
    Undo (ed);
    ShowCursor (ed);
    ShowMouse (FALSE);
  END;
END DoUndo;
 
PROCEDURE MarkWord (wdw : INTEGER);
(* Markiert das Wort beim Cursor als Block *)
  VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    HideMouse ();
    HideCursor (ed);
    EditTools.ClearBlock (ed);
    EditTools.MarkWord (ed);
    ShowCursor (ed);
    ShowMouse (FALSE);
  END;
END MarkWord;

PROCEDURE MarkAll (wdw : INTEGER);
(* Markiert den ganzen Text als Block *)
  VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    WITH ed^ DO 
      HideMouse();
      HideCursor (ed);
      SetCurrLine (ed, totalLineNr-1);
      currRow := editLen;
      (* EditGlobals.FixCursorPos (ed);*)
      SetBlockend (ed);
      SetCurrLine (ed, 0);
      currRow := 0;
      SetBlockstart (ed);
      block := TRUE;
      CenterCurrline (ed);
      ShowCursor (ed);
      ShowMouse (FALSE);
    END;
  END;
END MarkAll;
 
PROCEDURE EditSetOffset (wdw: INTEGER; offset: INTEGER);
(* Setzt den Cursor an die Position offset im aktuellen Buffer
 * Wird nur fr CAT gebraucht!
 *)
VAR ed : EDITPTR;
    line: LONGINT;
    row : INTEGER;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    EditBase.GetPos (ed, offset, line, row);
    EditFuncs.Goto (ed, line, row);
  END;
END EditSetOffset;

PROCEDURE EditSetLineAndRow (wdw: INTEGER; line: LONGINT; row: INTEGER);
(* Setzt den Cursor an die angegebene Position, falls mglich
 *)
VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    EditFuncs.Goto (ed, line, row);
  END;
END EditSetLineAndRow;

(* neue Funktionen fr Eddix *)
PROCEDURE ToLineNr (wdw : INTEGER; nr : LONGINT);
(* Geht zur Zeile nr, falls mglich *)
VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    EditFuncs.Goto (ed, nr, ed^.currRow);
  END;
END ToLineNr;
 
PROCEDURE GetCompInfo (wdw: INTEGER; VAR fName: ARRAY OF CHAR; 
                       VAR saved: BOOLEAN): BOOLEAN;
(* Liefert den kompletten Filenamen, falls das Fenster ein Editor
 * ist
 *)
 VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    WITH ed^ DO
      IF fileName.length # 0
      THEN
        Strings.Assign (fileName.text^, fName, v.bool);
      ELSE
        Strings.Assign (cNoname,fName, v.bool);
      END;
      saved := ~changed;
    END;
    RETURN TRUE
  END;
  RETURN FALSE;
END GetCompInfo;

PROCEDURE FileInfos (wdw : INTEGER; VAR lines, bytes : LONGCARD; 
                     VAR edits : INTEGER;
                     VAR totalMem : LONGCARD;
                     VAR fName : ARRAY OF CHAR) : BOOLEAN;
(* Gibt Informationen ber den aktuellen Text raus
 *)
 VAR ed : EDITPTR;
     clLine : LONGINT;
     clRow : INTEGER;
     aBuf  : aBufferPtr;
BEGIN
  edits := 0;
  ed := EditFuncs.editList;
  WHILE ed # NIL DO INC(edits); ed := ed^.nextEdit END;
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    WITH ed^ DO
      lines := totalLineNr;
      bytes := 0;
      totalMem := 0;
      clLine := currLineNr;
      clRow := currRow;
      MouseBusy();
      aBuf := firstBuff;
      WHILE aBuf # NIL DO
        INC (bytes, aBuf^.usedMem);
        INC (totalMem, aBuf^.bufSize);
        INC (totalMem, LONG(aBuf^.maxLine)*TSIZE(INTEGER));
        INC (totalMem, TSIZE (aBuffer));
        aBuf := aBuf^.next;
      END;
      (* YYYY
      SetCurrLine (ed, 0);
      WHILE currLine # NIL DO
        INC (bytes, LENGTH(currLine^.zeile.text^)+2);
        INC (totalMem, currLine^.zeile.length+TSIZE(aLine)+TSIZE(aLineDesc));
        currLine := currLine^.next;
      END;
      *)
      INC(totalMem, TSIZE (EDITOR));
      SetCurrLine(ed, clLine);
      currRow := clRow;
      IF fileName.length # 0
      THEN
        Strings.Assign (FileNames.FileName(fileName.text^), fName, v.bool);
      ELSE
        Strings.Assign (cNoname,fName, v.bool);
      END;
      MouseArrow();
      RETURN TRUE;
    END (* WITH ed^ *);
  END;
  RETURN FALSE
END FileInfos;
 
PROCEDURE SetBlockStart (wdw : INTEGER);
(* Setzt Blockanfang auf Cursorposition           
 *)
 VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    WITH ed^ DO 
     IF block THEN RETURN END;
     HideMouse();
     HideCursor (ed);
     SetBlockstart (ed);
     block := BlockIsMarked (ed^.wdw);
     ShowCursor (ed);
     ShowMouse (FALSE);
    END;
  END;
END SetBlockStart;
 
PROCEDURE SetBlockEnd (wdw : INTEGER);
(* Setzt Blockende auf Cursorposition           
 *)
 VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    WITH ed^ DO 
     IF block THEN RETURN END;
     HideMouse();
     HideCursor (ed);
     SetBlockend (ed);
     block := BlockIsMarked (ed^.wdw);
     ShowCursor (ed);
     ShowMouse (FALSE);
    END;
  END;
END SetBlockEnd;
 
PROCEDURE ClearBlock (wdw : INTEGER);
(* Lscht Blockmarkierung 
 *)
 VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    EditTools.ClearBlock (ed);
  END;
END ClearBlock;

PROCEDURE SetMark (wdw : INTEGER; which : INTEGER);
(* Setzt Marke which an Cursorposition 
 *)
 VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    WITH ed^ DO 
      IF which <= 4 THEN
        markPoints[which].line := currLineNr+1;
        markPoints[which].row := currRow;
      END;
    END;
  END;
END SetMark;
 
PROCEDURE ToMark (wdw : INTEGER; which : INTEGER);
(* Springt zur Marke which 
 *)
 VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    IF which <= 4 THEN
      WITH ed^.markPoints[which] DO
        EditFuncs.Goto (ed, line, row);
      END
    END;
  END;
END ToMark;
 
PROCEDURE ToBlockStart (wdw : INTEGER);
(* Springt zum Blockanfang 
 *)
 VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    ToBlockmark (ed, FALSE);
  END;
END ToBlockStart;
 
PROCEDURE ToBlockEnd (wdw : INTEGER);
(* Springt zum Blockende
 *)
 VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    ToBlockmark (ed, TRUE);
  END;
END ToBlockEnd;
 
PROCEDURE SetTabsize (wdw : INTEGER; size : INTEGER);
(* Setzt Tabsize auf size 
 *)
 VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    ed^.tabSize := size;
  END;
END SetTabsize;
 
PROCEDURE GetTabsize (wdw : INTEGER; VAR size : INTEGER);
(* Setzt Tabsize auf size 
 *)
 VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    size := ed^.tabSize; 
  END;
END GetTabsize;
 
PROCEDURE SetMargins (wdw : INTEGER; right : INTEGER; Umbruch : BOOLEAN);
(* Setzt die Rnder und man kann den Umbruch ein-
 * und ausschalten 
 *)
 VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    WITH ed^ DO 
      rightMargin := right;
      IF rightMargin < 1 THEN rightMargin := 1 END;
      umbruch := Umbruch;
    END;
  END;
END SetMargins;
 
PROCEDURE GetMargins (wdw : INTEGER; VAR right : INTEGER);
(* Setzt die Rnder und man kann den Umbruch ein-
 * und ausschalten 
 *)
 VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    right := ed^.rightMargin;
  END;
END GetMargins;
 
PROCEDURE ToggleMode (wdw : INTEGER; mode : editMode);
(* Schaltet einen Zustand um *)
 VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    WITH ed^ DO 
      HideMouse();
      HideCursor (ed);
      CASE mode OF
        insMode : insertMode := ~insertMode |
        indentMode : autoIndent := ~autoIndent; |
        autoBackup : backup := ~backup; |
        wrapMode   : umbruch := ~umbruch; |
        tabMode    : realTabs := ~realTabs;
                     cursPos.row := -1; |
        crMode     : showCR := ~showCR; |
        roMode     : readOnly := ~readOnly; |
        effMode    : parseEffects := ~parseEffects; |
        errorMode  : listMode := ~listMode; |
      ELSE
      END;
      SetInfoLine (ed);
      ShowCursor (ed);
      ShowMouse (FALSE);
    END;
  END;
END ToggleMode;
 
PROCEDURE SetMode (wdw : INTEGER; mode : editMode; val : BOOLEAN);
(* Setzt einen Zustand 
 *)
 VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    WITH ed^ DO 
      HideMouse();
      HideCursor (ed);
      CASE mode OF
        insMode    : insertMode := val; |
        indentMode : autoIndent := val; |
        autoBackup : backup :=  val; |
        wrapMode   : umbruch := val; |
        tabMode    : realTabs := val; 
                     cursPos.row := -1; |
        crMode     : showCR := val; |
        roMode     : readOnly := val; |
        effMode    : parseEffects := val; |
        errorMode  : listMode := val; |
      ELSE
      END;
      SetInfoLine (ed);
      ShowCursor (ed);
      ShowMouse (FALSE);
    END;
  END;
END SetMode;
 
PROCEDURE GetMode (wdw : INTEGER; mode : editMode) : BOOLEAN;
(* Fragt einen Zustand ab.
 *)
 VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    WITH ed^ DO 
      CASE mode OF
        insMode : RETURN insertMode |
        indentMode : RETURN autoIndent |
        autoBackup : RETURN backup |
        wrapMode   : RETURN umbruch |
        tabMode    : RETURN realTabs; |
        crMode     : RETURN showCR; |
        roMode     : RETURN readOnly; |
        effMode    : RETURN parseEffects; |
        errorMode  : RETURN listMode;
      ELSE
      END;
    END;
  END;
  RETURN FALSE
END GetMode;
 
(*$? NOT CAT:
PROCEDURE SetListMode (wdw: INTEGER);
(* Setzt den Listenmodus fr ein Fenster. Dabei wird der Cursor
 * ausgeschaltet, das Fenster auf Readonly gesetzt und der Listen-
 * modus angeschaltet
 *)
BEGIN
  SetMode (wdw, roMode, TRUE);
  SetMode (wdw, errorMode, TRUE);
END SetListMode;

PROCEDURE SetListProc (wdw: INTEGER; listProc : ADDRESS): BOOLEAN;
(* Setzt die ListModeProc fr ein Fenster. Um alles einzuschalten, 
 * sollte man einfach SetListMode aufrufen.
 *)
 VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    ed^.listModeProc := userListProc (listProc);
  END;
  RETURN ed # NIL
END SetListProc;

PROCEDURE FileIsEditor (REF fname: ARRAY OF CHAR; VAR wdw: INTEGER): BOOLEAN;
(* Gibt bei einem bergebenem Dateinamen zurck, ob diese Datei
 * schon geladen ist. Beachtet auch Case-Sensitivitt von Filesystemen
 * Im Falle von TRUE wird in wdw das Fensterhandle des Editors 
 * zurckgeliefert
 *)
 VAR ed : EDITPTR;
     caseSensitiv: BOOLEAN;
BEGIN
  IF MintUtil.IsMiNT()
  THEN
    caseSensitiv := Mintbind.Dpathconf (fname, 6) = 0;
  ELSE
    caseSensitiv := FALSE;
  END;
  ed := EditFuncs.editList;
  WHILE ed # NIL DO
    IF ed^.fileName.text # NIL
    THEN
      IF (caseSensitiv & Strings.StrEqual (fname, ed^.fileName.text^)) OR
         (~caseSensitiv & AssFuncs.StrIequal (fname, ed^.fileName.text^))
      THEN
        wdw := ed^.wdw;
        RETURN TRUE;
      END;
    END;
    ed := ed^.nextEdit;
  END;
  RETURN FALSE;
END FileIsEditor;

PROCEDURE CompileText (wdw : INTEGER);
 VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    EditFuncs.callComp (ed);
  END;
END CompileText;
 
PROCEDURE ShowError (wdw : INTEGER);
 VAR ed  : EDITPTR;
     adr : RECORD a,b : ADDRESS; END;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    EditFuncs.showError (ed);
  END;
END ShowError;
 
PROCEDURE SetError (wdw: INTEGER; errorLine : LONGINT; 
                    errorRow : INTEGER; REF errorMsg : ARRAY OF CHAR;
                    show : BOOLEAN);
 VAR ed  : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    WITH ed^ DO
      errRow := errorRow;
      errLine := errorLine;
      Strings.Assign (errorMsg, errMsg, v.bool);
      IF show THEN ShowError (wdw); END;
    END;
  END;
END SetError;
*)
 
(* Block Transformationen *)
PROCEDURE BlockUp (wdw : INTEGER);
  VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    IF ed^.block 
    THEN
      EditFuncs.TransformBlock (ed, EditFuncs.AllUp, FALSE);
    END
  END;
END BlockUp;
 
PROCEDURE BlockDown (wdw : INTEGER);
  VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    IF ed^.block 
    THEN
      EditFuncs.TransformBlock (ed, EditFuncs.AllLower, FALSE);
    END
  END;
END BlockDown;
 
PROCEDURE BlockCapitals (wdw : INTEGER);
  VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    IF ed^.block 
    THEN
      EditFuncs.TransformBlock (ed, EditFuncs.Capitalise, FALSE);
    END
  END;
END BlockCapitals;
 
PROCEDURE BlockSwap (wdw : INTEGER);
  VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    IF ed^.block 
    THEN
      EditFuncs.TransformBlock (ed, EditFuncs.SwapUpperLower, FALSE);
    END
  END;
END BlockSwap;
 
PROCEDURE BlockRot18 (wdw : INTEGER);
 VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN     
    IF ed^.block
    THEN
      EditFuncs.TransformBlock (ed, EditFuncs.Rot18, FALSE); 
    END   
  END; 
END BlockRot18;

PROCEDURE BlockRot (wdw : INTEGER);
 VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN     
    IF ed^.block
    THEN
      EditFuncs.rotateFaktor := 13; 
      EditFuncs.TransformBlock (ed, EditFuncs.RotXX, FALSE); 
    END   
  END; 
END BlockRot;

PROCEDURE BlockDecode (wdw : INTEGER);
 VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN     
    IF ed^.block
    THEN
      UUDecode.BeginDecode();
      EditFuncs.TransformBlock (ed, EditFuncs.XXDecode, FALSE); 
      UUDecode.EndDecode();
    END   
  END; 
END BlockDecode;

PROCEDURE BlockMirror (wdw : INTEGER);
 VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN     
    IF ed^.block
    THEN
      EditFuncs.TransformBlock (ed, EditFuncs.Mirror, FALSE); 
    END   
  END; 
END BlockMirror;

PROCEDURE BlockProtect (wdw : INTEGER);
 VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN     
    IF ed^.block
    THEN
      EditFuncs.TransformBlock (ed, EditFuncs.Protect, TRUE); 
    END   
  END; 
END BlockProtect;

PROCEDURE UndoPossible (wdw : INTEGER) : BOOLEAN;
  VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    RETURN EditTools.PossibleUndo (ed);
  END;
  RETURN FALSE;
END UndoPossible;
 
PROCEDURE GetTextLineLength (wdw : INTEGER; line: LONGINT; VAR len: INTEGER): BOOLEAN;
(* Liefert die Lnge der Zeile line im zum wdw gehrenden Editor zurck.
 * FALSE: Fenster ist kein Editor oder Zeile nicht vorhanden
 *)
  VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    RETURN EditBase.GetLineLength (ed, line, len);
  END;
  RETURN FALSE;
END GetTextLineLength;

PROCEDURE GetTextLine (wdw: INTEGER; line : LONGINT; VAR str : ARRAY OF CHAR; VAR len : INTEGER): BOOLEAN;
(* Liefert die Zeile line im zum wdw gehrenden Editor zurck.
 * FALSE: Fenster ist kein Editor oder Zeile nicht vorhanden
 *)
  VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    RETURN EditBase.GetLine (ed, line, str, len);
  END;
  RETURN FALSE;
END GetTextLine;

PROCEDURE GetEditBuffer (wdw: INTEGER; VAR adr : ADDRESS; VAR len : INTEGER): BOOLEAN;
(* Liefert die Adresse des ersten Buffers im zum wdw gehrenden Editor zurck.
 * In len steht der benutzte Speicherplatz.
 * FALSE: Fenster ist kein Editor 
 *)
  VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    adr := ed^.firstBuff^.buffer;
    len := ed^.firstBuff^.usedMem;
    RETURN TRUE;
  END;
  RETURN FALSE;
END GetEditBuffer;

PROCEDURE ToEnd(wdw : INTEGER);
(* Setzt den Cursor an das Ende eines Textes 
 *)
  VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    EditFuncs.Home (ed, TRUE);
  END;
END ToEnd;

PROCEDURE GetWildChars (VAR one, all: CHAR);
(* Holt die Wildcardzeichen 
 *)
BEGIN
  one := EditTypes.wildOneChar;
  all := EditTypes.wildAllChar;
END GetWildChars;

PROCEDURE SetWildChars (one, all: CHAR);
(* Setzt die Wildcardzeichen 
 *)
BEGIN
  EditTypes.wildOneChar := one;
  EditTypes.wildAllChar := all;
END SetWildChars;

PROCEDURE CheckWildAssign (VAR search, repl: ARRAY OF CHAR): BOOLEAN;
(* Prft die Konsistenz von Wildcards und ihren Gegenstcken im Such-
 * und Ersetzstring
 *)
BEGIN
  RETURN EditUtil.CheckWildAssign (search, repl);
END CheckWildAssign;

PROCEDURE MarkMultiple (wdw: INTEGER);
  VAR ed : EDITPTR;
BEGIN
  ed := EditFuncs.FindEditor (wdw);
  IF ed # NIL
  THEN
    EditUtil.MarkMultiple (ed);
  END;
END MarkMultiple;

BEGIN
  nums := numSet{};
  lastOpWasCtrlY := FALSE;
  (*$? NOT CAT:
  Strings.Assign (ShellMsg.ShellPath,PathEnv.HomePath, v.bool);
  *)
  Printer.ErrorProc := PrinterErrorProc;
  (*
  debugMode := FALSE;
  TOSDebug.Active := debugMode;
  TOSDebug.Continuous := ~debugMode;
  *)
END CatEdit.
