DEFINITION MODULE CatFiles;

FROM SYSTEM IMPORT ADDRESS;

TYPE SeekMode = (start, relative, end);
     openMode = (readFile, writeFile, readWrite);

CONST (* Zustzliche Fehler, die beim GEMDOS nicht direkt angegeben werden *)
      notAllWritten = -1004;
      notAllRead    = -1005;
      crcError      = -1006;
      NoError     = 0;

VAR FileError : INTEGER;

PROCEDURE GetErrorMsg (nr: INTEGER; VAR str: ARRAY OF CHAR);

PROCEDURE ErrorAlert(nr : INTEGER);

PROCEDURE OpenFile(REF path, name : ARRAY OF CHAR; mode : openMode):INTEGER;

PROCEDURE CreateFile(REF path, name : ARRAY OF CHAR):INTEGER;

PROCEDURE WriteFile(c : CHAR; handle : INTEGER);

PROCEDURE WriteMuch(howMuch : LONGCARD; handle : INTEGER; where : ADDRESS);

PROCEDURE ReadFile(VAR c : CHAR; handle : INTEGER);

PROCEDURE ReadMuch(howMuch : LONGCARD; handle : INTEGER; where : ADDRESS);

PROCEDURE FilePos(handle : INTEGER):LONGCARD;

PROCEDURE Seek(pos : LONGINT; handle : INTEGER; what : SeekMode);

PROCEDURE CloseFile(handle : INTEGER);

PROCEDURE SetPath(REF path : ARRAY OF CHAR):BOOLEAN;

PROCEDURE GetPath(VAR path : ARRAY OF CHAR);

PROCEDURE ClearPath(REF path, mask, lock : ARRAY OF CHAR);

PROCEDURE DeleteFile(REF path, name : ARRAY OF CHAR):BOOLEAN;

PROCEDURE RenameFile(REF path, name, path2, name2 : ARRAY OF CHAR):BOOLEAN;

PROCEDURE FileSizeAndDate (REF fname : ARRAY OF CHAR; VAR exists: BOOLEAN;
                           VAR date, time: CARDINAL) : LONGCARD;

PROCEDURE FileSize (REF fname : ARRAY OF CHAR; VAR exists: BOOLEAN) : LONGCARD;

PROCEDURE Exists (REF fname: ARRAY OF CHAR): BOOLEAN;

END CatFiles.
