DEFINITION MODULE CatOpts;

FROM SYSTEM IMPORT ADDRESS;

(* Die maximale Anzahl an Farben, die es gibt. Wird in CAT.M 
 * in InitRsc gesetzt.
 *)
VAR maxColors:  CARDINAL;

PROCEDURE InitDial (tree: ADDRESS) : BOOLEAN;
(* Initialisiert einen Dialog: NewDial und DialCenter
 *)

PROCEDURE GetItem(dial : ADDRESS; item : INTEGER):BOOLEAN;
(* Fragt ab, ob ein Button selektiert ist
 *)

PROCEDURE SetItem(dial : ADDRESS; item : INTEGER; b : BOOLEAN);
(* Setzt einen Button auf Selected oder nicht, je nach Wert von b
 *)

PROCEDURE DoSearch();
(* Der Suchdialog fr die Textsuche 
 *)

PROCEDURE DoSearchAgain (kstate: BITSET);
(* Es wird nochmal gesucht 
 *)

PROCEDURE DoReplace (win: INTEGER);
(* Suchen und Ersetzen
 *)


PROCEDURE DoTausch();
(* Die Tauschkonfiguration 
 *)

PROCEDURE CheckInfoline(REF infoline : ARRAY OF CHAR):BOOLEAN; (* Testet UserBLK.infoline *)
(* Prft, ob eine Infozeile korrekt ist 
 *)

PROCEDURE DoOption();
(* Der Allgemeine Konfigurationsdialog 
 *)

PROCEDURE DoAbruf();
(* Infile einstellen 
 *)

PROCEDURE DoInfos();
(* Infofiles konfigurieren 
 *)

PROCEDURE doPrinter();
(* Druckereinstellungen konfigurieren
 *)

PROCEDURE buildVarName (REF name: ARRAY OF CHAR; number: INTEGER; VAR newName: ARRAY OF CHAR);
(* Baut einen Variablennamen zusammen *)

PROCEDURE doList ();
(* Konfiguriert die Stichwortliste
 *)

PROCEDURE doEditor (wdw : INTEGER);
(* Konfiguriert den aktuellen Editor 
 *)

PROCEDURE doColor(wdw : INTEGER);
(* Setzt die Farben fr das aktuelle Fenster
 *)

PROCEDURE doConfig();
(* Der Konfigurationsdialog fr CAT.INF 
 *)

PROCEDURE doFormat ();
(* Die Formate-Dialogbox
 *)

END CatOpts.
