IMPLEMENTATION MODULE CatOpts2;

(*==============================================================*
 * Modul:               CAT Optionenmodul, zweiter Teil         *
 * Autor:               Dirk Steins                             *
 * erstellt am:         18.7.1995                               *
 * letzte nderung am:  18.7.1995                               *
 * Version:             0.1                                     *
 * Interne Version:     V#0001                                  *
 *==============================================================*

 *----------------------------------------------------------------------------
 * Datum    Vers. Autor  nderung (Arbeitsbericht)
 *----------------------------------------------------------------------------
 * 10.12.93 0.1   DS     Erste Implementation erstellt
 *                       einige Optionsdialoge aus CATOPTS.M hierhin verschoben
 *----------------------------------------------------------------------------
 *)

FROM SYSTEM IMPORT ADDRESS, ADR, TSIZE;

(* MM2-Module *)
IMPORT Block;
IMPORT Strings;
IMPORT StrConv;
FROM Storage    IMPORT ALLOCATE, DEALLOCATE;

(* Magic-Module *)
IMPORT MagicStrings, MagicAES;
IMPORT mtUtils, mtDials, mtAlerts, mtDir, mtPopups, mtAppl,
       mtTextfiles;

IMPORT WinDials;

(* CAT-Module *)
IMPORT CatFiles;
IMPORT CatTypes;
IMPORT CatGlobal;
IMPORT WdwManager;
IMPORT ConvertDate;
IMPORT dataSys;
IMPORT MausTauschrsc;
IMPORT MTE;
IMPORT CatEdit;
IMPORT grin;
IMPORT CatHelp;
IMPORT VDIUtil;
IMPORT ConfVars;
IMPORT Varnames;
IMPORT MTPaths;
IMPORT IoFilter;
IMPORT ShellCall;
IMPORT ListHelp;

FROM Void   IMPORT v;

(* Konstantendefinitionen *)
CONST   CR      = 15C;
        LF      = 12C;

(* Typdefinitionen *)

TYPE Trick =  POINTER TO RECORD
                CASE : BOOLEAN OF
                  TRUE:  wert: INTEGER;|
                  FALSE: hi: CHAR;
                         lo: CHAR;|
                END;
              END;


PROCEDURE buildVarName (REF name: ARRAY OF CHAR; number: INTEGER; VAR newName: ARRAY OF CHAR);
BEGIN
  MagicStrings.Assign (name, newName);
  MagicStrings.Append (StrConv.IntToStr (number, 0), newName);
END buildVarName;



TYPE floskelArray =  ARRAY [1..20] OF ARRAY[0..511] OF CHAR;

     floskelInfo = RECORD
                     txtArray : POINTER TO floskelArray;
                     oldEntry : INTEGER;
                     oldControl: BOOLEAN;
                     theWdw   : INTEGER;
                   END;
    floskelPtr = POINTER TO floskelInfo;
    
  PROCEDURE SetEntry (tree: ADDRESS; floskel : floskelPtr;
                      idx : INTEGER; isControl : BOOLEAN);
    VAR i       : INTEGER;
        str     : ARRAY  [0..1023] OF CHAR;
        strIdx    : INTEGER;
  BEGIN
    strIdx := idx - MausTauschrsc.fl_f1 + 1;
    IF isControl THEN INC (strIdx, 10) END;
    (* Suchen nach einzelnen LFs und ersetzen davon *)
    Strings.Assign (floskel^.txtArray^[strIdx], str, v.bool);
    i := 0;
    WHILE i >= 0 DO
      i := Strings.Pos (LF, str, i);
      IF i >= 0
      THEN
        Strings.Delete (str, i, 1, v.bool);
      END;
    END;
    CatGlobal.SetStrings (tree, MausTauschrsc.flline1, MausTauschrsc.flline6, str);
  END SetEntry;
  
  PROCEDURE GetEntry (tree: ADDRESS; floskel : floskelPtr;
                      idx : INTEGER; isControl : BOOLEAN);
    VAR i       : INTEGER;
        str     : ARRAY  [0..1023] OF CHAR;
        strIdx  : INTEGER;
  BEGIN 
    strIdx := idx - MausTauschrsc.fl_f1 + 1;
    IF isControl THEN INC (strIdx, 10) END;
    CatGlobal.GetStrings (tree, MausTauschrsc.flline1, MausTauschrsc.flline6, floskel^.txtArray^[strIdx]);
    i := 0; 
    (* Suchen nach einzelnen CRs und diese ersetzen durch Cr/LF *)
    Strings.Assign (floskel^.txtArray^[strIdx], str, v.bool);
    WHILE i >= 0 DO
      i := Strings.Pos (CR, str, i);
      IF i >= 0
      THEN
        IF str[i+1] # LF
        THEN
          Strings.Insert (LF, i+1, str, v.bool);
        END;
        INC (i);
      END;
    END;
    (* Suchen nach einzelnen LFs und ersetzen davon *)
    i := 0;
    WHILE i >= 0 DO
      i := Strings.Pos (LF, str, i);
      IF i >= 0
      THEN
        IF (i=0) OR ((i > 0) & (str[i-1] # CR))
        THEN
          Strings.Insert (CR, i, str, v.bool);
        END;
        INC (i);
      END;
    END;
    (* Jetzt nur noch in Textarray sichern *)
    Strings.Assign (str, floskel^.txtArray^[strIdx], v.bool);
  END GetEntry;

PROCEDURE floskelButton (tree: ADDRESS; private: ADDRESS; button: INTEGER;
                         mx, my : INTEGER; kstate: BITSET; clicks: INTEGER): BOOLEAN;
  VAR   floskel : floskelPtr;
        but     : INTEGER;
        isControl: BOOLEAN;
        strPtr  : CatTypes.Str1023Ptr;
        strLen  : LONGCARD;
BEGIN
  floskel := private;
  but := INTEGER(BITSET(button) - {15});
  CASE but OF
    MausTauschrsc.fl_f1..MausTauschrsc.fl_f10 :
      GetEntry (tree, floskel, floskel^.oldEntry, floskel^.oldControl);
      isControl := mtUtils.InState (tree, MausTauschrsc.fl_contrl, MagicAES.SELECTED);
      SetEntry (tree, floskel, but, isControl);
      floskel^.oldControl := isControl;
      floskel^.oldEntry   := but; 
      WinDials.WinDialDraw (tree, MausTauschrsc.flbox, 2, v.r, FALSE);
      |
    MausTauschrsc.fl_shift,
    MausTauschrsc.fl_contrl: 
      GetEntry (tree, floskel, floskel^.oldEntry, floskel^.oldControl);
      isControl := mtUtils.InState (tree, MausTauschrsc.fl_contrl, MagicAES.SELECTED);
      SetEntry (tree, floskel, floskel^.oldEntry, isControl);
      floskel^.oldControl := isControl;
      WinDials.WinDialDraw (tree , MausTauschrsc.flbox, 2, v.r, FALSE);
      |
    MausTauschrsc.flblock:
      IF CatEdit.GetBlock (floskel^.theWdw, FALSE, TRUE, strPtr, strLen)
      THEN
        IF strLen > 512 THEN strPtr^[511] := 0C END;
        CatGlobal.SetStrings (tree, MausTauschrsc.flline1, MausTauschrsc.flline6, strPtr^);
        GetEntry (tree, floskel, floskel^.oldEntry, floskel^.oldControl);
        SetEntry (tree, floskel, floskel^.oldEntry, floskel^.oldControl);
        WinDials.WinDialDraw (tree , MausTauschrsc.flbox, 2, v.r, FALSE);
        DEALLOCATE (strPtr, 0);
        mtUtils.ExclState (tree, but, MagicAES.SELECTED);
        WinDials.WinDialDraw (tree, but, 0, v.r, FALSE);
      END;
      |
    MausTauschrsc.flok,
    MausTauschrsc.flcancel:
      mtUtils.ExclState (tree, but, MagicAES.SELECTED);
      GetEntry (tree, floskel, floskel^.oldEntry, floskel^.oldControl);
      RETURN TRUE; |
  ELSE
  END;
  RETURN FALSE;
END floskelButton;

PROCEDURE floskelGetSetValues (tree: ADDRESS; private: ADDRESS; 
                               set: BOOLEAN; exit: INTEGER);
  VAR   floskel : floskelPtr;
        i       : INTEGER;
        found   : BOOLEAN;
        isControl: BOOLEAN;
        str     : ARRAY [0..511] OF CHAR;
        varName : CatTypes.String127;
        but     : INTEGER;
BEGIN
  floskel := private;
  but := INTEGER(BITSET(exit) - {15});
  IF set
  THEN
    FOR i := 1 TO 10 DO 
      buildVarName (cShiftFkey, i, varName);
      ConfVars.GetConfDefStr (varName, floskel^.txtArray^[i], '');
    END;
    mtUtils.SetState (tree, MausTauschrsc.flblock, MagicAES.DISABLED, 
                      ~(CatEdit.IsEditTop (floskel^.theWdw) & 
                        CatEdit.BlockIsMarked (floskel^.theWdw)));
    FOR i := 1 TO 10 DO 
      buildVarName (cCtrlFkey, i, varName);
      ConfVars.GetConfDefStr (varName, floskel^.txtArray^[10+i], '');
    END;
    (* Selektierten Eintrag feststellen *)
    i := MausTauschrsc.fl_f1;
    found := FALSE;
    WHILE ~found & (i <= MausTauschrsc.fl_f10) DO
      found := mtUtils.InState (tree, i, MagicAES.SELECTED);
      IF ~found THEN INC (i); END;
    END;
    isControl := mtUtils.InState (tree, MausTauschrsc.fl_contrl, MagicAES.SELECTED);
    SetEntry (tree, floskel, i, isControl);
    floskel^.oldEntry := i; 
    floskel^.oldControl := isControl;
  ELSE
    IF but = MausTauschrsc.flok
    THEN
      (* Strings abspeichern *)
      FOR i := 1 TO 10 DO 
        buildVarName (cShiftFkey, i, varName);
        IF ConfVars.GetConfigString (varName, str) OR (LENGTH (floskel^.txtArray^[i]) > 0) THEN
          v.bool := ConfVars.SetConfigString (varName, floskel^.txtArray^[i]);
        END;
      END;
      FOR i := 1 TO 10 DO 
        buildVarName (cCtrlFkey, i, varName);
        IF ConfVars.GetConfigString (varName, str) OR (LENGTH (floskel^.txtArray^[10+i]) > 0) THEN
          v.bool := ConfVars.SetConfigString (varName, floskel^.txtArray^[10+i]);
        END;
      END;
    END;
    DEALLOCATE (floskel^.txtArray, 0);
    DISPOSE (floskel);
  END;
END floskelGetSetValues;

PROCEDURE doFloskel();
  VAR floskelBox: mtUtils.tObjcTree;
      floskel   : floskelPtr;
BEGIN
  (* vorbereiten *)
  floskelBox := MausTauschrsc.TreeAddr^[MausTauschrsc.floskeln];
  NEW (floskel);
  IF floskel = NIL
  THEN
    MTE.noMemAlert();
    RETURN
  END;
  ALLOCATE (floskel^.txtArray, TSIZE (floskelArray));
  IF floskel^.txtArray = NIL
  THEN
    MTE.noMemAlert();
    DISPOSE (floskel);
    RETURN
  END; 
  floskel^.theWdw := WdwManager.ownTopWindow;
  IF ~WinDials.OpenWinDial (floskelBox, FALSE, 
                            floskelGetSetValues,
                            floskelGetSetValues,
                            floskelButton,
                            WinDials.defDraw,
                            "",
                            floskel)
  THEN
    MTE.noWinDialAlert();
    DEALLOCATE (floskel^.txtArray, 0);
    DISPOSE (floskel);
  END;
END doFloskel;

CONST cNotInst    = " Nicht installiert";

TYPE ioFiltArray = ARRAY [0..9] OF IoFilter.ioFilterStruct;
    
     ioInfStruct = RECORD
                     filter: POINTER TO ioFiltArray;
                     select   : INTEGER;
                     oldSelect: INTEGER;
                   END;
     ioInfPtr    = POINTER TO ioInfStruct;

(* Nicht lokal wegen evtl. C-Portierung *)
PROCEDURE setItems (tree: ADDRESS; pop: ADDRESS; REF filter: IoFilter.ioFilterStruct);
 VAR  str1, str2: CatTypes.String255;
      scrap     : ARRAY [0..10] OF CHAR;
      intVal    : INTEGER;
BEGIN
  WITH filter DO
    intVal := 0;
    IF forMsg THEN
      intVal := 1;
    ELSIF pastOutfile
    THEN
      intVal := 2;
    END;
    VDIUtil.SetXState (tree, MausTauschrsc.iofilttype1, ORD(intVal));
    VDIUtil.SetXString (tree, MausTauschrsc.iofilttype1, pop, ORD(intVal));
    mtUtils.SetFlag  (tree, MausTauschrsc.ioinfile, MagicAES.HIDETREE, forMsg OR pastOutfile);
    mtUtils.SetFlag  (tree, MausTauschrsc.iooutfile, MagicAES.HIDETREE, forMsg OR pastOutfile);
    mtUtils.SetState (tree, MausTauschrsc.ioinfile, MagicAES.SELECTED, forInfile);
    mtUtils.SetState (tree, MausTauschrsc.iooutfile, MagicAES.SELECTED, forOutfile);
    mtUtils.SetFlag (tree, MausTauschrsc.filtcmd2, MagicAES.HIDETREE, forMsg OR pastOutfile);
    mtUtils.SetFlag (tree, MausTauschrsc.filtcmd2, MagicAES.EDITABLE, ~forMsg & ~pastOutfile);
    mtUtils.SetFlag (tree, MausTauschrsc.iofiltcmd2, MagicAES.HIDETREE, forMsg OR pastOutfile);
    mtUtils.SetState (tree, MausTauschrsc.ioactive, MagicAES.SELECTED, activ);
    mtUtils.SetState (tree, MausTauschrsc.iobreak, MagicAES.SELECTED, stopAtErr);
    IF forMsg
    THEN
      mtUtils.SetObjcString (tree, MausTauschrsc.iofiltcmd, 'Kommandozeile fr Messages:');
    ELSIF pastOutfile
    THEN
      mtUtils.SetObjcString (tree, MausTauschrsc.iofiltcmd, 'Kommandozeile nach Einsortieren:');
    ELSE
      mtUtils.SetObjcString (tree, MausTauschrsc.iofiltcmd, 'Kommandozeile fr Infile:');
    END;
    mtUtils.SetObjcString (tree, MausTauschrsc.iofiltname, filtName);
    mtUtils.SetObjcString (tree, MausTauschrsc.filtcmd1, inCmd);
    mtUtils.SetObjcString (tree, MausTauschrsc.filtcmd2, outCmd);
    IF progName[0] # ''
    THEN
      mtDir.SplitPath (progName, str1, str2, scrap);
    ELSE
      MagicStrings.Assign ('leer', str2);
    END;
    mtUtils.SetObjcString (tree, MausTauschrsc.iofiltsel, str2);
  END;
END setItems;

PROCEDURE getItems (tree: ADDRESS; VAR filter: IoFilter.ioFilterStruct);
  VAR intVal : INTEGER;
BEGIN
  WITH filter DO
    intVal := VDIUtil.GetXState (tree, MausTauschrsc.iofilttype1);
    forMsg := intVal = 1;
    pastOutfile := intVal = 2;
    forInfile  := mtUtils.InState (tree, MausTauschrsc.ioinfile, MagicAES.SELECTED);
    forOutfile := mtUtils.InState (tree, MausTauschrsc.iooutfile, MagicAES.SELECTED);
    activ := mtUtils.InState (tree, MausTauschrsc.ioactive, MagicAES.SELECTED);
    stopAtErr := mtUtils.InState (tree, MausTauschrsc.iobreak, MagicAES.SELECTED);
    mtUtils.ObjcString (tree, MausTauschrsc.filtcmd1, inCmd);
    mtUtils.ObjcString (tree, MausTauschrsc.filtcmd2, outCmd);
    mtUtils.ObjcString (tree, MausTauschrsc.iofiltname, filtName);
  END;
END getItems;

PROCEDURE filterButton (obTree: ADDRESS; private: ADDRESS; button: INTEGER;
                        mx, my : INTEGER; kstate: BITSET; clicks: INTEGER): BOOLEAN;
  VAR ioInfo    : ioInfPtr;
      typeSel,
      x, y,
      but       : INTEGER;
      path,
      name      : CatTypes.String255;
      ext       : ARRAY [0..10] OF CHAR;
      tree      : mtUtils.tObjcTree;
      t         : Trick;
      filtSel   : mtUtils.tObjcTree;
      filtType  : mtUtils.tObjcTree;
      res       : BOOLEAN;
BEGIN
  ioInfo := private;
  tree := obTree;
  filtType  := MausTauschrsc.TreeAddr^[MausTauschrsc.iotype];
  filtSel := MausTauschrsc.TreeAddr^[MausTauschrsc.iofilter];
  (* Button auswerten *)
  but := INTEGER(BITSET(button) - {15});
  CASE but OF
    MausTauschrsc.iofiltok, 
    MausTauschrsc.iofiltquit : 
      IF but = MausTauschrsc.iofiltok
      THEN
        getItems (tree, ioInfo^.filter^[ioInfo^.select]);
      END;
      mtUtils.ExclState (tree, but, MagicAES.SELECTED);
      RETURN TRUE; |
    MausTauschrsc.iofilthelp : 
      CatHelp.DoHelp (CatHelp.iofilter);
      mtUtils.ExclState (tree, but, MagicAES.SELECTED);
      WinDials.WinDialDraw (tree, but, 1, v.r, FALSE); |
    MausTauschrsc.iofiltpop0, 
    MausTauschrsc.iofiltpop1 : 
      but := MausTauschrsc.iofiltpop1;
      getItems (tree, ioInfo^.filter^[ioInfo^.oldSelect]);
      MagicAES.ObjcOffset (tree, but, x, y);
      t := ADR (tree^[but].obState);
      ioInfo^.select := mtPopups.TreePopup (filtSel, x, y, ORD(t^.hi))-1;
      IF ioInfo^.select >= 0 THEN
        t^.hi := CHR(ioInfo^.select);
        VDIUtil.SetXString (tree, but, filtSel, ioInfo^.select);
        setItems (tree, filtType, ioInfo^.filter^[ioInfo^.select]);
        WinDials.WinDialDraw (tree, 0, 8, v.r, FALSE);
        ioInfo^.oldSelect := ioInfo^.select;
      ELSE
        ioInfo^.select := ioInfo^.oldSelect;
      END; |
    MausTauschrsc.iofiltpop2:
      getItems (tree, ioInfo^.filter^[ioInfo^.oldSelect]);
      t := ADR (tree^[but-1].obState);
      t^.hi := CHR((ORD(t^.hi)+1) MOD 10);
      ioInfo^.select := ORD (t^.hi);
      VDIUtil.SetXString (tree, but-1, filtSel, ioInfo^.select);
      setItems (tree, filtType, ioInfo^.filter^[ioInfo^.select]);
      ioInfo^.oldSelect := ioInfo^.select;
      WinDials.WinDialDraw (tree, 0, 8, v.r, FALSE); |
    MausTauschrsc.iofiltsel0, 
    MausTauschrsc.iofiltsel: 
      (* Neues Programm auswhlen *)
      IF ioInfo^.filter^[ioInfo^.oldSelect].progName[0] # ''
      THEN
        mtDir.SplitPath (ioInfo^.filter^[ioInfo^.oldSelect].progName, path, name, ext);
      ELSE
        CatGlobal.ApplPath (path);
        name := "";
      END;
      res := CatGlobal.FselGet (path, name, '*.*', 'I/O-Filter auswhlen', TRUE);
      (* mtDials.DialForm (tree, mtDials.DENABLE, v.r, v.r);  *)
      IF res
      THEN
        IF name[0] # ''
        THEN
          MagicStrings.Assign (path, ioInfo^.filter^[ioInfo^.oldSelect].progName);
          MagicStrings.Append (name, ioInfo^.filter^[ioInfo^.oldSelect].progName);
          mtUtils.SetObjcString (tree, MausTauschrsc.iofiltsel, name);
          MagicStrings.Insert (' ', name, 0);
          mtUtils.SetObjcString (filtSel, ioInfo^.oldSelect+1, name);
          ioInfo^.filter^[ioInfo^.oldSelect].activ := TRUE;
        ELSE
          MagicStrings.Assign (name, ioInfo^.filter^[ioInfo^.oldSelect].progName);
          mtUtils.SetObjcString (filtSel, ioInfo^.oldSelect+1, cNotInst);
          ioInfo^.filter^[ioInfo^.oldSelect].activ := FALSE;
          setItems (tree, filtType, ioInfo^.filter^[ioInfo^.oldSelect]);
        END;
        VDIUtil.SetXString (tree, MausTauschrsc.iofiltpop1, filtSel, ioInfo^.select);
        WinDials.WinDialDraw (tree, MausTauschrsc.iofiltpop1, 1, v.r, FALSE);
        WinDials.WinDialDraw (tree, MausTauschrsc.iofiltsel, 1, v.r, FALSE);
      END;
      mtUtils.ExclState (tree, but, MagicAES.SELECTED);
      WinDials.WinDialDraw (tree, but, 1, v.r, FALSE); |
    MausTauschrsc.iofilttype0,
    MausTauschrsc.iofilttype1: 
      but := MausTauschrsc.iofilttype1;
      MagicAES.ObjcOffset (tree, but, x, y);
      t := ADR (tree^[but].obState);
      typeSel := mtPopups.TreePopup (filtType, x, y, ORD(t^.hi))-1;
      IF typeSel >= 0 THEN
        t^.hi := CHR(typeSel);
        ioInfo^.filter^[ioInfo^.oldSelect].forMsg := typeSel = 1;
        ioInfo^.filter^[ioInfo^.oldSelect].pastOutfile := typeSel = 2;
        setItems (tree, filtType, ioInfo^.filter^[ioInfo^.oldSelect]);
        WinDials.WinDialDraw (tree, MausTauschrsc.iofiltpop1, 1, v.r, FALSE);
        mtUtils.CalcArea (tree, MausTauschrsc.iofiltback, v.r);
        WinDials.WinDialDraw (tree, 0, 8, v.r, TRUE);
      END; |
    MausTauschrsc.iofilttype2:
      t := ADR (tree^[but-1].obState);
      t^.hi := CHR((ORD(t^.hi)+1) MOD 3);
      typeSel := ORD (t^.hi);
      ioInfo^.filter^[ioInfo^.oldSelect].forMsg := typeSel = 1;
      ioInfo^.filter^[ioInfo^.oldSelect].pastOutfile := typeSel = 2;
      setItems (tree, filtType, ioInfo^.filter^[ioInfo^.oldSelect]);
      (*
      VDIUtil.SetXString (tree, but-1, filtType, typeSel);
      *)
      WinDials.WinDialDraw (tree, MausTauschrsc.iofiltpop1, 1, v.r, FALSE);
      mtUtils.CalcArea (tree, MausTauschrsc.iofiltback, v.r);
      WinDials.WinDialDraw (tree, 0, 8, v.r, TRUE); |
  ELSE
  END;
  RETURN FALSE;
END filterButton;

PROCEDURE filterGetSetValues (tree: ADDRESS; private: ADDRESS; 
                              set: BOOLEAN; exit: INTEGER);

  VAR ioInfo    : ioInfPtr;
      i         : INTEGER;
      filtSel   : mtUtils.tObjcTree;
      filtType  : mtUtils.tObjcTree;
      path,
      name      : CatTypes.String255;
      ext       : ARRAY [0..10] OF CHAR;
      varname   : CatTypes.String127;
      but       : INTEGER;
BEGIN
  ioInfo := private;
  filtType  := MausTauschrsc.TreeAddr^[MausTauschrsc.iotype];
  filtSel := MausTauschrsc.TreeAddr^[MausTauschrsc.iofilter];
  but := INTEGER(BITSET(exit) - {15});
  IF set
  THEN
    (* Strings einsetzen *)
    FOR i := 1 TO 10 DO
      (* Array fllen 
       *)
      WITH ioInfo^.filter^[i-1] DO
        buildVarName (cIoFilterProg, i, varname);
        IF ConfVars.GetConfigString (varname, progName)
        THEN
          IoFilter.ReadFilter (ioInfo^.filter^[i-1], i);
          (*
          buildVarName (cIoFilterInCmd, i, varname);
          ConfVars.GetConfDefStr (varname, inCmd, "");
          buildVarName (cIoFilterOutCmd, i, varname);
          ConfVars.GetConfDefStr (varname, outCmd, "");
          buildVarName (cIoFilterMsg, i, varname);
          ConfVars.GetConfDefBool (varname, forMsg, FALSE);
          buildVarName (cIoFilterPast, i, varname);
          ConfVars.GetConfDefBool (varname, pastOutfile, FALSE);
          buildVarName (cIoFilterInfile, i, varname);
          ConfVars.GetConfDefBool (varname, forInfile, FALSE);
          buildVarName (cIoFilterOutfile, i, varname);
          ConfVars.GetConfDefBool (varname, forOutfile, FALSE);
          buildVarName (cIoFilterActiv, i, varname);
          ConfVars.GetConfDefBool (varname, activ, TRUE);
          buildVarName (cIoFilterStopAtErr, i, varname);
          ConfVars.GetConfDefBool (varname, stopAtErr, FALSE);
          (* Jetzt Programmnamen extrahieren *)
          buildVarName (cIoFilterName, i, varname);
          ConfVars.GetConfDefStr (varname, filtName, "");
          *)
          IF filtName[0] = ""
          THEN
            mtDir.SplitPath (progName, path, name, ext);
          ELSE
            MagicStrings.Assign (filtName, name);
          END;
          MagicStrings.Insert (' ', name, 0);
          mtUtils.SetObjcString (filtSel, i, name);
        ELSE
          forMsg := FALSE;
          activ  := FALSE;
          stopAtErr := FALSE;
          mtUtils.SetObjcString (filtSel, i, cNotInst);
        END;
      END;
    END;
    ioInfo^.select := 0;
    ioInfo^.oldSelect := ioInfo^.select;
    setItems (tree, filtType, ioInfo^.filter^[ioInfo^.select]);
    (* vorbereiten *)
    VDIUtil.SetXState (tree, MausTauschrsc.iofiltpop1, ioInfo^.select);
    VDIUtil.SetXString (tree, MausTauschrsc.iofiltpop1, filtSel, ioInfo^.select);
  ELSE
    IF but = MausTauschrsc.iofiltok
    THEN
      FOR i := 1 TO 10 DO
        WITH ioInfo^.filter^[i-1] DO
          IF progName[0] # ''
          THEN
            buildVarName (cIoFilterProg, i, varname);
            v.bool := ConfVars.SetConfigString (varname, progName);
            buildVarName (cIoFilterInCmd, i, varname);
            v.bool := ConfVars.SetConfigString (varname, inCmd);
            buildVarName (cIoFilterOutCmd, i, varname);
            v.bool := ConfVars.SetConfigString (varname, outCmd);
            buildVarName (cIoFilterMsg, i, varname);
            v.bool := ConfVars.SetConfigBool (varname, forMsg);
            buildVarName (cIoFilterPast, i, varname);
            v.bool := ConfVars.SetConfigBool (varname, pastOutfile);
            buildVarName (cIoFilterInfile, i, varname);
            v.bool := ConfVars.SetConfigBool (varname, forInfile);
            buildVarName (cIoFilterOutfile, i, varname);
            v.bool := ConfVars.SetConfigBool (varname, forOutfile);
            buildVarName (cIoFilterActiv, i, varname);
            v.bool := ConfVars.SetConfigBool (varname, activ);
            buildVarName (cIoFilterStopAtErr, i, varname);
            v.bool := ConfVars.SetConfigBool (varname, stopAtErr);
            buildVarName (cIoFilterName, i, varname);
            v.bool := ConfVars.SetConfigString (varname, filtName);
          ELSE
            (* Configvariablen lschen! *)
            buildVarName (cIoFilterProg, i, varname);
            ConfVars.DeleteConfigVar (varname);
            buildVarName (cIoFilterInCmd, i, varname);
            ConfVars.DeleteConfigVar (varname);
            buildVarName (cIoFilterOutCmd, i, varname);
            ConfVars.DeleteConfigVar (varname);
            buildVarName (cIoFilterMsg, i, varname);
            ConfVars.DeleteConfigVar (varname);
            buildVarName (cIoFilterInfile, i, varname);
            ConfVars.DeleteConfigVar (varname);
            buildVarName (cIoFilterOutfile, i, varname);
            ConfVars.DeleteConfigVar (varname);
            buildVarName (cIoFilterPast, i, varname);
            ConfVars.DeleteConfigVar (varname);
            buildVarName (cIoFilterActiv, i, varname);
            ConfVars.DeleteConfigVar (varname);
            buildVarName (cIoFilterStopAtErr, i, varname);
            ConfVars.DeleteConfigVar (varname);
            buildVarName (cIoFilterName, i, varname);
            ConfVars.DeleteConfigVar (varname);
          END;
        END;
      END;
    END;
    DEALLOCATE (ioInfo^.filter, 0);
    DISPOSE (ioInfo);
  END;
END filterGetSetValues;

PROCEDURE doIOFilter ();
  VAR filterBox : mtUtils.tObjcTree;
      ioInfo    : ioInfPtr;
BEGIN
  filterBox := MausTauschrsc.TreeAddr^[MausTauschrsc.filefilt];
  NEW (ioInfo);
  IF ioInfo = NIL
  THEN
    MTE.noMemAlert ();
    RETURN
  END;
  ALLOCATE (ioInfo^.filter, TSIZE (ioFiltArray)); 
  IF ioInfo^.filter = NIL 
  THEN 
    DISPOSE (ioInfo);
    MTE.noMemAlert (); 
    RETURN 
  END;
  (* Defaults setzen *)
  Block.Clear (ioInfo^.filter, TSIZE (ioFiltArray));
  IF ~WinDials.OpenWinDial (filterBox, FALSE, 
                            filterGetSetValues,
                            filterGetSetValues,
                            filterButton,
                            WinDials.defDraw,
                            "",
                            ioInfo)
  THEN
    DEALLOCATE (ioInfo^.filter, 0); 
    DISPOSE (ioInfo);
    MTE.noWinDialAlert();
  END;
END doIOFilter;

  CONST lowExtern = 9;
        highExtern = 16;
        filtMax    = 16;
        filtExt    = 8;

PROCEDURE BuildFilterPopup (VAR filterNumber: INTEGER; VAR filtSel : mtUtils.tObjcTree; 
                            forDial: BOOLEAN);
  VAR i         : INTEGER;
      varname   : CatTypes.String127;
      cmd       : CatTypes.String127;
      filterBox : mtUtils.tObjcTree;
      isDa      : BOOLEAN;
BEGIN
  filterBox := MausTauschrsc.TreeAddr^[MausTauschrsc.filtbox];
  mtUtils.SetObjcString (filterBox, MausTauschrsc.fbcomm, "");
  filtSel := MausTauschrsc.TreeAddr^[MausTauschrsc.filtsel];
  mtUtils.SetObjcString (filterBox, MausTauschrsc.fbcomm, "");
  FOR i := lowExtern TO highExtern DO
    buildVarName (cFilter, i-lowExtern+1, varname);
    isDa := ConfVars.GetConfigString (varname, cmd);
    IF isDa
    THEN
      IF i - 1 = filterNumber
      THEN
        (* String setzen *)
        mtUtils.SetObjcString (filterBox, MausTauschrsc.fbcomm, cmd);
      END;
      MagicStrings.Insert (' ', cmd, 0);
    ELSE
      (* Extern X anlegen *)
      MagicStrings.Assign (' Extern ', cmd);
      MagicStrings.Append (StrConv.IntToStr (i-lowExtern+1, 0), cmd);
    END;
    mtUtils.SetState (filtSel, i, MagicAES.DISABLED, ~isDa & ~forDial);
    mtUtils.SetFlag  (filtSel, i, MagicAES.SELECTABLE, isDa OR forDial);
    mtUtils.SetObjcString (filtSel, i, cmd);
  END;
  IF ShellCall.IsShell() = ShellCall.noShell
  THEN
    FOR i := lowExtern TO highExtern DO
      mtUtils.InclState (filtSel, i, MagicAES.DISABLED);
      mtUtils.ExclFlag (filtSel, i, MagicAES.SELECTABLE);
    END;
  END;
END BuildFilterPopup;

TYPE    blockInfo   = RECORD
                        filterNumber    : INTEGER;
                        cmd             : CatTypes.String255;
                        exitBut         : INTEGER;
                        filtSel : mtUtils.tObjcTree;
                      END;
        blockInfoPtr = POINTER TO blockInfo;
        
PROCEDURE blockButton (obTree: ADDRESS; private: ADDRESS; button: INTEGER;
                       mx, my : INTEGER; kstate: BITSET; clicks: INTEGER): BOOLEAN;
VAR infoPtr : blockInfoPtr;
    but     : INTEGER;
    t       : Trick;
    x, y, 
    select  : INTEGER;
    varname : CatTypes.String127;
    tree    : mtUtils.tObjcTree;
BEGIN
  infoPtr := private;
  tree := obTree;
  but := INTEGER(BITSET(button) - {15});
  CASE but OF
    MausTauschrsc.fbok,
    MausTauschrsc.fbquit : 
      mtUtils.ExclState (tree, but, MagicAES.SELECTED);
      RETURN TRUE; |
    MausTauschrsc.fbhelp : 
      CatHelp.DoHelp (CatHelp.filter);
      mtUtils.ExclState (tree, but, MagicAES.SELECTED);
      mtDials.DialDraw (tree, but, 1, v.r, FALSE); |
    MausTauschrsc.fbfilt0,
    MausTauschrsc.fbfilt1:
      but := MausTauschrsc.fbfilt1;
      MagicAES.ObjcOffset (tree, but, x, y);
      t := ADR (tree^[but].obState);
      select := mtPopups.TreePopup (infoPtr^.filtSel, x, y, ORD(t^.hi))-1;
      IF (ShellCall.IsShell() = ShellCall.noShell) & (select >= lowExtern) THEN select := -1 END;
      IF select >= 0 THEN
        t^.hi := CHR(select);
        VDIUtil.SetXString (tree, but, infoPtr^.filtSel, select);
        IF select >= lowExtern-1
        THEN
          buildVarName (cFilter, select-lowExtern+2, varname);
          ConfVars.GetConfDefStr (varname, infoPtr^.cmd, "");
          mtUtils.SetObjcString (tree, MausTauschrsc.fbcomm, infoPtr^.cmd);
        ELSE
          mtUtils.SetObjcString (tree, MausTauschrsc.fbcomm, '');
        END;
        mtDials.DialDraw (tree, MausTauschrsc.fbcomm, 0, v.r, FALSE);
        mtDials.DialDraw (tree, but, 0, v.r, FALSE);
      END; |
    MausTauschrsc.fbfilt2:
      t := ADR (tree^[but-1].obState);
      IF (ShellCall.IsShell() # ShellCall.noShell)
      THEN
        t^.hi := CHR((ORD(t^.hi)+1) MOD filtMax);
      ELSE
        t^.hi := CHR((ORD(t^.hi)+1) MOD (filtMax - filtExt));
      END;
      select := ORD (t^.hi);
      VDIUtil.SetXString (tree, but-1, infoPtr^.filtSel, select);
      IF select >= lowExtern-1
      THEN
        buildVarName (cFilter, select-lowExtern+2, varname);
        ConfVars.GetConfDefStr (varname, infoPtr^.cmd, "");
        mtUtils.SetObjcString (tree, MausTauschrsc.fbcomm, infoPtr^.cmd);
      ELSE
        mtUtils.SetObjcString (tree, MausTauschrsc.fbcomm, '');
      END;
      mtDials.DialDraw (tree, MausTauschrsc.fbcomm, 0, v.r, FALSE);
      mtDials.DialDraw (tree, but-1, 0, v.r, FALSE); |
  ELSE
  END;
  RETURN FALSE;
END blockButton;

PROCEDURE blockGetSetValues (tree: ADDRESS; private: ADDRESS; 
                             set: BOOLEAN; exit: INTEGER);
VAR infoPtr : blockInfoPtr;
    varname : CatTypes.String127;
BEGIN
  infoPtr := private;
  infoPtr^.exitBut := INTEGER(BITSET(exit) - {15});
  IF set
  THEN
    BuildFilterPopup (infoPtr^.filterNumber, infoPtr^.filtSel, TRUE);
    (* vorbereiten *)
    VDIUtil.SetXState (tree, MausTauschrsc.fbfilt1, infoPtr^.filterNumber);
    VDIUtil.SetXString (tree, MausTauschrsc.fbfilt1, infoPtr^.filtSel, infoPtr^.filterNumber);
  ELSE
    IF infoPtr^.exitBut = MausTauschrsc.fbok
    THEN
      infoPtr^.filterNumber := VDIUtil.GetXState (tree, MausTauschrsc.fbfilt1);
      IF infoPtr^.filterNumber >= lowExtern-1
      THEN
        (* String auslesen *)
        mtUtils.ObjcString (tree, MausTauschrsc.fbcomm, infoPtr^.cmd);
        Strings.DelLeadingBlanks (infoPtr^.cmd);
        Strings.DelTrailingBlanks (infoPtr^.cmd);
        buildVarName (cFilter, infoPtr^.filterNumber-lowExtern+2, varname);
        IF LENGTH (infoPtr^.cmd) > 0
        THEN
          v.bool := ConfVars.SetConfigString (varname, infoPtr^.cmd);
        ELSE
          ConfVars.DeleteConfigVar (varname);
        END;
      END;
    END; 
  END;
END blockGetSetValues;

PROCEDURE doFilter (VAR filterNumber: INTEGER; VAR cmd: ARRAY OF CHAR): BOOLEAN;
  VAR filterBox : mtUtils.tObjcTree;
      infoPtr   : blockInfoPtr;
      result    : BOOLEAN;
BEGIN
  IF filterNumber < 0 THEN filterNumber := 0; END;
  filterBox := MausTauschrsc.TreeAddr^[MausTauschrsc.filtbox];
  NEW (infoPtr);
  IF infoPtr=NIL
  THEN
    MTE.noMemAlert();
    RETURN FALSE;
  END;
  MagicStrings.Assign (cmd, infoPtr^.cmd);
  infoPtr^.filterNumber := filterNumber;
  
  IF ~WinDials.OpenWinDial (filterBox, TRUE, 
                            blockGetSetValues,
                            blockGetSetValues,
                            blockButton,
                            WinDials.defDraw,
                            "",
                            infoPtr)
  THEN
    MTE.noWinDialAlert();
    DISPOSE (infoPtr);
    RETURN FALSE;
  END;
  (* Da wir die Ergebnisse brauchen, mssen wir hier die Eventroutine 
   * aufrufen 
   *)
  WinDials.WinDialHandleEvents();
  
  filterNumber := infoPtr^.filterNumber;
  MagicStrings.Assign (infoPtr^.cmd, cmd);

  result := infoPtr^.exitBut = MausTauschrsc.fbok;
  
  DISPOSE (infoPtr);
  
  RETURN result;
  
END doFilter;

PROCEDURE doPopupFilter (VAR filterNumber: INTEGER; VAR cmd: ARRAY OF CHAR): BOOLEAN;
  VAR but       : INTEGER;
      filtSel   : mtUtils.tObjcTree;
      varname   : CatTypes.String127;
      x, y      : INTEGER;
      fNumber   : INTEGER;
BEGIN
  IF filterNumber < 0 THEN filterNumber := 0; END;
  BuildFilterPopup (filterNumber, filtSel, FALSE);
  MagicAES.GrafMkstate (x, y, v.bset, v.bset);
  fNumber := mtPopups.TreePopup (filtSel, x, y, 0) - 1;
  IF fNumber >= 0
  THEN
    filterNumber := fNumber;
  END;
  IF fNumber >= lowExtern-1
  THEN
    (* String auslesen *)
    buildVarName (cFilter, fNumber-lowExtern+2, varname);
    IF ConfVars.GetConfigString (varname, cmd)
    THEN
      RETURN TRUE;
    END;
    RETURN FALSE
  END;
  RETURN fNumber >= 0
END doPopupFilter;
(*------------------------------------------------------------------------*)

PROCEDURE NrHolen(VAR Nr : ARRAY OF CHAR):BOOLEAN;
VAR exit   : INTEGER;
    str    : CatTypes.String255;
    whichNr: mtUtils.tObjcTree;
BEGIN
  whichNr   := MausTauschrsc.TreeAddr^[MausTauschrsc.whichnr];
  mtUtils.ObjcString(whichNr, MausTauschrsc.nrstring, str);
  exit    := WinDials.WinDialDo (whichNr, 0);
  IF exit = MausTauschrsc.whcancel THEN
    mtUtils.SetObjcString(whichNr, MausTauschrsc.nrstring, str);
    RETURN FALSE
  END;
  mtUtils.ObjcString(whichNr, MausTauschrsc.nrstring, Nr);
  RETURN TRUE;
END NrHolen;

PROCEDURE DatumHolen(forWv: BOOLEAN; VAR Nr : ARRAY OF CHAR):BOOLEAN;
CONST   wvTitle     = "Wiedervorlage am";
        abrufTitle  = "Abrufen ab Datum";
        
VAR exit   : INTEGER;
    saveStr, str    : ARRAY[0..10] OF CHAR;
    ok : BOOLEAN;
    dateein: mtUtils.tObjcTree;
BEGIN
  dateein   := MausTauschrsc.TreeAddr^[MausTauschrsc.datumein];
  IF forWv
  THEN
    mtUtils.SetObjcString (dateein, MausTauschrsc.dtitle, wvTitle);
  ELSE
    mtUtils.SetObjcString (dateein, MausTauschrsc.dtitle, abrufTitle);
  END;
  mtUtils.ObjcString(dateein, MausTauschrsc.ddate, saveStr);
  REPEAT
    ok := FALSE;
    exit    := WinDials.WinDialDo (dateein, 0);
    IF exit = MausTauschrsc.dateok THEN
      mtUtils.ObjcString(dateein, MausTauschrsc.ddate, str);
      ok := ConvertDate.DateOk(str);
      IF ~ok THEN
        MTE.info ('[1][CAT:|Kein bekanntes|Datumsformat.][[Ok]')
      END;
    END;
  UNTIL (exit = MausTauschrsc.dcancel) OR ok;
  IF exit = MausTauschrsc.dcancel THEN
    mtUtils.SetObjcString(dateein, MausTauschrsc.ddate, saveStr);
    RETURN FALSE
  END;
  mtUtils.ObjcString(dateein, MausTauschrsc.ddate, Nr);
  RETURN TRUE;
END DatumHolen;

PROCEDURE GetUser(VAR on : BOOLEAN; VAR name : ARRAY OF CHAR):BOOLEAN;
VAR oldName : ARRAY[0..79] OF CHAR;
    chefStr : ARRAY [0..9] OF CHAR;
    k       : CARDINAL;
    j       : INTEGER;
    cGroup  : CARDINAL;
    gruppen : mtUtils.tObjcTree;
    getuser : mtUtils.tObjcTree;
    grinWdw : INTEGER;
BEGIN
  gruppen   := MausTauschrsc.TreeAddr^[MausTauschrsc.gruppen];
  getuser   := MausTauschrsc.TreeAddr^[MausTauschrsc.getuser];
  grin.GetGrinTopWdw (grinWdw);
  grin.ActualFrom (grinWdw, oldName);
  cGroup := grin.ActualGroupNr (grinWdw);
  mtUtils.SetState(getuser, MausTauschrsc.useron, MagicAES.SELECTED, cGroup = dataSys.private);
  mtUtils.SetState(getuser, MausTauschrsc.useroff, MagicAES.SELECTED, cGroup # dataSys.private);
  mtUtils.SetObjcString(getuser, MausTauschrsc.guserstr, oldName);
  REPEAT
    j := WinDials.WinDialDo (getuser, 0);

    mtUtils.ObjcString(getuser, MausTauschrsc.guserstr, name);
    IF (j # MausTauschrsc.userabru) & (name[0] = 0C) THEN
      MTE.info (MTE.emptyEName)
    END;
  UNTIL (j = MausTauschrsc.userabru) OR (name[0] # 0C);
  IF j # MausTauschrsc.userabru THEN
    mtUtils.ObjcString(getuser, MausTauschrsc.guserstr, name);
    on := mtUtils.InState(getuser, MausTauschrsc.useron, MagicAES.SELECTED);
    grin.ActualReceiver (grinWdw, oldName);
    MagicStrings.CAPS (oldName);
    MagicStrings.Copy (oldName, 0, 4, chefStr);
    IF MagicStrings.Equal (chefStr, 'CHEF')
    THEN
      MagicStrings.Delete (oldName, 0, 5);
      k := MagicStrings.Pos ('@', oldName, 0, FALSE);
      IF k < LENGTH (oldName) THEN 
        MagicStrings.Delete (oldName, k, LENGTH (oldName) - k+1);
      END;
      mtUtils.SetObjcString (gruppen, MausTauschrsc.newgroup, oldName);
      ListHelp.SetLastGroup (oldName);
    END;
    RETURN TRUE;
  ELSE
    mtUtils.SetObjcString(getuser, MausTauschrsc.guserstr, oldName);
    RETURN FALSE;
  END;
END GetUser;

PROCEDURE DoUserSelect();
VAR cmd  : CatTypes.String255;
    on   : BOOLEAN;
    grStr: CatTypes.String255;
    out  : INTEGER;
    ap   : ARRAY[0..1] OF CHAR;
BEGIN
  MagicStrings.Assign ("", grStr);
  IF GetUser(on, cmd) & ListHelp.SelectGroup(grStr, v.card, TRUE, FALSE, FALSE, ListHelp.gsmUser) & 
     (~MagicStrings.Equal (grStr, dataSys.personalName)) THEN
    out := CatFiles.OpenFile(MTPaths.MessagePath, 'grselect.inf', CatFiles.writeFile);
    IF out < 0 THEN
      MTE.info (MTE.changeNoSave);
    ELSE
      CatFiles.Seek(0, out, CatFiles.end);
    END;
    IF out > 0 THEN
      MagicStrings.Insert(':GU', cmd, 0);
      IF on THEN ap := '>' ELSE ap := '<' END;
      MagicStrings.Append(ap, cmd);
      MagicStrings.Append(grStr, cmd);
      CatFiles.WriteMuch(LONG(MagicStrings.Length(cmd)), out, ADR(cmd));
      CatFiles.WriteFile(CR, out); 
      CatFiles.WriteFile(LF, out);
      CatFiles.CloseFile(out);
    END;
  END
END DoUserSelect;


END CatOpts2.
