IMPLEMENTATION MODULE CatUtil;

FROM SYSTEM IMPORT ADDRESS;

(* Magic-Module *)
IMPORT mtCommand, MagicStrings, MagicXBIOS, MagicDOS, mtTextfiles, 
       MagicTypes, MagicSys;

(* CAT-Module *)
IMPORT CatTypes, CatFiles, CatGlobal, Messages, CatEdit, ShellCall,
       ConvertDate, ConfVars, Varnames, MsgWindow, grin, msgList,
       treeList, ARCStarter;
FROM MTPaths            IMPORT ARCPath, MessagePath, ImportPath,
                               ExportPath, DataPath, TerminalPath, ARCName,
                               archiveName, TerminalName, enarcStr,
                               dearcStr, TerminalCmd, ReadInf, lastInfName;

(* MM2-Module *)
IMPORT Strings, StrConv, Lists, Paths;

FROM Storage IMPORT ALLOCATE, DEALLOCATE;

FROM Void IMPORT v;

CONST whatString = '@(#)CAT '+CatTypes.CatVersion + ', Copyright (c) 1997 Dirk Steins (Oct 24 1997)'+0C;

CONST cExecSelf = FALSE;

PROCEDURE makeTmpName (VAR path, name: ARRAY OF CHAR);
 TYPE lBITSET = SET OF [0..31];  
  VAR currentPath: CatTypes.String255;
      tname     : CatTypes.String127;
      mtime,
      sec       : LONGCARD;
BEGIN
  (* Aktuellen Pfad merken *)
  CatFiles.GetPath (currentPath);
  (* TmpDir holen *)
  IF ~mtCommand.EnvVar ('TMP', path)
  THEN
    (* tmpDir ist aktuelles Verzeichnis! *)
    MagicStrings.Assign (currentPath, path);
  END;
  (* Jetzt Pfad richtig abschlieen mit Backslash *)
  IF path[LENGTH(path)-1] # '\'
  THEN
    MagicStrings.Append ('\',path);
  END;
  (* Tmp-Pfad setzen *)
  v.bool := CatFiles.SetPath (path);
  (* Dateinamen basteln aus Inhalt des 200 Hz Timers *)
  REPEAT
    mtime := MagicXBIOS.Random();
    MagicStrings.Assign ('CT', tname);
    MagicStrings.Append (StrConv.LNumToStr (mtime, 36, 6, '0'), tname);
    MagicStrings.Append ('.ASC', tname);
    (* Jetzt testen, ob Datei schon vorhanden *)
    MagicStrings.Assign (tname, name);
    sec := CatFiles.FileSize (name, v.bool);
  UNTIL ~v.bool;
  (* Aktuellen Pfad wiederherstellen *)
  v.bool := CatFiles.SetPath (currentPath);
END makeTmpName;

PROCEDURE buildCommand (wdw: INTEGER; REF com, path, in, out: ARRAY OF CHAR; VAR cmd : ARRAY OF CHAR);
(* In dieser Prozedur werden hauptschlich Strings ersetzt 
 * Das eigentliche zusammenbauen der Kommandozeile wird von einer
 * Prozedur weiter oben in der Hierarchie erledigt 
 * Folgendes wird ersetzt: $B fr Eingabeblock durch ersten Namen (in),
 * $O fr Ausgabe des Kommandos durch zweiten Namen
 *)
 VAR tname  : CatTypes.String255;
     p      : CARDINAL;
BEGIN
  MagicStrings.Assign (path, tname);
  MagicStrings.Append (in, tname);
  MagicStrings.Assign (com, cmd);
  CatGlobal.ReplaceStr (cmd, '$B', tname);
  MagicStrings.Assign (path, tname);
  MagicStrings.Append (out, tname);
  CatGlobal.ReplaceStr (cmd, '$O', tname);
  IF Messages.MsgEditorTop (wdw)
  THEN
    Messages.MsgEditGetInfos (wdw, Messages.itReceiver, tname);
    p := MagicStrings.Pos ('@', tname, 0, FALSE);
    IF p < LENGTH (tname)
    THEN
      tname[p] := '';
      IF tname[p-1] = ' ' THEN tname[p-1] := '' END;
    END;
    CatGlobal.ReplaceStr (cmd, '$U', tname);
  END;
END buildCommand;

(*$? cExecSelf:
PROCEDURE EnvSearch (VAR val : ARRAY OF CHAR; REF name: ARRAY OF CHAR;
                     env : ADDRESS);
                     
  PROCEDURE search (str, name : ARRAY OF CHAR;
                    VAR val : ARRAY OF CHAR) : BOOLEAN;
    VAR i : INTEGER;
  BEGIN
    Strings.Append ('=',name,v.bool);
    i := Strings.Pos (name, str, 0);
    IF i < 0 THEN RETURN FALSE END;
    Strings.Copy (str, i+INTEGER(Strings.Length(name)),
                  INTEGER(Strings.Length (str)-Strings.Length(name))-i, val, v.bool);
    RETURN TRUE
  END search;
  
  VAR ch : POINTER TO CHAR;
      lastCh : CHAR;
      i      : INTEGER;
      str    : ARRAY [0..2047] OF CHAR;
BEGIN
  ch := env;
  lastCh := ch^;
  i := 0;
  (* Solange noch env da ist *)
  WHILE (ch^ # 0C) OR (lastCh # 0C) DO
    str[i] := ch^;
    INC(i);
    lastCh := ch^;
    IF lastCh = 0C
    THEN (* string complete, search *)
      IF search(str, name, val) THEN RETURN
      ELSE
        str := "";
        i := 0;
      END;
    END;
    INC (ch);
  END;
END EnvSearch;

PROCEDURE getSystemPaths (VAR pathList: Lists.List);
  VAR basePage    : MagicTypes.PtrPD;
      systemPath  : ARRAY [0..2047] OF CHAR;
      p, p1, p2   : INTEGER;
      path        : CatTypes.String255;
      new         : CatTypes.Str255Ptr;
      ok          : BOOLEAN;

BEGIN
  (* suchen nach Environment-Variable PATH *)
  basePage := MagicSys.Basepage();
  systemPath[0] := '';
  EnvSearch (systemPath, 'PATH', basePage^.pEnv);
  IF systemPath[0] # ''
  THEN
    IF (systemPath[0] = ',')
    OR (systemPath[0] = ';')
    THEN
      p := 1;
    ELSE
      p := 0;
    END;
    REPEAT
      p1 := Strings.Pos (',', systemPath, p);
      p2 := Strings.Pos (';', systemPath, p);
      IF (p1 > 0) OR (p2 > 0)
      THEN
        IF (p1 > 0) & ((p1 < p2) OR (p2 < 0))
        THEN
          (* Komma als Trenner gefunden *)
          Strings.Copy (systemPath, p, p1-p, path, v.bool);
          p := p1+1;
        ELSIF (p2 > 0) & ((p2 < p1) OR (p1 < 0))
        THEN
          (* Semikolon als Trenner gefunden *)
          Strings.Copy (systemPath, p, p2-p, path, v.bool);
          p := p2+1;
        END;
        (* Jetzt neuen Eintrag fr die Liste erzeugen *)
        ALLOCATE (new, LENGTH (path)+2);
        IF new # NIL
        THEN
          MagicStrings.Assign (path, new^);
          (* Neuen Eintrag anlegen *)
          Lists.AppendEntry (pathList, new, v.bool);
        END;
      ELSE 
        p := -1;
      END;
    UNTIL p < 0;
  END;
END getSystemPaths;

PROCEDURE DeleteSimpleList (VAR l: Lists.List; killCarrier: BOOLEAN);

VAR   entry: ADDRESS;

BEGIN
  Lists.ResetList (l);
  entry := Lists.PrevEntry (l);
  WHILE entry # NIL DO
    Lists.RemoveEntry (l, v.bool);
    DEALLOCATE (entry, 0L);
    entry := Lists.CurrentEntry (l);
  END;
  IF killCarrier THEN Lists.DeleteList (l, v.bool) END;
END DeleteSimpleList;

PROCEDURE SearchExec (VAR name: ARRAY OF CHAR): BOOLEAN;
  VAR paths : Lists.List;
      newName: CatTypes.String255;
      found : BOOLEAN;
BEGIN
  Lists.CreateList (paths, v.bool);
  getSystemPaths (paths);
  Paths.SearchFile (name, paths, Paths.fromStart, found, newName);
  (* Liste wieder lschen *)
  DeleteSimpleList (paths, TRUE);
  IF found
  THEN
    MagicStrings.Assign (newName, name);
  END;
  RETURN found;
END SearchExec;
*)

PROCEDURE PipeEditBlock (wdw: INTEGER; REF command: ARRAY OF CHAR);
  VAR path,
      tname,
      inName,
      outName : CatTypes.String255;
      len     : LONGCARD;
      cmdLine : CatTypes.String255;
      done    : BOOLEAN;
      (*$? cExecSelf:
      cmdName : CatTypes.String255;
      cmdL    : CatTypes.String255;
      p       : INTEGER;
      res     : INTEGER;
      *)
BEGIN
  done := FALSE;
  IF LENGTH(command) = 0 THEN RETURN END;
  
  (* Vorgehensweise: 2*tmpFileName erstellen (in und out)
   * Kommando mit Redirection an shell absetzen 
   * kommando <in >out
   *)
  makeTmpName (path, inName);
  (* Block aus Editor schreiben *)
  CatEdit.EditSave (wdw, path, inName, FALSE);
  (* zweiten tmpnamen basteln *)
  makeTmpName (path, outName);
  (* Shellkommando basteln *)
  buildCommand (wdw, command, path, inName, outName, cmdLine);
  (*$? cExecSelf:
  (* Jetzt sehen, ob MagiX 5.04 oder grer *)
  IF CatGlobal.magIx & (CatGlobal.magIxVer >= $504)
  THEN
    (* Testen, ob mit IO-Redirection. Wenn nicht, starten wir es 
     * direkt selber
     *)
    IF (Strings.Pos ("<", cmdLine, 0) < 0)
     & (Strings.Pos (">", cmdLine, 0) < 0)
     & (Strings.Pos ("|", cmdLine, 0) < 0)
    THEN
      (* Keine IO-Redirection, keine Pipes, also selber ausfhren *)
      p := Strings.Pos (" ", cmdLine, 0);
      IF p > 0
      THEN
        (* split command line *)
        Strings.Split (cmdLine, p, cmdName, cmdL, v.bool);
        Strings.DelLeadingBlanks (cmdL);
        Strings.DelTrailingBlanks (cmdL);
        IF SearchExec (cmdName)
        THEN
          ARCStarter.ExecProgram (cmdName, cmdL, FALSE, FALSE, FALSE, res);
          done := res = 0;
        END;
      END;
    END;
  END;
  done := TRUE;
  *)
  IF ~done
  THEN
    (* Shellkommando aufrufen *)
    ShellCall.CallShell (cmdLine, TRUE);
  END;
  (* Testen, ob Ausgabe existiert und lnger als 0 Bytes ist *)
  MagicStrings.Assign (path, tname);
  MagicStrings.Append (outName, tname);
  len := CatFiles.FileSize (tname, v.bool);
  IF v.bool & (len > 0) 
  THEN
    (* Ausgabe in Editor einlesen *)
    CatEdit.EditPasteFile (wdw, TRUE, path, outName);
  END;
  (* temporre Files wieder lschen *)
  v.bool := CatFiles.DeleteFile (path, inName);
  v.bool := CatFiles.DeleteFile (path, outName);
END PipeEditBlock;

PROCEDURE writeInfo (REF inf: mtTextfiles.TEXTFILE);
  VAR z1 : CARDINAL;
      tstr   : ARRAY [0..12] OF CHAR;
      dt     : ConvertDate.Date;
      ti     : ConvertDate.Time;
BEGIN
  mtTextfiles.WriteLine (inf, '# ');
  mtTextfiles.WriteLine (inf, whatString);
  mtTextfiles.WriteLn (inf);
  z1 := MagicDOS.Tgetdate();
  dt := ConvertDate.UnpackDate (z1);
  ConvertDate.DateToText (dt, 'EEE dd yyyy', tstr);
  IF isTmp
  THEN
    mtTextfiles.WriteLine (inf, '# temporary configuration file');
  ELSE
    mtTextfiles.WriteLine (inf, '# configuration file');
  END;
  mtTextfiles.WriteLn (inf);
  mtTextfiles.WriteLine (inf, '# created ');
  mtTextfiles.WriteLine (inf, tstr);
  mtTextfiles.WriteLine (inf, ', ');
  z1 := MagicDOS.Tgettime();
  ti := ConvertDate.UnpackTime (z1);
  ConvertDate.TimeToText (ti, "HH:MM:SS", tstr);
  mtTextfiles.WriteLine (inf, tstr);
  mtTextfiles.WriteLn (inf);
END writeInfo;

PROCEDURE WriteUserBlock();
  CONST name = 'catuser.inf';
  VAR handle : INTEGER;
      infFileName : CatTypes.String255;
BEGIN
  MagicStrings.Assign (DataPath, infFileName);
  MagicStrings.Append (name, infFileName);
  isTmp := FALSE;
  v.bool := ConfVars.WriteConfigFile (infFileName, writeInfo);
END WriteUserBlock;

PROCEDURE GetPosPath (VAR path: ARRAY OF CHAR);
BEGIN
  (* Jetzt temporren Pfad holen *)
  ConfVars.GetConfDefBool (cUseTmpPath, v.bool, FALSE);
  IF ~v.bool OR ~mtCommand.EnvVar ('TMP', path)
  THEN
    CatGlobal.ApplPath (path);
  END;
  IF LENGTH(path) = 0 
  THEN 
    CatGlobal.ApplPath (path);
  END;
  IF path[LENGTH(path)-1] # '\'
  THEN
    (* ggf. Backslash anhngen *)
    MagicStrings.Append ('\', path);
  END;
END GetPosPath;

PROCEDURE WriteSavePos(force : BOOLEAN; delVars : BOOLEAN) : BOOLEAN;
  VAR ptail : CatTypes.String255;
      apPath: CatTypes.String255;
      apName: BOOLEAN;
BEGIN
  ConfVars.GetConfDefBool (cSetAppName, apName, TRUE);
  ConfVars.ConfigConfigModule (TRUE);
  v.bool := ConfVars.SetConfigBool (cSetAppName, apName);
  MsgWindow.msgSavePos ();
  ConfVars.ConfigConfigModule (FALSE);
  IF ~MsgWindow.msgCloseAll(force) 
  THEN 
    RETURN FALSE 
  END;
  ConfVars.ConfigConfigModule (TRUE);
  grin.grinSavePos();
  msgList.listSavePos();
  CatEdit.EditSavePos();
  v.bool := ConfVars.SetConfigString (cLastInfName, lastInfName);
  ConfVars.ConfigConfigModule (FALSE);
  IF ~CatEdit.CloseAllEditors (FALSE)
  THEN 
    RETURN FALSE
  END;
  grin.grinCloseAll();
  msgList.listCloseAll();
  treeList.treeCloseAll();
  msgList.listFreeAll();
  (* Jetzt temporren Pfad holen *)
  GetPosPath (ptail);
  MagicStrings.Append (tmpInf, ptail);
  ConfVars.ConfigConfigModule (TRUE);
  isTmp := TRUE;
  v.bool := ConfVars.WriteConfigFile (ptail, writeInfo);
  IF delVars
  THEN
    (* Variablen wieder lschen *)
    ConfVars.DeleteAllVars();
  END;
  (* Modul wieder zurckkonfigurieren *)
  ConfVars.ConfigConfigModule (FALSE);
  RETURN TRUE
END WriteSavePos;

END CatUtil.
