DEFINITION MODULE Clip;

(*==============================================================*
 * Modul:               Clipboard-Modul, nach Atari-Doku        *
 * Autor:               Johannes Gttker-Schnetmann             *
 * erstellt am:         10.02.1992                              *
 * letzte nderung am:  09.03.1992                              *
 * Version:             1.0                                     *
 * Interne Version:     V#0002                                  *
 *==============================================================*

 *----------------------------------------------------------------------------
 * Datum    Vers. Autor  nderung (Arbeitsbericht)
 *----------------------------------------------------------------------------
 * 10.02.92 0001  JGS    Erstellen
 * 09.03.92 0002  JGS    ClipDirty, ScrapClear hhinzugefgt
 *----------------------------------------------------------------------------
 *)

PROCEDURE ScrapClear(REF f, not : ARRAY OF CHAR);
(* leert das Clipboard falls Pfad leer, sonst den bergebenen Pfad *)

PROCEDURE GetScrap(VAR f : ARRAY OF CHAR):BOOLEAN;
(* Liefert den aktuellen Clipboard-Ordner *)

PROCEDURE ScrapDirty(REF f : ARRAY OF CHAR):BOOLEAN;
(* Ist etwas im Clipboard? *)
(* d.h. sieht entweder im bergebenen Pfad oder im Clipboard nach *)
(* ob ein SCRAP.TXT vorhanden ist *)

PROCEDURE ScrapWritten (type: BITSET; defExt: ARRAY OF CHAR);
(* Wir haben selber etwas in's Clipboard geschrieben *)

PROCEDURE SomethingInScrap (): BOOLEAN;
(* Sieht intern in einer Variablen nach. Im Zweifelsfall eher 
 * ScrapDirty benutzen
 *)

PROCEDURE ScrapIsDirty();
(* Sagt dem Modul, da extern irgendwas ins Clipboard geschrieben wurde 
 *)

END Clip.
