IMPLEMENTATION MODULE ConvertDate;

FROM SYSTEM IMPORT ASSEMBLER, ADR, WORD, CAST;
IMPORT MOSConfig, StrConv, Strings;

IMPORT MagicDOS;
IMPORT MagicStrings;

(*$R-,S-*)

(*
FROM InOut      IMPORT WriteString, WriteLn, Write, WriteInt, ReadString;
*)

MODULE MyDateFuncs; (* Internes Modul, fr die intern verwendeten Funktionen *)

IMPORT (*GEMDOS, Length;*) MagicDOS, MagicStrings, Date, Strings;

(* Die Sachen hier mssen auch nur fr den Test
 * exportiert werden!  vvvvvvvvvvvvvvvvvvv
 *)

EXPORT EncodeDate, DecodeDate, TextToDate, GetCurrentDate, CalcDate, Date2Days;

PROCEDURE StrToInt   ( s: ARRAY OF CHAR; VAR p: CARDINAL;
                       VAR valid: BOOLEAN ): INTEGER;
 (* Ich brauche eine eigene StrToInt-Funktion, da die vom
  * TDI immer ab Position 0 anfngt und nicht so fehlertolerant ist.
  *)
  VAR i : INTEGER;
      minus : BOOLEAN;
      wasNumber : BOOLEAN;
BEGIN
  valid := TRUE;
  wasNumber := FALSE;
  IF p > HIGH (s) THEN valid := FALSE; RETURN 0 END;
  i := 0;

  (* Fhrende nichtnumerische Zeichen berspringen *)
  WHILE (p<=HIGH(s)) & ((s[p]<'0') OR (s[p] > '9'))
      & (s[p] # '-') & (s[p] # 0C) DO
    INC(p)
  END;
  IF (p > HIGH (s)) OR (s[p] = 0C) THEN valid := FALSE; RETURN 0 END;

  minus := s[p] = '-';
  IF minus THEN INC(p) END;
  IF p > HIGH (s) THEN valid := FALSE; RETURN 0 END;
  WHILE (p<= HIGH(s)) & (s[p]>='0') & (s[p] <='9') DO
    i:= i*10 + VAL(INTEGER,ORD(s[p])-ORD('0'));
    INC(p);
    wasNumber := TRUE;
  END;
  valid := valid & wasNumber;
  IF minus
  THEN
    RETURN -i
  ELSE
    RETURN i
  END;
END StrToInt;

(* Da der ganze 'C'-Kram im TDI nicht ans laufen zu kriegen war, habe
 * ich mir eigene Funktionen gestrickt, die das Datum umrechnen.
 * Dafr brauche ich auch das Array hier, das enthlt die Tage, die bis zu 
 * dem Monat (index) vergangen sind
 *)
VAR mDays : ARRAY [0..11] OF LONGINT;

PROCEDURE initMDays ();
(* Nur fllen des Monatsarrays
 *)
BEGIN
  mDays[0] := 0;
  mDays[1] := 31;
  mDays[2] := 59;
  mDays[3] := 90;
  mDays[4] := 120;
  mDays[5] := 151;
  mDays[6] := 181;
  mDays[7] := 212;
  mDays[8] := 243;
  mDays[9] := 273;
  mDays[10] := 304;
  mDays[11] := 334;
END initMDays;

PROCEDURE Date2Days (d : Date) : LONGINT;
(* Berechnet aus Datum die Anzahl der Tage seit dem 1.1.1980.
 * Mte auch mit anderen Jahren funktionieren, Hauptsache, das Jahr
 * ist ein Schaltjahr. Fr den Fall einfach die 1980 berall austauschen.
 *)

  PROCEDURE schaltTage (d:Date) : LONGINT;
  (* Berechnet die Anzahl der Schalttage, die bis zum Datum d seit
   * dem 1.1.1980 vergangen sind.
   *)
    VAR sd : INTEGER;
  BEGIN
    (* Erst mal einfach durch 4 teilen und 1 dazu *)
    sd := (d.year - 1980) DIV 4 + 1;
    (* Hier wird dann noch die Korrektur fr das aktuelle Jahr gemacht *)
    IF (d.month < 3) &  ((d.year MOD 4 = 0) &
       ((d.year MOD 100 <> 0) OR (d.year MOD 400 = 0)))
    THEN
      DEC (sd)
    END;
    (* Ab dem Jahr 2100 wird die Funktion nicht mehr ganz stimmen, dann
     * mte noch ein Tag abgezogen werden. Dazu hatte ich aber keine 
     * Lust :-)
     *)
    RETURN LONG(sd)
  END schaltTage;
  
  VAR days : LONGINT;
  
BEGIN
  (* Ganz einfache Formel, braucht wohl keine Erklrung *)
  days := (LONG(d.year)-1980D)*365D + schaltTage (d) +
          mDays[d.month-1] + LONG(INTEGER(d.day)) - 1D;
  RETURN days
END Date2Days;

PROCEDURE CalcDate(days: LONGINT; VAR d : Date);
(* Hier wird aus einer Anzahl Tagen wieder ein Datum gemacht.
 * Das ist etwas untrivialer, als es zuerst scheint, hat mich am meisten
 * Zeit gekostet und ist auch frchterlich chaotisch, funktioniert aber.
 * Und beim nachtrglichen Dokumentieren habe ich mich auch gewundert,
 * warum das ganze funktioniert (siehe Trick), aber es geht wirklich
 *)
  VAR jahrGrob,
      monGrob,
      dayGrob,
      nDays,
      rDays   : LONGINT;
      tDate   : Date;
BEGIN
  (* Erst mal Jahr und Monat grob bestimmen *)
  jahrGrob := days DIV 365;
  rDays := days MOD 365 - (jahrGrob MOD 4);
  (* Das folgende ist eine Division durch 30.6, aber ich wollte die REAL-
   * Konvertierung umgehen. 30.6 ist die Durchschnittszahl von Tagen/Monat.
   *)
  monGrob := (5 * rDays) DIV 153;
  REPEAT
    rDays := days - (jahrGrob*365) - (jahrGrob MOD 4);
    (* Tage berechnen, gehen von 1..31 *)
    dayGrob := rDays - mDays[SHORT(monGrob) ];
    IF dayGrob <= 0
    THEN
      DEC(monGrob);
    END;
    (* Bei mehr als 29 Tagen erst mal einen Monat mehr nehmen, wird
     * weiter unten wieder korrigiert
     *)
    IF dayGrob > 29
    THEN
      INC(monGrob);
      DEC (dayGrob, 29);
      (* Wenn > 11, dann haben wir schon nchstes Jahr *)
      IF monGrob > 11
      THEN
        INC(jahrGrob);
        DEC(monGrob,12);
      END
    END;
    (* Wenn < 0, dann stimmt wohl das Jahr auch nicht, nehmen wir mal
     * eines weniger
     *)
    IF (monGrob < 0)
    THEN
      DEC (jahrGrob);
      INC (monGrob,12);
    END;
  UNTIL (monGrob >= 0) & (dayGrob > 0);
  (* So, jetzt haben wir ein ziemlich ungenaues Datum (vielleicht stimmt's
   * ja auch!)
   *)
  d.day := SHORT(dayGrob);
  d.month := SHORT (monGrob)+1;
  d.year := SHORT (jahrGrob) + 1980;
  (* Jetzt kommt der groe Trick! *)
  LOOP
    (* Ich hatte es auch einmal probeweise in einen riesigen
     * booleschen Ausdruck gepackt, aber diese Lsung ist von der
     * Codegre her besser.
     * Die Laufzeit ist sowieso unkritisch, schnell genug ist es immer.
     *)
    IF (d.day > 30) & ((d.month = 2) OR (d.month = 4) OR (d.month = 6) OR
        (d.month = 9) OR (d.month = 11))
    THEN
       (* Mehr als 30 Tage und Monat pat halt nicht *)
       INC(d.month);
       DEC(d.day,30);
    ELSIF (d.day >= 29) & (d.month = 2)
    THEN
      (* 29 Tage im Februar? Mal sehen, haben wir ein Schaltjahr? *)
      IF ~((d.year MOD 4 = 0) &
          ((d.year MOD 100 <> 0) OR (d.year MOD 400 = 0)))
      THEN
        (* Nein, kein Schaltjahr, also geht auch 29 Tage im Februar nicht! *)
        DEC(d.day,28);
        INC(d.month);
      ELSE
        IF (d.day > 29)
        THEN
          DEC (d.day, 29);
          INC(d.month);
        END
      END;
    END;
    (* Da isser: Ich rechne das errechnete Datum nochmal zurck!
     *)
    nDays := Date2Days (d);
    (* Ist gleich, stimmt wohl *)
    IF nDays = days THEN EXIT
    ELSIF nDays > days
    THEN
      (* Stimmt nicht, nach unten korrigieren.
       * Dabei natrlich Monats- und Jahreswechsel bercksichtigen
       *)
      DEC (d.day,nDays-days);
      IF d.day <= 0
      THEN
        DEC (d.month);
        INC (d.day, nDays-days);
        IF d.month <= 0
        THEN
          INC(d.month, 12);
          DEC (d.year);
        END
      END;
    ELSIF days > nDays
    THEN
      (* Stimmt nicht, nach oben korrigieren.
       * Dabei natrlich Monats- und Jahreswechsel bercksichtigen
       *)
      INC (d.day, days - nDays);
      IF (d.day > 31)
      THEN
        DEC (d.day,31);
        INC (d.month);
        IF d.month > 11
        THEN
          DEC (d.month,12);
          INC(d.year);
        END;
      END
    END
  END;
END CalcDate;

PROCEDURE EncodeDate (d: Date; VAR date: CARDINAL);
BEGIN
  IF d.year > 1980 THEN DEC (d.year, 1980); END;
  date := (((d.year * 16) + INTEGER(d.month)) * 32) + INTEGER(d.day);
END EncodeDate;

PROCEDURE DecodeDate (gt : CARDINAL; VAR d: Date);
BEGIN
  d.day := gt MOD 32;
  gt := gt DIV 32;
  d.month := gt MOD 16;
  gt := gt DIV 16;
  d.year := gt MOD 128;
  INC(d.year,1980);
END DecodeDate;

PROCEDURE GetCurrentDate (VAR d: Date);
(* GEMDOS-Datum erfragen und auseinanderpflcken *)
  VAR gt : CARDINAL;
BEGIN
  gt := MagicDOS.Tgetdate();
  DecodeDate (gt, d);
END GetCurrentDate;
    
PROCEDURE TextToDate ( s: ARRAY OF CHAR; VAR d: Date; VAR valid: BOOLEAN );
(* Die eigentliche Hauptfunktion: Sie wandelt sowohl ins Datum und 
 * berprft auch, ob das Datum gltig ist. Die wird auch von den 
 * Funktionen DateOK und StrToDate aufgerufen.
 *)
  VAR p:CARDINAL;
      i : INTEGER;
      today : Date;
      jul : LONGINT;

  (* skip: nicht-numerische Zeichen im String s werden bersprungen.
   * p gibt dann die Position des nchsten numerischen Zeichens im String an 
   *)
  PROCEDURE skip (VAR s:ARRAY OF CHAR; VAR p:CARDINAL);
    BEGIN
      WHILE (p<MagicStrings.Length(s)) & ( (s[p]<'0') OR (s[p]>'9')) DO
        INC (p)
      END;
    END skip;
  
  (* get: liest aus dem String s eine Zahl aus und berprft, ob diese
   *      im bergebenen Wertebereich liegt. Wenn ja, wird valid auf TRUE
   *      gesetzt. Wenn nein, ist valid FALSE und als Ergebnis wird die
   *      untere Grenze 'lo' zurckgegeben.
   *)
  PROCEDURE get (lo,hi:INTEGER): INTEGER;
    VAR v:INTEGER;
    BEGIN
      v:= StrToInt (s,p,valid);
      skip (s,p);
      IF (v<lo) OR (v>hi) THEN valid:= FALSE END;
      IF ~valid THEN v := lo END;
      RETURN v
    END get;
  
  (* getd: Holt mittels get den Tag des Datums aus dem String *)  
  PROCEDURE getd;
    BEGIN
      IF valid THEN
        d.day:= get (1,31)
      END
    END getd;
    
  (* getm: Holt mittels get den Monat des Datums aus dem String *)  
  PROCEDURE getm;
    BEGIN
      IF valid THEN
        d.month:= get (1,12);
      END
    END getm;
    
  (* gety: Holt mittels get das Jahr des Datums aus dem String *)  
  PROCEDURE gety;
    BEGIN
      IF valid THEN
        d.year:= get (-9999,9999);
        IF valid THEN
          (* Dieses Jahrhundert mitnehmen *)
          IF (d.year<=99) THEN INC (d.year,1900) END
        END
      END
    END gety;

  BEGIN
    (* init *)
    p:=0;
    valid:=TRUE;
    GetCurrentDate(today);
    
    (* convert: Erst mal sehen, ob es nur eine Integerzahl ist *)
    Strings.DelLeadingBlanks (s);
    i:= StrToInt (s,p,valid);
    IF ((i<=0) & valid)
    OR ((i > 0) & valid & (s[0] = '+'))
    THEN
      (* Ist negativ,        *)
      (* Datum zurckrechnen *)
      jul := Date2Days (today);
      jul := jul + LONG(i);   (* da i negativ ist, + *)
      (* es wird bis maximal 1.1.1980 zurckgerechnet,
       * weiter geht nicht, fhrt zu Loop!
       *)
      IF jul < 0 THEN valid := FALSE; RETURN END;
      CalcDate (jul, d);
    ELSE
      (* Ist keine Integerzahl oder positiv, also nehmen wir ein normales
       * Datum an. 
       *)
      p:=0;
      getd;
      (* Nur wenn Tag nicht gltig, schlgt alles fehl!!*)
      IF valid
      THEN
        getm;
        IF valid
        THEN
          gety;
          IF ~valid
          THEN
            d.year := today.year
          END;
        ELSE
          d.year := today.year;
          d.month := today.month;
        END;
        valid := TRUE;
      END;
    END;
    (* Numerisch gltig, jetzt logische Prfung *)
    IF valid
    THEN
      (* Ich hatte es auch einmal probeweise in einen riesigen
       * booleschen Ausdruck gepackt, aber diese Lsung ist von der
       * Codegre her besser.
       * Die Laufzeit ist sowieso unkritisch, schnell genug ist es immer.
       *)
      IF (d.day > 30) & ((d.month = 2) OR (d.month = 4) OR (d.month = 6) OR
          (d.month = 9) OR (d.month = 11))
      THEN
        (* Mehr als 30 Tage und Monat pat halt nicht *)
         valid := FALSE;
      ELSIF (d.day > 29) & (d.month = 2)
      THEN
        (* Mehr als 29 Tage im Februar geht nun wirklich nicht *)
        valid := FALSE;
      ELSIF (d.day = 29) & (d.month = 2)
      THEN
        (* 29 Tage im Februar? Mal sehen, haben wir ein Schaltjahr? *)
        IF ~((d.year MOD 4 = 0) &
            ((d.year MOD 100 <> 0) OR (d.year MOD 400 = 0)))
        THEN
          (* Nein, kein Schaltjahr, also geht auch 29 Tage im Februar nicht! *)
          valid := FALSE;
        END
      END;
    END;
    (* Jetzt noch prfen, ob Jahr < 1990 *)
    IF d.year < 1990
    THEN 
      valid := FALSE;
    END;
    (* Das wars! *)
  END TextToDate;

BEGIN
  (* Beim Start kurz das Monatsfeld fllen *)
  initMDays;
END MyDateFuncs;

(* So, nun kommen die Funktionen, die Du haben wolltest:
 *)

PROCEDURE CurrentDate (): LONGCARD;
 VAR  d     : Date;
BEGIN
  GetCurrentDate (d);
  DEC(d.year, 1990);
  (* Frher als 1990 geht nicht! *)
  IF d.year < 0 THEN d.year := 0 END;
  (* und jetzt noch die Riesenzahl draus machen
   *)
  RETURN ((((LONG(VAL(CARDINAL,d.year))*100D)+LONG(VAL(CARDINAL,d.month)))*100D)
            +LONG(VAL(CARDINAL,d.day)))*10000D;
END CurrentDate;


PROCEDURE StrToDate (str : ARRAY OF CHAR) : LONGCARD;
  (* Eingabe: String mit relativ beliebigem Format.
   * Ausgabe: LONGCARD mit folgenden Format:
   *          jjmmddhhmm, Jahr minus 1990.
   *          0000  immer, da Zeit nicht eingegeben wird.
   * Anmerkung: Diese Funktion gibt nur bis 2032 das korrekte Datum
   *            zurck, da danach ein berlauf des 32-Bit Wertes
   *            auftritt. Sptestens dann ist diese Funktion bzw.
   *            das Datumsformat zu berarbeiten :-)
   *)
  VAR voidO : BOOLEAN;
      d     : Date;
BEGIN
  (* Umwandeln in Datum *)
  TextToDate (str, d, voidO);
  (* Vom Jahr 1990 abziehen (blder Kommentar, nicht) *)
  DEC(d.year, 1990);
  (* Frher als 1990 geht nicht! *)
  IF d.year < 0 THEN d.year := 0 END;
  (* und jetzt noch die Riesenzahl draus machen
   * Hier knnte man noch Zeit und Datum als Random-Zahlen einstreuen :-)
   *)
  RETURN ((((LONG(VAL(CARDINAL,d.year))*100D)+LONG(VAL(CARDINAL,d.month)))*100D)
            +LONG(VAL(CARDINAL,d.day)))*10000D;
END StrToDate;

PROCEDURE StrToMTDate (str : ARRAY OF CHAR; VAR res: ARRAY OF CHAR);
  (* Eingabe: String mit relativ beliebigem Format.
   * Ausgabe: Datum im Maustausch-Format, Uhrzeit wird auf 0 Uhr gesetzt
   *)
  VAR voidO : BOOLEAN;
      d     : Date;
      cD    : CARDINAL;
BEGIN
  (* Umwandeln in Datum *)
  TextToDate (str, d, voidO);
  EncodeDate (d, cD);
  MakeFreeDate (cD, 0, res);
END StrToMTDate;

PROCEDURE TextDateToNum (date: ARRAY OF CHAR): LONGCARD;
  VAR d : Date;
      voidO: BOOLEAN;
BEGIN
  (* Umwandeln in Datum *)
  TextToDate (date, d, voidO);
  IF ~voidO THEN RETURN 0 END;
  RETURN LONGCARD (Date2Days (d));
END TextDateToNum;

PROCEDURE DateOk (str : ARRAY OF CHAR) : BOOLEAN;
  (* DateOk prft nach, ob ein Datum in einem String ein gltiges Datum ist.
   * Wenn nicht, wird FALSE zurckgegeben, andernfalls ...
   *)
  VAR voidD : Date;
      isOk  : BOOLEAN;
BEGIN
  (* TextToDate macht das schon :-) *)
  TextToDate (str, voidD, isOk);
  (* und Ergebnis zurck *)
  RETURN isOk
END DateOk;

PROCEDURE CatDate2Datim (cd: LONGCARD; VAR date: Date; VAR time: Time);
(* Wandelt ein CAT-Datum in ein Datum und eine Uhrzeit um
 *)
BEGIN
  WITH time DO
    second := 0;
    minute := CAST(INTEGER, cd MOD 100);
    cd := cd DIV 100;
    hour := CAST(INTEGER, cd MOD 100);
    cd := cd DIV 100;
  END;
  WITH date DO
    day := CAST(INTEGER, cd MOD 100);
    cd := cd DIV 100;
    month := CAST(INTEGER, cd MOD 100);
    cd := cd DIV 100;
    year := CAST(INTEGER, cd MOD 100);
    INC (year, 1990);
  END;
END CatDate2Datim;

PROCEDURE UnpackDate (date: CARDINAL): Date;
(* Wandelt GEMDOS-Datum in Datum um
 *)
  VAR d: Date;
BEGIN
  DecodeDate (date, d);
  RETURN d;
END UnpackDate;

PROCEDURE PackDate (date: Date): CARDINAL;
(* Wandelt Datum in GEMDOS-Datum um
 *)
 VAR  d: CARDINAL;
BEGIN
  EncodeDate (date, d);
  RETURN d
END PackDate;

PROCEDURE UnpackTime (time: CARDINAL): Time;
(* Wandelt GEMDOS-Zeit in Zeit um
 *)
 VAR ti : Time;
BEGIN
  WITH ti DO
    second := (time MOD 32) * 2;
    time := time DIV 32;
    minute := time MOD 64;
    hour := time DIV 64;
  END;
  RETURN ti;
END UnpackTime;

PROCEDURE PackTime (time: Time): CARDINAL;
(* Wandelt Zeit in GEMDOS-Zeit um
 *)
 VAR t : CARDINAL;
BEGIN
  WITH time DO
    t := ((hour * 64) + minute) * 32 + second;
  END;
  RETURN t;
END PackTime;

PROCEDURE DateInNum (date : CARDINAL): LONGCARD;
  VAR d: Date;
BEGIN
  DecodeDate (date, d);
  RETURN LONGCARD(Date2Days (d));  
END DateInNum;

PROCEDURE NumInDate (num : LONGCARD): CARDINAL;
  VAR d: Date;
      date: CARDINAL;
BEGIN
  CalcDate (num, d);
  EncodeDate (d, date);
  RETURN date;
END NumInDate;

PROCEDURE DateToJulian (d : Date): LONGCARD;
(* Wandelt ein Datum in eine Zahl (Tage seit 1.1.1980) um
 *)
BEGIN
  RETURN LONGCARD(Date2Days (d));  
END DateToJulian;

PROCEDURE GoodFriday(Year: INTEGER; VAR day, month: INTEGER);
VAR
    Golden,          (* Year in Mentonic cycle *)
    Easter,          (* Easter Sunday *)
    GrCor,           (* Gregorian correction *)
    ClCor,           (* Clavian correction *)
    Epact,           (* age of calendar moon at start of Year *)
    Century,         (* Century *)
    Extra,           (* when Sunday occurs in March *)
    Emonth: INTEGER; (* Month of Easter Sunday (March/April) *)
BEGIN
    Golden := (Year DIV 19) * (-19);
    Golden := Golden + Year+1;

    IF (Year > 1582) THEN 
        Century := (Year DIV 100) + 1;

        GrCor := ((Century*3) DIV (-4)) + 12;

        ClCor := ((Century-18) DIV (-25)) + ((Century-16) DIV 3);

        Extra := (Year*5 DIV 4) + GrCor - 10;

        Epact := (Golden*11) + 20 + ClCor + GrCor;
        Epact := Epact + (Epact DIV 30) * (-30);

        IF (Epact <= 0) THEN
           Epact := Epact + 30;
        END;
        IF ((Epact=25) AND (Golden>11)) OR (Epact=24) THEN
            INC(Epact);
        END;
    ELSE
        Extra := (Year*5) DIV 4;
        Epact := (Golden*11) - 4;
        Epact := Epact + (Epact DIV 30) * (-30);
        INC(Epact);
    END;

    Easter := -Epact + 44;
    IF (Easter < 21) THEN
        Easter := Easter + 30;
    END;

    Extra := Extra + Easter;
    Extra := Extra + (Extra DIV 7) * (-7);

    Easter := Easter - Extra + 7;
    Emonth := 3;

    IF (Easter > 31) THEN
        Easter := Easter - 31;
        INC(Emonth);
    END;
    (* Easter/Emonth now contain date of Easter sunday *)

    (* calculate good friday's date *)
    Easter := Easter - 2;
    IF (Easter < 0) THEN
      Easter := Easter + 31;
      DEC(Emonth);
    END;

    day := Easter;
    month := Emonth;
END GoodFriday;

PROCEDURE LeapYear(year: INTEGER): BOOLEAN;
BEGIN
    RETURN ((year MOD 4) = 0) & ((year MOD 100 # 0) OR (year MOD 400 = 0));
    (*
    leapyear := (year MOD 4) = 0;

    IF (year MOD 100 = 0) AND (year MOD 400 <> 0) THEN
        RETURN FALSE;
    *)
END LeapYear;

PROCEDURE DaysInFeb(year: INTEGER): INTEGER;
BEGIN
  IF LeapYear(year) THEN
    RETURN 29
  ELSE
    RETURN 28;
  END;
END DaysInFeb;

PROCEDURE WeekDay (d: Date): tWeekday;
(* Liefert den aktuellen Wochentag zurck 
 *)
VAR
  jul: LONGINT;
BEGIN
  jul := Date2Days(d);
  RETURN tWeekday (SHORT((jul+1) MOD 7));
END WeekDay;

PROCEDURE BuBtag(year: INTEGER): LONGINT;
VAR d: Date;
    weekday: tWeekday;
BEGIN
  (* Wochentag berechnen *)
  weekday := WeekDay (Date{16,11,year});
  
  d.year := year;
  d.month := 11;
  d.day := 25 - ORD (weekday);
  IF d.day > 22 THEN DEC (d.day, 7); END;
  
  RETURN Date2Days(d);
END BuBtag;

PROCEDURE WeekEnd(d: Date): BOOLEAN;
(* Liefert TRUE, wenn das Datum am Wochenende ist
 *)
  TYPE tWeekSet = SET OF tWeekday;
BEGIN
  RETURN WeekDay(d) IN tWeekSet{Saturday,Sunday};
END WeekEnd;

PROCEDURE Holiday(VAR d: Date): BOOLEAN;
(* Gibt zurck, ob das Datum ein deutscher Feiertag ist
 *)
VAR
    dy, mn: INTEGER;
    i: INTEGER;
    jul: LONGINT;
  good_friday,
  eastermonday,
    eastersunday: LONGINT;
TYPE
  daymonth = RECORD day : INTEGER[1..31];
                    month: INTEGER[1..12]; 
             END;
  holArray = ARRAY [0..7] OF daymonth;
CONST
  holidays = holArray {
        daymonth{1,1},    (* Neujahr *)
        daymonth{1,5},    (* 1. Mai *)
        daymonth{3,10},   (* Tag der dt. Einheit *)
        daymonth{1,11},   (* Allerheiligen *)
        daymonth{24,12},  (* Heiligabend *)
        daymonth{25,12},  (* 1. Weihnachtstag *)
        daymonth{26,12},  (* 2. Weihnachtstag *)
        daymonth{31,12}}; (* Sylvester *)
BEGIN
  IF d.year < 1900 THEN INC (d.year, 1900); END;
  (* wann ist Ostern? *)
  GoodFriday(d.year,dy,mn);
  good_friday := Date2Days(Date{dy,mn,d.year});
  eastersunday := good_friday+2;
  eastermonday := good_friday+3;

  FOR i:=0 TO 7 DO
    IF (d.day=holidays[i].day) AND (d.month=holidays[i].month) THEN 
       RETURN TRUE;
    END;
  END;

  jul := Date2Days(d);

  IF (jul = good_friday) OR (jul=eastermonday) OR (jul=eastersunday) 
  OR (jul = eastersunday + 39)      (* Christi Himmelfahrt *)
  OR (jul = eastersunday + 50)      (* Pfingstmontag *)
  OR (jul = BuBtag(d.year))         (* Buss- und Bettag *)
  THEN
    RETURN TRUE;
  END;
  RETURN FALSE;
END Holiday;

PROCEDURE BussBet (year: INTEGER; VAR d: Date);
(* Liefert das Datum vom Bu- und Bettag
 *)
  VAR bub: LONGINT;
BEGIN
  bub := BuBtag (year);
  CalcDate (bub, d);
END BussBet;

PROCEDURE KarFreitag (year: INTEGER; VAR d: Date);
(* Liefert das Datum von Karfreitag
 *)
 VAR dd, dm: INTEGER;
BEGIN
  GoodFriday (year, dd, dm);
  d.day := dd; 
  d.month := dm;
  d.year := year;
END KarFreitag;

PROCEDURE KarFreitagNumber (year: INTEGER) : LONGCARD;
(* Liefert das Datum von Karfreitag als Zahl
 * Damit kann man einige andere variable Feiertage berechnen:
 *
 *  Ostersonntag = Karfreitag + 2
 *  Ostermontag  = Karfreitag + 3
 *  Christi Himmelfahrt  = Karfreitag + 41
 *  Pfingstmontag  = Karfreitag + 52
 *)
 VAR d: Date;
BEGIN
  KarFreitag (year, d);
  RETURN LONGCARD (Date2Days (d));
END KarFreitagNumber;

CONST langHigh = 2; (* hchster Sprachindex f. 'mon' *)
      monHigh = 9;

TYPE MonStr= ARRAY [0..monHigh] OF CHAR;

VAR strok: BOOLEAN;

PROCEDURE Repl (VAR source: ARRAY OF CHAR; index,len: WORD; VAR dest:ARRAY OF CHAR );
(*$L-*)
BEGIN
  ASSEMBLER
        MOVEM.L D3-D6,-(A7)
        MOVE    -(A3),D6         ;HIGH(dest)
        MOVE.L  -(A3),A2         ;dest
        MOVE    -(A3),D0         ;D0:=len
        MOVE    -(A3),D1         ;D1:=index
        MOVE    -(A3),D5         ;HIGH(source)
        MOVE.L  -(A3),A1         ;source
        MOVEQ   #0,D4           ; index f. dest
        MOVEQ   #-1,D2          ; index f. source
        TST     D0
        BNE     start
        
l2      ADDQ    #1,D2
        CMP     D1,D2           ; haben wir start-index erreicht ?
        BEQ     ok
        CMP     D5,D2
        BHI     ende             ; Stringende berschritten
        TST.B   0(A1,D2.W)
        BEQ     ende
        BRA     l2              ; Nein, noch nicht kopieren
        
l       ADDQ    #1,D2
        CMP     D5,D2
        BHI     ende             ; Stringende berschritten
        MOVE.B  0(A1,D2.W),D3
        BEQ     ende
        CMP     D1,D2           ; haben wir start-index erreicht ?
        BCS     l               ; Nein, noch nicht kopieren
        CMP     D6,D4           ; pat Zeichen noch in String ?
        BHI     ende
        MOVE.B  D3,0(A2,D4.W)   ; Zeichen kopieren
        ADDQ    #1,D4
start   DBRA    D0,l
ok
ende    MOVEM.L (A7)+,D3-D6
  END
END Repl;
(*$L=*)

CONST   StringOverflow  = -8;

TYPE  String = ARRAY [0..79] OF CHAR;

PROCEDURE TimeToText ( s: Time; REF mask: ARRAY OF CHAR; VAR d: ARRAY OF CHAR );
  (* %% Komplett neue PROCEDURE TimeToText. Wertet jetzt 'mask' komplett
   * aus. Jeder Wert wird nur einmal in das Ergebnis gesetzt.
   * Es wird kein Test auf ungltige Werte in 's' vorgenommen, sollten
   * aber auch nicht drin sein.
   *)
  
  VAR english : BOOLEAN;
      l       : CARDINAL;
      p       : INTEGER;
      i,j     : CARDINAL;
      ch      : CHAR;
      up, hSet, mSet, sSet, eSet: BOOLEAN;
      
PROCEDURE set (value: CARDINAL; zeros: BOOLEAN);
  VAR ins: String;
  BEGIN
    ins := StrConv.NumToStr (value,10,2,'0');
    IF zeros OR (ins[0] # '0') THEN
      d[j] := ins[0];
      INC(j);
    END;
    d[j] := ins[1];
    INC(j);
    INC(i, 2);
  END set;

PROCEDURE copy;
  BEGIN
    d[j] := mask[i];
    INC(j);
    INC(i);
  END copy;

BEGIN
  IF mask[0] = '' THEN
    TimeToText (s, MOSConfig.StdTimeMask, d);
    RETURN
  END;
  (* Flags initialisieren *)
  english := FALSE;
  hSet := FALSE;
  mSet := FALSE;
  sSet := FALSE;
  eSet := FALSE;
  l := MagicStrings.Length (mask);
  IF l > (HIGH(d)+1) THEN
    ASSEMBLER
      TRAP    #6
      DC.W    StringOverflow
    END;
    l:= HIGH (d)+1
  END;
  
  (* Test auf englische Notierung: *)
  p:= 0;
  LOOP
    p:= MagicStrings.Pos ('#', mask, p, FALSE);
    IF p > INTEGER(HIGH (mask)) THEN EXIT END;
    INC (p);
    IF CAP (mask[p]) = 'E' THEN
      english := TRUE;
      EXIT
    END
  END;
  
  (* Maske scannen *)
  j := 0;
  i := 0;
  WHILE i < l DO
    ch:= mask[i];
    IF (ch = '#') & (CAP(mask[i+1])='E') & ~eSet THEN
      up:= mask[i+1]='E';
      IF s.hour > 12 THEN
        d[j] := 'p'
      ELSE
        d[j] := 'a'
      END;
      IF up THEN d[j]:= CAP (d[j]) END;
      INC(j);
      IF up THEN d[j]:= 'M' ELSE d[j]:= 'm' END;
      INC(j);
      INC(i,2);
      eSet := TRUE;
    ELSIF mask[i+1]=ch THEN
      up:= CAP(ch) = ch;
      IF (CAP (ch) = 'H') & ~hSet THEN
        IF english & (s.hour > 12) THEN
          set (s.hour-12, up);
        ELSE
          set (s.hour, up)
        END;
        hSet:= TRUE
      ELSIF (CAP (ch) = 'M') & ~mSet THEN
        set (s.minute, up);
        mSet:= TRUE
      ELSIF (CAP (ch) = 'S') & ~sSet THEN
        set (s.second, up);
        sSet:= TRUE
      ELSE
        copy
      END
    ELSE
      copy
    END
  END (* WHILE i *);
  IF j <= HIGH (d) THEN
    d[j] := 0c
  END;
END TimeToText;


PROCEDURE mon (lang: INTEGER; month: CARDINAL): MonStr;
          (* lang: -1: User-defined, 0: Deutsch, 1:Frz., 2:Engl *)
  (*$L-*)
  BEGIN
    ASSEMBLER
        MOVE    -(A3),D0
        SUBQ    #1,D0
        MOVE    -(A3),D1
        MOVE.L  A3,A0
        ADDA.W  #monHigh+1,A3
        BEQ     tger
        BMI     tusr
        SUBQ    #2,D1
        BCS     tfrz

        LEA     eng(PC),A1
        BRA     cont
      tfrz:
        LEA     frz(PC),A1
        BRA     cont
      tger:
        LEA     ger(PC),A1
        BRA     cont

      lup:
        TST.B   (A1)+
        BNE     lup
      cont:
        DBRA    D0,lup
      lup2:
        MOVE.B  (A1)+,(A0)+
        BNE     lup2
        RTS

      tusr:
        LEA     MOSConfig.NameOfMonth,A1
        MULU    #10,D0          ; SIZE (NameOfMonth[1])
        ADDA.W  D0,A1
        MOVEQ   #monHigh,D1
      lupu:
        MOVE.B  (A1)+,(A0)+
        DBEQ    D1,lupu
        RTS

      ger:
        ACZ     'Januar'
        ACZ     'Februar'
        ACZ     'Mrz'
        ACZ     'April'
        ACZ     'Mai'
        ACZ     'Juni'
        ACZ     'Juli'
        ACZ     'August'
        ACZ     'September'
        ACZ     'Oktober'
        ACZ     'November'
        ACZ     'Dezember'
        
      frz:
        ACZ     'Janvier'
        ACZ     'Fvrier'
        ACZ     'Mars'
        ACZ     'Avril'
        ACZ     'Mai'
        ACZ     'Juin'
        ACZ     'Juillet'
        ACZ     'Aot'
        ACZ     'Septembre'
        ACZ     'Octobre'
        ACZ     'Novembre'
        ACZ     'Dcembre'
        
      eng:
        ACZ     'January'
        ACZ     'February'
        ACZ     'March'
        ACZ     'April'
        ACZ     'May'
        ACZ     'June'
        ACZ     'July'
        ACZ     'August'
        ACZ     'September'
        ACZ     'October'
        ACZ     'November'
        ACZ     'December'
    END
  END mon;
  (*$L=*)

PROCEDURE DateToText ( s: Date; REF m0: ARRAY OF CHAR; VAR d: ARRAY OF CHAR );

  VAR mask: String;
      vo  : BOOLEAN;

  PROCEDURE Del (a,b:INTEGER);
    BEGIN
      MagicStrings.Delete (d,a,b);
      MagicStrings.Delete (mask,a,b)
    END Del;

  PROCEDURE set (ch:CHAR; v: CARDINAL): BOOLEAN;
    VAR p,l,n:CARDINAL; 
        ps: POINTER TO String; 
        s2: String; 
        c1,c2: CHAR;
        t : CARDINAL;
    BEGIN
      IF Strings.Pos (ch,d,0)>=0 THEN
        p:= Strings.Pos (ch,d,0);
        n:=1;
        WHILE Strings.Chr (d,p+n) = ch DO
          INC (n)
        END;
        IF (Strings.Chr(d,p+n)='#') & (Strings.Chr(mask,p+n+1)='E') THEN
          t := v MOD 10;
          IF (t > 0) & (t < 4) & 
             ((v < 10) OR (v > 20))
          THEN
            IF t=1 THEN c1:='s'; c2:='t'
            ELSIF t=2 THEN c1:='n'; c2:='d'
            ELSIF t=3 THEN c1:='r'; c2:='d'
            ELSE c1:='t'; c2:='h' END;
          ELSE c1:='t'; c2:='h' END;
          d[p+n]:=c1; d[p+n+1]:=c2
        END;
        s2:= StrConv.CardToStr (v,0);
        l:= MagicStrings.Length (s2);
        IF l >= n THEN
          (* Feld wird vollst. gefllt; die Zahl rechtsbndig kopieren: *)
          ps:= ADR (d)+LONG(p);
          Repl (s2,l-n,n,ps^)
        ELSE
          IF mask[p] >= 'a' THEN
            (* Feld ist zu gro; krzen: *)
            Del (p,n-l);
            ps:= ADR (d)+LONG(p);
            Repl (s2,0,l,ps^);
          ELSE
            (* Feld ist zu gro; mit Nullen fllen: *)
            WHILE l # n DO
              d[p]:='0';
              INC (p);
              DEC (n)
            END;
            ps:= ADR (d)+LONG(p);
            Repl (s2,0,l,ps^)
          END
        END;
        RETURN TRUE
      END;
      RETURN FALSE
    END set;

  PROCEDURE monset (ch:CHAR; v: INTEGER);
    VAR p,l,n:CARDINAL; ps: POINTER TO String; s2: MonStr;
    BEGIN
      IF Strings.Pos (ch,d,0)>=0 THEN
        p:= Strings.Pos (ch,d,0);
        n:=1;
        WHILE Strings.Chr (d,p+n) = ch DO
          INC (n)
        END;
        s2:= mon(v,s.month);
        l:= Strings.Length (s2);
        IF l >= n THEN
          (* Feld wird vollst. gefllt; den String linksbndig kopieren: *)
          l:=n;
        ELSE
          (* Feld ist zu gro; krzen: *)
          Del (p,n-l)
        END;
        ps:= ADR (d)+LONG(p);
        Repl (s2,0,l,ps^)
      END
    END monset;

BEGIN
  IF m0[0]=0C THEN
    MagicStrings.Assign (MOSConfig.StdDateMask,mask)
  ELSE
    MagicStrings.Assign (m0,mask)
  END;
  IF HIGH (d)+1 < MagicStrings.Length (mask) THEN
    ASSEMBLER
      TRAP    #6
      DC.W    -8      ; string overflow
    END
  ELSE
    MagicStrings.Assign (mask,d);
    (* Strings.Upper (d); *)
    IF ~set ('D',s.day) THEN vo := set ('d', s.day) END;
    IF ~set ('M',s.month) THEN vo := set ('m', s.month) END;
    IF ~set ('Y',s.year) THEN vo := set ('y', s.year) END;
    monset ('U',-1);
    monset ('G',0);
    monset ('F',1);
    monset ('E',2);
  END
END DateToText;

CONST dayHigh = 11;

TYPE DayStr= ARRAY [0..dayHigh] OF CHAR;

PROCEDURE daystr (lang: INTEGER; wday: tWeekday): DayStr;
          (* lang: 0: Deutsch, 1:Frz., 2:Engl *)
  (*$L-*)
  BEGIN
    ASSEMBLER
        MOVE    -(A3),D0    ; wday nach d0
        MOVE    -(A3),D1    ; lang nach d1
        MOVE.L  A3,A0
        ADDA.W  #dayHigh+1,A3   ; Platz auf Stack fr String
        BEQ     tger
;        BMI     tusr
        SUBQ    #2,D1
        BCS     tfrz

        LEA     eng(PC),A1
        BRA     cont
      tfrz:
        LEA     frz(PC),A1
        BRA     cont
      tger:
        LEA     ger(PC),A1
        BRA     cont

      lup:
        TST.B   (A1)+
        BNE     lup
      cont:
        DBRA    D0,lup
      lup2:
        MOVE.B  (A1)+,(A0)+
        BNE     lup2
        RTS

      ger:
        ACZ     'Montag'
        ACZ     'Dienstag'
        ACZ     'Mittwoch'
        ACZ     'Donnerstag'
        ACZ     'Freitag'
        ACZ     'Samstag'
        ACZ     'Sonntag'
        
      frz:
        ACZ     'Lundi'
        ACZ     'Mardi'
        ACZ     'Mercredi'
        ACZ     'Jeudi'
        ACZ     'Vrendredi'
        ACZ     'Samedi'
        ACZ     'Dimanche'
        
      eng:
        ACZ     'Monday'
        ACZ     'Tuesday'
        ACZ     'Wednesday'
        ACZ     'Thursday'
        ACZ     'Friday'
        ACZ     'Saturday'
        ACZ     'Sunday'
        SYNC
    END
  END daystr;
  (*$L=*)

PROCEDURE DayToText ( s: Date; REF m0: ARRAY OF CHAR; VAR d: ARRAY OF CHAR );

  VAR mask: String;
      wd  : tWeekday;
      set : BOOLEAN;

  PROCEDURE Del (a,b:INTEGER);
    BEGIN
      MagicStrings.Delete (d,a,b);
      MagicStrings.Delete (mask,a,b)
    END Del;

  PROCEDURE dayset (ch:CHAR; v: INTEGER): BOOLEAN;
    VAR p,l,n:CARDINAL; ps: POINTER TO String; s2: DayStr;
    BEGIN
      IF Strings.Pos (ch,d,0)>=0 THEN
        p:= Strings.Pos (ch,d,0);
        n:=1;
        WHILE Strings.Chr (d,p+n) = ch DO
          INC (n)
        END;
        s2:= daystr(v, wd);
        l:= Strings.Length (s2);
        IF l >= n THEN
          (* Feld wird vollst. gefllt; den String linksbndig kopieren: *)
          l:=n;
        ELSE
          (* Feld ist zu gro; krzen: *)
          Del (p,n-l)
        END;
        ps:= ADR (d)+LONG(p);
        Repl (s2,0,l,ps^);
        RETURN TRUE;
      END;
      RETURN FALSE;
    END dayset;

BEGIN
  IF m0[0]=0C THEN
    MagicStrings.Assign ('GGGGGGGGGGG',mask)
  ELSE
    MagicStrings.Assign (m0,mask)
  END;
  IF HIGH (d)+1 < MagicStrings.Length (mask) THEN
    ASSEMBLER
      TRAP    #6
      DC.W    -8      ; string overflow
    END
  ELSE
    MagicStrings.Assign (mask,d);
    Strings.Upper (d);
    wd := WeekDay (s);
    set := dayset ('G',0) OR dayset ('F',1) OR dayset ('E',2);
  END
END DayToText;

(* FuzzyTime *)
CONST   L_DEUTSCH   = 0;
        L_ENGLISH   = 1;

TYPE    langString = ARRAY [0..13] OF CHAR;
        hourString = ARRAY [0..7] OF CHAR;

TYPE    MINUTES    = RECORD
                       lang_min    : langString;
                       lang_halb   : langString;
                       offset      : INTEGER;
                     END;
        MinuteArray = ARRAY [0..11] OF MINUTES;
        
        HourArray   = ARRAY [0..11] OF hourString;

CONST   minutenDeutsch  = MinuteArray {
                            MINUTES{ "", "",0 },
                            MINUTES{ "Fnf nach","",0 },
                            MINUTES{ "Zehn nach","",0 },
                            MINUTES{ "Viertel nach","",0 },
                            MINUTES{ "Zwanzig nach","",0 },
                            MINUTES{ "Fnf vor","halb ",1 },
                            MINUTES{ "","Halb ",1 },
                            MINUTES{ "Fnf nach","halb ",1 },
                            MINUTES{ "Zwanzig vor","",1 },
                            MINUTES{ "Viertel vor","",1 },
                            MINUTES{ "Zehn vor","",1 },
                            MINUTES{ "Fnf vor","",1 }
                          };
        minutenEnglish  = MinuteArray {
                            MINUTES{ "","",0 },
                            MINUTES{ "five past","",0 },
                            MINUTES{ "ten past","",0 },
                            MINUTES{ "a quarter","past ",0 },
                            MINUTES{ "twenty past","",0 },
                            MINUTES{ "twenty-five","past ",0 },
                            MINUTES{ "half past","",0 },
                            MINUTES{ "twenty-five","to ",1 },
                            MINUTES{ "twenty to","",1 },
                            MINUTES{ "a quarter","to ",1 },
                            MINUTES{ "ten to","",1 },
                            MINUTES{ "five to","",1 }
                          };

        stundenDeutsch  = HourArray {"Zwlf", "Eins", "Zwei", "Drei", "Vier", "Fnf",
                                     "Sechs", "Sieben", "Acht", "Neun", "Zehn", "Elf"};

        stundenEnglish  = HourArray {"twelve", "one", "two", "three", "four", "five",
                                     "six", "seven", "eight", "nine", "ten", "eleven"};

(*************************************************************************
**
*A  fuzzytime ( ftime ) . . . . . . . . . . . . . . . . .  FuzzyTime lesen
*)

PROCEDURE FuzzyTime (uhrzeit: Time; REF mask: ARRAY OF CHAR; VAR ftime: ARRAY OF CHAR);
VAR tmp : ARRAY [0..79] OF CHAR;
    minuten: MinuteArray;
    stunden: HourArray;
    eins   : hourString;
    uhr    : langString;
    std    : INTEGER;
    min    : INTEGER;
    lang   : INTEGER;
BEGIN
    IF CAP (mask[0]) = 'E'
    THEN
      lang := L_ENGLISH
    ELSE
      lang := L_DEUTSCH
    END;
    CASE lang OF
        L_DEUTSCH   : 
            minuten := minutenDeutsch;
            stunden := stundenDeutsch;
            eins := "Ein";
            uhr := " Uhr"; |
        L_ENGLISH:
            minuten := minutenEnglish;
            stunden := stundenEnglish;
            eins := "one";
            uhr := " O'Clock";
    ELSE
    END;
    CASE uhrzeit.minute OF
        2:  min := 1; |
        28: min := 5; |
        32: min := 7; |        
        58: min := 11; |
    ELSE
      min := ( ( uhrzeit.minute + 2 ) MOD 60 ) DIV 5;
    END;
    std := uhrzeit.hour;
    IF uhrzeit.minute > 57
    THEN
      INC (std, 1)
    ELSE
      INC (std, minuten[min].offset);
    END;
    std := std MOD 12;
    
    IF min = 0
    THEN
      IF std=1 
      THEN
        MagicStrings.Assign (eins, tmp)
      ELSE
        MagicStrings.Assign (stunden[std], tmp);
      END;
      MagicStrings.Append (uhr, tmp);
      IF lang = L_DEUTSCH 
      THEN
        tmp[0] := CAP(tmp[0]);
      END;
    ELSE
      MagicStrings.Assign (minuten[min].lang_halb, tmp);
      MagicStrings.Append (stunden[std], tmp);
    END;
    MagicStrings.Assign (minuten[min].lang_min, ftime);
    IF lang = L_DEUTSCH
    THEN
      CASE uhrzeit.minute OF
        27, 28,
        57, 58: MagicStrings.Assign ("Kurz vor", ftime); |
        2, 3,
        32, 33: MagicStrings.Assign ("Kurz nach", ftime); 
      END;
    END;
    IF LENGTH (ftime) > 0 THEN
      MagicStrings.Append (" ", ftime);
    END;
    MagicStrings.Append (tmp, ftime);
END FuzzyTime;


(* FuzzyDate-Routinen *)
 
(* Die Routine liefert fr alle Daten, die innerhalb der letzten Woche liegen,
 * entweder den Wochentag oder heute/gestern/vorgestern zurck.
 * Zustzlich wird auch noch festgestellt, ob es morgens, mittags, nachmittags,
 * abends oder nachts ist.
 *)

PROCEDURE FuzzyDate (dt: Date; ti: Time; REF mask: ARRAY OF CHAR; VAR str: ARRAY OF CHAR);
  VAR today:        Date;
      dateLong:     LONGINT;
      todayLong:    LONGINT;
      dateDiff:     LONGINT;
      wd:           tWeekday;
      appendS:      BOOLEAN;
BEGIN
  appendS := FALSE;
  (* Wochentag bestimmen *)
  wd := WeekDay (dt);
  dateLong := Date2Days (dt);
  GetCurrentDate (today);
  todayLong := Date2Days (today);
  dateDiff := todayLong - dateLong;
  IF dateDiff < 0
  THEN
    (* In der Zukunft, das mag die Routine nicht so *)
    MagicStrings.Assign ("in der Zukunft ", str);
  END;
  CASE dateDiff OF
    0: MagicStrings.Assign ("heute ", str); |
    1: MagicStrings.Assign ("gestern ", str); |
    2: MagicStrings.Assign ("vorgestern ", str); |
  ELSE
    IF dateDiff <= 7
    THEN
      MagicStrings.Assign ("letzten ", str);
      MagicStrings.Append (daystr (0, wd), str);
    ELSE
      MagicStrings.Assign ("in grauer Vorzeit ", str);
      appendS := TRUE;
    END;
  END;
  (* Nun noch den Tageszusatz betimmen *)
  IF (ti.hour >= 7) & (ti.hour < 12)
  THEN
    (* morgens *)
    MagicStrings.Append ("morgen", str);
  ELSIF (ti.hour >= 12) & (ti.hour < 14)
  THEN 
    (* mittags *)
    MagicStrings.Append ("mittag", str);
  ELSIF (ti.hour >= 14) & (ti.hour < 18)
  THEN 
    (* nachmittags *)
    MagicStrings.Append ("nachmittag", str);
  ELSIF (ti.hour >= 18) & (ti.hour < 23)
  THEN 
    (* abends *)
    MagicStrings.Append ("abend", str);
  ELSIF (ti.hour >= 23) OR (ti.hour < 7)
  THEN 
    (* nachts *)
    MagicStrings.Append ("nacht", str);
  END;
  IF appendS 
  THEN
    MagicStrings.Append ("s", str);
  END;
END FuzzyDate;

(* Erzeugt die Datumszeile *)
PROCEDURE MakeFreeDate (cDt, cTi: CARDINAL;
                        VAR str: ARRAY OF CHAR);
VAR
      dt    : Date;
      ti    : Time;
      tmp   : ARRAY [0..11] OF CHAR;
      voidO : BOOLEAN;
BEGIN
  dt := UnpackDate (cDt);
  ti := UnpackTime (cTi);
  DateToText (dt, 'YYYYMMDD', str);
  TimeToText (ti, 'HHMM', tmp);
  Strings.Append (tmp, str, voidO);
END MakeFreeDate;

PROCEDURE MakeDate(VAR str : ARRAY OF CHAR); 
  VAR z1, z2    : CARDINAL;
BEGIN
  z1 := MagicDOS.Tgetdate();
  z2 := MagicDOS.Tgettime();
  MakeFreeDate (z1, z2, str);
END MakeDate;

(* Nur fr Test:

VAR str : ARRAY [0..40] OF CHAR;
    d   : Date;
    voidO : BOOLEAN;

BEGIN
  WriteString ('aktuelles Datum: ');
  GetCurrentDate (d);
  WriteInt (d.day,0); Write ('.');
  WriteInt (d.month,0); Write ('.');
  WriteInt (d.year,0); WriteLn;
  WriteLn;
  REPEAT
    WriteString ('Bitte geben Sie ein Datum ein: ');
    ReadString (str);
    WriteLn;
    IF str[0] # 0C
    THEN
      TextToDate (str, d, voidO);
      WriteLn;
      WriteString ('Tag  : '); WriteInt (d.day,0); WriteLn;
      WriteString ('Monat: '); WriteInt (d.month,0); WriteLn;
      WriteString ('Jahr : '); WriteInt (d.year,0); WriteLn;
      WriteLn;
      WriteString ('CAT-Format : ');
      WriteInt (StrToDate(str), 10);
      WriteLn;
      WriteString ('Feiertag: ');
      IF Holiday (d) THEN WriteString ('Ja!'); ELSE WriteString ('Nein'); END;
      WriteLn;
      WriteString ('Wochentag: (0=Montag)'); WriteInt (INTEGER(WeekDay (d)),0); WriteLn;
      WriteString ('Karfreitag ist dieses Jahr:'); 
      WriteLn;
      KarFreitag (d.year, d);
      WriteString ('Tag  : '); WriteInt (d.day,0); WriteLn;
      WriteString ('Monat: '); WriteInt (d.month,0); WriteLn;
      WriteString ('Jahr : '); WriteInt (d.year,0); WriteLn;
      WriteLn;
      WriteString ('Bu- und Bettag ist dieses Jahr:'); 
      WriteLn;
      BussBet (d.year, d);
      WriteString ('Tag  : '); WriteInt (d.day,0); WriteLn;
      WriteString ('Monat: '); WriteInt (d.month,0); WriteLn;
      WriteString ('Jahr : '); WriteInt (d.year,0); WriteLn;
      WriteLn;
    END;
  UNTIL str[0] = 0C;
  
  *)
END ConvertDate.
