DEFINITION MODULE DialSlider;

FROM mtUtils    IMPORT tRect;

TYPE SLIDER;

PROCEDURE DrawSlider (sl : SLIDER; r : tRect; clip : BOOLEAN);
(* Zeichnet den Slider sl im Rechtecht r (oder ganz, 
 * wenn clip FALSE ist)
 *)

PROCEDURE CreateSlider (VAR sl : SLIDER; hori : BOOLEAN; accel : INTEGER;
                        slSize : INTEGER; slScale, slPos : LONGINT): BOOLEAN;
(* Erzeugt einen neuen Slider. hori gibt an, ob es sich um einen 
 * horizontalen Slider handelt, und accel gibt die Zeilenzahl beim
 * scrollen an (normalerweise 1)
 *)

PROCEDURE FreeSlider (sl : SLIDER);
(* Gibt einen Slider wieder frei. Danach darf nicht mehr
 * darauf zugegriffen werden
 *)

PROCEDURE SetSliderSize (sl : SLIDER; size : INTEGER);
(* Setzt die Gre des Sliders  
 *)

PROCEDURE SetSliderScale (sl : SLIDER; scale : LONGINT); 
(* Setzt die Skalierung fr den Slider (Anzahl Elemente)
 *)

PROCEDURE SetSliderPos (sl : SLIDER; pos : LONGINT; draw: BOOLEAN);
(* Setzt die aktuelle Position des Sliders
 *)

PROCEDURE SliderExtents (sl : SLIDER; x, y : INTEGER; len : INTEGER; draw: BOOLEAN);
(* Plaziert den Slider an die richtige Stelle
 * Sollte direkt nach dem Erzeugen aufgerufen werden 
 *)

TYPE updateProc = PROCEDURE ((* sl : *) SLIDER, (* pos: *) LONGINT);
                            
PROCEDURE SliderClick (sl : SLIDER; x, y : INTEGER; clicks : INTEGER; update : updateProc): LONGINT; 
(* In: Mauskoordinate. Out: Neue Position. Bei einem Mausklick
 * auerhalb des Sliders wird -1 zurckgegeben
 * Falls sich die Koordinate gendert hat, wird auerdem vorher noch 
 * die UpdateProc update aufgerufen mit dem neuen Wert. 
 * Auerdem wird beim Scrolling auch die 
 * Updateproc stndig aufgerufen, falls sich der Wert ndert.
 *)

END DialSlider.