IMPLEMENTATION MODULE DialSlider;

FROM SYSTEM     IMPORT ADR, ADDRESS, CADR, TSIZE, CALLSYS;
FROM Storage    IMPORT ALLOCATE, DEALLOCATE;

FROM mtUtils    IMPORT tRect;
FROM mtAppl     IMPORT CharWidth, CharHeight;

IMPORT MagicAES, mtAppl, mtRsc, mtUtils, ListUtils, BinOps;

(*----------------------------------------------------------------------*
 *        Resource-Coder 1.03  (C)92 by Peter Hellinger Software        *
 *----------------------------------------------------------------------*
 *           Inline-Resource erzeugt am 12.10.1992 14:21:20             *
 *----------------------------------------------------------------------*)
 
TYPE tRscData = ARRAY [0..142] OF CARDINAL;
 
CONST RscData = tRscData {
        00000H, 0002CH, 0011CH, 0011CH, 0011CH, 0011CH, 0011CH, 0011CH, 0011CH, 
        00024H, 0000AH, 00002H, 00000H, 00000H, 00000H, 00000H, 00000H, 0011CH, 
        00000H, 0002CH, 00000H, 000A4H, 0FFFFH, 00001H, 00003H, 00014H, 00000H, 
        00000H, 000FFH, 01100H, 00000H, 00000H, 00002H, 0000CH, 00002H, 0FFFFH, 
        0FFFFH, 0001BH, 00000H, 00000H, 001FFH, 01100H, 00000H, 00000H, 00002H, 
        00001H, 00003H, 0FFFFH, 0FFFFH, 0001BH, 00000H, 00000H, 002FFH, 01100H, 
        00000H, 0000BH, 00002H, 00001H, 00000H, 00004H, 00004H, 00014H, 00040H, 
        00000H, 000FFH, 01111H, 00000H, 00001H, 00002H, 0000AH, 00003H, 0FFFFH, 
        0FFFFH, 00014H, 00060H, 00000H, 000FFH, 01100H, 00000H, 00000H, 00002H, 
        00002H, 0FFFFH, 00001H, 00003H, 00014H, 00000H, 00000H, 000FFH, 01100H, 
        00000H, 00000H, 00012H, 00001H, 00002H, 0FFFFH, 0FFFFH, 0001BH, 00040H, 
        00000H, 004FFH, 01100H, 00000H, 00000H, 00002H, 00001H, 00003H, 0FFFFH, 
        0FFFFH, 0001BH, 00040H, 00000H, 003FFH, 01100H, 00010H, 00000H, 00002H, 
        00001H, 00000H, 00004H, 00004H, 00014H, 00040H, 00000H, 000FFH, 01111H, 
        00002H, 00000H, 0000EH, 00001H, 00003H, 0FFFFH, 0FFFFH, 00014H, 00060H, 
        00000H, 000FFH, 01100H, 00000H, 00000H, 00006H, 00001H, 00000H
        }; (* Ende RscData *)
CONST

    Form1    =   0;    (* Formular/Dialog *)
    Gup      =   1;    (* BUTTON in Baum FORM1 *)
    Gdown    =   2;    (* BUTTON in Baum FORM1 *)
    Gvbar    =   3;    (* BOX in Baum FORM1 *)
    Gvslid   =   4;    (* BOX in Baum FORM1 *)

    Form2    =   1;    (* Formular/Dialog *)
    Gleft    =   1;    (* BOXCHAR in Baum FORM2 *)
    Gright   =   2;    (* BOXCHAR in Baum FORM2 *)
    Ghbar    =   3;    (* BOX in Baum FORM2 *)
    Ghslid   =   4;    (* BOX in Baum FORM2 *)
    
    parent   =   3;
    slider   =   4;
(*----------------------------------------------------------------------*)

TYPE SLIDER = POINTER TO SLIDSPEC;

     SliderTree = ARRAY [0..4] OF MagicAES.OBJECT;

     SLIDSPEC   = RECORD
                    hori        : BOOLEAN;
                    accel       : INTEGER;
                    scale       : LONGINT;
                    position    : LONGINT;
                    size        : INTEGER;
                    step        : INTEGER;
                    ob          : SliderTree;
                    drawn       : BOOLEAN;
                  END;

VAR 
        vertSlidTree,
        horiSlidTree    : POINTER TO SliderTree;
        deskSize        : tRect;

PROCEDURE calcSlider (sl : SLIDER; pos: LONGINT);
  VAR sFrame, 
      pFrame : tRect;
BEGIN
  WITH sl^ DO 
    (* calculate slider size *)
    mtUtils.ObjcRect (ADR(ob), 4, sFrame);
    mtUtils.ObjcRect (ADR(ob), 3, pFrame);
    IF hori
    THEN
      IF scale > LONG(size) THEN
        sFrame.w := pFrame.w;
        sFrame.w := SHORT((((LONG(size)*100) DIV scale) * LONG(pFrame.w)) DIV 100);
        IF sFrame.w > pFrame.w THEN sFrame.w := pFrame.w END;
        IF sFrame.w < CharWidth * 2
        THEN sFrame.w := CharWidth * 2 END;
      ELSE
        sFrame.w := pFrame.w;
      END;
      sFrame.x := 0;
      mtUtils.SetObjcRect (ADR(ob), 4, sFrame);
      IF scale > LONG(size) THEN
        step := ((100*(pFrame.w-sFrame.w)) DIV SHORT(scale-LONG(size))+50 ) DIV 100;
      ELSE
        step := 0;
      END;
    ELSE
      IF scale > LONG(size) THEN
        sFrame.h := pFrame.h;
        sFrame.h := SHORT((((LONG(size)*100) DIV scale) * LONG(pFrame.h)) DIV 100);
        IF sFrame.h > pFrame.h THEN sFrame.h := pFrame.h END;
        IF sFrame.h < CharHeight 
        THEN sFrame.h := CharHeight END;
      ELSE
        sFrame.h := pFrame.h;
      END;
      sFrame.y := 0;
      mtUtils.SetObjcRect (ADR(ob), 4, sFrame);
      IF scale > LONG(size) THEN
        step := ((100*(pFrame.h-sFrame.h)) DIV SHORT(scale-LONG(size))+50 ) DIV 100;
      ELSE
        step := 0;
      END;
    END;
    position := pos;
  END;
END calcSlider;

PROCEDURE DrawSlider (sl : SLIDER; r : tRect; clip : BOOLEAN);
(* Zeichnet den Slider sl im Rechtecht r (oder ganz, 
 * wenn clip FALSE ist)
 *)
BEGIN
  IF sl # NIL THEN
    IF clip 
    THEN
      IF (r.w > 0) & (r.h > 0)
      THEN
        MagicAES.ObjcDraw (ADR(sl^.ob), 0, 8, r);
      END;
    ELSE
      MagicAES.ObjcDraw (ADR(sl^.ob), 0, 8, deskSize);
    END;
    sl^.drawn := TRUE;
  END;
END DrawSlider; 

PROCEDURE CreateSlider (VAR sl : SLIDER; hor : BOOLEAN; acc : INTEGER; 
                        slSize : INTEGER; slScale, slPos : LONGINT): BOOLEAN;
(* Erzeugt einen neuen Slider. hori gibt an, ob es sich um einen 
 * horizontalen Slider handelt, und accel gibt die Zeilenzahl beim
 * scrollen an (normalerweise 1)
 *)
   VAR i : INTEGER;
       wincol : ARRAY [0..3] OF INTEGER;
BEGIN
  NEW (sl);
  IF sl = NIL THEN RETURN FALSE END;
  WITH sl^ DO
    hori := hor;
    accel := acc;
    scale := slScale;
    position := slPos;
    size     := slSize;
    step     := 0;
    drawn    := FALSE;
    IF hori THEN
      ob := horiSlidTree^;
    ELSE
      ob := vertSlidTree^
    END;
    FOR i := 0 TO 4 DO 
      MagicAES.RsrcObfix (ADR (ob), i);
    END;
    (*
    (* Jetzt noch die Farben der AES-Slider setzen *)
    IF MagicAES.AESGlobal.apVersion >= $0320
    THEN
      (* Farben abfragen und setzen *)
      IF hori
      THEN
        wincol[0] := MagicAES.WLFARROW;
        MagicAES.WindGet (0, MagicAES.WFDCOLOR, wincol);
        ob[1].obSpec.Box.flags := BITSET(wincol[1]);
        wincol[0] := MagicAES.WRTARROW;
        MagicAES.WindGet (0, MagicAES.WFDCOLOR, wincol);
        ob[2].obSpec.Box.flags := BITSET(wincol[1]);
        wincol[0] := MagicAES.WHSLIDE;
        MagicAES.WindGet (0, MagicAES.WFDCOLOR, wincol);
        ob[3].obSpec.Box.flags := BITSET(wincol[1]);
        wincol[0] := MagicAES.WHELEV;
        MagicAES.WindGet (0, MagicAES.WFDCOLOR, wincol);
        ob[4].obSpec.Box.flags := BITSET(wincol[1]);
      ELSE
        wincol[0] := MagicAES.WUPARROW;
        MagicAES.WindGet (0, MagicAES.WFDCOLOR, wincol);
        ob[1].obSpec.Box.flags := BITSET(wincol[1]);
        wincol[0] := MagicAES.WDNARROW;
        MagicAES.WindGet (0, MagicAES.WFDCOLOR, wincol);
        ob[2].obSpec.Box.flags := BITSET(wincol[1]);
        wincol[0] := MagicAES.WVSLIDE;
        MagicAES.WindGet (0, MagicAES.WFDCOLOR, wincol);
        ob[3].obSpec.Box.flags := BITSET(wincol[1]);
        wincol[0] := MagicAES.WVELEV;
        MagicAES.WindGet (0, MagicAES.WFDCOLOR, wincol);
        ob[4].obSpec.Box.flags := BITSET(wincol[1]);
      END;
    END;
    *)
  END;
  RETURN TRUE;
END CreateSlider;

PROCEDURE FreeSlider (sl : SLIDER);
(* Gibt einen Slider wieder frei. Danach darf nicht mehr
 * darauf zugegriffen werden
 *)
BEGIN
  IF sl # NIL
  THEN
    DISPOSE (sl);
  END;
END FreeSlider;

PROCEDURE SetSliderSize (sl : SLIDER; size : INTEGER);
(* Setzt die Gre des Sliders (Anzahl der angezeigten Eintrge)
 *)
BEGIN
  IF (sl # NIL) & (sl^.size # size)
  THEN 
    sl^.size := size;
    calcSlider (sl, 0);
  END;
END SetSliderSize;

PROCEDURE SetSliderScale (sl : SLIDER; scale : LONGINT); 
(* Setzt die Skalierung fr den Slider (Anzahl Elemente)
 *)
BEGIN
  IF (sl # NIL) & (sl^.scale # scale)
  THEN
    sl^.scale := scale;
    calcSlider (sl, 0);
  END;
END SetSliderScale;

PROCEDURE SetSliderPos (sl : SLIDER; pos : LONGINT; draw: BOOLEAN);
(* Setzt die aktuelle Position des Sliders
 *)
  VAR scale : LONGINT;
BEGIN
  IF (sl # NIL) & (sl^.position # pos)
  THEN
    scale := sl^.scale - LONG(sl^.size);
    sl^.position := pos;
    IF sl^.hori
    THEN
      ListUtils.formSetSlider (ADR(sl^.ob), 3, 4, 0, 
                               scale, sl^.position, sl^.drawn & draw);
    ELSE
      ListUtils.formSetSlider (ADR(sl^.ob), 3, 4, 1, 
                               scale, sl^.position, sl^.drawn & draw);
    END
  END;
END SetSliderPos;

PROCEDURE SliderExtents (sl : SLIDER; x, y : INTEGER; len : INTEGER; draw: BOOLEAN);
(* Plaziert den Slider an die richtige Stelle
 * Sollte direkt nach dem Erzeugen aufgerufen werden 
 *)
   VAR scl : LONGINT;
       l2  : INTEGER;
BEGIN
  IF sl # NIL
  THEN
    WITH sl^ DO
      (* Anpassung an 1 Pixel Rahmen der Slider-Objekte *)
      INC (x);
      INC (y);
      DEC (len, 2);
      (* Jetzt testen, ob sich was gendert hat *)
      IF hori THEN 
        l2 := ob[0].obWidth
      ELSE 
        l2 := ob[0].obHeight
      END;
      IF (x = ob[0].obX) & (y = ob[0].obY) & (len = l2) THEN RETURN END;
      (* Basisobjekt *)
      ob[0].obX := x;
      ob[0].obY := y;
      IF hori THEN
        ob[0].obWidth := len;
        ob[0].obHeight := CharHeight;
      ELSE
        ob[0].obHeight := len;
        ob[0].obWidth := CharWidth*2;
      END;
      (* Erster Arrow *)
      ob[1].obX := 0;
      ob[1].obY := 0;
      ob[1].obWidth := CharWidth*2;
      ob[1].obHeight := CharHeight;
      (* Zweiter Arrow *)
      ob[2].obWidth := CharWidth*2;
      ob[2].obHeight := CharHeight;
      IF hori THEN
        ob[2].obX := len - CharWidth*2;
        ob[2].obY := 0;
        (*
        ob[2].obX := (len DIV CharWidth) - 4;
        ob[2].obY := 0;
        *)
      ELSE
        (*
        ob[2].obX := 0;
        ob[2].obY := (len DIV CharHeight) - 2;
        *)
        ob[2].obX := 0;
        ob[2].obY := len - CharHeight;
      END;
      (* Slidebar *)
      IF hori THEN
        ob[3].obX := CharWidth*2;
        ob[3].obY := 0;
        ob[3].obHeight := CharHeight;
        ob[3].obWidth  := len - CharWidth*4;
        (*
        ob[3].obX := x+CharWidth*2;
        ob[3].obY := y;
        ob[3].obHeight := CharHeight;
        ob[3].obWidth  := len - CharWidth*4;
        *)
      ELSE
        ob[3].obX := 0;
        ob[3].obY := CharHeight;
        ob[3].obHeight := len - CharHeight*2;
        ob[3].obWidth  := CharWidth*2;
        (*
        ob[3].obWidth  := CharWidth*2;
        *)
        (*
        ob[3].obX := x;
        ob[3].obY := y+CharHeight;
        ob[3].obHeight := len - CharHeight*2;
        ob[3].obWidth  := CharWidth*2;
        *)
      END;
      
      (* Slider *)
      IF hori THEN
        ob[4].obX := 0;
        ob[4].obY := 0;
        ob[4].obHeight := CharHeight;
        ob[4].obWidth  := len - CharWidth*4;
      ELSE
        ob[4].obX := 0;
        ob[4].obY := 0;
        ob[4].obHeight := len - CharHeight*2;
        ob[4].obWidth  := CharWidth*2;
      END;
      calcSlider(sl, position);
      scl := scale - LONG(size);
      IF hori
      THEN
        ListUtils.formSetSlider (ADR(ob), 3, 4, 0, 
                                 scl, position, drawn & draw);
      ELSE
        ListUtils.formSetSlider (ADR(ob), 3, 4, 1, 
                                 scl, position, drawn & draw);
      END;
    END;
  END; (* IF sl # NIL *)
END SliderExtents;

PROCEDURE formSlider (sl : SLIDER; update : updateProc);
    VAR newPos  : INTEGER;
        newVal  : LONGINT;

        pAbsFrame,
        sAbsFrame,
        oldsFrame,
        pFrame,
        sFrame,
        xFrame  : tRect;

        xOff,
        yOff    : INTEGER;
        X, Y, W, H    : INTEGER;
        mrect   : tRect;
        mess : ADDRESS;
        evnt : BITSET;
        button,
        kstate  : BITSET;
        ch      : CHAR;
        faktor  : INTEGER;
        oldStart : LONGINT;
        dial    : ADDRESS;
        Epp     : LONGINT;
        
  BEGIN
    dial := ADR(sl^.ob);
    mtUtils.ObjcArea (dial, parent, pAbsFrame);
    mtUtils.ObjcArea (dial, slider, sAbsFrame);
    ListUtils.CalcAbsArea (dial, slider, xFrame);

    mtUtils.ObjcRect (dial, parent, pFrame);
    mtUtils.ObjcRect (dial, slider, sFrame);
    oldsFrame := sFrame;
    
    mtAppl.MouseHand();
    oldStart := sl^.position;
    newVal := oldStart;
    MagicAES.GrafMkstate (X, Y, button, kstate);
    xOff := X - sAbsFrame.x-1;
    yOff := Y - sAbsFrame.y-1;
    LOOP
      (* ersetzt durch evnt-Multi  *)
      MagicAES.GrafMkstate (X, Y, button, kstate);
(*    
      WITH mrect DO
        x := X;
        y := Y;
        w := 1;
        h := 1;
      END;
      evnt := MagicAES.EvntMulti ({MagicAES.MUBUTTON, MagicAES.MUM1},
                                  1,{0},{}, MagicAES.LeaveRect, mrect, 0, mrect, mess, 0, 0,
                                  X, Y, button, faktor, kstate, faktor, ch, faktor);
      IF MagicAES.MUBUTTON IN evnt
      THEN
        IF ~(0 IN button) THEN EXIT END;
      END;
*)
      IF ~(0 IN button) THEN EXIT END;

      WITH sl^ DO
        IF ~hori
        THEN
          IF pAbsFrame.h <= sAbsFrame.h 
          THEN
            newVal := 0
          ELSE
          (*
            Epp := ((scale-LONG(size)) * 1000L) DIV LONG(pFrame.h - sFrame.h);
            newVal := ((LONG(Y - yOff - pAbsFrame.y) * Epp) DIV 1000L);
          *)
            newVal := (LONG(Y - yOff - pAbsFrame.y) * (scale-LONG(size))*1000L) DIV (LONG(pAbsFrame.h - sAbsFrame.h) * 1000L);
            newVal := BinOps.LowerLInt (newVal, scale - LONG(size) );
            newVal := BinOps.HigherLInt (newVal, 0);
          END;
          IF sl^.accel > 0 
          THEN
            newVal := (newVal DIV LONG(sl^.accel)) * LONG(sl^.accel);
          END;
        ELSE
          IF pFrame.w <= sFrame.w
          THEN
            newVal := 0;
          ELSE
            newVal := (LONG(X - xOff - pAbsFrame.x) * (scale-LONG(size))*1000L) DIV (LONG(pAbsFrame.w - sAbsFrame.w) * 1000L);
            newVal := BinOps.LowerLInt (newVal, scale - LONG(size));
            newVal := BinOps.HigherLInt (newVal, 0);
          END;
          IF sl^.accel > 0 
          THEN
            newVal := (newVal DIV LONG(sl^.accel)) * LONG(sl^.accel);
          END;
        END;
      END;
      
      (* Slider neu zeichnen und Liste updaten *)
      IF newVal # oldStart THEN 
        update (sl, newVal); 
        oldStart := newVal;
        SetSliderPos (sl, newVal, TRUE);
      END;

    END; (* LOOP *)
    mtAppl.MouseArrow();
    sl^.position := newVal;
  END formSlider;

PROCEDURE SelectButton (adr: ADDRESS; objc: INTEGER; doSel: BOOLEAN);
  VAR r : mtUtils.tRect;
BEGIN
  mtUtils.SetState (adr, objc, MagicAES.SELECTED, doSel);
  mtUtils.CalcArea (adr, objc, r);
  MagicAES.ObjcDraw (adr, 0, 2, r);
END SelectButton;

PROCEDURE SliderClick (sl : SLIDER; x, y : INTEGER; clicks : INTEGER; update: updateProc) : LONGINT; 
(* In: Mauskoordinate. Out: Neue Position. Bei einem Mausklick
 * auerhalb des Sliders wird -1 zurckgegeben
 *)
 VAR objc : INTEGER;
     kstate,
     buts : BITSET;
     r    : tRect;
     newPos,
     oldPos: LONGINT;
BEGIN
  IF (sl # NIL) OR (clicks = 0)
  THEN
    WITH sl^ DO
      objc := MagicAES.ObjcFind (ADR(ob), 0, 8, x, y);
      IF objc > 0 
      THEN
        (* Klick behandeln *)
        CASE objc OF
          1 : (* Up- bzw. Leftarrow *) 
              SelectButton (ADR(ob), objc, TRUE);
              oldPos := position;
              newPos := position;
              IF clicks > 1 THEN newPos:= 0 END;
              REPEAT
                DEC (newPos, accel);
                IF newPos < 0 THEN newPos := 0 END;
                IF newPos # oldPos
                THEN
                  update (sl, newPos);
                  SetSliderPos (sl, newPos, TRUE);
                END;
                oldPos := newPos;
                MagicAES.GrafMkstate (x, y, buts, kstate);
              UNTIL ~(0 IN buts);
              SelectButton (ADR(ob), objc, FALSE);
              |
          2 : (* Down- bzw. Rightarrow *) 
              SelectButton (ADR(ob), objc, TRUE);
              oldPos := position;
              newPos := position;
              IF clicks > 1 THEN newPos := scale - LONG(size) END;
              REPEAT 
                INC (newPos, accel);
                IF newPos > scale - LONG(size) THEN newPos := scale - LONG(size) END;
                IF newPos # oldPos
                THEN
                  update (sl, newPos);
                  SetSliderPos (sl, newPos, TRUE);
                END;
                oldPos := newPos;
                MagicAES.GrafMkstate (x, y, buts, kstate);
              UNTIL ~(0 IN buts);
              SelectButton (ADR(ob), objc, FALSE);
              |
          3 : (* Slidebar *)
              mtUtils.CalcArea (ADR(ob), 4, r);
              oldPos := position;
              newPos := position;
              IF (hori & (x < r.x)) OR (~hori & (y < r.y))
              THEN
                REPEAT 
                  (* Page Up/Right *)
                  DEC (newPos, size);
                  IF newPos < 0 THEN newPos := 0 END;
                  IF newPos # oldPos
                  THEN
                    update (sl, newPos);
                    SetSliderPos (sl, newPos, TRUE);
                  END;
                  oldPos := newPos;
                  MagicAES.GrafMkstate (x, y, buts, kstate);
                UNTIL ~(0 IN buts);
              ELSE
                REPEAT 
                  (* Page Down/Left *)
                  INC (newPos, size);
                  IF newPos > scale - LONG(size)
                  THEN
                    newPos := scale - LONG(size);
                  END;
                  IF newPos # oldPos
                  THEN
                    update (sl, newPos);
                    SetSliderPos (sl, newPos, TRUE);
                  END;
                  oldPos := newPos;
                  MagicAES.GrafMkstate (x, y, buts, kstate);
                UNTIL ~(0 IN buts);
              END;
              | 
          4 : (* Slider *)
              formSlider (sl, update);
              |
        ELSE
        END;
        (*
        update (sl, position);
        *)
        RETURN position;
      ELSE
        RETURN -1
      END;
    END;
  END;
  RETURN -1;
END SliderClick;

VAR rsc : mtRsc.RESOURCE;
    data: POINTER TO tRscData;

BEGIN
  (* Modulinterne Resource laden *) 
  (* Erstmal Resource kopieren in allozierten Speicher *)
  ALLOCATE (data, TSIZE (tRscData));
  IF data = NIL THEN HALT END; (* Kein Speicher frei *)
  (* Kopieren *)
  data^ := RscData;
  (* und jetzt relozieren *)
  IF mtRsc.RelocRsc (data, rsc) THEN 
 
    vertSlidTree := mtRsc.GaddrRsc (rsc, MagicAES.RTREE, Form1);
    horiSlidTree := mtRsc.GaddrRsc (rsc, MagicAES.RTREE, Form2);
  ELSE
    HALT;       (* Relozieren der internen Ressource fehlgeschlagen, 
                 * sollte aber eigentlich nicht vorkommen
                 *)
  END;
  deskSize := tRect{mtAppl.DeskX, mtAppl.DeskY, mtAppl.MaxWidth, mtAppl.MaxHeight};
END DialSlider.