DEFINITION MODULE EditDraw;

FROM SYSTEM     IMPORT ADDRESS;
FROM GrafBase   IMPORT Rectangle;
FROM EditTypes  IMPORT EDITPTR;

CONST   
        UP      = 0;
        DOWN    = 1;
        RIGHT   = 0;
        LEFT    = 1;
        
PROCEDURE drawLine (ed : EDITPTR; screenLine : INTEGER);

PROCEDURE redrawLine (ed : EDITPTR; insChar : BOOLEAN; full : BOOLEAN);

PROCEDURE GetBlockRects (VAR ed: EDITPTR; VAR blockRects: ARRAY OF Rectangle;
                         VAR count: INTEGER;
                         oldLine : LONGINT; oldRow : INTEGER; 
                         newLine : LONGINT; newRow : INTEGER);

PROCEDURE MarkArea (VAR ed : EDITPTR; oldLine : LONGINT; oldRow : INTEGER; 
                    newLine : LONGINT; newRow : INTEGER; clipIt : BOOLEAN);

        (* Vorhandener Block wird angezeigt *)
PROCEDURE ShowBlockMark (VAR ed : EDITPTR; clipIt : BOOLEAN);

        (* Alle redraw-Funktionen *)
PROCEDURE redrawWdw (wdw, vdiH : INTEGER; special : ADDRESS; frame : Rectangle);
(* Service-Routine fr Window-Library *)

PROCEDURE redrawLines (ed : EDITPTR; fromLine : INTEGER);

PROCEDURE redrawLineArea (ed : EDITPTR; fromLine, toLine : LONGINT);
(* Hier werden richtige Zeilennummern bergeben, nicht die Bildschirmzeilen *)

        (* Scroll-Funktionen *)

PROCEDURE scrollRegion (ed : EDITPTR; from, to, amount : INTEGER);

        (* Bltterfunktionen *)

PROCEDURE CenterCurrline (ed : EDITPTR);

END EditDraw.
