IMPLEMENTATION MODULE EditDraw;

FROM SYSTEM     IMPORT  ADDRESS, ADR, TSIZE, CADR, LOC, LONGWORD, WORD, CALLSYS;

(* Megamax-Lib *)

FROM GrafBase   IMPORT Rectangle, Point;

IMPORT Strings, FileNames, BinOps, Block, StrConv, MOSGlobals, Keyboard;

FROM Keyboard  IMPORT SpecialCode;

(* MagicLib *)
IMPORT MagicAES, MagicVDI, MagicDOS, MagicSys, mtAlerts, mtAppl, mtDials, mtUtils;

FROM MagicVDI   IMPORT VDIIntIn, VDIPtsIn, VDIControl;

(* CAT Module *)
FROM Void        IMPORT v;
IMPORT CatGlobal;

(* Editor  *)
FROM EditTypes  IMPORT EDITPTR, aLinePtr, aLineDesc, textPtr, aMark, deskSize, pixOff, CAT,
                       CharSet, TrennSet, theDrawLine, maxBlocks;

FROM EditGlobals        IMPORT  SetDocument, Text, InqTextextend, isQuote,
                                ClipWork, MouseIsOn, HideMouse, ShowMouse, 
                                CursorIsOn, HideCursor, ShowCursor,
                                OutputLine;
                                

FROM EditTools          IMPORT  getCharPos, SetStartLine, SetCurrLine, SetInfoLine;

IMPORT EditBase;

IMPORT WdwManager, ConfVars, Varnames, RectFuncs;

VAR                                 
    control7:       POINTER TO ADDRESS; (* it's tricky... *)
    control9:       POINTER TO ADDRESS;


PROCEDURE GetBlockRects (VAR ed: EDITPTR; VAR blockRects: ARRAY OF Rectangle;
                         VAR count: INTEGER;
                         oldLine : LONGINT; oldRow : INTEGER; 
                         newLine : LONGINT; newRow : INTEGER);
  VAR   i       : INTEGER;
        viewLine: LONGINT;
        cursOn  : BOOLEAN;
BEGIN
  WITH ed^ DO
    (* OldLine mu kleiner sein, da es als Anfang genommen wird. *)
    (* Erstmal Zeilen auf gltige Werte bringen *)
    IF oldLine < 0 THEN oldLine := 0 END;
    IF newLine < 0 THEN newLine := 0 END;
    IF newLine > totalLineNr (* - 1 *) THEN newLine := totalLineNr (* - 1 *) END;
    IF oldLine > totalLineNr (* - 1 *) THEN oldLine := totalLineNr (* - 1 *) END;
    (* Notfalls swappen! *)
    IF oldLine > newLine THEN 
      v.lint := newLine; newLine := oldLine; oldLine := v.lint; 
      v.int := newRow; newRow := oldRow; oldRow := v.int;
    ELSIF (oldLine = newLine) & (oldRow > newRow) 
    THEN 
      v.int := newRow; newRow := oldRow; oldRow := v.int;
    END;
    i := 0;
    (* Jetzt gewnschten Bereich malen *)
    IF (oldLine >= 0) & (newLine >= 0) & (newLine >= oldLine)
    THEN
      (* Block ist vorhanden *)
      IF ~(((oldLine < StartLine) & (newLine < StartLine)) OR (oldLine > StartLine + LONG(windLines)))
      THEN 
        (* Block ist zumindest teilweise im Fenster. 
         * Es werden maximal drei Rechtecke berechnet, die den Block im Fenster komplett beschreiben. 
         *)
        IF (oldLine >= StartLine)
        THEN 
          WITH blockRects[i] DO 
            getCharPos (ed, oldLine, oldRow, x, y);
            IF x <= editWork.x + pixOff THEN x := editWork.x + pixOff END;
            IF newLine = oldLine
            THEN 
              getCharPos (ed, newLine, newRow, w, h);
              DEC (w);
              INC (h, charHeight-1);
            ELSE
              w := editWork.x + editWork.w - 1;
              h := y + charHeight-1;
            END;
            INC (i);
          END (* WITH blockRects [i] *);
        END;
        (* Komplette Zeilen zwischen Start und Ende *)
        IF (newLine > oldLine + 1) 
        THEN 
          (* mindestens eine Zeile im Fenster *)
          viewLine := BinOps.HigherLInt (oldLine + 1, StartLine);
          WITH blockRects[i] DO 
            getCharPos (ed, viewLine, 0, x, y);
            viewLine := BinOps.LowerLInt (newLine - 1, StartLine + LONG(windLines));
            getCharPos (ed, viewLine, 0, v.int, h);
            INC (h, charHeight-1);
            x := editWork.x+pixOff;
            w := editWork.x + editWork.w - 1;
          END;
          INC(i);
        END;
        IF (newLine >= StartLine) & (newLine <= StartLine + LONG(windLines)) & (newLine # oldLine)
        THEN
          (* Blockende im Fenster und nicht in Startzeile *)
          WITH blockRects[i] DO 
            x := editWork.x+pixOff;
            getCharPos (ed, newLine, newRow, w, y);
            DEC (w);
            h := y + charHeight - 1;
          END;
          INC(i);
        END;
      END;
    END;
  END;
  count := i;
END GetBlockRects;

PROCEDURE MarkArea (VAR ed : EDITPTR; oldLine : LONGINT; oldRow : INTEGER; 
                    newLine : LONGINT; newRow : INTEGER; clipIt : BOOLEAN);
  VAR   work, c, 
        clip    : Rectangle;
        i, j    : INTEGER;
        viewLine: LONGINT;
        blockRects : ARRAY [0..2] OF Rectangle;
        cursOn  : BOOLEAN;
BEGIN
  HideMouse();
  IF clipIt THEN HideCursor (ed); END;
  WITH ed^ DO 
    IF clipIt
    THEN 
      (* selber clippen *)
      ClipWork (ed);
    END; 
    GetBlockRects (ed, blockRects, i, oldLine, oldRow, newLine, newRow);
    (*

    (* OldLine mu kleiner sein, da es als Anfang genommen wird. *)
    (* Erstmal Zeilen auf gltige Werte bringen *)
    IF oldLine < 0 THEN oldLine := 0 END;
    IF newLine < 0 THEN newLine := 0 END;
    IF newLine > totalLineNr (* - 1 *) THEN newLine := totalLineNr (* - 1 *) END;
    IF oldLine > totalLineNr (* - 1 *) THEN oldLine := totalLineNr (* - 1 *) END;
    (* Notfalls swappen! *)
    IF oldLine > newLine THEN 
      v.lint := newLine; newLine := oldLine; oldLine := v.lint; 
      v.int := newRow; newRow := oldRow; oldRow := v.int;
    ELSIF (oldLine = newLine) & (oldRow > newRow) 
    THEN 
      v.int := newRow; newRow := oldRow; oldRow := v.int;
    END;
    (* Jetzt gewnschten Bereich malen *)
    IF (oldLine >= 0) & (newLine >= 0) & (newLine >= oldLine)
    THEN
      (* Block ist vorhanden *)
      IF ~(((oldLine < StartLine) & (newLine < StartLine)) OR (oldLine > StartLine + LONG(windLines)))
      THEN 
        (* Block ist zumindest teilweise im Fenster. 
         * Es werden maximal drei Rechtecke berechnet, die den Block im Fenster komplett beschreiben. 
         *)
        i := 0;
        IF (oldLine >= StartLine)
        THEN 
          WITH blockRects[i] DO 
            getCharPos (ed, oldLine, oldRow, x, y);
            IF x <= editWork.x + pixOff THEN x := editWork.x + pixOff END;
            IF newLine = oldLine
            THEN 
              getCharPos (ed, newLine, newRow, w, h);
              DEC (w);
              INC (h, charHeight-1);
            ELSE
              w := editWork.x + editWork.w - 1;
              h := y + charHeight-1;
            END;
            INC (i);
          END (* WITH blockRects [i] *);
        END;
        (* Komplette Zeilen zwischen Start und Ende *)
        IF (newLine > oldLine + 1) 
        THEN 
          (* mindestens eine Zeile im Fenster *)
          viewLine := BinOps.HigherLInt (oldLine + 1, StartLine);
          WITH blockRects[i] DO 
            getCharPos (ed, viewLine, 0, x, y);
            viewLine := BinOps.LowerLInt (newLine - 1, StartLine + LONG(windLines));
            getCharPos (ed, viewLine, 0, v.int, h);
            INC (h, charHeight-1);
            x := editWork.x+pixOff;
            w := editWork.x + editWork.w - 1;
          END;
          INC(i);
        END;
        IF (newLine >= StartLine) & (newLine <= StartLine + LONG(windLines)) & (newLine # oldLine)
        THEN
          (* Blockende im Fenster und nicht in Startzeile *)
          WITH blockRects[i] DO 
            x := editWork.x+pixOff;
            getCharPos (ed, newLine, newRow, w, y);
            DEC (w);
            h := y + charHeight - 1;
          END;
          INC(i);
        END;
        (* alle rechtecke berechnet *)
*)
    IF i > 0
    THEN
      v.int := MagicVDI.SetWritemode (hdl, MagicVDI.XOR);
      v.int := MagicVDI.SetFillcolor (hdl, MagicAES.BLACK);
      (* Jetzt Rechteckliste abfragen und auf Rechtecke clippen *)
      IF clipIt 
      THEN
        IF WdwManager.RectList (wdw, 0, work)
        THEN
          REPEAT
            (* kleinsten Redrawbereich bestimmen *)
            c := RectFuncs.ClipRect (work, deskSize);
            c := RectFuncs.ClipRect (c, editWork);
            IF c.w > 0 THEN
              INC (c.w, c.x-1);
              INC (c.h, c.y-1);
              MagicVDI.SetClipping (hdl, c, TRUE);
              FOR j := 0 TO i-1 DO 
                IF (blockRects[j].w > blockRects[j].x) & (blockRects[j].h > blockRects[j].y) THEN
                  MagicVDI.FillRectangle (hdl, blockRects[j]);
                END;
              END;
              ClipWork (ed);
            END;
          UNTIL ~WdwManager.RectList (wdw, 1, work);
        END;
      ELSE
        FOR j := 0 TO i-1 DO 
          IF (blockRects[j].w > blockRects[j].x) & (blockRects[j].h > blockRects[j].y) THEN
            MagicVDI.FillRectangle (hdl, blockRects[j]);
          END;
        END;
      END;
      v.int := MagicVDI.SetWritemode (hdl, MagicVDI.REPLACE);
      v.int := MagicVDI.SetFillcolor (hdl, backCol);
    END; 
  END (* WITH ed^ *);
  IF clipIt THEN ShowCursor (ed); END;
  ShowMouse (FALSE);
END MarkArea; 

        (* Vorhandener Block wird angezeigt *)
PROCEDURE ShowBlockMark (VAR ed : EDITPTR; clipIt : BOOLEAN);
  VAR   clip    : Rectangle;
        i, j    : INTEGER;
        viewLine: LONGINT;
        blockRects : ARRAY [0..2] OF Rectangle;
        cursOn  : BOOLEAN;
BEGIN
  WITH ed^ DO 
    FOR i := 0 TO maxBlocks - 1 DO
      WITH blocks[i] DO
        IF (blockStart.line >= 0) & (blockEnd.line >= 0)(* & (blockEnd.line >= blockStart.line) *)
        THEN
          MarkArea (ed, blockStart.line, blockStart.row, blockEnd.line, blockEnd.row, clipIt);
        END;
      END;
    END;
  END;
END ShowBlockMark;

PROCEDURE ConvertCR (VAR s : ARRAY OF CHAR; VAR l : INTEGER);
BEGIN
  IF (l>0) & (s[l-1] = 15C) THEN DEC (l); s[l] := 0C END;
END ConvertCR;

PROCEDURE MakeDrawLine (ed : EDITPTR; lineNr : LONGINT; VAR drawLine : ARRAY OF CHAR; VAR l : INTEGER);
  VAR tmpLine : ARRAY [0..4095] OF CHAR;
      gotLine : BOOLEAN;
BEGIN
  WITH ed^ DO
    gotLine := EditBase.GetLine (ed, lineNr, drawLine, l);
    IF (gotLine OR (l > INTEGER(HIGH (drawLine))))
    THEN
      IF (l>0) & (drawLine[l-1] = 12C) THEN DEC (l); drawLine[l] := 0C; END;
      IF ~umbruch OR ~showCR
      THEN
        ConvertCR (drawLine, l);
      END;
      IF (l>0) & (drawLine[l-1] = 12C) THEN DEC (l); drawLine[l] := 0C; END;
      IF realTabs
      THEN
        Strings.Assign (drawLine, tmpLine, v.bool);
        CatGlobal.ConvertTabs (tmpLine, drawLine, tabSize);
        l := LENGTH (drawLine);
      END;
    ELSE
      drawLine[0] := "";
      l := 0;
    END;
  END;
END MakeDrawLine;

(*
PROCEDURE OutputLine (ed : EDITPTR; x, y : INTEGER; REF line : ARRAY OF CHAR);
BEGIN
  WITH ed^ DO
    IF readOnly & isQuote (line)
    THEN
      IF mtAppl.Bitplanes > 1
      THEN
        (* Farbe umsetzen auf Quotefarbe *)
        v.int := MagicVDI.SetTextcolor (hdl, quoteCol);
        (* Zeile ausgeben *)
        Text (ed, x, y, line);
        (* Farbe wieder zurcksetzen *)
        v.int := MagicVDI.SetTextcolor (hdl, textCol);
      ELSE
        (* Texteffekt umsetzen *)
        v.bset := MagicVDI.SetTexteffect (hdl, quoteEff);
        (* Zeile ausgeben *)
        Text (ed, x, y, line);
        v.bset := MagicVDI.SetTexteffect (hdl, {});
      END;
    ELSE
      Text (ed, x, y, line);
    END;
  END;
END OutputLine;
*)
PROCEDURE rawRedraw (ed : EDITPTR; clip : Rectangle);
  (* Geht davon aus, da RectFuncs.ClipRect gesetzt ist und nur Zeilen zu zeichnen sind! 
   *)
VAR cursOn : BOOLEAN;
    text   : textPtr;
    extend : ARRAY [0..3] OF Point;
    i      : INTEGER;
    width  : INTEGER;
    xOutput, 
    yOutput: INTEGER;
    l      : INTEGER;
    topLine: LONGINT;
BEGIN
  WITH ed^ DO
    v.int := MagicVDI.SetTextcolor (hdl, textCol);
    v.int := MagicVDI.SetWritemode (hdl, MagicVDI.TRANSPARENT);
    topLine := StartLine;
    i := 0;   (* Zeilenzhler im Fenster *)
    (* Nicht im Redrawbereich liegende Zeilen berspringen *)
    WHILE (topLine < totalLineNr) & ((editWork.y + (i+1)*charHeight) - 1 < clip.y) DO
      INC (topLine);
      INC(i);
    END;
    xOutput := editWork.x + pixOff - leftOffset;
    yOutput := editWork.y + i * charHeight;
    (* Jetzt zeichnen *)
    WHILE (topLine < totalLineNr) & (i < editWork.h DIV charHeight) 
          & (yOutput <= clip.h) DO
      MakeDrawLine (ed, topLine, theDrawLine, l);
      text := ADR (theDrawLine);
      (*
      IF monoSpaced & ~realTabs
      THEN
        width := l * charWidth;
      ELSE
        InqTextextend (ed, text^, extend, TRUE);
        width := extend[1].x - extend[0].x;
      END;
      *)
      OutputLine (ed, xOutput, yOutput, text^, l, width);
      IF width < 32767
      THEN
        maxWidth := BinOps.HigherInt (maxWidth, width + charWidth);
      END;
      INC(i);
      INC (topLine);
      INC (yOutput, charHeight);
    END;
    v.int := MagicVDI.SetWritemode (hdl, MagicVDI.REPLACE);
    ShowBlockMark (ed, FALSE);
  END (* WITH ed *);
END rawRedraw;

        (* Alle redraw-Funktionen *)
PROCEDURE redrawWdw (wdw, vdiH : INTEGER; special : ADDRESS; frame : Rectangle);
VAR clip : Rectangle;
    i    : INTEGER;
    cursOn : BOOLEAN;
    strAdr : textPtr;
    ed     : EDITPTR;
    oldMax : INTEGER;
    wr     : INTEGER;
    eff    : INTEGER;
    currSize : Rectangle;
    wasRO  : BOOLEAN;
BEGIN
  ed := EDITPTR (special);
  WITH ed^ DO
    IF readOnly
    THEN
      textCol := CatGlobal.viewTextCol;
      backCol := CatGlobal.viewBackCol;
      quoteCol := CatGlobal.viewQuoteCol;
      CASE CatGlobal.viewQuoteEff OF
        0 : quoteEff := {}; |
        1 : quoteEff := {MagicVDI.Fat}; |
        2 : quoteEff := {MagicVDI.Italic}; |
        3 : quoteEff := {MagicVDI.Light}; |
      ELSE
        quoteEff := {};
      END;
    ELSE
      textCol := CatGlobal.editTextCol;
      backCol := CatGlobal.editBackCol;
      quoteCol := textCol;
    END;
    (* Jetzt ggf. Farben bei monochrom ignorieren und nur von Hintergrundfarbe
     * ausgehen 
     *)
    IF (mtAppl.Bitplanes = 1)
    THEN
      IF (textCol > 0) OR (quoteCol > 0)
      THEN
        backCol := 0;
        IF textCol = 0 THEN textCol := 1 END;
        IF quoteCol = 0 THEN quoteCol := 1 END;
      ELSE
        IF backCol = 0 THEN backCol := 1 END;
      END
    END;
    (* Clipping auf Rectangle setzen *)
    IF hasUserProc
    THEN
      clip := frame;
      IF RectFuncs.rcIntersect (userRect, clip)
      THEN
        WdwManager.GetWdwWork (wdw, currSize);
        clip := currSize;
        ed^.drawUserArea (wdw, hdl, clip, frame, textCol, backCol);
      END;
    END;
    clip := frame;
    IF RectFuncs.rcIntersect ( editWork, clip)
    THEN
      oldMax := maxWidth;
      clip := RectFuncs.ClipRect (frame, editWork);
      clip.w := clip.x + clip.w - 1; 
      clip.h := clip.y + clip.h -1;
      
      v.int := MagicVDI.SetFillcolor (hdl, backCol);
      
      MagicVDI.FillRectangle(hdl, clip);
      

      IF clip.x = editWork.x THEN
        INC (clip.x, pixOff);
      END;
      
      clip.x := BinOps.LowerInt (clip.x, clip.w);
      
      WdwManager.SetClip (hdl, clip, FALSE);

      rawRedraw (ed, clip);
      
      IF oldMax # maxWidth THEN SetDocument (ed) END;
    END;
    ClipWork (ed);
  END (* WITH ed^ DO *);
END redrawWdw;

PROCEDURE redrawLines (ed : EDITPTR; fromLine : INTEGER);
  VAR frame : Rectangle;
BEGIN
  WITH ed^ DO 
    HideCursor (ed);
    frame := editWork;
    frame.y := editWork.y + fromLine * charHeight;
    WdwManager.RedrawWdw (ed^.wdw, frame);
    ShowCursor (ed);
  END;
END redrawLines;

PROCEDURE redrawLineArea (ed : EDITPTR; fromLine, toLine : LONGINT);
(* Hier werden richtige Zeilennummern bergeben, nicht die Bildschirmzeilen *)
  VAR frame : Rectangle;
BEGIN
  WITH ed^ DO 
    IF ((fromLine >= StartLine) & (fromLine < StartLine + LONG(windLines))) OR
       ((toLine >= StartLine) & (toLine < StartLine + LONG(windLines)))
    THEN
      (* Nur Bereich neu zeichnen *)
      HideCursor (ed);
      frame := editWork;
      IF fromLine > StartLine
      THEN
        frame.y := editWork.y + SHORT(fromLine-StartLine) * charHeight;
      END;
      IF toLine < StartLine + LONG (windLines)
      THEN
        frame.h := editWork.y + SHORT(toLine-StartLine+1) * charHeight;
        frame.h := frame.h - frame.y + 1;
      END;
      WdwManager.RedrawWdw (ed^.wdw, frame);
      ShowCursor (ed);
    ELSIF (fromLine < StartLine) & (toLine > StartLine)
    THEN
      (* komplett neu zeichnen *)
      HideCursor (ed);
      WdwManager.RedrawWdw (ed^.wdw, editWork);
      ShowCursor (ed);
    END;
  END;
END redrawLineArea;

        (* Scroll-Funktionen *)


PROCEDURE scrollRegion (ed : EDITPTR; from, to, amount : INTEGER);
VAR pscrMFDB,
    pdesMFDB : MagicVDI.MFDB;
    copy     : ARRAY [0..1] OF Rectangle;
    clip     : Rectangle;
    flag     : INTEGER;
    dir      : INTEGER;
BEGIN
  WITH ed^ DO 
    IF from = to THEN RETURN END;
    copy[0].x := BinOps.LowerInt(mtAppl.MaxWidth-1, editWork.x);
    copy[0].w := BinOps.LowerInt(mtAppl.MaxWidth-1, editWork.w);
    copy[0].y := BinOps.LowerInt(mtAppl.MaxHeight-1, editWork.y+from*charHeight);
    IF from < to 
    THEN
      copy[0].h := BinOps.LowerInt(mtAppl.MaxHeight-1, (to - from + 1) * charHeight);
    ELSE
      copy[0].h := BinOps.LowerInt(mtAppl.MaxHeight-1, (to - from + 1) * charHeight);
    END;
    IF amount > 0
    THEN 
      dir := WdwManager.UP;
    ELSE
      dir := WdwManager.DOWN;
      amount := -1 * amount;
    END;
    amount := amount * charHeight;
    WdwManager.ScrollInWdw (wdw, copy[0], dir, amount);
  (*
    (* X-Koordinaten festlegen *)
    copy[0].x := BinOps.LowerInt(mtAppl.MaxWidth-1, editWork.x);
    copy[0].w := BinOps.LowerInt(mtAppl.MaxWidth-1, editWork.x+editWork.w-1);
    copy[1].x := BinOps.LowerInt(mtAppl.MaxWidth-1, editWork.x);
    copy[1].w := BinOps.LowerInt(mtAppl.MaxWidth-1, editWork.x+editWork.w-1);
    (* y-Koordinaten berechnen *)
    copy[0].y := BinOps.LowerInt(mtAppl.MaxHeight-1, editWork.y+from*charHeight);
    copy[0].h := BinOps.LowerInt(mtAppl.MaxHeight-1, editWork.y+to*charHeight-1);
    copy[1].y := BinOps.LowerInt(mtAppl.MaxHeight-1, editWork.y+from*charHeight+amount*charHeight);
    copy[1].h := BinOps.LowerInt(mtAppl.MaxHeight-1, editWork.y+to*charHeight+amount*charHeight-1);
    pscrMFDB.fdAddr := NIL;  pdesMFDB.fdAddr := NIL;
    flag := 0;
    WHILE WdwManager.RectList (wdw, flag, clip) DO
      WdwManager.SetClip (hdl, clip, TRUE);
      MagicVDI.CopyRasterOpaque(hdl, 3, copy, pscrMFDB, pdesMFDB);
      flag := 1;
    END;
    ClipWork (ed);
    *)
  END;
END scrollRegion;


PROCEDURE IsInBlock (VAR ed : EDITPTR; lnr : LONGINT) : BOOLEAN;
  VAR i : INTEGER;
BEGIN
  FOR i := 0 TO maxBlocks-1 DO
    WITH ed^.blocks[i] DO
      IF (blockStart.line <= lnr) & (blockEnd.line >= lnr)
      THEN
        RETURN TRUE
      END;
    END;
  END;
  RETURN FALSE;
END IsInBlock;

PROCEDURE drawLine (ed : EDITPTR; screenLine : INTEGER);
  VAR fill : Rectangle;
      wr   : INTEGER;
      i    : INTEGER;
      width: INTEGER;
      extend: ARRAY [0..3] OF Point;
      text : textPtr;
      topLine : LONGINT;
      len   : INTEGER;
      clipr : Rectangle;
BEGIN
  IF screenLine < 0 THEN RETURN END;
  WITH ed^ DO 
    (* Fillrectangle berechnen *)
    fill.x := BinOps.LowerInt (mtAppl.MaxWidth-1, editWork.x);
    fill.y := BinOps.LowerInt (mtAppl.MaxHeight-1, editWork.y + screenLine * charHeight);
    fill.w := BinOps.LowerInt (mtAppl.MaxWidth-1, editWork.x + editWork.w - 1);
    fill.h := BinOps.LowerInt (mtAppl.MaxHeight-1, editWork.y + (screenLine+1) * charHeight - 1);
    IF WdwManager.RectList (wdw, 0, clipr)
    THEN
      REPEAT
        WdwManager.SetClip (hdl, clipr, TRUE);
        MagicVDI.FillRectangle (hdl, fill);
        v.int := MagicVDI.SetWritemode (hdl, MagicVDI.TRANSPARENT);
        (* String ausgeben *)
        IF StartLine + LONG (screenLine) < totalLineNr
        THEN
          MakeDrawLine (ed, StartLine + LONG(screenLine), theDrawLine, len);
          text := ADR (theDrawLine);
          (*
          InqTextextend (ed, text^, extend, TRUE);
          width := extend[1].x - extend[0].x;
          *)
          OutputLine (ed, fill.x+pixOff-leftOffset, fill.y, text^, len, width);
          IF width > maxWidth THEN maxWidth := width; END;
        END;
        (* Jetzt noch testen, ob es im Block war *)
        v.int := MagicVDI.SetWritemode (hdl, MagicVDI.REPLACE);
        IF IsInBlock (ed, StartLine+LONG(screenLine))
        THEN 
          MagicVDI.SetClipping (hdl, fill, TRUE);
          ShowBlockMark (ed, FALSE);
          ClipWork (ed);
        END (* IF IsInBlock *);
      UNTIL ~WdwManager.RectList (wdw, 1, clipr);
    END;
  END; (* WITH ed^ DO *)
END drawLine;

PROCEDURE redrawLineFSM (ed : EDITPTR);
  (* zeichnet currLine von currRow bis Ende neu *)
  VAR 
      ch :      ARRAY [0..1] OF CHAR;
      extend:   ARRAY [0..3] OF Point;
      width:    INTEGER;
      c:        Point; (* aktuelle Zeichenposition *)
      fill:     Rectangle; (* Fllrechteck *)
      wr:       INTEGER;
      charAdr:  POINTER TO CHAR;
      strAdr:   textPtr;
      saveCh:   CHAR;
      lastCh:   ARRAY [0..7] OF CHAR;
      i:        INTEGER;
      text:     textPtr;
      len:      INTEGER;
      clipr:    Rectangle;
BEGIN
  WITH ed^ DO
    (* Zeilenanfang holen *)
    MakeDrawLine (ed, currLineNr, theDrawLine, len);
    text := ADR(theDrawLine);
    IF currRow > 0
    THEN
      charAdr := ADR (text^[currRow-1]);
    ELSE
      charAdr := ADDRESS(text);
    END;
    saveCh := charAdr^;
    charAdr^ := 0C;
    InqTextextend (ed, text^, extend, FALSE);
    charAdr^ := saveCh;
    c.x := editWork.x + extend[1].x - extend[0].x + pixOff - leftOffset;
    c.y := editWork.y + SHORT(currLineNr - StartLine) * charHeight;

    fill.x := BinOps.LowerInt (mtAppl.MaxWidth-1, c.x);
    fill.y := BinOps.LowerInt (mtAppl.MaxHeight-1, c.y);
    fill.w := BinOps.LowerInt (mtAppl.MaxWidth-1, editWork.x + editWork.w - 1);
    fill.h := BinOps.LowerInt (mtAppl.MaxHeight-1, c.y + charHeight - 1);
    IF WdwManager.RectList (wdw, 0, clipr)
    THEN
      REPEAT
        WdwManager.SetClip (hdl, clipr, TRUE);
        MagicVDI.FillRectangle (hdl, fill);
        (* String ausgeben *)
        fill.x := BinOps.LowerInt (mtAppl.MaxWidth-1, editWork.x);
        (*
        InqTextextend (ed, text^, extend, FALSE);
        width := extend[1].x - extend[0].x;
        *)
        wr := MagicVDI.SetWritemode (hdl, MagicVDI.TRANSPARENT);
        OutputLine (ed, fill.x+pixOff-leftOffset, fill.y, text^, len, width);
        IF width+charWidth > maxWidth THEN maxWidth := width+charWidth; END;
        IF IsInBlock (ed, currLineNr)
        THEN
          MagicVDI.SetClipping (hdl, fill, TRUE);
          ShowBlockMark (ed, FALSE);
          ClipWork (ed);
        END;
        wr := MagicVDI.SetWritemode (hdl, MagicVDI.REPLACE);
      UNTIL ~WdwManager.RectList (wdw, 1, clipr);
    END;
  END; (* WITH ed^ *)
END redrawLineFSM;

PROCEDURE redrawLineMono (ed : EDITPTR; insChar : BOOLEAN);
  (* zeichnet currLine von currRow bis Ende neu,
   * fr monospaced font
   *)
  VAR 
      width:    INTEGER;
      c:        Point; (* aktuelle Zeichenposition *)
      fill:     Rectangle; (* Fllrechteck *)
      wr:       INTEGER;
      lastCh:   ARRAY [0..7] OF CHAR;
      copy:     ARRAY [0..1] OF Rectangle;
      tmp:      Rectangle;
      extend:   ARRAY [0..3] OF Point;
      strAdr:   textPtr;
      le,
      row:      INTEGER;
      pscrMFDB,
      pdesMFDB: MagicVDI.MFDB;
      clipr:    Rectangle;
BEGIN
  pscrMFDB.fdAddr := NIL;
  pdesMFDB.fdAddr := NIL;
  WITH ed^ DO
    (* Fenster nach links aus dem Bildschirm raus mit WinX? *)
    IF editWork.x < 0 THEN redrawLineFSM (ed); RETURN END;
    MakeDrawLine (ed, currLineNr, theDrawLine, le);
    (* Zeichen unter Cursor *)
    lastCh[0] := theDrawLine[currRow];
    lastCh[1] := theDrawLine[currRow+1];
    lastCh[2] := 0C;
    (* zeichenposition berechnen *)
    c.x := editWork.x + pixOff - leftOffset + currRow * charWidth;
    c.y := editWork.y + SHORT (currLineNr-StartLine) * charHeight ;

    fill.x := BinOps.LowerInt (mtAppl.MaxWidth-1, c.x);
    fill.y := BinOps.LowerInt (mtAppl.MaxHeight-1, c.y);
    fill.w := BinOps.LowerInt (mtAppl.MaxWidth-1, c.x+ charWidth - 1);
    fill.h := BinOps.LowerInt (mtAppl.MaxHeight-1, c.y + charHeight-1);
    IF WdwManager.RectList (wdw, 0, clipr)
    THEN
      REPEAT
        WdwManager.SetClip (hdl, clipr, TRUE);
    
        IF insertMode OR ~insChar OR (ORD(theDrawLine[currRow]) < 32)
        THEN
          (* Bitblocktransfer der brigen Zeichen nach hinten *)
          WITH copy[0] DO
            x := BinOps.LowerInt (mtAppl.MaxWidth-1, c.x);
            y := BinOps.LowerInt (mtAppl.MaxHeight-1, c.y);
            w := BinOps.LowerInt (mtAppl.MaxWidth-1, editWork.x+editWork.w - charWidth-1);
            h := BinOps.LowerInt (mtAppl.MaxHeight-1, c.y + charHeight-1);
          END;
          WITH copy[1] DO
            x := BinOps.LowerInt (mtAppl.MaxWidth-1, c.x+charWidth);
            y := BinOps.LowerInt (mtAppl.MaxHeight-1, c.y);
            w := BinOps.LowerInt (mtAppl.MaxWidth-1, editWork.x+editWork.w - 1);
            h := BinOps.LowerInt (mtAppl.MaxHeight-1, c.y + charHeight-1);
          END;
          (* Beim Lschen BitBlk-Transfer um 1 Zeichen zurck *)
          IF ~insChar THEN tmp:= copy[0]; copy[0]:=copy[1];copy[1]:= tmp; END;
          MagicVDI.CopyRasterOpaque(hdl, 3, copy, pscrMFDB, pdesMFDB);
          (* Noch Zeilenbreite bestimmen *)
          width := le * charWidth;
          IF width+charWidth > maxWidth THEN maxWidth := width+charWidth; END;
        END;
        IF ~insChar 
        THEN
          (* Zeilenende noch lschen und ggf neuzeichnen *)
          copy[0].x := copy[0].w-charWidth;
          MagicVDI.FillRectangle (hdl, copy[0]);
          row := ((copy[0].x -editWork.x + leftOffset -pixOff) DIV charWidth);
          IF (row < le) & (row >= 0)
          THEN
            strAdr := ADR(theDrawLine[row]);
            wr := MagicVDI.SetWritemode (hdl, MagicVDI.TRANSPARENT);
            copy[0].x := (editWork.x - leftOffset + pixOff) + row * charWidth;
            Text (ed, copy[0].x, copy[0].y, strAdr^);
          END;
        ELSE
          MagicVDI.FillRectangle (hdl, fill);
          (* Zeichen ausgeben *)
          wr := MagicVDI.SetWritemode (hdl, MagicVDI.TRANSPARENT);
          Text (ed, fill.x, fill.y, lastCh);
        END;
        (* Blockmarkierung erneuern *)
        IF IsInBlock (ed, currLineNr)
        THEN
          MagicVDI.SetClipping (hdl, fill, TRUE);
          ShowBlockMark (ed, FALSE);
          ClipWork (ed);
        END;
        wr := MagicVDI.SetWritemode (hdl, MagicVDI.REPLACE);
      UNTIL ~WdwManager.RectList (wdw, 1, clipr);
    END;
  END; (* WITH ed^ *)
END redrawLineMono;

PROCEDURE redrawLine (ed : EDITPTR; insChar : BOOLEAN; full : BOOLEAN);
BEGIN
  IF ed^.wdw # WdwManager.theTopWindow
  THEN
    redrawLineFSM (ed);
  ELSIF ed^.monoSpaced & ~full & ~ed^.realTabs & ~ed^.isFSM (* added "& ~isFSM" for Monospaced 821 Font *)
  THEN
    redrawLineMono (ed, insChar)
  ELSIF (ed^.realTabs OR full) & ~ed^.isFSM
  THEN
    drawLine (ed, SHORT(ed^.currLineNr-ed^.StartLine));
  ELSE
    redrawLineFSM (ed);
  END;
END redrawLine;

        (* Bltterfunktionen *)

PROCEDURE CenterCurrline (ed : EDITPTR);
  VAR oldLine : LONGINT;
      maxOffset : INTEGER;
      oldOffset: INTEGER;
      x, y    : INTEGER;
      centered: BOOLEAN;
BEGIN
  WITH ed^ DO 
    centered := FALSE;
    IF (currLineNr < StartLine) OR (currLineNr > StartLine + LONG(windLines)-1)
    THEN
      HideMouse();
      HideCursor (ed);
      (* Zentrieren ist ntig! *)
      oldLine := StartLine;
      SetStartLine (ed, BinOps.HigherLInt(0, currLineNr - (LONG(windLines) DIV 2)), TRUE);
      centered := TRUE;
      ShowCursor (ed);
      ShowMouse(FALSE);
    END;
    getCharPos (ed, currLineNr, currRow, x, y);
    IF (x < editWork.x) OR (x >= editWork.x + editWork.w) OR ((editWork.w > maxWidth) & (leftOffset > 0))
    THEN
      HideMouse();
      HideCursor (ed);
      (* Zentrieren ist ntig! *)
      oldOffset := leftOffset;
      maxOffset := BinOps.HigherInt (0, maxWidth - editWork.w);
      (* neuen offset berechnen *)
      leftOffset := BinOps.HigherInt (0, oldOffset+(x-editWork.x) - charWidth*5);
      leftOffset := BinOps.LowerInt (leftOffset, maxOffset);
      IF x + oldOffset < editWork.w - charWidth*2 THEN leftOffset := 0; END;
      SetDocument (ed);
      centered := TRUE;
      ShowCursor (ed);
      ShowMouse(FALSE);
    END;
    IF centered
    THEN
      SetInfoLine (ed);
    END;
  END;
END CenterCurrline;

BEGIN
  control7:= ADR (VDIControl[7]);
  control9:= ADR (VDIControl[9]);
END EditDraw.
