DEFINITION MODULE EditFuncs;

FROM SYSTEM     IMPORT ADDRESS;

FROM EditTypes  IMPORT EDITPTR, CAT, textPtr, aLinePtr, CharSet,
                       aBufferPtr, aLineDesc, searchPos, searchDir, searchCount;

VAR rotateFaktor : CARDINAL;
    editList     : EDITPTR;

(*$? NOT CAT:
PROCEDURE callComp (ed : EDITPTR);
*)

TYPE formFunc   = PROCEDURE ( (* text *)  textPtr);

PROCEDURE FindEditor ( wdw : INTEGER) : EDITPTR;

PROCEDURE GetEditNumber (wdw : INTEGER) : INTEGER;

PROCEDURE OutOfMem ();

PROCEDURE findNext (text : textPtr; fromPos, l : INTEGER; tSet : CharSet) : INTEGER;

PROCEDURE FindNext(ed : EDITPTR; umbruch : BOOLEAN; l : INTEGER): INTEGER;

PROCEDURE findLast (text : textPtr; fromPos : INTEGER; tSet : CharSet) : INTEGER;

PROCEDURE FindLast(ed : EDITPTR; umbruch : BOOLEAN): INTEGER;

PROCEDURE CursorDown (ed : EDITPTR; ctrl : BOOLEAN);

PROCEDURE CursorUp (ed : EDITPTR; ctrl : BOOLEAN);

PROCEDURE CursorLeft (ed : EDITPTR; kstate : BITSET);

PROCEDURE CursorRight(ed : EDITPTR; kstate : BITSET);

PROCEDURE AllUp (text : textPtr);

PROCEDURE AllLower (text : textPtr);

PROCEDURE SwapUpperLower (text : textPtr);

PROCEDURE Capitalise (text : textPtr);

PROCEDURE RotXX (text : textPtr);

PROCEDURE Rot18 (text : textPtr);

PROCEDURE Mirror (text : textPtr);

PROCEDURE Protect (text : textPtr);

PROCEDURE XXDecode (text: textPtr);

PROCEDURE TransformBlock (ed : EDITPTR; trans : formFunc; wholeLines: BOOLEAN);

PROCEDURE Home (ed : EDITPTR; ende : BOOLEAN); 

PROCEDURE SwapLines (ed : EDITPTR; withUp : BOOLEAN);
(* Vertauscht die aktuelle Zeile mit
 * withUp = TRUE der Zeile darber
 * withUp = FALSE der Zeile darunter
 *)

PROCEDURE outputText (ed: EDITPTR; fromLine : LONGINT; fromRow : INTEGER;
                      toLine : LONGINT; toRow : INTEGER; fHdl : INTEGER; umbruch : BOOLEAN;
                      usePrintMod : BOOLEAN) : BOOLEAN;

TYPE    ErrReason = (memError, readError, noTextError);

PROCEDURE ReadBuffer (VAR ed : EDITPTR; VAR buf: ADDRESS; len : LONGCARD; 
                      freeBuffer: BOOLEAN; VAR err: ErrReason) : BOOLEAN;

(*
PROCEDURE ReadEditBuffer (VAR ed : EDITPTR; buf : ADDRESS; len : LONGCARD; inLine : BOOLEAN; REF pre : ARRAY OF CHAR) : BOOLEAN;
*)

PROCEDURE readText (VAR ed : EDITPTR; fastRead : BOOLEAN;
                    flen : LONGCARD; VAR fHdl : INTEGER;
                    right : INTEGER; VAR readBuf : ADDRESS; 
                    inLine : BOOLEAN; fullText : BOOLEAN) : BOOLEAN;

PROCEDURE Goto (ed : EDITPTR; line : LONGINT; row : INTEGER);

PROCEDURE showError (ed: EDITPTR);

PROCEDURE KillEditor (VAR ed : EDITPTR);

PROCEDURE CreateEditor(VAR ed : EDITPTR) : BOOLEAN;

(*$? NOT CAT:
PROCEDURE FreeShortkeyList ();

PROCEDURE ReadShortkeyFile(REF fname: ARRAY OF CHAR);

PROCEDURE InsertShortkey (VAR ed: EDITPTR);
*)

PROCEDURE searchAndReplace (ed : EDITPTR; w, r : ARRAY OF CHAR; pos : searchPos; 
                  direction : searchDir; count : searchCount; 
                  num (* wird nur bei count = nmal benutzt *) : INTEGER;
                  ignoreCase : BOOLEAN; onlyWord : BOOLEAN; 
                  replace : BOOLEAN; ask : BOOLEAN; again : BOOLEAN;
                  doBing: BOOLEAN): BOOLEAN;


PROCEDURE Delete (ed : EDITPTR; ctrl : BOOLEAN; saveLine : BOOLEAN);

PROCEDURE Backspace(ed : EDITPTR; ctrl: BOOLEAN);

PROCEDURE DupLine (ed : EDITPTR); 

PROCEDURE Tab (ed : EDITPTR; onlyIndent: BOOLEAN);

PROCEDURE InsertCR (ed : EDITPTR);

PROCEDURE Format0 (ed : EDITPTR; forcedJoin : BOOLEAN);

PROCEDURE Insert (ed: EDITPTR; ch : CHAR);

PROCEDURE cutBlock (ed : EDITPTR; toClip, redraw : BOOLEAN): BOOLEAN;

PROCEDURE cutEdit (ed : EDITPTR; fromOuter : BOOLEAN): BOOLEAN;

PROCEDURE putLineInEditor (ed: EDITPTR; adr: ADDRESS; len: CARDINAL; 
                           redraw: BOOLEAN): BOOLEAN; 

END EditFuncs.
