IMPLEMENTATION MODULE EditFuncs;

(*$Z+*)
(*$Y+*) 

FROM SYSTEM     IMPORT  ADDRESS, ADR, TSIZE, CADR, LOC, LONGWORD, WORD, CALLSYS;

(* Megamax-Lib *)

FROM Storage    IMPORT ALLOCATE, DEALLOCATE, Inconsistent;

FROM GrafBase   IMPORT LongRect, Rectangle, Point;

IMPORT Storage, Strings, BinOps, Block, StrConv, 
       MOSGlobals, Keyboard, Characters, Lists;

FROM Keyboard  IMPORT SpecialCode;

(* MagicLib *)
IMPORT MagicAES, MagicVDI, MagicDOS, MagicBIOS, MagicSys, MagicFSM, 
       mtAlerts, mtAppl, mtDials, mtUtils, mtTextfiles;

(* CAT Module *)
IMPORT CatFiles, MTE, Clip;

FROM Void       IMPORT v;

IMPORT FontSelect;

(* Editor  *)
FROM EditTypes  IMPORT EDITPTR, EDITOR, aLinePtr, aLineDesc, aLine, textPtr, aMark, 
                       userProcType, userGetRectProc, drawUserProc, userCloseProc, 
                       deskSize, pixOff, undoType, SuchFlags, SuchModus, searchDir, 
                       searchPos, searchCount, CAT, CharSet, TrennSet, UmbruchSet,
                       userKeyProc, userTopProc, userUntopProc, theDrawLine, aBufferPtr, 
                       LFIRST, LNEXT;

FROM EditGlobals        IMPORT  ClipWork, MouseArrow, MouseBusy, 
                                HideMouse, ShowMouse, HideCursor, 
                                ShowCursor, drawCursor, RowToIndex, 
                                SetDocument, CursorIsOn, AllocNew;
FROM EditTools          IMPORT  SetInfoLine, SetEditTitle, ShowFileChanged, 
                                SetCurrLine, SetStartLine, getCharPos, 
                                SaveLine, SaveOp, DeleteLine, 
                                Undo, NewBlockToUndoBuffer,  
                                SetBlockstart, SetBlockend, ClearBlock,
                                GetClickLineAndRow, TestBlockMarksAndSwap, ToWordEnd,
                                ToWordStart, MarkLine, MarkWord, MarkBlock, 
                                ToBlockmark, SearchWord, ReplaceWord, FreeUndoBuffer,
                                UpdateCurrLine, ToLineEnd;
                                
FROM EditDraw           IMPORT  drawLine, redrawLine, 
                                redrawLines, redrawWdw,
                                redrawLineArea, scrollRegion, CenterCurrline; 

IMPORT CatEdit;         (* Circulrer Import! *)
IMPORT EditGlobals;
IMPORT EditBase;
IMPORT EditTools;
IMPORT WdwManager;
IMPORT Printer;
IMPORT ConfVars;
IMPORT Varnames;
IMPORT CatGlobal;
IMPORT UUDecode;

(*$? NOT CAT:
(* Fr Compilierung im Speicher *)
IMPORT Loader, Directory, Paths, ShellMsg, PathEnv;
*)
IMPORT FileNames;

(*$? CAT:
IMPORT mtDir;
*)
(*$? CAT:
CONST   progName = 'CAT:';
*)
(*$? NOT CAT:
CONST   progName = 'Fred:';
*)

CONST   outOfMem = '[3]['+progName+'|Nicht genug|freier Speicher][[Abbruch]';
        readErr  = '[3]['+progName+'|Konnte Text nicht lesen!|Editor wird nicht|geffnet!][[Abbruch]';
        noTextErr= '[3]['+progName+'|Dies ist kein ASCII-Text!|Das kann ich leider|nicht laden.][[Abbruch]';
        askRepl  = '[2]['+progName+'|Text ersetzen: |Sie knnen (J)a, (N)ein |oder (A)bbruch eingeben|oder diesen Dialog beantworten!][[Ja|[Nein|:[Abbruch]';
        
        compileMsg  = ' Compiling...'+0C;
        
        CR      = 15C;
        LF      = 12C;
        TAB     = 11C;

TYPE
     Str128     = ARRAY [0..127] OF CHAR;
     numSet     = SET OF [0..255];

(*$? NOT CAT: 

(* Variablen fr Compilierung im Speicher *)
VAR  callRes    : Loader.LoaderResults;
     callMsg    : Strings.String;
     exitCode   : INTEGER;

     compLine   : LONGINT;
     compEd     : EDITPTR;

(*
 Auszug aus dem GME:
 -------------------
 * Diese Prozedur wird vom Compiler pro Zeile aufgerufen, wenn ihre
 * Adresse in Textform (ggf. auch Hex mit "$" voran) nach der Option
 * "/^" in der Argumentzeile beim Compileraufruf angegeben wird.
 * Zustzlich sollte noch die Option "/Q" angegeben werden, um weitere
 * Ausgaben des Compilers zu unterdrcken.
 *)

VAR compEOF : ARRAY[0..3] OF CHAR;

(*$Z-*)
PROCEDURE doCompilerLine (): textPtr;
  VAR p : textPtr;
  BEGIN
      IF compLine < compEd^.totalLineNr THEN
        v.bool := EditBase.GetLine (compEd, compLine, theDrawLine, v.int);
        p:= ADR (theDrawLine); (* nchste Zeile, mit 0C abgeschlossen! *)
        DEC (v.int);
        WHILE (v.int >= 0) & (ORD(theDrawLine[v.int]) < 32) DO theDrawLine[v.int] := 0C END;
        CALLSYS (1, 4201, CADR("cLine %ld: %s"), compLine, p);
        INC (compLine);
      ELSE
        compEOF[0]:= 3C;  (* Programmende *)
        compEOF[1]:= 0C;
        p:= ADR (compEOF);
      END;
      RETURN p
  (*
    ASSEMBLER
        LEA     compLine,A0
        MOVE.L  (A0),A1
        BEQ     atEOF
        MOVE.L  compLine.zeile.text(A1),(A3)+   
        MOVE.L  compLine.next(A1),(A0)

        RTS

      atEOF
        MOVE.W  #$0300,compEOF
        MOVE.L  #compEOF,(A3)+
    END;
  *)
  END doCompilerLine;
(*$Z+*)

PROCEDURE call ( ed : EDITPTR; VAR modname: ARRAY OF CHAR; args: ARRAY OF CHAR;
                 stackSize: LONGCARD; tool:BOOLEAN );
  
  VAR sufstr            : ARRAY[0..2] OF CHAR;
      dummy             : ARRAY[0..12] OF CHAR;
      name, path,
      oldPath           : Str128;
      prevStackSize     : LONGCARD;

  BEGIN
    Strings.Assign (modname, name, v.bool);
    Strings.Upper (name);

    FileNames.SplitPath (name, path, dummy);
    FileNames.SplitName (dummy,dummy,sufstr);

    Directory.GetDefaultPath (oldPath);
    IF (path[0] = 0C) AND NOT tool THEN
      (* Ist kein Pfad angegeben, bleibt bei Tools und
       * Systemprgs der akt. Pfad erhalten
       *)
      Paths.SearchFile (name, ShellMsg.StdPaths, Paths.fromStart, v.bool, name);
      FileNames.SplitPath (name, path, dummy);
    END;
    Directory.SetDefaultPath (path, v.int);
    
    prevStackSize:= Loader.DefaultStackSize;

    IF stackSize # 0 THEN Loader.DefaultStackSize:= stackSize END;

    Loader.CallModule (name, ShellMsg.StdPaths, args, NIL, exitCode, callMsg, callRes);

    Loader.DefaultStackSize:= prevStackSize;
    
    Directory.SetDefaultPath (oldPath, v.int);

  END call;

(*  callComp -- Calls the compiler to compile the file in the editor 'ed'.
 *)
 

PROCEDURE callComp (ed : EDITPTR);


CONST   CompilerStackSize = 16000;

  VAR i:INTEGER;
      s,msg:Str128;
      adr : RECORD a,b : ADDRESS; END;

  BEGIN
    (*  String mit Compileroptionen aufbauen.
     *)
    MouseBusy();
    
    WITH ShellMsg.CompilerParm DO
      IF shortMsgs THEN s:= ' -Q' ELSE s:= ' +Q' END;
      Strings.Append (' ', s, v.bool);
      Strings.Append (ShellMsg.CompilerArgs, s, v.bool);
      IF ~ Strings.Empty (ShellMsg.MainOutputPath) THEN
        Strings.Append (' /O', s, v.bool);
        Strings.Append (ShellMsg.MainOutputPath, s, v.bool);
      END;
      IF protocol THEN
        Strings.Append (' /C', s, v.bool);
        Strings.Append (StrConv.CardToStr (protWidth, 0), s, v.bool);
        Strings.Append (' /P', s, v.bool);
        Strings.Append (protName, s, v.bool);
      END;
      (* Parameter fr Quiet und im Speicher *)
      Strings.Append (' /Q /^',s, v.bool);
      Strings.Append (StrConv.LHexToStr(ADDRESS(doCompilerLine),0),s, v.bool);
    END;
    
    Strings.Assign (compileMsg, ed^.errMsg, v.bool);
    WdwManager.SetWdwInfoline (ed^.wdw, ed^.errMsg);
    IF ed^.fileName.length > 0
    THEN
      Strings.Concat (ed^.fileName.text^,s, s, v.bool);
    ELSE
      Strings.Concat ('namenlos.txt', s, s, v.bool);
    END;
    
    compLine := 0;

    call (ed, ShellMsg.CompilerParm.name, s,
          CompilerStackSize, TRUE);
    
    IF callRes # Loader.noError THEN
      (* Fehlermeldung, Compiler nicht gefunden *)
    ELSE
      IF exitCode # 0
      THEN
        WITH ed^ DO 
          errLine := ShellMsg.TextLine;
          errRow := ShellMsg.TextCol-1;
          Strings.Assign (ShellMsg.ErrorMsg, errMsg, v.bool);
        END;
        showError (ed);
      ELSE
        Strings.Assign (ShellMsg.CodeName, ed^.errMsg, v.bool);
        Strings.Append (', ', ed^.errMsg, v.bool);
        Strings.Append (StrConv.CardToStr (ShellMsg.CodeSize,0), ed^.errMsg, v.bool);
        Strings.Append (' Bytes.', ed^.errMsg, v.bool);
        WdwManager.SetWdwInfoline (ed^.wdw, ed^.errMsg);
      END;
    END;
    HideMouse ();
    MouseArrow();
    ShowMouse (FALSE);
  END callComp;
*)

                (* "Suchfunktionen" *)

PROCEDURE FindEditor ( wdw : INTEGER) : EDITPTR;
  VAR ed : EDITPTR;
BEGIN
  ed := editList;
  WHILE ed # NIL DO
    IF ed^.wdw = wdw THEN RETURN ed END;
    ed := ed^.nextEdit;
  END;
  RETURN NIL;
END FindEditor;

PROCEDURE GetEditNumber (wdw : INTEGER) : INTEGER;
(* Gibt die interne Nummer des Editors zurck *)
  VAR ed : EDITPTR;
BEGIN
  ed := FindEditor (wdw);
  IF ed # NIL
  THEN 
    RETURN ed^.number
  ELSE
    RETURN -1
  END;
END GetEditNumber;

PROCEDURE OutOfMem ();
BEGIN
  (*$? CAT:
  MTE.noMemAlert ();
  *)
  (*$? NOT CAT:
  MTE.info (outOfMem);
  *)
END OutOfMem;

PROCEDURE findNext (text : textPtr; fromPos, l : INTEGER; tSet : CharSet) : INTEGER;
  VAR z : INTEGER;
      ch : CHAR;
BEGIN
  z := fromPos;
  WHILE (z < l) AND ~(text^[z] IN CharSet{0C, CR, LF}) AND ~(text^[z] IN tSet) DO  INC(z);  END;
  WHILE (z < l) AND ~(text^[z] IN CharSet{0C, CR, LF}) AND  (text^[z] IN tSet) DO  INC(z);  END;
(*
  WHILE (z < l) & ~(text^[z] IN tSet) DO INC (z) END;
  ch := text^[z];
  IF (ch # CR) & (ch # LF) THEN
    WHILE (z < l) & (text^[z] = ch) DO INC (z) END;
  END;
(*  IF z = fromPos
  THEN
    RETURN findNext (text, z+1, l, tSet);
  END;
*)
*)
  RETURN z;
END findNext;

PROCEDURE FindNext(ed : EDITPTR; umbr : BOOLEAN; l : INTEGER): INTEGER;
VAR z    : INTEGER;
    text : textPtr;
    tSet : CharSet;
BEGIN
  WITH ed^ DO 
    IF umbr THEN 
      RETURN findNext (editLine.text, currRow, l, UmbruchSet);
    ELSE 
      RETURN findNext (editLine.text, currRow, l, TrennSet);
    END;
  END (* WITH ed^ DO *);
END FindNext;

PROCEDURE findLast (text : textPtr; fromPos : INTEGER; tSet : CharSet) : INTEGER;
  VAR z : INTEGER;
      ch: CHAR;
BEGIN
  z := fromPos;
  (*
  IF (z>0) & (text^[z] = 0C) & (text^[z-1] IN tSet)
  THEN DEC (z) END;
  (*
  IF (z > 0) & ~(text^[z] IN tSet) & (text^[z-1] IN tSet) THEN 
    WHILE (z > 0) & ~(text^[z] IN tSet) DO DEC(z) END;
  END;
  *)
  IF text^[z] IN tSet THEN
    WHILE (z > 0) & (text^[z] IN tSet)  DO DEC(z) END;
  ELSE
    WHILE (z > 0) & ~(text^[z] IN tSet) DO DEC(z) END;
    ch := text^[z];
    WHILE (z > 0) & (text^[z] = ch)  DO DEC(z) END;
  END;
  (*
  WHILE (z > 0) & (text^[z] IN tSet)  DO DEC(z) END;
  *)
  WHILE (z > 0) & ~(text^[z] IN tSet) DO DEC(z) END;
  IF (z # fromPos) & (z # 0) THEN INC(z) END;
  *)
  WHILE (z > 0) AND (text^[z-1] IN tSet) DO  DEC(z);  END;
  WHILE (z > 0) AND ~(text^[z-1] IN tSet) DO  DEC(z);  END;
  RETURN z;
END findLast;

PROCEDURE FindLast(ed : EDITPTR; umbr : BOOLEAN): INTEGER;
BEGIN
  WITH ed^ DO 
    IF umbr THEN 
      RETURN findLast (editLine.text, currRow, UmbruchSet);
    ELSE 
      RETURN findLast (editLine.text, currRow, TrennSet);
    END;
  END (* WITH ed^ DO *);
END FindLast;

PROCEDURE CursorDown (ed : EDITPTR; ctrl : BOOLEAN);
BEGIN
  WITH ed^ DO
    HideMouse();
    HideCursor(ed);
    IF block & ~readOnly THEN 
      SetCurrLine (ed, blocks[0].blockEnd.line);
      currRow := blocks[0].blockEnd.row;
      EditGlobals.FixCursorPos (ed);
      ClearBlock (ed); 
    END;
    IF (currLineNr - StartLine  = LONG(windLines-1)) OR (readOnly & ~multiBlockMark) THEN      (* hier nur ganze Zeile *)
      IF ctrl
      THEN
        WdwManager.PageDown (ed^.wdw);
      ELSE
        WdwManager.ScrollDown(ed^.wdw, 1);
      END;
    ELSE
      IF ctrl 
      THEN
        SetCurrLine (ed, StartLine + LONG(windLines) - 1) 
      ELSE
        SetCurrLine (ed, currLineNr + 1);
      END;
      currRow := BinOps.LowerInt(currRow, editLen);
      EditGlobals.FixCursorPos (ed);
    END;
    CenterCurrline (ed);
    ShowCursor(ed);
    ShowMouse (FALSE);
  END;
END CursorDown;

PROCEDURE CursorUp (ed : EDITPTR; ctrl : BOOLEAN);
BEGIN
  WITH ed^ DO
    HideMouse();
    HideCursor (ed);
    IF block & ~readOnly THEN 
      SetCurrLine (ed, blocks[0].blockStart.line);
      currRow := blocks[0].blockStart.row;
      EditGlobals.FixCursorPos (ed);
      ClearBlock (ed); 
    END;
    IF ((currLineNr = StartLine) & (currLineNr > 0)) OR (readOnly & ~multiBlockMark) THEN
      IF ctrl THEN
        WdwManager.PageUp (ed^.wdw)
      ELSE
        WdwManager.ScrollUp(ed^.wdw, 1);
      END;
    ELSIF ((currLineNr - StartLine) # 0) & (currLineNr > 0) THEN
      IF ctrl THEN
        SetCurrLine (ed, StartLine)
      ELSE
        SetCurrLine (ed, currLineNr-1);
      END;
      currRow := BinOps.LowerInt(currRow, editLen);
      EditGlobals.FixCursorPos (ed);
    END;
    ShowCursor(ed);
    ShowMouse (FALSE);
  END;
END CursorUp;

PROCEDURE CursorLeft (ed : EDITPTR; kstate : BITSET);
  VAR l : INTEGER;
BEGIN
  HideMouse();
  HideCursor (ed);
  WITH ed^ DO
    IF block & ~readOnly THEN 
      SetCurrLine (ed, blocks[0].blockStart.line);
      currRow := blocks[0].blockStart.row;
      EditGlobals.FixCursorPos (ed);
      ClearBlock (ed);
      ShowCursor (ed);
      ShowMouse (FALSE);
      RETURN;
    END;
    IF readOnly & ~multiBlockMark
    THEN
      IF CatGlobal.WithShift (kstate) THEN
        WdwManager.PageLeft (ed^.wdw);
      ELSE
        WdwManager.ScrollLeft (ed^.wdw, 1);
      END;
    ELSIF currRow = 0 THEN
      IF currLineNr > StartLine THEN
        SetCurrLine (ed, currLineNr - 1);
        currRow := editLen;
      ELSIF StartLine > 0 THEN
        WdwManager.ScrollUp(ed^.wdw, 1);
        currRow := editLen;
      END;
    ELSIF CatGlobal.WithCtrl (kstate) THEN
      currRow := FindLast(ed, FALSE); 
    ELSIF (0 IN kstate) OR (1 IN kstate) THEN
      currRow := 0; 
    ELSIF currRow > 0 THEN
      DEC(currRow);
    END;
    EditGlobals.FixCursorPos (ed);
  END (* WITH ed^ DO *);
  ShowCursor (ed);
  ShowMouse (FALSE);
END CursorLeft;

PROCEDURE CursorRight(ed : EDITPTR; kstate : BITSET);
  VAR l : INTEGER;
      m : aMark;
BEGIN
  HideMouse();
  HideCursor (ed);
  WITH ed^ DO
    IF block & ~readOnly THEN
      SetCurrLine (ed, blocks[0].blockEnd.line);
      currRow := blocks[0].blockEnd.row;
      EditGlobals.FixCursorPos (ed);
      ClearBlock (ed); 
      ShowCursor (ed);
      ShowMouse (FALSE);
      RETURN;
    END;
    IF readOnly & ~multiBlockMark
    THEN
      IF CatGlobal.WithShift (kstate) THEN
        WdwManager.PageRight (ed^.wdw);
      ELSE
        WdwManager.ScrollRight (ed^.wdw, 1);
      END;
    ELSIF (editLine.text^[currRow] = CR) OR (editLine.text^[currRow] = LF)  (* currRow >= l *)
    THEN 
      (* Zeilenende *) 
      IF (currLineNr-StartLine < LONG(windLines)-1) & (currLineNr < totalLineNr - 1) THEN
        SetCurrLine (ed, currLineNr + 1);
        currRow := 0;
      ELSIF currLineNr < totalLineNr - 1
      THEN
        WdwManager.ScrollDown (ed^.wdw, 1);
        currRow := 0;
      END;
    ELSIF kstate = {}
    THEN
      INC (currRow);
    ELSIF CatGlobal.WithCtrl (kstate) THEN
      currRow := FindNext(ed, FALSE, editLen);
    ELSIF (0 IN kstate) OR (1 IN kstate) THEN
      currRow := editLen; 
    END;
    EditGlobals.FixCursorPos (ed);
  END (* WITH ed^ DO *);
  ShowCursor (ed);
  ShowMouse (FALSE);
END CursorRight;

PROCEDURE AllUp (text : textPtr);
BEGIN
  Strings.Upper (text^);
END AllUp;

PROCEDURE AllLower (text : textPtr);
BEGIN
  Strings.Lower (text^);
END AllLower;

PROCEDURE SwapUpperLower (text : textPtr);
  VAR i : INTEGER;
BEGIN
  i := 0;
  LOOP
    IF text^[i] = 0C THEN EXIT END;
    IF Characters.IsUpper (text^[i])
    THEN
      Strings.Lower (text^[i]);
    ELSIF Characters.IsLower (text^[i])
    THEN
      Strings.Upper (text^[i]);
    END;
    INC (i);
  END;
END SwapUpperLower;

PROCEDURE Capitalise (text : textPtr);
  VAR i : INTEGER;
BEGIN
  i := 0;
  LOOP
    WHILE (text^[i] IN TrennSet) & (text^[i] # 0C) DO INC (i); END;
    IF text^[i] = 0C THEN EXIT END;
    Strings.Upper (text^[i]);
    INC(i);
    WHILE ~(text^[i] IN TrennSet) & (text^[i] # 0C) DO 
      Strings.Lower (text^[i]);
      INC (i); 
    END;
  END;
END Capitalise;

PROCEDURE Mirror (text : textPtr);
  VAR i : INTEGER;
      ch: CHAR;
BEGIN
  i := 0;
  LOOP
    ch := text^[i];
    IF ch = 0C THEN EXIT END;
    IF (ch >= "A") & (ch <= "Z")
    THEN
      ch := CHR(ORD('A')+ORD('Z')-ORD(ch));
    END;
    IF (ch >= "a") & (ch <= "z")
    THEN
      ch := CHR(ORD('a')+ORD('z')-ORD(ch));
    END;
    text^[i] := ch;
    INC(i);
  END;
END Mirror;

PROCEDURE Rot18 (text : textPtr);
  VAR i : INTEGER;
      p : INTEGER;
      ch: CHAR;
      table : ARRAY [0..62] OF CHAR;
BEGIN
  i := 0;
  table := "STUVWXYZ0123456789ABCDEFGHIJKLMNOPQRnopqrstuvwxyzabcdefghijklm";
  (* Erst mal radikal growandeln *)
  LOOP
    ch := text^[i];
    IF ch = 0C THEN EXIT END;
    p := Strings.Pos(ch, "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789abcdefghijklmnopqrstuvwxyz", 0);
    IF p >= 0
    THEN
      text^[i] := table[p];
    END;
    INC(i);
  END;
END Rot18;

PROCEDURE RotXX (text : textPtr);
  VAR i : INTEGER;
      ch: CHAR;
BEGIN
  i := 0;
  (* Erst mal radikal growandeln *)
  LOOP
    ch := text^[i];
    IF ch = 0C THEN EXIT END;
    IF (ch >= "A") & (ch <= "Z")
    THEN
      text^[i] := CHR( (((ORD(ch) - ORD('A')) + rotateFaktor) MOD 26) + ORD ('A'));
    END;
    IF (ch >= "a") & (ch <= "z")
    THEN
      text^[i] := CHR( (((ORD(ch) - ORD('a')) + rotateFaktor) MOD 26) + ORD ('a'));
    END;
    INC(i);
  END;
END RotXX;

PROCEDURE Protect (text : textPtr);
  VAR l : CARDINAL;
BEGIN
  l := (*SYSTEM.*)LENGTH (text^);
  WHILE (l > 0) & ((text^[l-1] = CR) OR (text^[l-1] = LF)) DO DEC (l) END;
  text^[l] := CR;
  text^[l+1] := LF;
  text^[l+2] := 0C;
END Protect;

PROCEDURE XXDecode (text: textPtr);
  VAR l : CARDINAL;
      saveCh : CHAR;
BEGIN
  l := (*SYSTEM.*)LENGTH (text^);
  WHILE (l > 0) & ((text^[l-1] = CR) OR (text^[l-1] = LF)) DO DEC (l) END;
  saveCh := text^[l];
  text^[l] := 0C;
  v.bool := UUDecode.DecodeLine (text^);
  text^[l] := saveCh;
END XXDecode;

PROCEDURE TransformBlock (ed : EDITPTR; trans : formFunc; wholeLines : BOOLEAN);
  VAR ch2       : POINTER TO CHAR;
      save2     : CHAR;
      text, t1  : textPtr;
      le        : INTEGER;
      l         : LONGINT;
      frame     : Rectangle;
      blS, blE  : aMark;
      oldCurrLine: LONGINT;
      oldRow    : INTEGER;
BEGIN
  (* Ruft fr jede Zeile im Block die Funktion trans auf 
   * Anfang und Ende werden entsprechend umgeformt!
   *)
  WITH ed^ DO
    oldCurrLine := currLineNr;
    oldRow := currRow;
    ShowFileChanged (ed);
    IF wholeLines THEN
      blS := blocks[0].blockStart;
      blE := blocks[0].blockEnd;
      blocks[0].blockStart.row := 0;
      IF blocks[0].blockEnd.line = totalLineNr - 1
      THEN
        blocks[0].blockEnd.row := ToLineEnd (ed, blocks[0].blockEnd.line);
      ELSE
        blocks[0].blockEnd.row := 0;
        INC (blocks[0].blockEnd.line);
      END;
    END;
    SaveOp (ed, blockPaste, FALSE); 
    SetCurrLine (ed, blocks[0].blockStart.line);
    currRow := blocks[0].blockStart.row;
    EditGlobals.FixCursorPos (ed);
    IF blocks[0].blockStart.line = blocks[0].blockEnd.line 
    THEN
      IF ~wholeLines THEN
        (* Nur Block in einer Zeile *)
        t1 := ADR (editLine.text^[blocks[0].blockStart.row]);
        ch2 := ADR (editLine.text^[blocks[0].blockEnd.row]);
        save2 := ch2^;
        ch2^ := 0C;
      ELSE
        t1 := editLine.text;
      END;
      trans (t1);
      IF ~wholeLines THEN
        ch2^ := save2;
      END;
      editChanged := TRUE;
      editLen := (*SYSTEM.*)LENGTH (editLine.text^);
      v.bool := EditBase.PutCurrLine (ed);
    ELSE
      (* mehrzeiliger Block *)
      l := blocks[0].blockStart.line;
      WHILE l <= blocks[0].blockEnd.line DO
        le := editLen;
        IF wholeLines THEN AllocNew (editLine, editLen + 3) END;
        WITH editLine DO
          IF (l = blocks[0].blockStart.line) & (blocks[0].blockStart.row > 0) & ~wholeLines THEN
            (* Nur Teilweise bearbeiten *)
            t1 := ADR (text^[blocks[0].blockStart.row]);
            trans (t1);
          ELSIF (l = blocks[0].blockEnd.line) & (blocks[0].blockEnd.row < le) & ~wholeLines  THEN
            (* ebenfalls nur teilweise bearbeiten *)
            ch2 := ADR (text^[blocks[0].blockEnd.row]);
            save2 := ch2^;
            ch2^ := 0C;
            trans (text);
            ch2^ := save2;
          ELSE
            trans (text);
          END;
        END (* WITH editLine *);
        editChanged := TRUE;
        editLen := (*SYSTEM.*)LENGTH (editLine.text^);
        SetCurrLine (ed, currLineNr + 1);
        INC (l);
      END (* WHILE *);
    END; (* IF blockStart.line = blockEnd.line *)
    (* Noch Blockstart fr Undobuffer merken *)
    NewBlockToUndoBuffer (ed);
    IF wholeLines
    THEN
      blocks[0].blockStart := blS;
      blocks[0].blockEnd := blE;
    END;
    currRow := oldRow;
    SetCurrLine (ed, oldCurrLine);
    (* Jetzt noch redraw von blockstart bis blockende *)
    redrawLineArea (ed, blocks[0].blockStart.line, blocks[0].blockEnd.line);
  END; 
END TransformBlock;

PROCEDURE Home (ed : EDITPTR; ende : BOOLEAN); 
  VAR newLine : LONGINT;
      dir     : INTEGER;
BEGIN
  WITH ed^ DO
    HideMouse(); 
    HideCursor (ed);
    IF block & ~readOnly THEN ClearBlock (ed); END;
    IF ende THEN
      newLine := BinOps.HigherLInt(0, totalLineNr - LONG(windLines));
      IF (newLine # StartLine) & (newLine # 0) THEN
        SetStartLine (ed, newLine, TRUE);
      END;
      SetCurrLine (ed, totalLineNr-1);
      currRow := editLen;
      EditGlobals.FixCursorPos (ed);
    ELSE (* IF Ende *)
      IF StartLine # 0 THEN
        SetStartLine (ed, 0, TRUE);
      END;
      SetCurrLine (ed, 0);
      currRow := 0;
    END;
    ShowCursor(ed);
    ShowMouse (FALSE);
  END (* WITH ed^ DO *);
END Home;

PROCEDURE SwapLines (ed : EDITPTR; withUp : BOOLEAN);
  VAR l : LONGINT;
      swap : aLineDesc;
      len  : INTEGER;
BEGIN
  WITH ed^ DO
    IF block THEN RETURN END;
    IF withUp THEN
      l := currLineNr-1;
    ELSE
      l := currLineNr+1;
    END;
    IF (l < 0) OR (l >= totalLineNr) THEN RETURN END;
    ShowFileChanged (ed);
    HideMouse ();
    HideCursor (ed);
    v.bool := EditBase.GetLineLength (ed, l, len);
    ALLOCATE (swap.text, len+2);
    IF swap.text = NIL THEN RETURN END;
    v.bool := EditBase.GetLine (ed, l, swap.text^, len);
    IF len > editLen THEN 
      v.bool := EditBase.PutLine (ed, l, editLine.text^, editLen);
      v.bool := EditBase.PutLine (ed, currLineNr, swap.text^, len);
    ELSE
      v.bool := EditBase.PutLine (ed, currLineNr, swap.text^, len);
      v.bool := EditBase.PutLine (ed, l, editLine.text^, editLen);
    END;
    editChanged := FALSE;
    drawLine (ed, SHORT(currLineNr-StartLine));
    IF withUp THEN
      drawLine (ed, SHORT(currLineNr-StartLine)-1);
      SetCurrLine (ed, currLineNr-1);
    ELSE
      drawLine (ed, SHORT(currLineNr-StartLine)+1);
      SetCurrLine (ed, currLineNr+1);
    END;
    DEALLOCATE (swap.text, 0);
    CenterCurrline (ed);
    ShowCursor (ed);
    ShowMouse (FALSE);
  END (* WITH ed^ DO *)
END SwapLines;

                (* IO-Routinen *)

                (* allgemeine Saveroutine *)
                
VAR buffer : POINTER TO ARRAY [$0L..$1FFFFL] OF CHAR;
    bufPos, bufSize : LONGCARD;

  PROCEDURE WriteBuffered (fHdl : INTEGER; VAR l : LONGCARD; buf : ADDRESS);
    VAR (*$Reg*) remain  : LONGCARD;
        (*$Reg*) wrBytes : LONGCARD;
        (*$Reg*) ptr     : POINTER TO ARRAY [0..$FFFFFFFF] OF CHAR;
  BEGIN
    IF l+bufPos > bufSize
    THEN
      remain := l-(bufSize-bufPos);
      Block.Copy (buf, bufSize-bufPos, ADR(buffer^[bufPos]));
      INC(bufPos, bufSize-bufPos);
      wrBytes := bufPos;
      MagicDOS.Fwrite (fHdl, bufPos, buffer);
      IF bufPos # wrBytes
      THEN
        l := bufPos;
        RETURN
      END;
      ptr := buf;
      Block.Copy (ADR(ptr^[l-remain]), remain, buffer);
      bufPos := remain;
    ELSE
      Block.Copy (buf, l, ADR(buffer^[bufPos]));
      INC(bufPos,l);
    END;
  END WriteBuffered;
  
  PROCEDURE WritePrinter (fHdl : INTEGER; VAR l : LONGCARD; buf : ADDRESS);
    VAR str : textPtr;
  BEGIN
    IF l > bufSize
    THEN
      str := textPtr (buf);
      IF str^[0] = CR
      THEN
        IF Printer.Response = Printer.done THEN Printer.WriteLn(); END;
      ELSE
        IF Printer.Response = Printer.done THEN Printer.WriteString (str^); END;
      END;
    ELSE
      Block.Copy (buf, l, buffer);
      str := textPtr (buffer);
      str^[SHORT(l)] := 0C;
      IF (l>0) & (str^[SHORT(l)-1] = CR) THEN str^[SHORT(l)-1] := 0C END;
      IF str^[0] = CR
      THEN
        IF Printer.Response = Printer.done THEN Printer.WriteLn(); END;
      ELSE
        IF Printer.Response = Printer.done THEN Printer.WriteString (str^); END;
      END;
    END;
  END WritePrinter;

PROCEDURE outputText (ed : EDITPTR; fromLine : LONGINT; fromRow : INTEGER;
                      toLine : LONGINT; toRow : INTEGER; fHdl : INTEGER; umbruch : BOOLEAN;
                      usePrintMod : BOOLEAN) : BOOLEAN;
  CONST CrLf = 15C+12C+0C;
        Cr   = 15C+0C;
        Lf   = 12C+0C;

  VAR line : LONGINT;
      saveall : BOOLEAN;
      i    : LONGINT;
      wlen : LONGCARD;
      len  : LONGCARD;
      length   : INTEGER;
      writeAdr : textPtr;
      writeProc : PROCEDURE (INTEGER, VAR LONGCARD, ADDRESS);
      chPtr : POINTER TO CHAR;
      writeCR : BOOLEAN;
      writeLF : BOOLEAN;
      text    : textPtr;
      buff    : aBufferPtr;
      s       : ARRAY [0..255] OF CHAR;
      margin  : INTEGER;
      marginStr : ARRAY [0..12] OF CHAR;

BEGIN
  MouseBusy();
  saveall := toLine < fromLine;
  buffer := NIL;
  bufSize := $F000;
  WHILE buffer = NIL DO
    ALLOCATE (buffer, bufSize);
    IF buffer = NIL THEN DEC(bufSize, $100) END;
  END;
  IF bufSize = 0
  THEN
    writeProc := MagicDOS.Fwrite;
  ELSE
    IF usePrintMod 
    THEN
      writeProc := WritePrinter;
      ConfVars.GetConfDefInt (cPrtMargin, margin, 0);
      IF margin > 0 THEN
        Strings.Assign (Strings.Space (margin), marginStr, v.bool);
      END;
    ELSE
      writeProc := WriteBuffered;
    END;
  END;
  bufPos := 0;
  IF saveall & ~(usePrintMod OR ed^.readOnly)
  THEN
    WITH ed^ DO
      buff := firstBuff;
      WHILE buff # NIL DO
        len := buff^.usedMem;
        writeProc (fHdl, len, buff^.buffer);
        IF len # LONGCARD(LONG(buff^.usedMem))
        THEN
          (* Schreibfehler! *)
          MouseArrow();
          MTE.info (MTE.NoWrite);
          RETURN FALSE;
        END;
        buff := buff^.next;
      END;
    END;
  ELSE
  (* Nur langsames, zeilenweises sichern *)
    IF saveall & (usePrintMod OR ed^.readOnly)
    THEN 
      fromLine := 0; fromRow := 0;
      toLine := ed^.totalLineNr - 1;
      v.bool := EditBase.GetLineLength (ed, toLine, toRow);
      (* Extinfo ausgeben, falls vorhanden *)
      IF ed^.readOnly & ~usePrintMod & 
         (ADDRESS(ed^.userPrint) # NIL)
       & ed^.userPrint (ed^.wdw, LFIRST, s)
      THEN
        (* erste Zeile ausgeben *)
        writeAdr := ADR(s);
        REPEAT
          len := LONG(LENGTH(s));
          wlen := len;
          writeProc (fHdl, wlen, writeAdr);
          IF wlen # len
          THEN
            (* Schreibfehler! *)
            MouseArrow();
            MTE.info (MTE.NoWrite);
            RETURN FALSE;
          END;
          (* CR/LF schreiben *)
          wlen := 2;
          writeProc (fHdl, wlen, CADR(CrLf));
          IF wlen # 2 
          THEN
            MouseArrow ();
            MTE.info (MTE.NoWrite);
            RETURN FALSE
          END;
        UNTIL ~ed^.userPrint (ed^.wdw, LNEXT, s);
      END;
    END;
    line := fromLine;
    i := fromLine;
    WHILE line <= toLine DO
      v.bool := EditBase.GetLineAdr (ed, line, writeAdr, length);
      len := VAL (LONGCARD, length);
      IF i = fromLine
      THEN
        INC (writeAdr, fromRow);
        len := LONGCARD(BinOps.HigherLInt ( 0, LONGINT(len)-LONG(fromRow)));
      END;
      IF i = toLine
      THEN
        DEC (len, length - toRow);
      END;
      (* CR/LFs am Zeilenende entfernen *)
      writeLF := FALSE;
      writeCR := FALSE;
      WHILE (len > 0) & ((writeAdr^[SHORT(len-1)]=CR) OR (writeAdr^[SHORT(len-1)]=LF)) DO
        IF writeAdr^[SHORT(len-1)]=LF THEN writeLF := TRUE END;
        IF writeAdr^[SHORT(len-1)]=CR THEN writeCR := TRUE END;
        DEC (len);
      END;
      IF ed^.readOnly
      THEN
        writeLF := TRUE;
        writeCR := TRUE;
      END;
      IF (i>= fromLine) & (i <= toLine)
      THEN
        IF usePrintMod & (margin > 0) THEN 
          IF Printer.Response = Printer.done THEN Printer.WriteString (marginStr); END;
        END;
        wlen := len;
        writeProc (fHdl, wlen, writeAdr);
        IF wlen # len
        THEN
          (* Schreibfehler! *)
          MouseArrow();
          MTE.info (MTE.NoWrite);
          RETURN FALSE;
        END;
      END;
      IF (i >= fromLine) & (i <= toLine)
      THEN
        IF (writeLF & writeCR)
        THEN
          len := 2;
          writeAdr := CADR (CrLf);
        ELSIF writeLF
        THEN
          len := 1;
          writeAdr := CADR (Lf);
        ELSIF (writeCR & ~umbruch) OR (writeCR & usePrintMod)
        THEN
          len := 1;
          writeAdr := CADR (Cr);
        ELSE
          len := 0;
        END;
        IF usePrintMod
        THEN
          IF Printer.Response = Printer.done THEN Printer.WriteLn() END;
        ELSIF ~((i = toLine) & (toRow # length)) & (len > 0)
        THEN
          wlen := len;
          writeProc (fHdl, len, writeAdr);
          IF len # wlen
          THEN
            (* Schreibfehler! *)
            MouseArrow();
            MTE.info (MTE.NoWrite);
            RETURN FALSE;
          END;
        END;
      END; 
      INC (line);
      INC(i);
    END; (* WHILE line <= toLine *)
  END;
  IF (bufSize > 0) & (bufPos > 0)
  THEN
    IF ~usePrintMod
    THEN
      (* Buffer noch flushen *)
      wlen := bufPos;
      MagicDOS.Fwrite (fHdl, bufPos, buffer);
    END;
    IF (wlen # bufPos) & ~usePrintMod
    THEN
      MouseArrow();
      MTE.info (MTE.NoWrite);    
      RETURN FALSE;
    END;
  END;
  IF bufSize > 0
  THEN
    DEALLOCATE (buffer, 0);
  END;
  MouseArrow();
  RETURN TRUE;
END outputText;

PROCEDURE KillEditor (VAR ed : EDITPTR);
  VAR line : aLinePtr;
      edi  : EDITPTR;
BEGIN
  WITH ed^ DO
    WHILE firstBuff # NIL DO
      currentBuff := firstBuff;
      EditBase.FreeBuffer (ed);
    END;
    DEALLOCATE (editLine.text, 0);
    IF fileName.text # NIL THEN DEALLOCATE (fileName.text, 0); END;
  END; (* WITH ed *)
  IF editList # ed
  THEN
    edi := editList; 
    WHILE edi^.nextEdit # ed DO
      (* ed suchen in Liste *)
      edi := edi^.nextEdit;
    END;
    edi^.nextEdit := ed^.nextEdit;
  ELSE
    editList := ed^.nextEdit
  END;
  DISPOSE (ed);
  IF editList = NIL
  THEN
    (* letzter Editor geschlossen *)
    FreeUndoBuffer();
  END;
END KillEditor;
 
PROCEDURE CreateEditor(VAR ed : EDITPTR) : BOOLEAN;
  VAR currEd : EDITPTR;
      found  : BOOLEAN;
BEGIN
  found := FALSE;
  NEW (ed);
  IF ed = NIL THEN RETURN FALSE END;
  IF editList = NIL
  THEN 
    (* noch kein Editor da! *)
    editList := ed;
    ed^.nextEdit := NIL;
  ELSE
    currEd := editList;
    WHILE (currEd # NIL) & ~found DO
      IF currEd^.nextEdit = NIL
      THEN 
        found := TRUE
      ELSE
        currEd := currEd^.nextEdit;
      END;
    END;
    IF found THEN
      currEd^.nextEdit := ed;
      WITH ed^ DO
        currentBuff := NIL;
        firstBuff := NIL;
      END;
    ELSE
      DISPOSE (ed);
      ed := NIL;
      RETURN FALSE
    END;
  END;
  WITH ed^ DO
    wdw := -1;
    StartLine := 0;
    currLineNr := 0;
    totalLineNr := 1;
    tabSize := 4;
    currRow := 0;
    currentBuff := NIL;
    editLine.text := NIL;
    ALLOCATE (editLine.text, 16);
    IF editLine.text = NIL THEN RETURN FALSE END;
    editLine.length := 16;
    editLine.text^[0] := "";
    firstBuff := NIL;
    multiBlockMark := FALSE;
    multiBlockIdx := -1;
    editChanged := FALSE;
    editLen := 0;
    nextEdit := NIL;
    parseEffects := FALSE;
    userDD := FALSE;
    isEnriched := FALSE;
  END;
  RETURN TRUE
END CreateEditor;

PROCEDURE ReadBuffer (VAR ed : EDITPTR; VAR buf: ADDRESS; len : LONGCARD; 
                      freeBuffer: BOOLEAN; VAR err: ErrReason) : BOOLEAN;
  VAR allocSize : INTEGER;
      chkLen,
      i         : INTEGER;  
      ptr       : textPtr;
      isText    : BOOLEAN;
      ch        : CHAR;
BEGIN
  WITH ed^ DO
  (*
    (* Erstmal den Buffer prfen *)
    IF len > 100
    THEN
      chkLen := 100;
    ELSE
      chkLen := VAL (INTEGER,len);
    END;
    ptr := buf;
    i := 0;
    isText := TRUE;
    WHILE (i < chkLen) & isText DO
      ch := ptr^[i];
      IF (ORD (ch) < 32) & 
         ~(ch IN CharSet{0c, TAB, CR, LF, 20C, 21C, 25C, 32C})
      THEN
        isText := FALSE;
      END;
      INC (i);
    END;
    IF ~isText
    THEN
      MouseArrow();
      MTE.info (noTextErr);
      err := noTextError;
      RETURN FALSE
    END;
    *)
    err := memError;
    IF firstBuff = NIL
    THEN 
      IF readOnly & (len + 50 < EditBase.memBlockSize)
      THEN
        allocSize := INTEGER(SHORT(len) + 50);
      ELSE
        allocSize := EditBase.memBlockSize
      END;
      IF ~EditBase.GetBuffer (ed, allocSize)
      THEN RETURN FALSE END;
      currentBuff := firstBuff;
      WITH currentBuff^ DO
        fromLine := 0;
        toLine := 0;
        usedMem := 0;
      END;
      currLineNr := 0;
      currRow := 0;
      totalLineNr := 1;
    END;
    IF editChanged THEN v.bool := EditBase.PutCurrLine (ed); END;
    IF EditBase.InsertBuffer (ed, buf, len, freeBuffer)
    THEN
      UpdateCurrLine (ed, currLineNr);
      RETURN TRUE
    ELSE
      RETURN FALSE
    END;
  END;
END ReadBuffer;

PROCEDURE readText (VAR ed : EDITPTR; fastRead : BOOLEAN;
                    flen : LONGCARD; VAR fHdl : INTEGER;
                    right : INTEGER; VAR readBuf : ADDRESS; 
                    inLine : BOOLEAN; fullText : BOOLEAN) : BOOLEAN;
  CONST smallBufSize = 28000L;

  VAR readBytes : LONGCARD;
      tmpEd     : EDITPTR;
      cLine     : LONGINT;
      clLine    : LONGINT;
      cRow      : INTEGER;
      i,
      spaces    : INTEGER;
      err       : ErrReason;
      bufPos    : LONGCARD;
      rb        : LONGCARD;
      wasBlock  : BOOLEAN;
      bEnd      : aMark;
      text      : textPtr;
      ch        : CHAR;

PROCEDURE CheckMM2Format ();
BEGIN
  WITH ed^ DO
    IF fullText
    THEN
      WITH ed^ DO
        (* Position sichern *)
        clLine := currLineNr;
        cRow := currRow;
        (* Anpassung an MM2-Kurzformat *)
        cLine := 0;
        SetCurrLine (ed, cLine);
        (* Erstmal prfen, ob berhaupt was gewandelt werden mu! *)
        IF editLine.text^[0] = 20C
        THEN
          (* Ok, ist MM2-Kurzformat, wandeln *)
          WHILE cLine < ed^.totalLineNr DO
            SetCurrLine (ed, cLine);
            IF (editLen > 1) & (editLine.text^[0] = 20C) & (ORD(editLine.text^[1]) >= 32)
            THEN
              (* change line *)
              spaces := BinOps.HigherInt (0, ORD (editLine.text^[1]) - 32);
              AllocNew (editLine, editLen  + spaces + 2);
              Strings.Delete (editLine.text^, 0, 2, v.bool);
              IF (spaces > 0) & (spaces < 80) THEN 
                Strings.Insert (Strings.Space (spaces), 0, editLine.text^, v.bool);
              END;
              (* Zeilenende anpassen *)
              editLen := editLen + spaces - 2;
              i := editLen;
              WHILE editLine.text^[i] # 0C DO INC (i) END;
              DEC (i);
              WHILE (i >= 0) & ((editLine.text^[i] = CR) OR (editLine.text^[i] = LF)) DO DEC (i) END;
              INC (i);
              editLine.text^[i] := CR;
              editLine.text^[i+1] := LF;
              editLine.text^[i+2] := 0C;
              editLen := LENGTH (editLine.text^);
              editChanged := TRUE;
            END;
            INC (cLine);
          END;
        END;
        (* Position restaurieren *)
        SetCurrLine (ed, clLine);
        currRow := cRow;
      END;
    END;
  END;
END CheckMM2Format;

BEGIN
  IF fastRead THEN
    readBytes := flen;
    MagicDOS.Fread (fHdl, readBytes, readBuf);
    IF readBytes # flen THEN
      (* nicht alles gelesen! *)
      IF SHORT(LONGINT(readBytes)) = -37
      THEN
        CatFiles.ErrorAlert (-37)
      ELSE
        v.int := mtAlerts.Alert (1, readErr);
      END;
      v.int := MagicDOS.Fclose (fHdl);
      RETURN FALSE;
    END;
    v.int := MagicDOS.Fclose (fHdl);
    CatFiles.ErrorAlert (v.int);
    v.bool := EditBase.PutCurrLine (ed);
    fHdl := 0;
    (* Text aus Buffer in Editor Zeilenweise bertragen *)
    HideCursor (ed);
    MouseBusy();
    ed^.rightMargin := right;
    (*
    IF ~fullText 
    THEN
      IF ~EditBase.InsertBuffer (ed, readBuf, flen)
      THEN
        IF readBuf # NIL THEN DEALLOCATE (readBuf, 0); END;
        HideMouse();
        ShowCursor (ed);
        MouseArrow();
        RETURN FALSE
      END;
        
    ELSE
    *)
      IF ~ReadBuffer (ed, readBuf, flen, TRUE, err)
      THEN
        IF readBuf # NIL THEN DEALLOCATE (readBuf, 0); END;
        HideMouse();
        ShowCursor (ed);
        ShowMouse (FALSE); 
        MouseArrow();
        CASE err OF
          memError : OutOfMem(); |
          readError: (* schon behandelt, tritt nicht auf *) |
          noTextError : (* Fehlermeldung kam schon *) |
        ELSE
        END;
        RETURN FALSE
      END;
(*    END; *)
    (* 2 Buffer wieder freigeben *)
    IF readBuf # NIL THEN DEALLOCATE (readBuf, 0); END;
    CheckMM2Format();
    SetDocument (ed);
    HideMouse();
    ShowCursor (ed);
    ShowMouse (FALSE); 
    MouseArrow();
  ELSE
    (* langsames Lesen des Textes *)
    IF readBuf # NIL THEN DEALLOCATE (readBuf,0); END;
    ALLOCATE (readBuf, smallBufSize);
    IF readBuf = NIL
    THEN
      OutOfMem();
      RETURN FALSE;
    END;
    v.bool := EditBase.PutCurrLine (ed);
    (* Text aus Buffer in Editor Zeilenweise bertragen *)
    HideCursor (ed);
    MouseBusy();
    WITH ed^ DO
      rightMargin := right;
      bufPos := 0;
      clLine := currLineNr;
      cRow := currRow;
      wasBlock := block;
      bEnd := blocks[0].blockEnd;
      block := TRUE;
      WHILE bufPos < flen DO
        v.lcard := MagicDOS.Fseek (bufPos, fHdl, MagicDOS.SeekStart);
        readBytes := BinOps.LowerLCard (flen - bufPos, smallBufSize);
        rb := readBytes;
        MagicDOS.Fread (fHdl, readBytes, readBuf);
        IF readBytes # rb THEN
          (* nicht alles gelesen! *)
          IF INT(readBytes) = -37
          THEN
            CatFiles.ErrorAlert (-37)
          ELSE
            v.int := mtAlerts.Alert (1, readErr);
          END;
          v.int := MagicDOS.Fclose (fHdl);
          RETURN FALSE;
        END;
        (* Jetzt ausgehend vom Ende des Buffers ein Zeilenende suchen 
         * und nur bis dahin einlesen
         *)
        IF bufPos + readBytes < flen 
        THEN
          text := readBuf;
          ch := text^[SHORT(readBytes)-1];
          WHILE (ch # CR) & (ch # LF) & (readBytes > 0) DO
             DEC (readBytes); 
             ch := text^[SHORT(readBytes)-1];
          END;
        END;
        IF ~ReadBuffer (ed, readBuf, readBytes, FALSE, err)
        THEN
          IF readBuf # NIL THEN DEALLOCATE (readBuf, 0); END;
          HideMouse();
          ShowCursor (ed);
          ShowMouse (FALSE); 
          MouseArrow();
          CASE err OF
            memError : OutOfMem(); |
            readError: (* schon behandelt, tritt nicht auf *) |
            noTextError : (* Fehlermeldung kam schon *) |
          ELSE
          END;
          v.int := MagicDOS.Fclose (fHdl);
          CatFiles.ErrorAlert (v.int);
          RETURN FALSE
        END;
        IF blocks[0].blockEnd.line > totalLineNr - 1
        THEN
          blocks[0].blockEnd.line := totalLineNr - 1;
          v.bool := EditBase.GetLineLength (ed, blocks[0].blockEnd.line, blocks[0].blockEnd.row);
        END;
        SetCurrLine (ed, blocks[0].blockEnd.line);
        currRow := blocks[0].blockEnd.row;
        INC (bufPos, readBytes);
      END;
      v.int := MagicDOS.Fclose (fHdl);
      CatFiles.ErrorAlert (v.int);
      DEALLOCATE (readBuf, 0);
      (* Position restaurieren *)
      block := wasBlock;
      blocks[0].blockEnd := bEnd;
      SetCurrLine (ed, clLine);
      currRow := cRow;
    END;
    CheckMM2Format();
    SetDocument (ed);
    HideMouse();
    ShowCursor (ed);
    ShowMouse (FALSE); 
    MouseArrow();
  END; (* IF fastRead *)
  RETURN TRUE
END readText;

PROCEDURE Goto (ed : EDITPTR; line : LONGINT; row : INTEGER);
BEGIN
  IF line-1 >= 0
  THEN
    HideMouse();
    HideCursor (ed);
    SetCurrLine (ed, line-1);
    ed^.currRow := BinOps.LowerInt (row, ed^.editLen);
    EditGlobals.FixCursorPos (ed);
    CenterCurrline (ed);
    ShowCursor (ed);
    ShowMouse (FALSE);
  END;
END Goto;

PROCEDURE showError (ed : EDITPTR);
 VAR adr : RECORD a,b : ADDRESS; END;
BEGIN
  WITH ed^ DO
    IF errLine >= 0 THEN
      HideMouse();
      HideCursor(ed);
      ClearBlock (ed);
      Goto (ed, errLine, errRow);
      WdwManager.SetWdwInfoline (wdw, errMsg);
      ShowCursor (ed);
      ShowMouse (FALSE);
    ELSE
      WdwManager.SetWdwInfoline (wdw, errMsg);
    END;
  END;
END showError;

(*$? NOT CAT:

(* Funktionen und Typen fr QED-kompatible Krzeldateien 
 *)

TYPE shortElem = RECORD
                   val : CARDINAL;  (* ARRAY [0..1] OF CHAR interpreted als Wort *)
                   len : INTEGER;   (* Lnge des Textes *)
                   text: textPtr;   (* Der Pointer auf den Text *)
                 END;
     shortPtr  = POINTER TO shortElem;

     varType = (noVar, comment, string);

VAR shortList:      Lists.List;
    shortListRead:  BOOLEAN;

(*$Z-*)                   
PROCEDURE findValue (entry : ADDRESS; info : ADDRESS) : BOOLEAN;
  VAR theVar : shortPtr;
      theName: POINTER TO CARDINAL;
BEGIN
  theVar := shortPtr (entry);
  theName := info;
  RETURN theVar^.val = theName^;
END findValue;
(*$Z+*)                   

(*$W-*)
PROCEDURE findShortKey (short : CARDINAL; VAR var : shortPtr) : BOOLEAN;
  VAR found : BOOLEAN;
BEGIN
  Lists.ResetList (shortList);
  Lists.ScanEntries (shortList, Lists.forward, findValue, ADR (short), found);
  IF found THEN
    var := Lists.CurrentEntry (shortList);
  ELSE
    var := NIL;
  END;
  RETURN found  & (var # NIL);
END findShortKey;
(*$W+*)

PROCEDURE setKey (theVar : shortElem) : BOOLEAN;
(* verndert eine vorhandene Variable oder erzeugt eine neue 
 *)
 VAR newVar : shortPtr;
BEGIN
  IF ~findShortKey (theVar.val, newVar)
  THEN
    ALLOCATE (newVar, TSIZE (shortElem));
    IF newVar = NIL 
    THEN RETURN FALSE
    END;
    newVar^.val  := theVar.val;
    newVar^.len  := theVar.len;
    newVar^.text := theVar.text;
    Lists.AppendEntry (shortList, newVar, v.bool);
    IF v.bool THEN RETURN FALSE END;
  ELSE
    DEALLOCATE (newVar^.text, 0);
    newVar^.text := theVar.text;
  END;
  RETURN TRUE;
END setKey;

PROCEDURE prep (REF in: ARRAY OF CHAR; VAR name, arg : ARRAY OF CHAR);
  VAR tmp : ARRAY [0..255] OF CHAR;
  BEGIN
    Strings.Split (in,Strings.PosLen (' ',in,0), name,arg, v.bool);
    Strings.DelLeadingBlanks (arg);
    Strings.Split (arg, Strings.PosLen ('=',arg,0)+1,tmp, arg, v.bool);
    IF arg[0] = 0C THEN Strings.Assign (tmp, arg, v.bool) END;
    Strings.DelLeadingBlanks (arg);
    (* YYYY Hier noch Semikolon-Abfrage ndern *)
    Strings.Split (arg, Strings.PosLen (';',arg,0),arg, tmp, v.bool);
    Strings.DelLeadingBlanks (arg);
    Strings.DelTrailingBlanks (arg);
  END prep;

PROCEDURE getNameAndType (REF line : ARRAY OF CHAR; 
                          VAR val: CARDINAL;
                          VAR argStr : ARRAY OF CHAR): varType;
  VAR name : ARRAY [0..127] OF CHAR;
BEGIN
  prep (line, name, argStr);
  IF (name[0] = ';') OR (name[0] = '#') OR (name[0] = 0C) THEN RETURN comment END;
  IF (argStr[0] = 0C) THEN 
    RETURN noVar 
  END;
  Strings.DelLeadingBlanks (name);
  val := ORD(name[0])*255 + ORD(name[1]);
  RETURN string;
END getNameAndType;

PROCEDURE processLine (REF fname, line : ARRAY OF CHAR) : BOOLEAN;
  VAR theVar : shortElem;
      error  : BOOLEAN;
      argStr,
      valStr : ARRAY [0..1023] OF CHAR;

  PROCEDURE getInfoStr (arg : ARRAY OF CHAR; VAR str : ARRAY OF CHAR);
    VAR pos : INTEGER;
        numStr : ARRAY [0..9] OF CHAR;
        p1  : CARDINAL;
  BEGIN
      IF LENGTH (arg) > 0
      THEN
        Strings.Assign (arg,str, v.bool);
        (* Sonderzeichen bersetzen *)
        pos := 0;
        WHILE pos >= 0 DO 
          pos := Strings.Pos ('\', str, pos);
          IF pos >= 0
          THEN
            (* Feststellen, ob die nchsten drei Zahlen sind *)
            Strings.Copy (str, pos+1, 3, numStr, v.bool);
            IF Characters.IsDigit (numStr[0])
             & Characters.IsDigit (numStr[1])
             & Characters.IsDigit (numStr[2])
            THEN
              Strings.Delete (str, pos, 4, v.bool);
              p1 := 0;
              Strings.Insert (CHR(StrConv.StrToCard (numStr, p1, v.bool)), pos, str, v.bool);
            ELSIF (numStr[0] = '\')
            THEN
              (* Ein \ entfernen *)
              Strings.Delete (str, pos, 1, v.bool);
              INC(pos);
            ELSE
              INC(pos);
            END;
          END;
        END;
      ELSE
        error := TRUE;
      END;
    END getInfoStr;

BEGIN
  error := FALSE;
  CASE getNameAndType (line, theVar.val, argStr) OF
    string: getInfoStr  (argStr, valStr);
            IF ~error THEN
              theVar.len := LENGTH (valStr);
              ALLOCATE (theVar.text, theVar.len+1);
              IF theVar.text = NIL THEN RETURN FALSE END;
              Strings.Assign (valStr, theVar.text^, v.bool);
            END; |
    noVar,
    comment: RETURN TRUE |
  ELSE
    error := TRUE;
  END;
  (* Variable richtig eingelesen, also weitermachen *)
  IF ~error
  THEN
    RETURN setKey (theVar);
  END;
  RETURN TRUE;
END processLine;

PROCEDURE FreeShortkeyList ();
  VAR theVar : shortPtr;
BEGIN
  Lists.ResetList (shortList);
  theVar := Lists.NextEntry (shortList);
  WHILE theVar # NIL DO
    Lists.RemoveEntry (shortList, v.bool);
    DEALLOCATE (theVar^.text, 0);
    DEALLOCATE (theVar, 0);
    theVar := Lists.NextEntry (shortList);
  END;
  shortListRead := FALSE;
END FreeShortkeyList;

PROCEDURE ReadShortkeyFile(REF fname: ARRAY OF CHAR);
  VAR s : ARRAY [0..1023] OF CHAR;
      tf    : mtTextfiles.TEXTFILE;
      cont  : BOOLEAN;
BEGIN
  IF shortListRead THEN 
    FreeShortkeyList();
  END;
  IF ~mtTextfiles.OpenTextfile (fname, mtTextfiles.READ, 8192, tf)
  THEN 
    OutOfMem();
    RETURN
  END;
  (* Jetzt Zeilenweise einlesen und dann die einzelnen Zeilen parsen *)
  REPEAT
    mtTextfiles.ReadLine (tf, s);
    mtTextfiles.ReadLn(tf);
    cont := processLine (fname, s);
  UNTIL mtTextfiles.EndofText (tf) OR ~cont;
  mtTextfiles.CloseTextfile (tf);
  shortListRead := TRUE;
  IF ~cont 
  THEN
    OutOfMem();
  END;
END ReadShortkeyFile;

PROCEDURE searchAndReplace (ed : EDITPTR; w, r : ARRAY OF CHAR; pos : searchPos; 
                  direction : searchDir; count : searchCount; 
                  num (* wird nur bei count = nmal benutzt *) : INTEGER;
                  ignoreCase : BOOLEAN; onlyWord : BOOLEAN; 
                  replace : BOOLEAN; ask : BOOLEAN; again : BOOLEAN;
                  doBing : BOOLEAN): BOOLEAN; FORWARD;

PROCEDURE SetEditShort (VAR ed: EDITPTR; theKey: shortPtr);
  VAR cLine, cl2    : LONGINT;
      cRow, cr2     : INTEGER;
      scrLine       : INTEGER;
BEGIN
  WITH ed^ DO
    (* Jetzt Position sichern *)
    cLine := currLineNr;
    cRow := currRow;
    IF putLineInEditor (ed, theKey^.text, theKey^.len, FALSE)
    THEN
      cl2 := currLineNr;
      cr2 := currRow;
      (* Jetzt die Tilde suchen und den Cursor dort positionieren *)
      IF searchAndReplace (ed, "~","", fromPos, backward, searchOne, 1, FALSE, 
                           FALSE, FALSE, FALSE, FALSE, FALSE)
      THEN
        (* Erstmal nachsehen, ob das auch im neuen Bereich ist *)
        IF (currLineNr > cLine) 
        OR ((currLineNr = cLine) & (currRow >= cRow))
        THEN
          (* Tilde entfernen *)
          Strings.Delete (editLine.text^, currRow, 1, v.bool);
          DEC (editLen);
          editChanged := TRUE;
          v.bool := EditBase.PutCurrLine (ed);
        ELSE
          (* Blockmarkierung lschen *)
          blocks[0].blockStart.line := -1;
          blocks[0].blockEnd.line := -1;
          block := FALSE;
          SetCurrLine (ed, cl2);
          currRow := cr2;
        END;
        (* Blockmarkierung lschen *)
        blocks[0].blockStart.line := -1;
        blocks[0].blockEnd.line := -1;
        block := FALSE;
      ELSE
        SetCurrLine (ed, cl2);
        currRow := cr2;
      END;
      (* Redraw auslsen *)
      IF cLine = cl2
      THEN
        redrawLineArea (ed, cLine, cLine);
      ELSE
        CenterCurrline (ed);
        scrLine := BinOps.HigherInt (0, SHORT(cLine - StartLine));
        redrawLines (ed, scrLine);
      END;
      ShowCursor (ed);
    END;
  END;
END SetEditShort;

PROCEDURE InsertShortkey (VAR ed: EDITPTR);
  VAR kurzVal : CARDINAL;
      theKey  : shortPtr;
BEGIN
  (* Erstmal nachsehen, ob wir so ein Krzel haben *)
  WITH ed^ DO
    IF (currRow = 0) OR block THEN RETURN END;
    IF ~shortListRead THEN RETURN END;
    IF (currRow > 1) & (editLine.text^[currRow-2] # ' ')
    THEN 
      (* Erstmal nach Zwei-Zeichen-Krzel suchen *)
      kurzVal := ORD (editLine.text^[currRow-2]) * 255 + 
                 ORD (editLine.text^[currRow-1]);
      IF findShortKey (kurzVal, theKey)
      THEN
        (* gefunden, ersetzen *)
        Strings.Delete (editLine.text^, currRow-2, 2, v.bool);
        DEC (editLen, 2);
        DEC (currRow, 2);
        editChanged := TRUE;
        v.bool := EditBase.PutCurrLine (ed);
        (* Jetzt einsetzen *)
        SetEditShort (ed, theKey);
        RETURN
      END;
    END;
    (* Jetzt nach Ein-Zeichen-Krzel suchen *)
    kurzVal := ORD (editLine.text^[currRow-1]) * 255;
    IF findShortKey (kurzVal, theKey)
    THEN
      (* gefunden, ersetzen *)
      Strings.Delete (editLine.text^, currRow-1, 1, v.bool);
      DEC (editLen);
      DEC (currRow);
      editChanged := TRUE;
      v.bool := EditBase.PutCurrLine (ed);
      (* Jetzt einsetzen *)
      SetEditShort (ed, theKey);
    END;
  END;
END InsertShortkey;

(* Ende von bedingter Compilierung fr Krzel *)
*)

(* Erweiterte Funktionen fr Search & Replace *)
PROCEDURE AskForReplace() : INTEGER;
  VAR moX, moY  : INTEGER;
      moButton  : BITSET;
      kReturn   : INTEGER;
      moKState  : BITSET;
      scan      : INTEGER;
      ch        : CHAR;
      bReturn   : INTEGER;
      event     : BITSET;
      mess      : ADDRESS;
      mrect     : Rectangle;
      valid     : BOOLEAN;
BEGIN
  valid := FALSE;
  LOOP
    (* 5 Sekunden Zeit, um eine Taste zu drcken *)
    event := MagicAES.EvntMulti(
           {MagicAES.MUKEYBD, MagicAES.MUTIMER},
           2, {0},{0}, MagicAES.LeaveRect, mrect, 0, mrect, mess, 5000, 0,
           moX, moY, moButton, kReturn, moKState, scan, ch, bReturn);
    IF MagicAES.MUTIMER IN event
    THEN
      valid := FALSE;
      EXCL (event, MagicAES.MUTIMER);
    END;
    IF MagicAES.MUKEYBD IN event
    THEN
      ch := CAP(ch);
      valid := (ch = 'J') OR (ch='N') OR (ch='Q') OR (ch ='A');
      (* Timer-Event lschen! *)
      MagicAES.EvntTimer (1);
    END;
    IF valid THEN EXIT
    ELSE
      v.int := mtAlerts.Alert (1,askRepl);
      RETURN v.int
    END;    
  END; (* LOOP *)
  IF ch = 'J' THEN RETURN 1 ELSIF ch = 'N' THEN RETURN 2 ELSE RETURN 3 END;
END AskForReplace;


PROCEDURE Bing;
BEGIN
  CatGlobal.Bing (7);
END Bing;

PROCEDURE searchAndReplace (ed : EDITPTR; w, r : ARRAY OF CHAR; pos : searchPos; 
                  direction : searchDir; count : searchCount; 
                  num (* wird nur bei count = nmal benutzt *) : INTEGER;
                  ignoreCase : BOOLEAN; onlyWord : BOOLEAN; 
                  replace : BOOLEAN; ask : BOOLEAN; again : BOOLEAN;
                  doBing: BOOLEAN): BOOLEAN;
(* Suchoperationen: 
 *
 * Start:       aktuelle Position, Top, Ende
 * Richtung:    nach oben, nach unten
 * Anzahl:      erstes, ntes, letztes Vorkommen
 * Modus:       groklein, nurWort
 *)
 VAR found : BOOLEAN;
     f2    : BOOLEAN;
     fc    : INTEGER;
     rw    : ARRAY [0..1023] OF CHAR;
BEGIN
  WITH ed^ DO 
    mtAppl.MouseBusy();
    HideCursor (ed);
    v.bool := EditBase.PutCurrLine (ed);
    findMode := SuchModus{};
    IF ignoreCase THEN INCL (findMode, GrossKlein); END;
    IF onlyWord THEN INCL (findMode, NurWort); END;
    IF replace & ~ask & (count # searchOne) THEN INCL (findMode, silent) END;
    IF ~doBing THEN INCL (findMode, silent) END;
    IF pos = fromStart
    THEN
      Home (ed, FALSE);
    END;
    found := FALSE;
    IF ~EditTools.InitSearch (ed, direction, w, rw, replace)
    THEN
      ShowCursor (ed);
      mtAppl.MouseArrow();
      RETURN FALSE
    END;
    IF count = searchOne
    THEN
      SearchWord (ed, w, direction, found, rw, again);
      IF ~found & doBing THEN Bing() 
      ELSE
        IF replace
        THEN
          IF ask
          THEN
            CenterCurrline (ed);
            v.int := AskForReplace();
            IF v.int = 1
            THEN
              ReplaceWord (ed, rw, r)
(*            ELSIF v.int = 3
            THEN 
              (* Cancel!!!, bei einmal Suchen egal *)
*)           END;
          ELSE
            ReplaceWord (ed, rw, r);
          END;
        END;
      END;
    ELSE
      found := FALSE;
      fc := 0;
      LOOP
        IF replace
        THEN
          SearchWord (ed, w, direction, f2, rw, FALSE);
        ELSE
          SearchWord (ed, w, direction, f2, rw, (fc#0) OR again);
        END;
        IF f2 THEN 
          INC (fc); 
          found := TRUE; 
          IF replace
          THEN
            IF ask
            THEN
              CenterCurrline (ed);
              v.int := AskForReplace();
              IF v.int = 1
              THEN
                ReplaceWord (ed, rw, r)
              ELSIF v.int = 3
              THEN 
                (* Cancel! *)
                replace := FALSE;
                f2 := FALSE;
              ELSE
                (* um nchstes zu finden *)
                INC (currRow);
              END;
            ELSE
              ReplaceWord (ed, rw, r);
            END;
          END;
        END;
        IF ((fc >= num) & (count = searchNum)) OR ~f2 THEN EXIT END;
        IF ~replace THEN INC (currRow); END;
        EditGlobals.FixCursorPos (ed);
      END;
      IF (((count = searchNum) & ~f2) OR ~found) & doBing THEN Bing() END;
      IF found & ~f2 & ~replace THEN DEC (currRow); END;
    END;
    IF found 
    THEN
      CenterCurrline (ed);
      IF replace THEN WdwManager.RedrawWdw (ed^.wdw, ed^.editWork); END;
    END;
    (* Suchmuster wieder freigeben *)
    EditTools.EndSearch ();
    ShowCursor (ed);
  END;
  mtAppl.MouseArrow();
  RETURN found;
END searchAndReplace;

(*
PROCEDURE searchAndReplace (ed : EDITPTR; w, r : ARRAY OF CHAR; pos : searchPos; 
                  direction : searchDir; count : searchCount; 
                  num (* wird nur bei count = nmal benutzt *) : INTEGER;
                  ignoreCase : BOOLEAN; onlyWord : BOOLEAN; 
                  replace : BOOLEAN; ask : BOOLEAN; again : BOOLEAN;
                  doBing: BOOLEAN): BOOLEAN;
(* Suchoperationen: 
 *
 * Start:       aktuelle Position, Top, Ende
 * Richtung:    nach oben, nach unten
 * Anzahl:      erstes, ntes, letztes Vorkommen
 * Modus:       groklein, nurWort
 *)
 VAR found : BOOLEAN;
     f2    : BOOLEAN;
     fc    : INTEGER;
     rw    : ARRAY [0..1023] OF CHAR;
BEGIN
  WITH ed^ DO 
    mtAppl.MouseBusy();
    HideCursor (ed);
    v.bool := EditBase.PutCurrLine (ed);
    findMode := SuchModus{};
    IF ignoreCase THEN INCL (findMode, GrossKlein); END;
    IF onlyWord THEN INCL (findMode, NurWort); END;
    IF replace & ~ask & (count # searchOne) THEN INCL (findMode, silent) END;
    IF ~doBing THEN INCL (findMode, silent) END;
    IF pos = fromStart
    THEN
      IF inBlock
      THEN
        ToBlockmark (ed, FALSE);
      ELSE
        Home (ed, FALSE);
      END;
    ELSIF pos = fromEnd 
    THEN
      IF inBlock
      THEN
        ToBlockmark (ed, TRUE);
      ELSE
        Home (ed, TRUE);
      END;
    ELSE
      IF ~inBlock & BlockIsMarked(ed^.wdw)
      THEN
        again := TRUE
      END;
    END;
    found := FALSE;
    IF ~EditTools.InitSearch (ed, direction, w, rw, replace)
    THEN
      ShowCursor (FALSE);
      mtAppl.MouseArrow();
      RETURN FALSE
    END;
    IF count = searchOne
    THEN
      SearchWord (ed, w, direction, found, rw, again);
      IF ~found & doBing THEN Bing() 
      ELSE
        (* Wegen Wildcards: Erstmal Fund heraussuchen 
        Strings.Copy (editLine.text^, blocks[0].blockStart.row, blocks[0].blockEnd.row - blocks[0].blockStart.row, rw, v.bool);
        *)
        IF replace
        THEN
          IF ask
          THEN
            CenterCurrline (ed);
            v.int := AskForReplace();
            IF v.int = 1
            THEN
              ReplaceWord (ed, rw, r)
(*            ELSIF v.int = 3
            THEN 
              (* Cancel!!!, bei einmal Suchen egal *)
*)           END;
          ELSE
            ReplaceWord (ed, rw, r);
          END;
        END;
      END;
    ELSE
      found := FALSE;
      fc := 0;
      LOOP
        IF replace
        THEN
          SearchWord (ed, w, direction, f2, rw, FALSE);
        ELSE
          SearchWord (ed, w, direction, f2, rw, (fc#0) OR again);
        END;
        IF f2 THEN 
          (* Wegen Wildcards: Erstmal Fund heraussuchen 
          Strings.Copy (editLine.text^, blocks[0].blockStart.row, blocks[0].blockEnd.row - blocks[0].blockStart.row , rw, v.bool);
          *)
          INC (fc); 
          found := TRUE; 
          IF replace
          THEN
            IF ask
            THEN
              CenterCurrline (ed);
              v.int := AskForReplace();
              IF v.int = 1
              THEN
                ReplaceWord (ed, rw, r)
              ELSIF v.int = 3
              THEN 
                (* Cancel! *)
                replace := FALSE;
                f2 := FALSE;
              ELSE
                (* um nchstes zu finden *)
                INC (currRow);
              END;
            ELSE
              ReplaceWord (ed, rw, r);
            END;
          END;
        END;
        IF ((fc >= num) & (count = searchNum)) OR ~f2 THEN EXIT END;
        IF ~replace THEN INC (currRow); END;
        EditGlobals.FixCursorPos (ed);
      END;
      IF (((count = searchNum) & ~f2) OR ~found) & doBing THEN Bing() END;
      IF found & ~f2 & ~replace THEN DEC (currRow); END;
    END;
    IF found 
    THEN
      CenterCurrline (ed);
      IF replace THEN WdwManager.RedrawWdw (ed^.wdw, ed^.editWork); END;
    END;
    (* Suchmuster wieder freigeben *)
    EditTools.EndSearch ();
    ShowCursor (ed);
  END;
  mtAppl.MouseArrow();
  RETURN found;
END searchAndReplace;
*)

PROCEDURE JoinLines (ed : EDITPTR; appendSpace : BOOLEAN);
(* Fgt die aktuelle und die folgende Zeile zu einer zusammen 
 *)
 VAR newText,
     tx2      : textPtr;
     newLen   : INTEGER;
     len, len2: INTEGER;
     putLine  : LONGINT;
BEGIN
  WITH ed^ DO
    IF currLineNr < totalLineNr - 1
    THEN
      IF EditBase.GetLineLength (ed, currLineNr+1, len)
      THEN
        len2 := len;
        (* Neue Lnge berechnen *)
        newLen := len + editLen; 
        INC (newLen);
        ALLOCATE (newText, newLen+2);
        IF newText = NIL THEN RETURN END;
        (* Zeile holen *)
        v.bool := EditBase.GetLine (ed, currLineNr, newText^, len);
        (* Jetzt CR/LFs am Ende der Zeile lschen *)
        DEC (len);
        WHILE (len >= 0) & ((newText^[len] = CR) OR (newText^[len] = LF)) DO
          newText^[len] := 0C; DEC (len);
        END;
        (* Eventuell ein Leerzeichen anhngen *)
        len := (*SYSTEM.*)LENGTH (newText^);
        IF (len > 0) & appendSpace & ~(newText^[len-1] IN CharSet{' ','-'}) THEN 
          newText^[len] := ' '; INC (len); 
          newText^[len] := 0C; 
        END;
        (* Jetzt nchste Zeile holen *)
        ALLOCATE (tx2, len2+4);
        IF tx2 = NIL THEN RETURN END;
        v.bool := EditBase.GetLine (ed, currLineNr+1, tx2^, len2);
        IF ed^.umbruch THEN
          Strings.DelLeadingBlanks (tx2^);
        END;
        Strings.Append (tx2^, newText^, v.bool);
        newLen := LENGTH (newText^);
        putLine := currLineNr;
        v.bool := EditBase.DeleteLine (ed, currLineNr+1);
        v.bool := EditBase.PutLine (ed, putLine, newText^, newLen);
        editChanged := FALSE;
        EditTools.UpdateCurrLine (ed, putLine);
        DEALLOCATE (newText, 0);
        DEALLOCATE (tx2, 0);
      END;
    END;
    (*
    IF currLineNr < totalLineNr - 1
    THEN
      SetCurrLine (ed, currLineNr + 1);
      IF EditBase.GetLineLength (ed, currLineNr-1, len)
      THEN
        newLen := len + editLen; 
        INC (newLen);
        ALLOCATE (newText, newLen+2);
        IF newText = NIL THEN RETURN END;
        v.bool := EditBase.GetLine (ed, currLineNr-1, newText^, len);
        (* Jetzt CR/LFs am Ende der Zeile lschen *)
        DEC (len);
        WHILE (len >= 0) & ((newText^[len] = CR) OR (newText^[len] = LF)) DO
          newText^[len] := 0C; DEC (len);
        END;
        len := (*SYSTEM.*)LENGTH (newText^);
        IF (len > 0) & appendSpace & ~(newText^[len-1] IN CharSet{' ','-'}) THEN 
          newText^[len] := ' '; INC (len); 
          newText^[len] := 0C; 
        END;
        IF ed^.umbruch THEN
          Strings.DelLeadingBlanks (editLine.text^);
          editLen := (*SYSTEM.*)LENGTH (editLine.text^);
        END;
        Strings.Append (editLine.text^, newText^, v.bool);
        newLen := LENGTH (newText^);
        putLine := currLineNr - 1;
        v.bool := EditBase.DeleteLine (ed, currLineNr);
        v.bool := EditBase.PutLine (ed, putLine, newText^, newLen);
        editChanged := FALSE;
        EditTools.UpdateCurrLine (ed, putLine);
        DEALLOCATE (newText, 0);
      END;
    END;
    *)
  END;
END JoinLines;

PROCEDURE Format0 (ed : EDITPTR; forcedJoin : BOOLEAN); FORWARD;

PROCEDURE CheckUmbruch (ed : EDITPTR);
  VAR l, l2 : INTEGER;
      text  : textPtr;
      edLen : INTEGER;
BEGIN
  WITH ed^ DO
    IF umbruch
    THEN
      IF (currLineNr < totalLineNr - 1) & EditBase.GetLineLength (ed, currLineNr+1, l)
      THEN 
        (* Test, ob aktuelle Zeile mit CR/LF terminiert ist *)
        IF (editLen>0) & ((editLine.text^[editLen-1] = CR) OR ((editLen > 1) & (editLine.text^[editLen-2] = CR))) THEN RETURN END;
        (* Testen, ob noch ein Wort in die aktuelle Zeile pat *)
        v.bool := EditBase.GetLineAdr (ed, currLineNr+1, text, l);
        l2 := 0;
        WHILE (text^[l2] # 0C) & (text^[l2] = ' ') DO INC (l2) END;
        IF (l2 = l) THEN RETURN END;
        IF realTabs
        THEN
          edLen := EditGlobals.RowToIndex (editLine.text^, editLen, tabSize);
        ELSE
          edLen := editLen
        END;
        IF (edLen + findNext (text, l2, l, UmbruchSet) - l2) <= rightMargin
        THEN
          Format0 (ed, FALSE);
        END;
      END;
    END;
  END;
END CheckUmbruch;

PROCEDURE cutEdit (ed : EDITPTR; fromOuter : BOOLEAN): BOOLEAN;FORWARD;

PROCEDURE Delete (ed : EDITPTR; ctrl : BOOLEAN; saveLine : BOOLEAN);
(* Neu implementiert fr neue Textstruktur 24.6.92
 *)
 VAR join : BOOLEAN;
     delChars : INTEGER;
     l2       : INTEGER;
BEGIN
  WITH ed^ DO
    saveLine := saveLine & ~block;
    IF block THEN SaveOp (ed, blockCut, FALSE); v.bool := cutEdit (ed, FALSE); RETURN END;
    HideMouse();
    HideCursor (ed);
    (* Test auf Zeilenende *)
    join := (editLine.text^[currRow] = CR) OR (editLine.text^[currRow] = LF) OR (editLine.text^[currRow] = 0C);
    ShowFileChanged(ed); (* Anzeigen, da Text gendert *)
    IF join & (currLineNr < totalLineNr - 1)
    THEN
      (* Zeile mit nchster vereinigen *)
      v.bool := EditBase.GetLineLength (ed, currLineNr+1, l2);
      IF editLen + l2  < rightMargin THEN
        (* ok, Folgezeile pat komplett rein *)
        v.bool := EditBase.PutCurrLine (ed);
        IF ~v.bool THEN 
          ShowCursor (ed); ShowMouse (FALSE); RETURN (* HALT *) 
        END;
        editChanged := FALSE;
        JoinLines (ed, FALSE);
        redrawLine (ed, FALSE, TRUE); (* CurrLine neu zeichnen *) 
        IF currLineNr < StartLine + LONG(windLines) THEN
         (* Scrollen bis zu einer Zeile unter currLine *)
          IF currLineNr - StartLine + 2 < LONG(windLines) THEN
            scrollRegion (ed, SHORT(currLineNr-StartLine)+1, windLines, -1);
          ELSE
            drawLine (ed, windLines-1);
          END;
        END;
        SetDocument (ed);
        (*
        drawLine (ed, windLines-1);
        drawLine (ed, windLines);
        *)
        CheckUmbruch (ed);
      ELSIF umbruch THEN
        (* Folgezeile pat nicht komplett *)
        Format0(ed, TRUE);
      ELSE
        (* auch kein Umbruch, dann meckern *)
        HideMouse();
        MTE.info (MTE.NoFit);
        ShowMouse (FALSE);
      END;
    ELSIF ~join
    THEN
      (* Lschen in einer Zeile *)
      IF ctrl 
      THEN
        (* Anzahl der zu lschenden Zeichen feststellen *)
        l2 := currRow;
        currRow := findNext (editLine.text, currRow, editLen, TrennSet);
        EditGlobals.FixCursorPos (ed);
        delChars := currRow;
        currRow := l2;
        DEC (delChars, currRow);
        IF delChars <= 0 THEN delChars := 1 END;
        IF delChars + currRow > editLen THEN delChars := editLen - currRow (* HALT *) END;
      ELSE
        delChars := 1;
      END;
      Strings.Delete (editLine.text^, currRow, delChars, v.bool);
      DEC (editLen, delChars);
      editChanged := TRUE;
      redrawLine (ed, FALSE, ctrl);
      CheckUmbruch (ed);
    END;
    ShowCursor(ed);
    ShowMouse (FALSE);
  END (* WITH ed^ *);
END Delete;

PROCEDURE Backspace(ed : EDITPTR; ctrl: BOOLEAN);
(* CursorLeft & dann Delete *)
  VAR wasBlock : BOOLEAN;
BEGIN
  WITH ed^ DO 
    wasBlock := block;
    IF block THEN SaveOp (ed, blockCut, FALSE); v.bool := cutEdit (ed, FALSE); RETURN END;
    IF (currLineNr = 0) & (currRow = 0) THEN RETURN END;
    IF ctrl THEN 
      CursorLeft (ed, {MagicAES.KCTRL});
    ELSE
      CursorLeft (ed, {});
    END;
    CenterCurrline (ed);
    Delete (ed, ctrl, ~wasBlock);
  END;
END Backspace;

PROCEDURE DupLine (ed : EDITPTR); 
  VAR clLineNr : LONGINT;
BEGIN
  WITH ed^ DO
    HideMouse ();
    HideCursor (ed);
    IF block THEN RETURN END;
    ShowFileChanged (ed);
    v.bool := EditBase.PutCurrLine (ed);
    IF ~EditBase.InsertLine (ed, currLineNr, editLine.text^, FALSE, editLen) THEN 
      ShowCursor (ed);
      ShowMouse (FALSE);
      RETURN (* HALT *) 
    END;
    IF currLineNr < StartLine + LONG(windLines) THEN
      (* Scrollen bis zu einer Zeile unter currLine *)
      IF currLineNr - StartLine + 2 < LONG(windLines) THEN
        scrollRegion (ed, SHORT(currLineNr - StartLine) + 1, windLines, 1);
      END;
    END;
    SetDocument (ed);
    clLineNr := currLineNr;
    IF currLineNr >= StartLine + LONG(windLines)
    THEN 
      WdwManager.ScrollDown(ed^.wdw, 1);
    END;
    SetCurrLine (ed, clLineNr);
    (* und zeichnen *)
    drawLine (ed, SHORT(currLineNr - StartLine)+1);
    ShowCursor (ed);
    ShowMouse (FALSE);
  END;
END DupLine;

PROCEDURE Insert (ed: EDITPTR; ch : CHAR);FORWARD;

PROCEDURE Tab (ed : EDITPTR; onlyIndent: BOOLEAN);
  VAR prevLine : aLinePtr;
      prevText : textPtr;
      i, j,
      spacesToInsert,
      tabsToInsert,
      l        : INTEGER;
BEGIN
  WITH ed^ DO
    HideMouse();
    HideCursor (ed);
    CenterCurrline (ed);
    IF onlyIndent 
    THEN
      (* Alle Whitespaces in Zeile darber berspringen und bis dahin einrcken  
       *)
      IF currLineNr > 0
      THEN
        v.bool := EditBase.GetLineAdr (ed, currLineNr - 1, prevText, l);
        (* Jetzt nach erstem Buchstaben suchen *)
        i := 0;
        WHILE (i < l) & ((prevText^[i] = TAB) OR (prevText^[i] = ' ')) DO INC(i) END;
        IF i > 0 THEN
          FOR j := 0 TO i-1 DO Insert (ed, prevText^[j]) END;
        END;
      END;
    ELSE
      (* Einfach entweder ein TAB einfgen oder mit Spaces auffllen bis zur nchsten Marke 
       *)
      IF realTabs THEN
        Insert (ed, TAB);
      ELSE
        i := ((currRow DIV tabSize) + 1) * tabSize;
        spacesToInsert := i - currRow;
        IF spacesToInsert < 0 THEN spacesToInsert := 0; (* HALT *) END;
        FOR i := 0 TO spacesToInsert-1 DO Insert (ed, ' '); END;
      END;
    END;
(*    
    spacesToInsert := -1;
    IF currLineNr > 0
    THEN
      v.bool := EditBase.GetLineAdr (ed, currLineNr - 1, prevText, l);
      (* nchsten Wortanfang in Prevline suchen *)
      i := currRow;
      IF realTabs
      THEN
        i := RowToIndex (editLine.text^, currRow, tabSize);
      END;
      IF i < l 
      THEN
        (* ok, knnte noch ein Wort kommen *)
        IF ~onlyIndent
        THEN
          WHILE (i < l) & (prevText^[i] # ' ') DO INC (i); END;
        END;
        WHILE (i < l) & (prevText^[i] = ' ') DO INC (i); END;
        IF realTabs
        THEN
          spacesToInsert := i-RowToIndex (editLine.text^, currRow, tabSize) - 1;
        ELSE
          spacesToInsert := i-currRow - 1;
        END;
      END;
    END;
    IF realTabs
    THEN
      IF (spacesToInsert <= 0) & ~onlyIndent
      THEN
        tabsToInsert := 1;
        spacesToInsert := 0;
      ELSE
        INC (spacesToInsert);
        tabsToInsert := spacesToInsert DIV tabSize;
        DEC (spacesToInsert, tabsToInsert * tabSize);
      END;
      FOR i := 1 TO tabsToInsert DO Insert (ed, TAB); END;
      FOR i := 0 TO spacesToInsert-1 DO Insert (ed, ' '); END;
    ELSE
      IF (spacesToInsert <= 0) & ~onlyIndent
      THEN
        i := ((currRow DIV tabSize) + 1) * tabSize;
        spacesToInsert := i - currRow;
      END;
      FOR i := 0 TO spacesToInsert DO Insert (ed, ' '); END;
    END;
    *)
    ShowCursor (ed);
    ShowMouse (FALSE);
  END; 
END Tab;

PROCEDURE InsertCR (ed : EDITPTR);
  VAR row       : CARDINAL;
      cRow      : INTEGER;
      cLine     : aLinePtr;
      newSize   : INTEGER;
      tBuf      : textPtr;
      copy      : ARRAY [0..1] OF Rectangle;
      l         : INTEGER;
      clLineNr  : LONGINT;
      ch        : CHAR;
BEGIN
  WITH ed^ DO
    HideMouse();
    HideCursor (ed);
    ShowFileChanged(ed);
    l := editLen;
    IF ~EditBase.PutCurrLine (ed) THEN 
      ShowCursor (ed);
      ShowMouse (FALSE);
      RETURN (* HALT *)
    END;
    IF ~EditBase.InsertCr (ed, currLineNr, currRow) THEN 
      SetCurrLine (ed, clLineNr);
      (* und zeichnen *)
      drawLine (ed, SHORT(currLineNr - StartLine));
      CenterCurrline (ed);
      ShowCursor (ed);
      ShowMouse (FALSE);
      RETURN
    END;
    (* Zeilen unter currLine kopieren *)
    IF currLineNr < StartLine + LONG(windLines) THEN
      (* Scrollen bis zu einer Zeile unter currLine *)
      IF currLineNr - StartLine + 2 < LONG(windLines) THEN
        scrollRegion (ed, SHORT(currLineNr - StartLine) + 1, windLines, 1);
      END;
    END;
    SetDocument (ed);
    SetCurrLine (ed, currLineNr + 1);
    drawLine (ed, SHORT(currLineNr - StartLine-1));
    clLineNr := currLineNr;
    IF currLineNr >= StartLine + LONG(windLines)
    THEN 
      WdwManager.ScrollDown(ed^.wdw, 1);
    END;
    SetCurrLine (ed, clLineNr);
    (* und zeichnen *)
    drawLine (ed, SHORT(currLineNr - StartLine));
    CenterCurrline (ed);
    ShowCursor (ed);
    ShowMouse (FALSE);
  END (* WITH ed^ *)
END InsertCR;

CONST EndSet = CharSet{15C,'.','!',':','?',')'};

PROCEDURE IsAbsatzEnde (ed : EDITPTR; row : INTEGER; VAR ende : BOOLEAN);
VAR tBuf     : textPtr;
    z        : INTEGER;
BEGIN
  WITH ed^ DO
    IF row > editLen THEN row := editLen END;
    IF row = 0 THEN ende := TRUE; RETURN END; 
    ende := ende OR (editLine.text^[row-1] IN EndSet) OR ((row > 1) & (editLine.text^[row-2] IN EndSet))
            OR (currLineNr + 1 >= totalLineNr);
    IF ~ende
    THEN
      v.bool := EditBase.GetLineAdr (ed, currLineNr+1, tBuf, z);
      ende := TRUE;
      DEC(z);    (* tBuf^[z] ist immer = 0C *)
      WHILE (z >= 0) & ((tBuf^[z] = LF) OR (tBuf^[z] = CR)) DO DEC (z) END;
      WHILE (z >= 0) & ende DO
        ende := tBuf^[z] = ' ';
        DEC (z);
      END;
    END;
  END;
END IsAbsatzEnde;

PROCEDURE Format0 (ed : EDITPTR; forcedJoin : BOOLEAN);
(* Formatiert einen Absatz neu. Dabei werden zu lange Zeilen 
 * auf die maximale Zeilenlnge verkrzt, Autoindent wird beachtet,
 * und Leerzeichen am Zeilenanfang werden entfernt bzw. bersprungen 
 *)
 VAR tmp : aLineDesc;
     tBuf  : textPtr;
     frame : Rectangle;
     absatzEnde,
     tmpValid,
     insertNew : BOOLEAN;
     saveCh2,
     saveCh    : CHAR;
     rowAdd,
     scrLines,
     linesAdded,
     linesRemoved,
     length, newLength,
     z, l, row, newRow,
     cRow     : INTEGER;
     xNr,
     clNr,
     rdrStart,
     aEnde,
     lastLine : LONGINT;
     idx      : INTEGER;

  PROCEDURE JoinSomeLines();
  BEGIN
    WITH ed^ DO
      row := editLen;
      absatzEnde := FALSE;
      IsAbsatzEnde (ed, row, absatzEnde);
      (* Solange Zeilen zusammensetzen, bis rightMargin (Zeilenlnge) berschritten ist *)
      WHILE (~absatzEnde & (newRow < rightMargin)) OR forcedJoin DO
        (* Check auf row > 0 nicht ntig, da dann schon Absatzende ist! *)
        IF (row > 0) & ~forcedJoin
        THEN
          JoinLines (ed, TRUE);
        ELSE
          JoinLines (ed, FALSE);
          forcedJoin := FALSE;
        END;
        row := editLen;
        IsAbsatzEnde (ed, row, absatzEnde);
        WHILE (row > 0) & ((editLine.text^[row-1] = CR) OR (editLine.text^[row-1]= LF)) DO DEC (row) END;
        newRow := row;
      END;
      WHILE (row > 0) & ((editLine.text^[row-1] = CR) OR (editLine.text^[row-1]= LF)) DO DEC (row) END;
      newRow := row;
    END;
  END JoinSomeLines;

  PROCEDURE SplitLine();
    VAR termCh : CHAR;
        len    : INTEGER;
  BEGIN
    WITH ed^ DO
      (* Alles hinter Umbruchstelle in tmp kopieren *)
      AllocNew (tmp, row - newRow + 2);
      Strings.Copy (editLine.text^, newRow, row-newRow, tmp.text^, v.bool);
      tmpValid := TRUE;
      
      (* Aktuelle Zeile terminieren *)
      Strings.Delete (editLine.text^, newRow, row-newRow, v.bool);
      IF newRow >= editLen THEN newRow := editLen - 2; (* HALT *) END;
      editLine.text^[newRow] := LF;
      editLine.text^[newRow+1] := 0C;
      editLen := newRow+1;
      
      editChanged := TRUE;
      v.bool := EditBase.PutCurrLine (ed);
      
      (* Jetzt tmp-String bearbeiten: 
       * Erst mal CR/LF am Zeilenende lschen.
       * Wenn kein Space und kein '-' am Ende ist, dann ein Space anfgen
       *)
      len := LENGTH (tmp.text^);
      (* Jetzt CR/LFs am Ende der Zeile lschen *)
      DEC (len);
      WHILE (len >= 0) & ((tmp.text^[len] = CR) OR (tmp.text^[len] = LF)) DO
        tmp.text^[len] := 0C; DEC (len);
      END;
      IF len >= 0 THEN 
        termCh := tmp.text^[len];
        IF (termCh # ' ') & (termCh # '-') & ~(termCh IN EndSet) & ~absatzEnde
        THEN
          Strings.Append (' ', tmp.text^, v.bool);
        END;                      
      END;
      IF (currLineNr = clNr) & (cRow > newRow)
      THEN
        INC(clNr); (* Saveposition inkrementieren *)
        (* neue aktuelle Spalte bestimmen *)
        cRow := cRow - newRow;
      END;
    END;
  END SplitLine;

  PROCEDURE maySplit (text: textPtr; row : INTEGER; idx: INTEGER): BOOLEAN;
  BEGIN
    IF (row >= ed^.rightMargin) OR (ed^.realTabs & (idx >= ed^.rightMargin)) THEN RETURN TRUE
    ELSE
      RETURN ~(text^[row] IN CharSet {0C, LF, CR}) &  (* Zeilenende, nicht splitten! *)
              ( ( (row > 0) & 
                  ( (text^[row-1] IN CharSet{'(','[','{'}) OR 
                    ( (text^[row-1] IN CharSet{'"',"'"}) & (row > 1) & (text^[row-2]=' ')
                    )
                  )
                )
                OR ( (row > 0) & (text^[row] IN CharSet{')',']','}'}) )
              );
    END;
  END maySplit; 

BEGIN
  WITH ed^ DO
    tmp.length := 16;
    ALLOCATE (tmp.text, 16);
    IF tmp.text = NIL THEN RETURN END;
    tmp.text^[0] := 0C;
    HideMouse();
    HideCursor (ed);
    (* Position merken *)
    clNr := currLineNr;
    rdrStart := clNr;
    cRow := currRow;
    insertNew := FALSE;
    length := editLen;
    absatzEnde := FALSE;
    linesRemoved := 0;
    idx := 0;
    (*
     * Dafr merke ich mir die zeilennummer des Absatzanfangs und 
     * des Absatzendes
     *)
    WHILE ~absatzEnde DO
      IsAbsatzEnde (ed, editLen, absatzEnde);
      IF ~absatzEnde
      THEN
        SetCurrLine (ed, currLineNr+1);
      END; 
    END;
    aEnde := currLineNr;
    (* Wenn Zeilen wirklich vereinigt werden sollen, 
     * dann nochmal checken 
     *)
    IF forcedJoin & (aEnde = clNr) THEN
      SetCurrLine (ed, currLineNr+1);
      absatzEnde := FALSE;
      WHILE ~absatzEnde DO
        IsAbsatzEnde (ed, editLen, absatzEnde);
        IF ~absatzEnde
        THEN
          SetCurrLine (ed, currLineNr+1);
        END; 
      END;
      aEnde := currLineNr;
    END;
    absatzEnde := FALSE;
    SetCurrLine (ed, clNr);             (* Position restaurieren *)
    tmpValid := FALSE;
    WHILE ~absatzEnde (* (length >= rightMargin) & ~insertNew *)  OR forcedJoin DO
      
      JoinSomeLines();
      
      (* Wenn jetzt die Lnge der aktuellen Zeile < rightMargin ist,
       * dann war ein anderer Grund fr das Absatzende da und es mu
       * nichts mehr gemacht werden, auch kein Einfgen von irgendwelchen
       * temporren Teilen
       *)
      (* In row steht die Lnge der Zeile *)
      IF realTabs 
      THEN
        idx := EditGlobals.RowToIndex (editLine.text^, newRow, tabSize);
      END;

      IF (newRow >= rightMargin) OR (realTabs & (idx >= rightMargin))
      THEN 
        (* Jetzt Stelle zum Splitten der aktuellen Zeile finden *)
        WHILE maySplit (editLine.text, newRow, idx) DO
          newRow := findLast (editLine.text, newRow, UmbruchSet);
          IF realTabs 
          THEN
            idx := EditGlobals.RowToIndex (editLine.text^, newRow, tabSize);
          END;
        END;
        (* Wenn Zeile nur aus einem Wort besteht,
         * dann harten Umbruch einfgen 
         *)
        IF newRow = 0
        THEN
          newRow := BinOps.LowerInt ((*SYSTEM.*)LENGTH (editLine.text^), rightMargin-2);
          IF newRow >= row THEN newRow := row - 2; (* HALT *) END;
        END;

        (* Aktuelle Zeile wird mit richtigem Umbruch terminiert 
         * und der Rest wird in tmp kopiert 
         *)
        SplitLine ();
 
        (* Wenn wir am Absatzende sind, dann mu tmp als neue 
         * Zeile eingefgt werden. Andernfalls wird es vor die nchste
         * Zeile gehngt und dann erneut die Schleife durchlaufen
         *)
        IF absatzEnde 
        THEN
          insertNew := TRUE;
        ELSE
          (* Nicht Absatzende, also tmp in nchste Zeile kopieren *)
          currRow := 0;
          (* Indent feststellen von aktueller Zeile *)
          IF autoIndent THEN
            WHILE (currRow <= editLen) & (editLine.text^[currRow] = ' ') & ~(ORD (editLine.text^[currRow]) < 32) DO INC (currRow) END;
          END;
          
          (* Nchste Zeile zu aktueller Zeile machen *)
          z := currRow;
          SetCurrLine (ed, currLineNr+1);
          currRow := z;
          
          (* Cursorspalte evtl. korrigieren *)
          IF clNr = currLineNr
          THEN
            INC(cRow, currRow);
          END;

          l := editLen; (* Lnge aktueller Zeile *)
          z := (*SYSTEM.*)LENGTH (tmp.text^); (* tmp ist 0C terminiert ohne CR/LF *)
          (* Jetzt genaue Einfgeposition bestimmen 
           * currRow zeigt Indent von vorheriger Zeile an, newRow 
           * hiernach Indent der aktuellen Zeile
           *)

          newRow := 0;
          IF autoIndent THEN
            WHILE (editLine.text^[newRow] = ' ') & (editLine.text^[newRow] # 0C) DO INC (newRow) END;
          END;

          (* Wenn indent der oberen Zeile grer dem der unteren ist,
           * dann mu noch was hinzugefgt werden
           *)
          IF currRow > newRow THEN rowAdd := currRow - newRow ELSE rowAdd := 0 END;

          (* Jetzt feststellen, wie lang die Zeile danach wird und 
           * dann evtl. neu allozieren 
           *)
          AllocNew (editLine, l+z+rowAdd);

          IF currRow > newRow THEN
            (* In vorheriger Zeile mehr eingerckt: Zeile einrcken *)
            AllocNew (tmp, (*SYSTEM.*)LENGTH (tmp.text^) + CARDINAL(currRow - newRow));
            Strings.Insert (Strings.Space(currRow-newRow), 0, tmp.text^, v.bool);
            Strings.Insert (tmp.text^, newRow, editLine.text^, v.bool);
          ELSIF newRow > currRow
          THEN
            (* In vorheriger Zeile weniger Spaces am Anfang: Spaces lschen *)
            Strings.Delete (editLine.text^, 0, newRow-currRow, v.bool);
            Strings.Insert (tmp.text^, currRow, editLine.text^, v.bool);
          ELSE
            (* dritter Fall und mu jedesmal gemacht werden: tmp einfgen *)
            Strings.Insert (tmp.text^, currRow, editLine.text^, v.bool);
          END;

          editLen := INTEGER((*SYSTEM.*)LENGTH (editLine.text^));
          editChanged := TRUE;
          v.bool := EditBase.PutCurrLine (ed);
          tmpValid := FALSE;
        END;
      END;
      length := editLen;
    END (* WHILE *);
    IF tmpValid
    THEN
      l := (*SYSTEM.*)LENGTH (tmp.text^);
      linesAdded := 0;
      WHILE l > 0 DO
        z := 0;
        IF autoIndent THEN
          saveCh := editLine.text^[z];
          (* Gengend Spaces einfgen *)
          WHILE (saveCh = ' ') DO
            INC (z);
            saveCh := editLine.text^[z];
          END;
          IF (saveCh # 0C) & (saveCh # CR) & (saveCh # LF) 
          THEN
            (* Autoindent nur, wenn die Zeile nicht nur aus Space besteht *)
            AllocNew (tmp, l + z);
            Strings.Insert (Strings.Space(z), 0, tmp.text^, v.bool);
            l := (*SYSTEM.*)LENGTH (tmp.text^);
          ELSE
            z := 0;
          END;
        END;
        (* Jetzt neue Zeile einfgen *)
        newRow := BinOps.LowerInt (rightMargin+5, (*SYSTEM.*)LENGTH (tmp.text^));
        IF realTabs 
        THEN
          idx := EditGlobals.RowToIndex (tmp.text^, newRow, tabSize);
        END;
        WHILE maySplit (tmp.text, newRow, idx) DO
          newRow := findLast (tmp.text, newRow, UmbruchSet);
          IF realTabs 
          THEN
            idx := EditGlobals.RowToIndex (tmp.text^, newRow, tabSize);
          END;
        END;
        IF newRow = 0
        THEN
          (* Endlosschleife verhindern, harter Umbruch! *)
          newRow := BinOps.LowerInt ((*SYSTEM.*)LENGTH (tmp.text^), rightMargin-1);
        END;
        IF newRow < l
        THEN
          saveCh := tmp.text^[newRow];
          saveCh2 := tmp.text^[newRow+1];
          tmp.text^[newRow] := LF;
          tmp.text^[newRow+1] := 0C;
        ELSE
          AllocNew (tmp, newRow+2);
          tmp.text^[newRow] := CR;
          tmp.text^[newRow+1] := LF;
          tmp.text^[newRow+2] := 0C;
          INC (newRow, 2);
        END;
        IF ~EditBase.InsertLine (ed, currLineNr, tmp.text^, FALSE, LENGTH (tmp.text^)) THEN (* HALT *) END;
        SetCurrLine (ed, currLineNr + 1);
        INC(linesAdded);
        IF newRow < l THEN
          tmp.text^[newRow] := saveCh;
          tmp.text^[newRow+1] := saveCh2;
        END;
        Strings.Delete (tmp.text^, 0, newRow, v.bool);
        currRow := z;
        IF currLineNr = clNr 
        THEN
          INC (cRow, currRow);
        END;
        l := (*SYSTEM.*)LENGTH (tmp.text^);
      END;
    END;
    lastLine := currLineNr;
    (*
    IF aEnde < lastLine
    THEN
      (* Zeilen hinzugekommen, alles unter Absatzende nach unten scrollen *)
      IF lastLine < (StartLine + LONG (windLines) - 1)
      THEN
        scrollRegion (ed, SHORT(lastLine - StartLine) + 1, windLines, SHORT(lastLine-aEnde));
        redrawLineArea (ed, lastLine, lastLine+(lastLine - aEnde));
      END;
    ELSIF aEnde > lastLine 
    THEN
      (* Zeilen entfernt, alles unter AbsatzEnde nach oben scrollen *)
      IF aEnde < (StartLine + LONG (windLines) - 1)
      THEN
        scrollRegion (ed, SHORT(aEnde - StartLine) + 1, windLines, SHORT(lastLine-aEnde));
        redrawLines (ed, windLines - SHORT(aEnde-lastLine));
      END;
    END;
    *)
    DEALLOCATE (tmp.text, 0);
    SetCurrLine (ed, clNr);
    SetDocument (ed);
    currRow := cRow;
    (* Jetzt noch redraw von Absatzstart bis Absatzende *)
    IF lastLine # aEnde
    THEN 
      redrawLines (ed, SHORT(clNr - StartLine)-1); 
    ELSE
      IF lastLine = rdrStart THEN INC (lastLine); END;
      redrawLineArea (ed, rdrStart, lastLine);
    END;
    ShowFileChanged (ed);
    ShowCursor (ed);
    ShowMouse (FALSE);
  END (* WITH ed^ DO *)
END Format0;
 
PROCEDURE Insert (ed: EDITPTR; ch : CHAR);
(* Die wichtigste Prozedur berhaupt: 
 * ein Zeichen an der Cursorposition einfgen.
 * Neu geschrieben am 11.1.92 fr Untersttzung von 
 * Flietextmodus und geringere Fehleranflligkeit.
 *)
VAR tBuf : textPtr;
    idx,
    l, z : INTEGER;
 
 PROCEDURE InsertOne ();
   VAR lastCh : CHAR;
       newLength : INTEGER;
 BEGIN
   WITH ed^ DO 
     (* Zeichen ohne Umbruch einfgen *)
     IF (editLine.length-2 <= l) OR (currRow >= editLine.length-2)
     THEN 
       (* Shit, Zeile zu kurz, umspeichern *)
       newLength := ((editLine.length DIV 16) + 1) * 16;
       IF newLength <= editLine.length THEN INC (newLength,16); END;
       ALLOCATE (tBuf, newLength);
       IF tBuf = NIL THEN 
         v.bool := EditBase.CompactBuffer (ed);
         ALLOCATE (tBuf, newLength);
         IF tBuf = NIL
         THEN
           (* kein Speicher mehr frei *) 
           RETURN (* Zeichen einfach nicht einfgen *)
           (* HALT *)
         END;
       END;
       Strings.Assign (editLine.text^, tBuf^, v.bool);
       DEALLOCATE (editLine.text, 0);
       editLine.text := tBuf;
       editLine.length := newLength;
     END;
     lastCh := editLine.text^[currRow];
     IF insertMode OR (ORD(lastCh) < 32)
     THEN
       Strings.Insert (ch, currRow, editLine.text^, v.bool);
       INC (editLen);
     ELSE
       editLine.text^[currRow] := ch;
     END;
     editChanged := TRUE;
   END; (* WITH ed^ DO *)
 END InsertOne;
 
BEGIN
  WITH ed^ DO
    (* Cursor und Mouse ausschalten *)
    HideMouse();
    HideCursor (ed);
    (* Aktuelle Zeile sichern fr Undo *)
(*    SaveLine(currLine, currLineNr); *)
    (* Bei markiertem Block diesen ersetzen und Operation fr Undo merken *)
    IF block THEN SaveOp (ed, blockToChar, FALSE); v.bool := cutEdit (ed, FALSE); END;
    (* Zeilenlnge feststellen *)
    l := editLen;
    (* Anzeigen, das File gendert *)
    ShowFileChanged (ed);
    (* Wenn Zeilenlnge nicht zu gro ist, dann einfach einfgen *)
    IF realTabs
    THEN
      idx := EditGlobals.RowToIndex (editLine.text^, l, tabSize);
    ELSE
      idx := l
    END;
    IF (idx < rightMargin) OR (ch = CR) OR (ch = LF)
    THEN
      (* Zeichen ohne Umbruch einfgen *)
      InsertOne();
      IF (ch # CR) & (ch # LF) THEN redrawLine (ed, TRUE, FALSE); END;
      INC (currRow);
    ELSIF umbruch
    THEN
      (* Hier Absatzumbruch vornehmen! *)
      (* Jetzt aktuelle Zeile umbrechen *)
      IF (currRow >= l) & (ch = ' ') & (editLine.text^[l-1] = ' ')
      THEN
        (* Am Ende der Zeile Space einfgen => Sprung in nchste Zeile 
         * und dort Space einfgen
         *)
        IF currLineNr - 1 < totalLineNr
        THEN
          IF autoIndent THEN 
            (* findFirstWord in CurrLine *) 
            currRow := 0;
            WHILE (editLine.text^[currRow] = ' ') & ~(ORD (editLine.text^[currRow]) < 32) DO
              INC (currRow) 
            END;
          ELSE currRow := 0 END;
          z := currRow;
          (* nchste Zeile zur aktuellen machen *)
          SetCurrLine (ed, currLineNr+1);
          currRow := z;
        ELSE
          (* Zeile einfgen mit Autoindent-Beachtung *)
          Insert (ed, LF);
          InsertCR(ed);
          currRow := 0; 
          IF autoIndent THEN Tab (ed, TRUE); END;
        END; (* IF currLine^.next # NIL *)
        Insert(ed, ch);
      ELSE
        (* Zeichen einfach einfgen und danach Absatzformatierung auslsen *)
        InsertOne();
        INC (currRow);
        Format0 (ed, FALSE);
      END;
    ELSE
      (* Zeile zu lang und kein Umbruch! *)
      (* Ein Bing ausgeben *)
      MagicDOS.Cconout (7C);       
    END;
    ShowCursor (ed);
    ShowMouse (FALSE);
  END (* WITH ed^ *)
END Insert;
 
                (* Clipboard-Funktionen *)
 
PROCEDURE cutBlock (ed : EDITPTR; toClip, redraw : BOOLEAN): BOOLEAN;
VAR   cLine : LONGINT;
      l     : LONGINT;
      clNr  : LONGINT;
      rdrStart : INTEGER;
      rdrLines : LONGINT;
      ende,
      addCr,
      oneLine  : BOOLEAN;
      bStart,
      blEnd,
      blStart  : LONGINT;
BEGIN
  WITH ed^ DO
    v.bool := EditBase.PutCurrLine(ed);
    addCr := FALSE;
    bStart := blocks[0].blockStart.line;
    IF (blocks[0].blockStart.line >= 0) & (blocks[0].blockEnd.line >= 0)
    THEN
      (* Jetzt erstmal Blockmarkierung auf gltige Bereiche beschrnken *)
      IF blocks[0].blockEnd.line > totalLineNr - 1 
      THEN
        SetCurrLine (ed, totalLineNr - 1);
        currRow := editLen;
        blocks[0].blockEnd.row := currRow;
        blocks[0].blockEnd.line := currLineNr
      END;
      
      (* Redraw-Bereich feststellen *)
      IF (blocks[0].blockStart.line >= StartLine) & (blocks[0].blockStart.line < StartLine + LONG(windLines))
      THEN
        rdrStart := SHORT(blocks[0].blockStart.line-StartLine);
      ELSE
        rdrStart := -1;
      END;
      (* Block auf Clipboard schieben *)
      IF toClip THEN 
        IF ~CatEdit.EditCopy (wdw) 
        THEN
          RETURN FALSE
        END; 
      END;

      SetCurrLine (ed, blocks[0].blockStart.line);
      currRow := blocks[0].blockStart.row;
      rdrLines := blocks[0].blockEnd.line - blocks[0].blockStart.line;

      (* Jetzt Block lschen *)
      IF (blocks[0].blockStart.line = blocks[0].blockEnd.line) 
      OR ((blocks[0].blockEnd.line = blocks[0].blockStart.line+1) 
        & (blocks[0].blockEnd.row = 0) 
        & (blocks[0].blockStart.row = 0))
      THEN 
        (* Flag fr Redraw setzen! *)
        oneLine := TRUE;
        (* Nur Block in einer Zeile *)
        IF ((blocks[0].blockStart.row = 0) & (blocks[0].blockEnd.row = editLen)) OR 
           ((blocks[0].blockStart.row = 0) & (blocks[0].blockEnd.row = 0) & (blocks[0].blockStart.line = blocks[0].blockEnd.line-1))
        THEN 
          (* Wenn die gelschte Zeile ein Absatzende enthlt und die 
           * darber nicht, dann mu an die darber ein Absatzende gesetzt 
           * werden 
           *)
          ende := FALSE;
          IsAbsatzEnde (ed, editLen, ende);
          IF ende & (blocks[0].blockStart.line > 0)
          THEN
            (* Jetzt die Zeile vorher kontrollieren *)
            SetCurrLine (ed, blocks[0].blockStart.line - 1);
            ende := FALSE;
            IsAbsatzEnde (ed, editLen, ende);
            IF ~ende
            THEN
              addCr := TRUE;
            END;
            SetCurrLine (ed, blocks[0].blockStart.line);
          END;
          (* Blockmarkierung lschen *)
          EditTools.ClearBlock (ed);
          (* Genau eine Zeile markiert *)
          DeleteLine (ed, TRUE);
          (* Redraw wird schon bei DeleteLine gemacht *)
          redraw := FALSE;
        ELSE
          Strings.Delete (editLine.text^, blocks[0].blockStart.row, blocks[0].blockEnd.row-blocks[0].blockStart.row, v.bool);
          editChanged := TRUE;
          editLen := (*SYSTEM.*)LENGTH (editLine.text^);
        END;
      ELSE
        oneLine := FALSE;
        (* mehrzeiliger Block *)
        l := blocks[0].blockStart.line;
        IF blocks[0].blockEnd.line - blocks[0].blockStart.line - 2 > 0 
        THEN
          blEnd := blocks[0].blockEnd.line;
          blStart := blocks[0].blockStart.line;
          (* Erstmal Ende und Anfang bearbeiten *)
          SetCurrLine (ed, blocks[0].blockStart.line);
          WITH editLine DO
            IF blocks[0].blockStart.row > 0 THEN
              (* Nur Teilweise lschen *)
              Strings.Delete (text^, blocks[0].blockStart.row, editLen-blocks[0].blockStart.row, v.bool);
              DEC (editLen, editLen - blocks[0].blockStart.row);
              editChanged := TRUE;
              v.bool := EditBase.PutCurrLine(ed);
            ELSE
(*              DeleteLine (ed, FALSE); *)
              DEC (blStart);
(*              DEC (blEnd); *)
            END;
          END;
          SetCurrLine (ed, blEnd);
          WITH editLine DO
            IF (blocks[0].blockEnd.row < length) THEN
              (* ebenfalls nur teilweise lschen *)
              Strings.Delete (text^, 0, blocks[0].blockEnd.row, v.bool);
              DEC (editLen, blocks[0].blockEnd.row);
              editChanged := TRUE;
              v.bool := EditBase.PutCurrLine(ed);
            ELSE
(*              DeleteLine (ed, FALSE); *)
              ende := FALSE;
              IsAbsatzEnde (ed, editLen, ende);
              IF ende & (blocks[0].blockStart.line > 0)
              THEN
                (* Jetzt die Zeile vorher kontrollieren *)
                SetCurrLine (ed, blocks[0].blockStart.line - 1);
                ende := FALSE;
                IsAbsatzEnde (ed, editLen, ende);
                IF ~ende
                THEN
                  addCr := TRUE;
                END;
              END;
              INC (blEnd);
            END;
          END (* WITH editLine *);
          (* Und jetzt die grobe Harke *)
          v.bool := EditBase.DeleteSomeLines (ed, blStart+1, blEnd-1);
          SetCurrLine (ed, blocks[0].blockStart.line);
          currRow := blocks[0].blockStart.row;
        ELSE
          blEnd := blocks[0].blockEnd.line;
          WHILE l <= blEnd DO
            SetCurrLine (ed, l);
            WITH editLine DO
              IF (l = blocks[0].blockStart.line) & (blocks[0].blockStart.row > 0) THEN
                (* Nur Teilweise lschen *)
                Strings.Delete (text^, blocks[0].blockStart.row, editLen-blocks[0].blockStart.row, v.bool);
                DEC (editLen, editLen - blocks[0].blockStart.row);
                editChanged := TRUE;
                INC(l);
              ELSIF (l = blEnd) & (blocks[0].blockEnd.row < length) THEN
                (* ebenfalls nur teilweise lschen *)
                Strings.Delete (text^, 0, blocks[0].blockEnd.row, v.bool);
                DEC (editLen, blocks[0].blockEnd.row);
                editChanged := TRUE;
                INC(l);
              ELSE
                DeleteLine (ed, FALSE);
                DEC (blEnd);
              END;
            END (* WITH editLine *);
          END (* WHILE *);
        END;
        (* Join lines if necessary *)
        IF blocks[0].blockStart.row > 0 THEN 
          SetCurrLine (ed, blocks[0].blockStart.line); 
          currRow := blocks[0].blockStart.row; 
          EditTools.ClearBlock (ed); 
          Delete (ed, FALSE, FALSE);
        END;
      END; (* IF blockStart.line = blockEnd.line *)
    
      v.bool := EditBase.PutCurrLine(ed);
      
      (* Jetzt nachsehen, ob ein CR hinzugefgt werden mu *)
      IF addCr 
      THEN
        cLine := currLineNr;
        SetCurrLine (ed, bStart-1);
        AllocNew (editLine, editLen + 4);
        Protect (editLine.text);
        editChanged := TRUE;
        editLen := (*SYSTEM.*)LENGTH (editLine.text^);
        v.bool := EditBase.PutCurrLine (ed);
        IF ~redraw
        THEN
          redraw := bStart-1 >= StartLine;
          rdrStart := SHORT(bStart-1-StartLine);
          oneLine := TRUE;
        ELSIF rdrStart > 0 
        THEN
          DEC (rdrStart)
        END;
        SetCurrLine (ed, cLine);
      END;
      (* Blockmarken lschen *)
      EditTools.ClearBlock (ed);
      SetDocument (ed);
    
      EditTools.UpdateCurrLine (ed, currLineNr);
      (* Jetzt nur noch neu Zeichnen *)
      IF redraw
      THEN
        IF rdrStart >= 0
        THEN
          IF oneLine
          THEN
            drawLine (ed, rdrStart);
          ELSIF rdrLines < LONG (windLines) 
          THEN
            redrawLines (ed, rdrStart-1);
          ELSE
            CenterCurrline (ed);
            WdwManager.RedrawWdw (ed^.wdw, editWork)
          END;
        ELSE
          CenterCurrline (ed);
          WdwManager.RedrawWdw (ed^.wdw, editWork);
        END;
      END;
    END; (* IF blockDa *)
  END (* WITH ed^ DO *);
  RETURN TRUE;
END cutBlock;
 
PROCEDURE cutEdit (ed : EDITPTR; fromOuter : BOOLEAN): BOOLEAN;
 VAR res: BOOLEAN;
BEGIN
  IF ed^.readOnly THEN RETURN FALSE END;
  IF fromOuter THEN SaveOp (ed, blockCut, FALSE); END;
  ShowFileChanged(ed); (* Anzeigen, da Text gendert *)
  res := cutBlock (ed, fromOuter, TRUE);
  CenterCurrline (ed);
  IF ed^.showInfo THEN SetInfoLine (ed); END;
  RETURN res;
END cutEdit;
 
PROCEDURE putLineInEditor (ed: EDITPTR; adr: ADDRESS; len: CARDINAL; redraw: BOOLEAN): BOOLEAN;
(* Fgt einen Text an adr an die aktuelle Position ein! 
 *)
 VAR blStart  : LONGINT;
     scrLine  : INTEGER;
     wasBlock : BOOLEAN;
     adr2     : ADDRESS;
BEGIN
  WITH ed^ DO 
    IF readOnly OR (len = 0) THEN RETURN TRUE END;
    (* Der Text an adr wird hier dupliziert, da der Speicher 
     * danach in der Leseroutine freigegeben wird
     *)
    ALLOCATE (adr2, len);
    IF adr2=NIL
    THEN
      OutOfMem();
      RETURN FALSE
    END;
    Block.Copy (adr,len, adr2);
    HideMouse();
    HideCursor (ed);
    v.bool := EditBase.PutCurrLine (ed);
    wasBlock := block;
    IF block THEN 
      SaveOp (ed, blockPaste, FALSE); 
      v.bool := cutBlock (ed, FALSE, FALSE); 
    ELSE
      SaveOp (ed, normalPaste, FALSE);
    END;
    SetBlockstart (ed);
    block := TRUE;
    IF ~EditBase.InsertBuffer (ed, adr2, len, TRUE)
    THEN
      (* Fehlermeldung *)
      blocks[0].blockStart.line := -1;
      blocks[0].blockEnd.line := -1;
      block := FALSE;
      OutOfMem();
      ShowCursor (ed);
      ShowMouse (FALSE);
      RETURN FALSE
    END;
(*      DEALLOCATE (adr2, 0); *)
    NewBlockToUndoBuffer (ed);
    blStart := blocks[0].blockStart.line;
    SetCurrLine (ed, blocks[0].blockEnd.line);
    currRow := blocks[0].blockEnd.row;
    IF ~wasBlock THEN 
      (* normal Paste *) 
      block := FALSE; 
      blocks[0].blockStart.line := -1; 
      blocks[0].blockEnd.line := -1; 
    END;
    EditTools.UpdateCurrLine (ed, currLineNr);
    EditGlobals.FixCursorPos (ed);
    SetDocument (ed);
    ShowFileChanged (ed);
    IF redraw
    THEN
      CenterCurrline (ed);
      scrLine := BinOps.HigherInt (0, SHORT(blStart - StartLine));
      redrawLines (ed, scrLine);
    END;
    ShowCursor (ed);
    ShowMouse (FALSE);
  END;
  RETURN TRUE
END putLineInEditor;

BEGIN
  editList := NIL;
  rotateFaktor := 13;
  (*$? NOT CAT:
  Lists.CreateList (shortList, v.bool);
  shortListRead := FALSE;
  *)
END EditFuncs.
 
