DEFINITION MODULE EditGlobals;

FROM SYSTEM     IMPORT LOC;

FROM GrafBase   IMPORT Rectangle, Point;

IMPORT MagicTypes;

FROM EditTypes  IMPORT EDITPTR, aLineDesc;



(* Window-Funktionen fr Darstellung auf Bildschirm *)

(* Setzt neues virtuelles Fenster *)
PROCEDURE SetDocument (ed : EDITPTR);

        (* GrafGrowbox und GrafShrinkbox neu, da das AES bei kleinen Boxgren anscheinend Mll macht *)

PROCEDURE GrowAndShrink (ed : EDITPTR; from : Rectangle);

PROCEDURE isQuote (REF str : ARRAY OF CHAR) : BOOLEAN;
(* Stellt fest, ob eine Textzeile ein Quote ist *)

PROCEDURE GetQuote (REF str : ARRAY OF CHAR; VAR quote: ARRAY OF CHAR);
(* Holt den Quoteteil aus der Zeile *)

PROCEDURE OutputLine (ed : EDITPTR; x, y : INTEGER; REF line : ARRAY OF CHAR; 
                      len : INTEGER; VAR width: INTEGER);
(* Gibt die Zeile line an der Position x,y im Editor ed aus 
 * und gibt die Breite der Zeile zurck
 *)

PROCEDURE AllocNew (VAR line : aLineDesc; newLen : INTEGER);
(* Alloziert ggf. eine neue Zeile, damit der Text die neue Lnge haben
 * kann
 *)

        (* VDI Text Funktionen    *)
        
PROCEDURE Text (ed : EDITPTR; x, y: INTEGER; REF string: ARRAY OF CHAR);

PROCEDURE InqTextextend (ed : EDITPTR; REF string: ARRAY OF CHAR;
                             VAR extent: ARRAY OF LOC; parseEffects: BOOLEAN);

PROCEDURE GetTextWidth (ed : EDITPTR; REF string: ARRAY OF CHAR; idx: INTEGER;
                             VAR extent: ARRAY OF LOC);
(* Diese Porzedur parst den Text immer. Pos gibt die Position an, bis zu der der 
 * String maximal zusammengesetzt wird! 
 *)

PROCEDURE FixCursorPos (VAR ed : EDITPTR);
(* Pat auf, das der Cursor nie hinter einem CR/LF steht
 *)

PROCEDURE RowToIndex (REF str : ARRAY OF CHAR; row, tabSize : INTEGER) : INTEGER;

        (* Cursor-Zeichenfunktionen *)
        
PROCEDURE ClipWork (ed : EDITPTR);

PROCEDURE drawCursor (VAR ed : EDITPTR; grow : BOOLEAN);

PROCEDURE MouseArrow;
PROCEDURE MouseCursor;
PROCEDURE MouseBusy;
PROCEDURE MouseFinger;
PROCEDURE MouseHand;
PROCEDURE MouseThincross;
PROCEDURE MouseThickcross;
PROCEDURE MouseOutline;
PROCEDURE MouseUser;
(* Diese Routinen schalten die Maus mit dem jeweilige Bild EIN *)

PROCEDURE MouseIsOn () : BOOLEAN;
(* Erfragt, ob die Maus an ist oder nicht *)


PROCEDURE UserMouse (VAR form: MagicTypes.MFORM);
(* Setzt eine User-Definierte Maus. Sichtbar erst mit MouseUser! *)

PROCEDURE SaveMouse ();

PROCEDURE RestoreMouse();

PROCEDURE MouseIsOn () : BOOLEAN;

PROCEDURE HideMouse ();

PROCEDURE ShowMouse (force : BOOLEAN);

PROCEDURE CursorIsOn (ed : EDITPTR) : BOOLEAN;

PROCEDURE HideCursor (VAR ed : EDITPTR);

PROCEDURE ShowCursor (VAR ed : EDITPTR);

PROCEDURE ForceCursor (VAR ed : EDITPTR);

END EditGlobals.
