IMPLEMENTATION MODULE EditGlobals;

FROM SYSTEM     IMPORT  ADDRESS, ADR, TSIZE, CADR, LOC, LONGWORD, CALLSYS;

(* Megamax-Lib *)

FROM GrafBase   IMPORT LongRect, Rectangle, Point;

IMPORT BinOps, Strings, Block;

FROM Storage IMPORT ALLOCATE, DEALLOCATE;

(* MagicLib *)
IMPORT MagicAES, MagicVDI, MagicFSM, MagicDOS, MagicSys, MagicTypes, mtAppl;

FROM MagicVDI   IMPORT VDIIntIn, VDIPtsIn, VDIControl, VDICall;

(* CAT Module *)
IMPORT WdwManager;
IMPORT RectFuncs;
IMPORT CatGlobal;

FROM Void       IMPORT v;

(* Editor *)
FROM EditTypes  IMPORT EDITPTR, aLinePtr, aLineDesc, aMark, textPtr, deskSize, pixOff,
                       theDrawLine, CharSet, TrennSet, cursorHandle;

IMPORT EditBase;

FROM Characters IMPORT TAB, CR, LF;


        (* Window-Funktionen fr Darstellung auf Bildschirm *)

(* Setzt neues virtuelles Fenster *)
PROCEDURE SetDocument (ed : EDITPTR);
  VAR r : LongRect;
BEGIN
  WITH ed^ DO
    WdwManager.SetWdwDocument (wdw, LongRect{LONG(leftOffset), StartLine, LONG(maxWidth), totalLineNr-1});
  END;
END SetDocument;

PROCEDURE AllocNew (VAR line : aLineDesc; newLen : INTEGER);
  VAR newLength : INTEGER;
      tBuf      : textPtr;
BEGIN
  IF newLen >= line.length-1
  THEN
    newLength := ((newLen + 16) DIV 16 ) * 16;
    IF newLength < newLen THEN INC (newLength, 16) END;
    ALLOCATE (tBuf, newLength);
    IF tBuf = NIL 
    THEN 
(*      CompactAll (); *)
      ALLOCATE (tBuf, newLength);
      IF tBuf = NIL 
      THEN
        HALT (* kein Speicher mehr frei *) 
      END;
    END;
    Block.Clear (tBuf, newLength);
    Block.Copy (line.text, line.length, tBuf);
    DEALLOCATE (line.text, 0);
    line.text := tBuf;
    line.length := newLength;
  END;
END AllocNew;

        (* GrafGrowbox und GrafShrinkbox neu, da das AES bei kleinen Boxgren anscheinend Mll macht *)

PROCEDURE GrowAndShrink (ed : EDITPTR; from : Rectangle);
  VAR pts : ARRAY [0..4] OF Point;
      i, j, k : INTEGER;
      diffw, 
      diffh : INTEGER;
BEGIN
  WITH ed^ DO 
    v.int := MagicVDI.SetLinetype (cursorHandle, MagicVDI.User);
    (* MagicVDI.SetUserlinestyle (cursorHandle, $5555); *)
    MagicVDI.SetUserlinestyle (cursorHandle, $FFFF);
    diffw := BinOps.HigherInt (4, from.w DIV 2);
    diffh := from.h DIV 2;
    FOR j := 0 TO 3 DO 
      FOR k := 0 TO 7 DO 
        FOR i := 0 TO 10 DO 
          pts[0].x := from.x - diffw * i;
          pts[0].y := from.y - diffh * i;
          pts[1].x := from.x + from.w - 1 + diffw * i ;
          pts[1].y := pts[0].y;
          pts[2].x := pts[1].x;
          pts[2].y := from.y + from.h + diffh * i - 1;
          pts[3].x := pts[0].x;
          pts[3].y := pts[2].y;
          pts[4] := pts[0];
          MagicVDI.Polyline (cursorHandle, 5, pts);
        END;
        (* Hier irgendeine Wartefunktion einbauen *)
        FOR i := 0 TO 1000 DO pts[0].x := 999 END;
      END;
    END;
  END;
END GrowAndShrink;

        (* VDI Text Funktionen    *)
        
PROCEDURE Text (ed : EDITPTR; x, y: INTEGER; REF string: ARRAY OF CHAR);
          (* v_gtext *)
BEGIN
  IF string[0] = 0C THEN RETURN END;
  WITH ed^ DO
    IF isFSM
    THEN
      MagicFSM.FSMText (hdl, x, y+charHeight-1, string);
    ELSE
      MagicVDI.Text (hdl, x, y+charHeight-1, string);
    END;
  END;
END Text;

PROCEDURE isQuote (REF str : ARRAY OF CHAR) : BOOLEAN;
  VAR i, j, l : CARDINAL;
      isQ: BOOLEAN;
      ch : CHAR;
BEGIN
  i := 0;
  l := LENGTH (str);
  WHILE (i < l) & (str[i] = ' ') DO INC(i); END;
  isQ := TRUE;
  j := i;
  WHILE (j <= i+5) & (str[j] # '>') & isQ DO
    ch := str[j];
    IF (j >= i+2) THEN ch := CAP(ch) END;
    IF ch IN CharSet{'A'..'Z','','',''} THEN 
      INC (j)
    ELSE
      isQ := FALSE;
    END;
  END;
  isQ := isQ & (j <= i+5);
  RETURN isQ;
  (*
  RETURN (i<3) & (str[i]=">") OR ((str[i] IN CharSet{'A'..'Z'}) & ((str[i+1]=">") OR ((str[i+1] IN CharSet{'A'..'Z'}) & ((str[i+2]=">"))))
         OR ((str[i+2] IN CharSet{'A'..'Z'}) & ((str[i+3]=">")  
         OR ((str[i+3] IN CharSet{'A'..'Z'}) & ((str[i+4]=">"))))
  *)
END isQuote;

PROCEDURE GetQuote (REF str : ARRAY OF CHAR; VAR quote: ARRAY OF CHAR);
  VAR i, j, l : CARDINAL;
      isQ: BOOLEAN;
      ch : CHAR;
BEGIN
  quote[0] := '';
  i := 0;
  l := LENGTH (str);
  WHILE (i < l) & (str[i] = ' ') DO INC(i); END;
  isQ := TRUE;
  j := i;
  WHILE (j <= i+5) & (str[j] # '>') & isQ DO
    ch := str[j];
    IF (j >= i+2) THEN ch := CAP(ch) END;
    IF ch IN CharSet{'A'..'Z','','',''} THEN 
      INC (j)
    ELSE
      isQ := FALSE;
    END;
  END;
  isQ := isQ & (j <= i+5);
  IF isQ
  THEN
    Strings.Copy (str, 0, j+1, quote, v.bool);
  END;
END GetQuote;

PROCEDURE handleEffectLine (ed: EDITPTR; x, y: INTEGER; REF line: ARRAY OF CHAR; len: INTEGER; 
                            doOutput: BOOLEAN; maxExtIdx: INTEGER; VAR ext: ARRAY OF Point);
CONST NormalChars = CharSet{'A'..'Z','a'..'z','','','','','','','','0'..'9','"',"'"};
      delimiters  = CharSet{' ','-','>','(','[','{','"',"'"};
      wordEnds = CharSet {0C, 12C, 15C, ' ','.',',',';','!','-','?',':','"',"'",'}',']',')'};

  VAR isQ : BOOLEAN;
      display: ARRAY [0..4095] OF CHAR;
      xOff   : INTEGER;
      maxI,
      i, j,
      idx : INTEGER;
      inEffect: BOOLEAN;
      extend    : ARRAY [0..3] OF Point;
      eff       : BITSET;
      effChar   : CHAR;
      chAdr     : POINTER TO CHAR;
      saveCh    : CHAR;

  (*$W-*)
  PROCEDURE simpleOutput();
  BEGIN
    WITH ed^ DO
      (* Zeile einfach ausgeben *)
      IF doOutput
      THEN
        Text (ed, x, y, line);
      END;
      IF ~monoSpaced OR isFSM (* added "OR isFSM" for Monospaced 821 Font *)
      THEN
        chAdr := ADR(line[maxExtIdx]);
        saveCh := chAdr^;
        chAdr^ := 0C;
        (* Textadvance und damit xOffset berechnen *)
        InqTextextend (ed, line, extend, FALSE);
        chAdr^ := saveCh;
        INC (xOff, extend[1].x - extend[0].x);
      ELSE
        INC (xOff, maxExtIdx*charWidth);
      END;
    END;
  END simpleOutput;

BEGIN
  WITH ed^ DO
    xOff := 0;
    IF (maxExtIdx >= SIZE(display))
    OR ((maxExtIdx >= (mtAppl.MaxWidth * 2) DIV charWidth) & ~doOutput)
    THEN
      (* Lnge berschreitet maximal mgliche Testlnge,
       * daher Breite als MAXINT zurckliefern 
       *)
      (* ext-Array fllen *)
      FOR i := 0 TO 3 DO
        ext[i].x := 0;
        ext[i].y := 0;
      END;
      ext[0].x := 0;
      ext[1].x := 32767;
      RETURN ;
    END;
    IF readOnly 
    THEN
      isQ := isQuote (line);
      IF isQ & (mtAppl.Bitplanes > 1)
      THEN
        (* Farbe umsetzen auf Quotefarbe *)
        v.int := MagicVDI.SetTextcolor (hdl, quoteCol);
      ELSIF isQ
      THEN
        (* Texteffekt umsetzen *)
        v.bset := MagicVDI.SetTexteffect (hdl, quoteEff);
      END;
      IF parseEffects
      THEN
        (* Zeile parsen und ggf. Effekte einstellen *)
        i := 0;
        idx := 0;
        xOff := 0;
        inEffect := FALSE;
        maxI := maxExtIdx;  (* vorher: maxI := len *)
        eff := {};
        WHILE (i < maxI) & (line[i] # '') DO
          (* Solange Teilstrings kopieren, bis Sonderzeichen gefunden wurde *)
          IF (line[i] IN CharSet{'*','_','/'})
          THEN
            IF inEffect 
            THEN
              (* Testen, ob Effect nicht beendet wird *)
              IF (i < len-1) & ~(line[i+1] IN TrennSet) & (effChar = '_')
              THEN
                IF line[i] = '_' THEN 
                  display [idx] := ' ';
                ELSE
                  display [idx] := line[i];
                END;
                INC (idx);
              ELSIF (effChar = line[i]) & (line[i+1] IN wordEnds)
              THEN
                (* Effekt beendet *)
                display[idx] := '';
                IF doOutput
                THEN
                  (* Letzten Teil ausgeben *)
                  Text (ed, x+xOff, y, display);
                END;
                (* Textadvance und damit xOffset berechnen *)
                InqTextextend (ed, display, extend, FALSE);
                INC (xOff, extend[1].x - extend[0].x);
                (* Effekt wieder abstellen *)
                eff := {};
                IF isQ & (mtAppl.Bitplanes <= 1) THEN eff := eff + quoteEff END;
                v.bset := MagicVDI.SetTexteffect (hdl, eff);
                idx := 0;
                inEffect := FALSE;
              ELSE
                display[idx] := line[i];
                INC (idx);
              END;
            ELSE 
              (* Nicht in Effekt, vielleicht ein neuer? *)
              IF (i < len-1) & (line[i+1] IN NormalChars)
                 & ((i=0) OR ((i>0) & (line[i-1] IN delimiters)))
              THEN
                (* Jetzt noch testen, ob das Zeichen in der Zeile nochmal kommt *)
                j := i;
                REPEAT
                  REPEAT
                    INC(j);
                  UNTIL (j >= len) OR (line[j] = line[i]);
                UNTIL (j >= len) OR (line[j+1] IN wordEnds);
                IF (j < len)
                THEN
                  (* Beginn eines Effects *)
                  inEffect := TRUE;
                  (* Letzten Teil ausgeben *)
                  display[idx] := '';
                  IF doOutput
                  THEN
                    (* Textstck ausgeben *)
                    Text (ed, x+xOff, y, display);
                  END;
                  (* Textadvance und damit xOffset berechnen *)
                  InqTextextend (ed, display, extend, FALSE);
                  INC (xOff, extend[1].x - extend[0].x);
                  (* Jetzt Effekt setzen *)
                  eff := {};
                  IF (line[i] = '*')
                  THEN
                    (* Texteffekt umsetzen *)
                    eff := {MagicVDI.Fat};
                  ELSIF (line[i] = '/')
                  THEN
                    eff := {MagicVDI.Italic};
                  ELSIF (line[i] = '_')
                  THEN
                    eff := {MagicVDI.Underline};
                  END;
                  IF isQ & (mtAppl.Bitplanes <= 1) THEN eff := eff + quoteEff END;
                  v.bset := MagicVDI.SetTexteffect (hdl, eff);
                  effChar := line[i];
                  idx := 0;
                ELSE
                  display[idx] := line[i];
                  INC (idx);
                END;
              ELSE
                display[idx] := line[i];
                INC (idx);
              END;
            END;
          ELSE
            display[idx] := line[i];
            INC (idx);
          END;
          INC(i);
        END;
        IF idx > 0 
        THEN
          (* Text noch nicht ausgegeben *)
          display[idx] := '';
          IF doOutput
          THEN
            (* Text noch ausgeben *)
            Text (ed, x+xOff, y, display);
          END;
          (* Textadvance und damit xOffset berechnen *)
          InqTextextend (ed, display, extend, FALSE);
          INC (xOff, extend[1].x - extend[0].x);
        END;
        (* Texteffekt wieder abstellen *)
        v.bset := MagicVDI.SetTexteffect (hdl, {});
      ELSE
        (* Zeile einfach ausgeben *)
        simpleOutput();
        (*
        IF doOutput
        THEN
          Text (ed, x, y, line);
        END;
        chAdr := ADR(line[maxExtIdx]);
        saveCh := chAdr^;
        chAdr^ := 0C;
        (* Textadvance und damit xOffset berechnen *)
        InqTextextend (ed, line, extend, FALSE);
        chAdr^ := saveCh;
        INC (xOff, extend[1].x - extend[0].x);
        *)
      END;
      IF isQ & (mtAppl.Bitplanes > 1)
      THEN
        (* Farbe wieder zurcksetzen *)
        v.int := MagicVDI.SetTextcolor (hdl, textCol);
      ELSIF isQ
      THEN
        (* Texteffekt wieder zurcksetzen *)
        v.bset := MagicVDI.SetTexteffect (hdl, {});
      END;
    ELSE
      simpleOutput();
      (*
      IF doOutput
      THEN
        Text (ed, x, y, line);
      END;
      chAdr := ADR(line[maxExtIdx]);
      saveCh := chAdr^;
      chAdr^ := 0C;
      (* Textadvance und damit xOffset berechnen *)
      InqTextextend (ed, line, extend, FALSE);
      chAdr^ := saveCh;
      INC (xOff, extend[1].x - extend[0].x);
      *)
    END;
    (* ext-Array fllen *)
    FOR i := 0 TO 3 DO
      ext[i] := extend[i];
    END;
    ext[0].x := 0;
    ext[1].x := xOff;
  END;
  (*$W=*)
END handleEffectLine;

PROCEDURE OutputLine (ed : EDITPTR; x, y : INTEGER; REF line : ARRAY OF CHAR; 
                      len : INTEGER; VAR width : INTEGER);
 VAR extend    : ARRAY [0..3] OF Point;
BEGIN
  handleEffectLine (ed, x, y, line, len, TRUE, len, extend);
  width := extend[1].x - extend[0].x;
END OutputLine;

PROCEDURE GetTextWidth (ed : EDITPTR; REF string: ARRAY OF CHAR; idx: INTEGER;
                             VAR extent: ARRAY OF LOC);
(* Diese Porzedur parst den Text immer. Idx gibt die Position an, bis zu der der 
 * String maximal zusammengesetzt wird! 
 *)
 VAR extend     : POINTER TO ARRAY [0..3] OF Point;
BEGIN
  extend := ADR(extent);
  handleEffectLine (ed, 0, 0, string, LENGTH(string), FALSE, idx, extend^);
END GetTextWidth;

PROCEDURE InqTextextend (ed : EDITPTR; REF string: ARRAY OF CHAR;
                             VAR extent: ARRAY OF LOC; parseEffects: BOOLEAN);
          (* vqt_extent *)
  VAR (*$Reg*) i : CARDINAL;
      extend     : POINTER TO ARRAY [0..3] OF Point;
      l          : INTEGER;
BEGIN
  IF string[0] = 0C THEN 
    FOR i := 0 TO HIGH (extent)-1 DO extent[i] := 0; END;
    RETURN
  END;
  IF ~parseEffects
  THEN
    WITH ed^ DO 
      IF isFSM
      THEN
        MagicFSM.InqFExtent (hdl, string, extent);
      ELSE 
        MagicVDI.InqTextextent (hdl, string, extent);
      END;
    END;
  ELSE
    extend := ADR(extent);
    l := LENGTH (string);
    handleEffectLine (ed, 0, 0, string, l, FALSE, l, extend^);
  END;
END InqTextextend;

PROCEDURE RowToIndex (REF str : ARRAY OF CHAR; row, tabSize : INTEGER) : INTEGER;
  VAR i, j : INTEGER;
BEGIN
  j := 0;
  FOR i := 0 TO row - 1 DO
    IF str[i] = TAB
    THEN
      j := ((j DIV tabSize) + 1) * tabSize;
    ELSE
      INC(j);
    END;
  END;
  RETURN j;
END RowToIndex;

PROCEDURE FixCursorPos (VAR ed : EDITPTR);
(* Pat auf, das der Cursor nie hinter einem CR/LF steht
 *)
  VAR (*$Reg*) tPtr: textPtr;
      (*$Reg*) ch  : CHAR;
BEGIN
  WITH ed^ DO
    IF (currRow > 0)
    THEN
      tPtr := editLine.text;
      LOOP
        (* IF (ORD(editLine.text^[currRow-1]) >= 20) OR (editLine.text^[currRow-1] = TAB) THEN EXIT END; *)
        ch := tPtr^[currRow-1];
        IF (ch # CR) & (ch # LF) THEN EXIT END;
        DEC (currRow);
        IF currRow <= 0 THEN EXIT END;
      END;
    END;
  END;
END FixCursorPos;

        (* Cursor-Zeichenfunktionen *)
        
PROCEDURE ClipWork (ed : EDITPTR);
  VAR clip : Rectangle;
BEGIN
  clip := RectFuncs.ClipRect (deskSize, ed^.editWork);
  WdwManager.SetClip (ed^.hdl, clip, TRUE);
END ClipWork;

PROCEDURE getCursorRect (VAR ed : EDITPTR; VAR xy: ARRAY OF INTEGER);
  VAR c, r : Rectangle;
      extend    : ARRAY [0..3] OF Point;
      ch  : ARRAY [0..1] OF CHAR;
      saveCh : CHAR;
      charAdr : POINTER TO CHAR;
      text    : textPtr;
BEGIN
  WITH ed^ DO
    IF (currLineNr >= totalLineNr) OR (readOnly & ~multiBlockMark) THEN RETURN END;
    (* So geht's schneller: *)
    (*
    getCharPos (ed, currLineNr, currRow, c.x, c.y);
    *)
    IF ~EditBase.GetLineAdr (ed, currLineNr, text, v.int) THEN RETURN END;
    IF currRow > v.int THEN currRow := v.int; END;
    charAdr := ADR (text^[currRow]);
    saveCh := charAdr^;
    IF (currRow # cursPos.row) OR (currLineNr # cursPos.line)
    THEN
      IF ~monoSpaced OR realTabs OR isFSM   (* added "OR isFSM" for Monospaced 821 Font *)
      THEN
        (* String terminieren *)
        charAdr^ := 0C;
        IF realTabs 
        THEN
          CatGlobal.ConvertTabs (text^, theDrawLine, tabSize);
          text := ADR (theDrawLine);
        END;
        (* Cursorposition bestimmen *)
        InqTextextend (ed, text^, extend, FALSE);
        (* nderung wieder rckgngig machen *)
        charAdr^ := saveCh;
        cursPos.x := extend[1].x - extend[0].x;
      ELSE
        cursPos.x := currRow * charWidth;
        extend[1].x := cursPos.x;
        extend[0].x := 0;
      END;
      cursPos.row := currRow;
      cursPos.line := currLineNr;
      
    ELSE
      extend[1].x := cursPos.x;
      extend[0].x := 0;
    END;
    (*----*)
    c.x := editWork.x + extend[1].x - extend[0].x + pixOff - leftOffset;
    c.y := editWork.y + SHORT(currLineNr - StartLine) * charHeight;
    xy[0] := c.x;
    xy[1] := c.y - 1;
    xy[3] := c.y + charHeight + 1;
    IF insertMode THEN
      xy[2]:= xy[0]+1;
    ELSE
      (* Zeichenausmae holen *)
      ch[1] := 0C;
      ch[0] := saveCh;
      IF (ch[0] = 0C) OR (monoSpaced & ~isFSM) THEN (* added "& ~isFSM" for Monospaced 821 Font *)
        xy[2] := c.x + charWidth;
      ELSE
        InqTextextend (ed, ch, extend, FALSE);
        xy[2] := c.x + extend[1].x - extend[0].x - 1;
      END;
      INC (xy[1]); DEC(xy[3]);
    END;
  END;
END getCursorRect;

PROCEDURE drawCursor (VAR ed: EDITPTR; grow: BOOLEAN);
  VAR xy : ARRAY [0..3] OF INTEGER;
      r  : Rectangle;
BEGIN
  WITH ed^ DO
    getCursorRect (ed, xy);
    IF grow THEN
      WITH r DO x := xy[0]; y := xy[1]; w := xy[2] - xy[0] + 1; h := xy[3] - xy[1] + 1;  END;
      GrowAndShrink (ed, r);
    ELSE
      MagicVDI.FillRectangle (cursorHandle, xy);
    END;
  END;
END drawCursor;

(*----------------------------------------------------------------------*
 *                            Musetreiberei                            *
 *----------------------------------------------------------------------*)

VAR mouseCount : CARDINAL;
    smCount    : CARDINAL;
    smForm     : INTEGER;
    smUser     : ADDRESS;
    MausForm   : INTEGER;
    Usermaus   : ADDRESS;
    
PROCEDURE SetMouse ();
BEGIN
  IF MausForm = MagicAES.USERDEF THEN
   MagicAES.GrafMouse (MausForm, Usermaus);
  ELSE
   MagicAES.GrafMouse (MausForm, NIL);
  END;
END SetMouse;

PROCEDURE MouseArrow;
BEGIN
 MausForm:= MagicAES.ARROW;  SetMouse(); (* ShowMouse(FALSE); *)
END MouseArrow;


PROCEDURE MouseCursor;
BEGIN
 MausForm:= MagicAES.TEXTCRSR;  SetMouse();
END MouseCursor;


PROCEDURE MouseBusy;
BEGIN
 MausForm:= MagicAES.BUSYBEE;  SetMouse();
END MouseBusy;


PROCEDURE MouseFinger;
BEGIN
 MausForm:= MagicAES.POINTHAND;  SetMouse();
END MouseFinger;


PROCEDURE MouseHand;
BEGIN
 MausForm:= MagicAES.FLATHAND;  SetMouse();
END MouseHand;


PROCEDURE MouseThincross;
BEGIN
 MausForm:= MagicAES.THINCROSS;  SetMouse();
END MouseThincross;


PROCEDURE MouseThickcross;
BEGIN
 MausForm:= MagicAES.THICKCROSS;  SetMouse();
END MouseThickcross;


PROCEDURE MouseOutline;
BEGIN
 MausForm:= MagicAES.OUTLCROSS;  SetMouse();
END MouseOutline;


PROCEDURE MouseUser;
BEGIN
 MausForm:= MagicAES.USERDEF;  SetMouse();
END MouseUser;

PROCEDURE UserMouse (VAR form: MagicTypes.MFORM);
BEGIN
 Usermaus:= ADR(form);
END UserMouse;

PROCEDURE SaveMouse ();
BEGIN
  smCount := mouseCount;
  smUser := Usermaus;
  smForm := MausForm;
END SaveMouse;

PROCEDURE RestoreMouse();
BEGIN
  Usermaus := smUser;
  MausForm := smForm;
  IF (mouseCount > 0) & (smCount = 0)
  THEN 
    SetMouse();
    ShowMouse (TRUE);
  ELSIF (mouseCount = 0) & (smCount > 0)
  THEN 
    SetMouse();
    HideMouse();
  ELSE
    mouseCount := smCount
  END;
END RestoreMouse;

PROCEDURE MouseIsOn () : BOOLEAN;
BEGIN
  RETURN mouseCount = 0;
END MouseIsOn;

PROCEDURE HideMouse ();
BEGIN
  IF mouseCount = 0 THEN 
    MagicAES.GrafMouse (MagicAES.MOFF, NIL);
  END;
  INC (mouseCount);
END HideMouse;

PROCEDURE ShowMouse (force : BOOLEAN);
BEGIN
  IF (mouseCount > 0) OR force THEN 
    IF mouseCount <= 0 THEN RETURN END;
    DEC (mouseCount);
    IF force THEN mouseCount := 0 END;
    IF mouseCount = 0 THEN MagicAES.GrafMouse (MagicAES.MON, NIL);
    END;
  END;
END ShowMouse;

PROCEDURE CursorIsOn (ed : EDITPTR) : BOOLEAN;
BEGIN
  RETURN (ed^.cursor = 0)
END CursorIsOn;

VAR inForce : BOOLEAN;

PROCEDURE HideCursor (VAR ed : EDITPTR);
  VAR r: Rectangle;
BEGIN
  WITH ed^ DO
    IF isHidden OR inForce THEN RETURN END;
    IF cursor = 0 THEN 
      IF (~readOnly OR multiBlockMark) & (~block OR (block & blockIndent))THEN 
        IF WdwManager.RectList (wdw, 0, r)
        THEN
          REPEAT
            WdwManager.SetClip (cursorHandle, r, TRUE);
            drawCursor (ed, FALSE); 
          UNTIL ~WdwManager.RectList (wdw, 1, r);
        END;
        WdwManager.SetClip (cursorHandle, ed^.editWork, TRUE);
      END;
    END;
    INC (cursor);
  END;
END HideCursor;

PROCEDURE ShowCursor (VAR ed : EDITPTR);
  VAR r: Rectangle;
BEGIN
  WITH ed^ DO
    IF isHidden OR inForce THEN RETURN END;
    IF (cursor < 0) THEN HALT END;
    IF cursor > 0 THEN 
      DEC (cursor);
      IF (cursor = 0) & (~readOnly OR multiBlockMark) & (~block OR (block & blockIndent)) THEN 
        IF WdwManager.RectList (wdw, 0, r)
        THEN
          REPEAT
            WdwManager.SetClip (cursorHandle, r, TRUE);
            drawCursor (ed, FALSE); 
          UNTIL ~WdwManager.RectList (wdw, 1, r);
        END;
        WdwManager.SetClip (cursorHandle, ed^.editWork, TRUE);
      END;
    END;
  END;
END ShowCursor;

PROCEDURE ForceCursor (VAR ed: EDITPTR);
  VAR xy : ARRAY [0..3] OF INTEGER;
       r : Rectangle;
BEGIN
  WITH ed^ DO
    IF isHidden THEN RETURN END;
    inForce := TRUE;
    cursor := 0;
    getCursorRect (ed, xy);
    WITH r DO x := xy[0]; y := xy[1]; w := xy[2] - xy[0] + 1; h := xy[3] - xy[1] + 1;  END;
    WdwManager.RedrawWdw (wdw, r);
    inForce := FALSE;
    IF (readOnly & ~multiBlockMark) OR (block & ~blockIndent) THEN RETURN END;
    IF WdwManager.RectList (wdw, 0, r)
    THEN
      REPEAT
        WdwManager.SetClip (cursorHandle, r, TRUE);
        drawCursor (ed, FALSE); 
      UNTIL ~WdwManager.RectList (wdw, 1, r);
    END;
    WdwManager.SetClip (cursorHandle, ed^.editWork, TRUE);
  END;
END ForceCursor;

BEGIN
  inForce := FALSE;
END EditGlobals.
