DEFINITION MODULE EditTools;

FROM SYSTEM     IMPORT ADDRESS;

FROM EditTypes  IMPORT EDITPTR, aLinePtr, undoType, aMark, searchDir;

PROCEDURE SetInfoLine (ed : EDITPTR);

PROCEDURE SetEditTitle (ed : EDITPTR);

PROCEDURE ShowFileChanged (ed : EDITPTR);

PROCEDURE UpdateCurrLine (VAR ed : EDITPTR; line : LONGINT);

PROCEDURE SetCurrLine (VAR ed : EDITPTR; line : LONGINT);

PROCEDURE SetStartLine (VAR ed : EDITPTR; line : LONGINT; docUpdate : BOOLEAN);

        (* Abfrage-Funktionen           *)

PROCEDURE getCharPos (VAR ed : EDITPTR; line : LONGINT; row : INTEGER; VAR x, y : INTEGER);

PROCEDURE SaveLine(VAR l : aLinePtr; lNr : LONGINT);

PROCEDURE PutInUndoList (line : aLinePtr);

PROCEDURE SaveOp (ed : EDITPTR; op : undoType; append : BOOLEAN);

PROCEDURE NewBlockToUndoBuffer (VAR ed : EDITPTR);

PROCEDURE DeleteLine (VAR ed : EDITPTR; redraw : BOOLEAN);

PROCEDURE FreeUndoBuffer();

PROCEDURE CheckAndFreeUndo(wdw: INTEGER);

PROCEDURE Undo (VAR ed : EDITPTR);

PROCEDURE SetBlockstart (VAR ed : EDITPTR);

PROCEDURE SetBlockend (VAR ed : EDITPTR);

PROCEDURE ClearBlock (VAR ed : EDITPTR);

PROCEDURE GetClickLineAndRow (ed : EDITPTR; x, y : INTEGER; VAR clLine : LONGINT; VAR clRow : INTEGER);

PROCEDURE TestBlockMarksAndSwap (ed : EDITPTR);

PROCEDURE ToWordEnd (ed : EDITPTR; line : LONGINT; row : INTEGER) : INTEGER;

PROCEDURE ToWordStart (ed : EDITPTR; line : LONGINT; row : INTEGER) : INTEGER;

PROCEDURE ToLineEnd (ed: EDITPTR; line: LONGINT): INTEGER;

PROCEDURE ToLineStart (ed: EDITPTR; line: LONGINT): INTEGER;

PROCEDURE MarkLine (ed : EDITPTR);

PROCEDURE MarkWord (VAR ed : EDITPTR);

PROCEDURE MarkBlock (VAR ed : EDITPTR; ox, oy : INTEGER; init: BOOLEAN; fromTop : BOOLEAN);

PROCEDURE ToBlockmark (ed : EDITPTR; ende : BOOLEAN); 

PROCEDURE InitSearch (ed: EDITPTR; direction: searchDir;
                      VAR search, repl: ARRAY OF CHAR; doRepl: BOOLEAN): BOOLEAN; 
(* Compiliert das Suchmuster und setzt ein paar Variablen fr
 * Suchen & Ersetzen mit Wildcards, falls ersetzt werden soll
 *)

PROCEDURE SearchWord (ed : EDITPTR; w: ARRAY OF CHAR; 
                      direction : searchDir; VAR gefunden: BOOLEAN;
                      VAR foundWord: ARRAY OF CHAR; again : BOOLEAN);

PROCEDURE ReplaceWord (ed : EDITPTR; VAR s, t: ARRAY OF CHAR);

PROCEDURE EndSearch ();
(* Gibt das compilierte Suchmuster wieder frei
 *)

PROCEDURE PossibleUndo (ed: EDITPTR): BOOLEAN;

END EditTools.
