DEFINITION MODULE EditTypes;

FROM SYSTEM IMPORT ADDRESS;

FROM GrafBase   IMPORT Rectangle;

CONST CAT = TRUE;

TYPE CharSet  = SET OF CHAR;

CONST   TrennSet =      CharSet {0C..' ', '!', '"', '%', '&',
          '(', ')', '=', '?', "'", '`', '#', '^', '@', '\', '+', 
          '[', ']', '{', '}', '<', '>', ',', ';', '.', ':', '-', 
          '~', '|'};
        
        UmbruchSet = CharSet {0C..' ','-','~'};
        
        maxBlocks   = 50;

TYPE lineMode   = (LFIRST, LNEXT);

TYPE aMark      = RECORD
                    line        : LONGINT;
                    row         : INTEGER;
                  END;  (* aMark *)
     aBlock     = RECORD
                    blockStart,
                    blockEnd    : aMark;
                  END;
     
     textPtr    = POINTER TO ARRAY [0..$7FFF] OF CHAR;
     bigTextPtr = POINTER TO ARRAY [0..MAX(LONGCARD)] OF CHAR;
                   
     aLineDesc  = RECORD
                    text        : textPtr;
                    length      : INTEGER;
                  END; (* aLineDesc *)
                  
     aLinePtr   = POINTER TO aLine;
     
     lineArray  = ARRAY [0..$7FFF] OF INTEGER;

     lineArrayPtr = POINTER TO lineArray;
     
     aBufferPtr = POINTER TO aBuffer;
     
     aBuffer    = RECORD
                    buffer : textPtr;
                    bufSize: INTEGER;
                    lines  : lineArrayPtr;
                    usedMem,
                    maxLine: INTEGER;
                    fromLine,
                    toLine : LONGINT;
                    next,
                    prev   : aBufferPtr;
                  END;
                  
     
     aLine      = RECORD
                    next, prev  : aLinePtr;
                    zeile       : aLineDesc;
                  END;  (* aLine *)
     
     userProcType       = PROCEDURE ((* wdw:    *) INTEGER,
                                     (* vdiHdl: *) INTEGER,
                                     (* mx, my :*) INTEGER, INTEGER, 
                                     (* kstate :*) BITSET,
                                     (* work :  *) Rectangle); 

     userGetRectProc    = PROCEDURE ((* wdw:  *) INTEGER,
                                     (*wdwRect*) Rectangle, 
                                     VAR (* userRect *) Rectangle,
                                     VAR (* editWorkRect *) Rectangle);
                            
     drawUserProc       = PROCEDURE ((* wdw:     *) INTEGER,
                                     (* vdiHdl:  *) INTEGER,
                                     (* wdwWork: *) Rectangle,
                                     (* clip:    *) Rectangle,
                                     (* textCol: *) INTEGER,
                                     (* backCol: *) INTEGER);

     (* Wird dann aufgerufen, wenn der Editor definitiv geschlossen wird! *)
     userCloseProc      = PROCEDURE ((* wdw: *) INTEGER): BOOLEAN;

     (* Falls diese Prozedur existiert, wird sie vor jeder Tastenbehandlung aufgerufen.
      * Man mu diese Prozedur aber nicht bergeben, NIL geht auch!
      *)
     userKeyProc        = PROCEDURE ((* wdw *)            INTEGER, 
                                     VAR (* scan, c: *)   CHAR, VAR CHAR,
                                     VAR (* kstate: *)    BITSET, 
                                     VAR (* moreChars: *) BOOLEAN): BOOLEAN;
     (* Wird aufgerufen, bevor die Taste vom Editor behandelt wird.
      * Wenn TRUE zurckgegeben wird, wird die Taste danach NICHT vom Editor behandelt.
      * Wenn moreChars auf TRUE gesetzt wird, wird nach der Behandlung durch den 
      * Editor die Prozedur solange aufgerufen und die Tasten aus scan und c behandelt,
      * bis moreChars auf FALSE gesetzt wird.
      *)
     userTopProc       = PROCEDURE ( (* wdw: *) INTEGER); 
     (* Wird aufgerufen, wenn das Fenster getoppt wird. Dann kann das Usermodul
      * ggf. noch andere dazu passende Aktionen unternehmen (Menuzeile umgestalten)
      * Man kann auch statt der Prozedur NIL bergeben
      *)
     userUntopProc     = PROCEDURE ( (* wdw: *) INTEGER); 
     (* Wird aufgerufen, wenn das Fenster enttoppt wird. Dann kann das Usermodul
      * ggf. noch andere dazu passende Aktionen unternehmen (Menuzeile umgestalten)
      * Man kann auch statt der Prozedur NIL bergeben
      *)

     userPrePrintProc = PROCEDURE ( (* wdw *) INTEGER,  
                                    (* which *) lineMode,
                                    VAR (* string *) ARRAY OF CHAR) : BOOLEAN;
     (* Falls diese Prozedur bergeben wird, dann wird diese vor dem Drucken
      * eines Textes oder Blocks solange aufgerufen, bis sie als Ergebnis FALSE
      * liefert. Beim ersten Aufruf wird sie mit dem Parameter LFIRST und
      * bei den folgenden mit dem Parameter LNEXT aufgerufen.
      * Man kann auch NIL an den Editor bergeben.
      *)
     
     userListProc       = PROCEDURE ( (* wdw: *) INTEGER,
                                      REF (* line: *) ARRAY OF CHAR);
     (* Diese Prozedur wird im Listenmodus benutzt, wenn eine Zeile
      * doppelgeclickt wird
      *)
     
     (* Die folgenden Prozedurtypen sind fr die Untersttzung von zustzlichen
      * Drag&Drop-Typen als Server durch die Userprozeduren 
      *)
     
     userDDGetMaxExtProc= PROCEDURE ( (* wdw: *) INTEGER): INTEGER;
     (* Liefert die Anzahl der zustzlich verfgbaren Extensions
      * fr das Drag&Drop
      *)
     
     userDDGetExtProc   = PROCEDURE ( (* wdw: *)    INTEGER, 
                                      (* mode: *)   INTEGER,
                                      VAR (* ext: *) ARRAY OF CHAR): BOOLEAN;
     (* Liefert die erste oder weitere zustzliche Extensions. mode ist der
      * Headermode aus dem WdwManager (HDRFIRST, HDRNEXT)
      * In ext mu die Prozedur die Daten reinschreiben, 4 Zeichen lang!
      *)
     
     userDDGetExtNameProc = PROCEDURE ( (* wdw: *)   INTEGER, 
                                        (* idx: *)   INTEGER,
                                        VAR (* name: *) ARRAY OF CHAR);
     (* Mu den Namen der Extension liefern
      * idx: Index der Userextension, von 0 an gezhlt
      *)
     
     userDDGetSizeProc  = PROCEDURE ( (* wdw: *)   INTEGER, 
                                      (* idx: *)   INTEGER,
                                      VAR (* size: *) LONGCARD);
     (* Liefert die Gre der zu verschickenden Daten
      * idx: Index der Userextension, von 0 an gezhlt
      *)
     
     userDDGetDataProc  = PROCEDURE ( (* wdw: *)   INTEGER, 
                                      (* idx: *)   INTEGER,
                                      VAR (* data: *) ADDRESS);
     (* Liefert die zu verschickenden Daten
      * idx: Index der Userextension, von 0 an gezhlt
      * Der Speicher wird spter vom Drag&Drop-Teil wieder
      * freigegeben
      *)

     searchPos = (fromPos, fromStart);
     
     searchDir = (forward, backward);
     
     searchCount = (searchOne, searchNum, searchAll);

     SuchFlags  = (GrossKlein, NurWort, silent);
     
     SuchModus  = SET OF SuchFlags;
     
     EDITPTR    = POINTER TO EDITOR;
     
     EDITOR     = RECORD
                    wdw         : INTEGER;          (* window handle *)
                    hdl         : INTEGER;          (* VDI-Handle    *)
                    font        : INTEGER;          (* font id *)
                    fontSize    : INTEGER;          (* font point size *)
                    windComps   : BITSET;
                    charHeight,
                    charWidth   : INTEGER;          (* charWidht only for *)
                    wasOpen, 
                    isFSM,                          (* ist FSM-Font?      *)
                    monoSpaced  : BOOLEAN;          (* monospaced fonts   *)
                    editWork    : Rectangle;        (* Der reine Edit-Bereich *)
                    isFull      : BOOLEAN;          (* window fulled? *)
                    isHidden    : BOOLEAN;          (* window is hidden *)
                    (* userProc fr Events, die vom User gemanaget werden *)
                    hasUserProc : BOOLEAN;
                    userProc    : userProcType;
                    getUserRect : userGetRectProc;
                    drawUserArea: drawUserProc;
                    userClose   : userCloseProc;
                    userKey     : userKeyProc;
                    userRect    : Rectangle;
                    userTop     : userTopProc;
                    userUntop   : userUntopProc;
                    userPrint   : userPrePrintProc;
                    listModeProc: userListProc;
                    (* User-Drag&Drop *)
                    userDD              : BOOLEAN;
                    userDDGetMaxExts    : userDDGetMaxExtProc;
                    userDDGetExt        : userDDGetExtProc;
                    userDDGetExtName    : userDDGetExtNameProc;
                    userDDGetSize       : userDDGetSizeProc;
                    userDDGetData       : userDDGetDataProc;
                    (* -------- *)
                    hOffset     : INTEGER;      (* Unterschied zwischen charHeight und userRect.h *)
                    (* nun die Editor-Variablen *)
                    windLines   : INTEGER;      (* Zeilen pro Fensterseite *)
                    new,
                    changed     : BOOLEAN;
                    showInfo    : BOOLEAN;
                    firstBuff,
                    currentBuff : aBufferPtr; 
                    StartLine,               (* oberste Zeile im Fenster *)
                    currLineNr,
                    totalLineNr : LONGINT;
                    editLine    : aLineDesc;
                    editLineNr  : LONGINT;
                    editLen     : INTEGER;
                    editChanged : BOOLEAN;
                    maxWidth    : INTEGER;   (* Breite in Pixeln des Textes *)
                    leftOffset  : INTEGER;   (* Pixeloffset fr linken Rand *)
                    currRow     : INTEGER;
                    tabSize     : INTEGER;
                    lineBlock,                  (* Block wurde Zeilenweise markiert *)
                    wordBlock   : BOOLEAN;      (* Block wurde im Wortmodus markiert *)
                    blocks      : ARRAY [0..maxBlocks-1] OF aBlock;
                    (* blockStart,
                    blockEnd    : aMark; *)
                    markPoints  : ARRAY [0..4] OF aMark;  (* 5 Marken knnen gesetzt werden *)
                    rightMargin : INTEGER;
                    realTabs,                   (* Echte Tabs ja/nein                             *)
                    umbruch,                    (* Umbruch ja/nein                                *)
                    backup,                     (* automatisch ein Backup erzeugen beim Speichern *)
                    readOnly,                   (* Text darf nicht gendert werden! *)
                    showCR, 
                    autoIndent,
                    insertMode,
                    listMode,                   (* Die Anzeige ist nur eine Liste von Zeilen *)
                    parseEffects,               (* Bei Anzeige auf Effekte parsen *)
                    alienCoords : BOOLEAN;      (* Fensterkoordinaten werden von Fremdmodul verwaltet *)
                    number      : INTEGER;      (* Die Nummer fr die Editorvariablen *)
                    cursor      : INTEGER;      (* cursor an/aus *)
                    multiBlockMark,             (* Gerade im markieren multipler Blcke *)
                    blockIndent,                (* Gerade im Block einrcken *)
                    block       : BOOLEAN;      (* Ein Block ist an! *)
                    multiBlockIdx: INTEGER;     (* Nummer des Blocks, der gerade markiert wird *)
                    cursPos     : RECORD 
                                    line : LONGINT;
                                    row  : INTEGER;
                                    x, y : INTEGER;
                                  END;
                    fileName    : aLineDesc;
                    findMode    : SuchModus;
                    WindowInfo  : ARRAY [0..139] OF CHAR;
                    WindowTitle : ARRAY [0..139] OF CHAR;
                    (* Fr Fehlermeldungen *)
                    errLine     : LONGINT;
                    errRow      : INTEGER;
                    errMsg      : ARRAY [0..127] OF CHAR;
                    nextEdit    : EDITPTR;
                    (* Ab 2.02 fr Farben etc. *)
                    quoteEff    : BITSET;       (* Effekt fr Quotes, nur Monochrom *)
                    quoteCol    : INTEGER;      (* Farbe fr Quotes *)
                    textCol     : INTEGER;      (* Textfarbe *)
                    backCol     : INTEGER;      (* Hintergrundfarbe *)
                    (* Fr Drag & Drop *)
                    currentExt  : INTEGER;      (* Aktuelle Extension, die als Server geliefert wird *)
                    (* fr Umbruch von langen Nachrichten *)
                    lastWrapWidth: INTEGER;
                    isEnriched  : BOOLEAN;      (* Fr Anzeige. Wenn TRUE, dann wird immer umbrochen *)
                    wdwIsOpen   : BOOLEAN;
                  END;  (* EDITOR *)

TYPE
        undoType   = (blockToChar, charToBlock, blockCut, cutUndo, blockPaste, normalPaste, nothingToDo);

CONST pixOff    = 2;                    (* pixelOffset fr linken Rand          *)                    

VAR deskSize : Rectangle;               (* grtmglicher Arbeitsbereich        *)

    theDrawLine : ARRAY [0..4095] OF CHAR;
    
    wildAllChar : CHAR;                 (* Alle Zeichen, Default: '*' *)
    wildOneChar : CHAR;                 (* Ein Zeichen, Default: '?' *)
    
    cursorHandle: INTEGER;              (* Handle der Workstation des Cursors *)
    
END EditTypes.
