IMPLEMENTATION MODULE FontSelect;

(* Modul:               FontSelect                              *
 * Autor:               Dirk Steins                             *
 * erstellt am:         11.10.91                                *
 * letzte nderung am:  27.10.94                                *
 * Version:             0.5                                     *
 * Interne Version:     V#003                                   *
 * Kommentar:           Fontauswahl fr Cat und CatPutz         *
 *                                                              *
 * Es wird eine eigene Fontliste aufgebaut, und aus dieser      *
 * kann man dann die Fonts auswhlen.                           *
 * Die Ressource fr beide mu gleich sein, da ich nicht alle   *
 * Konstanten anpassen will. Also mssen zumindest die          *
 * symbolischen Namen alle vorhanden sein.                      *
 *                                                              *
 *==============================================================*
 * Datum    Version     nderung                                *
 *==============================================================*
 *                                                              *
 * 11.10.91 0.1         Modul erstellt, da starke nderungen    *
 *                      in MagicLib.                            *
 *  1.11.91 0.2         WindUpdate ergnzt, fehlte noch         *
 * 22.11.92 0.3         Verzichtet jetzt komplett auf mtFonts   *
 *                      und ersetzt dieses dadurch              *
 * 21.09.93 0.4         Fontliste wird sortiert ausgegeben.     *
 *                      Dafr ein Dank an Gerd Castan fr die   *
 *                      Sortierroutine                          *
 * 27.10.94 0.5         Umgestellt auf Fensterdialog            *
 *                                                              *
 *==============================================================*)

FROM SYSTEM     IMPORT ADDRESS, ADR, LONGWORD, TSIZE;

FROM Storage    IMPORT ALLOCATE, DEALLOCATE;

FROM GrafBase   IMPORT Rectangle, Point;

FROM StrConv    IMPORT IntToStr, StrToInt;

IMPORT Strings;

IMPORT MagicAES, MagicVDI, MagicFSM, mtAppl, mtUtils, mtDials, mtAlerts, mtXobjects, mtRsc;

FROM MagicSys   IMPORT sINTEGER, lCARDINAL, sBITSET;


FROM mtDials    IMPORT DialDraw, DialForm, DSTART, DFINISH, DialDo, DialCenter, CSCREEN,
                       NewDial, DisposeDial, InstallHandler, CallByHandling, RemoveHandler;

FROM ListDl   IMPORT PrepareListDial, ReleaseListDial, FindDial, 
                     HandleListDial, AutoLocate, InitAutoLocator,
                     FreeAutoLocator, NilDIAL, DIAL, DrawListDial,
                     ldHandler, ldElems, ldElemSet,
                     BuildLdHandler;

FROM WinDials   IMPORT WinDialDraw, OpenWinDial, CloseWinDial, 
                       WinDialHandleEvents;

FROM RectFuncs  IMPORT ClipRect;
(*----------------------------------------------------------------------*
 *        Resource-Coder 1.03  (C)92 by Peter Hellinger Software        *
 *----------------------------------------------------------------------*
 *           Inline-Resource erzeugt am 29.05.1995 22:21:32             *
 *----------------------------------------------------------------------*)
 
TYPE tRscData = ARRAY [0..350] OF CARDINAL;
 
CONST RscData = tRscData {
        00000H, 0002CH, 001C4H, 00234H, 00234H, 00234H, 00234H, 002BCH, 002BCH, 
        00024H, 00011H, 00002H, 00004H, 00000H, 00000H, 00000H, 00000H, 002BCH, 
        00000H, 0002CH, 00000H, 001ACH, 0FFFFH, 00001H, 0000FH, 00014H, 00400H, 
        00010H, 00002H, 01100H, 00000H, 00000H, 00038H, 00013H, 00002H, 0FFFFH, 
        0FFFFH, 01119H, 00040H, 00010H, 00001H, 01101H, 00036H, 00000H, 00002H, 
        00001H, 00003H, 0FFFFH, 0FFFFH, 0131CH, 00000H, 00020H, 00000H, 00234H, 
        00002H, 00001H, 00012H, 00001H, 00004H, 0FFFFH, 0FFFFH, 00016H, 00000H, 
        00000H, 00000H, 001C4H, 00002H, 00003H, 00128H, 00001H, 00005H, 0FFFFH, 
        0FFFFH, 00016H, 00000H, 00000H, 00000H, 001E0H, 0002DH, 00003H, 00109H, 
        00001H, 00007H, 00006H, 00006H, 00014H, 00040H, 00000H, 000FFH, 01100H, 
        00002H, 00004H, 00028H, 00008H, 00005H, 0FFFFH, 0FFFFH, 00014H, 00040H, 
        00000H, 000FFH, 01100H, 00000H, 00000H, 00026H, 00008H, 00009H, 00008H, 
        00008H, 00014H, 00040H, 00000H, 000FFH, 01100H, 0002DH, 00004H, 00009H, 
        00006H, 00007H, 0FFFFH, 0FFFFH, 00014H, 00040H, 00000H, 000FFH, 01100H, 
        00000H, 00000H, 00007H, 00006H, 0000AH, 0FFFFH, 0FFFFH, 0001EH, 00008H, 
        00000H, 00000H, 001FCH, 0002DH, 0000BH, 00005H, 00001H, 0000BH, 0FFFFH, 
        0FFFFH, 0001CH, 00040H, 00000H, 00000H, 00246H, 00033H, 0000BH, 00003H, 
        00001H, 0000DH, 0000CH, 0000CH, 0141AH, 00000H, 00004H, 00000H, 00249H, 
        00002H, 0000DH, 00033H, 00003H, 0000BH, 0FFFFH, 0FFFFH, 0001CH, 00000H, 
        00000H, 00000H, 00259H, 00000H, 00000H, 00033H, 00003H, 0000EH, 0FFFFH, 
        0FFFFH, 0121AH, 08005H, 00000H, 00000H, 00264H, 00002H, 00011H, 00011H, 
        00001H, 0000FH, 0FFFFH, 0FFFFH, 0121AH, 00007H, 00000H, 00000H, 00275H, 
        0001FH, 00011H, 00009H, 00001H, 00000H, 0FFFFH, 0FFFFH, 0121AH, 04025H, 
        00000H, 00000H, 00279H, 0002CH, 00011H, 00009H, 00001H, 0FFFFH, 0FFFFH, 
        0FFFFH, 00016H, 00020H, 00000H, 00000H, 00218H, 00000H, 00000H, 00028H, 
        00001H, 00000H, 00282H, 00000H, 00290H, 00000H, 00291H, 00003H, 00006H, 
        00002H, 011A1H, 00000H, 0FFFFH, 0000EH, 00001H, 00000H, 00292H, 00000H, 
        0029AH, 00000H, 0029BH, 00003H, 00006H, 00002H, 011A1H, 00000H, 0FFFFH, 
        00008H, 00001H, 00000H, 0029CH, 00000H, 002A0H, 00000H, 002A5H, 00003H, 
        00006H, 00000H, 01180H, 00000H, 0FFFFH, 00004H, 00005H, 00000H, 002A9H, 
        00000H, 002B9H, 00000H, 002BAH, 00003H, 00000H, 00000H, 01100H, 00000H, 
        00000H, 00010H, 00001H, 05363H, 06872H, 06966H, 07420H, 06175H, 07377H, 
        08468H, 06C65H, 06E00H, 07074H, 00053H, 06368H, 07269H, 06674H, 06265H, 
        06973H, 07069H, 0656CH, 00054H, 06573H, 07473H, 07472H, 0696EH, 06700H, 
        05B42H, 06569H, 07370H, 06965H, 06C20H, 07A65H, 06967H, 0656EH, 0005BH, 
        04F4BH, 0005BH, 04162H, 06272H, 07563H, 06800H, 0205AH, 06569H, 06368H, 
        0656EH, 07361H, 0747AH, 02000H, 00000H, 02047H, 07294H, 09E65H, 02000H, 
        00000H, 03030H, 03000H, 0205FH, 05F5FH, 00039H, 03939H, 00041H, 06D65H, 
        07269H, 06361H, 06E61H, 02042H, 06F6CH, 06420H, 00000H, 00000H, 00000H

        }; (* Ende RscData *)
(*----------------------------------------------------------------------*)

(* Resource Datei Indizes fr FONTBOX *)
CONST

    Fontbox  =   0; (* Formular/Dialog *)
    Nameback =   5; (* BOX in Baum FONTBOX *)
    Namebox  =   6; (* BOX in Baum FONTBOX *)
    Sizeback =   7; (* BOX in Baum FONTBOX *)
    Sizebox  =   8; (* BOX in Baum FONTBOX *)
    Sizeedit =   9; (* FBOXTEXT in Baum FONTBOX *)
    Example  =  12; (* STRING in Baum FONTBOX *)
    Showexam =  13; (* BUTTON in Baum FONTBOX *)
    Fontok   =  14; (* BUTTON in Baum FONTBOX *)
    Fontcanc =  15; (* BUTTON in Baum FONTBOX *)

    Nametext =   1; (* Formular/Dialog *)
    Fontname =   0; (* BOXTEXT in Baum NAMETEXT *)
    
CONST   SysFontName     = 'Systemfont'+0C;

(* Datenstrukturen: 
 * fontList = Liste der Fontlisten :-)
 * In einem Eintrag Liste der Fonts
 *)
 TYPE   Fonts        = POINTER TO FontEntry;
        FontEntry    = RECORD
                        info : tFontinfo;
                        infoSet : BOOLEAN;
                        sel  : BOOLEAN;
                        next,
                        prev : Fonts;
                       END;
 
        FONTList    = POINTER TO FontList;
        FontList    = RECORD
                        handle   : sINTEGER;
                        numFonts : sINTEGER;
                        active   : sINTEGER;
                        actSize  : sINTEGER;
                        fonts    : Fonts;
                        dummy    : Fonts;
                        next     : FONTList;
                      END;
        SizePtr     = POINTER TO SizeEntry;
        SizeEntry   = RECORD
                        size : sINTEGER;
                        sel  : BOOLEAN;
                        next,
                        prev : SizePtr;
                      END;
        Sizes       = RECORD 
                        root, 
                        curr : SizePtr;
                        count : CARDINAL;
                      END;
                      
        fontEnv     = RECORD 
                        handle: sINTEGER;
                        monos : BOOLEAN;
                        tree  : ADDRESS;
                        size  : INTEGER;
                        fl    : FONTList;
                      END;
        fontEnvPtr  = POINTER TO fontEnv;

        FONTSEL     = POINTER TO FontSelType;
        FontSelType = RECORD
                        fontDial: DIAL;
                        sizeDial: DIAL;
                        fontHandler: ldHandler;
                        sizeHandler: ldHandler;
                        sizeList  : Sizes;
                        lastElem: ADDRESS;
                        oldSize : INTEGER;
                        oldId   : INTEGER;
                        fontId  : INTEGER;
                        fontSize: INTEGER;
                        exitBut : INTEGER;
                        handle  : INTEGER;
                        env     : fontEnv;
                        fl      : FONTList;
                        terminate: BOOLEAN;
                        currFont: sINTEGER;
                      END;
                        

  VAR fontList  : FONTList;     (* Die Liste der Fonts *)
      vi        : sINTEGER;
      vb        : BOOLEAN;
      gdos      : lCARDINAL;
      fontBox   : ADDRESS;      (* Baumadresse fr Fontbox *)
      fontText  : mtUtils.tObjcTree;      (* Baumadresse fr Anzeigestring *)

PROCEDURE FindFont (fl : FONTList; font : sINTEGER) : Fonts;
  VAR f : Fonts;
BEGIN
  f := fl^.fonts;
  WHILE (f # NIL) & (f^.info.id # font) DO f := f^.next END;
  RETURN f;
END FindFont;

PROCEDURE iLoadFonts (handle : sINTEGER) : INTEGER; 
(* Ldt die Fonts fr eine Workstation und gibt die Anzahl 
 * der geladenen Fonts zurck 
 *)
BEGIN
  IF gdos = MagicVDI.NoGdos THEN
   RETURN 0
  ELSE
   RETURN MagicVDI.LoadFonts (handle, 0);
  END;
END iLoadFonts;


(* Interne Prozedur fr SortFonts *)
PROCEDURE ZipSort (VAR list: Fonts; nodes: CARDINAL);

  VAR
    list1, list2: Fonts;
    I           : CARDINAL;
    result,last1: Fonts;

BEGIN
  IF list=NIL THEN HALT END;

  IF nodes<=1 THEN RETURN END; (* Eine Liste aus einem Element ist schon sortiert *)

  (* Liste in etwa gleich groe Teile aufteilen: *)
  (* list1 erhlt nodes DIV 2; list2 den rest *)
  list1 := list;
  list2 := list;
  FOR I := 1 TO (nodes DIV 2) DO
    last1 := list2;
    list2 := list2^.next
  END;
  last1^.next := NIL; (* Listen auseinanderschneiden *)
  (*WriteList (list1);
    WriteList (list2); *)
  (* list1 und list2 enthalten garantiert mindestens 1 Element *)

  (* Einzellisten Sortieren *)
  ZipSort (list1,nodes DIV 2);
  ZipSort (list2,nodes - (nodes DIV 2));

  (* Jetzt kommts: *)
  (* Erstes Listenelement festlegen: *)
  (* Die folgende IF-Bedingung macht das selbe wie die Zeile
   * >IF Strings.Compare (list2^.info.name, list1^.info.name)=Strings.less THEN
   * Ist aber statistisch wesentlich schneller.
   * Die IF-Bedingung bentigt sonst mehr Rechenzeit als alle anderen
   * Befehle zusammen.
   *)
  IF (list2^.info.name[0]<list1^.info.name[0])
  OR (Strings.Compare (list2^.info.name, list1^.info.name)=Strings.less) THEN
    list := list2; list2 := list2^.next
  ELSE
    list := list1; list1 := list1^.next
  END;
  result := list;

  LOOP
    IF list1=NIL THEN
      result^.next := list2; EXIT
    END;
    IF list2=NIL THEN
      result^.next := list1; EXIT
    END;
    IF (list2^.info.name[0]<list1^.info.name[0])
    OR (Strings.Compare (list2^.info.name, list1^.info.name)=Strings.less) THEN
      result^.next := list2; list2 := list2^.next
    ELSE
      result^.next := list1; list1 := list1^.next
    END;
    result := result^.next
  END;
END ZipSort;


(* Gc: *)
PROCEDURE SortFonts (fl: FONTList);
(* Sortiert die zu handle gehrigen Fonts nach dem Namen *)
  VAR
    font: Fonts;
    prev: Fonts;
BEGIN
  (* Liste als einfach verkettete Liste interpretieren und sortieren: *)
  ZipSort (fl^.fonts, fl^.numFonts);

  (* Zerstrte Rckwrtsverkettung restaurieren: *)
  font := fl^.fonts;
  prev := NIL;
  WHILE font#NIL DO
    font^.prev := prev;
    prev := font;
    font := font^.next
  END;
END SortFonts;

PROCEDURE GetFontList (handle : sINTEGER) : FONTList;
  VAR f1, 
      fl : FONTList;
      fInfo: tFontinfo;
      font : Fonts;
      num  : sINTEGER;
      name : ARRAY [0..79] OF CHAR;
      vi   : sINTEGER;
      vb   : BOOLEAN;
      wo   : ARRAY [0..60] OF INTEGER;
BEGIN
  fl := fontList;
  WHILE (fl # NIL) & (fl^.handle # handle) DO fl := fl^.next; END;
  IF fl = NIL
  THEN 
    (* Noch keine Fontliste mit diesem Handle vorhanden,
     * also neu eintragen! 
     *)
    (* Extended Inquire, um die Anzahl der Systemfonts rauszubekommen *)
    MagicVDI.ExtendedInq (handle, 0, wo);
    NEW (fl);
    IF (fl = NIL) THEN RETURN NIL END;
    fl^.handle := handle;
    IF gdos = MagicVDI.NoGdos THEN
      num := wo[10] - 1;
    ELSE
     num := MagicVDI.LoadFonts (handle, 0);
     IF num > 0 THEN 
       (* Systemfonts hinzufgen *)
       num := num + wo[10] - 1; 
     ELSIF num = -1 THEN 
       (* Laden fehlgeschlagen, Systemfonts nehmen *)
       num := wo[10] - 1 
     ELSE 
       (* num < -1 oder num = 0, unbekannt *)
       num := 0;
     END;
    END;
    fl^.next := NIL;
    fl^.fonts := NIL;
    (* Jetzt an fontListe anhngen *)
    IF fontList = NIL
    THEN
      fontList := fl;
    ELSE
      f1 := fontList;
      WHILE f1^.next # NIL DO
       f1 := f1^.next;
      END;
      f1^.next := fl;
    END;
    (* Jetzt alle Fonts nacheinander in Liste eintragen, aber ohne Infos! *)
    fl^.numFonts := 0;
    fl^.active := 1;
    IF mtAppl.CharHeight = 8 THEN  fl^.actSize := 9;  ELSE  fl^.actSize := 10;  END;
    vi := 0;
    LOOP
      IF vi > num THEN  EXIT;  END;
      NEW (font);
      IF font = NIL THEN RETURN fl END;
      INC (fl^.numFonts);
      font^.info.id := MagicFSM.InqFacename (handle, vi+1, font^.info.name, font^.info.fsm);
      (* Jetzt an Liste anhngen *)
      font^.sel := FALSE;
      font^.infoSet := FALSE;
      font^.next := NIL;
      IF fl^.fonts = NIL
      THEN
        fl^.fonts := font;
        font^.prev := NIL;
        fl^.dummy := fl^.fonts;
      ELSE
        fl^.dummy^.next := font;
        font^.prev := fl^.dummy;
        fl^.dummy := font;
      END;
      (* Nchsten Font nehmen *)
      INC (vi);
    END; (* LOOP *)
    SortFonts (fl);
  END; (* IF fl = NIL *)
  RETURN fl
END GetFontList;

PROCEDURE UnloadFonts (handle : sINTEGER);
  (* Lscht die Fonts wieder aus der Liste *)
  VAR fl, fl2 : FONTList;
BEGIN
  fl := fontList;
  WHILE (fl # NIL) & (fl^.handle # handle) DO fl := fl^.next; END;
  IF fl = NIL
  THEN RETURN END;
  WITH fl^ DO
    dummy := fonts;
    WHILE dummy # NIL DO
      dummy:= dummy^.next;
      DISPOSE (fonts);
      fonts := dummy;
    END;
    MagicVDI.UnloadFonts (handle, 0);
  END;
  (* Aus Liste austragen *)
  IF fl = fontList
  THEN
    fontList := fl^.next;
  ELSE
    fl2 := fontList;
    WHILE fl2^.next # fl DO fl2 := fl2^.next END;
    fl2^.next := fl^.next;
  END;
  DISPOSE (fl); 
END UnloadFonts;

(* Hilfsprozeduren fr das Blttern in der Liste *)

(* Es wird die Fontliste bergeben, so da ich auch
 * auf die anderen Variablen zugreifen kann
 *)
PROCEDURE resetFonts (l : ADDRESS);
  VAR fl : FONTList;
BEGIN
  fl := l;
  IF fl # NIL
  THEN
    fl^.dummy := NIL;
  END;
END resetFonts;

PROCEDURE nextFont (l : ADDRESS) : ADDRESS;
  VAR fl : FONTList;
BEGIN
  fl := l;
  IF fl # NIL
  THEN
   WITH fl^ DO
    IF dummy = NIL
    THEN
      dummy := fonts;
    ELSE
      dummy := dummy^.next;
    END;
    RETURN dummy
   END;
  END;
  RETURN NIL
END nextFont;

PROCEDURE prevFont (l : ADDRESS) : ADDRESS;
  VAR fl : FONTList;
BEGIN
  fl := l;
  IF fl # NIL
  THEN
   WITH fl^ DO
    IF dummy = NIL
    THEN
      dummy := fonts;
    ELSE
      dummy := dummy^.prev;
    END;
    RETURN dummy
   END;
  END;
  RETURN NIL
END prevFont;

PROCEDURE fontCount (l : ADDRESS; VAR ll: LONGINT; VAR ww: INTEGER);
  VAR fl : FONTList;
BEGIN
  fl := l;
  ww := 0;
  ll := 0;
  IF fl # NIL
  THEN 
    ll := LONG(fl^.numFonts)
  END;
END fontCount;

PROCEDURE fontEnabled (entry, env : ADDRESS) : BOOLEAN;
  VAR font : Fonts;
      ptrEnv : fontEnvPtr;
BEGIN
  font := entry;
  ptrEnv := env;
  IF ~ptrEnv^.monos THEN RETURN TRUE END;
  IF font # NIL
  THEN
    RETURN font^.info.mono
  END;
  RETURN TRUE
END fontEnabled;

PROCEDURE fontIsSelected (entry, env : ADDRESS) : BOOLEAN;
  VAR font : Fonts;
BEGIN
  font := entry;
  IF font # NIL
  THEN
    RETURN font^.sel
  END;
  RETURN FALSE
END fontIsSelected;

PROCEDURE fontSelected (entry, env : ADDRESS; line : INTEGER) : BOOLEAN;
  VAR font : Fonts;
      ptrEnv : fontEnvPtr;
      r : Rectangle;
BEGIN
  font := entry;
  ptrEnv := env;
  IF font # NIL
  THEN
    (* Feststellen, ob ein anderer selektiert ist *)
    IF ~font^.sel 
    THEN 
      (* Anderen Font deselektieren! *)
      font^.sel := TRUE;
    ELSE
      font^.sel := FALSE;
    END;
  END;
  RETURN FALSE
END fontSelected;

PROCEDURE fontToString (entry, env : ADDRESS; VAR str : ARRAY OF CHAR);
  VAR font : Fonts;
      ptrEnv : fontEnvPtr;
      fInfo  : tFontinfo;
BEGIN
  font := entry;
  ptrEnv := env;
  IF font # NIL
  THEN
    FontInfo (ptrEnv^.handle, font^.info.id, fInfo);
    Strings.Assign (fInfo.name, str, vb);
    Strings.Assign (fInfo.name, str, vb);
  END;
END fontToString;

PROCEDURE buildSizeList (font : sINTEGER; handle, fontSize : sINTEGER; VAR sizeList : Sizes): sINTEGER;
  VAR name : ARRAY [0..40] OF CHAR;
      lastSize,
      newSize,
      size,
      id,
      min, 
      max  : sINTEGER;
      fInfo : tFontinfo;
      aSize : SizePtr;
BEGIN
  WHILE sizeList.root # NIL DO
    aSize := sizeList.root;
    sizeList.root := sizeList.root^.next;
    DISPOSE (aSize);
  END;
  sizeList.count := 0;
  FontInfo (handle, font, fInfo);
  size := fInfo.point;
  min  := fInfo.min;
  max  := fInfo.max;
  IF fontSize = -1 THEN fontSize := size END;
  IF max < MAX (INTEGER) 
  THEN
    lastSize := max+1;
  ELSE
    lastSize := max
  END;
  vi := MagicVDI.SetTextface (handle, font);
  LOOP
    newSize := MagicVDI.SetCharpoints (handle, lastSize-1, vi, vi, vi, vi);
    IF newSize = lastSize THEN EXIT END;
    NEW (aSize);
    IF aSize = NIL THEN EXIT END;
    INC (sizeList.count);
    aSize^.size := newSize;
    aSize^.sel := aSize^.size = fontSize;
    aSize^.prev := NIL;
    IF sizeList.root = NIL
    THEN
      sizeList.root := aSize;
      aSize^.next := NIL;
    ELSE
      (* Am Anfang einhngen *)
      aSize^.next := sizeList.root;
      sizeList.root^.prev := aSize;
      sizeList.root := aSize;
    END;
    lastSize := newSize;
  END;
  sizeList.curr := sizeList.root;
  newSize := MagicVDI.SetCharpoints (handle, size, vi, vi, vi, vi);
  RETURN size;
END buildSizeList;

PROCEDURE resetSize (l : ADDRESS);
  VAR sp : POINTER TO Sizes;
BEGIN
  sp := l;
  IF sp # NIL
  THEN
    sp^.curr := NIL;
  END;
END resetSize;

PROCEDURE nextSize (l : ADDRESS) : ADDRESS;
  VAR sp : POINTER TO Sizes;
BEGIN
  sp := l;
  IF sp # NIL
  THEN
    WITH sp^ DO 
      IF curr = NIL
      THEN
        curr := root
      ELSE
        curr := curr^.next;
      END;
      RETURN curr;
    END;
  END;
  RETURN NIL;
END nextSize;
  
PROCEDURE prevSize (l : ADDRESS) : ADDRESS;
  VAR sp : POINTER TO Sizes;
BEGIN
  sp := l;
  IF sp # NIL
  THEN
    WITH sp^ DO 
      IF curr = NIL
      THEN
        curr := root
      ELSE
        curr := curr^.prev;
      END;
      RETURN curr;
    END;
  END;
  RETURN NIL;
END prevSize;

PROCEDURE sizeCount (l : ADDRESS; VAR ll : LONGINT; VAR ww: INTEGER);
  VAR sp : POINTER TO Sizes;
BEGIN
  sp := l;
  ww := 0;
  ll := 0;
  IF sp # NIL
  THEN
    ll := LONG(sp^.count);
  END;
END sizeCount;

PROCEDURE sizeEnabled (entry, env : ADDRESS) : BOOLEAN;
BEGIN
  RETURN TRUE
END sizeEnabled;

PROCEDURE isBold (entry, env : ADDRESS) : BOOLEAN;
BEGIN
  RETURN FALSE
END isBold;

PROCEDURE sizeIsSelected (entry, env : ADDRESS) : BOOLEAN;
  VAR size : SizePtr;
BEGIN
  size := entry;
  IF size # NIL
  THEN
    RETURN size^.sel
  END;
  RETURN FALSE
END sizeIsSelected;

PROCEDURE sizeSelected (entry, env : ADDRESS; line: INTEGER) : BOOLEAN;
  VAR size : SizePtr;
      ptrEnv : fontEnvPtr;
      r : Rectangle;
BEGIN
  size := entry;
  ptrEnv := env;
  IF size # NIL
  THEN
    (* Feststellen, ob ein anderer selektiert ist *)
    IF ~size^.sel (* & (obj >= 0) *)
    THEN 
      (* Size selektieren *)
      size^.sel := TRUE;
    ELSE (* IF (obj < 0) 
    THEN
    *)
      size^.sel := FALSE;
    END;
    ptrEnv^.size := size^.size;
  END;
  RETURN FALSE
END sizeSelected;

PROCEDURE sizeToString (entry, env : ADDRESS; VAR str : ARRAY OF CHAR);
  VAR size : SizePtr;
BEGIN
  size := entry;
  IF size # NIL
  THEN
    Strings.Assign (IntToStr (size^.size,3), str, vb);
  END;
END sizeToString;

VAR fontWidth : INTEGER;
    sizeWidth : INTEGER;

CONST spaceString = "          ";
      demoText    = 'The quick brown fox jumps over the lazy dog';

  PROCEDURE fontDrawEntry (entry, env : ADDRESS; x, y : INTEGER;
                           offset : INTEGER; clip   : Rectangle);

       VAR e   : Fonts;
           str : ARRAY [0..255] OF CHAR;
    BEGIN
      Strings.Assign ("", str, vb);
      fontToString (entry, env, str);
      mtUtils.SetObjcStringAdr (fontText, 0, ADR(str));
      fontText^[0].obX := x;
      fontText^[0].obY := y;
      fontText^[0].obWidth := fontWidth;
      
      IF e # NIL
      THEN 
        mtUtils.SetState (fontText, 0, MagicAES.SELECTED, fontIsSelected (entry, env));
        mtUtils.SetState (fontText, 0, MagicAES.DISABLED, ~fontEnabled (entry, env));
      ELSE
        mtUtils.SetState (fontText, 0, MagicAES.SELECTED, FALSE);
        mtUtils.SetState (fontText, 0, MagicAES.DISABLED, FALSE);
      END;
      MagicAES.ObjcDraw (fontText, 0, 8, clip);
    END fontDrawEntry;
  
  PROCEDURE sizeDrawEntry (entry, env : ADDRESS; x, y : INTEGER;
                           offset : INTEGER; clip   : Rectangle);
       VAR e   : Fonts;
           str : ARRAY [0..255] OF CHAR;
           vb  : BOOLEAN;
    BEGIN
      Strings.Assign ("", str, vb);
      sizeToString (entry, env, str);
      Strings.Insert (" ", 0, str, vb);
      mtUtils.SetObjcStringAdr (fontText, 0, ADR(str));
      fontText^[0].obX := x;
      fontText^[0].obY := y;
      fontText^[0].obWidth := sizeWidth;
      
      IF e # NIL
      THEN 
        mtUtils.SetState (fontText, 0, MagicAES.SELECTED, sizeIsSelected (entry, env));
        mtUtils.SetState (fontText, 0, MagicAES.DISABLED, ~sizeEnabled (entry, env));
      ELSE
        mtUtils.SetState (fontText, 0, MagicAES.SELECTED, FALSE);
        mtUtils.SetState (fontText, 0, MagicAES.DISABLED, FALSE);
      END;
      MagicAES.ObjcDraw (fontText, 0, 8, clip);
    END sizeDrawEntry;

VAR userDraw : RECORD
                handle : sINTEGER;
                fsm    : BOOLEAN;
                font,
                size   : sINTEGER;
                orgFsm : BOOLEAN;
                orgFont,
                orgSize : sINTEGER;
               END;

PROCEDURE drawText (para : MagicAES.PtrPARMBLK) : sBITSET;
VAR objctree:  mtUtils.tObjcTree;
    parent      : sINTEGER;
    clip,
    draw     : Rectangle;
    vbs      : sBITSET;
BEGIN
  objctree:= para^.pbTree; (* Beim Aufruf der Draw-Prozedur bekommt
                            * man nur eine Adresse bergeben 
                            *)
  (* Jetzt an den Objectkoordinaten einen String zeichnen *)
  parent := mtUtils.ObjcParent (objctree, para^.pbObj);
  mtUtils.ObjcArea (objctree, parent, clip);
  INC (clip.x, 1); INC (clip.y, 1);
  DEC (clip.w, 1); DEC (clip.h, 1);
  WITH para^ DO
    mtUtils.VarsToRect (pbXc, pbYc, pbWc, pbHc, FALSE, draw);
  END;
  WITH clip DO
    mtUtils.VarsToRect (x, y, w, h, FALSE, clip);
  END;
  draw := ClipRect (clip, draw);
  (* Fr VDI umwandeln *)
  mtUtils.AbsRect (draw);
  mtUtils.AbsRect (clip);
  MagicVDI.SetClipping (userDraw.handle, draw, TRUE);
  MagicVDI.FillRectangle(userDraw.handle, clip);
  
  (* Jetzt Font auswhlen *)
  
  vi := MagicVDI.SetTextface (userDraw.handle, userDraw.font);
  vi := MagicVDI.SetWritemode (userDraw.handle, MagicVDI.TRANSPARENT);
  vbs := MagicVDI.SetTexteffect (userDraw.handle, {});

  MagicVDI.SetTextalignment (userDraw.handle, 0, 3, vi, vi);
  IF userDraw.fsm
  THEN
    vi := MagicFSM.SetArbpoints (userDraw.handle, userDraw.size, vi, vi, vi, vi);
    MagicFSM.FSMText (userDraw.handle, clip.x, clip.h, demoText);
  ELSE
    vi := MagicVDI.SetCharpoints (userDraw.handle, userDraw.size, vi, vi, vi, vi);
    MagicVDI.Text (userDraw.handle, clip.x, clip.h, demoText);
  END;
  (* Text wieder zurcksetzen *)
  vi := MagicVDI.SetTextface (userDraw.handle, userDraw.orgFont);
  IF userDraw.orgFsm
  THEN
    vi := MagicFSM.SetArbpoints (userDraw.handle, userDraw.orgSize, vi, vi, vi, vi);
  ELSE
    vi := MagicVDI.SetCharpoints (userDraw.handle, userDraw.orgSize, vi, vi, vi, vi);
  END;   
  (* Clipping wieder ausschalten *)
  MagicVDI.SetClipping (userDraw.handle, draw, FALSE);
  RETURN {};
END drawText;

PROCEDURE fontSetGetValues (tree: ADDRESS; private: ADDRESS; set: BOOLEAN; exitBut: INTEGER);
  VAR d          : FONTSEL;
BEGIN
  d := private;
  IF set
  THEN
    (* Wird am Anfang aufgerufen *)
    (* ldHandler fr Fontliste aufbauen *)
    BuildLdHandler (d^.fl,  (* Zeiger auf die Liste *)
                    resetFonts, nextFont, prevFont, fontCount,
                    fontEnabled, fontSelected, fontToString,
                    fontIsSelected, fontDrawEntry,
                    0, mtAppl.CharHeight,
                    0, 0, 
                    d^.fontHandler);
                              
    
    (* Fontliste initialisieren *)
    IF ~PrepareListDial (fontBox, 
                         ldElemSet{ldSelect,ldArrows,ldDoubleExit, ldModal},
                         d^.fontHandler,
                         Namebox, Nameback,
                         Fontok, Fontcanc, 
                         ADR(d^.env),
                         Fontok,
                         d^.fontDial)
    THEN d^.terminate := TRUE; RETURN END;
    (* Sizeliste erstellen *)
    d^.sizeList.root := NIL;
    d^.sizeList.curr := NIL;
    userDraw.orgSize := buildSizeList (d^.currFont, d^.handle, d^.fontSize, d^.sizeList);
    (* Sizeliste vorbereiten *)
    (* ldHandler fr Fontliste aufbauen *)
    BuildLdHandler (ADR(d^.sizeList),  (* Zeiger auf die Liste *)
                    resetSize, nextSize, prevSize, sizeCount,
                    sizeEnabled, sizeSelected, sizeToString,
                    sizeIsSelected, sizeDrawEntry,
                    0, mtAppl.CharHeight,
                    0, 0, 
                    d^.sizeHandler);
    
    IF ~PrepareListDial (fontBox, 
                         ldElemSet{ldSelect,ldArrows,ldDoubleExit, ldAutolocate, ldModal},
                         d^.sizeHandler,
                         Sizebox, Sizeback,
                         Fontok, Fontcanc, 
                         ADR(d^.env),
                         Fontok,
                         d^.sizeDial)
    THEN vb := ReleaseListDial (d^.fontDial); d^.terminate := TRUE; RETURN END;
  ELSE
    IF d^.exitBut = Fontok
    THEN
      d^.fontId := userDraw.font;
      (* d^.fontSize := userDraw.size; *)
      SetFont (d^.handle, d^.fontId, d^.fontSize, FALSE, vb, vb, vi, vi); 
    ELSE
      d^.fontId := d^.oldId;
      d^.fontSize := d^.oldSize;
      SetFont (d^.handle, d^.oldId, d^.oldSize, FALSE, vb, vb, vi, vi); 
    END;
    (* Autolocator wieder ausklinken *)
    FreeAutoLocator();
    RemoveHandler (fontBox);
    (* Userdef wieder freigeben *)
    mtXobjects.FreeUserdef (fontBox, Example);
    (* ListDials wieder freigeben *)
    mtUtils.ExclState (tree, d^.exitBut, MagicAES.SELECTED);

    vb := ReleaseListDial (d^.sizeDial);
    vb := ReleaseListDial (d^.fontDial);
  END;
END fontSetGetValues;

PROCEDURE fontDraw (tree: ADDRESS; private: ADDRESS; clip: Rectangle);
  VAR d: FONTSEL;
BEGIN
  d := private;
  WITH d^ DO
    IF terminate THEN 
      CloseWinDial (tree);
    ELSE
      DrawListDial (fontDial, clip);
      DrawListDial (sizeDial, clip);
    END;
  END;
END fontDraw;

PROCEDURE fontButton (tree: ADDRESS; private: ADDRESS; button: INTEGER;
                      mx, my : INTEGER; kstate: BITSET; clicks: INTEGER): BOOLEAN;
  VAR d         : FONTSEL;
      d2        : DIAL;
      draw,
      exit      : BOOLEAN;
      i         : INTEGER;
      buts      : BITSET;
      upperFrame: Rectangle;

      select    : Fonts;
      sizePtr   : SizePtr;
      sizeStr   : ARRAY [0..79] OF CHAR;
      pos       : CARDINAL;
      lastElem  : ADDRESS;
BEGIN
  d := FONTSEL (private);
            
  d2 := FindDial (tree, button, FALSE);
  IF d2 # NilDIAL()
  THEN
    IF button = -1 (* Autolocator-Redraw *)
    THEN
      d2 := d^.sizeDial
    END;
    lastElem := NIL;
    exit := HandleListDial  (d2, button, mx, my, kstate, lastElem);
    IF (lastElem # NIL)
    THEN
      IF d2 = d^.fontDial
      THEN
        select := lastElem;
        IF select^.info.id # userDraw.font
        THEN
          vb := ReleaseListDial (d^.sizeDial);
          userDraw.font := select^.info.id;
          userDraw.size := buildSizeList (select^.info.id, d^.handle, -1, d^.sizeList);
          userDraw.fsm := select^.info.fsm;
          (* Sizeliste vorbereiten *)
          IF ~PrepareListDial (fontBox, 
                               ldElemSet{ldSelect,ldArrows,ldDoubleExit, ldAutolocate, ldModal},
                               d^.sizeHandler,
                               Sizebox, Sizeback,
                               Fontok, Fontcanc, 
                               ADR(d^.env),
                               Fontok,
                               d^.sizeDial)
          THEN END;
          (* SizeDial neu zeichnen *)
          WinDialDraw (fontBox, Sizeback, 1, upperFrame, FALSE);
          WinDialDraw (fontBox, Example, 1, upperFrame, FALSE);
          InitAutoLocator (d^.sizeDial);
          
          (* EditString noch neu setzen *)
          mtUtils.SetObjcString (fontBox, Sizeedit, IntToStr (userDraw.size, 3));
          (* und zeichnen *)
          WinDialDraw (fontBox, Sizeedit, 0, upperFrame, FALSE);
        END;
      ELSIF d2 = d^.sizeDial
      THEN
        sizePtr := lastElem;
        userDraw.size := sizePtr^.size;
        WinDialDraw (fontBox, Example, 1, upperFrame, FALSE);
        (* EditString noch neu setzen *)
        mtUtils.SetObjcString (fontBox, Sizeedit, IntToStr (userDraw.size, 3));
        (* und zeichnen *)
        WinDialDraw (fontBox, Sizeedit, 0, upperFrame, FALSE);
      END;
    END;
    IF exit THEN 
      button := INTEGER(BITSET(button) - {15});
      d^.exitBut := button;
      IF button = Fontok
      THEN
        (* Erstmal nachsehen, ob eine Gre selektiert ist, 
         * wenn nicht, dann den editString nehmen 
         *)    
        sizePtr := d^.sizeList.root;
        WHILE (sizePtr # NIL) & ~(sizePtr^.sel) DO 
          sizePtr := sizePtr^.next;
        END;
        IF sizePtr # NIL
        THEN
          d^.fontSize := sizePtr^.size;
        ELSE
          mtUtils.ObjcString (fontBox, Sizeedit, sizeStr);
          pos := 0;
          d^.fontSize := StrToInt (sizeStr, pos, vb);
        END;
        IF d^.fontSize <= 1
        THEN
          vi := mtAlerts.Alert (1,"[1][Eine Fontgre von|0 oder 1 Punkt ist|nicht sinnvoll!][[Stimmt]");
        ELSE
          RETURN TRUE;
        END;
      ELSE
        RETURN TRUE;
      END;
    END;
  ELSE
    button := INTEGER(BITSET(button) - {15});
    IF button = Showexam
    THEN
      mtUtils.ObjcString (fontBox, Sizeedit, sizeStr);
      pos := 0;
      userDraw.size := StrToInt (sizeStr, pos, vb);
      WinDialDraw (fontBox, Example, 1, upperFrame, FALSE);
      mtUtils.ExclState (fontBox, button, MagicAES.SELECTED);
      WinDialDraw (fontBox, button, 0, upperFrame, FALSE);
    END;
  END; 

  RETURN FALSE;
END fontButton;

PROCEDURE DoSelectFont (handle : sINTEGER; monoFonts : BOOLEAN; VAR fontId, fontSize : sINTEGER) : BOOLEAN;
 (* Fhrt kompletten Dialog durch. 
  * handle : VDI-Handle der Workstation;
  * monoFonts: Nur monospaced-Fonts sind selectable!
  *)
  VAR vb        : BOOLEAN; 
      fInfo     : tFontinfo;
      org       : Rectangle;
      sizeStr   : ARRAY [0..40] OF CHAR;
      but       : sINTEGER;
      buts,
      kstate    : BITSET;
      mx, my    : sINTEGER;
      select    : Fonts;
      sizePtr   : SizePtr;
      pos       : CARDINAL;
      osiz      : INTEGER;
      exit      : BOOLEAN;
      fs        : FontSelType;
BEGIN
  fs.terminate := FALSE;
  fs.oldId := fontId;
  fs.oldSize := fontSize;
  fs.lastElem := NIL;
  fs.handle := handle;
  fs.fl := GetFontList (handle);
  IF fs.fl = NIL THEN fontId := 1; RETURN FALSE END;
  WITH fs.fl^ DO 
    (* Vorarbeiten *)
    fs.env.handle := handle;
    fs.env.monos := monoFonts;
    fs.env.tree := fontBox;
    fs.env.fl   := fs.fl;
    
    (* aktuellen Font feststellen und schon mal selektieren *)
    dummy := fonts;
    WHILE (dummy # NIL) DO 
      dummy^.sel := FALSE;
      dummy := dummy^.next;
    END;
    dummy := fonts;
    WHILE (dummy # NIL) & (dummy^.info.id # fontId) DO
      dummy := dummy^.next;
    END;
    IF dummy # NIL THEN 
      dummy^.sel := TRUE; fs.currFont := dummy^.info.id; 
      osiz := dummy^.info.point;
    ELSE
      fs.currFont := 1;
      osiz := fs.oldSize;
    END;

    (* Noch etwas mit Objekten rumrechnen *)
    mtUtils.CalcArea (fontBox, Namebox, org);
    fontWidth := org.w;
    mtUtils.CalcArea (fontBox, Sizebox, org);
    sizeWidth := org.w;
    fontText^[0].obSpec.TedPtr^.teTxtlen := 45;

    
    (* Userobject noch vorbereiten *)
    mtDials.ObjcExtype (fontBox, Example, 99);  (* Userdef *)
    IF ~mtXobjects.InstUserdef (fontBox, Example, drawText, NIL)
    THEN HALT END;

    FontInfo (handle, fs.currFont, fInfo);
        
    WITH userDraw DO
      font    := fInfo.id;
      size    := fInfo.point;
      fsm     := fInfo.fsm;
      orgFont := font;
      orgSize := size;
      orgFsm  := FALSE;
    END;
    userDraw.handle := handle;
    
    (* Editable-Text noch setzen *)
    mtUtils.SetObjcString (fontBox, Sizeedit, IntToStr (userDraw.size, 3));
    
    (* WindowDialog ffnen *)
    IF ~OpenWinDial (fontBox, TRUE, fontSetGetValues, fontSetGetValues, fontButton,
                     fontDraw, "", ADR(fs))
    THEN
      vb := ReleaseListDial (fs.sizeDial);
      vb := ReleaseListDial (fs.fontDial);
      RemoveHandler (fontBox);
      RETURN FALSE;
    END;
    
    (* Autolocator installieren *)
    InitAutoLocator (fs.sizeDial);
    InstallHandler (fontBox, AutoLocate, CallByHandling, 0, 0, org, NIL);
    (* Und direkt einmal initialisieren *)
    kstate := AutoLocate (fontBox, 0, 0, 0, {}, {MagicAES.MUKEYBD}, Sizeedit);
    
    WinDialHandleEvents ();
    
    IF fs.exitBut = Fontok
    THEN
      fontSize := fs.fontSize;
      fontId   := fs.fontId;
    END;

    RETURN fs.exitBut = Fontok;
  END; (* WITH fl^ DO *)
END DoSelectFont;

PROCEDURE FontNumber (handle : sINTEGER) : sINTEGER;
(* Anzahl der zur Verfgung stehenden Fonts *)
  VAR fl : FONTList;
BEGIN
  fl := GetFontList (handle);
  IF fl # NIL
  THEN
    RETURN fl^.numFonts; 
  ELSE
    RETURN -1
  END;
END FontNumber;

PROCEDURE LoadFonts (handle : sINTEGER; VAR num : sINTEGER);
(* Fast wie mtFonts.LoadFonts, nur wird die Fontliste 
 * nicht zurckgegeben. Die wird intern verwaltet.
 *)
BEGIN
  num := FontNumber (handle);
END LoadFonts;

PROCEDURE FontSelect (handle : sINTEGER; font : sINTEGER);
(* Selektion eines Fonts 
 *)
 VAR fl : FONTList;
BEGIN
  fl := GetFontList (handle);
  IF fl # NIL
  THEN
    fl^.active:= MagicVDI.SetTextface (handle, font);
  END;
END FontSelect;

PROCEDURE FontInfo (handle,                     (* VDI-Handle *)
                    font : sINTEGER;            (* Font-ID    *)
                    VAR info : tFontinfo);
  VAR attr : ARRAY [0..15] OF sINTEGER;
      extend1, 
      extend2 : ARRAY [0..7] OF sINTEGER;
      fl   : FONTList;
      f    : Fonts;
BEGIN
  fl := GetFontList (handle);
  IF (fl # NIL) 
  THEN
    f := FindFont (fl, font);
    IF f = NIL THEN 
      f := FindFont (fl, fl^.active);
      IF f = NIL THEN RETURN END;
    END;
    info.id := f^.info.id;
    IF ~f^.infoSet
    THEN
      (* Font setzen *)
      vi := MagicVDI.SetTextface (handle, font);
      (* Nun Auskunft einholen *)
      MagicVDI.InqText (handle, attr); (* Aktuelle Parameter holen *)
      f^.info.chw:=    attr[6];
      f^.info.chh:=    attr[7];
      f^.info.boxw:=   attr[8];
      f^.info.boxh:=   attr[9];
      f^.info.point := MagicVDI.SetCharpoints (handle, 12, vi, vi, vi, vi);
      IF f^.info.id = 1 THEN (* Sonderbehandlung fr Systemfont *)
       Strings.Assign (SysFontName, f^.info.name, vb);  (* Name des Fonts *)
       IF mtAppl.CharHeight = 8 THEN  f^.info.point:= 9;  ELSE  f^.info.point:= 10;  END;
      END;
      IF f^.info.fsm THEN
       f^.info.min:= 1;  f^.info.max:= MAX (sINTEGER);
      ELSE
       f^.info.min:= MagicVDI.SetCharpoints (handle, 1, vi, vi, vi, vi);
       f^.info.max:= MagicVDI.SetCharpoints (handle, 9999, vi, vi, vi, vi);
      END;
      (* Annahme, aber leider gibts keine Abfragemglichkeit *)
      MagicVDI.InqTextextent (handle, 'MMmmWWww', extend1);
      MagicVDI.InqTextextent (handle, 'IIiiLLll', extend2);
      vi:= 0;  f^.info.mono:= TRUE;
      WHILE (vi < 8) AND f^.info.mono DO
       f^.info.mono:= extend1[vi] = extend2[vi];  
       INC (vi);
      END;
      f^.infoSet := TRUE;
      (* Jetzt wieder zurcksetzen *)
      vi := MagicVDI.SetTextface (handle, fl^.active);
      vi := FontSize (handle, fl^.actSize, vi, vi, vi, vi);
    END;
    info := f^.info;
  ELSE
    MagicVDI.InqText (handle, attr);
    info.id:= attr[0];
    IF info.id = 1 THEN  Strings.Assign (SysFontName, info.name, vb);
                   ELSE  Strings.Assign ('', info.name, vb);
    END;
    info.chw:=    attr[6];
    info.chh:=    attr[7];
    info.boxw:=   attr[8];
    info.boxh:=   attr[9];
    info.min:=    -1;
    info.max:=    -1;
    info.fsm:=    FALSE;
    IF info.id = 1 THEN
     IF mtAppl.CharHeight = 8 THEN  info.point:= 9;  ELSE  info.point:= 10;  END;
    END;
    info.mono:= TRUE;
  END;
END FontInfo;

PROCEDURE FontActive (handle : sINTEGER) : sINTEGER;
(* Liefert die ID des momentan aktiven Fonts.
 *)
 VAR fl : FONTList;
     f  : Fonts; 
     attr : ARRAY [0..9] OF sINTEGER;
BEGIN
 MagicVDI.InqText (handle, attr);
 fl := GetFontList (handle);
 IF fl # NIL
 THEN
   f:= FindFont (fl, attr[0]);
   IF f # NIL THEN 
   (* Bei der Gelgenheit gleich mal Daten auffrischen *)
     f^.info.chw:= attr[6];
     f^.info.chh:= attr[7];
     f^.info.boxw:= attr[8];
     f^.info.boxh:= attr[9];
   END;
   fl^.active := attr[0];
 END;
 RETURN attr[0];
END FontActive;
 
PROCEDURE FontSize (handle, size: sINTEGER;
                    VAR cw, ch, bw, bh: sINTEGER): sINTEGER;
(* Bestimmung der Gre des aktuellen Fonts in POINTS.
 * cw = Zeichenbreite
 * ch = Zeichenhhe
 * bw = Breite der Zeichenbox
 * bh = Hhe der Zeichenbox
 *)
  VAR fl : FONTList;
      f  : Fonts;
BEGIN
 fl := GetFontList (handle);
 IF fl # NIL
 THEN
   f:= FindFont (fl, fl^.active);
   IF f # NIL THEN
     fl^.actSize := size;
     IF ~f^.infoSet
     THEN 
       FontInfo (handle, fl^.active, f^.info);
     END;
     IF f^.info.fsm THEN
       f^.info.point:= MagicFSM.SetArbpoints (handle, size, cw, ch, bw, bh);
     ELSE
       f^.info.point:= MagicVDI.SetCharpoints (handle, size, cw, ch, bw, bh);
     END;
     (* Daten erneuern *)
     vi := FontActive (handle);
     RETURN f^.info.point;
   END;
 END;
 RETURN -1
END FontSize;

PROCEDURE SetFont (handle : sINTEGER; VAR font, fontSize : sINTEGER; 
                   getBoldWidth : BOOLEAN;
                   VAR mono, fsm : BOOLEAN; VAR boxw, boxh : sINTEGER);
VAR extend    : ARRAY [0..3] OF Point;
    cw, ch, bw, bh : INTEGER;
    string: ARRAY [0..255] OF CHAR;
    fInfo: tFontinfo;
    voidS: BITSET;
BEGIN
  (* IF font <= 0 THEN font := 1 END; *)
  FontSelect (handle, font);
  FontInfo (handle, font, fInfo);
  mono := fInfo.mono;
  fsm := fInfo.fsm;
  fontSize := FontSize (handle, fontSize, cw, ch, bw, bh);
  (* Textalignment setzen *)
  MagicVDI.SetTextalignment (handle, 0, 3, vi, vi);
  IF getBoldWidth
  THEN
    voidS := MagicVDI.SetTexteffect (handle, {MagicVDI.Fat});
  ELSE
    voidS := MagicVDI.SetTexteffect (handle, {});
  END;
  (* Durchschnittliche Zeichenbreite berechnen *)
  Strings.Assign ('abcdefghijklmnopqrstuvwxyz abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ abcdefghijklmnopqrstuvwxyz 1234567890', string, vb);
  IF fInfo.fsm
  THEN
    MagicFSM.InqFExtent (handle, string, extend);
  ELSE 
    MagicVDI.InqTextextent (handle, string, extend);
  END;
  IF getBoldWidth
  THEN
    voidS := MagicVDI.SetTexteffect (handle, {});
  END;
  bw := (extend[1].x - extend[0].x) DIV INTEGER(LENGTH(string)-1); (* Zeichenbreite berechnen *)
  boxw := mtUtils.Max (1, bw);
  boxh := mtUtils.Max (1, bh);
  IF ~fInfo.mono
  THEN
    boxw := (boxw * 6) DIV 5;
  END;
END SetFont;

(*
PROCEDURE FontDefsize (handle: sINTEGER);
(* Stellt die Max-Gre DIV 2 des aktuellen Fonts ein. Dies ist in der
 * Regel der Default-Size des Fonts.  
 * Beim Systemfont wird die Gre entsprechend der Auflsung gesetzt. 
 *)
BEGIN
END FontDefsize;

PROCEDURE FontRotate (handle, angle: sINTEGER): sINTEGER;
(* Winkel einstellen, in dem der Font ausgegeben wird. Bei Bitmap-
 * Fonts sind hier nur 0, 90, 180 und 270 Grad mglich.
 * angle ist in Zehntel Grad anzugeben (1800 fr 180 Grad)
 *)
BEGIN
  RETURN -1
END FontRotate;
*)

VAR rsc : mtRsc.RESOURCE;
    data: POINTER TO tRscData;

BEGIN
  (* Modulinterne Resource laden *) 
  (* Erstmal Resource kopieren in allozierten Speicher *)
  ALLOCATE (data, TSIZE (tRscData));
  IF data = NIL THEN HALT END; (* Kein Speicher frei *)
  (* Kopieren *)
  data^ := RscData;
  (* und jetzt relozieren *)
  IF mtRsc.RelocRsc (data, rsc) THEN 
 
    fontBox  := mtRsc.GaddrRsc (rsc, MagicAES.RTREE, Fontbox);
    fontText := mtRsc.GaddrRsc (rsc, MagicAES.RTREE, Nametext);
  ELSE
    HALT;       (* Relozieren der internen Ressource fehlgeschlagen, 
                 * sollte aber eigentlich nicht vorkommen
                 *)
  END;
  fontList := NIL;
  gdos:= mtAppl.VqGdos();
END FontSelect.
