DEFINITION MODULE FredProtokoll;

(*

XAcc und AV/VA-Protokoll in Modula-2

Autor : Johannes Gttker-Schnetmann

Last Change : 26.02.1991

*)

FROM SYSTEM IMPORT ADDRESS;
FROM CatTypes IMPORT Str255Ptr;

TYPE React        = (rNoproto, rNone, rChar, rText, rStart, rOpen, rSeMess);

(* Das mu der WatchDog bekommen, jetzt kommt etwas mehr
TYPE WatchDogMsg = RECORD
       PtrGruppe,
       PtrName,
       PtrBetreff,
       PtrText    : ADDRESS;
       TextLength : CARDINAL
     END;
*)

PROCEDURE IsProtokoll(mess : ADDRESS;
                     VAR kReturn : INTEGER; VAR mokState : BITSET;
                     VAR pName, pCmd : Str255Ptr):React;


PROCEDURE SendProgstart(error : BOOLEAN);
(* dem Acc mitteilen, ob der Programmstart geklappt hat, not yet implementet *)

PROCEDURE SendAcknowledge (apId : INTEGER; succ: BOOLEAN);
(* dem Acc mitteilen, das ACC_TEXT oder ACC_KEY geklappt haben *)

PROCEDURE SendOpenwind (id : INTEGER; path, name : ADDRESS);
(* einer anderen Applikation sagen, das sie ein Fenster ffnen soll
 * ist fr den Fall, das CAT oder Eddix schon geffnet sind, dann wird 
 * diese Message verschickt.
 *)

PROCEDURE SendHelp (VAR str : ARRAY OF CHAR);
(* Untersttzung fr PC-Help Protokoll. Sendet einmal Help aus. *)

PROCEDURE SendTerminate();
(* Bei anderen APPs abmelden *)

PROCEDURE ProtoInit ();
(* XACC-Initialisierung *)

PROCEDURE SeProtoInit ();
(* Initialisierung fr SeProto *)

PROCEDURE SendEsMessage (mess: INTEGER; adr: ADDRESS);
(* Schickt eine ES-Nachricht an den Teilnehmer *)

PROCEDURE SEProtoActiv (): BOOLEAN;
(* Gibt zurck, ob das SE-Protokoll aktiv ist
 *)

PROCEDURE SendPathUpdate (REF path: ARRAY OF CHAR);
(* Schickt ein AV_PATH_UPDATE an den AV_SERVER *)

END FredProtokoll.
