DEFINITION MODULE grin;

(*==============================================================*
 * Modul:               CAT-Anzeigemodul, neue Version          *
 * Autor:               Johannes Gttker-Schnetmann             *
 * erstellt am:         19.10.1991                              *
 * letzte nderung am:  19.04.1991                              *
 * Version:             1.0                                     *
 * Interne Version:     V#0003                                  *
 *==============================================================*

 *----------------------------------------------------------------------------
 * Datum    Vers. Autor  nderung (Arbeitsbericht)
 *----------------------------------------------------------------------------
 * 19.10.91 0001  JGS    Erstellen, erster Vorschlag
 * 02.04.92       JGS    Status fr persnliche Msgs
 * 10.04.92 0002  JGS    Aufrumen...
 * 19.04.92 0003  JGS    Suchen-Deklaration eingebaut
 *----------------------------------------------------------------------------
 *)
 
FROM SYSTEM IMPORT ADDRESS;
IMPORT data, ConvertDate;

TYPE grinNextMessProc = PROCEDURE ((*which :*)          CARDINAL, 
                                   (* nextOrPrev :*)    BOOLEAN,
                                   (* with shift *)     BOOLEAN,
                                   (* listHandle: *)    LONGCARD,
                                   (* windoptr*)        ADDRESS) : CARDINAL;
TYPE getNumberProc = PROCEDURE ((* dataHandle *) data.OneGroupHandle):CARDINAL;

CONST   grinWindowProto = FALSE;

PROCEDURE grinInit():BOOLEAN;
(* Einiges Initialisieren, gemeckert wird selbst *)

TYPE openMode = (mFromBeginning, mFirstNew, mUnread, mLastPos, mOther);

PROCEDURE grinOpenMessage(gruppe, which : CARDINAL; nextMess: grinNextMessProc; 
                          listHandle : LONGCARD; mode : openMode): INTEGER;
(* Ein Messagefenster der <gruppe> mit der Msg-nr. <which> ffnen
 * Liefert als Ergebnis das Handle des geffneten Fensters zurck.
 *)

(*$H+*)
PROCEDURE grinOpenWithProc(gruppe : CARDINAL; whichNumber : getNumberProc;
                          nextMess: grinNextMessProc; listHandle : LONGCARD;
                          mode    : openMode): INTEGER;
(* Ein Messagefenster der gruppe <gruppe> an der Stelle ffnen, die von 
 * der bergebenen Prozedur zurckgeliefert wird.
 * Liefert als Ergebnis das Handle des geffneten Fensters zurck 
 * (im Fehlerfall -1)
 *)
(*$H= *)

PROCEDURE grinClose(wdw : INTEGER);
(* Oberstes Fenster schlieen -> KANN NOCH RAUSFLIEGEN *)

PROCEDURE grinSavePos();
(* Sichert die Positionen aller grin-Fenster *)

PROCEDURE grinRestorePos();
(* Restauriert die Positionen, wenn mglich *)

PROCEDURE grinCloseAll();
(* Alle Fenster schlieen *)

PROCEDURE grinSwitchTo (win : INTEGER; which : CARDINAL; 
                        nextMess : grinNextMessProc; listHandle: LONGCARD;
                        doNotTop: BOOLEAN): BOOLEAN;
(* Schaltet in der aktuellen Gruppe zu der Nachricht which um.
 * doNotTop= TRUE: Das Fenster wird NICHT automatisch getoppt
 *)
PROCEDURE grinSwitchToMess (win : INTEGER; group : CARDINAL; 
                            whichNumber: getNumberProc):BOOLEAN;
(* Neue Msg in ein Fenster setzen 
 *)


PROCEDURE grinSetListWdw (win : INTEGER; nextMess : grinNextMessProc; 
                          listHandle: LONGCARD): BOOLEAN;     (* exported *)
(* Exportiert fr die Msgliste 
 * Setzt fr Fenster win das Stichwortfenster
 *)

PROCEDURE grinWindowTop(win : INTEGER):BOOLEAN;
(* Ist ein Fenster Anzeigefenster das oberste? *)

(* Auskunftprozeduren *)
PROCEDURE ActualSubject(win : INTEGER; VAR subject : ARRAY OF CHAR);
PROCEDURE ActualID(win : INTEGER; VAR ID : ARRAY OF CHAR);
PROCEDURE ActualMId(win : INTEGER; VAR ID : ARRAY OF CHAR);
PROCEDURE ActualFrom(win : INTEGER; VAR sender : ARRAY OF CHAR);
PROCEDURE ActualReceiver(win : INTEGER; VAR receiver : ARRAY OF CHAR);
PROCEDURE ActualGroup(win : INTEGER; VAR group : ARRAY OF CHAR);
PROCEDURE ActualGroupNr(win : INTEGER):CARDINAL;
PROCEDURE ActualDist (win : INTEGER; VAR dist: data.tDistribution);
PROCEDURE ActualName (win : INTEGER; VAR name : ARRAY OF CHAR);
PROCEDURE ActualReplyto (win : INTEGER; VAR sender : ARRAY OF CHAR);

(* Neue Auskunftsprozeduren *)
PROCEDURE ActualRefId (win: INTEGER; VAR id: ARRAY OF CHAR);
PROCEDURE ActualRId (win: INTEGER; VAR id: ARRAY OF CHAR);
PROCEDURE ActualSender(win : INTEGER; VAR sender : ARRAY OF CHAR);
PROCEDURE ActualWdwName (win : INTEGER; VAR name : ARRAY OF CHAR);
PROCEDURE ActualFollowup (win: INTEGER; VAR id: ARRAY OF CHAR);
PROCEDURE ActualDate (win: INTEGER; VAR date: ConvertDate.Date;
                      VAR time: ConvertDate.Time);
PROCEDURE ActualStatusDate (win: INTEGER; VAR date: ConvertDate.Date;
                      VAR time: ConvertDate.Time);
PROCEDURE ActualText (win: INTEGER; txtBuf: ADDRESS);
PROCEDURE ActualMime (win: INTEGER; VAR mime: ARRAY OF CHAR);
PROCEDURE ActualGate (win: INTEGER; VAR gate: ARRAY OF CHAR);
PROCEDURE ActualBox  (win: INTEGER; VAR box: ARRAY OF CHAR);
PROCEDURE ActualStatus (win: INTEGER; VAR status: ARRAY OF CHAR);
PROCEDURE ActualIsOwn  (win: INTEGER; VAR isOwn: BOOLEAN);
PROCEDURE ActualOrgText (win: INTEGER; txtBuf: ADDRESS);
PROCEDURE ActualInternalId (win: INTEGER; VAR Id: LONGCARD);

(* Grenabfragen *)
PROCEDURE ActSubjectSize (win: INTEGER) : LONGCARD;
PROCEDURE ActIdSize (win: INTEGER) : LONGCARD;
PROCEDURE ActMIdSize (win: INTEGER) : LONGCARD;
PROCEDURE ActFromSize (win: INTEGER) : LONGCARD;
PROCEDURE ActSenderSize (win: INTEGER) : LONGCARD;
PROCEDURE ActWdwNameSize (win: INTEGER) : LONGCARD;
PROCEDURE ActReceiverSize (win: INTEGER) : LONGCARD;
PROCEDURE ActGroupSize (win: INTEGER) : LONGCARD;
PROCEDURE ActNameSize (win: INTEGER) : LONGCARD;
PROCEDURE ActReplyToSize (win: INTEGER) : LONGCARD;
PROCEDURE ActRefIdSize (win: INTEGER) : LONGCARD;
PROCEDURE ActRIdSize (win: INTEGER) : LONGCARD;
PROCEDURE ActFollowupSize (win: INTEGER) : LONGCARD;
PROCEDURE ActDistSize (win: INTEGER) : LONGCARD;
PROCEDURE ActStatusSize (win: INTEGER) : LONGCARD;
PROCEDURE ActDateSize (win: INTEGER) : LONGCARD;
PROCEDURE ActStatusDateSize (win: INTEGER) : LONGCARD;
PROCEDURE ActTextSize (win: INTEGER) : LONGCARD;
PROCEDURE ActMimeSize (win: INTEGER) : LONGCARD;
PROCEDURE ActGateSize (win: INTEGER) : LONGCARD;
PROCEDURE ActBoxSize (win: INTEGER) : LONGCARD;
PROCEDURE ActIsOwnSize (win: INTEGER) : LONGCARD;
PROCEDURE ActOrgTextSize (win: INTEGER) : LONGCARD;
PROCEDURE ActInternalIdSize (win: INTEGER) : LONGCARD;

 
PROCEDURE InvertStatus(topWin : INTEGER; whichState : CARDINAL);
(* Invertiert den angegebenen Status, entsprechende Konstanten 
 * sind in data.d zu finden *)

PROCEDURE newStatus(topWin : INTEGER; clear, set : BITSET);

PROCEDURE grinNewState(TopWin : INTEGER; newState : CHAR);

PROCEDURE grinResetState(REF id : ARRAY OF CHAR);
(* Den Status einer persnlichen Msg zurcksetzen, wenn eine noch nicht abgeschickte *)
(* Antwort dazu gelscht wird. *)

PROCEDURE SearchMenu(topWin : INTEGER);
PROCEDURE DoSearch(topWin : INTEGER; forward : BOOLEAN);

PROCEDURE grinWithEffects (wdw: INTEGER): BOOLEAN;
(* Gibt zurck, ob momentan Effekte angezeigt werden oder nicht
 *)

PROCEDURE grinSetAlternativeFont (wdw, font, fontSize : INTEGER);
(* Setzt den alternativen (monospaced) Font fr das Anzeigefenster *)

PROCEDURE GetWdwFont (wdw: INTEGER; VAR font, fontSize : INTEGER);
(* Holt den eingestellten Font *)

PROCEDURE GetAlternativeFont (VAR font, fontSize : INTEGER);
(* Holt den alternativen Font *)

PROCEDURE grinSetFont (wdw, font, fontSize : INTEGER);
(* Setzt den Font fr das Anzeigefenster *)

PROCEDURE grinNextNotWorked (topWin : INTEGER; withShift : BOOLEAN);
(* Springt zur nchsten nicht bearbeiteten Msg bei den persnlichen Msgs *)

PROCEDURE grinNextMess (which : CARDINAL; nextOrPrev, withShift : BOOLEAN; 
                        listHdl : LONGCARD; winp: ADDRESS): CARDINAL;
(* Default-Prozedur fr nchste/letzte Message *)

PROCEDURE grinInfoline(msgWin : INTEGER; editWin : INTEGER; REF infoline : ARRAY OF CHAR);
(* Neue Infoline-Prozedur *)

(* --- Fr die Protokolluntersttzung --- *)
(*$? grinWindowProto:
PROCEDURE getAllWinds(adr : ADDRESS; maxAnz : INTEGER; VAR anz : INTEGER);
(* Schreibt alle offenen Anzeigefenster in den Speicher ab <adr>    *)
(* Maximal <max> viele. Rckgabewert der geschriebenen in <anz>.    *)
(* Sind es mehr als max, so ist dies die Anzahl der offenen Fenster *)

PROCEDURE getPos(adr : ADDRESS; pos : INTEGER; win : INTEGER):CARDINAL;
(* Positionen zu einem Fenster abrufen: *)
(* 0 Neue, 1 letzte Position, 2 ab Datum, 3 ab Nummer, 4 erste ungelesene *)
(* bei 2 und 3 wird in adr die Adresse eines Strings bergeben.           *)

PROCEDURE switchMess(win : INTEGER; mess, group : CARDINAL):BOOLEAN;
(* Neue Msg in ein Fenster setzen; Fr das Protokoll *)

PROCEDURE getInfo(win : INTEGER; adr : ADDRESS; amount : LONGCARD):BOOLEAN;
(* Die Infos zu diesem Fenster abholen. Geliefert wird:                             *)
(* ab <adr> steht ein data.MessageType. Direkt dahinter die Infostrings und         *)
(* dahinter noch der eigentliche MsgText. Gibt zurck, ob es geklappt hat oder ob   *)
(* das Fenster nicht mehr da ist bzw. die Information nicht gepat hat.             *)
*)

PROCEDURE getBasicInfo(win : INTEGER; VAR group, mess: CARDINAL; storageAmount : LONGCARD):BOOLEAN;
(* Feststellen, welche Msg welcher Gruppe im bergebenen Fenster dargestellt wird.  *)
(* In StorageAmount wird zurckgegeben, wieviel Speicher mal bentigt, um die       *)
(* Informationen, die zu dieser Msg gehren, zu speichern.                          *)

(* --- Ende der Protokollprozeduren --- *)

PROCEDURE changeTree(win : INTEGER; clear, set : BITSET; all : BOOLEAN);
(* Baum mit durchlaufen, dabei die Flags clear lschen und set setzen   *)
(* all - ganzer Baum, sonst nur runter                                  *)

PROCEDURE grinOnlyOneWind (VAR wdw: INTEGER): BOOLEAN;
(* Wenn nur ein grin-Window offen ist, bekommt man TRUE zurck und 
 * das wdw-Handle auch direkt
 *)
PROCEDURE GetGrinTopWdw (VAR wdw: INTEGER);
(* Liefert das oberste Anzeigefenster zurck *)

(* Etwas fr Dirk *)
PROCEDURE hiddenFeature(wdw: INTEGER; feature: INTEGER);

END grin.
