DEFINITION MODULE handlePool;

(*==============================================================*
 * Modul:               Verwaltet Pool von Datenbank-Handles    *
 * Autor:               Johannes Gttker-Schnetmann             *
 * erstellt am:         09.04.1992                              *
 * letzte nderung am:  12.04.1992                              *
 * Version:             1.0                                     *
 * Interne Version:     V#0002                                  *
 *==============================================================*

 *----------------------------------------------------------------------------
 * Datum    Vers. Autor  nderung (Arbeitsbericht)                            
 *----------------------------------------------------------------------------
 * 09.04.92 0001  JGS    Erste Version
 * 12.04.92 0002  JGS    Erweitertes Listenhandling, flexibler
 *----------------------------------------------------------------------------
 *)

IMPORT SYSTEM;
IMPORT Lists;
IMPORT data;

(*-- Allgemeine Listenverwaltung ---------------*)

PROCEDURE BlankToList(VAR new  : SYSTEM.ADDRESS;
                          size : LONGCARD;
                      VAR list : Lists.List):BOOLEAN;
(* Ein Listenelement an die angegebene Liste anhngen *)

PROCEDURE FreeOnePtr(ptr  : SYSTEM.ADDRESS;
                     VAR list : Lists.List);

PROCEDURE FindEntry(data     : SYSTEM.ADDRESS;
                    condProc : Lists.LCondProc;
                    list     : Lists.List;
                VAR ptr      : SYSTEM.ADDRESS):BOOLEAN;

(*-- Spezielle Datenbankhandleliste ------------*)

(* Die Handles fr den lesenden Zugriff auf die Datenbank: *)
(* Es drfen auch noch Flags gendert werden, nicht aber   *)
(* Nachrichten mittels dieser Handles angehngt werden     *)

TYPE oneHandlePtr = POINTER TO oneHandleElement;
TYPE oneHandleElement =
       RECORD
         group   : CARDINAL;            (* Gruppennummer *)
         open    : CARDINAL;            (* Anzahl der offenen Fenster dazu *)
         Zugriff : data.OneGroupHandle; (* Zugriffshandle *)
       END;

PROCEDURE SearchDataHandle(gruppe : CARDINAL;
                       VAR handle : oneHandlePtr):BOOLEAN;
(* Handle-Liste nach einem Eintrag der Gruppe <gruppe> durchsuchen *)

PROCEDURE GetOneDatahandle(gruppe : CARDINAL;
                       VAR handle : oneHandlePtr):BOOLEAN;
(* Erst die bestehende Liste nach schon offenen Handles durchsuchen,
 * falls dort nicht gefunden, versuchen ein neues zu ffnen
 *)

PROCEDURE FreeOneDataHandle(handle : oneHandlePtr);
(* Nachsehen, ob er noch bentigt wird, sonst aus der Liste entfernen *)

PROCEDURE InitPool():BOOLEAN;
(* Wird in grin.grinInit aufgerufen, Fehler auch dort angemeckert und braucht *)
(* nicht weiter beachtet zu werden *)

PROCEDURE isOneGroupOpen():BOOLEAN;
(* Fragt nach, ob _irgendeine_ Gruppe noch geffnet ist. Insbesondere fr   *)
(* parser.i -> Gruppe offen: Einfgen abbrechen und CAT beenden             *)

END handlePool.
