IMPLEMENTATION MODULE Hashing2;

FROM SYSTEM IMPORT ADDRESS;
FROM Characters IMPORT CR, LF;
FROM Storage IMPORT ALLOCATE, DEALLOCATE;
(*IMPORT Storage;*)
IMPORT MagicDOS;
IMPORT MagicConvert;
FROM Void IMPORT v;

CONST (*maxTab = 5003;*)
      empty = 0FFFFH; (* leerer Listenplatz *)

TYPE maxCardArray = ARRAY[0..MAX(CARDINAL)] OF CARDINAL;
TYPE maxCardPtr   = POINTER TO maxCardArray;
TYPE hashHandle = POINTER TO hInfo;
TYPE hInfo      = RECORD
                    list   : maxCardPtr;
                    entry  : CARDINAL;
                    aAnz,
                    actual : CARDINAL;
                    hashMax: CARDINAL; (* entspricht maxTab! *)
                    hash   : maxCardArray;
                  END;

CONST maxPrim = 30;
TYPE primArrayType = ARRAY[0..maxPrim] OF CARDINAL;
CONST PRIM = primArrayType{2503, 3001, 3449, 4001, 4507, 5003,
                           5501, 6007, 6521, 7001, 7507, 8009,
                           9001,   10007,  11003,
                           12007,  13001,  14009,
                           15013,  16001,  18013,
                           20011,  25013,  30011,
                           35023,  40009,  45007,
                           50021,  55001,  60013,
                           65521};

PROCEDURE H(crc, maxTab : CARDINAL):CARDINAL;
BEGIN
  RETURN crc MOD maxTab
END H;

PROCEDURE whatsGood():CARDINAL;
(* Gibt die Primzahl zurck, die in diesem Fall genommen werden soll *)
VAR isAvail : LONGCARD;
    prim    : CARDINAL;
    z       : CARDINAL;
BEGIN
  isAvail  := MagicDOS.Malloc(LONG(-1)); (* Wieviel ist da?              *)
  prim := 0;
  z := 0;
  IF isAvail > MAX(CARDINAL) THEN isAvail := LONG(MAX(CARDINAL)) END;
  WHILE (z <= maxPrim) & (SHORT(isAvail) >= PRIM[z])  DO
    INC(z);
  END;
  IF z = 0 THEN
    RETURN 0
  ELSE
    RETURN PRIM[z-1]
  END;
END whatsGood;

PROCEDURE ToHash(crcAdr : ADDRESS; anz, add : CARDINAL):hashHandle;
(* gibt hashHandle zurck, die hashcrcs werden in einem Array[0..xx] *)
(* bergeben, dessen Anzahl <anz> ist. <add> gibt die Anzahl der     *)
(* noch zu erwartenden Nachrichten an                                *)

TYPE crcPtr = POINTER TO ARRAY[0..MAX(CARDINAL)] OF CARDINAL;
VAR z    : CARDINAL;
    crc  : crcPtr;

    zz   : CARDINAL;
    ptr  : hashHandle;
    prim : CARDINAL;

BEGIN
(*  NEW(ptr); *)
  prim := whatsGood();
  IF prim = 0 THEN RETURN NIL END;
  ptr := MagicDOS.Malloc(12+2*LONG(prim+1));
  IF ptr = NIL THEN RETURN NIL END;
  WITH ptr^ DO
    hashMax := prim;
    list := MagicDOS.Malloc(LONG(anz+add)*2);
    IF (list # NIL) & (LONGCARD(list) # LONGCARD(0)) THEN
      FOR z := 0 TO hashMax DO (* Hashtabelle lschen *)
        hash[z] := empty
      END;
      aAnz  := anz;
      entry := 0;
      crc   := crcAdr;
      FOR z := 1 TO anz DO
        AddCrc(ptr, crc^[z-1]);

      END;
      RETURN ptr
    ELSE
      v.bool := MagicDOS.Mfree(ptr);
(*      DISPOSE(ptr);*)
    END;
  END; (* WITH ptr^ DO *)
  RETURN NIL
END ToHash;

PROCEDURE ReleaseHash(ptr : hashHandle);
BEGIN
(*
    Storage.DEALLOCATE(hash, LONG(hashMax+1)*2);
    Storage.DEALLOCATE(list, LONG(last+1+additionalSpace)*2);
*)
  IF ptr # NIL THEN
    v.bool := MagicDOS.Mfree(ptr^.list);
    v.bool := MagicDOS.Mfree(ptr);
  END;
(*    DISPOSE(ptr);*)
END ReleaseHash;

PROCEDURE FreeEntry(ptr : hashHandle; start : CARDINAL):CARDINAL;
VAR next : CARDINAL;
BEGIN
  WHILE ptr^.list^[start] # empty DO start := ptr^.list^[start] END;
  RETURN start;
END FreeEntry;

PROCEDURE AddCrc(ptr : hashHandle; crc : CARDINAL);
VAR nr : CARDINAL;
BEGIN
  IF ptr = NIL THEN RETURN END; (* Neu *)
  WITH ptr^ DO
    nr := H(crc, hashMax);
    list^[entry] := empty;
    IF hash[nr] = empty THEN
      hash[nr] := entry;
      (* Der Eintrag in der Liste ist <empty> *)
    ELSE
      (* Der Eintrag in der Hashtabelle ist dann schon fertig *)
      list^[FreeEntry(ptr, hash[nr])] := entry
    END;
    INC(entry);
  END;
END AddCrc;

VAR actual : CARDINAL;

PROCEDURE GetFirst(ptr : hashHandle; crc : CARDINAL):CARDINAL; (* 0FFFFH nichts gefunden *)
BEGIN
  WITH ptr^ DO
    actual := hash[H(crc, hashMax)];
    RETURN actual
  END;
END GetFirst;

PROCEDURE GetNext(ptr : hashHandle):CARDINAL; (* 0FFFFH nicht gefunden *)
BEGIN
  WITH ptr^ DO
    IF actual # empty THEN
      actual := list^[actual]
    END;
    RETURN actual
  END;
END GetNext;

PROCEDURE getEmptyHash():hashHandle;
BEGIN
  RETURN NIL
END getEmptyHash;

PROCEDURE emptyHash(h : hashHandle):BOOLEAN;
BEGIN
  RETURN h = NIL
END emptyHash;

END Hashing2.
