MODULE IconView;

(*$R- Kein Rangecheck *)
(*$S- Kein Stackcheck *)
(*$Z+ Rckgabe ber D0 *)


(* Dies ist ein einfacher Iconviewer, der die einzelnen Dialoge einer Resource
 * in einem Fenster anzeigt, und zwar inklusive Farbicons 
 * Der Einfachheit halber benutze ich die cat-module hierzu.
 *)

FROM SYSTEM IMPORT ADDRESS, ADR;

IMPORT Keyboard, MOSGlobals, Strings, FileNames, GrafBase;
FROM Storage IMPORT ALLOCATE, DEALLOCATE;

FROM Keyboard IMPORT SpecialCode;

IMPORT mtAppl, mtRsc, mtUtils, MagicAES, MagicVDI, mtDials, mtCommand,
       mtDir, MagicStrings, MagicCookie;

IMPORT WdwManager, CatTypes, RectFuncs;

FROM Void IMPORT v;


CONST
    (* Cookies definieren *)
    FselCookie  = 'FSEL';
    MagiXCookie = 'MagX';
    MultiGEMCookie = 'MGEM';
    MagicMacCookie = 'MgMc';

TYPE    VIEW    = RECORD
                    fileName: CatTypes.pathStrType;
                    infoLine: CatTypes.String255;
                    rsc     : mtRsc.RESOURCE;
                    treeIdx : INTEGER;
                    treeCnt : INTEGER;
                    wdw     : INTEGER;
                    vdi     : INTEGER;
                  END;
        viewPtr = POINTER TO VIEW;


VAR loadPath: CatTypes.pathStrType;
    loadName: CatTypes.nameStrType;
    deskSize: GrafBase.Rectangle;

(* Funktionen aus CatGlobal *)    

PROCEDURE FselGet(VAR InPath, InSel: ARRAY OF CHAR; REF ext, msg : ARRAY OF CHAR;
                  pathOnly : BOOLEAN):BOOLEAN;
(* Ausgelagert aus CAT.M, da ich die auch im Editor verwenden kann.
 *)
TYPE    fselPtr = POINTER TO RECORD
                    id      : LONGCARD;
                    version : CARDINAL;
                  END;

VAR scrapP : CatTypes.pathStrType;
    scrapN : CatTypes.nameStrType;
    l      : CARDINAL;
    fsel   : fselPtr;
    noMCtrl: BOOLEAN;
BEGIN
  mtDir.DelTail (InPath);
  MagicStrings.Assign(InPath, scrapP);
  (*
  l := LENGTH (InPath);
  IF l > 0
  THEN
    IF InPath[l-1] #'\'
    THEN InPath[l-1] := '\';InPath[l] := 0C;
    END;
  END;
  *)
  noMCtrl := MagicCookie.FindCookie (FselCookie, fsel);
  IF noMCtrl
  THEN
    noMCtrl := fsel^.version >= 0200H;
  END;
  MagicStrings.Assign(InSel, scrapN);
  MagicStrings.Append(ext, InPath);
  IF ~noMCtrl
  THEN
    MagicAES.WindUpdate(MagicAES.BEGMCTRL);
  END;
  IF mtDir.GetDir(InPath, InSel, msg) THEN
    IF ~noMCtrl
    THEN
      MagicAES.WindUpdate(MagicAES.ENDMCTRL);
    END;
    mtDir.DelTail(InPath);
    IF pathOnly
    THEN 
      RETURN TRUE
    ELSE
      RETURN LENGTH (InSel) # 0;
    END;
  ELSE
    IF ~noMCtrl
    THEN
      MagicAES.WindUpdate(MagicAES.ENDMCTRL);
    END;
    MagicStrings.Assign(scrapP, InPath);
    MagicStrings.Assign(scrapN, InSel);
    RETURN FALSE
  END
END FselGet;
 
PROCEDURE WithShift (kstate : BITSET) : BOOLEAN;
(* Gibt zurck, ob eine der Shifttasten gedrckt wurde *)
BEGIN
  RETURN (MagicAES.KLSHIFT IN kstate) OR (MagicAES.KRSHIFT IN kstate)
END WithShift;

PROCEDURE WithCtrl (kstate : BITSET) : BOOLEAN;
(* Gibt zurck, ob Ctrl gedrckt wurde *)
BEGIN
  RETURN (MagicAES.KCTRL IN kstate)
END WithCtrl;

PROCEDURE WithAlt (kstate : BITSET) : BOOLEAN;
(* Gibt zurck, ob Alternate gedrckt wurde *)
BEGIN
  RETURN (MagicAES.KALT IN kstate)
END WithAlt;

(* Prototypen *)

PROCEDURE OpenOneView (REF fname: ARRAY OF CHAR); FORWARD;

(* Fensterhandling *)

PROCEDURE clickInView (wdw, vdi : INTEGER; env : ADDRESS; mx, my : INTEGER; kstate, buts : BITSET; clicks :INTEGER): BOOLEAN;
BEGIN
  (* Wir machen nix mit Buttons *)
  RETURN FALSE;
END clickInView;

PROCEDURE ChangeTree (view: viewPtr; next: BOOLEAN);
  VAR work : GrafBase.Rectangle;
      tree : mtUtils.tObjcTree;
BEGIN
  WITH view^ DO
    tree := mtRsc.GaddrRsc (rsc, MagicAES.RTREE, treeIdx);
    mtDials.DisposeDial (tree);
    IF next
    THEN
      INC (treeIdx);
      IF treeIdx >= treeCnt THEN treeIdx := 0; END; 
    ELSE
      DEC (treeIdx); 
      IF treeIdx < 0 THEN 
        treeIdx := treeCnt - 1;
      END;
    END;
    tree := mtRsc.GaddrRsc (rsc, MagicAES.RTREE, treeIdx);
    v.bool := mtDials.NewDial (tree);
    WdwManager.GetWdwWork (wdw, work);
    WdwManager.SetScrollParms (wdw, work.w - 16, work.h - 16, 16, 16);
    mtUtils.CalcArea (tree, 0, work);
    WdwManager.SetNewDocument (wdw, GrafBase.LongRect{0, 0, LONG (work.w), LONG (work.h)}, TRUE);
  END;
END ChangeTree;

PROCEDURE keyView (wdw, vdi : INTEGER; env: ADDRESS; taste: INTEGER; char, scan : CHAR; kstate : BITSET): BOOLEAN;
  VAR gemCh : CARDINAL;
      key   : MOSGlobals.Key;
      ctrl  : BOOLEAN;
      shift : BOOLEAN;
      done  : BOOLEAN;
BEGIN
  gemCh := ORD(scan) * 256 + ORD(char);
  Keyboard.GemCharToKey (gemCh,  SHORT (INTEGER(kstate)), key);
  ctrl := WithCtrl (kstate);
  shift := WithShift (kstate);
  done := TRUE;
  IF Keyboard.IsSpecial (key)
  THEN
    CASE Keyboard.SpecialKey (key) OF
      left          : WdwManager.ScrollLeft (wdw, 1);  |
      soln          : WdwManager.PageLeft (wdw);    |
      right         : WdwManager.ScrollRight (wdw, 1); | 
      eoln          : WdwManager.PageRight (wdw);   |
      up            : WdwManager.ScrollUp (wdw, 1); |
      down          : WdwManager.ScrollDown (wdw, 1); |
      pgUp          : WdwManager.PageUp (wdw);      |
      pgDown        : WdwManager.PageDown (wdw);    |
      ctrlW         : WdwManager.TopNextWindow(); |
      ctrlO         : OpenOneView(""); |
      ctrlU         : v.bool := WdwManager.CloseWindow (wdw, FALSE); |
      wdLeft        : ChangeTree (env, FALSE); |
      wdRight       : ChangeTree (env, TRUE); |
    ELSE
      done := FALSE
    END;
  ELSE
    done := FALSE;
  END;
  RETURN done;
END keyView;

PROCEDURE closeView (wdw, vdi: INTEGER; env : ADDRESS; force : BOOLEAN): BOOLEAN;
  VAR view: viewPtr;
      tree: mtUtils.tObjcTree;
BEGIN
  view := env;
  tree := mtRsc.GaddrRsc (view^.rsc, MagicAES.RTREE, view^.treeIdx);
  mtDials.DisposeDial (tree);
  mtRsc.FreeRsc (view^.rsc);
  DISPOSE (view);
  RETURN TRUE
END closeView;

PROCEDURE hideView (wdw, vdi: INTEGER; env : ADDRESS; hide : BOOLEAN);
BEGIN
END hideView;

PROCEDURE timerView (wdw, vdi: INTEGER; env : ADDRESS): BOOLEAN;
BEGIN
  RETURN FALSE;
END timerView;

PROCEDURE topView (wdw, vdi: INTEGER; env: ADDRESS): BOOLEAN;
BEGIN
  RETURN TRUE
END topView;

PROCEDURE untopView (wdw, vdi: INTEGER; env: ADDRESS);
END untopView;

PROCEDURE setWork (wdw, vdi: INTEGER; env: ADDRESS; doc: GrafBase.LongRect; slided: BOOLEAN);
  VAR work: GrafBase.Rectangle;
BEGIN
  WdwManager.GetWdwWork (wdw, work);
  WdwManager.SetScrollParms (wdw, work.w - 16, work.h - 16, 16, 16);
END setWork;

PROCEDURE getRect (wdw, vdi: INTEGER; env: ADDRESS; VAR r : GrafBase.Rectangle);
END getRect;

PROCEDURE redrawView (wdw, vdi : INTEGER; env : ADDRESS; clip : GrafBase.Rectangle);
  VAR view: viewPtr;
      tree: mtUtils.tObjcTree;
      doc : GrafBase.LongRect;
      work: GrafBase.Rectangle;
BEGIN
  view := env;
  WITH view^ DO
    v.int := MagicVDI.SetWritemode (vdi, MagicVDI.REPLACE);
    v.int := MagicVDI.SetFillstyle (vdi, MagicVDI.Full);
    v.int := MagicVDI.SetFillinterior (vdi, MagicVDI.Full);
    v.int := MagicVDI.SetFillcolor (vdi, MagicAES.WHITE);
    work := clip;
    work.w := clip.x + clip.w - 1;
    work.h := clip.y + clip.h - 1;
    MagicVDI.FillRectangle (vdi, work);
    tree := mtRsc.GaddrRsc (rsc, MagicAES.RTREE, treeIdx);
    (* Jetzt positionieren *)
    WdwManager.GetWdwDocument (wdw, doc);
    WdwManager.GetWdwWork (wdw, work);
    tree^[0].obX := work.x - SHORT(doc.x);
    tree^[0].obY := work.y - SHORT(doc.y);
    (* Und zeichnen *)
    mtDials.DialDraw (tree, 0, 8, clip, TRUE);
  END;
END redrawView;

PROCEDURE updateView (wdw, vdi: INTEGER; env: ADDRESS; doIt: BOOLEAN);
BEGIN
  IF doIt 
  THEN 
    MagicAES.WindUpdate (MagicAES.BEGUPDATE);
    mtAppl.MouseOff();
  ELSE
    mtAppl.MouseOn();
    MagicAES.WindUpdate (MagicAES.ENDUPDATE);
  END;
END updateView;


PROCEDURE OpenOneRsc(VAR fullName : ARRAY OF CHAR; VAR rsc : mtRsc.RESOURCE): BOOLEAN;
BEGIN
  
  IF (LENGTH (fullName) > 0) OR
     FselGet (loadPath, loadName, "*.RSC", "Resource laden", FALSE)
  THEN
    IF LENGTH (fullName) = 0
    THEN
      FileNames.ValidatePath (loadPath);
      FileNames.ConcatPath (loadPath, loadName, fullName);
    END;
    IF mtRsc.LoadRsc (fullName, rsc)
    THEN
      RETURN TRUE;
    END;
  END;
  RETURN FALSE;
END OpenOneRsc;

PROCEDURE CreateView (VAR view: viewPtr): BOOLEAN;
BEGIN
  NEW (view);
  IF view = NIL THEN RETURN FALSE END;
  WITH view^ DO
    Strings.Assign ("", fileName, v.bool);
    Strings.Assign ("", infoLine, v.bool);
    treeIdx := 0;
    treeCnt := 0;
    wdw := -1;
    vdi := -1;
  END;
  RETURN TRUE;
END CreateView;

PROCEDURE OpenOneView (REF fname: ARRAY OF CHAR);
  VAR comps: BITSET;
      work : GrafBase.Rectangle;
      work2: GrafBase.Rectangle;
      view : viewPtr;
      tree : mtUtils.tObjcTree;
      head : mtRsc.RSXHDR;
BEGIN
  IF CreateView(view) 
  THEN
    WITH view^ DO
      IF LENGTH(fname) > 0
      THEN
        Strings.Assign (fname, fileName, v.bool);
      END;
      IF OpenOneRsc (fileName, rsc)
      THEN
        (* Anzahl der Bume rausfinden *)
        mtRsc.GetRscHeader (rsc, head);
        treeCnt := VAL (INTEGER, head.rshNtree);
        (* Ausmae des dargestellten Baumes rausfinden *)
        tree := mtRsc.GaddrRsc (rsc, MagicAES.RTREE, treeIdx);
        v.bool := mtDials.NewDial (tree);
        mtUtils.CalcArea (tree, 0, work);
        (* noch clippen *)
        work := RectFuncs.ClipRect (work, deskSize);
        comps := {MagicAES.NAME..MagicAES.HSLIDE};
        MagicAES.WindCalc (MagicAES.WCBORDER, comps, work, work2); 
        INC (work2.x, 40);
        INC (work2.y, 40);
        (* Fenster ffnen *)
        IF WdwManager.OpenWindow (clickInView, keyView, timerView, 
                      deskSize,  work2, comps,
                      FALSE, infoLine, fileName, WdwManager.snapProc (NIL),
                      closeView, redrawView, topView,
                      untopView, updateView, setWork, getRect,
                      hideView, 0, view, FALSE, TRUE, TRUE, 
                      TRUE, wdw, vdi)
        THEN
          (* Scrollparameter setzen *)
          WdwManager.SetDocumentParms (wdw, 1, 1);
          WdwManager.GetWdwWork (wdw, work);
          WdwManager.SetScrollParms (wdw, work.w - 16, work.h - 16, 16, 16);
          mtUtils.CalcArea (tree, 0, work);
          WdwManager.SetWdwDocument (wdw, GrafBase.LongRect{0, 0, LONG (work.w), LONG (work.h)});
        END;
      END;
    END;
  END;
END OpenOneView;

CONST 
    whatString = '@(#)IconView 1.0, Copyright (c) 1996 Dirk Steins'+0C;

  VAR kstate : BITSET;
      taste  : INTEGER;
      scanInt: INTEGER;
      scan,
      ch     : CHAR;
      evnt   : BITSET;
      msgBuf : ARRAY [0..7] OF INTEGER;
      topWdw : INTEGER;
      dr     : GrafBase.Rectangle;
      name   : CatTypes.pathStrType;

BEGIN
  WdwManager.GetWdwWork (0, deskSize);
  WdwManager.EnableIconify (TRUE);
  IF mtCommand.ParamCount() > 0 THEN
    FOR scanInt := 1 TO mtCommand.ParamCount() DO
      mtCommand.ParamString (scanInt, name);
      OpenOneView (name);
    END;
  ELSE
    OpenOneView("");
  END;
  REPEAT
     evnt := MagicAES.EvntMulti ({MagicAES.MUKEYBD, MagicAES.MUMESAG},
                              0, {}, {}, 0, dr, 0, dr, msgBuf, 0,0,
                              v.int, v.int, v.bset, taste, 
                              kstate, scanInt, ch, v.int);
    scan := CHAR(SHORT(scanInt));
    IF WdwManager.HandleEvent (evnt, msgBuf, {}, kstate, ch, scan, taste, 0, 0, 0)
    THEN 
    END;
    WdwManager.GetOwnTopWindow (topWdw);
  UNTIL topWdw = -1;
END IconView.
