IMPLEMENTATION MODULE InfoDlg;

FROM SYSTEM  IMPORT ADDRESS, ADR, TSIZE, CALLSYS, CADR;

(* MM2-Module *)
FROM Storage IMPORT ALLOCATE, DEALLOCATE;
IMPORT Lists, Block, GrafBase;

(* Magic-Module *)
IMPORT MagicConvert, MagicStrings, MagicAES, MagicVDI, mtUtils, mtPopups, 
       mtAppl, mtTextfiles;

(* CAT-Module *)
FROM MTPaths IMPORT DataPath;
FROM Void    IMPORT v;
IMPORT MTE, ListHelp, MausTauschrsc, VDIUtil,
       CatGlobal, ConvertDate, 
       CatHelp, WinDials, CatTypes;

IMPORT Infofiles;
FROM Infofiles IMPORT infEntryPtr, infEntry, infList, BuildName;

FROM ListDl     IMPORT specialButHdler, ldElems;
IMPORT ListDl;

(* Fr Listdialoge, Environmentinfo *)

TYPE    infoBlock = RECORD
                      open: BOOLEAN;
                      exitBut: INTEGER;
                    END;
        infoPtr = POINTER TO infoBlock;

VAR TEdPtr : POINTER TO MagicAES.TEDINFO;

VAR gruppen : ADDRESS;      (* Adresse des Dialoges *)
    lastFile : ARRAY [0..255] OF CHAR;
    maxListWidth : INTEGER;
    maxShortname : INTEGER;
    listChanged  : BOOLEAN;

PROCEDURE ExtendStr (VAR str : ARRAY OF CHAR; len : CARDINAL);
  VAR (*$Reg*) max, 
      (*$Reg*) s, 
      (*$Reg*) i : CARDINAL;
BEGIN
  IF len > HIGH (str) THEN max := HIGH(str) ELSE max := len END;
  s := LENGTH (str);
  FOR i := s TO max DO str[i] := ' '; END;
  IF max < HIGH (str) THEN str[max+1] := 0C; END;
END ExtendStr;

PROCEDURE infToStr (entry, env : ADDRESS; VAR str : ARRAY OF CHAR);
  VAR inf : infEntryPtr;
      e : POINTER TO BOOLEAN;
      numstr : ARRAY [0..5] OF CHAR;
BEGIN
  inf := infEntryPtr (entry);
  IF entry = NIL THEN 
    MagicStrings.Assign ("", str);
    RETURN
  END;
  MagicStrings.Assign (inf^.mausShort, str);
  MagicStrings.Append (' ', str);
  MagicStrings.Append (inf^.mausName, str);
END infToStr;

PROCEDURE buildInfEntry (entry : ADDRESS; VAR str : ARRAY OF CHAR);
  VAR inf : infEntryPtr;
      numstr : ARRAY [0..5] OF CHAR;
      s2    : ARRAY [0..15] OF CHAR;
      d     : CARDINAL;
      date  : ConvertDate.Date;
BEGIN
  inf := infEntryPtr (entry);
  IF entry = NIL THEN 
    MagicStrings.Assign ("", str);
    RETURN
  END;
  IF inf^.ordered THEN 
    MagicStrings.Assign (' '+10C+' ',str); 
  ELSE
    MagicStrings.Assign ('   ',str); 
  END;
  MagicStrings.Append (inf^.mausShort, str);
  ExtendStr (str, 2+maxShortname);
  MagicStrings.Append (' ', str);
  IF inf^.isMaus
  THEN
    MagicConvert.IntToStr (inf^.orderIntervall, 0, numstr);
    MagicStrings.Append (numstr, str);
  END;
  ExtendStr (str, 5+maxShortname);
  IF inf^.isMaus & inf^.avail
  THEN
    d := ConvertDate.NumInDate (inf^.lastOrdered);
    date := ConvertDate.UnpackDate (d);
    ConvertDate.DateToText (date, " DD.MM.YY ", s2);
    MagicStrings.Append (s2, str);
  END;
  ExtendStr (str, 15+maxShortname);
  MagicStrings.Append (inf^.mausName, str);
END buildInfEntry;

PROCEDURE selInfEntry (entry, env: ADDRESS; line : INTEGER): BOOLEAN;
  VAR inf : infEntryPtr;
      infStr: ARRAY [0..255] OF CHAR;
BEGIN
  inf := infEntryPtr (entry);
  IF inf = NIL THEN RETURN FALSE END;
  inf^.selected := ~inf^.selected;
  IF inf^.selected & (line >= 0) THEN
    infToStr (entry, CADR(TRUE), infStr);
    mtUtils.SetObjcString (gruppen, MausTauschrsc.newgroup, infStr);
    WinDials.WinDialDraw (gruppen, MausTauschrsc.newgroup, 0, v.r, FALSE);
  END;
  RETURN FALSE
END selInfEntry;

PROCEDURE isSelected (entry, env : ADDRESS) : BOOLEAN;
  VAR ent : infEntryPtr;
      e : POINTER TO BOOLEAN;
BEGIN
  ent := infEntryPtr (entry);
  e := env;
  IF (e# NIL) & (ent # NIL) & e^
  THEN
    (* Ist fr's ffnen *)
    IF ent^.selected
    THEN
      (* Prfen *)
      ent^.selected := ~ent^.isMaus OR ent^.avail
    END;
  END;
  RETURN (ent # NIL) & ent^.selected;
END isSelected;

PROCEDURE isEnabled (entry, env : ADDRESS) : BOOLEAN;
  VAR e : POINTER TO BOOLEAN;
      ent : infEntryPtr;
BEGIN
  ent := infEntryPtr (entry);
  e := env;
  IF (e# NIL) & (ent # NIL) & e^
  THEN
    RETURN ~ent^.isMaus OR ent^.avail
  END;
  RETURN TRUE
END isEnabled;

  PROCEDURE enableFsel (infBox: ADDRESS; ordered, enable: BOOLEAN; draw: BOOLEAN);
  BEGIN
    mtUtils.SetState (infBox, MausTauschrsc.icfile,  MagicAES.DISABLED, enable);
    mtUtils.SetState (infBox, MausTauschrsc.icorder,  MagicAES.DISABLED, ~enable);
    mtUtils.SetState (infBox, MausTauschrsc.icorder, MagicAES.SELECTED, ordered);
    mtUtils.SetFlag (infBox, MausTauschrsc.icfile,  MagicAES.TOUCHEXIT, ~enable);
    mtUtils.SetFlag (infBox, MausTauschrsc.icorder,  MagicAES.TOUCHEXIT, enable);
    IF draw
    THEN
      WinDials.WinDialDraw (infBox, MausTauschrsc.icfile, 0, v.r, FALSE);
      WinDials.WinDialDraw (infBox, MausTauschrsc.icorder, 0, v.r, FALSE);
    END;
  END enableFsel;
  
  PROCEDURE enablePopup (infBox: ADDRESS; enable: BOOLEAN; draw : BOOLEAN; select: INTEGER);
  BEGIN
    mtUtils.SetState (infBox, MausTauschrsc.icdays,  MagicAES.DISABLED, ~enable);
    mtUtils.SetState (infBox, MausTauschrsc.icint1, MagicAES.DISABLED,  ~enable);
    mtUtils.SetState (infBox, MausTauschrsc.icint2, MagicAES.DISABLED,  ~enable);
    mtUtils.SetFlag (infBox, MausTauschrsc.icint1,  MagicAES.TOUCHEXIT,  enable);
    mtUtils.SetFlag (infBox, MausTauschrsc.icint2,  MagicAES.TOUCHEXIT,  enable);
    mtUtils.SetFlag (infBox, MausTauschrsc.icdays, MagicAES.EDITABLE, enable & (select = 5));
    IF draw
    THEN
      WinDials.WinDialDraw (infBox, MausTauschrsc.icdays, 1, v.r, FALSE);
      WinDials.WinDialDraw (infBox, MausTauschrsc.icint1, 1, v.r, FALSE);
      WinDials.WinDialDraw (infBox, MausTauschrsc.icint2, 1, v.r, FALSE); 
    END;
  END enablePopup;
  
  PROCEDURE SetFileName (tree: ADDRESS; obj: INTEGER; REF fname: ARRAY OF CHAR);
    VAR copy : ARRAY [0..255] OF CHAR;
        maxLen: INTEGER;
        i, j, len: INTEGER;
  BEGIN
    mtUtils.ObjcStrLen (tree, obj, maxLen, v.int);
    len := (*SYSTEM.*)LENGTH (fname);
    IF len >= maxLen
    THEN
      i := MagicStrings.Pos ('\', fname, 0, FALSE);
      IF i < len THEN
        (* Pfade am Anfang herauskrzen *)
        j := i+1;
        REPEAT
          (* nchsten Slash suchen *)
          i := MagicStrings.Pos ('\', fname, i+1, FALSE);
        UNTIL (i > len) OR (len - (i - j - 4) < maxLen);
        IF i > len
        THEN
          mtUtils.SetObjcString (tree, obj, fname);
        ELSE
          MagicStrings.Assign (fname, copy);
          MagicStrings.Delete (copy, j, i-j);
          MagicStrings.Insert ('...', copy, j);
          mtUtils.SetObjcString (tree, obj, copy);
        END;
      ELSE
        mtUtils.SetObjcString (tree, obj, fname);
      END;
    ELSE
      mtUtils.SetObjcString (tree, obj, fname);
    END;
  END SetFileName;

TYPE    changeInfo  = RECORD
                        editOld : BOOLEAN;
                        infPop  : ADDRESS;
                        inf     : infEntry;
                        select  : INTEGER;
                        wasMouse: BOOLEAN;
                        fname   : ARRAY [0..255] OF CHAR;
                        exitBut : INTEGER;
                      END;
                      
        changePtr   = POINTER TO changeInfo;

TYPE    daysArray = ARRAY [0..5] OF ARRAY [0..2] OF CHAR;

CONST   days = daysArray{'-1',' 0', ' 1', ' 7', '14',''};
TYPE    Trick =  POINTER TO RECORD
                   CASE : BOOLEAN OF
                     TRUE:  wert: INTEGER;|
                     FALSE: hi: CHAR;
                            lo: CHAR;|
                    END;
                  END;


PROCEDURE changeButton (obTree: ADDRESS; private: ADDRESS; button: INTEGER;
                        mx, my : INTEGER; kstate: BITSET; clicks: INTEGER): BOOLEAN;
  VAR info  : changePtr;
      tree  : mtUtils.tObjcTree;
      but   : INTEGER;
      x, y  : INTEGER;
      t     : Trick;
      path,
      name  : ARRAY [0..255] OF CHAR;
      res   : BOOLEAN;
      r     : mtUtils.tRect;
BEGIN
  info := private;
  tree := obTree;
  WITH info^ DO
    but := INTEGER(BITSET(button) - {15});
    CASE but OF 
      MausTauschrsc.icmaus: 
           inf.isMaus := ~inf.isMaus;
           mtUtils.CalcArea (tree, but, r);
           mtUtils.SetState (tree, but, MagicAES.SELECTED, inf.isMaus);
           WinDials.WinDialDraw (tree, but, 1, r, FALSE);
           IF inf.isMaus
           THEN
             mtUtils.ObjcString (tree, MausTauschrsc.icshort, fname);
             MagicStrings.Append (CatTypes.textExt, fname);
             mtUtils.SetObjcString (tree, MausTauschrsc.icfile, fname);
           ELSE
             inf.ordered := FALSE;
             enablePopup (tree, inf.ordered, TRUE, select);
           END;
           enableFsel (tree, inf.ordered, inf.isMaus, TRUE); |
      MausTauschrsc.icorder: 
           inf.ordered := ~inf.ordered;
           mtUtils.CalcArea (tree, but, r);
           mtUtils.SetState (tree, but, MagicAES.SELECTED, inf.ordered);
           WinDials.WinDialDraw (tree, but, 1, r, FALSE);
           enablePopup (tree, inf.ordered, TRUE, select) |
      MausTauschrsc.icint1:
           MagicAES.ObjcOffset (tree, but, x, y);
           t := ADR (tree^[but].obState);
           select := mtPopups.TreePopup (infPop, x, y, ORD(t^.hi))-1;
           IF select >= 0 THEN
             t^.hi := CHR(select);
             IF select < 5
             THEN
               mtUtils.SetObjcString (tree, MausTauschrsc.icdays, days[select]);
             END;
             mtUtils.SetFlag (tree, MausTauschrsc.icdays, MagicAES.EDITABLE, select = 5);
             VDIUtil.SetXString (tree, but, infPop, select);
             WinDials.WinDialDraw (tree, but, 0, v.r, FALSE);
             WinDials.WinDialDraw (tree, MausTauschrsc.icdays, 0, v.r, FALSE);
           END;|
      MausTauschrsc.icint2:
           t := ADR (tree^[but-1].obState);
           t^.hi := CHR((ORD(t^.hi)+1) MOD 6);
           select := ORD (t^.hi);
           IF select < 5 THEN
             mtUtils.SetObjcString (tree, MausTauschrsc.icdays, days[select]);
           END;
           mtUtils.SetFlag (tree, MausTauschrsc.icdays, MagicAES.EDITABLE, select = 5);
           VDIUtil.SetXString (tree, but-1, infPop, select);
           WinDials.WinDialDraw (tree, but-1, 0, v.r, FALSE); 
           WinDials.WinDialDraw (tree, MausTauschrsc.icdays, 0, v.r, FALSE);
           |
      MausTauschrsc.icfile:
           MagicStrings.Assign (DataPath, path);
           name := "";
           res := CatGlobal.FselGet (path, name, '*.*', 'Infodatei auswhlen', FALSE);
           IF res
           THEN
             MagicStrings.Assign (path, fname);
             MagicStrings.Append (name, fname);
             SetFileName (tree, MausTauschrsc.icfile, fname);
             (*
             mtUtils.SetObjcString (tree, MausTauschrsc.icfile, fname);
             *)
             mtUtils.ExclState (tree, but, MagicAES.SELECTED);
             WinDials.WinDialDraw (tree, MausTauschrsc.icfile, 0, v.r, FALSE);
           END; 
           mtUtils.ExclState (tree, but, MagicAES.SELECTED);
           WinDials.WinDialDraw (tree, but, 0, v.r, FALSE); |  
      MausTauschrsc.ichelp:
           mtUtils.ExclState (tree, but, MagicAES.SELECTED);
           CatHelp.DoHelp (CatHelp.infoEdit);
           WinDials.WinDialDraw (tree, but, 0, v.r, FALSE); |  
      MausTauschrsc.icok,
      MausTauschrsc.icquit : 
           mtUtils.ExclState (tree, but, MagicAES.SELECTED);
           RETURN TRUE |
    ELSE
    END;
  END;
  RETURN FALSE;
END changeButton;

PROCEDURE changeGetSetValues (tree: ADDRESS; private: ADDRESS; 
                              set: BOOLEAN; exit: INTEGER);
  VAR info  : changePtr;
      but   : INTEGER;
BEGIN
  info := private;
  but := INTEGER(BITSET(exit) - {15});
  IF set
  THEN
    IF info^.editOld
    THEN
      mtUtils.SetObjcString (tree, MausTauschrsc.ictitel, 'Infodatei anfordern');
      mtUtils.SetObjcString (tree, MausTauschrsc.icshort, info^.inf.mausShort);
      mtUtils.SetObjcString (tree, MausTauschrsc.icinfo, info^.inf.mausName);
      CatGlobal.ReplaceStr (info^.inf.filename, '$D', DataPath);
      SetFileName (tree, MausTauschrsc.icfile, info^.inf.filename);
    ELSE
      info^.inf.ordered := FALSE;
      info^.inf.isMaus := FALSE;
      info^.inf.orderIntervall := 0;
      mtUtils.SetObjcString (tree, MausTauschrsc.ictitel, 'Neue Infodatei definieren');
      mtUtils.SetObjcString (tree, MausTauschrsc.icshort, '');
      mtUtils.SetObjcString (tree, MausTauschrsc.icinfo, '');
      mtUtils.SetObjcString (tree, MausTauschrsc.icfile, '');
    END;
    CASE info^.inf.orderIntervall OF
     -1: info^.select := 0| 
      0: info^.select := 1| 
      1: info^.select := 2|
      7: info^.select := 3|
     14: info^.select := 4
    ELSE
      info^.select := 5
    END;
    mtUtils.SetFlag (tree, MausTauschrsc.icdays, MagicAES.EDITABLE, info^.select = 5);
    VDIUtil.SetIntStr (tree, MausTauschrsc.icdays, info^.inf.orderIntervall);
    VDIUtil.SetXState (tree, MausTauschrsc.icint1, info^.select);
    VDIUtil.SetXString (tree, MausTauschrsc.icint1, info^.infPop, info^.select);
    mtUtils.SetState (tree, MausTauschrsc.icmaus, MagicAES.SELECTED, info^.inf.isMaus);
    enableFsel (tree, info^.inf.ordered, info^.inf.isMaus, FALSE);
    enablePopup (tree, info^.inf.ordered, FALSE, info^.select);
    info^.wasMouse := info^.inf.isMaus;
    MagicStrings.Assign (info^.inf.filename, info^.fname);
  ELSE
    info^.exitBut := but;
    IF but = MausTauschrsc.icok
    THEN
      VDIUtil.GetIntStr (tree, MausTauschrsc.icdays, info^.inf.orderIntervall);
      mtUtils.ObjcString (tree, MausTauschrsc.icshort, info^.inf.mausShort);
      mtUtils.ObjcString (tree, MausTauschrsc.icinfo, info^.inf.mausName);
      MagicStrings.Assign (info^.fname, info^.inf.filename);
      CatGlobal.ReplaceStr (info^.inf.filename, DataPath, '$D');
      IF ~info^.inf.isMaus
      THEN
        info^.inf.avail := TRUE;
      ELSE
        IF ~info^.wasMouse
        THEN
          info^.inf.avail := FALSE;
        END;
      END;
      listChanged := TRUE;
    END;
  END;
END changeGetSetValues;

PROCEDURE doChangeInf (editOld: BOOLEAN; VAR inf: infEntry): BOOLEAN;

VAR infBox : mtUtils.tObjcTree;
    but    : INTEGER;
    info   : changePtr;

BEGIN
  infBox := MausTauschrsc.TreeAddr^[MausTauschrsc.inf_conf];
  NEW (info);
  IF info = NIL 
  THEN
    MTE.noMemAlert();
    RETURN FALSE;
  END;
  info^.infPop := MausTauschrsc.TreeAddr^[MausTauschrsc.orderbox];
  info^.editOld := editOld;
  info^.inf := inf;
  IF WinDials.OpenWinDial (infBox, TRUE, 
                           changeGetSetValues,
                           changeGetSetValues,
                           changeButton,
                           WinDials.defDraw,
                           "",
                           info)
  THEN
    WinDials.WinDialHandleEvents ();
    
    but := info^.exitBut;
    IF but = MausTauschrsc.icok
    THEN
      inf := info^.inf;
    END;
  ELSE
    but := -1;
    MTE.info (MTE.NoWinDial);
  END;
  DISPOSE (info);
  RETURN but = MausTauschrsc.icok;
END doChangeInf;

(*$Z-*)  
PROCEDURE findSel (e, i : ADDRESS): BOOLEAN;
  VAR entry : infEntryPtr;
BEGIN
  entry := infEntryPtr (e);
  RETURN entry^.selected;
END findSel;
(*$Z+*)

PROCEDURE chgEntry (obj: INTEGER; env, info: ADDRESS; VAR draw: BOOLEAN; VAR exit: BOOLEAN);
  VAR entry : infEntryPtr;
      edEntry: infEntry;
      l : CARDINAL;
      bSize : CARDINAL;

  PROCEDURE edToList (new: BOOLEAN);
  BEGIN
    l := (*SYSTEM.*)LENGTH (edEntry.filename);
    bSize := TSIZE (infEntry) - 256 + l + 2;
    ALLOCATE (entry, bSize);
    IF entry = NIL
    THEN
      MTE.noMemAlert (); 
      RETURN 
    END;
    Block.Copy (ADR(edEntry), bSize, entry);
    IF ~new
    THEN
      Lists.InsertEntry (infList, entry, v.bool);
    ELSE
      entry^.selected := FALSE;
      Lists.AppendEntry (infList, entry, v.bool);
    END;
    IF v.bool
    THEN
      DEALLOCATE (entry, 0);
      MTE.noMemAlert ();
      IF new THEN draw := FALSE END;
    ELSE
      Infofiles.SortList (infList);
    END;
  END edToList;

BEGIN
  exit := FALSE;
  Lists.ResetList (infList);
  Lists.ScanEntries (infList, Lists.forward, findSel, NIL, v.bool);
  Block.Clear (ADR(edEntry), TSIZE (infEntry));
  IF v.bool
  THEN
    entry := Lists.CurrentEntry (infList);
    l := (*SYSTEM.*)LENGTH (entry^.filename);
    bSize := TSIZE (infEntry) - 256 + l;
    Block.Copy (entry, bSize, ADR(edEntry));
    draw := doChangeInf (TRUE, edEntry);
    IF draw 
    THEN
      (* Entry nochmal suchen *)
      Lists.ResetList (infList);
      Lists.ScanEntries (infList, Lists.forward, findSel, NIL, v.bool);
      IF v.bool 
      THEN
        Lists.RemoveEntry (infList, v.bool);
        DEALLOCATE (entry, 0);
        edToList (FALSE);
      END;
    END;
  ELSE
    draw := doChangeInf (FALSE, edEntry);
    IF draw
    THEN
      edToList (TRUE);
    END;
  END;
  mtUtils.ExclState (gruppen, obj, MagicAES.SELECTED);
  WinDials.WinDialDraw (gruppen, obj, 1, v.r, FALSE);
END chgEntry;

PROCEDURE killEntry (obj: INTEGER; env, info: ADDRESS; VAR draw: BOOLEAN; VAR exit: BOOLEAN);
  VAR entry : infEntryPtr;
BEGIN
  exit := FALSE;
  Lists.ResetList (infList);
  Lists.ScanEntries (infList, Lists.forward, findSel, NIL, draw);
  IF draw
  THEN
    entry := Lists.CurrentEntry (infList);
    Lists.RemoveEntry (infList, v.bool);
    DEALLOCATE (entry, 0);
  END;
  (* Editfeld lschen *)
  mtUtils.SetObjcString (gruppen, MausTauschrsc.newgroup, '');
  mtUtils.ExclState (gruppen, obj, MagicAES.SELECTED);
  WinDials.WinDialDraw (gruppen, obj, 1, v.r, FALSE);
  WinDials.WinDialDraw (gruppen, MausTauschrsc.newgroup, 1, v.r, FALSE);
END killEntry;

PROCEDURE helpButton (obj: INTEGER; env, info : ADDRESS; VAR draw : BOOLEAN; VAR exit : BOOLEAN);
 VAR  modePtr : POINTER TO BOOLEAN;
      topic : CatHelp.tHelp;
BEGIN
  modePtr := env;
  IF modePtr^
  THEN
    topic := CatHelp.infoRead;
  ELSE
    topic := CatHelp.infoEdit;
  END;
  CatHelp.DoHelp (topic);
  mtUtils.ExclState (gruppen, obj, MagicAES.SELECTED);
  WinDials.WinDialDraw (gruppen, obj, 1, v.r, FALSE); 
  draw := FALSE;
  exit := FALSE;
END helpButton;

PROCEDURE updateButton (entry, env : ADDRESS);
  CONST changeStr = '[ndern...';
        neuStr    = '  [Neu   ';
  VAR oneSel : BOOLEAN;
      str    : ARRAY [0..20] OF CHAR;
      info   : infEntryPtr;
      isITG  : BOOLEAN;
BEGIN
  Lists.ResetList (infList);
  Lists.ScanEntries (infList, Lists.forward, findSel, NIL, oneSel);
  info := Lists.CurrentEntry (infList);
  mtUtils.ObjcString (gruppen, MausTauschrsc.gchange, str);
  IF oneSel 
  THEN
    IF ~MagicStrings.Equal (str, changeStr)
    THEN
      mtUtils.SetObjcString (gruppen, MausTauschrsc.gchange, changeStr);
      WinDials.WinDialDraw (gruppen, MausTauschrsc.gchange, 0, v.r, FALSE);
    END;
    isITG := (info # NIL) & 
             (info^.isMaus) &
             Infofiles.IsNeededInfo (info^.mausShort);
             (*
              OR MagicStrings.Equal (info^.mausShort, 'IGK'));
                 MagicStrings.Equal (info^.mausShort, 'ITG')
               OR MagicStrings.Equal (info^.mausShort, 'ITI')
               OR MagicStrings.Equal (info^.mausShort, 'ITK')
               OR MagicStrings.Equal (info^.mausShort, 'IGK'));
               *)
    IF mtUtils.InState (gruppen, MausTauschrsc.gdelete, MagicAES.DISABLED) # isITG
    THEN
      mtUtils.SetState (gruppen, MausTauschrsc.gdelete, MagicAES.DISABLED, isITG);
      WinDials.WinDialDraw (gruppen, MausTauschrsc.gdelete, 0, v.r, FALSE);
    END;
    IF mtUtils.InState (gruppen, MausTauschrsc.gchange, MagicAES.DISABLED) # isITG
    THEN
      mtUtils.SetState (gruppen, MausTauschrsc.gchange, MagicAES.DISABLED, isITG);
      WinDials.WinDialDraw (gruppen, MausTauschrsc.gchange, 0, v.r, FALSE);
    END;
  ELSIF ~oneSel & ~MagicStrings.Equal (str, neuStr)
  THEN
    mtUtils.SetObjcString (gruppen, MausTauschrsc.gchange, neuStr);
    mtUtils.SetState (gruppen, MausTauschrsc.gchange, MagicAES.DISABLED, FALSE);
    WinDials.WinDialDraw (gruppen, MausTauschrsc.gchange, 0, v.r, FALSE);
  END;
  IF ~oneSel
  THEN
    IF ~mtUtils.InState (gruppen, MausTauschrsc.gdelete, MagicAES.DISABLED)
    THEN
      mtUtils.InclState (gruppen, MausTauschrsc.gdelete, MagicAES.DISABLED);
      WinDials.WinDialDraw (gruppen, MausTauschrsc.gdelete, 0, v.r, FALSE);
    END;
    (*
    IF ~mtUtils.InState (gruppen, MausTauschrsc.gchange, MagicAES.DISABLED)
    THEN
      mtUtils.InclState (gruppen, MausTauschrsc.gchange, MagicAES.DISABLED);
      WinDials.WinDialDraw (gruppen, MausTauschrsc.gchange, 0, v.r, FALSE);
    END;
    *)
  END;
END updateButton;

PROCEDURE CalcWidth ();
  VAR info : infEntryPtr;
      maxLength : INTEGER;
BEGIN
  (* Maximale Breite eines Listeneintrages herausfinden *)
  maxLength := 0;
  maxShortname := 0;
  Lists.ResetList (infList);
  info := Lists.NextEntry (infList);
  WHILE info # NIL DO 
    IF INTEGER(LENGTH (info^.mausShort)) > maxShortname
    THEN
      maxShortname := LENGTH (info^.mausShort);
    END;
    IF INTEGER(LENGTH (info^.mausName)) > maxLength
    THEN
      maxLength := LENGTH (info^.mausName);
    END;
    info := Lists.NextEntry (infList);
  END;
  (* 17: 3 Zeichen vorne inkl. Hkchen, 
   *     1 Zeichen nach mausShort, 
   *     2 Zeichen Intervall 
   *     1 Trennzeichen
   *     8 Zeichen Datum
   *     1 Trennzeichen
   *     1 Zeichen nach Infotext
   *)
  maxListWidth := maxLength + maxShortname + 17;
END CalcWidth;
  
PROCEDURE countEntries ( l : ADDRESS; VAR ll: LONGINT; VAR ww: INTEGER);
 VAR lp : POINTER TO Lists.List;
BEGIN
 lp := l;
 IF listChanged 
 THEN 
   CalcWidth();
   listChanged := FALSE;
 END;
 ww := maxListWidth * mtAppl.CharWidth;
 ll := VAL (LONGINT, Lists.NoOfEntries (lp^));
END countEntries;

VAR  tree     : mtUtils.tObjcTree;

PROCEDURE drawInfEntry (entry, env : ADDRESS; x, y : INTEGER;
                          offset : INTEGER; clip   : GrafBase.Rectangle);

  CONST spaceString = "          ";
     VAR e   : infEntryPtr;
         str : ARRAY [0..255] OF CHAR;
         bool: POINTER TO BOOLEAN;
         tr  : mtUtils.tObjcTree;
         eff : BITSET;
         fillcol : INTEGER;
         fill: GrafBase.Rectangle;
         isSel: BOOLEAN;
  BEGIN
    e := entry;
    (*
    tr := tree;
    tr^[0].obX := x;
    tr^[0].obY := y;
    *)
    fill.x := x;
    fill.y := y;
    fill.w := fill.x + maxListWidth*mtAppl.CharWidth - 1;
    fill.h := fill.y + mtAppl.CharHeight -1 ;
    bool := env;
    (* Wir zeichnen jetzt hier die Eintrge selber, da bei einigen 
     * das ja angeblich abstrzt
     *)
    clip.w := clip.x+clip.w-1;
    clip.h := clip.y+clip.h-1;

    MagicVDI.SetClipping (mtAppl.PrivateWS, clip, TRUE);
    v.int := MagicVDI.SetWritemode (mtAppl.PrivateWS, MagicVDI.REPLACE);
    fillcol := 0;
    isSel := FALSE;
    IF (e # NIL) & isSelected (entry, env)
    THEN
      fillcol := 1; 
      isSel := TRUE;
    END;
    mtAppl.MouseOff();
    v.int := MagicVDI.SetFillcolor (mtAppl.PrivateWS, fillcol);
    MagicVDI.FillRectangle (mtAppl.PrivateWS, fill);
    IF e # NIL
    THEN
      eff := {};
      IF ~isEnabled (entry, env)
      THEN
        INCL (eff, MagicVDI.Light);
      END;
      IF bool^ & e^.new
      THEN
        INCL (eff, MagicVDI.Fat);
      END;
      IF isSel
      THEN
        v.int := MagicVDI.SetWritemode (mtAppl.PrivateWS, MagicVDI.XOR);
      END;
      eff:= MagicVDI.SetTexteffect (mtAppl.PrivateWS, eff);
      buildInfEntry (e, str);
      MagicVDI.Text (mtAppl.PrivateWS, x, y, str);
      eff:= MagicVDI.SetTexteffect (mtAppl.PrivateWS, {});
      v.int := MagicVDI.SetWritemode (mtAppl.PrivateWS, MagicVDI.REPLACE);
    END;
    MagicVDI.SetClipping (mtAppl.PrivateWS, clip, FALSE);
    mtAppl.MouseOn();

    (*
    IF e # NIL
    THEN
      (* Jetzt hier den String fr den Gruppennamen zusammenbauen *)
      mtUtils.SetObjcStringAdr (tr, 0, ADR(str));
      mtUtils.SetState (tr, 0, MagicAES.SELECTED, isSelected (entry, env));
      mtUtils.SetState (tr, 0, MagicAES.DISABLED, ~isEnabled (entry, env));
      mtUtils.SetState (tr, 0, MagicAES.DRAW3D, bool^ & e^.new);
    ELSE
      mtUtils.SetObjcStringAdr (tr, 0, CADR(spaceString));
      mtUtils.SetState (tr, 0, MagicAES.SELECTED, FALSE);
      mtUtils.SetState (tr, 0, MagicAES.DISABLED, FALSE);
      mtUtils.SetState (tr, 0, MagicAES.DRAW3D, FALSE);
    END;
    mtDials.DialDraw (tr, 0, 8, clip, TRUE);
    *)
  END drawInfEntry;

PROCEDURE setAndGetInfoValues (tree: ADDRESS; private: ADDRESS; set: BOOLEAN; exitBut: INTEGER);
  VAR iPtr : infoPtr;
BEGIN
  IF set
  THEN
  ELSE
    iPtr := private;
    iPtr^.exitBut := exitBut;
  END;
END setAndGetInfoValues;

PROCEDURE doInfoList (open : BOOLEAN; 
                      VAR fname : ARRAY OF CHAR): BOOLEAN;

  VAR specials : ARRAY [0..2] OF specialButHdler;
      info     : infEntryPtr;
      env      : infoBlock;
      exit     : INTEGER;
      dcBut    : INTEGER;
      filename : ARRAY [0..255] OF CHAR;
      exists   : BOOLEAN;
      maxLength: INTEGER;
      r        : GrafBase.Rectangle;
      dialHandler: ListDl.ldHandler;

BEGIN
  v.int := MagicVDI.SetFillinterior (mtAppl.PrivateWS, MagicVDI.Full);
  v.int := MagicVDI.SetFillstyle (mtAppl.PrivateWS, MagicVDI.Full);
  v.int := MagicVDI.SetFillcolor (mtAppl.PrivateWS, 0);
  env.open := open;

  IF ~Infofiles.InfoLoaded() THEN Infofiles.LoadInfoInf (FALSE, FALSE); END;
  gruppen := MausTauschrsc.TreeAddr^[MausTauschrsc.gruppen];
  (* Strings umsetzen *)
  IF open
  THEN
    mtUtils.SetObjcString (gruppen, MausTauschrsc.gtitel, 'Infodatei ffnen');
  ELSE
    mtUtils.SetObjcString (gruppen, MausTauschrsc.gtitel, 'Infodateien konfigurieren');
  END;
  mtUtils.SetState (gruppen, MausTauschrsc.gok, MagicAES.DISABLED, FALSE);
  mtUtils.SetFlag (gruppen, MausTauschrsc.gok, MagicAES.DEFAULT, TRUE);
  mtUtils.SetFlag (gruppen, MausTauschrsc.grcfull, MagicAES.HIDETREE, TRUE);
  mtUtils.SetFlag (gruppen, MausTauschrsc.grcempty, MagicAES.HIDETREE, TRUE);
  mtUtils.SetFlag (gruppen, MausTauschrsc.gball, MagicAES.HIDETREE, TRUE);
  mtUtils.SetFlag (gruppen, MausTauschrsc.gchange, MagicAES.HIDETREE, open);
  mtUtils.SetFlag (gruppen, MausTauschrsc.gdelete, MagicAES.HIDETREE, open);
  mtUtils.SetState (gruppen, MausTauschrsc.gchange, MagicAES.DISABLED, FALSE);
  mtUtils.SetObjcString (gruppen, MausTauschrsc.gdelete, '[Lschen');

  (* String-Pointer bestimmen *)
  mtUtils.SetObjcString (gruppen, MausTauschrsc.newgroup, lastFile);
  (* specials bestimmen *)
  IF ~open
  THEN
    specials[0].objc := MausTauschrsc.gchange;
    specials[1].objc := MausTauschrsc.gdelete;
  ELSE
    specials[0].objc := -1000;
    specials[1].objc := -1000;
  END;
  specials[0].proc := chgEntry;
  specials[1].proc := killEntry;
  specials[2].objc := MausTauschrsc.ghelp;
  specials[2].proc := helpButton;
  
  IF open 
  THEN dcBut := MausTauschrsc.gok;
  ELSE dcBut := MausTauschrsc.gchange;
  END;

  (* Maximale Breite eines Listeneintrages herausfinden *)
  CalcWidth ();
  listChanged := FALSE;
  
  (* Jetzt das Object zusammenbauen *)
  mtUtils.CalcArea (gruppen, MausTauschrsc.groupbox, r);
  maxLength := maxListWidth; (* r.w DIV mtAppl.CharWidth; *)

  (* WindowDialog vorbereiten *)
  ListDl.BuildLdHandler (ADR(infList), 
                  ListHelp.resetList,
                  ListHelp.nextEntry,
                  ListHelp.prevEntry,
                  countEntries,
                  isEnabled, selInfEntry,
                  infToStr, isSelected, drawInfEntry,
                  0, mtAppl.CharHeight, 
                  8, maxLength*mtAppl.CharWidth,
                  dialHandler);
  (* ListWinDialog ffnen *)
  IF ListDl.WinListDial (gruppen, ListDl.ldElemSet{ldSelect, ldArrows, ldDoubleExit, ldAutolocate, ldModal},
                  dialHandler,
                  MausTauschrsc.groupbox,
                  MausTauschrsc.groupback,
                  MausTauschrsc.gok,
                  MausTauschrsc.gcancel,
                  ADR(env), dcBut,
                  MausTauschrsc.newgroup,
                  updateButton,
                  specials,
                  3,
                  ListDl.dummyCheckExit,
                  setAndGetInfoValues,
                  setAndGetInfoValues,
                  info)
  THEN
    exit := env.exitBut;
  ELSE
    RETURN FALSE;
  END;

  mtUtils.ObjcString (gruppen, MausTauschrsc.newgroup, lastFile);
  IF open & (info # NIL)
  THEN
    IF ~BuildName (info, fname)
    THEN
      (* Wenn Ok angewhlt, dann Fehlermeldung *)
      IF exit = MausTauschrsc.gok
      THEN
        MTE.info (MTE.noInfFile);
      END;
      (* Und Abbruch zurckgeben *)
      RETURN FALSE 
    END;
  ELSE
    IF exit = MausTauschrsc.gok
    THEN
      Infofiles.SaveInfoInf();
    ELSE
      Infofiles.LoadInfoInf (FALSE, FALSE);
    END;
  END;
  RETURN (exit = MausTauschrsc.gok) & (info # NIL);
END doInfoList;

BEGIN
  lastFile := "";
END InfoDlg.
