DEFINITION MODULE Infofiles;

FROM SYSTEM IMPORT ADDRESS;

IMPORT Lists;

(*$Z+*)
TYPE infMode = (IFIRST, INEXT);

     tCrcState = (cNa, cWithCrc, cNoCrc);

     infEntry = RECORD
                  CASE : BOOLEAN OF
                     TRUE:  crc   : CARDINAL;
                            new   : BOOLEAN;
                            avail : BOOLEAN;
                            isMaus: BOOLEAN;
                            ordered: BOOLEAN;
                            orderIntervall: INTEGER; (* -1: Einmalig, 0: Immer, 1: tglich *)
                            lastOrdered: LONGCARD; (* Datum in Tagen seit dem 1.1.1900 *)
                            selected: BOOLEAN;
                            hasCrc: tCrcState;
                            res   : CARDINAL;
                            mausShort : ARRAY [0..9] OF CHAR;
                            mausName  : ARRAY [0..255] OF CHAR;
                            filename  : ARRAY [0..255] OF CHAR; |
                     FALSE: data: ARRAY [0..1023] OF CHAR; |
                  END;
                END;
  
    infEntryPtr = POINTER TO infEntry;

VAR infList : Lists.List;

PROCEDURE IsNeededInfo (REF str: ARRAY OF CHAR): BOOLEAN;
(* Gibt zurck, ob es ein Infofile ist, das von CAT immer 
 * bentigt wird
 *)

PROCEDURE InfoLoaded(): BOOLEAN;

PROCEDURE LoadInfoInf(dbChanged, clearNew : BOOLEAN);

PROCEDURE SaveInfoInf();

PROCEDURE SetInfoCrc (REF inf : ARRAY OF CHAR; VAR str : ARRAY OF CHAR);
(* Setzt die CRC fr das Infofile inf. Falls das Infofile nicht
 * gefunden wird, dann wird gar nichts gesetzt.
 *)

PROCEDURE GetInfoCrc (VAR str : ARRAY OF CHAR; mode : infMode) : BOOLEAN;
(* Liefert den Namen eines Infofiles inkl. Crc zurck. Bei Mode = IFIRST wird das erste Infofile
 * zurckgeliefert, bei Mode = INEXT wird der nchste zurckgeliefert.
 * Wenn alle Infostrings geliefert wurden, dann wird FALSE zurckgegeben 
 * (kann auch bei IFIRST passieren).
 * Zwischen den Aufrufen sollte nicht anders auf die Liste
 * zugegriffen werden, da ansonsten evtl. nicht alle angefordert
 * werden oder einige doppelt angefordert werden.
 *)

PROCEDURE AddEntry (isMausInf, order, avail, new : BOOLEAN; crc : CARDINAL; inter : INTEGER;
                    lastOrder : LONGCARD; REF short, name, file : ARRAY OF CHAR;
                    saveInf : BOOLEAN; withCrc: tCrcState): BOOLEAN;
(* Fgt einen Eintrag fr ein Infofile an die Liste an.
 * Bei einem Mausinfofile ist die Angabe des Namens berflssig,
 * da dort immer das Krzel mit der Extension .TXT genommen wird.
 *)

PROCEDURE GetInfoFilename (REF short: ARRAY OF CHAR; 
                           VAR fname : ARRAY OF CHAR): BOOLEAN;
(* Liefert zum Krzel des Infofiles den Filenamen. 
 * FALSE: Infofile nicht vorhanden 
 *)

PROCEDURE IsInfoFile (REF short: ARRAY OF CHAR; onlyMaus: BOOLEAN): BOOLEAN;
(* Liefert zurck, ob ein Krzel ein Infofile ist oder nicht 
 *)

PROCEDURE TestDirectParse (REF short: ARRAY OF CHAR);
(* Wird vom Parser aufgerufen, wenn ein Infofile geschlossen wurde. Falls es 
 * wichtige Informationen enthlt (ITG), wird es dann direkt geparst
 *)

PROCEDURE BuildName (info: ADDRESS; VAR fname : ARRAY OF CHAR): BOOLEAN;

PROCEDURE SortList (VAR l : Lists.List);                        (* exported *)

END Infofiles.
