IMPLEMENTATION MODULE InstRsc; (*$M-*)

FROM SYSTEM     IMPORT  ADR, TSIZE, ASSEMBLER, ADDRESS, CADR, CAST, BYTE;

(*$R-, S-, P+, M- *) 
(*  Graphics  *)

(* GrafBase kann ich benutzen, da keine Aufrufe der MM2 GEM-Library gemacht
 * werden
 *)

FROM GrafBase   IMPORT Rect, Point, Rectangle, FrameRects,
                       MemFormDef, BitOperation, TransRect;

FROM Storage    IMPORT ALLOCATE, DEALLOCATE;
                     
(* Importe aus der MagicLib: *)

FROM MagicTypes IMPORT MFORM;

FROM MagicSys   IMPORT sBITSET, sINTEGER, sCARDINAL, CastToInt;

FROM MagicAES   IMPORT
     OBJECT, SELECTABLE, SELECTED, DISABLED, SHADOWED, EDITABLE,
     Exit, DEFAULT, OUTLINED, HIDETREE,
     GBOX, GIBOX, GBOXCHAR, GIMAGE, GICON, GTEXT, GBOXTEXT,
     GFTEXT, GFBOXTEXT, GBUTTON,
     RED, BLUE, BLACK,
     AESIntIn, AESIntOut, EvntPmulti, MUKEYBD, MUTIMER,
     CallResult, BoxInfo,
     ObjcOffset,  ObjcDraw ,
     WindUpdate, ENDUPDATE, BEGUPDATE, ENDMCTRL, BEGMCTRL,
     ShelRead, ShelFind,
     RsrcLoad, RsrcFree, RsrcGaddr, RTREE, RFRSTR, RSTRING,
     Horizontal, Vertical, GrafSlidebox, GrafHandle,
     GrafMkstate, GrafMouse, USERDEF,
     WindGet, WFWORKXYWH,
     EvntTimer;
     
FROM MagicVDI   IMPORT
     TransformForm, REPLACE, CopyRasterOpaque, SetFillcolor;

FROM MagicDOS    IMPORT Dgetpath, Dgetdrv;

FROM mtAppl     IMPORT
     ApplInit, ApplTerm, ApplIdent, ApplPath, VDIHandle, MaxWidth, MaxHeight,
     MouseArrow, MouseBusy, MouseUser, UserMouse, Bitplanes;

FROM mtUtils         IMPORT SetObjcStringAdr, SetObjcString, ObjcString,
                            InclFlag, ExclFlag, InFlag, InclState, ExclState,
                            InState, ObjcStrLen, ObjcArea, SetObjcRect, tRect,
                            CalcArea, ObjcRect;

FROM mtDir      IMPORT GetDir;

FROM SysUtil0   IMPORT WExcl;
(*
FROM Lists      IMPORT  List,           CreateList,     DeleteList,
                        AppendEntry,    ListEmpty,      CurrentEntry,
                        NextEntry,      ResetList,      RemoveEntry,
                        ScanEntries,    LDir,           LCondProc,
                        NoOfEntries,    PrevEntry;
*)
FROM Strings    IMPORT  String,         Space,          Pos,
                        DelLeadingBlanks,               Append,
                        Assign,         Concat,         Empty,
                        Insert;

FROM StrConv    IMPORT StrToInt, IntToStr;

FROM FileNames  IMPORT SplitPath, ConcatPath, PathConc;

FROM BinOps     IMPORT LowerInt;

IMPORT FastStrings;
FROM Directory IMPORT SetDefaultPath, CreateDir;

IMPORT Inst_30; (* Resource-Definitions *)


(* MagicLib *)
IMPORT MagicAES;
IMPORT MagicVDI;
IMPORT MagicDOS;
IMPORT MagicStrings;
IMPORT MagicConvert;
IMPORT MagicSys;

(* MagicTools *)
IMPORT mtAppl;
IMPORT mtCommand;
IMPORT mtUtils;
IMPORT mtDir;
IMPORT mtTextfiles;
IMPORT mtTime;

FROM Void       IMPORT v;

TYPE FileStr  = ARRAY [0..139] OF CHAR;
  
VAR
        apId            : CARDINAL;
        gemHdl          : INTEGER;
        devHdl          : INTEGER;
        
        charWidth,
        charHeight      : INTEGER;
        
        voidI           : INTEGER;
        voidC           : CARDINAL;
        voidO           : BOOLEAN;
        vr              : tRect;
        
        (* image und icon-konvertierung *)
                
PROCEDURE vdiFix (VAR pfd : MemFormDef; theAddr : ADDRESS;
                  wb, h : CARDINAL);
BEGIN
  WITH pfd DO
    words  := wb DIV 2;
    w      := wb * 8;
    h      := h;
    planes := 1;   (* monochrom *)
    start  := theAddr;
  END;
END vdiFix;

PROCEDURE vdiTrans (source : ADDRESS; sourceWb : CARDINAL;
                    dest   : ADDRESS; destWb   : CARDINAL;
                    h   : CARDINAL; handle : INTEGER);
                    
  VAR src, dst : MemFormDef;
BEGIN
  vdiFix (src, source, sourceWb, h);
  src.standardForm := TRUE;
  vdiFix (dst, dest, destWb, h);
  dst.standardForm := FALSE;
  TransformForm (handle, src, dst);
END vdiTrans;

PROCEDURE transBitBlk (spec : PtrBitBlock; handle : INTEGER);
  VAR tAddr : ADDRESS;
      wb, hl : CARDINAL;
BEGIN
  tAddr := spec^.biData;
  IF tAddr = ADDRESS(-1L) THEN RETURN END;
  wb := spec^.biWb;
  hl := spec^.biHl;
  vdiTrans (tAddr, wb, tAddr, wb, hl, handle);
END transBitBlk;

PROCEDURE transObj ( tree : PtrObjTree; obj : CARDINAL; handle : INTEGER);
  VAR wb, hl    : CARDINAL;
      tAddr     : ADDRESS;
      spec      : PtrIconBlock;
      type      : INTEGER;
BEGIN
  type := tree^[obj].obType;
  spec := PtrIconBlock(tree^[obj].obSpec.IconPtr);
  
  CASE type OF
                GIMAGE   : transBitBlk (ADDRESS(spec), handle); |
                GICON    : hl := spec^.ibHicon;
                           wb := (spec^.ibWicon + 7) DIV 8;
                           tAddr := spec^.ibPdata;
                           IF tAddr # ADDRESS(-1L)
                           THEN
                             vdiTrans (tAddr, wb, tAddr, wb, hl, handle)
                           END;
                           tAddr := spec^.ibPmask;
                           IF tAddr # ADDRESS(-1L)
                           THEN
                             vdiTrans (tAddr, wb, tAddr, wb, hl, handle)
                           END;
                           
  ELSE
  END (* CASE *)
END transObj;

        (*  Routinen fr den Umgang mit Objektbumen  *)
        (*  ========================================  *)

PROCEDURE DoSimpleBox (form: ADDRESS) : INTEGER;
    VAR i : INTEGER;
  BEGIN
     WindUpdate (BEGUPDATE);
     WindUpdate (BEGMCTRL);
     MagicAES.FormCenter (form, vr);
     MagicAES.FormDial (MagicAES.FMDSTART, vr, vr);
     MagicAES.ObjcDraw (form, 0, 8, vr);
     REPEAT
       i := MagicAES.FormDo (form, 0);
     UNTIL (i # -1) & (i # -2) & (i#-3);
     MagicAES.FormDial (MagicAES.FMDFINISH, vr, vr);
     WExcl (i, 15);
     ExclState (form, i, SELECTED);
     WindUpdate (ENDMCTRL);
     WindUpdate (ENDUPDATE);
     RETURN i
  END DoSimpleBox;

PROCEDURE GetHomePath();
VAR applpath:   MaxStr;
    shelPath:   MaxStr;
    shelCmd:    MaxStr;
    cDrv:       INTEGER;
BEGIN
  cDrv := Dgetdrv();
  Dgetpath (applpath, cDrv+1);
  Insert ('A:',0, applpath, voidO);
  applpath [0] := CHR(ORD('A')+CARDINAL(cDrv));
  IF applpath[LENGTH(applpath)-1] # '\'
  THEN
    Append ('\',applpath, voidO);
  END;
(*  ApplPath (applpath); *)
  ShelRead (shelPath, shelCmd);
  (* Jetzt haben wir den aktuellen Pfad und den aus ShellRead.
   * Jetzt mssen wir nur noch testen, welches der richtige ist
   *)
  IF Pos ('INST',shelPath,0) >= 0
  THEN
    (* Im ShellPfad ist PUTZ drin, also wird der wohl stimmen *)
    SplitPath (shelPath, homePath, shelCmd);
    IF Empty (homePath)
    THEN
      Assign (applpath, homePath, voidO);
    END;
  ELSE
    (* PUTZ ist nicht im ShellPfad, dann nehmen wir lieber den aktuellen *)
    Assign (applpath, homePath, voidO);
  END;
END GetHomePath;

VAR MaxBoxStrLen : INTEGER;

PROCEDURE InitResource (VAR resourceName : ARRAY OF CHAR) : BOOLEAN;
  
  CONST
        noRscAlt        = '[3][Kann das Resource-File|INST_26.RSC nicht laden][Schade...]';
        
        noLowResAlt     = '[3][Die gewhlte Auflsung|ist zu niedrig|fr Install!][ OK ]';
        
  VAR success     : BOOLEAN;
      screenColumns : CARDINAL;
      box         : BoxInfo;
      rscLoaded   : BOOLEAN;
      rscString   : FileStr;
  BEGIN
    
    devHdl := VDIHandle;
    GrafHandle (gemHdl, charWidth, charHeight, voidI, voidI);
    
    apId  := ApplIdent;
    
    GetHomePath();
    
    (* 80-Zeichen Bildschirm wird verlangt! *)
    screenColumns := MaxWidth DIV charWidth;
    
    IF screenColumns < 80
    THEN
      voidI := MagicAES.FormAlert (1,noLowResAlt);
      RETURN FALSE
    END;
                  (* Resource laden und Baumaddressen ermitteln *)
    rscLoaded := RsrcLoad (resourceName);
    IF ~rscLoaded
    THEN
      Concat (homePath, resourceName, rscString, voidO);
      rscLoaded := RsrcLoad (rscString);
    END;
    IF ~rscLoaded
    THEN
      voidI := MagicAES.FormAlert (1,noRscAlt);
      RETURN FALSE
    END;
    
    infoBox       :=RsrcGaddr (RTREE, Infobox);
    menu          :=RsrcGaddr (RTREE, Menu);
    pathbox       :=RsrcGaddr (RTREE, Path_cnf);
    helppath      :=RsrcGaddr (RTREE, Helppath);
    (*
    voidO := TRUE;
    voidO    := voidO & NewDial (infoBox);
    voidO    := voidO & NewDial (pathbox);
    voidO    := voidO & NewDial (helppath);
    IF ~voidO THEN RETURN FALSE END;
    DialCenter (infoBox, CSCREEN, 0, 0, vr);
    DialCenter (pathbox,  CSCREEN, 0, 0, vr);
    DialCenter (helppath, CSCREEN, 0, 0, vr);
    *)
    
    (* Versionsnummer einsetzen *)
    SetObjcString (infoBox, Version, version);
    
    (* Bit Images anpassen *)
    
    transObj (infoBox, Thecat0, devHdl);
    transObj (infoBox, Thecat1, devHdl);
    transObj (infoBox, Thecat2, devHdl);
    
    RETURN TRUE
  END InitResource;
  
PROCEDURE doInfo();
  VAR but : INTEGER;
BEGIN
  but := DoSimpleBox (infoBox);
END doInfo;

PROCEDURE ClrRsrc();
BEGIN
  RsrcFree();
END ClrRsrc;

PROCEDURE ReplaceStr (VAR str : ARRAY OF CHAR; REF s1, s2 : ARRAY OF CHAR);
  VAR p : CARDINAL;
      sLen : CARDINAL;
      s1Len: CARDINAL; 
BEGIN
  sLen := LENGTH (str);
  s1Len:= LENGTH (s1);
  p := MagicStrings.Pos (s1, str, 0, FALSE);
  WHILE p <= sLen DO
    MagicStrings.Delete (str, p, s1Len);
    MagicStrings.Insert (s2, str, p);
    sLen := LENGTH (str);
    p := MagicStrings.Pos (s1, str, p, FALSE);
  END;
END ReplaceStr;
  
PROCEDURE FselGet(VAR InPath, InSel: ARRAY OF CHAR; REF ext, msg : ARRAY OF CHAR;
                  pathOnly : BOOLEAN):BOOLEAN;
(* Ausgelagert aus CAT.M, da ich die auch im Editor verwenden kann.
 *)
VAR scrapP : ARRAY[0..127] OF CHAR;
    scrapN : ARRAY[0..12] OF CHAR;
    l      : CARDINAL;
BEGIN
  MagicStrings.Assign(InPath, scrapP);
  l := LENGTH (InPath);
  IF l > 0
  THEN
    IF InPath[l-1] #'\'
    THEN InPath[l-1] := '\';InPath[l] := 0c;
    END;
  END;
  MagicStrings.Assign(InSel, scrapN);
  MagicStrings.Append(ext, InPath);
  MagicAES.WindUpdate(MagicAES.BEGMCTRL);
  IF mtDir.GetDir(InPath, InSel, msg) THEN
    MagicAES.WindUpdate(MagicAES.ENDMCTRL);
    mtDir.DelTail(InPath);
    IF pathOnly
    THEN 
      RETURN TRUE
    ELSE
      RETURN LENGTH (InSel) # 0;
    END;
  ELSE
    MagicAES.WindUpdate(MagicAES.ENDMCTRL);
    MagicStrings.Assign(scrapP, InPath);
    MagicStrings.Assign(scrapN, InSel);
    RETURN FALSE
  END
END FselGet;

PROCEDURE info (REF s: ARRAY OF CHAR);
BEGIN
  v.int := MagicAES.FormAlert (1, s);
END info;

PROCEDURE InfoAlert(REF s1,s2,s3 : ARRAY OF CHAR);
VAR scrap : ARRAY[0..255] OF CHAR;
BEGIN
  MagicStrings.Assign(s1, scrap);
  MagicStrings.Append(s2, scrap);
  MagicStrings.Append(s3, scrap);
  info (scrap);
END InfoAlert;
 
PROCEDURE doConfig(REF newPath: ARRAY OF CHAR; VAR newDataPath: ARRAY OF CHAR);
TYPE varArray =  ARRAY [1..11] OF ARRAY[0..255] OF CHAR;
     titleArray = ARRAY [1..11] OF ARRAY [0..39] OF CHAR;

CONST   lzhArc  = 'a $E$F $MINFILE.TXT';
        lzhDearc= 'x $I$O $I OUTFILE.TXT';
        zipArc  = '-a $E$F $MINFILE.TXT';
        zipDearc= '-x $I$O $I OUTFILE.TXT';
        
VAR   tree      : PtrObjTree;
      titles    : POINTER TO titleArray;
      txtArray  : POINTER TO varArray;
      pathOnly  : BOOLEAN; 
      str, 
      path      : ARRAY [0..255] OF CHAR;
      suff,
      name      : ARRAY [0..20] OF CHAR;
      but, idx, 
      i         : INTEGER;
      res       : BOOLEAN;
      or,
      r         : mtUtils.tRect;
      tf        : mtTextfiles.TEXTFILE;
      ex        : BOOLEAN;
      nFound    : BOOLEAN;
      nameL     : CARDINAL;

  PROCEDURE translateOut (VAR src, dest : ARRAY OF CHAR);
  BEGIN
    MagicStrings.Assign (src, dest);  
    mtDir.SplitPath (txtArray^[5], path, name, suff);
    MagicStrings.Insert ("INFILE.", suff, 0);
    ReplaceStr (dest, "$F", suff);          (* Infilename *)
    ReplaceStr (dest, "$I", txtArray^[4]);  (* Importpath *)
    ReplaceStr (dest, "$O", txtArray^[5]);  (* Outfilename *)
    ReplaceStr (dest, "$E", txtArray^[6]);  (* Exportpath *)
    ReplaceStr (dest, "$M", txtArray^[7]);  (* Messagepath *)
    mtDir.SplitPath (txtArray^[9], path, name, suff);
    ReplaceStr (dest, "$T", path);          (* Terminalpath *)
  END translateOut;
  
  PROCEDURE getEdits();
  BEGIN          
    mtUtils.ObjcString (tree, Psarc, txtArray^[2]);
    mtUtils.ObjcString (tree, Psdearc, txtArray^[3]);
    mtUtils.ObjcString (tree, Pscomm, txtArray^[10]);
  END getEdits;
  
BEGIN
  MagicStrings.Assign ("", newDataPath); 
  tree := pathbox;
  ALLOCATE (txtArray, TSIZE (varArray));
  IF txtArray = NIL
  THEN
    info ("[3][Install:|Fr die gewnschte|Operation steht|zuwenig Speicher|zur Verfgung.][Abbruch]");
    RETURN
  END;
  FOR i := 1 TO 11 DO MagicStrings.Assign ("", txtArray^[i]); END;
  ALLOCATE (titles, TSIZE (titleArray));
  IF titles = NIL
  THEN
    info ("[3][Install:|Fr die gewnschte|Operation steht|zuwenig Speicher|zur Verfgung.][Abbruch]");
    DEALLOCATE (titles, 0);
    RETURN
  END; 
  (* Strings setzen *)
  FOR i := 1 TO 10 DO
    MagicStrings.Assign ("", txtArray^[i]);
  END;
  (* Jetzt Defaults festlegen *)
  SetDefaultPath (newPath, v.int);
  (* Jetzt Unterverzeichnisse anlegen *)
  CreateDir ('IMPORT', v.int);
  MagicStrings.Assign (newPath, txtArray^[4]);
  MagicStrings.Append ('IMPORT\', txtArray^[4]);
  CreateDir ('EXPORT', v.int);
  MagicStrings.Assign (newPath, txtArray^[6]);
  MagicStrings.Append ('EXPORT\', txtArray^[6]);
  CreateDir ('MESSAGES', v.int);
  MagicStrings.Assign (newPath, txtArray^[7]);
  MagicStrings.Append ('MESSAGES\', txtArray^[7]);
  CreateDir ('DATABASE', v.int);
  MagicStrings.Assign (newPath, txtArray^[8]);
  MagicStrings.Append ('DATABASE\', txtArray^[8]);

  (* Titel fr Fileselektor setzen *)
  MagicStrings.Assign ("Packer auswhlen", titles^[1]);
  MagicStrings.Assign ("Importpfad auswhlen", titles^[4]);
  MagicStrings.Assign ("Outfilenamen festlegen", titles^[5]);
  MagicStrings.Assign ("Exportpfad auswhlen", titles^[6]);
  MagicStrings.Assign ("Nachrichtenpfad auswhlen", titles^[7]);
  MagicStrings.Assign ("Databasepfad auswhlen", titles^[8]);
  MagicStrings.Assign ("Terminalprogramm auswhlen", titles^[9]);
  FOR i := Pspack TO Pscomm DO
    mtUtils.SetObjcString (tree, i, txtArray^[i-Pspack+1]);
  END;
  MagicAES.FormCenter (tree, or);
  MagicAES.FormDial (MagicAES.FMDSTART, or, or);
  MagicAES.ObjcDraw (tree, 0, 8, or);
  LOOP
    but := MagicAES.FormDo (tree, 0);
    but := INTEGER(BITSET(but) - {15});
    idx := but - Pbpack+1;
    CASE but OF
      Pbpack..Pbterm:
        (* Pfad holen *)
        (* Nur bei pboutfil nur Dateinamen ohne Pfad nehmen,
         * bei pbpack oder pbterm auch noch Dateinamen an Pfad 
         * anhngen  
         *)
        IF but = Pboutfil
        THEN
          MagicStrings.Assign (txtArray^[4], path);
          MagicStrings.Assign (txtArray^[idx], name);
        ELSE
          IF txtArray^[idx][0] # ''
          THEN
            mtDir.SplitPath (txtArray^[idx], path, name, suff);
          ELSE
            MagicStrings.Assign (newPath, path);
            name[0] := "";
          END;
        END;
        IF (but # Pbterm) 
         & (but # Pboutfil)
         & (but # Pbpack)
        THEN
          res := GetAndCreatePath (path, name, titles^[idx]);
        ELSE
          res := FselGet (path, name, '*.*', titles^[idx], FALSE);
        END;
        mtUtils.CalcArea (tree, 0, r); 
        MagicAES.ObjcDraw (tree, 0, 8, r);
        IF res
        THEN
          IF but = Pboutfil
          THEN
            MagicStrings.Assign (name, txtArray^[idx]);
          ELSE
            MagicStrings.Assign (path, txtArray^[idx]);
          END;
          IF (but = Pbpack) 
          OR (but = Pbterm) 
          THEN
            IF name[0] # ''
            THEN
              MagicStrings.Append (name, txtArray^[idx]);
            ELSE
              MagicStrings.Assign ('', txtArray^[idx]);
            END;
          END;
          mtUtils.SetObjcString (tree, but-Pbpack+Pspack, txtArray^[idx]);
          mtUtils.CalcArea (tree, but-Pbpack+Pspack, r); 
          MagicAES.ObjcDraw (tree, 0, 2, r);
          IF but = Pbpack
          THEN
            (* Defaults fr die Kommandozeilen und das Outfile eintragen *)
            nFound := FALSE;
            nameL := MagicStrings.Length (name);
            IF (MagicStrings.Pos ('LZH*', name, 0, TRUE) < nameL) OR
               (MagicStrings.Pos ('LHA*', name, 0, TRUE) < nameL)
            THEN
              (* LHArc gefunden *)
              mtUtils.SetObjcString (tree, Psarc, lzhArc);
              mtUtils.SetObjcString (tree, Psdearc, lzhDearc);
              MagicStrings.Assign ('OUTFILE.LZH', txtArray^[5]);
              mtUtils.SetObjcString (tree, Psoutfil, txtArray^[5]);
            ELSIF MagicStrings.Pos ('ZOO*', name, 0, TRUE) < nameL
            THEN
              mtUtils.SetObjcString (tree, Psarc, lzhArc);
              mtUtils.SetObjcString (tree, Psdearc, lzhDearc);
              MagicStrings.Assign ('OUTFILE.ZOO', txtArray^[5]);
              mtUtils.SetObjcString (tree, Psoutfil, txtArray^[5]);
            ELSIF MagicStrings.Pos ('ARC*', name, 0, TRUE) < nameL
            THEN
              mtUtils.SetObjcString (tree, Psarc, lzhArc);
              mtUtils.SetObjcString (tree, Psdearc, lzhDearc);
              MagicStrings.Assign ('OUTFILE.ARC', txtArray^[5]);
              mtUtils.SetObjcString (tree, Psoutfil, txtArray^[5]);
            ELSIF MagicStrings.Pos ('ZIP*', name, 0, TRUE) < nameL
            THEN
              mtUtils.SetObjcString (tree, Psarc, zipArc);
              mtUtils.SetObjcString (tree, Psdearc, zipDearc);
              MagicStrings.Assign ('OUTFILE.ZIP', txtArray^[5]);
              mtUtils.SetObjcString (tree, Psoutfil, txtArray^[5]);
            ELSE
              nFound := TRUE;
            END;
            IF ~nFound
            THEN
              ObjcString (tree, Psarc, txtArray^[2]);
              ObjcString (tree, Psdearc, txtArray^[3]);
              mtUtils.CalcArea (tree, Psarc, r); 
              MagicAES.ObjcDraw (tree, 0, 2, r);
              mtUtils.CalcArea (tree, Psdearc, r); 
              MagicAES.ObjcDraw (tree, 0, 2, r);
              mtUtils.CalcArea (tree, Psoutfil, r); 
              MagicAES.ObjcDraw (tree, 0, 2, r);
            END;
          END;
        END; |
      Pathhelp:
        v.int := DoSimpleBox  (helppath); |
      Pathok  : 
        getEdits();
        IF LENGTH (txtArray^[4]) = 0
        THEN
          (* Importpfad *)
          v.int := MagicAES.FormAlert (1, '[3][Importpfad nicht angegeben!|Bitte whlen Sie einen Pfad aus!][Nochmal]');
        ELSIF LENGTH (txtArray^[5]) = 0
        THEN  
          v.int := MagicAES.FormAlert (1, '[3][Outfile nicht angegeben!|Bitte whlen Sie die Datei aus!][Nochmal]');
        ELSIF LENGTH (txtArray^[6]) = 0
        THEN  
          (* Exportpfad *)
          v.int := MagicAES.FormAlert (1, '[3][Exportpfad nicht angegeben!|Bitte whlen Sie einen Pfad aus!][Nochmal]');
        ELSIF LENGTH (txtArray^[7]) = 0
        THEN
          (* Messagepfad *)
          v.int := MagicAES.FormAlert (1, '[3][Messagepfad nicht angegeben!|Bitte whlen Sie einen Pfad aus!][Nochmal]');
        ELSIF LENGTH (txtArray^[8]) = 0
        THEN
          (* Databasepfad *)
          v.int := MagicAES.FormAlert (1, '[3][Databasepfad nicht angegeben!|Bitte whlen Sie einen Pfad aus!][Nochmal]');
        ELSIF LENGTH (txtArray^[9]) = 0
        THEN
          (* Terminalprogramm *)
          v.int := MagicAES.FormAlert (1, '[3][Kein Terminalprogramm ausgewhlt!|Bitte whlen Sie eine Datei aus!][Nochmal]');
        ELSIF (LENGTH (txtArray^[1]) # 0) & (LENGTH (txtArray^[2]) = 0)
        THEN
          (* Leere Kommandozeile fr Einpacken *)
          v.int := MagicAES.FormAlert (1, '[3][Die Kommandozeile zum Einpacken|des Infiles ist leer!|Bitte tragen Sie dort die|richtigen Befehle ein.][Nochmal]');
        ELSIF (LENGTH (txtArray^[1]) # 0) & (LENGTH (txtArray^[3]) = 0)
        THEN
          (* Leere Kommandozeile fr Auspacken *)
          v.int := MagicAES.FormAlert (1, '[3][Die Kommandozeile zum Auspacken|des Outfiles ist leer!|Bitte tragen Sie dort die|richtigen Befehle ein.][Nochmal]');
        ELSE
          ex := TRUE;
          IF LENGTH (txtArray^[1]) = 0
          THEN
            v.int := MagicAES.FormAlert (1, '[3][Kein Packer ausgewhlt!|Sind sie sicher, da das korrekt ist?][Ja|Nein]');
            ex := v.int = 1;
          END;
          IF ex & (LENGTH (txtArray^[1]) = 0)
          THEN
            v.int := MagicAES.FormAlert (1, '[3][Kein Kommandozeile fr das|Terminalprogramm festgelegt!|Sind sie sicher, da das korrekt ist?][Ja|Nein]');
            ex := v.int = 1;
          END;
          IF ex THEN EXIT; END;
        END; |
      (*
      Pathquit: EXIT |
      *)
    ELSE
    END;
    mtUtils.ExclState (tree, but, MagicAES.SELECTED);
    mtUtils.CalcArea (tree, but, r); 
    MagicAES.ObjcDraw (tree, but, 1, r);
  END;
  mtUtils.ExclState (tree, but, MagicAES.SELECTED);
  mtUtils.CalcArea (tree, but, r); 
  MagicAES.ObjcDraw (tree, but, 1, r);
  IF but = Pathok
  THEN
    getEdits();                         (* editables holen *)
    (* Strings bernehmen *)
    MagicStrings.Assign (newPath, path);
    MagicStrings.Append ('CAT.INF', path);
    IF mtTextfiles.OpenTextfile (path, mtTextfiles.WRITE, 512, tf)
    THEN
      getEdits();                                                                (* editable Strings holen *)
      IF LENGTH(txtArray^[1]) > 0
      THEN
        mtDir.SplitPath(txtArray^[1], path, name, suff);
        mtTextfiles.WriteConst (tf, path); mtTextfiles.WriteLn(tf);                (* Arc-Path *)
        mtTextfiles.WriteConst (tf, name); mtTextfiles.WriteLn(tf);                (* Arc-Name *)
      ELSE
        mtTextfiles.WriteLn (tf);
        mtTextfiles.WriteLn (tf);
      END;
      translateOut (txtArray^[2], str); 
      mtTextfiles.WriteConst (tf, str); mtTextfiles.WriteLn(tf);                 (* arc-Command *)
      translateOut (txtArray^[3], str);
      mtTextfiles.WriteConst (tf, str); mtTextfiles.WriteLn(tf);                 (* dearc-Command *)
      mtTextfiles.WriteConst (tf, txtArray^[5]); mtTextfiles.WriteLn(tf);        (* Outfile name *)
      mtTextfiles.WriteLn(tf);          (* not supported from dialog *)
      mtTextfiles.WriteLn(tf);          (* not supported from dialog *)
      mtTextfiles.WriteConst (tf, txtArray^[7]); mtTextfiles.WriteLn(tf);        (* Messagepath *)
      mtTextfiles.WriteConst (tf, txtArray^[4]); mtTextfiles.WriteLn(tf);        (* Importpath *)
      mtTextfiles.WriteConst (tf, txtArray^[6]); mtTextfiles.WriteLn(tf);        (* Exportpath *)
      mtTextfiles.WriteConst (tf, txtArray^[8]); mtTextfiles.WriteLn(tf);        (* Databasepath *)
      mtDir.SplitPath(txtArray^[9], path, name, suff);
      mtTextfiles.WriteConst (tf, path); mtTextfiles.WriteLn(tf);                (* TerminalPath *)
      mtTextfiles.WriteConst (tf, name); mtTextfiles.WriteLn(tf);                (* TerminalName *)
      translateOut (txtArray^[10], str);
      mtTextfiles.WriteConst (tf, str); mtTextfiles.WriteLn(tf);                 (* Terminalcommand *)
      mtTextfiles.CloseTextfile (tf);
    ELSE
      InfoAlert ("[3][Install:|", name, "|konnte nicht geschrieben|werden.][Abbruch]");
    END;
    
    MagicStrings.Assign (txtArray^[8], newDataPath);
    
  END;
  DEALLOCATE (titles, 0);
  DEALLOCATE (txtArray, 0);
  MagicAES.FormDial(MagicAES.FMDFINISH, or, or);
END doConfig;
  
PROCEDURE GetAndCreatePath (VAR path, name : ARRAY OF CHAR; 
                            REF title: ARRAY OF CHAR): BOOLEAN;
VAR
      gName   : FileStr;
      oDta: ADDRESS;
      dta : MagicDOS.DTA;
      res : INTEGER;
  
BEGIN
  name [0] := '';
  v.bool := FselGet (path, name, '*.*', title, TRUE);
  IF ~v.bool THEN RETURN FALSE END;
  IF name[0] # ''
  THEN
    oDta := MagicDOS.Fgetdta ();
    MagicDOS.Fsetdta (ADR(dta));
    (* Testen, ob es ein Dateiname oder Pfadname ist,
     * ggf. nachfragen und ggf. Pfad anlegen 
     *)
    Concat (path, name, gName, v.bool);
    res := MagicDOS.Fsfirst (gName, {4});
    MagicDOS.Fsetdta (oDta); 
    IF (res = 0) & (dta.dAttrib = SHORT(INTEGER({4})))
    THEN
      (* Name ist ein Ordnername *)
      (* Nachfragen! *)
      IF MagicAES.FormAlert (1,'[2][Install:|Du hast noch einen|Ordnernamen im Namen angegeben.|Soll CAT in diesem Pfad installiert|werden oder im ausgewhlten Pfad?][Auswahl|Name]') = 2
      THEN
        MagicStrings.Append (name, path);
        MagicStrings.Append ('\', path);
        name[0] := '';
      END;
    ELSIF (res = 0)
    THEN
      (* Nur Dateiname, ignorieren *)
    ELSE
      (* Kein Name, also neuer Ordnername! *)
      res := MagicDOS.Dcreate (gName);
      IF res # 0 
      THEN
        info ('[3][Ordner konnte nicht|angelegt werden!][Abbruch]');
        RETURN FALSE;
      END;
      MagicStrings.Append (name, path);
      MagicStrings.Append ('\', path);
      name[0] := '';
    END;
  END;
  RETURN TRUE;
END GetAndCreatePath;

BEGIN
  WindGet (0, WFWORKXYWH, deskSize);
END InstRsc.
