DEFINITION MODULE IoFilter;

IMPORT CatTypes;

TYPE   ioFilterStruct   = RECORD
                            progName: CatTypes.String255;
                            inCmd   : CatTypes.String255;
                            outCmd  : CatTypes.String255;
                            filtName: ARRAY [0..25] OF CHAR;
                            activ   : BOOLEAN;
                            stopAtErr: BOOLEAN;
                            forMsg  : BOOLEAN;  (* Default: FALSE *)
                            forInfile   : BOOLEAN;
                            forOutfile  : BOOLEAN;
                            pastOutfile : BOOLEAN;
                          END;


PROCEDURE ReadFilter (VAR filter: ioFilterStruct; num: INTEGER);
(* Liest die Daten zu Filter num aus den Configvaraiblen 
 * aus
 *)

PROCEDURE IoFilterMessage(VAR isError: BOOLEAN): BOOLEAN;
(* Ruft die definierten Filter auf, die vor dem erstellen von 
 * Infile.txt benutzt werden sollen
 * TRUE: Es wurde mindestens ein Filter aufgerufen
 *)

PROCEDURE IoFilterInfile(): BOOLEAN;
(* Ruft die definierten Filter auf, die auf dem Infile arbeiten
 * TRUE: Alles ohne Probleme abgelaufen.
 * FALSE: Erstellung des Infiles abbrechen
 *)

PROCEDURE IoFilterOutfile(): BOOLEAN;
(* Ruft die definierten Filter auf, die auf dem Outfile arbeiten
 * TRUE: Alles ohne Probleme abgelaufen.
 * FALSE: Einfgen des Outfiles abbrechen
 *)

PROCEDURE IoFilterPastOutfile();
(* Ruft die definierten Filter auf, die nach dem Einfgen arbeiten
 *)

END IoFilter.
