DEFINITION MODULE ListHelp;

(*==============================================================*
 * Modul:               Modul zur Verwaltung der Abrufboxen     *
 * Autor:               Dirk Steins, Jo Gttker-Schnetmann      *
 * erstellt am:         10.04.1992                              *
 * letzte nderung am:  10.04.1992                              *
 * Version:             1.0                                     *
 * Interne Version:     V#0001                                  *
 *==============================================================*

 *----------------------------------------------------------------------------
 * Datum    Vers. Autor  nderung (Arbeitsbericht)                            
 *----------------------------------------------------------------------------
 *----------------------------------------------------------------------------
 *)

(* Nach der endgltigen Umstellung knnen die Prozeduren SelectGroup und *)
(* SelectName aus Cat endgltig verschwinden                             *)

FROM SYSTEM IMPORT ADDRESS;

TYPE groupSelectMode = (gsmReadBegin, gsmReadNew, gsmReadUnread, gsmReadLastPos, gsmReadDate, 
                        gsmReadId, gsmWrite, gsmUser, gsmGroupCom, gsmModify, gsmOther,
                        gsmChief);

(* Hilfsprozeduren, die bei den Listdialogen benutzt werden *)

PROCEDURE nextEntry ( l : ADDRESS) : ADDRESS;

PROCEDURE prevEntry ( l : ADDRESS) : ADDRESS;

PROCEDURE resetList (l : ADDRESS);

(* Die eigentlichen Nutzprozeduren *)

PROCEDURE SetLastGroup (REF name : ARRAY OF CHAR);
(* Setzt den Gruppennamen, der beim nchsten Aufruf in der 
 * Gruppenbox angezeigt wird
 *)

PROCEDURE SelectGroup (VAR gruppe : ARRAY OF CHAR; VAR Nr: CARDINAL;
                           nG     : BOOLEAN; clearEdit: BOOLEAN;
                           forSearch: BOOLEAN; mode: groupSelectMode):BOOLEAN;

PROCEDURE SelectName(VAR Name : ARRAY OF CHAR):BOOLEAN;

PROCEDURE NewNameEntry (name, info : ARRAY OF CHAR);
(* Fgt einen Namen in die ADR.INF ein oder ndert einen 
 * vorhandenen. Speichert auch ab!
 *)

PROCEDURE Init(gruppen, adr : ADDRESS);
(* Objektbume fr die Gruppenauswahl- und die Adressenauswahlbox *)

END ListHelp.
