IMPLEMENTATION MODULE ListUtils;

(*$R-, S-, M-, J+, Z+ *)

FROM SYSTEM     IMPORT ADDRESS, LONGWORD;

FROM BinOps     IMPORT LowerInt, HigherInt;

FROM MagicAES   IMPORT SELECTED, Vertical, GrafDragbox, SHADOWED, ObjcDraw;

FROM mtUtils    IMPORT tRect, tObjcTree, SetObjcString, ObjcPos, ObjcFrame, 
                       InclState, ExclState, InclFlag, ExclFlag, CalcArea,
                       SetObjcRect, ObjcStrLen, ObjcRect,
                       ObjcArea;

PROCEDURE WordArray (VAR r1, r2 : tRect) : TwoRects;
  VAR two : TwoRects;
      i   : INTEGER;
BEGIN
  two[0] := r1;
  two[1] := r2;
  FOR i := 0 TO 1 DO
    WITH two[i] DO
      w := x+w-1;
      h := y+h-1;
    END;
  END;
  RETURN two
END WordArray;

PROCEDURE FrameRects (r1, r2: tRect): tRect;

  VAR   r: tRect;
  
  BEGIN
    WITH r DO
      IF r1.x > r2.x THEN x := r2.x ELSE x := r1.x END;
      IF r1.y > r2.y THEN y := r2.y ELSE y := r1.y END;
      r1.w := r1.x + r1.w;
      r2.w := r2.x + r2.w;
      IF r1.w < r2.w THEN w := r2.w - x ELSE w := r1.w - x END;
      r1.h := r1.y + r1.h;
      r2.h := r2.y + r2.h;
      IF r1.h < r2.h THEN h := r2.h - y ELSE h := r1.h - y END;
    END;
    
    RETURN r
  END FrameRects;
  
  PROCEDURE DiffVertRect (r1, r2 : tRect) : tRect;
   (* liefert das Rechteck aus r1, das nicht von r2 berdeckt wird 
    *)
   VAR r : tRect;
  BEGIN
    r := r1;
    r.h := r1.y + r1.h-1;
    (* Hhe auf absolute Koordinate *)
    WITH r DO
      IF (r2.y < r1.y) & (r2.y+r2.h >= r1.y)
      THEN
        r.y := r2.y + r2.h-1;
      END;
      IF (r1.y < r2.y) & (r1.y+r1.h > r2.y)
      THEN
        r.h := r2.y;
      END;
    END;
    (* Hhe wieder auf relative Koordinate *)
    r.h := r.h - r.y+1;
    (* Jetzt das gleiche fr die X-Richtung *)
    r.w := r1.x + r1.w-1;
    (* Breite auf absolute Koordinate *)
    WITH r DO
      IF (r2.x < r1.x) & (r2.x+r2.w >= r1.x)
      THEN
        r.x := r2.x + r2.w-1;
      END;
      IF (r1.x < r2.x) & (r1.x+r1.w > r2.x)
      THEN
        r.w := r2.x;
      END;
    END;
    (* Breite wieder auf relative Koordinate *)
    r.w := r.w - r.x+1;
    RETURN r
  END DiffVertRect;
  
  PROCEDURE CalcAbsArea (tree : ADDRESS; obj: INTEGER; VAR r : tRect);
  VAR ob, border: INTEGER;
      dial:  tObjcTree;
  BEGIN
   dial:= tree;
   border:= ObjcFrame (tree, obj);
   ObjcArea (tree, obj, r);
   IF border < 0 THEN (* Rahmen ausserhalb des Objekts! *)
    border:= ABS (border);
    DEC (r.x, border);
    DEC (r.y, border);
    INC (r.w, border * 2);
    INC (r.h, border * 2);
   END;
   IF (SHADOWED IN dial^[obj].obState) THEN
    INC (r.w, border * 2);  INC (r.h, border * 2);
   END;
  END CalcAbsArea;

(* slider Routinen *)

PROCEDURE formSetSlider (dial: ADDRESS;
                         parent, slider : INTEGER;
                         dir : INTEGER;
                         maxVal, currentVal : LONGINT;
                         draw : BOOLEAN);
VAR   (*$Reg *) newPos  : CARDINAL;
      pFrame,
      sFrame,
      dummy  : tRect;
      (*$Reg *) faktor  : INTEGER;
      (*$Reg *) Epp     : LONGINT;
BEGIN
  ObjcRect (dial, parent, pFrame);
  ObjcRect (dial, slider, sFrame);
  CalcAbsArea (dial, slider, dummy);
        
  IF dir = Vertical
  THEN
    IF pFrame.h = sFrame.h THEN (* volle Hhe *) RETURN END;
    (* Wert 1000*(Eintrge/Pixel) *)
    Epp := ((maxVal*1000) DIV LONG(pFrame.h-sFrame.h));
    WITH sFrame DO
      y := SHORT((currentVal*1000L) DIV Epp);
      IF y+h >= pFrame.h THEN y := pFrame.h-h END;
      IF y<0 THEN y := 0 END;
    END;
  ELSE
    IF pFrame.w = sFrame.w THEN (* volle Breite *) RETURN END;
    Epp := ((maxVal*1000) DIV LONG(pFrame.w-sFrame.w));
    WITH sFrame DO
      x := SHORT((currentVal*1000L) DIV Epp);
      IF x+w >= pFrame.w THEN x := pFrame.w-w END;
      IF x<0 THEN x := 0 END;
    END;
  END;

  SetObjcRect (dial, slider, sFrame);
  CalcAbsArea (dial, slider, sFrame);
  IF draw THEN
    dummy := DiffVertRect (dummy, sFrame);
    ObjcDraw (dial, parent, 0, dummy);
    ObjcDraw (dial, slider, 0, sFrame);
  END;
END formSetSlider;

END ListUtils.
