DEFINITION MODULE MsgWindow;

FROM SYSTEM IMPORT ADDRESS;

IMPORT Messages;

PROCEDURE msgOpen (errorMsg: BOOLEAN);
(* Bringt das Fenster mit der Nachrichtenbersicht 
 * in den Vordergrund bzw. ffnet es, falls noch nicht 
 * offen. Die Nachricht mu dann im Fenster ausgewhlt 
 * werden.
 *)

PROCEDURE msgClose (wdw : INTEGER);
(* Schliet das Fenster mit der Nachrichtenbersicht wieder
 *)

PROCEDURE msgWindowTop (wdw : INTEGER) : BOOLEAN;
(* Gibt zurck, ob das Fenster mit der bersicht oben ist
 *)

PROCEDURE msgSetFont (wdw: INTEGER; font, fontSize : INTEGER);
(* Setzt den Font fr die bersicht 
 *)

PROCEDURE msgSelectAll (wdw: INTEGER);
(* Selektiert alle Nachrichten in der Nachrichtenliste 
 *) 

PROCEDURE msgSavePos();
(* Sichert die Position des Messagefensters und der 
 * zugehrigen Editoren 
 *)

PROCEDURE msgRestorePos ();
(* Restauriert die Positionen des Messagefensters 
 * und der zugehrigen Editoren 
 *)

PROCEDURE msgUpdateInfo ();
(* Die MSGINFO.DAT wird neu eingelesen. 
 *)

PROCEDURE msgCloseAll (force : BOOLEAN): BOOLEAN;
(* Schliet das bersichtsfenster und alle dazugehrigen 
 * Editorfenster. Nur wichtig, falls die Positionen 
 * gesichert und restauriert werden sollen.
 *)

PROCEDURE changeHdr (VAR message : Messages.msgInfo): BOOLEAN;
(* Ruft den Dialog auf, um den Nachrichtenheader zu ndern. 
 * TRUE: Daten gendert
 *)

PROCEDURE MsgSetList (list: ADDRESS; doRedrawWdw: BOOLEAN);
(* Setzt die Liste fr das Fenster
 *)

PROCEDURE MsgSetMaxPos (maxPos : INTEGER; doRedrawWdw: BOOLEAN);
(* Setzt die Maximalposition fr die Liste
 *)

PROCEDURE MsgCloseIfOpen ();
(* Schliet das Fenster, falls es offen ist
 *)

PROCEDURE MsgUpdateButtons ();
(* Aktualisiert die Buttons im Anzeigefenster passend zur Selektion 
 *)

PROCEDURE MsgRedrawEntry (idx: INTEGER);
(* Erzwingt das Neuzeichnen des Eintrags mit der Nummer idx 
 * im Fenster
 *)

PROCEDURE MsgDeselectAll ();
(* Setzt den Selectindex auf -1 und erzwingt ggf. einen Redraw
 *)

PROCEDURE InitMessageManager ();
(* Initialisiert das Modul und einige wichtige Daten
 * Ruft intern auch die Initialisierung vom Modul Messages auf
 *)
 
END MsgWindow.
