IMPLEMENTATION MODULE MsgWindow;

FROM SYSTEM     IMPORT  TSIZE, ADDRESS, ADR, CALLSYS, CADR, BYTE, ASSEMBLER;


(* MM2-Module *)
IMPORT Block, Strings, StrConv, GrafBase, BinOps, MOSGlobals,
       Keyboard;
FROM Keyboard  IMPORT SpecialCode;
FROM Storage    IMPORT ALLOCATE, DEALLOCATE;


(* Magic-Module *)
IMPORT MagicAES, MagicVDI, MagicDOS, MagicFSM, mtTextfiles, mtAlerts, mtAppl,
       mtUtils, mtDials, mtPopups, MagicXBIOS;
FROM MagicSys   IMPORT Bit0, Bit1, Bit2, Bit3, Bit4, Bit5, Bit6, Bit7,
                       Bit8, Bit9, Bit10, Bit11, Bit12, Bit13, Bit14, Bit15;


(* CAT-Module *)
IMPORT ARCStarter, CatFiles, CatTypes, MTE, MTEdit2, 
       CatEdit, FontSelect, WdwManager, VDIStandards, VDIUtil, ConfVars,
       CatGlobal, EditTypes, MausTauschrsc, grinTools, ListHelp,
       grin, data, dataSys, QuickSort, Varnames, Infofiles, RectFuncs,
       GroupSelect, WinDials, CatHelp;

FROM CatGlobal   IMPORT OpenName;
FROM MTPaths     IMPORT MessagePath, DataPath, ExportPath, ImportPath, ARCName;
IMPORT ConvertDate;
FROM UserInformation IMPORT UserBLK, batchProcess;
FROM Void        IMPORT v;

IMPORT Messages;
FROM Messages   IMPORT MessageType;

CONST msgWindowTitle0   = '[CAT] '+0C;
      msgWindowTitle    = 'Nachrichtenauswahl'+0C;
      msgGroup          = 'Gruppe:'+0C;
      msgAn             = 'An:'+0C;
      msgWegen          = 'Wegen:'+0C;
      msgNummer         = 'Nummer:'+0C;
      msgSend           = 'Status: Versenden'+0C;
      msgKlemm          = 'Status: Zurckhalten'+0C;
      msgSize           = 'Gre:'+0C;
      msgBytes          = 'Bytes'+0C;
      msgDate           = 'Datum:'+0C;
      msgCopy           = 'Kopie'+0C;
      msgForward        = 'Weiterleitung'+0C;
      msgGrpComm        = 'Gruppenkommentar'+0C;
      msgComm           = 'Kommentar'+0C;
      msgMail           = 'Nachricht'+0C;
      msgAnswer         = 'Antwort'+0C;
      msgPersAnswer     = 'Privatkommentar'+0C;
      msgPrivate        = 'Persnliche'+0C;

      msgNoHdrText      = 'HDR-Datei konnte nicht gelesen werden! Nachrichten bitte '+0C;
      msgNoHdrText2     = 'immer nur ber dieses Modul lschen, sonst gibt es diesen Fehler!'+0C;


TYPE
  msgWindowType = RECORD
                    wdw         : INTEGER;      (* Windowhandle *)
                    vdi         : INTEGER;      (* VDI-Handle   *)
                    butWork,
                    msgWork     : GrafBase.Rectangle; (* Workrectangle des Fensters *)
                    isHidden    : BOOLEAN;
                    list        : Messages.msgArrayPtr;
                    sel         : INTEGER;      (* Nummer des zuletzt selektierten Eintrags *)
                    windLines   : INTEGER;      (* Anzahl der Zeilen im Fenster *)
                    number      : INTEGER;      (* Nummer des Fensters im Modul *)
                    font, 
                    fontSize    : INTEGER;      (* Font & Gre *)
                    startPos    : INTEGER;      (* aktuelle Top-Position *)
                    leftOffset  : INTEGER;
                    maxPos      : INTEGER;      (* = messages *)
                    maxWidth    : INTEGER;
                    charHeight,                 (* Zeichensatzvariablen *)
                    charWidth   : INTEGER;
                    isFSM       : BOOLEAN;
                    monoSpaced  : BOOLEAN;
                  END;

     msgWdwPtr = POINTER TO msgWindowType;

TYPE        
        Trick =  POINTER TO RECORD
                   CASE : BOOLEAN OF
                     TRUE : wert: INTEGER;|
                     FALSE: hi: CHAR;
                            lo: CHAR;|
                   END;
                 END;


VAR 
        lineDist        : INTEGER;
        pixOffset       : INTEGER;
        
        msgWindow       : msgWindowType;

        distSel  : mtUtils.tObjcTree;
        butBox   : mtUtils.tObjcTree;
        
        inOpen   : BOOLEAN;     (* Semaphore fr snapWdw *)
        init     : INTEGER;

(*=========================================================================*)
(* Hier kommen jetzt die Prozeduren zur Verwaltung des Messagefensters     *)
(*=========================================================================*)

(* ---------------------- Font-Funktionen ----------------------- *)
PROCEDURE iMsgSetFont (wdw : INTEGER; fnt, fntSize : INTEGER; redraw: BOOLEAN);
(* Setzt den Font fr das Stichwortlistenfenster *)
  VAR r : GrafBase.Rectangle;
BEGIN
  IF wdw = msgWindow.wdw
  THEN
    WITH msgWindow DO
      font := fnt;
      fontSize := fntSize;
      FontSelect.SetFont (vdi, font, fontSize, FALSE, monoSpaced, isFSM, charWidth, charHeight);
      (* Jetzt ist der Font gesetzt. Jetzt noch Window snappen und dann neu
       * zeichnen lassen 
       *)
      maxWidth := 0;
      v.bool := ConfVars.SetConfigInt (cfgFont, font);
      v.bool := ConfVars.SetConfigInt (cfgFontSize, fontSize);
      WdwManager.SetDocumentParms (wdw, 1, 2*charHeight+lineDist);
      WdwManager.GetWdwSize (wdw, r);
      WdwManager.SetWdwSize (wdw, r);
      r := msgWork;
      INC (r.x, pixOffset);
      IF redraw THEN 
        IF ~isHidden THEN WdwManager.RedrawWdw (wdw, r); END;
        WdwManager.SetWdwDocument (wdw, GrafBase.LongRect{LONG(leftOffset), startPos, LONG(maxWidth), maxPos});
      END;
    END; (* WITH ed^ DO *)
  END;
END iMsgSetFont;

(*-------------- Selektion von Eintrgen ----------------------*)
PROCEDURE hasSelectedEntries (ptr : msgWdwPtr; VAR first : INTEGER): BOOLEAN;
  VAR i : INTEGER;
BEGIN
  WITH ptr^ DO
    FOR i := 0 TO maxPos DO
      IF list^[i].selected THEN first := i; RETURN TRUE
      END;
    END;
  END;
  RETURN FALSE;
END hasSelectedEntries;

PROCEDURE countSelectedEntries (ptr : msgWdwPtr) : CARDINAL;
  VAR i : INTEGER;
      (*$Reg *) counter : CARDINAL;
BEGIN
  WITH ptr^ DO
    counter := 0;
    FOR i := 0 TO maxPos DO
      IF list^[i].selected THEN INC (counter)
      END;
    END;
  END;
  RETURN counter;
END countSelectedEntries;

PROCEDURE redrawEntry (entry: INTEGER);
  VAR rect : GrafBase.Rectangle;
BEGIN
  WITH msgWindow DO
    IF (wdw < 0) OR isHidden THEN RETURN END;
    IF entry > maxPos THEN RETURN END;
    rect := msgWork;
    INC (rect.x, pixOffset);
    rect.y := rect.y + (entry - startPos) * (2*charHeight+lineDist);
    rect.h := 2*charHeight + lineDist;
    WdwManager.RedrawWdw (wdw, rect);
  END;
END redrawEntry;

PROCEDURE toggleEntry (ptr : msgWdwPtr; entry: INTEGER);
  VAR rect : GrafBase.Rectangle;
BEGIN
  WITH ptr^ DO
    IF (entry > maxPos) OR (entry < 0) THEN RETURN END;
    list^[entry].selected := ~list^[entry].selected;
    redrawEntry (entry);
  END;
END toggleEntry;

PROCEDURE deselectEntries (ptr : msgWdwPtr);
  VAR i         : INTEGER;
      rect      : GrafBase.Rectangle;
      first     : BOOLEAN;
BEGIN
  WITH ptr^ DO
    rect := msgWork;
    INC (rect.x, pixOffset);
    first := TRUE;
    rect.h := 2*charHeight + lineDist;
    FOR i := 0 TO maxPos DO
      IF list^[i].selected
      THEN
        list^[i].selected := FALSE;
        IF (i >= startPos) & (i <= startPos + windLines)
        THEN 
          (* redraw *)
          IF first THEN 
            rect.y := msgWork.y + (i - startPos) * (2*charHeight+lineDist);
            first := FALSE
          ELSE
            rect.h := msgWork.y + (i - startPos + 1) * (2*charHeight+lineDist) - rect.y;
          END;
        END;
      END;
    END;
    IF ~first THEN WdwManager.RedrawWdw (wdw, rect) END;;
  END;
END deselectEntries;

(*-------------- Funktionen fr WdwManager --------------------*)
PROCEDURE AdjustTreePos (r: GrafBase.Rectangle; VAR rt : GrafBase.Rectangle);
BEGIN
  WITH butBox^[0] DO
    obX := r.x;
    obY := r.y;
    obWidth := r.w;
    rt.x := obX; rt.y := obY;
    rt.w := obWidth; rt.h := obHeight+1;
  END;
END AdjustTreePos;

PROCEDURE rawRedraw (ptr : msgWdwPtr; clip : GrafBase.Rectangle);
  (* Geht davon aus, da RectFuncs.ClipRect gesetzt ist und nur Zeilen zu zeichnen sind! 
   *)
  
VAR 
    extend : ARRAY [0..3] OF GrafBase.Point;
    i      : INTEGER;
    width  : INTEGER;
    xOutput, 
    yOutput: INTEGER;
    xOffset: INTEGER;
    j      : INTEGER;
    topLine: INTEGER;
    tmpStr : CatTypes.String255;
    msgName: CatTypes.String255;
    msg    : Messages.msgInfo;
    myClip : GrafBase.Rectangle;
    fill   : GrafBase.Rectangle;
    attrSet: BOOLEAN;
    isStatus: BOOLEAN;
    dt      : ConvertDate.Date;
    ti      : ConvertDate.Time;
    holdEff : BITSET;
BEGIN
  WITH ptr^ DO
    topLine := startPos;
    attrSet := FALSE;
    i := 0;   (* Zeilenzhler im Fenster *)
    (* Nicht im Redrawbereich liegende Zeilen berspringen *)
    WHILE (topLine <= maxPos) & ((msgWork.y + (i+1)*(2*charHeight+lineDist)) - 1 < clip.y) DO
      INC (topLine);
      INC(i);
    END;
    xOutput := msgWork.x + pixOffset - leftOffset;
    yOutput := msgWork.y + i * (2*charHeight + lineDist) + (lineDist DIV 2) + charHeight-1;
    (* Eintrag in Liste suchen *)
    (* Jetzt zeichnen *)
    myClip := clip;
    v.int := MagicVDI.SetFillcolor (vdi, MagicAES.BLACK);
    v.int := MagicVDI.SetTextcolor (vdi, CatGlobal.msgTextCol);
    v.int := MagicVDI.SetWritemode (vdi, MagicVDI.TRANSPARENT);
    WHILE (topLine <= maxPos) & (i <= msgWork.h DIV (2*charHeight+lineDist)) 
          & (yOutput <= clip.h + charHeight-1) DO
      msg := list^[topLine];
      IF ~msg.hdrRead
      THEN
        Messages.ReadHdrInfo (msg, TRUE);
        list^[topLine] := msg;
      END;
      IF msg.hdrRead
      THEN
        (* 1. Zeile: MSG001   An/Gruppe: <empfnger/gruppenname>
         * 2. Zeile: status   Wegen: 
         *)
        IF ~msg.sendMsg
        THEN
          IF mtAppl.Bitplanes > 1
          THEN
            v.int := MagicVDI.SetTextcolor (vdi, CatGlobal.msgHoldCol);
          ELSE
            CASE CatGlobal.msgHoldEff OF
              0 : holdEff := {}; |
              1 : holdEff := {MagicVDI.Fat}; |
              2 : holdEff := {MagicVDI.Italic}; |
              3 : holdEff := {MagicVDI.Light}; |
            ELSE
              holdEff := {};
            END;
            IF msg.toDelete 
            THEN
              INCL (holdEff, MagicVDI.Italic);
            END;
            v.bset := MagicVDI.SetTexteffect (vdi, holdEff);
          END;
        ELSIF msg.toDelete 
        THEN
          v.bset := MagicVDI.SetTexteffect (vdi, {MagicVDI.Italic});
        END;
        (* Jetzt die einzelnen Zeilenteile ausgeben *)
        xOffset := 0;
        Messages.Number2Name (msg.number, msgName);
        VDIStandards.Text (isFSM, vdi, xOutput+xOffset, yOutput, msgName);
        INC (xOffset, 8*charWidth); 
        CASE msg.msgType OF
          copyOwn, 
          copyOther    : Strings.Assign (msgCopy, msgName, v.bool); |
          forward      : Strings.Assign (msgForward, msgName, v.bool); |
          groupcomment : Strings.Assign (msgGrpComm, msgName, v.bool); |
          comment      : Strings.Assign (msgComm, msgName, v.bool); |
          mail         : Strings.Assign (msgMail, msgName, v.bool); |
          persanswer   : Strings.Assign (msgPersAnswer, msgName, v.bool); |
          answer       : Strings.Assign (msgAnswer, msgName, v.bool); |
          private      : Strings.Assign (msgPrivate, msgName, v.bool); |
        ELSE
        END;
        isStatus := (msg.msgType = copyOther) OR (msg.msgType = copyOwn) 
                    OR (msg.msgType = forward);
        VDIStandards.Text (isFSM, vdi, xOutput+xOffset, yOutput, msgName);
        INC (xOffset, 18*charWidth);
        IF (msg.msgType = mail) OR (msg.msgType = comment) OR (msg.msgType = groupcomment)
        THEN
          VDIStandards.Text (isFSM, vdi, xOutput+xOffset, yOutput, Messages.msgDistr);
          INC (xOffset, 8*charWidth);
          VDIStandards.Text (isFSM, vdi, xOutput+xOffset, yOutput, Messages.msgDistribs [msg.dist]);
          (*
          CASE msg.dist OF 
            dNone     : VDIStandards.Text (isFSM, vdi, xOutput+xOffset, yOutput, msgDNone); |
            dLokal    : VDIStandards.Text (isFSM, vdi, xOutput+xOffset, yOutput, msgDLokal) |
            dMausNet  : VDIStandards.Text (isFSM, vdi, xOutput+xOffset, yOutput, msgDMausNet) |
            dNet      : VDIStandards.Text (isFSM, vdi, xOutput+xOffset, yOutput, msgDNet) |
          ELSE
          END;
          *)
          INC (xOffset, 10*charWidth);
        ELSE
          INC (xOffset, 18*charWidth);
        END;
        IF msg.sendMsg
        THEN
          VDIStandards.Text (isFSM, vdi, xOutput+xOffset, yOutput, msgSend);
        ELSE
          VDIStandards.Text (isFSM, vdi, xOutput+xOffset, yOutput, msgKlemm);
        END;
        INC (xOffset, INTEGER(LENGTH (msgKlemm)+2) * charWidth);
        IF ~isStatus
        THEN
          VDIStandards.Text (isFSM, vdi, xOutput+xOffset, yOutput, msgSize);
          INC (xOffset, INTEGER(LENGTH (msgSize)+1) * charWidth);
          Strings.Assign (StrConv.LNumToStr (msg.size, 10, 0, ' '), msgName, v.bool);
          VDIStandards.Text (isFSM, vdi, xOutput+xOffset, yOutput, msgName);
          INC (xOffset, INTEGER(LENGTH (msgName)+1) * charWidth);
          VDIStandards.Text (isFSM, vdi, xOutput+xOffset, yOutput, msgBytes);
          INC (xOffset, INTEGER(LENGTH (msgBytes)+2) * charWidth);
        END;
        (* Jetzt noch Datum und Uhrzeit *)
        VDIStandards.Text (isFSM, vdi, xOutput + xOffset, yOutput, msgDate);
        INC (xOffset, INTEGER(LENGTH (msgDate)) * charWidth);
        (* Datum und Zeit in String setzen *)
        dt := ConvertDate.UnpackDate (msg.cDate);
        ti := ConvertDate.UnpackTime (msg.cTime);
        ConvertDate.DayToText (dt, 'GG, ', msgName);
        ConvertDate.DateToText (dt, 'dd. GGG YYYY, ', tmpStr);
        Strings.Append (tmpStr, msgName, v.bool);
        ConvertDate.TimeToText (ti, 'HH:MM:SS Uhr', tmpStr);
        Strings.Append (tmpStr, msgName, v.bool);
        VDIStandards.Text (isFSM, vdi, xOutput + xOffset, yOutput, msgName);
        INC (xOffset, INTEGER(LENGTH (msgName)+1) * charWidth);
        width := xOffset;
        
        (* Zweite Zeile: 
         * Gruppe/Empfnger und dann Stichwort
         *)
        xOffset := charWidth;
        IF (msg.msgType = comment) OR (msg.msgType = mail) OR (msg.msgType = groupcomment)
        THEN
          VDIStandards.Text (isFSM, vdi, xOutput+xOffset, yOutput+charHeight, msgGroup);
          INC (xOffset, 8*charWidth);
          VDIStandards.Text (isFSM, vdi, xOutput+xOffset, yOutput+charHeight, msg.group^);
          INC (xOffset, INTEGER(LENGTH (msg.group^)+2)*charWidth);
        ELSE
          VDIStandards.Text (isFSM, vdi, xOutput+xOffset, yOutput+charHeight, msgAn);
          INC (xOffset, 4*charWidth);
          VDIStandards.Text (isFSM, vdi, xOutput+xOffset, yOutput+charHeight, msg.receiver^);
          INC (xOffset, INTEGER(LENGTH (msg.receiver^)+2)*charWidth);
        END;
        xOffset := BinOps.HigherInt (xOffset, 26*charWidth);
        VDIStandards.Text (isFSM, vdi, xOutput+xOffset, yOutput+charHeight, msgWegen);
        INC (xOffset, 7*charWidth);
        IF msg.topic # NIL
        THEN
          VDIStandards.Text (isFSM, vdi, xOutput+xOffset, yOutput+charHeight, msg.topic^);
          INC (xOffset, INTEGER(LENGTH (msg.topic^) + 1) * charWidth);
        END;
        width := BinOps.HigherInt (width, xOffset);
        maxWidth := BinOps.HigherInt (maxWidth, width+pixOffset);
        IF msg.selected
        THEN
          fill.x := xOutput;
          fill.y := yOutput - charHeight+1;
          fill.w := xOutput + maxWidth - 1;
          fill.h := yOutput + charHeight ;
          (* Schreibmodus setzen *)
          v.int := MagicVDI.SetWritemode (vdi, MagicVDI.XOR);
          MagicVDI.FillRectangle(vdi, fill);
          v.int := MagicVDI.SetWritemode (vdi, MagicVDI.TRANSPARENT);
        END;
        IF ~msg.sendMsg
        THEN
          IF mtAppl.Bitplanes > 1
          THEN
            v.int := MagicVDI.SetTextcolor (vdi, CatGlobal.msgTextCol);
          ELSE
            v.bset := MagicVDI.SetTexteffect (vdi, {});
          END;
        ELSIF msg.toDelete 
        THEN
          v.bset := MagicVDI.SetTexteffect (vdi, {});
        END;
      ELSE
        (* Header konnte nicht gelesen werden! Name ausgeben und 
         * dahinter Fehlermeldung 
         *)
        (* Jetzt die einzelnen Zeilenteile ausgeben *)
        xOffset := 0;
        Messages.Number2Name (msg.number, msgName);
        VDIStandards.Text (isFSM, vdi, xOutput+xOffset, yOutput, msgName);
        INC (xOffset, 8*charWidth); 
        VDIStandards.Text (isFSM, vdi, xOutput+xOffset, yOutput, msgNoHdrText);
        VDIStandards.Text (isFSM, vdi, xOutput+xOffset, yOutput+charHeight, msgNoHdrText2);
        INC (xOffset, BinOps.HigherInt (INTEGER(LENGTH (msgNoHdrText)+1) * charWidth, INTEGER(LENGTH (msgNoHdrText2)+1) * charWidth));
        width := xOffset;
        maxWidth := BinOps.HigherInt (maxWidth, width+pixOffset);
        IF msg.selected
        THEN
          fill.x := xOutput;
          fill.y := yOutput - charHeight+1;
          fill.w := xOutput + maxWidth - 1;
          fill.h := yOutput + charHeight ;
          (* Schreibmodus setzen *)
          v.int := MagicVDI.SetWritemode (vdi, MagicVDI.XOR);
          MagicVDI.FillRectangle(vdi, fill);
          v.int := MagicVDI.SetWritemode (vdi, MagicVDI.TRANSPARENT);
        END;
      END;
      INC(i);
      INC (topLine);
      INC (yOutput, 2*charHeight+lineDist);
    END;
    v.int := MagicVDI.SetWritemode (vdi, MagicVDI.REPLACE);
    v.int := MagicVDI.SetFillcolor (vdi, CatGlobal.msgBackCol);
  END (* WITH ptr *);
END rawRedraw;

PROCEDURE drawMsgWdw (wdw, vdiH : INTEGER; special : ADDRESS; frame : GrafBase.Rectangle);
VAR clip : GrafBase.Rectangle;
    ptr  : msgWdwPtr;
    oldMax : INTEGER;
BEGIN
  ptr := msgWdwPtr (special);
  WITH ptr^ DO
    IF (mtAppl.Bitplanes = 1) 
    THEN
      IF (CatGlobal.msgTextCol > 0) 
      THEN
        CatGlobal.msgBackCol := 0;
      ELSE
        IF CatGlobal.msgBackCol = 0 THEN CatGlobal.msgBackCol := 1 END;
      END;
    END;
    clip := frame;
    IF RectFuncs.rcIntersect (butWork, clip)
    THEN
      VDIUtil.SetTreeColor (butBox, CatGlobal.msgTextCol, CatGlobal.msgBackCol);
      mtDials.DialDraw (butBox, 0, 8, clip, TRUE);
      mtAppl.MouseOff();
    END;
    clip := frame;
    IF RectFuncs.rcIntersect (msgWork, clip)
    THEN
      oldMax := maxWidth;
      clip := RectFuncs.ClipRect (frame, msgWork);
      clip.w := clip.x + clip.w - 1; 
      clip.h := clip.y + clip.h -1;
      
      v.int := MagicVDI.SetFillcolor (vdi, CatGlobal.msgBackCol);
      MagicVDI.FillRectangle(vdi, clip);
      
      IF clip.x = msgWork.x THEN
        INC (clip.x, pixOffset);
      END;
      
      clip.x := BinOps.LowerInt (clip.x, clip.w);

      WdwManager.SetClip (vdi, clip, FALSE);
      
      rawRedraw (ptr, clip);
      
      IF oldMax # maxWidth THEN 
        WdwManager.SetWdwDocument (wdw, GrafBase.LongRect{LONG(leftOffset), startPos, LONG(maxWidth), maxPos});
      END;
    END;
  END (* WITH ptr^ DO *);
END drawMsgWdw;

PROCEDURE redrawButton (wdw: INTEGER; butBox: mtUtils.tObjcTree; ob: INTEGER);
  VAR r : GrafBase.Rectangle;
BEGIN
  mtUtils.ObjcPos (butBox, ob, r.x, r.y);
  DEC (r.x); DEC (r.y);
  r.w := butBox^[ob].obWidth+1;
  r.h := butBox^[ob].obHeight+1;
  WdwManager.RedrawWdw (wdw, r);
END redrawButton;

TYPE    changeInfo  = RECORD
                        msg       : Messages.msgInfo;
                        isCopy, 
                        wasPrivate,
                        isPrivate : BOOLEAN;
                        grName    : CatTypes.String255;
                        lastName  : CatTypes.String255;
                        select    : INTEGER;
                        exitBut   : INTEGER;
                      END;
        changeInfoPtr = POINTER TO changeInfo;
                        

  PROCEDURE redrawGrName (tree: mtUtils.tObjcTree);
    VAR x1, y1 : INTEGER;
  BEGIN
    mtUtils.ObjcArea (tree, MausTauschrsc.chgruppe, v.r);
    mtUtils.ObjcPos (tree, MausTauschrsc.chgrstr, x1, y1);
    INC (v.r[2], v.r[0]-x1);
    INC (v.r[3], v.r[1]-y1);
    v.r[0] := x1;
    v.r[1] := y1;
    WinDials.WinDialDraw (tree, 0, 8, v.r, TRUE);
  END redrawGrName;
  
  PROCEDURE selName(tree: mtUtils.tObjcTree; chInfo: changeInfoPtr);
  BEGIN
    (* Empfnger auswhlen *)
    v.bool := ListHelp.SelectName (chInfo^.grName);
    IF v.bool
    THEN
      mtUtils.SetObjcString (tree, MausTauschrsc.chgrstr, msgAn);
      mtUtils.SetObjcString (tree, MausTauschrsc.chgruppe, chInfo^.grName);
      Strings.Assign (chInfo^.grName, chInfo^.lastName, v.bool);
      chInfo^.isPrivate := TRUE;
      redrawGrName(tree);
    END;
  END selName;
  
  PROCEDURE selGroup(tree: mtUtils.tObjcTree; chInfo: changeInfoPtr);
    VAR newGroup : CARDINAL;
  BEGIN
    (* Gruppe auswhlen *)
    v.bool := ListHelp.SelectGroup (chInfo^.grName, newGroup, TRUE, FALSE, FALSE, ListHelp.gsmWrite);
    IF v.bool
    THEN
      mtUtils.SetObjcString (tree, MausTauschrsc.chgrstr, msgGroup);
      IF newGroup # dataSys.private THEN 
        mtUtils.SetObjcString (tree, MausTauschrsc.chgruppe, chInfo^.grName);
      END;
      Strings.Assign (chInfo^.grName, chInfo^.lastName, v.bool);
      redrawGrName(tree);
      chInfo^.isPrivate := FALSE;
    END;
  END selGroup;

  PROCEDURE DiscardRadioSelect(tree, popup1: mtUtils.tObjcTree; sel : INTEGER);
    VAR t : Trick;
  BEGIN
    t := ADR (tree^[MausTauschrsc.chtype1].obState);
    t^.hi := CHR(sel);
    VDIUtil.SetXString (tree, MausTauschrsc.chtype1, popup1, sel);
    WinDials.WinDialDraw (tree, MausTauschrsc.chtype1, 0, v.r, FALSE);
  END DiscardRadioSelect;
  
  PROCEDURE enablePopup (tree: ADDRESS; ob : INTEGER; enable : BOOLEAN; draw : BOOLEAN);
  BEGIN
    mtUtils.SetFlag (tree, ob,    MagicAES.TOUCHEXIT, enable);
    mtUtils.SetFlag (tree, ob+1,  MagicAES.TOUCHEXIT, enable);
    mtUtils.SetState (tree, ob,   MagicAES.DISABLED, ~enable);
    mtUtils.SetState (tree, ob+1, MagicAES.DISABLED, ~enable);
    IF draw THEN
      WinDials.WinDialDraw (tree, ob, 1, v.r, FALSE);
    END;
  END enablePopup;
  
PROCEDURE changeButton (obTree: ADDRESS; private: ADDRESS; button: INTEGER;
                        mx, my : INTEGER; kstate: BITSET; clicks: INTEGER): BOOLEAN;
  VAR chInfo    : changeInfoPtr;
      but       : INTEGER;
      popup1,
      popup2,
      pop       : ADDRESS;
      x, y      : INTEGER;
      max       : CARDINAL;
      scrap     : CatTypes.String255;
      t         : Trick;
      tree      : mtUtils.tObjcTree;
BEGIN
  tree := obTree;
  but := INTEGER(BITSET(button) - {15});
  popup1 := MausTauschrsc.TreeAddr^[MausTauschrsc.msgtypbx];
  popup2 := MausTauschrsc.TreeAddr^[MausTauschrsc.distribx];
  chInfo := private;
  WITH chInfo^ DO
    IF but = MausTauschrsc.chdist0
    THEN
      but := MausTauschrsc.chdist1
    ELSIF but = MausTauschrsc.chtype0
    THEN
      but := MausTauschrsc.chtype1
    END;
    mtUtils.ExclState (tree, but, MagicAES.SELECTED);
    CASE but OF 
      MausTauschrsc.chhelp  : CatHelp.DoHelp (CatHelp.changemsg);
                              WinDials.WinDialDraw (tree, 0, 8, v.r, TRUE); |
      MausTauschrsc.chquit  : RETURN TRUE; |
      MausTauschrsc.chok    : mtUtils.ObjcString (tree, MausTauschrsc.chwegen, scrap);
                              IF ~isCopy
                              THEN
                                IF grinTools.CheckBetreff (scrap)
                                THEN
                                  mtUtils.SetObjcString (tree, MausTauschrsc.chwegen, scrap);
                                  RETURN TRUE;
                                END;
                              ELSIF (LENGTH (scrap) > 79) & isCopy
                              THEN
                                MTE.info (MTE.longCopy);
                              ELSE
                                RETURN TRUE;
                              END; 
                              mtUtils.CalcArea (tree, but, v.r);
                              WinDials.WinDialDraw (tree, 0, 8, v.r, TRUE); |
      MausTauschrsc.chdist1,
      MausTauschrsc.chtype1 : IF but = MausTauschrsc.chdist1
                              THEN
                                pop := popup2
                              ELSE
                                pop := popup1
                              END;
                              IF ~mtUtils.InState (tree, but, MagicAES.DISABLED)
                              THEN
                                MagicAES.ObjcOffset (tree, but, x, y);
                                t := ADR (tree^[but].obState);
                                select := mtPopups.TreePopup (pop, x, y, ORD(t^.hi))-1;
                                IF select >= 0 THEN
                                  t^.hi := CHR(select);
                                  VDIUtil.SetXString (tree, but, pop, select);
                                  WinDials.WinDialDraw (tree, but, 0, v.r, FALSE);
                                END; 
                              END; |
      MausTauschrsc.chdist2,
      MausTauschrsc.chtype2 : IF but = MausTauschrsc.chdist2
                              THEN
                                pop := popup2;
                                max := 4;
                              ELSE
                                pop := popup1;
                                max := 2;
                              END;
                              t := ADR (tree^[but-1].obState);
                              t^.hi := CHR((ORD(t^.hi)+1) MOD max);
                              select := ORD (t^.hi);
                              VDIUtil.SetXString (tree, but-1, pop, select);
                              (*
                              mtUtils.ObjcString (pop, select+1, selStr);
                              mtUtils.SetObjcString (tree, but-1, selStr);
                              *)
                              WinDials.WinDialDraw (tree, but-1, 0, v.r, FALSE); |
      MausTauschrsc.chgruppe: (* Entweder neuen Namen oder neue Gruppe auswhlen und setzen *)
                              IF isPrivate
                              THEN
                                mtUtils.ObjcString (tree, but, scrap);
                                selName(tree, chInfo);
                              ELSE
                                selGroup(tree, chInfo);
                              END; 
                              redrawGrName(tree); |
    ELSE
    END;
    IF (but = MausTauschrsc.chtype1) OR (but = MausTauschrsc.chtype2)
    THEN
      t := ADR (tree^[MausTauschrsc.chtype1].obState);
      IF isPrivate & (t^.hi = 1C)
      THEN
        Strings.Assign ("", grName, v.bool);
        selGroup(tree, chInfo);
        IF ~v.bool
        THEN
          DiscardRadioSelect (tree, popup1, 0);
        ELSE
          enablePopup (tree, MausTauschrsc.chdist1, ~(isPrivate OR isCopy), TRUE);
        END;
      ELSIF ~isPrivate & (t^.hi = 0C)
      THEN
        Strings.Assign ("", grName, v.bool);
        Strings.Assign ('',scrap, v.bool);
        selName(tree, chInfo);
        IF ~v.bool
        THEN
          DiscardRadioSelect (tree, popup1, 1);
        ELSE
          enablePopup (tree, MausTauschrsc.chdist1, ~(isPrivate OR isCopy), TRUE);
        END;
      END;
    END;
  END;
  RETURN FALSE;
END changeButton;

PROCEDURE changeGetSetValues (tree: ADDRESS; env: ADDRESS; 
                              set: BOOLEAN; exit: INTEGER);
  VAR chInfo    : changeInfoPtr;
      popup1,
      popup2,
      pop       : ADDRESS;
      max       : CARDINAL;
      scrap     : CatTypes.String255;
BEGIN
  chInfo := env;
  chInfo^.exitBut := INTEGER(BITSET(exit) - {15});
  popup1 := MausTauschrsc.TreeAddr^[MausTauschrsc.msgtypbx];
  popup2 := MausTauschrsc.TreeAddr^[MausTauschrsc.distribx];
  IF set
  THEN
    WITH chInfo^ DO
      mtUtils.SetState (tree, MausTauschrsc.chklemm, MagicAES.SELECTED, ~msg.sendMsg);
      isPrivate := (msg.msgType = answer) OR (msg.msgType = private) OR (msg.msgType = persanswer);
      isCopy := (msg.msgType = copyOwn) OR (msg.msgType = copyOther) OR (msg.msgType = forward);
      isPrivate := isPrivate OR isCopy;
      IF isPrivate
      THEN
        max := 0;
      ELSE
        max := 1;
      END;
      IF (msg.refId # NIL) & (LENGTH (msg.refId^) > 0)
      THEN
        mtUtils.SetObjcString (tree, MausTauschrsc.chrefid, msg.refId^);
      ELSE
        mtUtils.SetObjcString (tree, MausTauschrsc.chrefid, "");
      END;
      VDIUtil.SetXState (tree, MausTauschrsc.chtype1, max);
      VDIUtil.SetXString (tree, MausTauschrsc.chtype1, popup1, max);
      enablePopup (tree, MausTauschrsc.chtype1, ~isCopy, FALSE);
      IF isPrivate 
      THEN
        mtUtils.SetObjcString (tree, MausTauschrsc.chgrstr, msgAn);
        mtUtils.SetObjcString (tree, MausTauschrsc.chgruppe, msg.receiver^);
        Strings.Assign (msg.receiver^, lastName, v.bool);
        Strings.Assign (msg.receiver^, grName, v.bool);
      ELSE
        mtUtils.SetObjcString (tree, MausTauschrsc.chgrstr, msgGroup);
        mtUtils.SetObjcString (tree, MausTauschrsc.chgruppe, msg.group^);
        Strings.Assign (msg.group^, lastName, v.bool);
        Strings.Assign (msg.group^, grName, v.bool);
      END;

      mtUtils.SetObjcString (tree, MausTauschrsc.chwegen, msg.topic^);
      VDIUtil.SetXState (tree, MausTauschrsc.chdist1, ORD (msg.dist));
      VDIUtil.SetXString (tree, MausTauschrsc.chdist1, popup2, ORD(msg.dist));
      enablePopup (tree, MausTauschrsc.chdist1, ~(isPrivate OR isCopy), FALSE);
      
      wasPrivate := isPrivate;
    END;
  ELSE
    WITH chInfo^ DO
      IF exitBut = MausTauschrsc.chok
      THEN
        msg.dist := data.tDistribution(VDIUtil.GetXState (tree, MausTauschrsc.chdist1));
        msg.sendMsg := ~mtUtils.InState (tree, MausTauschrsc.chklemm, MagicAES.SELECTED);
        mtUtils.ObjcString (tree, MausTauschrsc.chwegen, scrap);
        IF ~Strings.StrEqual (msg.topic^, scrap) 
         & (LENGTH (scrap) > LENGTH (msg.topic^))
        THEN
          DEALLOCATE (msg.topic, 0);
          ALLOCATE (msg.topic, LENGTH (scrap)+2);
        END;
        Strings.Assign (scrap, msg.topic^, v.bool);
        (*
        mtUtils.ObjcString (tree, MausTauschrsc.chgruppe, scrap);
        *)
        (* lastName enthlt den zuletzt ausgewhlten Namen oder die
         * zuletzt ausgewhlte Gruppe
         *)
        Strings.Assign (lastName, scrap, v.bool);
        IF isPrivate
        THEN
          IF ~Strings.StrEqual (msg.receiver^, scrap)
          THEN
            IF msg.msgType = answer
            THEN
              (* war Antwort, wird zu Lstermail *)
              msg.msgType := persanswer;
              msg.noRefLine := TRUE;
            END;
            IF (LENGTH (scrap) > LENGTH (msg.receiver^))
            THEN
              DEALLOCATE (msg.receiver, 0);
              ALLOCATE (msg.receiver, LENGTH (scrap)+2);
            END;
          END;
          Strings.Assign (scrap, msg.receiver^, v.bool);
          IF ~wasPrivate
          THEN
            IF ((msg.msgType = comment) OR (msg.msgType = groupcomment)) & (msg.refId # NIL) & (msg.refId^[0] # 0C) 
            THEN
              msg.msgType := persanswer;
              msg.noRefLine := TRUE;
            ELSE
              msg.msgType := private
            END;
          END;
        ELSE
          IF ~Strings.StrEqual (msg.group^, scrap) 
           & (LENGTH (scrap) > LENGTH (msg.group^))
          THEN
            DEALLOCATE (msg.group, 0);
            ALLOCATE (msg.group, LENGTH (scrap)+2);
          END;
          Strings.Assign (scrap, msg.group^, v.bool);
          IF wasPrivate
          THEN
            IF ((msg.msgType = private) OR (msg.msgType = persanswer)) & (msg.refId # NIL) & (msg.refId^[0] # 0C) 
            THEN
              IF Strings.StrEqual (msg.group^, msg.orgGroup^)
              THEN
                msg.msgType := comment;
                msg.noRefLine := FALSE;
              ELSE
                msg.msgType := groupcomment
              END;
            ELSE
              msg.msgType := mail
            END;
          ELSE
            IF ~Strings.StrEqual (msg.group^, msg.orgGroup^) & (msg.msgType = comment)
            THEN
              msg.msgType := groupcomment
            ELSIF Strings.StrEqual (msg.group^, msg.orgGroup^) & (msg.msgType = groupcomment)
            THEN
              msg.msgType := comment;
              msg.noRefLine := FALSE;
            END;
          END;
        END;
        Messages.WriteHdrInfo (msg);
      END;
    END;
  END;
END changeGetSetValues;

PROCEDURE changeHdr (VAR message : Messages.msgInfo): BOOLEAN;
  VAR tree : mtUtils.tObjcTree;
      cInfo     : changeInfoPtr;
      but       : INTEGER;  
BEGIN 
  tree := MausTauschrsc.TreeAddr^[MausTauschrsc.changebx];
  NEW (cInfo);
  IF cInfo = NIL 
  THEN
    MTE.noMemAlert();
    RETURN FALSE
  END;
  cInfo^.msg := message;
  Strings.Assign ("", cInfo^.grName, v.bool);
  IF WinDials.OpenWinDial (tree, TRUE,
                           changeGetSetValues,
                           changeGetSetValues,
                           changeButton,
                           WinDials.defDraw,
                           "",
                           cInfo)
  
  THEN
    WinDials.WinDialHandleEvents();
    
    but := cInfo^.exitBut;
    IF but = MausTauschrsc.chok
    THEN
      message := cInfo^.msg;
    END;
  ELSE
    MTE.info (MTE.NoWinDial);
    but := -1;
  END;
  DISPOSE (cInfo);
  RETURN but = MausTauschrsc.chok;
END changeHdr;

PROCEDURE careForButtons(ptr : msgWdwPtr; redraw : BOOLEAN);
  VAR selectCount : INTEGER;
      msg       : Messages.msgInfo;
      rdwCount,
      i         : INTEGER;
      isComm,
      isMail    : BOOLEAN;
      selSet,
      disSet    : BITSET;
BEGIN
  WITH ptr^ DO
    selSet := {};
    disSet := {};
    FOR i := MausTauschrsc.ctrledit TO MausTauschrsc.ctrldis2 DO
      IF mtUtils.InState (butBox, i, MagicAES.SELECTED) THEN INCL (selSet, i); END;
      IF mtUtils.InState (butBox, i, MagicAES.DISABLED) THEN INCL (disSet, i); END;
    END;
    INCL (selSet, MausTauschrsc.ctrldis1);  (* Fr Redraw *)
    IF (wdw > 0) & hasSelectedEntries (ptr, sel)
    THEN
      selectCount := countSelectedEntries (ptr);
      msg := Messages.msgArray^[sel];
      mtUtils.SetState (butBox, MausTauschrsc.ctrldel, MagicAES.DISABLED, FALSE);
      IF selectCount = 1
      THEN
        isMail := (msg.msgType = mail) OR (msg.msgType = comment) OR (msg.msgType = groupcomment);
        isComm := ~((msg.msgType=mail) OR (msg.msgType = private));
        mtUtils.SetState (butBox, MausTauschrsc.ctrledit, MagicAES.DISABLED, 
                         (msg.msgType = copyOwn) OR (msg.msgType = copyOther) OR (msg.msgType = forward)); 
        mtUtils.SetState (butBox, MausTauschrsc.ctrlview, MagicAES.DISABLED, 
                         (msg.msgType = copyOwn) OR (msg.msgType = copyOther) OR (msg.msgType = forward)); 
        mtUtils.SetState (butBox, MausTauschrsc.ctrlkomm, MagicAES.DISABLED,
                          ~isMail); 
        mtUtils.SetState (butBox, MausTauschrsc.ctrlcopy, MagicAES.DISABLED,
                          ~((msg.msgType = private) OR (msg.msgType = answer) OR (msg.msgType = persanswer)) ); 
        mtUtils.SetState (butBox, MausTauschrsc.ctrlhdr, MagicAES.DISABLED, FALSE);
        mtUtils.SetState (butBox, MausTauschrsc.ctrlback, MagicAES.DISABLED, ~isComm);
  
        mtUtils.SetState (butBox, MausTauschrsc.ctrldis1, MagicAES.DISABLED, ~isMail);
        mtUtils.SetState (butBox, MausTauschrsc.ctrldis2, MagicAES.DISABLED, ~isMail);
        VDIUtil.SetXState  (butBox, MausTauschrsc.ctrldis1, ORD(Messages.msgArray^[sel].dist));
        VDIUtil.SetXString (butBox, MausTauschrsc.ctrldis1, distSel, ORD(Messages.msgArray^[sel].dist));
        INCL (selSet, MausTauschrsc.ctrldis1);  (* Fr Redraw *)
        (*
        FOR i := MausTauschrsc.ctrlnone TO MausTauschrsc.ctrl_net DO
          mtUtils.SetState (butBox, i, MagicAES.SELECTED, FALSE);
          mtUtils.SetState (butBox, i, MagicAES.DISABLED, ~isMail);
        END;
        mtUtils.SetState (butBox, MausTauschrsc.ctrlnone + ORD (Messages.msgArray^[sel].dist), MagicAES.SELECTED, isMail);
        *)
      ELSE
        mtUtils.SetState (butBox, MausTauschrsc.ctrledit, MagicAES.DISABLED, FALSE);
        mtUtils.SetState (butBox, MausTauschrsc.ctrlkomm, MagicAES.DISABLED, TRUE);
        mtUtils.SetState (butBox, MausTauschrsc.ctrlview, MagicAES.DISABLED, FALSE);
        mtUtils.SetState (butBox, MausTauschrsc.ctrlcopy, MagicAES.DISABLED, TRUE);
        mtUtils.SetState (butBox, MausTauschrsc.ctrlhdr, MagicAES.DISABLED,  TRUE);
        mtUtils.SetState (butBox, MausTauschrsc.ctrlback, MagicAES.DISABLED, TRUE);
        mtUtils.SetState (butBox, MausTauschrsc.ctrldis1, MagicAES.DISABLED, TRUE);
        mtUtils.SetState (butBox, MausTauschrsc.ctrldis2, MagicAES.DISABLED, TRUE);
        VDIUtil.SetXString (butBox, MausTauschrsc.ctrldis1, distSel, 0);
        (*
        FOR i := MausTauschrsc.ctrlnone TO MausTauschrsc.ctrl_net DO
          mtUtils.SetState (butBox, i, MagicAES.SELECTED, FALSE);
          mtUtils.SetState (butBox, i, MagicAES.DISABLED, TRUE);
        END;
        *)
      END;  
    ELSE
      FOR i := MausTauschrsc.ctrledit TO MausTauschrsc.ctrldis2 DO
        mtUtils.ExclState (butBox, i, MagicAES.SELECTED);
        mtUtils.InclState (butBox, i, MagicAES.DISABLED);
      END;
      mtUtils.ExclState (butBox, MausTauschrsc.ctrldis0, MagicAES.DISABLED);
      VDIUtil.SetXString (butBox, MausTauschrsc.ctrldis1, distSel, 0);
    END;
    (* Alle neuzeichnen *)
    IF redraw & (wdw >= 0) THEN 
      rdwCount := 0;
      FOR i := MausTauschrsc.ctrledit TO MausTauschrsc.ctrldis2 DO
        IF (mtUtils.InState (butBox, i, MagicAES.SELECTED) # (i IN selSet)) OR 
           (mtUtils.InState (butBox, i, MagicAES.DISABLED) # (i IN disSet))
        THEN
          INC (rdwCount); 
        END;
      END;
      IF rdwCount < 5
      THEN
        FOR i := MausTauschrsc.ctrledit TO MausTauschrsc.ctrldis2 DO
          IF (mtUtils.InState (butBox, i, MagicAES.SELECTED) # (i IN selSet)) OR 
             (mtUtils.InState (butBox, i, MagicAES.DISABLED) # (i IN disSet))
          THEN
            redrawButton (wdw, butBox, i); 
          END;
        END;
      ELSE
        redrawButton (wdw, butBox, 0); 
      END;
    END;
  END;
END careForButtons;

PROCEDURE openSelected(ptr : msgWdwPtr; forView: BOOLEAN);
  VAR i : INTEGER;
BEGIN
  IF hasSelectedEntries (ptr, v.int)
  THEN
    FOR i := 0 TO ptr^.maxPos DO 
      IF ptr^.list^[i].selected
      THEN
        Messages.OpenEditor (ptr^.list^[i], FALSE, -1, 0, forView);
      END;
    END;
  END;
END openSelected;

PROCEDURE handleButtons (ptr : msgWdwPtr; ob : INTEGER) : BOOLEAN;
  VAR i      : INTEGER;
      oldDist: INTEGER;
      selectCount : INTEGER;
      msg    : Messages.msgInfo;
      name,
      Betreff,
      msgName: CatTypes.String255;
      x, y   : INTEGER;
      select : INTEGER;
      t      : Trick;

  PROCEDURE handleSelChanged(redrawBut: BOOLEAN);
  BEGIN
    WITH ptr^ DO
      Messages.WriteMessageInfo(FALSE);
      redrawEntry (sel);
      IF redrawBut THEN careForButtons (ptr, TRUE); END;
      (* Jetzt nachsehen, ob das irgendwo benutzt wird, und 
       * dann auch dort die Anzeige ndern 
       *)
      Messages.UpdateEditors (Messages.msgArray^[sel]);
    END;
  END handleSelChanged;

BEGIN
  WITH ptr^ DO
    IF ~mtUtils.InState (butBox, ob, MagicAES.DISABLED)
      & (mtUtils.InFlag (butBox, ob, MagicAES.SELECTABLE)
         OR (ob = MausTauschrsc.ctrldis2))
    THEN
      (* Button selektieren *)
      IF ob # MausTauschrsc.ctrldis2
      THEN
        mtUtils.InclState (butBox, ob, MagicAES.SELECTED);
        redrawButton (wdw, butBox, ob);
      END;
      mtUtils.Bounce();
      (* Selektierte Nachrichten zhlen *)
      selectCount := countSelectedEntries(ptr);
      IF selectCount = 1
      THEN
        v.bool := hasSelectedEntries (ptr, sel);
        msg := Messages.msgArray^[sel];
      END;
      CASE ob OF 
        MausTauschrsc.ctrledit : openSelected(ptr, FALSE); |
        MausTauschrsc.ctrlkomm : 
          IF (selectCount = 1) & 
             ((msg.msgType = mail) OR  
              (msg.msgType = comment) OR
              (msg.msgType = groupcomment))
          THEN
            IF ~msg.hdrRead
            THEN
              Messages.ReadHdrInfo (msg, TRUE);
            END;
            IF msg.hdrRead THEN
              IF msg.topic # NIL 
              THEN
                Strings.Assign (msg.topic^, Betreff, v.bool);
              ELSE
                Betreff := "";
              END;
              Messages.Number2Name (msg.number, msgName);
              IF grinTools.BetreffHolen(-1, Betreff, 'Stichwort fr Kommentar auf Nachricht :',
                                        msgName, msgWegen, FALSE) 
              THEN
                Messages.MakeMausId (msg, msgName);
                v.bool := Messages.CreateMessage (msg.number, '', msg.group^, msg.group^, msgName, Betreff, '', comment, 0, '', '', msg.dist, TRUE, v.int);
              END;
            END;
          END; |
        MausTauschrsc.ctrlview : openSelected(ptr, TRUE); |
        MausTauschrsc.ctrldel  : 
          IF selectCount > 0 
          THEN
            v.int := mtAlerts.Alert (2, MTE.delSelectedAlt);
            IF v.int = 1
            THEN
              i := Messages.messages-1;
              WHILE i >= 0 DO
                IF list^[i].selected
                THEN
                  Messages.Number2Name (list^[i].number, msgName);
                  Messages.deleteMessage (msgName, TRUE, TRUE);
                END;
                DEC (i);
                (* i := BinOps.LowerInt (i, Messages.messages-1); *)
              END;
              sel := -1;
            END;
            careForButtons(ptr, TRUE);
          END; |
        MausTauschrsc.ctrlcopy : 
          IF (selectCount = 1) & 
             ((msg.msgType = answer) OR  
              (msg.msgType = persanswer) OR  
              (msg.msgType = private))
          THEN
            IF ~msg.hdrRead
            THEN
              Messages.ReadHdrInfo (msg, TRUE);
              IF ~msg.hdrRead THEN RETURN TRUE END;
            END;
            Strings.Assign ('', name, v.bool);
            IF msg.copyCount >= 10
            THEN
              MTE.info (MTE.maxCopyAlert);
            ELSE
              IF grinTools.GetCommentLine(Betreff, TRUE) & ListHelp.SelectName(name) THEN
                Messages.Number2Name (msg.number, msgName);
                Messages.CopyOwnMessage (msgName, name, '', Betreff, 1);
              END
            END;
          END; |
        MausTauschrsc.ctrlhdr  : 
          IF (selectCount = 1) 
          THEN
            IF ~Messages.msgArray^[sel].hdrRead
            THEN
              Messages.ReadHdrInfo (Messages.msgArray^[sel], FALSE);
            END;
            IF Messages.msgArray^[sel].hdrRead
               & changeHdr (Messages.msgArray^[sel])
            THEN
              handleSelChanged(TRUE);
            END;
          END; |
        MausTauschrsc.ctrlback : 
          IF (selectCount = 1)
          THEN
            Messages.openReference (sel);
          END; |
        MausTauschrsc.ctrldis1 :
          IF (selectCount = 1)
          THEN
            MagicAES.ObjcOffset (butBox, ob, x, y);
            t := ADR (butBox^[ob].obState);
            select := mtPopups.TreePopup (distSel, x, y, ORD(t^.hi))-1;
            IF select >= 0 THEN
              t^.hi := CHR(select);
              Messages.msgArray^[sel].dist := data.tDistribution (ORD (select));
              VDIUtil.SetXString (butBox, ob, distSel, select);
              (*
              redrawButton (ptr^.wdw, butBox, ob);
              *)
              handleSelChanged(FALSE);
            END;
          END; |
        MausTauschrsc.ctrldis2 : 
          IF (selectCount = 1)
          THEN
            mtUtils.ExclState (butBox, ob, MagicAES.SELECTED);
            DEC (ob);   (* Button nehmen *)
            t := ADR (butBox^[ob].obState);
            t^.hi := CHR((ORD(t^.hi)+1) MOD 4);
            select := ORD (t^.hi);
            Messages.msgArray^[sel].dist := data.tDistribution (ORD (select));
            VDIUtil.SetXString (butBox, ob, distSel, select);
            (* 
            redrawButton (ptr^.wdw, butBox, ob-1);
            *)
            handleSelChanged(FALSE);
          END;
      ELSE
      END;
      (* Button deselektieren *)
      mtUtils.ExclState (butBox, ob, MagicAES.SELECTED);
      redrawButton (ptr^.wdw, butBox, ob);
      RETURN TRUE
    ELSE
      RETURN FALSE;
    END;
  END;
END handleButtons;

PROCEDURE clickInMsgWindow(win, vdiH : INTEGER; special : ADDRESS; 
                           x,y : INTEGER; kstate, buts : BITSET; clicks : INTEGER): BOOLEAN;
  VAR transY : INTEGER;
      ptr    : msgWdwPtr;
      entrySelected : BOOLEAN;
      line   : INTEGER;
      but    : BITSET;
      i      : INTEGER;
      ob     : INTEGER;
      selectCount : INTEGER;
      msg    : Messages.msgInfo;
      name,
      Betreff,
      msgName: CatTypes.String255;

    PROCEDURE selectArea;
      VAR firstLine,
          lastLine : INTEGER;
          i        : INTEGER;
          r, 
          rect     : GrafBase.Rectangle;
          first    : BOOLEAN;
    BEGIN
      WITH ptr^ DO
        rect := GrafBase.Rectangle{x, y, 0, 0};
        mtAppl.MouseFinger ();
        MagicAES.GrafRubberbox (x, y, -32767, -32767, rect.w, rect.h);
        mtAppl.MouseArrow();
        
        WITH rect DO
          IF w < 0
          THEN
            INC(x, w);
            w := -w
          END;
          IF h < 0
          THEN
            INC (y, h);
            h := -h
          END;
        END;
        (* clippen *)
        rect := RectFuncs.ClipRect (rect, msgWork);
        rect.h := BinOps.LowerInt (rect.h, msgWork.y + msgWork.h - 1 - rect.y);
        
        (* Jetzt testen, ob selektierbarer Bereich geschnitten wurde *)
        IF (((rect.x - msgWork.x) < pixOffset) & ((rect.x + rect.w - msgWork.x) < pixOffset)) OR
           (((rect.x - msgWork.x) > maxWidth) & ((rect.x + rect.w - msgWork.x) > maxWidth))
        THEN
          RETURN
        END;

        firstLine := (rect.y - msgWork.y) DIV (2*charHeight + lineDist);
        lastLine  := (rect.y + rect.h - msgWork.y) DIV (2*charHeight + lineDist);
        IF (rect.x - msgWork.x > pixOffset) OR (rect.x + rect.w - msgWork.x > pixOffset)
        THEN
          r := msgWork;
          INC (r.x, pixOffset);
          r.h := 2*charHeight + lineDist;
          first := TRUE;
          FOR i := startPos+firstLine TO startPos+lastLine DO
            IF (i>= 0) & (i<= maxPos)
            THEN
              list^[i].selected := ~list^[i].selected;
              IF (i >= startPos) & (i <= startPos + windLines)
              THEN 
                (* redraw *)
                IF first THEN 
                  r.y := msgWork.y + INTEGER(i - startPos) * (2*charHeight+lineDist);
                  first := FALSE
                ELSE
                  r.h := msgWork.y + INTEGER(i - startPos + 1) * (2*charHeight+lineDist) - r.y;
                END;
              END;
            END;
          END;
          IF ~first THEN WdwManager.RedrawWdw (wdw, r) END;
        END;
      END;
    END selectArea;

BEGIN
  ptr := msgWdwPtr (special);
  WITH ptr^ DO
    IF ~(0 IN buts) THEN RETURN FALSE END;
    IF RectFuncs.IsInRect (x, y, butWork)
    THEN
      ob := MagicAES.ObjcFind (butBox,  0, 8, x, y);
      IF (ob >= MausTauschrsc.ctrledit) & (ob <= MausTauschrsc.ctrldis2)
      THEN
        RETURN handleButtons (ptr, ob);
      END;
    ELSIF RectFuncs.IsInRect (x, y, msgWork)
    THEN
      IF ~((MagicAES.KRSHIFT IN kstate) OR (MagicAES.KLSHIFT IN kstate))
      THEN
        deselectEntries (ptr);
        sel := -1;
      END;
      (* Zeile herausfinden *)
      line := (y - msgWork.y) DIV (2*charHeight + lineDist);
      transY := (y - msgWork.y - (lineDist DIV 2));
      entrySelected := (transY >= line*(2*charHeight + lineDist)) & 
                       (transY < ((line+1) * 2*charHeight + line*lineDist)) &
                       ((x - msgWork.x) >= pixOffset) &
                       ((x - msgWork.x) <= maxWidth) &
                       (line+startPos <= maxPos);
      IF entrySelected
      THEN
        toggleEntry (ptr, line+startPos);
        IF list^[line+startPos].selected THEN
          sel := line+startPos;
        ELSE
          sel := -1;
        END;
        IF clicks > 1
        THEN
          openSelected(ptr, FALSE);
        ELSE
          REPEAT 
            MagicAES.GrafMkstate (x, y, but, kstate);
          UNTIL ~(0 IN but);
        END;
      ELSE
        MagicAES.GrafMkstate (x, y, but, kstate);
        IF 0 IN but
        THEN
          (* Graf-Rubberbox aufrufen *)
          selectArea();
        END;
      END;
      careForButtons (ptr, TRUE);
      RETURN TRUE;
    END;
  END;
  RETURN FALSE;
END clickInMsgWindow;

PROCEDURE handleMsgKey (wdw, vdiH : INTEGER; special : ADDRESS; taste: INTEGER; char, scan : CHAR; kstate : BITSET) : BOOLEAN;
  VAR ptr   : msgWdwPtr;
      gemCh : CARDINAL;
      key   : MOSGlobals.Key;
      ctrl  : BOOLEAN;
      done  : BOOLEAN;
      doc   : GrafBase.LongRect;
      newPos: BOOLEAN;
      pg    : BOOLEAN;
  
  PROCEDURE deselectLast();
  BEGIN
    IF countSelectedEntries (ptr) > 1
    THEN
      deselectEntries (ptr);
    ELSE
      toggleEntry (ptr, ptr^.sel);
    END;
  END deselectLast;
  
BEGIN
  ptr := msgWdwPtr (special);
  WITH ptr^ DO
    gemCh := ORD(scan) * 256 + ORD(char);
    Keyboard.GemCharToKey (gemCh,  SHORT (INTEGER(kstate)), key);
    ctrl := MagicAES.KCTRL IN kstate;
    done := TRUE;
    newPos := FALSE;
    IF Keyboard.IsSpecial (key)
    THEN
      CASE Keyboard.SpecialKey (key) OF
        left          : WdwManager.ScrollLeft (wdw, 1);  |
        soln          : WdwManager.PageLeft (wdw);    |
        right         : WdwManager.ScrollRight (wdw, 1); | 
        eoln          : WdwManager.PageRight (wdw);   |
        pgUp,
        up            : pg := Keyboard.SpecialKey (key) = pgUp;
                        IF pg THEN WdwManager.PageUp (wdw); END;
                        IF sel = -1 
                        THEN
                          sel := BinOps.LowerInt (maxPos, startPos+windLines-1);
                          toggleEntry (ptr, sel);
                        ELSIF sel > 0 THEN 
                          deselectLast();
                          IF pg THEN 
                            DEC (sel, windLines-1);
                            sel := BinOps.HigherInt (0, sel);
                          ELSE
                            DEC (sel); 
                          END;
                          sel := BinOps.LowerInt (sel, maxPos);
                          toggleEntry (ptr, sel);
                          IF (sel < startPos) OR (sel > startPos + windLines-1)
                          THEN
                            startPos := BinOps.LowerInt (maxPos - windLines+1, sel);
                            newPos := TRUE;
                          END; 
                        END; |
        pgDown,
        down          : pg := Keyboard.SpecialKey (key) = pgDown;
                        IF pg THEN WdwManager.PageDown (wdw); END;  
                        IF sel = -1
                        THEN
                          sel := startPos;
                          toggleEntry (ptr, sel);
                        ELSIF sel < maxPos THEN 
                          deselectLast();
                          IF pg THEN
                            INC (sel, windLines-1);
                            sel := BinOps.LowerInt (sel, maxPos);
                          ELSE
                            INC (sel); 
                          END;
                          sel := BinOps.HigherInt (sel, 0);
                          toggleEntry (ptr, sel);
                          IF (sel < startPos) OR (sel > startPos + windLines-1)
                          THEN
                            startPos := BinOps.LowerInt (maxPos - windLines+1, sel-windLines+1);
                            newPos := TRUE;
                          END; 
                        END; 
                        |
        home,
        clr           : IF sel >= 0 THEN 
                          deselectLast();
                          pg := TRUE;
                        ELSE
                          pg := FALSE;
                        END;
                        IF Keyboard.SpecialKey (key) = home
                        THEN
                          sel := 0;
                          IF pg THEN toggleEntry (ptr, sel); END;
                          startPos := 0;
                        ELSE
                          sel := maxPos;
                          IF pg THEN toggleEntry (ptr, sel); END;
                          startPos := BinOps.HigherInt (maxPos - windLines+1, 0);
                        END; 
                        IF ~pg 
                        THEN
                          sel := -1;
                        END;
                        newPos := TRUE;
                        |
        return,
        enter         : openSelected (ptr, FALSE); |
        esc           : deselectEntries (ptr); sel := -1; |
      ELSE
        done := FALSE
      END;
      IF newPos 
      THEN
        startPos := BinOps.HigherInt (0, startPos);
        WdwManager.SetWdwDocument (wdw, GrafBase.LongRect{LONG(leftOffset), startPos, LONG(maxWidth), maxPos});
      END;
      careForButtons (ptr, TRUE);
    ELSIF ~ctrl & ~CatGlobal.WithAlt (kstate)
    THEN
      CASE CAP (char) OF
        'A' : RETURN handleButtons (ptr, MausTauschrsc.ctrlhdr);  |
        'C' : RETURN handleButtons (ptr, MausTauschrsc.ctrlcopy); |
        'E' : RETURN handleButtons (ptr, MausTauschrsc.ctrledit); |
        'K' : RETURN handleButtons (ptr, MausTauschrsc.ctrlkomm); |
        'L' : RETURN handleButtons (ptr, MausTauschrsc.ctrldel);  |
        'O' : RETURN handleButtons (ptr, MausTauschrsc.ctrlback); |
        'D' : IF CatGlobal.WithShift (kstate)
              THEN
                RETURN handleButtons (ptr, MausTauschrsc.ctrldis2);
              ELSE
                RETURN handleButtons (ptr, MausTauschrsc.ctrldis1);
              END; |
        'V' : RETURN handleButtons (ptr, MausTauschrsc.ctrlview); |
        (*
        '0' : RETURN handleButtons (ptr, MausTauschrsc.ctrlnone); |
        '1' : RETURN handleButtons (ptr, MausTauschrsc.ctllokal); |
        '2' : RETURN handleButtons (ptr, MausTauschrsc.ctrlmaus); |
        '3' : RETURN handleButtons (ptr, MausTauschrsc.ctrl_net); |
        *)
      ELSE
        done := FALSE;
      END;
    ELSE
      done := FALSE
    END;
    RETURN done;
  END;
END handleMsgKey;

PROCEDURE closeMsgWindow (wdw, vdiH : INTEGER; special : ADDRESS; force : BOOLEAN) : BOOLEAN;
  VAR ptr : msgWdwPtr;
      full    : GrafBase.Rectangle;
BEGIN
  ptr := msgWdwPtr (special);
  WITH ptr^ DO
    WdwManager.GetWdwSize (wdw, full); (* Gre des Fensters abfragen *)
    v.bool := ConfVars.SetConfigRect (cfgWindow, full);
    v.bool := ConfVars.SetConfigInt (cfgFont, font);
    v.bool := ConfVars.SetConfigInt (cfgFontSize, fontSize);
    v.bool := ConfVars.SetConfigInt (cfgLeftOffset, pixOffset);
    v.bool := ConfVars.SetConfigInt (cfgLineDist, lineDist);
    FontSelect.UnloadFonts (vdi);
  END;
  ptr^.wdw := -1;
  ptr^.vdi := -1;
  RETURN TRUE
END closeMsgWindow;

PROCEDURE topMsgWdw (wdw, vdiH : INTEGER; special : ADDRESS) : BOOLEAN;
BEGIN
  RETURN TRUE;
END topMsgWdw;

PROCEDURE untopMsgWdw (wdw, vdiH : INTEGER; special : ADDRESS);
END untopMsgWdw;

PROCEDURE updateMsgWdw (wdw, vdiH : INTEGER; special : ADDRESS; update : BOOLEAN);
BEGIN
  IF update
  THEN
    MagicAES.WindUpdate (MagicAES.BEGUPDATE);
    mtAppl.MouseOff();
  ELSE
    mtAppl.MouseOn();
    MagicAES.WindUpdate (MagicAES.ENDUPDATE);
  END;
END updateMsgWdw;

PROCEDURE setMsgWork (wdw, vdiH : INTEGER; special : ADDRESS; doc : GrafBase.LongRect; slided : BOOLEAN);
  VAR ptr : msgWdwPtr;
BEGIN
  ptr := msgWdwPtr (special);
  WITH ptr^ DO
    leftOffset := SHORT(doc.x);
    startPos   := SHORT(doc.y);
  END;
END setMsgWork;

PROCEDURE getMsgScroll (wdw, vdiH : INTEGER; special : ADDRESS; VAR work : GrafBase.Rectangle);
  VAR ptr       : msgWdwPtr;
      full      : GrafBase.Rectangle;
BEGIN 
  ptr := msgWdwPtr (special);
  AdjustTreePos (work, ptr^.butWork);
  DEC (work.h, butBox^[0].obHeight+1);
  INC (work.y, butBox^[0].obHeight+1);
  WITH work DO
    ptr^.windLines := (BinOps.LowerInt(y+h-1, INTEGER(mtAppl.MaxHeight-1)) - y+1) DIV (2*ptr^.charHeight+lineDist); 
    WdwManager.SetScrollParms (wdw, w-ptr^.charWidth, ptr^.windLines-1, ptr^.charWidth, 1);
    WITH ptr^ DO
      msgWork := work;
    END;
  END;
  IF wdw >= 0
  THEN
    WdwManager.GetWdwSize (wdw, full); (* Gre des Fensters abfragen *)
    v.bool := ConfVars.SetConfigRect (cfgWindow, full);
  END;
END getMsgScroll;

PROCEDURE snapMsgWdw (wdw, vdiH : INTEGER; special : ADDRESS; VAR work : GrafBase.Rectangle);
  CONST minWindWidth = 128;
        minWindHeight = 48;
  VAR ptr       : msgWdwPtr;
BEGIN
  ptr := msgWdwPtr (special);
  WITH ptr^ DO
    AdjustTreePos (work, butWork);
    IF ~inOpen
    THEN
      WITH work DO
        DEC (h, butWork.h);
        INC (h);            (* Um Rundungsfehler zu vermeiden *)
        h := ((h+lineDist) DIV (2*charHeight+lineDist)  ) * (2*charHeight+lineDist);
        WHILE w < minWindWidth DO INC(w, charWidth) END;
        WHILE h < minWindHeight DO INC(h, 2*charHeight+lineDist) END;
        windLines := (BinOps.LowerInt(y+h-1, INTEGER(mtAppl.MaxHeight-1)) - y+1) DIV (2*charHeight+lineDist); 
        msgWork := work;
        INC (work.h, butWork.h);
        WdwManager.SetScrollParms (wdw, w-charWidth, windLines-1, charWidth, 1);
      END;
    END;
  END;
END snapMsgWdw;

PROCEDURE hideMsgWdw (wdw, vdiH : INTEGER; special : ADDRESS; hide : BOOLEAN);
  VAR ptr       : msgWdwPtr;
      full      : GrafBase.Rectangle;
BEGIN 
  ptr := msgWdwPtr (special);
  ptr^.isHidden := hide;
END hideMsgWdw;


(*-------------- exportierte Funktionen -----------------------*)

(*$H+*)
PROCEDURE msgOpen (errorMsg: BOOLEAN);
(* Bringt das Fenster mit der Nachrichtenbersicht 
 * in den Vordergrund bzw. ffnet es, falls noch nicht 
 * offen. Die Nachricht mu dann im Fenster ausgewhlt 
 * werden.
 *)
  VAR ptr       : msgWdwPtr;
      work      : GrafBase.Rectangle;
      comps     : BITSET;
      i         : INTEGER;
      title     : ARRAY [0..80] OF CHAR;
BEGIN
  IF msgWindow.wdw >= 0
  THEN 
    IF msgWindow.isHidden
    THEN
      v.bool := WdwManager.ShowWindow (msgWindow.wdw);
    ELSE
      WdwManager.TopWindow (msgWindow.wdw);
    END;
  ELSE
    ptr := ADR(msgWindow);
    ConfVars.GetConfDefRect (cfgWindow, ptr^.msgWork, EditTypes.deskSize);
    ConfVars.GetConfDefInt (cfgLeftOffset, pixOffset, 8);
    pixOffset := BinOps.HigherInt (0, pixOffset);
    ConfVars.GetConfDefInt (cfgLineDist, lineDist, 2);
    lineDist := BinOps.HigherInt (0, lineDist);
    (* Fensterkomponenten setzen *)
    comps := {MagicAES.NAME..MagicAES.HSLIDE};
    (* Infozeile brauchen wir nicht *)
    EXCL (comps, MagicAES.INFO);
    
    ptr^.wdw := -1;
    ptr^.maxPos := Messages.messages - 1;
    ptr^.list := Messages.msgArray;
    IF (Messages.msgArray = NIL) OR (Messages.messages <= 0) THEN 
      IF errorMsg THEN MTE.info (MTE.noMsgAlt); END;
      RETURN 
    END;
    FOR i := 0 TO Messages.messages - 1 DO
      Messages.msgArray^[i].selected := FALSE;
    END;
    careForButtons (ptr, FALSE);
    ptr^.charHeight  := 16;
    ptr^.charWidth   := 8;
    inOpen := TRUE;
    (* Fenster ffnen *)
    Strings.Assign (msgWindowTitle, title, v.bool);
    ConfVars.GetConfDefBool (cSetAppName, v.bool, TRUE);
    IF CatGlobal.multiTask & v.bool
    THEN
      Strings.Insert (msgWindowTitle0, 0, title, v.bool);
    END;
    IF WdwManager.OpenWindow (clickInMsgWindow, handleMsgKey, WdwManager.handleTimerProc (NIL),
                              EditTypes.deskSize, ptr^.msgWork, comps, TRUE, 
                              '', title, snapMsgWdw, closeMsgWindow, 
                              drawMsgWdw, topMsgWdw, untopMsgWdw, updateMsgWdw,
                              setMsgWork, getMsgScroll, hideMsgWdw, pixOffset, ptr, 
                              FALSE, TRUE, TRUE, TRUE, ptr^.wdw, ptr^.vdi)
    THEN
      WITH ptr^ DO
        inOpen := FALSE;
        isHidden := FALSE;
        (* Font aus Configvariablen lesen und setzen *)
        ConfVars.GetConfDefInt (cfgFont, font, 1);
        ConfVars.GetConfDefInt (cfgFontSize, fontSize, 10);
        startPos := 0;
        leftOffset := 0;
        maxWidth   := 0;
        (* Noch ein bichen was fr die Window-Library *)
        WdwManager.SetNewDocument (wdw, GrafBase.LongRect{LONG(leftOffset), startPos, LONG(maxWidth), maxPos}, FALSE);
        (* Fonts laden *)
        FontSelect.LoadFonts (vdi, v.int);
        (* Font setzen *)
        iMsgSetFont (wdw, font, fontSize, FALSE);
        (* Jetzt noch ein paar andere VDI-Variablen setzen *)
        v.int := MagicVDI.SetFillstyle (vdi, MagicVDI.Full);
        v.int := MagicVDI.SetFillinterior (vdi, MagicVDI.Full);
        v.int := MagicVDI.SetFillcolor (vdi, CatGlobal.msgBackCol);
        (* Schreibmodus setzen *)
        v.int := MagicVDI.SetWritemode (vdi, MagicVDI.REPLACE);
        sel := -1;
      END;
    ELSE
      inOpen := FALSE;
      ptr^.wdw := -1;
    END;
  END;
END msgOpen;
(*$H=*)

PROCEDURE msgClose (wdw : INTEGER);
(* Ein Stichwortlistenfenster wird geschlossen *)
BEGIN
  IF msgWindow.wdw = wdw
  THEN
    v.bool := WdwManager.CloseWindow (wdw, TRUE);
  END;
END msgClose;

PROCEDURE msgWindowTop (wdw : INTEGER) : BOOLEAN;
(* Ist ein Stichwortlistenfenster oben? *)
BEGIN
  RETURN (msgWindow.wdw = wdw) & (msgWindow.wdw >= 0);
END msgWindowTop;

PROCEDURE msgSetFont (wdw: INTEGER; font, fontSize : INTEGER);
BEGIN
  iMsgSetFont (wdw, font, fontSize, TRUE);
END msgSetFont;

PROCEDURE msgSelectAll (wdw: INTEGER);
(* Selektiert alle Nachrichten in der Nachrichtenliste 
 *)
  VAR i : INTEGER;
BEGIN
  IF msgWindow.wdw = wdw
  THEN
    WITH msgWindow DO 
      FOR i := 0 TO Messages.messages - 1 DO 
        IF ~Messages.msgArray^[i].selected
        THEN
          (* Erledigt auch direkt den Redraw davon *)
          toggleEntry (ADR(msgWindow), i); 
        END;
      END;
    END;
    careForButtons (ADR(msgWindow), TRUE);
  END;
END msgSelectAll;

PROCEDURE msgSavePos();
  VAR num : INTEGER;
      varName : ARRAY [0..127] OF CHAR;
      full: GrafBase.Rectangle;
      max : INTEGER;
BEGIN
  IF msgWindow.wdw >= 0
  THEN
    WITH msgWindow DO 
      v.bool := ConfVars.SetConfigBool (cfgOpen, TRUE);
      WdwManager.GetWdwSize (wdw, full); (* Gre des Fensters abfragen *)
      v.bool := ConfVars.SetConfigRect (cfgWindow, full);
      v.bool := ConfVars.SetConfigInt (cfgFont, font);
      v.bool := ConfVars.SetConfigInt (cfgFontSize, fontSize);
      v.bool := ConfVars.SetConfigInt (cfgLeftOffset, pixOffset);
      v.bool := ConfVars.SetConfigInt (cfgLineDist, lineDist);
    END;
  ELSE
    v.bool := ConfVars.SetConfigBool (cfgOpen, FALSE);
  END;
  Messages.SaveEditPos(max);
  v.bool := ConfVars.SetConfigInt (cfgMax, max);
END msgSavePos;

PROCEDURE msgRestorePos ();
  VAR num : INTEGER;
      i   : INTEGER;
      varName : ARRAY [0..127] OF CHAR;
      idx     : INTEGER;
      max     : INTEGER;
BEGIN
  IF ConfVars.GetConfigBool (cfgOpen, v.bool) & v.bool
  THEN
    msgOpen(FALSE);
  END;
  ConfVars.GetConfDefInt (cfgMax, max, -1);
  FOR i := 0 TO max DO 
    Strings.Concat (cfgEdit, StrConv.IntToStr (i, 0), varName, v.bool);
    IF ConfVars.GetConfigInt (varName, num) & (Messages.FindMessage (i) >= 0)
    THEN
      idx := Messages.FindMessage (i);
      IF ~Messages.msgArray^[idx].hdrRead
      THEN
        Messages.ReadHdrInfo (Messages.msgArray^[idx], FALSE);
      END;
      Messages.OpenEditor (Messages.msgArray^[idx], FALSE, num, 0, FALSE);
    END;
  END;
END msgRestorePos;

PROCEDURE msgUpdateInfo ();
BEGIN
  (* MSGINFO.DAT neu einlesen *)
  IF Messages.msgArray # NIL THEN DEALLOCATE (Messages.msgArray, 0); END;
  Messages.messages := 0;
  Messages.usedNumbers := Messages.msgNumberSet{};
  Messages.ReadMessageInfo();
  IF Messages.messages = 0
  THEN
    IF msgWindow.wdw >= 0
    THEN
      msgClose(msgWindow.wdw);
    END;
  END;
END msgUpdateInfo;

PROCEDURE msgCloseAll(force : BOOLEAN): BOOLEAN;
BEGIN
  IF ~Messages.CloseAllEditors (force)
  THEN
    RETURN FALSE
  END;
  IF msgWindow.wdw >= 0
  THEN
    msgClose(msgWindow.wdw);
  END;
  RETURN TRUE;
END msgCloseAll;

PROCEDURE MsgSetList (list: ADDRESS; doRedrawWdw: BOOLEAN);
(* Setzt die Liste fr das Fenster
 *)
BEGIN
  msgWindow.list := list;
  IF doRedrawWdw & (msgWindow.wdw >= 0) & ~msgWindow.isHidden
  THEN
    (* Fenster ist offen *)
    WdwManager.FullRedrawWdw (msgWindow.wdw);
  END;
END MsgSetList;

PROCEDURE MsgSetMaxPos (maxPos : INTEGER; doRedrawWdw: BOOLEAN);
(* Setzt die Maximalposition fr die Liste
 *)
BEGIN
  msgWindow.maxPos := maxPos; 
  IF msgWindow.startPos > msgWindow.maxPos 
  THEN 
    msgWindow.startPos := BinOps.HigherInt (0, msgWindow.maxPos-1) 
  END;
  IF doRedrawWdw
  THEN
    IF msgWindow.wdw >= 0
    THEN
      WITH msgWindow DO
        WdwManager.SetWdwDocument (wdw, GrafBase.LongRect{LONG(leftOffset), startPos, LONG(maxWidth), maxPos});
        WdwManager.FullRedrawWdw (msgWindow.wdw);
      END;
    END;
  END;
END MsgSetMaxPos;

PROCEDURE MsgCloseIfOpen ();
(* Schliet das Fenster, falls es offen ist
 *)
BEGIN
  IF msgWindow.wdw >= 0
  THEN
    v.bool := WdwManager.CloseWindow (msgWindow.wdw, TRUE);
  END; 
END MsgCloseIfOpen;

PROCEDURE MsgUpdateButtons ();
(* Aktualisiert die Buttons im Anzeigefenster passend zur Selektion 
 *)
BEGIN
  careForButtons (ADR(msgWindow), TRUE);
END MsgUpdateButtons;

PROCEDURE MsgRedrawEntry (idx: INTEGER);
(* Erzwingt das Neuzeichnen des Eintrags mit der Nummer idx 
 * im Fenster
 *)
BEGIN
  redrawEntry (idx);
END MsgRedrawEntry;

PROCEDURE MsgDeselectAll ();
(* Setzt den Selectindex auf -1 und erzwingt ggf. einen Redraw
 *)
BEGIN
  IF (msgWindow.wdw >= 0) & (msgWindow.sel >= 0) & ~(msgWindow.isHidden)
  THEN
    msgWindow.sel := -1;
    careForButtons (ADR(msgWindow), FALSE);
    WdwManager.FullRedrawWdw (msgWindow.wdw);
  END;
END MsgDeselectAll;

PROCEDURE InitMessageManager ();
(* Initialisiert das Modul und einige wichtige Daten
 * Ruft intern auch die Initialisierung vom Modul Messages auf
 *)
  VAR i : INTEGER;
BEGIN
  butBox := MausTauschrsc.TreeAddr^[MausTauschrsc.msgctrl];
  distSel := MausTauschrsc.TreeAddr^[MausTauschrsc.distribx];
  IF init # 23023
  THEN 
    v.bool := mtDials.NewDial (butBox);
  END;
  FOR i := MausTauschrsc.ctrledit TO MausTauschrsc.ctrldis2 DO
    mtUtils.InclState (butBox, i, MagicAES.DISABLED);
  END;
  init := 23023;
  Messages.InitMessages();
END InitMessageManager;

BEGIN
  msgWindow.wdw := -1;
  init := 0;
END MsgWindow.
