IMPLEMENTATION MODULE MTEdit2;

FROM SYSTEM IMPORT ADDRESS, ADR;

FROM Characters IMPORT CR, LF;

FROM Void       IMPORT v;

IMPORT CatEdit, UserInformation, Varnames, ConfVars, CatTypes, WildCards;

FROM CatOpts IMPORT buildVarName;

(*----------------------------------------------*)
VAR nextChar      : CHAR;
    nextScan      : CHAR;

PROCEDURE ChangeThisChar(wdw : INTEGER; VAR s, c : CHAR; VAR kstate : BITSET; VAR moreChars : BOOLEAN): BOOLEAN;
BEGIN
  moreChars := FALSE;
  IF UserInformation.UserBLK.UmlautWandler THEN
    IF nextChar # 0C THEN c := nextChar; s := nextScan; nextChar := 0C;
    ELSIF c = '' THEN c := 'A'; nextChar := 'e'; s := 36C; nextScan := 22C; moreChars := TRUE;
    ELSIF c = '' THEN c := 'O'; nextChar := 'e'; s := 30C; nextScan := 22C; moreChars := TRUE;
    ELSIF c = '' THEN c := 'U'; nextChar := 'e'; s := 26C; nextScan := 22C; moreChars := TRUE;
    ELSIF c = '' THEN c := 'a'; nextChar := 'e'; s := 36C; nextScan := 22C; moreChars := TRUE;
    ELSIF c = '' THEN c := 'o'; nextChar := 'e'; s := 30C; nextScan := 22C; moreChars := TRUE;
    ELSIF c = '' THEN c := 'u'; nextChar := 'e'; s := 26C; nextScan := 22C; moreChars := TRUE;
    ELSIF c = '' THEN c := 's'; nextChar := 's'; s := 37C; nextScan := 37C; moreChars := TRUE;
    ELSE
      nextChar := 0C;
    END
  ELSE
    nextChar := 0C;
  END;
  RETURN FALSE;
END ChangeThisChar;

PROCEDURE OpenEditWindow(VAR path, FileName : ARRAY OF CHAR; New, ReadOnly : BOOLEAN);
  VAR wdw : INTEGER;
      i     : INTEGER;
      found : BOOLEAN;
      varname   : CatTypes.String127;
      ext       : ARRAY [0..20] OF CHAR;
      tabs,
      margin    : INTEGER;
      succ,
      rtabs,
      wrap,
      errmode,
      doback    : BOOLEAN;
BEGIN
  i := 0;
  found := FALSE;
  WHILE (i <= 8) & ~found DO
    INC (i);
    buildVarName (cExtension, i, varname);
    IF ConfVars.GetConfigString (varname, ext) & (ext[0] # '')
    THEN
      found := WildCards.MatchName (FileName, ext, TRUE)
    END;
  END;
  IF found
  THEN
    (* Ein paar Einstellung holen *)
    buildVarName (cExtTabsize, i, varname);
    ConfVars.GetConfDefInt (varname, tabs, UserInformation.UserBLK.tabSize);
    buildVarName (cExtHardTabs, i, varname);
    ConfVars.GetConfDefBool (varname, rtabs, FALSE);
    buildVarName (cExtWordWrap, i, varname);
    ConfVars.GetConfDefBool (varname, wrap, FALSE);
    buildVarName (cExtRightMargin, i, varname);
    ConfVars.GetConfDefInt (varname, margin, 255);
    buildVarName (cExtAutoBackup, i, varname);
    ConfVars.GetConfDefBool (varname, doback, FALSE);
  ELSE
    tabs := UserInformation.UserBLK.tabSize; 
    rtabs := FALSE;
    wrap := FALSE; 
    margin := 255;
    doback := FALSE;
  END;
  v.bool := CatEdit.OpenEditor (path, FileName, New, 
                         FALSE, NIL, NIL, NIL, NIL, ADDRESS (ChangeThisChar), NIL, NIL, NIL,
                         margin, ~ReadOnly, wrap, -1, 
                         wdw);
  IF v.bool
  THEN
    CatEdit.SetMode (wdw, CatEdit.tabMode, rtabs);
    CatEdit.SetTabsize (wdw, tabs);
    CatEdit.SetMode (wdw, CatEdit.autoBackup, doback);
    CatEdit.SetMode (wdw, CatEdit.roMode, ReadOnly);
    ConfVars.GetConfDefBool (cAutoIndDflt, v.bool, TRUE);
    CatEdit.SetMode (wdw, CatEdit.indentMode, v.bool);
    IF ReadOnly THEN CatEdit.SetMode (wdw, CatEdit.effMode, TRUE); END;
  END;
END OpenEditWindow;

END MTEdit2.
