DEFINITION MODULE mtOlga;
(****************************************************************************
 *
 * Handling des Olga-Protokolles
 *
 *
 * $Source$
 *
 * $Revision$
 *
 * $Author$
 *
 * $Date$
 *
 * $State$
 *
 *****************************************************************************
 * History:
 *
 * $Log$
 *
 *
 ****************************************************************************)

(* Systemabhngiges *)
(* IMPLEMENTATION FR  >>> Hnisch-Modula-2 <<< *)
(*																							*)
(* Durchgefhrt von Steffen Engel 							*)
(*																							*)
(*$S- 	Stack-Checks														*)
(*$I- 	keine Variablen-Initialisierung 				*)
(*$V- 	keine arithmetischen Kontrollen 				*)
(*$T- 	kein Bereichstest 											*)
(*$Y- 	keine Laufzeittests auf RETURN und CASE *)
(*																							*)
(*----------------------------------------------*)



IMPORT SYSTEM, System;

(* Standard HM2-Libs *)

(* Magic-Lib *)
FROM MagicSys 	IMPORT
								(* Const *) Nil, Null, Bit0, Bit1, Bit2, Bit3, Bit4, Bit5,
														Bit6, Bit7, Bit8, Bit9, Bit10, Bit11, Bit12,
														Bit13, Bit14, Bit15,
								(* Type  *) LOC, Byte, ByteSet, sWORD, sINTEGER, sCARDINAL,
														sBITSET, lINTEGER, lCARDINAL, lWORD, lBITSET;

(* Magic-Tools *)

(* Eigene Libs *)

(* Projektlibs *)

TYPE
	tProgType 	= (Server, Client,	Res2,  Res3,	Res4, Res5, Res6, Res7,
								 Res8,	 Res9,	 Res10, Res11, Pipes, Res13, Res14, Res15);
	tsProgType	= SET OF tProgType;


	tObjType		= (Text, DTP, Editor, Database, Tabcalc, Raster,
								 Vektor, Graphics, Music, CAD, Comm, Desk, ProgShell);


(*-----------------------------------------------------------------------
 *
 * OLGA/OLE initialisieren
 * startet OLGA/OLE, wenn nicht vorhanden und meldet sich bei OLGA/OLE an
 * Die Antworten werden erst von Msg verarbeitet
 *
 *-----------------------------------------------------------------------*)
PROCEDURE Init(needOLE : BOOLEAN; progtype : tsProgType; objtype : tObjType);

PROCEDURE Exit;

TYPE
	tHandlerType	= (cUpdated);
	tHandleProc = RECORD
									CASE : tHandlerType OF
										|cUpdated : Updated : PROCEDURE(VAR (*$RO*) (* fname *) STRING,
																																(* index *) sCARDINAL,
																																(* Group *) sCARDINAL,
																																(* serverid *) sCARDINAL) : BOOLEAN;
										ELSE	proc : PROC;
									END;
								END;

(*-----------------------------------------------------------------------
 *
 * einen Handler installieren
 * Die Liste dieser Handler wird von Msg abgearbeitet. Wird ein passender
 * Handler gefunden, wird dieser aufgerufen.
 * liefert der Hndler TRUE gilt die Nachricht als verarbeitet, bei FALSE
 * wird nach weiteren Handler des passenen Types gesucht.
 * Damit knnen mehrere Handler fr einen Typ installiert werden, die nur
 * die sie betreffenden Teile auswerten.
 * Die Liste wird LIFO bearbeitet, wer als letztes installiert wurde,
 * bekommt als erstes angeboten.
 *
 * Ergebnis TRUE: Handler wurde aufgenommen
 *
 *-----------------------------------------------------------------------*)
PROCEDURE SetHandler(type : tHandlerType; proc : tHandleProc) : BOOLEAN;

(*-----------------------------------------------------------------------
 *
 * Einen Handler wieder entfernen
 * Es wird nur ein passender Handler deinstalliert. Damit ist es mglich, einen
 * Handler mehrfach zu installieren. ei der Deinstallation mssen gleich viele
 * Deinstallationen durchgefhrt werden, wie Installationen, bis der Handler
 * wirklich weg ist.
 *
 *-----------------------------------------------------------------------*)
PROCEDURE RemoveHandler(type : tHandlerType; proc : PROC);


(*-----------------------------------------------------------------------
 *
 * Ein Dokument wird geffnet
 *
 *-----------------------------------------------------------------------*)
PROCEDURE OpenDoc(GroupId : sCARDINAL);


(*-----------------------------------------------------------------------
 *
 * Ein Dokument wird geschlossen
 *
 *-----------------------------------------------------------------------*)
PROCEDURE CloseDoc(GroupId : sCARDINAL);


(*-----------------------------------------------------------------------
 *
 * Ein Dokument sol berwacht werden (Client)
 *
 *-----------------------------------------------------------------------*)
PROCEDURE Link(VAR (*$RO*) name : STRING; GroupId : sCARDINAL);


(*-----------------------------------------------------------------------
 *
 * Die berwachung kann beendet werden
 *
 *-----------------------------------------------------------------------*)
PROCEDURE Unlink(VAR (*$RO*) name : STRING; GroupId : sCARDINAL);



(*-----------------------------------------------------------------------
 *
 * Eine Datei wurde gespeichert, Mitteilung an OLGA versenden
 * Der Name darf flchtig sein, zur bergabe wird eine Kopie erstellt, die
 * automatisch von Msg wieder freigegeben wird.
 *
 *-----------------------------------------------------------------------*)
PROCEDURE Update(VAR (*$RO*) name : STRING);

(*------------------------------------------------------------------
 *
 *	Message verarbeiten
 *
 *	Es werden z.Zt. folgende Msgs (aus EvntMulti) verarbeitet:
 *
 *	OLE_NEW
 *	OLGA_INIT
 *	OLGA_UPDATED (an Handler)
 *	OLGA_ACK (von UPDATE, LINK, LINK_RENAMED
 *
 *
 *	RETURN :
 *
 *	 TRUE  : Msg wurde verarbeitet
 *	 FALSE : Msg geht mich nix an.
 *
(*------------------------------------------------------------------*)
PROCEDURE Msg (VAR (*$RO *)MsgBuffer : ARRAY OF LOC) : BOOLEAN;



END mtOlga.

		
	
	