IMPLEMENTATION MODULE mtOlga;
(****************************************************************************
*
*
* $Source$
*
* $Revision$
*
* $Author$
*
* $Date$
*
* $State$
*
*****************************************************************************
* History:
*
* $Log$
*
*
****************************************************************************)


(* Systemabhngiges *)
(* IMPLEMENTATION FR  >>> Hnisch-Modula-2 <<< *)
(*																							*)
(* Durchgefhrt von Steffen Engel 							*)
(*																							*)
(*$S- 	Stack-Checks														*)
(*$I- 	keine Variablen-Initialisierung 				*)
(*$V- 	keine arithmetischen Kontrollen 				*)
(*$T- 	kein Bereichstest 											*)
(*$Y- 	keine Laufzeittests auf RETURN und CASE *)
(*																							*)
(*----------------------------------------------*)



IMPORT
	SYSTEM,
	System,
	Portab;

(* Standard HM2-Libs *)
IMPORT
	Storage,
	Block;

(* Magic-Lib *)
FROM MagicSys 	IMPORT
							(* Const *) Nil, Null, Bit0, Bit1, Bit2, Bit3, Bit4, Bit5,
													Bit6, Bit7, Bit8, Bit9, Bit10, Bit11, Bit12,
													Bit13, Bit14, Bit15,
							(* Type  *) LOC, Byte, ByteSet, sWORD, sINTEGER, sCARDINAL,
													sBITSET, lINTEGER, lCARDINAL, lWORD, lBITSET;
IMPORT
	MagicDOS,
	MagicCookie,
	MagicStrings,
	MagicAES;

(* Magic-Tools *)
IMPORT
	mtCommand,
	mtAppl;

(* Eigene Libs *)

(* Projektlibs *)

CONST

OLE_INIT								 = 04950H;
OLE_EXIT								 = 04951H;
OLE_NEW 								 = 04952H;

OLGA_INIT 							 = 01236H;
OLGA_UPDATE 						 = 01238H;
OLGA_ACK								 = 01239H;
OLGA_RENAME 						 = 0123AH;
OLGA_OPENDOC						 = 0123BH;
OLGA_CLOSEDOC 					 = 0123CH;
OLGA_LINK 							 = 0123DH;
OLGA_UNLINK 						 = 0123EH;
OLGA_UPDATED						 = 0123FH;
OLGA_RENAMELINK 				 = 01240H;
OLGA_LINKRENAMED				 = 01241H;
OLGA_GETOBJECTS 				 = 01242H;
OLGA_OBJECTS						 = 01243H;
OLGA_BREAKLINK					 = 01244H;
OLGA_LINKBROKEN 				 = 01245H;
OLGA_START							 = 01246H;
OLGA_GETINFO						 = 01247H;
OLGA_INFO 							 = 01248H;
OLGA_IDLE 							 = 01249H;
OLGA_ACTIVATE 					 = 0124AH;
OLGA_EMBED							 = 0124BH;
OLGA_EMBEDDED 					 = 0124CH;
OLGA_UNEMBED						 = 0124DH;
OLGA_GETSETTINGS				 = 0124EH;
OLGA_SETTINGS 					 = 0124FH;
OLGA_REQUESTNOTIFICATION = 01250H;
OLGA_RELEASENOTIFICATION = 01251H;
OLGA_NOTIFY 						 = 01252H;
OLGA_NOTIFIED 					 = 01253H;
OLGA_SERVERTERMINATED 	 = 01254H;
OLGA_CLIENTTERMINATED 	 = 01255H;
OLGA_INPLACEUPDATE			 = 01256H;

OL_SERVER 							 = 00001H;
OL_CLIENT 							 = 00002H;
OL_PEER 								 = OL_SERVER + OL_CLIENT;
OL_IDLE 								 = 00800H;
OL_PIPES								 = 01000H;
OL_START								 = 02000H;
OL_MANAGER							 = 04000H;

OL_OEP									 = Bit0;

OLS_TYPE								 =		 1;
OLS_EXTENSION 					 =		 2;
OLS_NAME								 =		 3;

TYPE
	tMsg	= RECORD
						code		 : sCARDINAL;
						apid		 : sINTEGER;
						oversize : sCARDINAL;

						CASE (* code *) : sCARDINAL OF
							|OLE_INIT:
									progType							: tsProgType;
									ProtoVersion					: sCARDINAL;
									oep 									: sBITSET;
									ini_res 							: sCARDINAL;
									xacctype							: sCARDINAL;
							|OLE_NEW:
									olenew_progType 			: tsProgType;
									olenew_ProtoVersion 	: sCARDINAL;
									olenew_oep						: sBITSET;
									olenew_res						: sCARDINAL;
									olenew_managerversion : sCARDINAL;
							|OLGA_INIT:
									initmanager 					: sBITSET;
									olgainit_Protoversion : sCARDINAL;
									olgainit_res5 				: sCARDINAL;
									olgainit_res6 				: sCARDINAL;
									CanOL 								: sCARDINAL;
							|OLE_EXIT:
							|OLGA_UPDATE:
									update_pName					: Portab.tpStr;
									Index 								: sCARDINAL;

							|OLGA_ACK:
									ack_res 							: ARRAY[3..6] OF sCARDINAL;
									whichacknowledge			: sCARDINAL;

							|OLGA_LINK,
							 OLGA_UNLINK:
									link_pName						: Portab.tpStr;
									link_Group						: sCARDINAL;

							|OLGA_OPENDOC,
							 OLGA_CLOSEDOC:
									open_res							: ARRAY[3..4] OF sCARDINAL;
									open_Group						: sCARDINAL;

							 |OLGA_UPDATED:
									upd_pName 						: Portab.tpStr;
									upd_Index 						: sCARDINAL;
									upd_serverid					: sCARDINAL;
									upd_group 						: sCARDINAL;
							ELSE int: ARRAY [3..7] OF sWORD;
						END;
					END;


	tHandler			= RECORD
										Type : tHandlerType;
										Call : tHandleProc;
									END;

	tpHandlerTab	= POINTER TO tHandlerTab;
	tHandlerTab 	= RECORD
										Handler : tHandler;
										next		: tpHandlerTab;
									END;





VAR
	MyProgType	: tsProgType;
	MyObjType 	: tObjType;
	ServerCanOL : BOOLEAN;
	OLEApId,
	OLGAApId		: sINTEGER;
	HandlerTab	: tpHandlerTab;

(*-----------------------------------------------------------------------
 *
 * Aktivierung und Beendigung
 *
 *-----------------------------------------------------------------------*)
PROCEDURE DoInit(ApId : sINTEGER; progtype : tsProgType; objtype : tObjType);

VAR

	Msg : tMsg;

	BEGIN

		OLGAApId := ApId;

		Block.Clear(SYSTEM.ADR(Msg), SIZE(Msg));

		WITH Msg DO

			code := OLE_INIT;

			apid := mtAppl.ApplIdent;

			oversize := 0;

			progType := progtype;

			ProtoVersion := 0;

			oep := {};

			ini_res := 0;

			CASE objtype OF

				|Text:

						 xacctype := sCARDINAL("WP");

				|DTP:

						 xacctype := sCARDINAL("DP");

				|Editor:

						 xacctype := sCARDINAL("ED");

				|Database:

						 xacctype := sCARDINAL("DB");

				|Tabcalc:

						 xacctype := sCARDINAL("SS");

				|Raster:

						 xacctype := sCARDINAL("RG");

				|Vektor:

						 xacctype := sCARDINAL("VG");

				|Graphics:

						 xacctype := sCARDINAL("GG");

				|Music:

						 xacctype := sCARDINAL("MU");

				|CAD:

						 xacctype := sCARDINAL("CD");

				|Comm:

						 xacctype := sCARDINAL("DC");

				|Desk:

						 xacctype := sCARDINAL("DT");

				|ProgShell:

						 xacctype := sCARDINAL("PE");

			ELSE

				HALT;  (* ganz schlecht!!! *)

			END;

		END;

		MagicAES.ApplWrite(OLGAApId, 16, Msg);

	END DoInit;


PROCEDURE Init(needOLE : BOOLEAN; progtype : tsProgType; objtype : tObjType);

VAR

	olgaapid, oepapid : sINTEGER;

	OlePath : Portab.tPath;


	PROCEDURE Start(VAR Name : STRING) : sINTEGER;

	VAR

		ret 	: lCARDINAL;

		mode	: sCARDINAL;


		BEGIN

			IF MagicCookie.FindCookie('MagX', ret)

			THEN

				mode := 100;

			ELSE

				mode := 0;

			END;

			RETURN MagicAES.ShelWrite(1, 1, mode, Name, "");

		END Start;



BEGIN

	MyProgType := progtype;

	MyObjType  := objtype;


	olgaapid := MagicAES.ApplFind("OLGA    ");

	oepapid  := MagicAES.ApplFind("OEP_SERV");

	IF olgaapid < 0

	THEN


		(* den Managername holen *)

		IF mtCommand.EnvVar ("OLGAMANAGER", OlePath)

		THEN

			olgaapid := Start(OlePath);

		ELSE

			IF mtCommand.EnvVar ("OEPSERVER", OlePath)

			THEN

				olgaapid := Start(OlePath);

			END;

		END;

	END;


	IF olgaapid >= 0

	THEN

		DoInit(olgaapid, progtype, objtype);

	END;

END Init;


PROCEDURE Exit;

VAR

	Msg : tMsg;


BEGIN

	IF OLGAApId # -1

	THEN

		Block.Clear(SYSTEM.ADR(Msg), SIZE(Msg));

		WITH Msg DO

			code := OLE_EXIT;

			apid := mtAppl.ApplIdent;

			oversize := 0;

		END;

		MagicAES.ApplWrite(OLGAApId, 16, Msg);

	END;

END Exit;

(*-----------------------------------------------------------------------
 *
 * Setzen/Lschen von Handlern
 *
 *-----------------------------------------------------------------------*)
PROCEDURE SetHandler(type : tHandlerType; proc : tHandleProc) : BOOLEAN;

VAR

	pHandler : tpHandlerTab;


	BEGIN

		Storage.ALLOCATE(pHandler, SIZE(pHandler^));

		IF pHandler = NIL

		THEN

			RETURN FALSE;

		END;


		pHandler^.Handler.Type := type;

		pHandler^.Handler.Call.proc := proc.proc;


		(* und einketten *)

		pHandler^.next := HandlerTab;

		HandlerTab := pHandler;


		RETURN TRUE;

	END SetHandler;


PROCEDURE RemoveHandler(type : tHandlerType; proc : PROC);

VAR

	pHandler, RemoveHandler : tpHandlerTab;


	BEGIN

		pHandler := HandlerTab;


		(* ist es der erste in der Kette? *)

		IF (HandlerTab # NIL)

			AND (HandlerTab^.Handler.Call.proc = proc)

			AND (HandlerTab^.Handler.Type = type)

		THEN

			HandlerTab := HandlerTab^.next;

			Storage.DEALLOCATE(pHandler, 0);

		ELSE

			WHILE pHandler # NIL DO

				RemoveHandler := pHandler^.next;

				IF (RemoveHandler # NIL)

					AND (RemoveHandler^.Handler.Call.proc = proc)

					AND (RemoveHandler^.Handler.Type = type)

				THEN

					pHandler^.next := RemoveHandler^.next;

					Storage.DEALLOCATE(RemoveHandler, 0);

					RETURN;

				END;


				pHandler := pHandler^.next;

			END;

		END;


	END RemoveHandler;

(*-----------------------------------------------------------------------
 *
 * Abzusetzende Mitteilungen
 *
 *-----------------------------------------------------------------------*)
PROCEDURE Update(VAR (*$RO*) name : STRING);

VAR

	Msg : tMsg;

BEGIN

	IF OLGAApId # -1

	THEN

		Block.Clear(SYSTEM.ADR(Msg), SIZE(Msg));

		WITH Msg DO

			code := OLGA_UPDATE;

			apid := mtAppl.ApplIdent;

			oversize := 0;

			Storage.ALLOCATE(update_pName, LENGTH(name)+1);

			MagicStrings.Assign(name, update_pName^);

		END;

		MagicAES.ApplWrite(OLGAApId, 16, Msg);

	END;


END Update;


PROCEDURE OpenDoc(GroupId : sCARDINAL);

VAR

	Msg : tMsg;

BEGIN

	IF OLGAApId # -1

	THEN

		Block.Clear(SYSTEM.ADR(Msg), SIZE(Msg));

		WITH Msg DO

			code := OLGA_OPENDOC;

			apid := mtAppl.ApplIdent;

			oversize := 0;

			open_Group := GroupId;

		END;

		MagicAES.ApplWrite(OLGAApId, 16, Msg);

	END;

END OpenDoc;


PROCEDURE CloseDoc(GroupId : sCARDINAL);

VAR

	Msg : tMsg;

BEGIN

	IF OLGAApId # -1

	THEN

		Block.Clear(SYSTEM.ADR(Msg), SIZE(Msg));

		WITH Msg DO

			code := OLGA_CLOSEDOC;

			apid := mtAppl.ApplIdent;

			oversize := 0;

			open_Group := GroupId;

		END;

		MagicAES.ApplWrite(OLGAApId, 16, Msg);

	END;

END CloseDoc;


PROCEDURE Link(VAR (*$RO*) name : STRING; GroupId : sCARDINAL);

VAR

	Msg : tMsg;

BEGIN

	IF OLGAApId # -1

	THEN

		Block.Clear(SYSTEM.ADR(Msg), SIZE(Msg));

		WITH Msg DO

			code := OLGA_LINK;

			apid := mtAppl.ApplIdent;

			oversize := 0;

			Storage.ALLOCATE(link_pName, LENGTH(name)+1);

			MagicStrings.Assign(name, link_pName^);

			link_Group := GroupId;

		END;

		MagicAES.ApplWrite(OLGAApId, 16, Msg);

	END;

END Link;


PROCEDURE Unlink(VAR (*$RO*) name : STRING; GroupId : sCARDINAL);

VAR

	Msg : tMsg;

BEGIN

	IF OLGAApId # -1

	THEN

		Block.Clear(SYSTEM.ADR(Msg), SIZE(Msg));

		WITH Msg DO

			code := OLGA_UNLINK;

			apid := mtAppl.ApplIdent;

			oversize := 0;

			Storage.ALLOCATE(link_pName, LENGTH(name)+1);

			MagicStrings.Assign(name, link_pName^);

			link_Group := GroupId;

		END;

		MagicAES.ApplWrite(OLGAApId, 16, Msg);

	END;


END Unlink;


(*-----------------------------------------------------------------------
 *
 * Handling von Nachrichten
 *
 *-----------------------------------------------------------------------*)
PROCEDURE Acknowledge(VAR (*$RO*) Msg : tMsg);

VAR

	pName : Portab.tpStr;


	BEGIN

		CASE Msg.whichacknowledge OF

			|OLGA_UPDATE,

			 OLGA_UNLINK,

			 OLGA_LINK:

					pName := Msg.update_pName;

					Storage.DEALLOCATE(pName, 0);

		ELSE

		END;

	END Acknowledge;


PROCEDURE Updated(VAR (*$RO*) Msg : tMsg);
VAR
	pHandler : tpHandlerTab;

	BEGIN
		pHandler := HandlerTab;
		WHILE (pHandler # NIL) DO
			IF (pHandler^.Handler.Type = cUpdated)
				AND (pHandler^.Handler.Call.Updated(Msg.upd_pName^, Msg.upd_Index,
																						Msg.upd_group, Msg.upd_serverid))
			THEN
				RETURN; 	(* bearbeitet *)
			END;
			pHandler := pHandler^.next;
		END;
	END Updated;


PROCEDURE Msg (VAR (*$RO*) MsgBuffer : ARRAY OF LOC) : BOOLEAN;

VAR

	pMsg : POINTER TO tMsg;


	BEGIN

		pMsg := SYSTEM.ADR(MsgBuffer);

		CASE pMsg^.code OF

			|OLE_NEW : (* Empfang eines nachgestarteten Managers *)

					(* Antwort *)

					DoInit(pMsg^.apid, MyProgType, MyObjType);

		ELSE

			CASE pMsg^.code OF

				|OLGA_INIT :

						OLGAApId := pMsg^.apid;

						ServerCanOL := pMsg^.CanOL # 0;

				|OLGA_ACK:

						Acknowledge(pMsg^);

				|OLGA_UPDATED:

						IF pMsg^.upd_serverid # sCARDINAL(mtAppl.ApplIdent)

						THEN

							Updated(pMsg^);

						END;

			ELSE

				RETURN FALSE;

			END;

		END;

		RETURN TRUE;

	END Msg;



BEGIN
	OLGAApId := -1;
	OLEApId := -1;
	ServerCanOL := FALSE;
	HandlerTab := NIL;
END mtOlga.

		
	
	