DEFINITION MODULE Protokoll;

(*

XAcc und AV/VA-Protokoll in Modula-2

Autor : Johannes Gttker-Schnetmann

Last Change : 26.02.1991

*)

FROM SYSTEM IMPORT ADDRESS;
FROM CatTypes IMPORT Str255Ptr;
IMPORT data;

TYPE React        = (rNoproto, rNone, rChar, rText, rStart, rOpen, rExtCatMsg);

CONST
  (* Sub-Opcodes fr ExtCatMsg *)
  CatReadMsgInfo    = 1;    (* MSGINFO.DAT neu einlesen *)

(* Das mu der WatchDog bekommen, jetzt kommt etwas mehr
TYPE WatchDogMsg = RECORD
       PtrGruppe,
       PtrName,
       PtrBetreff,
       PtrText    : ADDRESS;
       TextLength : CARDINAL
     END;
*)

PROCEDURE IsProtokoll(mess : ADDRESS;
                     VAR kReturn : INTEGER; VAR mokState : BITSET;
                     VAR pName, pCmd : Str255Ptr):React;


PROCEDURE SendNewMsgInWdw ();
(* Angemeldeten ACCs mitteilen, das eine neue Nachricht im
 * obersten Anzeigefenster ist
 *)

PROCEDURE SendProgstart(error : BOOLEAN);
(* dem Acc mitteilen, ob der Programmstart geklappt hat, not yet implementet *)

PROCEDURE SendAcknowledge (apId : INTEGER; succ: BOOLEAN);
(* dem Acc mitteilen, das ACC_TEXT oder ACC_KEY geklappt haben *)

PROCEDURE SendOpenwind (id : INTEGER; path, name : ADDRESS);
(* einer anderen Applikation sagen, das sie ein Fenster ffnen soll
 * ist fr den Fall, das CAT oder Eddix schon geffnet sind, dann wird 
 * diese Message verschickt.
 *)

PROCEDURE Send2Filter (to: INTEGER; length: CARDINAL; what: ADDRESS): BOOLEAN;
(* Sendet eine Nachricht mit Filterdaten an ein anderes Programm
 * oder ein Accessory
 *)

PROCEDURE SendHelp (VAR str : ARRAY OF CHAR);
(* Untersttzung fr PC-Help Protokoll. Sendet einmal Help aus. *)

PROCEDURE SendExtendedHelp (VAR str : ARRAY OF CHAR; VAR helpText: ARRAY OF CHAR): BOOLEAN;
(* Untersttzung fr PC-Help Protokoll. Sendet einmal Help aus,
 * mit Erweiterung um Vorzugsnamen des Hilfetextes. 
 *)

PROCEDURE SendPrintFile (REF path, name: ARRAY OF CHAR; withEffects: BOOLEAN): BOOLEAN;
(* Druckt die angegebene Datei ber Idealist bzw. das CALCLOCK-Protokoll
 *)

PROCEDURE SendPathUpdate (REF path: ARRAY OF CHAR);
(* Schickt ein AV_PATH_UPDATE an den AV_SERVER *)

PROCEDURE SendTextReady();
(* not yet implementet, fr xAcc-Protokoll, senden, sobald der Text bernommen ist *)

PROCEDURE SendTerminate(terminate: BOOLEAN);
(* Beim WatchDog abmelden *)

TYPE watchType = (pCatAccept, pCatForget, pCatFiltered);

PROCEDURE AcceptThis(VAR mess : data.PtrRecord):watchType;
(* Soll diese Nachricht durchkommen, Frage von Datenbank an installierten WatchDog *)

PROCEDURE isWatchDog(VAR installed, active : BOOLEAN);
(* Ist der WatchDog angemeldet und aktiv? *)

PROCEDURE ProtoInit ();
(* XACC-Initialisierung unter MTOS *)

END Protokoll.
