IMPLEMENTATION MODULE RectFuncs;

FROM GrafBase   IMPORT Rectangle;

IMPORT BinOps;

PROCEDURE rcIntersect(VAR p1, p2 : Rectangle):BOOLEAN;
VAR tx, ty, tw, th : INTEGER;
BEGIN
  tw := BinOps.LowerInt(p2.x + p2.w, p1.x + p1.w);
  th := BinOps.LowerInt(p2.y + p2.h, p1.y + p1.h);
  tx := BinOps.HigherInt(p2.x, p1.x);
  ty := BinOps.HigherInt(p2.y, p1.y);
  p2.x := tx;
  p2.y := ty;
  p2.w := tw - tx;
  p2.h := th - ty;
  RETURN (tw > tx) & (th > ty);
END rcIntersect;

PROCEDURE ClipRect (frame: Rectangle; clip: Rectangle): Rectangle;
(* clippt das Rechteck frame auf das Rechteck clip
 *)
BEGIN
  WITH frame DO
    IF x<clip.x THEN w:=w-clip.x+x; x:=clip.x END;
    IF y<clip.y THEN h:=h-clip.y+y; y:=clip.y END;
    IF (w<0) OR (h<0) THEN w:=0;h:=0 END;
    IF (x+w)>(clip.x+clip.w) THEN w:=clip.x+clip.w-x END;
    IF (y+h)>(clip.y+clip.h) THEN h:=clip.y+clip.h-y END;
    IF (w<0) OR (h<0) THEN w:=0;h:=0 END;
  END;
  RETURN frame;
END ClipRect;
  
PROCEDURE IsInRect (x,y : INTEGER; r : Rectangle) : BOOLEAN;
(* Stellt fest, ob der Punkt mit den Koordinaten x,y im Rechteck r liegt *)
BEGIN
  RETURN (x >= r.x) & (x < r.x+r.w) & (y >= r.y) & (y <= r.y+r.h);
END IsInRect;

PROCEDURE RectEqual (REF r1, r2 : Rectangle): BOOLEAN;
(* Stellt fest, ob die Rechtecke r1 und r2 identisch sind *)
BEGIN
  WITH r1 DO
    RETURN (x = r2.x) & (y = r2.y) & (w = r2.w) & (h = r2.h)
  END;
END RectEqual;

END RectFuncs.
