DEFINITION MODULE SearchHelp;

(*==============================================================*
 * Modul:               Zwischenmodul fr die Suche             *
 * Autor:               Johannes Gttker-Schnetmann             *
 * erstellt am:         13.08.1993                              *
 * letzte nderung am:  05.09.1993                              *
 * Version:             1.0                                     *
 * Interne Version:     V#0001                                  *
 *==============================================================*

 *----------------------------------------------------------------------------
 * Datum    Vers. Autor  nderung (Arbeitsbericht)
 *----------------------------------------------------------------------------
 * 05.09.93 0001  JGS    Neue Typen deklariert
*)

CONST vUND = 0; vODER = 1;

CONST sUEBERALL = 0;     sTEXT = 1;         sBETREFF= 2;    sTEXTnBETREFF = 3;
      sABSENDER = 4;    sEMPFAENGER = 5;    sID = 6;

(* Achtung, bereinstimmung mit der Resourcedatei ist wichtig! *)
(* ZSearchDial geht implizit von der richtigen Zuordnung aus!  *)

CONST suchstringAnz   = 4; (* Vier Suchstrings gibt es in der Suchbox von CAT *)

TYPE searchStrType    = ARRAY[0..59] OF CHAR;
TYPE searchStrArray   = ARRAY[0..suchstringAnz-1] OF searchStrType;
TYPE verknType        = ARRAY[0..suchstringAnz-2] OF INTEGER;
TYPE woType           = ARRAY[0..suchstringAnz-1] OF INTEGER;
TYPE SearchRecordType = RECORD 
                          searchStr : searchStrArray;
                          verkn     : verknType; (* = (vUND, vODER); *)
                          wo        : woType;
                          show, change, statussearch, ask, 
                          searchText, gross, groupsearch : BOOLEAN;
                          sSetBits, sClearedBits, setBits, clearBits : BITSET;
                        END;

VAR suchVar   : SearchRecordType;

(* Das ist jetzt vorlufig redundant. Beide Variablen werden gesetzt, auf Dauer *)
(* soll aber nur das Record drin bleiben!                                       *)

PROCEDURE IsValidSearch (str: ARRAY OF CHAR): BOOLEAN;
(* Prft einen Suchstring, ob er gltig ist. 
 * FALSE: Suchstring ist nicht gltig.
 *)

PROCEDURE ValidateKonf (VAR konf: SearchRecordType): BOOLEAN;
(* Prft die bergebene Suchkonfiguration auf Gltigkeit. 
 *)

PROCEDURE getKonf(nr : CARDINAL; VAR konf : SearchRecordType):BOOLEAN;
(* Suchkonfiguration <nr> abrufen, FALSE -> nicht gesetzt *)
(* mglich sind im Moment die Nummern 0..9 *)

PROCEDURE setKonf(nr : CARDINAL; konf : SearchRecordType):BOOLEAN;
(* Suchkonfiguration <nr> setzen *)
(* Gibt zurck, ob die Variablen angelegt werden konnten *)

END SearchHelp.
