DEFINITION MODULE SearchMenu;

(************************************************************************)
(*                                                                      *)
(*      MenuSearch - Prozedur in Megamax-Modula-2                       *)
(*              von     Dirk Steins                                     *)
(*                      Auf dem Feldchen 48                             *)
(*                      5216 Niederkassel-6                             *)
(*                                                                      *)
(*      Original in C (Zeeh) in ST-Computer 11/89 von Urs Mller        *)
(*                                                                      *)
(*  Aufruf:                                                             *)
(*                                                                      *)
(*      res := MenuSearch( mTree, apId, kstate, key);                   *)
(*                                                                      *)
(*      mTree : PtrObjTree von Menubaum                                 *)
(*               (ber ResourceGetAddr(treeRsrc, xxxx, mTree) holen     *)
(*      apId  : ID der aufrufenden Applikation                          *)
(*               (liefert GEMEnv.ApplicationID)                         *)
(*      kstate: Status der Sondertasten                                 *)
(*               (liefert AESEvents.MultiEvent(...) )                   *)
(*      key   : gedrckte Taste (ASCII & Scan-Code)                     *)
(*               (liefert AESEvents.MultiEvent(...) )                   *)
(*                                                                      *)
(*      res : BOOLEAN =     TRUE  Passender Eintrag gefunden.           *)
(*                          FALSE Kein passender Eintrag gefunden.      *)
(*                                                                      *)
(*  MenuSearch bietet Tastenuntersttzung fr GEM-Pulldown-Menus.       *)
(*  Es werden alle Menueintrge des bergebenen Menubaums nach den      *)
(*  letzen Buchstaben untersucht. Wird bei einem Menueintrag eine       *)
(*  bereinstimmung mit den Werten von kstate und key gefunden und      *)
(*  ist das Menu bzw. der Eintrag nicht 'disabled', so wird eine        *)
(*  Meldung 'menuSelected' an die aufrufende Applikation geschickt.     *)
(*                                                                      *)
(*  Mgliche Werte fr die letzten Buchstaben in einem Menu:            *)
(*                                                                      *)
(*      "F1" bis "F10"  : Funktionstasten                               *)
(*      "F11" bis "F20" : Shift & Funktionstasten                       *)
(*      [Shift]"F1" bis [Shift]"F10": Shift & Funktionstasten           *)
(*                [Shift] = ASCII(1) oder 'S'                           *)
(*                                                                      *)
(*      "^" & Buchstabe : Control & Buchstabe                           *)
(*      Fullbox-Symbol & Buchstabe: Alternate & Buchstabe               *)
(*      Hochkomma-Buchstabe-Hochkomma : Buchstabe ohne Control & Alt    *)
(*                                                                      *)
(*  Es wird keine Unterscheidung zwischen Gro- und Kleinbuchstaben     *)
(*  vorgenommen, d.h. "^a" und "^A" sind gleich!!                       *)
(*                                                                      *)
(*                                                                      *)
(************************************************************************)

FROM SYSTEM         IMPORT BYTE, ADDRESS;

FROM GEMGlobals     IMPORT PtrObjTree, GemChar, SpecialKeySet;

TYPE  menuProc = PROCEDURE(CARDINAL, CARDINAL, BITSET); (* item, title, kbshift*)

PROCEDURE MenuSearch ( mTree : ADDRESS; apId : INTEGER;
                       kstate : BITSET; key : INTEGER;
                       hdlMenu : menuProc;
                       showMouse : BOOLEAN) : BOOLEAN;


(* Fr TDI leider nicht brauchbar:
 
PROCEDURE InstallMenuSearch (menu : PtrObjTree; apId : CARDINAL);
(* Ab MM2 Version 2.1 kann man ber eine Hilfsprozedur  *)
(* MenuSearch mittels InstallWatchDog installieren.     *)
(* Dies wird durch diese Prozedur erledigt.      *)

PROCEDURE DeInstallMenuSearch ();
(* Meldet MenuSearch wieder ab. Es ist nicht unbedingt                  *)
(* ntig, diese Prozedur aufzurufen, da bei der Terminierung des Moduls *)
(* MenuSearch automatisch wieder abgemeldet wird.                       *)

*)

END SearchMenu.
