IMPLEMENTATION MODULE SearchMenu;
(*$R-,S-*)

(************************************************************************)
(*                                                                      *)
(*      MenuSearch - Prozedur in Megamax-Modula-2                       *)
(*              von     Dirk Steins                                     *)
(*                      Auf dem Feldchen 48                             *)
(*                      5216 Niederkassel-6                             *)
(*                                                                      *)
(*      Original in C (Zeeh) in ST-Computer 11/89 von Urs Mller        *)
(*                                                                      *)
(*      Ist halt bersetzt aus C, deshalb teilweise nicht sehr          *)
(*      schn zu lesen.                                                 *)
(*                                                                      *)
(************************************************************************)

FROM SYSTEM         IMPORT ADDRESS, ADR, BYTE;

IMPORT MagicAES;
IMPORT MagicXBIOS;
IMPORT MagicStrings;
IMPORT mtAppl;

FROM GEMGlobals     IMPORT  PtrObjTree, SpecialKey, SpecialKeySet,
                            GemChar, OStateSet, ObjState, ObjType,
                            PtrMaxStr;
(*
FROM ObjHandler     IMPORT  SetCurrObjTree, ObjectState, ObjectType;
*)
(* Erweiterung fr TDI: ein paar Funktionen aus ObjHandler *)
MODULE ObjcHandler;

IMPORT OStateSet, ObjState, ObjType, PtrObjTree;
 
EXPORT  SetCurrObjTree, ObjectState, ObjectType;

(*
TYPE    ObjType         = (boxObj, textObj, boxTextObj, imageObj, progDefObj,
                           iBoxObj, buttonObj, boxCharObj, stringObj, fTextObj,
                           fBoxTextObj, iconObj, titleObj);

        ObjState        = (selectObj, crossObj, checkObj, disableObj,
                           outlineObj, shadowObj);
        
        OStateSet       = SET OF ObjState;
*)
VAR     currTree : PtrObjTree;
        treeErr : BOOLEAN;

PROCEDURE SetCurrObjTree (tree : PtrObjTree);
        (*  Setzt aktuellen Objektbaum *)
BEGIN
  currTree := tree;
  IF tree = NIL
  THEN
    treeErr := TRUE
  ELSE
    treeErr := FALSE
  END;
END SetCurrObjTree;

PROCEDURE ObjectState (obj: CARDINAL): OStateSet;
        (*  Liefert den Objektstatus des Objektes 'obj'.
         *)
BEGIN
  IF currTree = NIL
  THEN
    treeErr := TRUE;
    RETURN OStateSet{};
  ELSE
    RETURN OStateSet(currTree^[obj].state);
  END;
END ObjectState;

PROCEDURE ObjectType (obj: CARDINAL): ObjType;
        (*  Liefert Objekttyp des Objektes 'obj'.
         *)
BEGIN
  IF currTree = NIL
  THEN
    treeErr := TRUE;
    RETURN boxObj;
  ELSE
    RETURN ObjType(currTree^[obj].type-20);
  END;
END ObjectType;

BEGIN
  treeErr := FALSE;
END ObjcHandler;
(* *)

VAR   keyTable: MagicXBIOS.PtrKEYTAB;
      Unshift,
      Shift,
      CapsLock : MagicXBIOS.Keycode;

TYPE charSet = SET OF CHAR;

VAR ctrlSet, altSet, normalSet : charSet;
    where     : ARRAY[0..80] OF RECORD char : CHAR; shiftCode : CARDINAL; entry, title : CARDINAL; END;
    nextWhere : CARDINAL;
    checkIt   : BOOLEAN;


(* TestEntry testet einen String ab, ob darin eine der untersttzen     *)
(* Tastenkombinationen enthalten ist.                                   *)
(* str: der zu untersuchende String                                     *)
(* ch : ASCII und Scan-Code der gedrckten Taste                        *)
(* state : Tastatur-Status                                              *)

PROCEDURE TestEntry (str : PtrMaxStr; entry, title : CARDINAL);
  
  CONST
      (* noch nicht untersttzte Tasten *)
      clrHome = BYTE (71);    (*  <Clr>-Taste  *)
      delete  = BYTE (83);    (*  <Delete>-Taste  *)
      help    = BYTE (98);    (*  <Help>-Taste  *)
      escape  = BYTE (1);     (*  <Esc>-Taste  *)
      
      (* untersttzte Tasten *)
      F1    = 03bH;   (* Scan-Codes der Funktionstasten *)
      F10   = 044H;
      F11   = 054H;
      F20   = 05dH;
  TYPE  CharSet = SET OF CHAR;
  CONST compSet    = CharSet{'A'..'Z','',"'",'#',',','.','-','+','*','/'};

  VAR compChar : CHAR;
      idx   : INTEGER;
      zahl  : INTEGER;
BEGIN
  idx := MagicStrings.Length (str^)-1;              (* index auf Lnge des Eintrags *)
  WHILE str^[idx]=' ' DO DEC(idx) END; (* Space am Ende ignorieren     *)
  compChar := CAP(str^[idx]);          (* nur Grobuchstaben           *)

  IF (* (compChar >= 'A') & (compChar <= 'Z') *) compChar IN compSet THEN
    (* Test auf Control-Buchstabe oder Alt-Buchstabe *)
    DEC(idx);
    IF str^[idx]='^' THEN
      INCL(ctrlSet, compChar);
      where[nextWhere].char      := compChar;
      where[nextWhere].shiftCode := MagicAES.KCTRL;
      where[nextWhere].entry     := entry;
      where[nextWhere].title     := title;
      INC(nextWhere);
      RETURN
    END;
    IF ORD(str^[idx])=7 THEN
      INCL(altSet, compChar);
      where[nextWhere].char      := compChar;
      where[nextWhere].shiftCode := MagicAES.KALT;
      where[nextWhere].entry     := entry;
      where[nextWhere].title     := title;
      INC(nextWhere);
      RETURN
    END;
       (* FullBox-Zeichen fr Alternate *)
(* Normale Buchstaben auch ersma nich *)
  ELSIF (str^[idx]="'") THEN
    (* Test auf Buchstabe in Hochkommata *)
    DEC(idx);
    compChar := CAP(str^[idx]);
    IF (compChar >= 'A') & (compChar <= 'Z') & (str^[idx-1] = "'") THEN
      INCL(normalSet, compChar);
      where[nextWhere].char      := compChar;
      where[nextWhere].shiftCode := 0FFFFH;
      where[nextWhere].entry     := entry;
      where[nextWhere].title     := title;
      INC(nextWhere);
      RETURN
    END;
(* -- *)
  END;
(* Funktionstasten fallen erstmal weg..

  ELSIF (str^[idx]>='0') & (str^[idx]<='9')
  THEN
    (* Test auf Funktionstaste *)
    zahl := ORD(str^[idx])-ORD('0');       (* Wandeln CHAR -> INT *)
    DEC(idx);
    IF (str^[idx]>='0') & (str^[idx]<='9')     (* Buchstabe ist Zahl ? *)
    THEN
      zahl := zahl + INTEGER(10*(ORD(str^[idx])-ORD('0')));
      DEC (idx);
    END (* IF str^[idx]= ... *);
    IF (str^[idx]='F')
    THEN
      IF ((ORD(str^[idx-1])=1) OR (str^[idx-1]='S')) (* Shift - Zeichen *)
      THEN
        INC(zahl, 10);                  (* geschiftet + 10 *)
      END (* IF ORD(...)=1 *);
      IF (zahl >=1) & (zahl <= 10)
      THEN
        IF (zahl = INTEGER(chr.scan) - F1 + 1)
        THEN
          RETURN TRUE
        END (* IF zahl = ... *);
      END;
      IF (zahl >=11) & (zahl <= 20)
      THEN
        IF (zahl = INTEGER(chr.scan) - F11 + 11)
        THEN
          RETURN TRUE
        END (* IF zahl = ... *);
      END (* zahl >= ... *)
    END (* IF ..='F' *);
  END (* IF compChar= chr.ascii *);
  RETURN FALSE
*)
END TestEntry;

PROCEDURE CheckMenu( mTree : PtrObjTree );
(* Testet den ganzen Menbaum und setzt entsprechend die Bits in ctrlSet, altSet,
   normalSet; Sowie Funktionstasten (irgendwann mal) *)
VAR doQuit  : BOOLEAN;
    desk    : BOOLEAN;

    motherTitle,
    childTitle,
    motherEntry,
    childEntry  : CARDINAL;

BEGIN
(* die nchsten drei fr schnellen Test *)
  ctrlSet   := charSet{};
  altSet    := charSet{};
(*  normalSet := charSet{}; *)
  nextWhere := 0;

  doQuit := FALSE;
  desk   := TRUE;

  (* Auf geht's in die Objekt-Bume *)
  (* Bin mir nicht sicher, ob ich den Zeh-Code hier richtig verstanden *)
  (* habe, aber es funktioniert!                                       *)
  
  motherTitle := mTree^[mTree^[0].head].head;
  childTitle := mTree^[motherTitle].head;
  motherEntry := mTree^[mTree^[0].tail].head;
  childEntry := mTree^[motherEntry].head;

  SetCurrObjTree(mTree);

  WHILE ~doQuit DO
    (* Title Loop *)
    WHILE ~doQuit & (childEntry # motherEntry) & (childEntry # 0FFFFH) DO
      IF (* ~(disableObj IN ObjectState(childEntry)) & *)
         ((ObjectType(childEntry)=buttonObj) OR
          (ObjectType(childEntry)=stringObj))
      THEN
        (* Objekt ist String oder Button, also Eintrag prfen. *)
        TestEntry ( PtrMaxStr(mTree^[childEntry].spec), childEntry, childTitle);
      END;

      childEntry := mTree^[childEntry].next;
      IF desk
      THEN
      (* desk ist ein guter Trick: Es wird erst der Info-Eintrag geprft,
         dann jedoch direkt das nchste Menu genommen und die ACC's damit
         bergangen. (ist nicht von mir)
      *)
        childEntry := motherEntry;
        desk := FALSE;
      END;
    END; (* WHILE ~doQuit & (childEntry # motherEntry) & ... *)

    (* nchsten Eintrag nehmen *)
    childTitle := mTree^[childTitle].next;
    motherEntry := mTree^[motherEntry].next;
    childEntry := mTree^[motherEntry].head;
    IF childTitle = motherTitle
    THEN
      (* Menu komplett abgehandelt *)
      doQuit := TRUE;
    END;
  END (* WHILE ~doQuit *);
  (*
   * WHILE doQuit ist eigentlich berflssig, da die Routine sowieso
   * vorher verlassen wird.
   *)
END CheckMenu;

PROCEDURE MenuSearch ( YmTree : ADDRESS; YapId : INTEGER;
                       kstate : BITSET; Ykey : INTEGER;
                       hdlMenu : menuProc;
                       showMouse : BOOLEAN) : BOOLEAN;

   TYPE trick = RECORD CASE : BOOLEAN OF
                    TRUE : key : INTEGER|
                   FALSE : scan : BYTE;
                           ascii: CHAR;
                  END;
                END;
      
  VAR mTree : PtrObjTree;
      apId : CARDINAL; key : GemChar;
      msgBuff : ARRAY [0..7] OF CARDINAL;
      chr     : GemChar;
      state   : SpecialKeySet;
      scan    : CARDINAL;
      voidL   : LONGINT;
      z       : CARDINAL;
      found   : BOOLEAN;
      CompareState : CARDINAL;
      t       : trick;
BEGIN
(* neu *)
  mTree := PtrObjTree(YmTree); apId := CARDINAL(YapId); t.key := Ykey;
  key.scan := t.scan; key.ascii := t.ascii;
(* --- *)
  IF checkIt THEN (* Beim ersten mal checken *)
    CheckMenu(mTree);
    checkIt := FALSE;

    (* Adressen der Tastaturtabellen holen *)
    voidL := -1;
    Unshift := MagicXBIOS.Keycode(voidL);
    Shift   := MagicXBIOS.Keycode(voidL);
    CapsLock:= MagicXBIOS.Keycode(voidL);
    keyTable := MagicXBIOS.Keytbl(Unshift, Shift, CapsLock);
    WITH keyTable^ DO
      Unshift := unshift;
      Shift   := shift;
      CapsLock:= capslock;
    END;
    (*
    MagicXBIOS.Bioskeys();
    *)
  END;

(*
  (* Warten bis Drop-Down's geschlossen *)
  MagicAES.WindUpdate(MagicAES.BEGUPDATE);
  MagicAES.WindUpdate(MagicAES.ENDUPDATE);
*)
  
  (* ASCII - Wert selbst bestimmen, da kein Verla auf GEM *)
  (* CapsLock wird ignoriert *)
  IF (MagicAES.KLSHIFT IN kstate) OR (MagicAES.KRSHIFT IN kstate)
  THEN
    (* Shift-gedrckt, geshiftete Tabelle nehmen *)
    chr.ascii := CHAR (Shift^[CARDINAL(LONG(key.scan))]);
  ELSE
    (* nicht geschiftet *)
    chr.ascii := CHAR (Unshift^[CARDINAL(LONG(key.scan))]);
  END;
  chr.ascii := CAP(chr.ascii);
  chr.scan := key.scan;
   
  IF (MagicAES.KALT IN kstate) & (MagicAES.KCTRL IN kstate)
  THEN
    (* Beides ist nicht mglich *)
    RETURN FALSE
  END;

  IF MagicAES.KALT IN kstate THEN
    IF chr.ascii IN altSet THEN
      CompareState := MagicAES.KALT
    ELSE
      RETURN FALSE
    END;
  ELSIF MagicAES.KCTRL IN kstate THEN
    IF chr.ascii IN ctrlSet THEN
      CompareState := MagicAES.KCTRL
    ELSE
      RETURN FALSE
    END;
  ELSE
    RETURN FALSE
  END;

  z := 0;
  WHILE (z < nextWhere) &
        ((where[z].char # chr.ascii) OR (where[z].shiftCode # CompareState)) DO
    INC(z);
  END;

  SetCurrObjTree(mTree);

  (* Jetzt mu er gefunden worden sein!, naja trotzdem: *)
  IF (where[z].char # chr.ascii) OR (where[z].shiftCode # CompareState) OR
     (disableObj IN ObjectState(where[z].entry)) OR
     (disableObj IN ObjectState(where[z].title)) THEN
    RETURN FALSE
  END;

  (* Menu invertieren *)
  MagicAES.MenuTnormal (mTree, where[z].title, 0);

  IF showMouse THEN
    mtAppl.MouseOn;
  END;
  hdlMenu(CARDINAL(where[z].entry), CARDINAL(where[z].title), kstate);
  RETURN TRUE        (* das wars *)
END MenuSearch;

BEGIN
  checkIt := TRUE;
END SearchMenu.
