IMPLEMENTATION MODULE SwapServer;

(*
20.10.88 Assembler - MODULE fr TDI-Modula-2
18.05.91 Umstellung auf Megamax
JGS
*)

(*$L-,R-,S-,Z-*) (* Die Stackverschieberei lassen wir mal sein.. :-) *)

FROM SYSTEM     IMPORT LONGWORD, WORD, BYTE, ASSEMBLER;

PROCEDURE SplitLongToWord(L : LONGWORD;VAR W1,W2 : WORD);
BEGIN
  ASSEMBLER
    MOVE.L      -(A3),A0        ;ADR(W1)
    MOVE.L      -(A3),A1        ;ADR(W2)
    MOVE.L      -(A3),D0
    MOVE.W      D0,(A0)         ;Low-Word von L nach W1
    SWAP.W      D0
    MOVE.W      D0,(A1)         ;High-Word von L nach W2
  END;
END SplitLongToWord;

PROCEDURE SplitLongToByte(L : LONGWORD;VAR B1,B2,B3,B4 : BYTE);
BEGIN
  ASSEMBLER
    MOVE.L      B4(A3),A0       ;ADR(B4)
    MOVE.B      L+3(A3),(A0)
    MOVE.L      B3(A3),A0       ;ADR(B3)
    MOVE.B      L+2(A3),(A0)
    MOVE.L      B2(A3),A0       ;ADR(B2)
    MOVE.B      L+1(A3),(A0)
    MOVE.L      B1(A3),A0       ;ADR(B1)
    MOVE.B      L(A3),(A0)
    LEA         -20(A3),A3
  END
END SplitLongToByte;

PROCEDURE SplitWordToByte(W : WORD;VAR B1,B2 : BYTE);
BEGIN
  ASSEMBLER
    MOVE.L      B2(A3),A0       ;ADR(B1)
    MOVE.B      W+1(A3),(A0)
    MOVE.L      B1(A3),A0       ;ADR(B2)
    MOVE.B      W(A3),(A0)
    LEA         -10(A3),A3
  END
END SplitWordToByte;

PROCEDURE SwapLong(L : LONGWORD):LONGCARD;
BEGIN
  ASSEMBLER
    MOVE.L      -(A3),D0
    SWAP.W      D0
    MOVE.L      D0,(A3)+
  END
END SwapLong;

PROCEDURE SwapLong8086(L : LONGWORD):LONGCARD;
BEGIN
  ASSEMBLER
    MOVE.L      -(A3),D0
    ROL.W       #8,D0
    SWAP.W      D0
    ROL.W       #8,D0
    MOVE.L      D0,(A3)+
  END
END SwapLong8086;

PROCEDURE SwapWord(W : WORD):CARDINAL;
BEGIN
  ASSEMBLER
    MOVE.W      -(A3),D0
    ROL.W       #8,D0
    MOVE.W      D0,(A3)+
  END
END SwapWord;

PROCEDURE Compose4Bytes(B1,B2,B3,B4 : BYTE):LONGCARD;
BEGIN
  ASSEMBLER
    MOVEQ.L     #0,D0
    MOVEQ.L     #0,D1
    MOVEQ.L     #0,D2
    MOVE.L      -(A3),D0
    ANDI.L      #$FF00FF00,D0
    MOVE.L      -(A3),D1
    ANDI.L      #$FF00FF00,D1

    MOVE.W      D1,D2
    ROR.W       #8,D2
    SWAP.W      D2
    ADD.L       D2,D1

    MOVE.W      D0,D2
    ROR.W       #8,D2

    SWAP.W      D0
    MOVE.W      D0,D1
    ADD.W       D2,D1

    MOVE.L      D1,(A3)+
  END
END Compose4Bytes;

PROCEDURE Compose2Bytes(B1,B2 : BYTE):CARDINAL;
BEGIN
  ASSEMBLER
    MOVE.W      -(A3),D0
    MOVE.W      -(A3),D1
    ANDI.W      #$FF00,D0
    ANDI.W      #$FF00,D1;
    ROR.W       #8,D0
    ADD.W       D0,D1
    MOVE.W      D1,(A3)+
  END
END Compose2Bytes;

PROCEDURE ComposeWords(W1,W2 : WORD):LONGCARD;
BEGIN
  ASSEMBLER
    MOVE.W      -(A3),D0
    MOVE.W      -(A3),D1
    SWAP.W      D1
    MOVE.W      D0,D1
    MOVE.L      D1,(A3)+
  END
END ComposeWords;

PROCEDURE BiggerByte(B1,B2 : BYTE):CHAR;
BEGIN
  ASSEMBLER
  END
END BiggerByte;

PROCEDURE BiggerCard(C1,C2 : CARDINAL):CARDINAL;
BEGIN
  ASSEMBLER
    MOVE.W      -(A3),D0
    MOVE.W      -(A3),D1
    CMP.W       D0,D1
    BHI.S       D1GreaterD0
    MOVE.W      D0,D1
D1GreaterD0:
    MOVE.W      D1,(A3)+
  END
END BiggerCard;
  
PROCEDURE BiggerInt(I1, I2 : INTEGER):INTEGER;
BEGIN
  ASSEMBLER
    MOVE.W      -(A3),D0
    MOVE.W      -(A3),D1
    CMP.W       D0,D1
    BGT.S       D1GreaterD0
    MOVE.W      D0,D1
D1GreaterD0:
    MOVE.W      D1,(A3)+
  END
END BiggerInt;

PROCEDURE BiggerLong(L1,L2 : LONGWORD):LONGCARD;
BEGIN
  ASSEMBLER
    MOVE.L      -(A3),D0
    MOVE.L      -(A3),D1
    CMP.L       D0,D1
    BHI.S       D1GreaterD0
    MOVE.L      D0,D1
D1GreaterD0:
    MOVE.L      D1,(A3)+
  END
END BiggerLong;
  
PROCEDURE SmallerByte(B1,B2 : BYTE):CHAR;
BEGIN
  ASSEMBLER
  END
END SmallerByte;

PROCEDURE SmallerCard(C1,C2 : CARDINAL):CARDINAL;
BEGIN
  ASSEMBLER
    MOVE.W      -(A3),D0
    MOVE.W      -(A3),D1
    CMP.W       D0,D1
    BHI.S       D0GreaterD1
    MOVE.W      D1,D0
D0GreaterD1:
    MOVE.W      D0,(A3)+
  END
END SmallerCard;
  
PROCEDURE SmallerInt(I1, I2 : INTEGER):INTEGER;
BEGIN
  ASSEMBLER
    MOVE.W      -(A3),D0
    MOVE.W      -(A3),D1
    CMP.W       D0,D1
    BGT.S       D0GreaterD1
    MOVE.W      D1,D0
D0GreaterD1:
    MOVE.W      D0,(A3)+
  END
END SmallerInt;
  
PROCEDURE SmallerLong(L1,L2 : LONGWORD):LONGCARD;
BEGIN
  ASSEMBLER
    MOVE.L      -(A3),D0
    MOVE.L      -(A3),D1
    CMP.L       D0,D1
    BHI.S       D0GreaterD1
    MOVE.L      D1,D0
D0GreaterD1:
    MOVE.L      D0,(A3)+
  END
END SmallerLong;

PROCEDURE ExchangeByte(VAR B1,B2 : BYTE);
BEGIN
  ASSEMBLER
    MOVE.L      -(A3),A0
    MOVE.L      -(A3),A1
    MOVE.B      (A0),D0
    MOVE.B      (A1),(A0)
    MOVE.B      D0,(A1)
  END
END ExchangeByte;
  
PROCEDURE ExchangeWord(VAR W1,W2 : WORD);
BEGIN
  ASSEMBLER
    MOVE.L      -(A3),A0
    MOVE.L      -(A3),A1
    MOVE.W      (A0),D0
    MOVE.W      (A1),(A0)
    MOVE.W      D0,(A1)
  END
END ExchangeWord;
  
PROCEDURE ExchangeLong(VAR L1,L2 : LONGWORD);
BEGIN
  ASSEMBLER
    MOVE.L      -(A3),A0
    MOVE.L      -(A3),A1
    MOVE.L      (A0),D0
    MOVE.L      (A1),(A0)
    MOVE.L      D0,(A1)
  END
END ExchangeLong;

END SwapServer.
