IMPLEMENTATION MODULE VDIStandards;

FROM SYSTEM          IMPORT ADDRESS, ADR, WORD, LOC;
FROM Void            IMPORT v;
FROM GrafBase        IMPORT Rectangle;
IMPORT MTE;
IMPORT FontSelect;
IMPORT WdwManager;
IMPORT CatEdit;
IMPORT grin;
IMPORT Clip;
IMPORT CatGlobal;
IMPORT msgList;
IMPORT treeList;
IMPORT MsgWindow;
FROM SwapServer         IMPORT SplitWordToByte;

IMPORT MagicAES;
IMPORT MagicVDI;
IMPORT MagicFSM;
IMPORT MausTauschrsc;
IMPORT MagicSys;
IMPORT mtDials;
IMPORT mtUtils;
IMPORT mtAlerts;
IMPORT mtAppl;
IMPORT mtXobjects;
IMPORT MagicConvert;

IMPORT WinDials;

CONST minWindWidth  = 128;
      minWindHeight = 128-16;

VAR menu     : ADDRESS;
    (* menuLength: INTEGER; *)


        (* VDI Text Funktionen    *)
        
PROCEDURE Text (isFSM : BOOLEAN; hdl, x, y: INTEGER; REF string: ARRAY OF CHAR);
          (* v_gtext *)
BEGIN
  IF string[0] = 0C THEN RETURN END;

  IF isFSM
  THEN
    MagicFSM.FSMText (hdl, x, y, string);
  ELSE
    MagicVDI.Text (hdl, x, y, string);
  END;
END Text;

PROCEDURE InqTextextend (isFSM : BOOLEAN; hdl : INTEGER; REF string: ARRAY OF CHAR;
                         VAR extent: ARRAY OF LOC);
          (* vqt_extent *)
  VAR (*$Reg*) i : CARDINAL;
BEGIN
  IF string[0] = 0C THEN 
    FOR i := 0 TO HIGH (extent)-1 DO extent[i] := 0; END;
    RETURN
  END;
  IF isFSM
  THEN
    MagicFSM.InqFExtent (hdl, string, extent);
  ELSE 
    MagicVDI.InqTextextent (hdl, string, extent);
  END;
END InqTextextend;

PROCEDURE InitVDIStandards():BOOLEAN;
BEGIN
  menu        := MausTauschrsc.TreeAddr^[MausTauschrsc.menu];
  RETURN TRUE;
END InitVDIStandards;

(* Neue Fontauswahl: Ruft die Dialogbox auf und danach die entsprechende
 * Setzroutine fr das entsprechende Fenster.
 *)
PROCEDURE SelectFont (handle, wdw : INTEGER; onlyMono : BOOLEAN;
                      VAR font, size : INTEGER; setFont : iProc);
BEGIN
  IF FontSelect.DoSelectFont (handle, onlyMono, font, size)
  THEN
    setFont (wdw, font, size);
  END;
END SelectFont;

PROCEDURE GetSpec( tree : ADDRESS; Item : INTEGER):ADDRESS;
BEGIN
  RETURN mtXobjects.GetObSpec (tree, Item)
END GetSpec;

PROCEDURE GetState(tree : ADDRESS; Item : INTEGER):BITSET;
VAR objPtr : POINTER TO ARRAY[0..200] OF MagicAES.OBJECT;
BEGIN
  objPtr := tree;
  RETURN objPtr^[Item].obState
END GetState;

PROCEDURE GetFlags(tree : ADDRESS; Item : INTEGER):BITSET;
VAR objPtr : POINTER TO ARRAY[0..200] OF MagicAES.OBJECT;
BEGIN
  objPtr := tree;
  RETURN objPtr^[Item].obFlags
END GetFlags;

PROCEDURE SetSpec( tree : ADDRESS; Item : INTEGER; newSpec :ADDRESS);
VAR objPtr : POINTER TO ARRAY[0..200] OF MagicAES.OBJECT;
BEGIN
  objPtr := tree;
  objPtr^[Item].obSpec.StringPtr := newSpec
END SetSpec;

PROCEDURE SetState(tree : ADDRESS; Item : INTEGER; newState : BITSET);
VAR objPtr : POINTER TO ARRAY[0..200] OF MagicAES.OBJECT;
BEGIN
  objPtr := tree;
  newState := newState - {MagicSys.Bit15, MagicSys.Bit14,
                          MagicSys.Bit13, MagicSys.Bit12,
                          MagicSys.Bit11, MagicSys.Bit10,
                          MagicSys.Bit9,  MagicSys.Bit8};
  objPtr^[Item].obState := objPtr^[Item].obState -
                         {MagicSys.Bit7, MagicSys.Bit6,
                          MagicSys.Bit5, MagicSys.Bit4,
                          MagicSys.Bit3, MagicSys.Bit2,
                          MagicSys.Bit1, MagicSys.Bit0};
  objPtr^[Item].obState := objPtr^[Item].obState + newState
END SetState;

PROCEDURE SetFlags(tree : ADDRESS; Item : INTEGER; newFlags : BITSET);
VAR objPtr : POINTER TO ARRAY[0..200] OF MagicAES.OBJECT;
BEGIN
  objPtr := tree;
  newFlags := newFlags - {MagicSys.Bit15, MagicSys.Bit14,
                          MagicSys.Bit13, MagicSys.Bit12,
                          MagicSys.Bit11, MagicSys.Bit10,
                          MagicSys.Bit9};
  objPtr^[Item].obFlags := objPtr^[Item].obFlags -
                         {MagicSys.Bit8,
                          MagicSys.Bit7, MagicSys.Bit6,
                          MagicSys.Bit5, MagicSys.Bit4,
                          MagicSys.Bit3, MagicSys.Bit2,
                          MagicSys.Bit1, MagicSys.Bit0};
  objPtr^[Item].obFlags := objPtr^[Item].obFlags + newFlags
END SetFlags;

(*---------------------------------------------------------*)

PROCEDURE newState(b : BOOLEAN):INTEGER;
BEGIN
  IF b THEN RETURN 1 ELSE RETURN 0 END;
END newState;

TYPE mSet = SET OF [0..255];

VAR menuSet : mSet;

  PROCEDURE EnableItem (tree : ADDRESS; item : INTEGER; enable : BOOLEAN);
  BEGIN
    IF enable
    THEN
      IF ~(item IN menuSet) THEN 
        MagicAES.MenuIenable (menu, item, 1); 
        INCL(menuSet, item);
      END;
    ELSE
      IF item IN menuSet THEN 
        MagicAES.MenuIenable (menu, item, 0); 
        EXCL(menuSet, item);
      END;
    END;
  END EnableItem;

  PROCEDURE CheckItem (tree : ADDRESS; item : INTEGER; enable : BOOLEAN);
  BEGIN
    IF enable
    THEN
      MagicAES.MenuIcheck (menu, item, 1);
    ELSE
      MagicAES.MenuIcheck (menu, item, 0);
    END;
  END CheckItem;

PROCEDURE StatusEnable(yep : BOOLEAN);
VAR dr : Rectangle; show : BOOLEAN; i : INTEGER;
BEGIN
  (*
  IF yep THEN
    show :=  mtUtils.InState (menu, MausTauschrsc.gelesen, MagicAES.DISABLED);
    IF show THEN 
      FOR i := MausTauschrsc.gelesen TO MausTauschrsc.user2 DO
        EnableItem (menu, i, TRUE) 
      END;
    END;
  ELSE
    show := ~mtUtils.InState (menu, MausTauschrsc.gelesen, MagicAES.DISABLED);
    IF show THEN 
      FOR i := MausTauschrsc.gelesen TO MausTauschrsc.user2 DO
        EnableItem (menu, i, FALSE) 
      END;
    END;
  END;
  EnableItem (menu, MausTauschrsc.upsearch, yep);
  *)
  EnableItem (menu, MausTauschrsc.tmsagain, yep);
END StatusEnable;

PROCEDURE StatusCheck(b : BITSET);
BEGIN
(*
  CheckItem (menu, MausTauschrsc.gelesen, 0 IN b);
  CheckItem (menu, MausTauschrsc.gefunden, 1 IN b);
  CheckItem (menu, MausTauschrsc.interess, 2 IN b);
  CheckItem (menu, MausTauschrsc.teilloes, 3 IN b);
  CheckItem (menu, MausTauschrsc.totalloe, 4 IN b);
  CheckItem (menu, MausTauschrsc.kommenti, 5 IN b);
  CheckItem (menu, MausTauschrsc.beantwor, 6 IN b);
  CheckItem (menu, MausTauschrsc.user10, 7 IN b);
  CheckItem (menu, MausTauschrsc.user2, 8 IN b);
  *)
END StatusCheck;

VAR clipDa : BOOLEAN;

PROCEDURE enableMenuItems(wdw : INTEGER);

  VAR 
      bl,
      isTop, isMsg, isEdit,
      isWriteEdit, isList,
      qBlock,
      infoLine,
      moreWinds,
      isInQueue,
      isSel,
      isIcon,
      isTree,
      isButton,
      topNext  : BOOLEAN;
      botWdw:    INTEGER;
      mStr:     ARRAY [0..39] OF CHAR;
  
  
  PROCEDURE SetStr (VAR str : ARRAY OF CHAR; REF s2: ARRAY OF CHAR);
    VAR i, init, max: INTEGER;
  BEGIN
    init := 0;
    WHILE str[init]=' ' DO INC (init); END;
    max := mtUtils.Min (LENGTH(str), CARDINAL(init)+LENGTH(s2));
    FOR i := init TO max - 1 DO
      str[i] := s2[i-init];
    END;
  END SetStr;
  
BEGIN
  clipDa := Clip.SomethingInScrap();
  isMsg := grin.grinWindowTop (wdw);
  isList := msgList.listWindowTop (wdw);
  isTree := treeList.treeWindowTop (wdw);
  isEdit := ~isMsg & CatEdit.IsEditTop (wdw);
  isWriteEdit := isEdit & ~CatEdit.GetMode (wdw, CatEdit.roMode);
  isTop := isMsg OR isEdit;
  IF isTop 
  THEN
    bl := CatEdit.BlockIsMarked (wdw);
  ELSIF isList
  THEN
    bl := msgList.listSomethingSelected (wdw);
  ELSE
    bl := FALSE;
  END;
  isSel := MsgWindow.msgWindowTop (wdw);
  isInQueue := WdwManager.IsInQueue (wdw);
  moreWinds := WdwManager.GetSecondWdw(botWdw); 
  isIcon := WdwManager.WindowIsIcon (wdw);
  topNext := WdwManager.TopNextPossible();
  IF moreWinds THEN
    v.bool := WdwManager.GetSecondWdw (botWdw);
    infoLine := ~isIcon & isWriteEdit & (grin.grinWindowTop (botWdw) OR grin.grinOnlyOneWind (botWdw));
    qBlock := ~isIcon & infoLine & CatEdit.BlockIsMarked (botWdw);
  ELSE
    qBlock := FALSE;
    infoLine := FALSE;
  END;

  EnableItem (menu, MausTauschrsc.tmerge  , ~isIcon & isWriteEdit);   (* STRING in Baum MENU *)
  EnableItem (menu, MausTauschrsc.tclose  , WdwManager.WindowIsCloseable (wdw));    (* STRING in Baum MENU *)
  EnableItem (menu, MausTauschrsc.tsave   , ~isIcon & isEdit);   (* STRING in Baum MENU *)
  EnableItem (menu, MausTauschrsc.saveas  , ~isIcon & (isTop OR (isList & bl)));    (* STRING in Baum MENU *)
  EnableItem (menu, MausTauschrsc.tprint  , ~isIcon & isTop);    (* STRING in Baum MENU *)
  
  EnableItem (menu, MausTauschrsc.tundo   , ~isIcon & isTop);              (* STRING in Baum MENU *)
  EnableItem (menu, MausTauschrsc.tselall , ~isIcon & (isTop OR isList OR isSel OR isTree));    (* STRING in Baum MENU *)
  EnableItem (menu, MausTauschrsc.tcut    , ~isIcon & bl & isWriteEdit);        (* STRING in Baum MENU *)
  EnableItem (menu, MausTauschrsc.tcopy   , ~isIcon & (isTop OR (isList & bl)));        (* STRING in Baum MENU *)
  EnableItem (menu, MausTauschrsc.tpaste  , ~isIcon & clipDa & isWriteEdit);    (* STRING in Baum MENU *)
  EnableItem (menu, MausTauschrsc.blkprot,  ~isIcon & isWriteEdit & bl);         (* STRING in Baum MENU *)
  EnableItem (menu, MausTauschrsc.blockrot, ~isIcon & isTop & bl);         (* STRING in Baum MENU *)

  EnableItem (menu, MausTauschrsc.infoline, infoLine);           (* STRING in Baum MENU *)
  EnableItem (menu, MausTauschrsc.writeblo, qBlock);             (* STRING in Baum MENU *)
  EnableItem (menu, MausTauschrsc.tchflag , ~isIcon & (isMsg OR isList OR isTree));
  EnableItem (menu, MausTauschrsc.tsuchnb , ~isIcon & isMsg);

  EnableItem (menu, MausTauschrsc.tmsagain, ~isIcon & isMsg);    (* STRING in Baum MENU *)
  EnableItem (menu, MausTauschrsc.tsearch , ~isIcon & (isMsg OR isList));    (* STRING in Baum MENU *)

  EnableItem (menu, MausTauschrsc.findrepl, ~isIcon & isTop);   (* STRING in Baum MENU *)
  EnableItem (menu, MausTauschrsc.ttsagain, ~isIcon & isTop);   (* STRING in Baum MENU *)
  EnableItem (menu, MausTauschrsc.brepl   , ~isIcon & isEdit);   (* STRING in Baum MENU *)

  EnableItem (menu, MausTauschrsc.cyclewin, topNext  );(* STRING in Baum MENU *)
  EnableItem (menu, MausTauschrsc.wstacked, moreWinds);(* STRING in Baum MENU *)
  EnableItem (menu, MausTauschrsc.wneben  , moreWinds);(* STRING in Baum MENU *)
  EnableItem (menu, MausTauschrsc.wstaffel, moreWinds);(* STRING in Baum MENU *)
  EnableItem (menu, MausTauschrsc.wtiled  , moreWinds);(* STRING in Baum MENU *)
  EnableItem (menu, MausTauschrsc.fullwin , WdwManager.WindowIsFullable (wdw));          (* STRING in Baum MENU *)
  EnableItem (menu, MausTauschrsc.efont   , ~isIcon & (isList OR isTop OR isSel OR isTree));    (* STRING in Baum MENU *)
  EnableItem (menu, MausTauschrsc.ocolor  , ~isIcon & (isList OR isTop OR isSel OR isTree));    (* STRING in Baum MENU *)
  EnableItem (menu, MausTauschrsc.oeditor , ~isIcon & isTop);                       (* STRING in Baum MENU *)
  
  (* Jetzt String noch anpassen fr Oeditor *)
  IF isTop
  THEN
    mtUtils.ObjcString (menu, MausTauschrsc.oeditor, mStr);
    IF isEdit
    THEN
      SetStr (mStr, 'Editor...  ');
    ELSIF isMsg
    THEN
      SetStr (mStr, 'Anzeige... ');
    END;
    MagicAES.MenuText (menu, MausTauschrsc.oeditor, mStr);
  END;
 
END enableMenuItems;

PROCEDURE enableNewTop (wdw : INTEGER);
  VAR isInQueue,
      isEdit : BOOLEAN;
      clipPath : ARRAY [0..255] OF CHAR;
BEGIN
  clipDa := Clip.GetScrap (clipPath) & Clip.ScrapDirty (clipPath);
  isInQueue := WdwManager.IsInQueue (wdw);
  isEdit := ~grin.grinWindowTop (wdw) & CatEdit.IsEditTop (wdw) 
          & ~CatEdit.GetMode (wdw, CatEdit.roMode);
  EnableItem (menu, MausTauschrsc.tpaste, clipDa & isEdit);             (* STRING in Baum MENU *)
  StatusEnable (grin.grinWindowTop (wdw));
END enableNewTop;

PROCEDURE enableOrDisableMenu (disable : BOOLEAN);
  VAR mtree: mtUtils.tObjcTree;
BEGIN
  WdwManager.DisableMenu (menu, disable);
  (*
  v.int := MagicAES.MenuBar(menu, MagicAES.Reset);
  mtUtils.SetState (menu, MausTauschrsc.tdatei  , MagicAES.DISABLED, disable);
  mtUtils.SetState (menu, MausTauschrsc.tbearbei, MagicAES.DISABLED, disable);
  mtUtils.SetState (menu, MausTauschrsc.tmessage, MagicAES.DISABLED, disable);
  mtUtils.SetState (menu, MausTauschrsc.twindow , MagicAES.DISABLED, disable);
  mtUtils.SetState (menu, MausTauschrsc.ttausch , MagicAES.DISABLED, disable);
  mtUtils.SetState (menu, MausTauschrsc.tsuchen , MagicAES.DISABLED, disable);
  EnableItem (menu, MausTauschrsc.tabout, ~disable); 
  IF disable
  THEN
    mtree := menu;
    menuLength := mtree^[2].obWidth;
    mtree^[2].obWidth:= mtree^[3].obWidth; (* Breite auf DESK begrenzen *)
  ELSE
    mtree := menu;
    mtree^[2].obWidth:= menuLength; (* Breite zurcksetzen *)
  END;
  v.int := MagicAES.MenuBar(menu, MagicAES.Set);
  *)
END enableOrDisableMenu;

BEGIN
  menuSet     := mSet{0..255};
END VDIStandards.
