IMPLEMENTATION MODULE VDIUtil;

FROM SYSTEM          IMPORT ADDRESS, ADR, WORD, LOC;

IMPORT MagicAES;
IMPORT mtUtils;
IMPORT MagicConvert;
IMPORT WinDials;
IMPORT WdwManager;
FROM Void IMPORT v;

PROCEDURE SetObjColor (tr: ADDRESS; ob : INTEGER; foreground, background : INTEGER);
  VAR tree : POINTER TO ARRAY [0..255] OF MagicAES.OBJECT;
      tmp  : BITSET;
BEGIN
  tree := tr;
  foreground := foreground MOD 16;
  background := background MOD 16;
  CASE tree^[ob].obType OF
    MagicAES.GBOX,
    MagicAES.GIBOX,
    MagicAES.GBOXCHAR  : (* Boxinfo-Struktur *)
                tmp := tree^[ob].obSpec.Box.flags;
                tmp := BITSET(background) + {4..6} + BITSET(foreground * 256) + BITSET(CARDINAL(foreground) * 4096);
                tree^[ob].obSpec.Box.flags := tmp;
                (*
                (* Innenfarbe setzen auf Hintergrundfarbe *)
                tree^[ob].obSpec.Box.flags := tree^[ob].obSpec.Box.flags - {0..3} + BITSET(background);
                (* Textfarbe setzen *)
                tree^[ob].obSpec.Box.flags := tree^[ob].obSpec.Box.flags - {8..11} + BITSET(foreground*256);
                (* Muster noch auf Solid setzen *)
                tree^[ob].obSpec.Box.flags := tree^[ob].obSpec.Box.flags - {4..6} + BITSET(7*16);
                *)
                |
    MagicAES.GTEXT,
    MagicAES.GFTEXT,
    MagicAES.GBOXTEXT,
    MagicAES.GFBOXTEXT : (* TEDInfo-Struktur *)
                tmp := BITSET(tree^[ob].obSpec.TedPtr^.teColor);
                (* Jetzt aus beiden Farben einen neuen Wert fr tmp berechnen *)
                tmp := BITSET(background) + {4..6} + BITSET(foreground * 256) + BITSET(CARDINAL(foreground) * 4096);
                (*
                (* Rahmenfarbe setzen *)
                tmp := tmp - {12..15} + BITSET(foreground * 4096);
                (* Hintergrundfarbe setzen *)
                tmp := tmp - {8..11} + BITSET(foreground * 256);
                (* Vordergrundfarbe setzen *)
                tmp := tmp - {0..3} + BITSET (background);
                (* auf Solid setzen *)
                tmp := tmp - {4..6} + {4..6};
                (* Auf Transparent setzen *)
                tmp := tmp - {7};
                *)
                tree^[ob].obSpec.TedPtr^.teColor := INTEGER(tmp);
                |
    MagicAES.GIMAGE    : (* Image-Struktur *)
                tree^[ob].obSpec.ImagePtr^.biColor := foreground;
                |
    MagicAES.GICON     : (* Icon-Struktur *)
                tmp := BITSET(tree^[ob].obSpec.IconPtr^.ibChar);
                (* Hintergrundfarbe setzen *)
                tmp := tmp - {8..11} + BITSET(background * 256);
                (* Vordergrundfarbe setzen *)
                tmp := tmp - {12..15} + BITSET (CARDINAL(foreground) * 4096);
                tree^[ob].obSpec.IconPtr^.ibChar := INTEGER(tmp);
                |
  ELSE
  END;
END SetObjColor;

PROCEDURE setTreeColor (tr: ADDRESS; startOb, foreground, background : INTEGER);
(* Farben fr einen Objektbaum setzen *)
  VAR tree : POINTER TO ARRAY [0..255] OF MagicAES.OBJECT;
      ob   : INTEGER;
      tmp  : BITSET;
BEGIN
  tree := tr;
  ob := startOb;
  REPEAT
    SetObjColor (tree, ob, foreground, background);
    IF tree^[ob].obHead > 0
    THEN
      setTreeColor (tree, tree^[ob].obHead, foreground, background);
    END;
    ob := tree^[ob].obNext;
  UNTIL (ob <= startOb) OR (tree^[ob].obNext < 0);
END setTreeColor;

PROCEDURE SetTreeColor (tr : ADDRESS; foreground, background : INTEGER);
BEGIN
  setTreeColor (tr, 0, foreground, background);
END SetTreeColor;


PROCEDURE SetLongIntStr (tree: ADDRESS; obj: INTEGER; val : LONGINT);
  VAR str : ARRAY [0..79] OF CHAR;
BEGIN
  MagicConvert.LIntToStr (val, 0, str);
  mtUtils.SetObjcString (tree, obj, str);
END SetLongIntStr;

PROCEDURE GetLongIntStr (tree: ADDRESS; obj: INTEGER; VAR val : LONGINT);
  VAR str : ARRAY [0..79] OF CHAR;
BEGIN
  mtUtils.ObjcString (tree, obj, str);
  val := MagicConvert.StrToLInt (str);
END GetLongIntStr;

PROCEDURE SetIntStr (tree: ADDRESS; obj: INTEGER; val : INTEGER);
  VAR str : ARRAY [0..79] OF CHAR;
BEGIN
  MagicConvert.IntToStr (val, 0, str);
  mtUtils.SetObjcString (tree, obj, str);
END SetIntStr;

PROCEDURE GetIntStr (tree: ADDRESS; obj: INTEGER; VAR val : INTEGER);
  VAR str : ARRAY [0..79] OF CHAR;
      lval: LONGINT;
BEGIN
  mtUtils.ObjcString (tree, obj, str);
  lval := MagicConvert.StrToLInt (str);
  IF (lval > MAX(INTEGER)) THEN val := MAX(INTEGER)
  ELSIF (lval < MIN(INTEGER)) THEN val := MIN (INTEGER)
  ELSE
    val := SHORT (lval)
  END;
END GetIntStr;

  TYPE Trick =  POINTER TO RECORD
                  CASE : BOOLEAN OF
                    TRUE:  wert: INTEGER;|
                    FALSE: hi: CHAR;
                           lo: CHAR;|
                  END;
                 END;

TYPE  PtrObjTree = POINTER TO ARRAY [0..MAX(CARDINAL)] OF MagicAES.OBJECT;

PROCEDURE SetXString (tree  : ADDRESS; obj: INTEGER;
                      sTree : ADDRESS; idx: INTEGER);
  VAR t       : Trick;
      selStr  : ARRAY [0..40] OF CHAR;
BEGIN
  mtUtils.ObjcString (sTree, idx+1, selStr);
  mtUtils.SetObjcString (tree, obj, selStr);
END SetXString;

PROCEDURE SetXState (tree : ADDRESS; obj: INTEGER; xState : INTEGER);
  VAR t : Trick;
      tr: PtrObjTree;
BEGIN
  tr := tree;
  t := ADR (tr^[obj].obState);
  t^.hi := CHR(xState);
END SetXState;

PROCEDURE GetXState (tree : ADDRESS; obj: INTEGER) : INTEGER;
  VAR t : Trick;
      tr: PtrObjTree;
BEGIN
  tr := tree;
  t := ADR (tr^[obj].obState);
  RETURN INTEGER(ORD (t^.hi));
END GetXState;

PROCEDURE FormHandle(form : ADDRESS):INTEGER;
VAR exit   : INTEGER;
BEGIN
  exit := WinDials.WinDialDo(form, 0);
  exit := INTEGER(BITSET(exit) - {15});
  mtUtils.ExclState(form, exit, MagicAES.SELECTED);
  RETURN exit
END FormHandle;

PROCEDURE isKey(VAR kstate : BITSET; VAR scan, char : CHAR):BOOLEAN;
(* sieht per event_multi nach, ob ein Buchstabe vorliegt *)
VAR z : CARDINAL;
    mBuff: ARRAY [0..15] OF INTEGER;
    dr   : RECORD
             CASE :BOOLEAN OF
               TRUE : x,y,w,h : INTEGER|
               FALSE: adr, dum: ADDRESS
             END
           END;
    event,
    evnt      : BITSET;
    doExit    : BOOLEAN;
    moX, moY  : INTEGER;
    moButton  : BITSET;
    kReturn   : INTEGER;
    moKState  : BITSET;
    bReturn   : INTEGER;
    sc        : INTEGER;
BEGIN
    (* Hier bei MultiTasking noch eine kleiner EventMulti und ein paar
     * Events verarbeiten 
     *)
  LOOP
    evnt := MagicAES.EvntMulti(
               {MagicAES.MUMESAG, MagicAES.MUKEYBD, MagicAES.MUTIMER},
                0,{},{}, 0,dr, 0, dr, mBuff, 0, 0,
                moX, moY, moButton, kReturn, moKState, sc, char, bReturn);
    (* Den Timerevent brauchen wir nicht *)
    event := evnt;
    EXCL (event, MagicAES.MUTIMER);
    doExit := event = BITSET{};
    IF MagicAES.MUKEYBD IN evnt
    THEN
      scan := CHAR(SHORT(sc));
    ELSE
      scan := 0C;
    END;
    (* ESC gedrckt? *)
    doExit := doExit OR ((MagicAES.MUKEYBD IN evnt) & (char = 33C));
    IF doExit THEN EXIT END;
    MagicAES.WindUpdate(MagicAES.BEGUPDATE);
    v.bool := WdwManager.HandleEvent (evnt, mBuff, moButton, moKState, char, scan, kReturn, moX, moY, bReturn);
    MagicAES.WindUpdate(MagicAES.ENDUPDATE);
  END;
  
  RETURN MagicAES.MUKEYBD IN evnt;
END isKey;

END VDIUtil.
