IMPLEMENTATION MODULE ZCalcCrc;

FROM SYSTEM IMPORT LOAD, STORE, CODE, ADR, ASSEMBLER, CAST;
(* FROM InOut IMPORT ReadString, WriteString, WriteLn, WriteCard, Read; *)
FROM CatTypes IMPORT BigTextPtr;
IMPORT AssFuncs;

PROCEDURE CalcIdCrc (REF str: ARRAY OF CHAR): CARDINAL;
(* Berechnet eine CRC ber eine ID. Dabei wird der domain-part
 * der ID nach Upcase gewandelt, da dieser case-insensitiv
 * behandelt werden soll
 *)
  VAR (*$Reg*) l : CARDINAL;
      tmp        : ARRAY [0..511] OF CHAR;
BEGIN
  l := AssFuncs.CopyId (str, tmp);
  RETURN CalcCrcArray (ADR(tmp), l);
END CalcIdCrc;

PROCEDURE CalcCrc(REF str : ARRAY OF CHAR):CARDINAL;
(*
VAR d,e,i,temp : CARDINAL;
BEGIN
  d := 0;
  e := 0;
  i := 0;
  WHILE str[i] # 0C DO
    temp := XOR(ORD(str[i]), d) MOD 256;
(* WriteString('temp:');WriteCard(temp, 8); *)
    temp := XOR(temp, temp DIV 16) MOD 256;
(* WriteCard(temp, 8);WriteLn; *)
    d := XOR(XOR((temp * 16) MOD 256, temp DIV 8), e) MOD 256;
(* WriteString('e:');WriteCard(d, 8);WriteLn; *)
    e := XOR(temp, (temp * 32) MOD 256) MOD 256;
(* WriteString('d:');WriteCard(e, 8);WriteLn; *)
    INC(i);
  END;
  RETURN d * 256 + e
*)
BEGIN
(*$W-*)
  RETURN CalcCrcArray(ADR(str), LENGTH(str));
(*$W=*)
END CalcCrc;
(*
PROCEDURE CalcCrcArray(a : BigTextPtr; howMuch : CARDINAL):CARDINAL;
VAR d,e,i,temp : CARDINAL;

  PROCEDURE XOR(c1,c2 : CARDINAL):CARDINAL;
    VAR res : CARDINAL;
  BEGIN
    LOAD (c1, 0);
    LOAD (c2, 1);
    CODE(0B141H);
    STORE (1,res);
    RETURN res
  END XOR;

BEGIN
  d := 0;
  e := 0;
  IF howMuch = 0 THEN RETURN 0 END;
  FOR i := 0 TO howMuch-1 DO
    temp := XOR(ORD(a^[i]), d) MOD 256;
    temp := XOR(temp, temp DIV 16) MOD 256;
    d := XOR(XOR((temp * 16) MOD 256, temp DIV 8), e) MOD 256;
    e := XOR(temp, (temp * 32) MOD 256) MOD 256;
  END;
  RETURN d * 256 + e
END CalcCrcArray;
*)

(*$L-,Z+*)
PROCEDURE CalcCrcArray (a : BigTextPtr; howMuch : CARDINAL):CARDINAL;
BEGIN
  ASSEMBLER
    MOVEM.L     D3-D7,-(SP)
    MOVEQ       #0,D0   ; d
    MOVEQ       #0,D1   ; e
    MOVE.W      -(A3),D2  ; Zhler
    TST.W       D2              ; D2 = 0
    BEQ.S       ret             ; Direkt 0 zurckgeben
    MOVEQ       #0,D3           ; i in Schleife
    MOVE.L      -(A3),A0        ; Basisadresse fr String
loop:
    CMP.W       D2,D3           ; Schleifenende erreicht?
    BEQ.S       retx
    MOVE.W      D0,D4           ; D4 =  temp
;     temp := XOR(ORD(a^[i]), d) MOD 256;
    MOVE.B      0(A0,D3.W),D5
    EXT.W       D5
    EOR.W       D5,D4
    ANDI.W      #$FF,D4
;     temp := XOR(temp, temp DIV 16) MOD 256;
    MOVE.W      D4,D5
    LSR.W       #4,D5
    EOR.W       D5,D4
    ANDI.W      #$FF,D4
;     d := XOR(XOR((temp * 16) MOD 256, temp DIV 8), e) MOD 256;
    MOVE.W      D4,D5
    MOVE.W      D4,D0
    LSL.W       #4,D5
    ANDI.W      #$FF,D5
    LSR.W       #3,D0
    EOR.W       D5,D0
    EOR.W       D1,D0
    ANDI.W      #$FF,D0
;     e := XOR(temp, (temp * 32) MOD 256) MOD 256;
    MOVE.W      D4,D5
    LSL.W       #5,D5
    ANDI.W      #$FF,D5
    EOR.W       D5,D4
    ANDI.W      #$FF,D4
    MOVE.W      D4,D1
    ADDQ.W      #1,D3
    BRA.S       loop
retx:
    LSL.W       #8,D0
    ADD.W       D1,D0
ret:
    MOVEM.L     (SP)+,D3-D7
  END;
END CalcCrcArray;
(*$L=*)

(* Crc - 32 BIT ANSI X3.66 CRC checksum files *)
(* modified by wr 25-8-93 *)

(**********************************************************************\
|* Demonstration program to compute the 32-bit CRC used as the frame  *|
|* check sequence in ADCCP (ANSI X3.66, also known as FIPS PUB 71     *|
|* and FED-STD-1003, the U.S. versions of CCITT's X.25 link-level     *|
|* protocol).  The 32-bit FCS was added via the Federal Register,     *|
|* 1 June 1982, p.23798.  I presume but don't know for certain that   *|
|* this polynomial is or will be included in CCITT V.41, which        *|
|* defines the 16-bit CRC (often called CRC-CCITT) polynomial.  FIPS  *|
|* PUB 78 says that the 32-bit FCS reduces otherwise undetected       *|
|* errors by a factor of 10^-5 over 16-bit FCS.                       *|
\**********************************************************************)

(* Copyright (C) 1986 Gary S. Brown.  You may use this program, or
   code or tables extracted from it, as desired without restriction.*)

(* First, the polynomial itself and its table of feedback terms.  The  *)
(* polynomial is                                                       *)
(* X^32+X^26+X^23+X^22+X^16+X^12+X^11+X^10+X^8+X^7+X^5+X^4+X^2+X^1+X^0 *)
(* Note that we take it "backwards" and put the highest-order term in  *)
(* the lowest-order bit.  The X^32 term is "implied"; the LSB is the   *)
(* X^31 term, etc.  The X^0 term (usually shown as "+1") results in    *)
(* the MSB being 1.                                                    *)

(* Note that the usual hardware shift register implementation, which   *)
(* is what we're using (we're merely optimizing it by doing eight-bit  *)
(* chunks at a time) shifts bits into the lowest-order term.  In our   *)
(* implementation, that means shifting towards the right.  Why do we   *)
(* do it this way?  Because the calculated CRC must be transmitted in  *)
(* order from highest-order term to lowest-order term.  UARTs transmit *)
(* characters in order from LSB to MSB.  By storing the CRC this way,  *)
(* we hand it to the UART in the order low-byte to high-byte; the UART *)
(* sends each low-bit to hight-bit; and the result is transmission bit *)
(* by bit from highest- to lowest-order term without requiring any bit *)
(* shuffling on our part.  Reception works similarly.                  *)

(* The feedback terms table consists of 256, 32-bit entries.  Notes:   *)
(*                                                                     *)
(*  1. The table can be generated at runtime if desired; code to do so *)
(*     is shown later.  It might not be obvious, but the feedback      *)
(*     terms simply represent the results of eight shift/xor opera-    *)
(*     tions for all combinations of data and CRC register values.     *)
(*                                                                     *)
(*  2. The CRC accumulation logic is the same for all CRC polynomials, *)
(*     be they sixteen or thirty-two bits wide.  You simply choose the *)
(*     appropriate table.  Alternatively, because the table can be     *)
(*     generated at runtime, you can start by generating the table for *)
(*     the polynomial in question and use exactly the same "updcrc",   *)
(*     if your application needn't simultaneously handle two CRC       *)
(*     polynomials.  (Note, however, that XMODEM is strange.)          *)
(*                                                                     *)
(*  3. For 16-bit CRCs, the table entries need be only 16 bits wide;   *)
(*     of course, 32-bit entries work OK if the high 16 bits are zero. *)
(*                                                                     *)
(*  4. The values must be right-shifted by eight bits by the "updcrc"  *)
(*     logic; the shift must be unsigned (bring in zeroes).  On some   *)
(*     hardware you could probably optimize the shift in assembler by  *)
(*     using byte-swap instructions.                                   *)

(*
TYPE crcConstArray = ARRAY [0..255] OF LONGCARD;

CONST crc32tab = crcConstArray { (* CRC polynomial 0xedb88320 *)
$00000000L, $77073096L, $ee0e612cL, $990951baL, $076dc419L, $706af48fL,
$e963a535L, $9e6495a3L, $0edb8832L, $79dcb8a4L, $e0d5e91eL, $97d2d988L,
$09b64c2bL, $7eb17cbdL, $e7b82d07L, $90bf1d91L, $1db71064L, $6ab020f2L,
$f3b97148L, $84be41deL, $1adad47dL, $6ddde4ebL, $f4d4b551L, $83d385c7L,
$136c9856L, $646ba8c0L, $fd62f97aL, $8a65c9ecL, $14015c4fL, $63066cd9L,
$fa0f3d63L, $8d080df5L, $3b6e20c8L, $4c69105eL, $d56041e4L, $a2677172L,
$3c03e4d1L, $4b04d447L, $d20d85fdL, $a50ab56bL, $35b5a8faL, $42b2986cL,
$dbbbc9d6L, $acbcf940L, $32d86ce3L, $45df5c75L, $dcd60dcfL, $abd13d59L,
$26d930acL, $51de003aL, $c8d75180L, $bfd06116L, $21b4f4b5L, $56b3c423L,
$cfba9599L, $b8bda50fL, $2802b89eL, $5f058808L, $c60cd9b2L, $b10be924L,
$2f6f7c87L, $58684c11L, $c1611dabL, $b6662d3dL, $76dc4190L, $01db7106L,
$98d220bcL, $efd5102aL, $71b18589L, $06b6b51fL, $9fbfe4a5L, $e8b8d433L,
$7807c9a2L, $0f00f934L, $9609a88eL, $e10e9818L, $7f6a0dbbL, $086d3d2dL,
$91646c97L, $e6635c01L, $6b6b51f4L, $1c6c6162L, $856530d8L, $f262004eL,
$6c0695edL, $1b01a57bL, $8208f4c1L, $f50fc457L, $65b0d9c6L, $12b7e950L,
$8bbeb8eaL, $fcb9887cL, $62dd1ddfL, $15da2d49L, $8cd37cf3L, $fbd44c65L,
$4db26158L, $3ab551ceL, $a3bc0074L, $d4bb30e2L, $4adfa541L, $3dd895d7L,
$a4d1c46dL, $d3d6f4fbL, $4369e96aL, $346ed9fcL, $ad678846L, $da60b8d0L,
$44042d73L, $33031de5L, $aa0a4c5fL, $dd0d7cc9L, $5005713cL, $270241aaL,
$be0b1010L, $c90c2086L, $5768b525L, $206f85b3L, $b966d409L, $ce61e49fL,
$5edef90eL, $29d9c998L, $b0d09822L, $c7d7a8b4L, $59b33d17L, $2eb40d81L,
$b7bd5c3bL, $c0ba6cadL, $edb88320L, $9abfb3b6L, $03b6e20cL, $74b1d29aL,
$ead54739L, $9dd277afL, $04db2615L, $73dc1683L, $e3630b12L, $94643b84L,
$0d6d6a3eL, $7a6a5aa8L, $e40ecf0bL, $9309ff9dL, $0a00ae27L, $7d079eb1L,
$f00f9344L, $8708a3d2L, $1e01f268L, $6906c2feL, $f762575dL, $806567cbL,
$196c3671L, $6e6b06e7L, $fed41b76L, $89d32be0L, $10da7a5aL, $67dd4accL,
$f9b9df6fL, $8ebeeff9L, $17b7be43L, $60b08ed5L, $d6d6a3e8L, $a1d1937eL,
$38d8c2c4L, $4fdff252L, $d1bb67f1L, $a6bc5767L, $3fb506ddL, $48b2364bL,
$d80d2bdaL, $af0a1b4cL, $36034af6L, $41047a60L, $df60efc3L, $a867df55L,
$316e8eefL, $4669be79L, $cb61b38cL, $bc66831aL, $256fd2a0L, $5268e236L,
$cc0c7795L, $bb0b4703L, $220216b9L, $5505262fL, $c5ba3bbeL, $b2bd0b28L,
$2bb45a92L, $5cb36a04L, $c2d7ffa7L, $b5d0cf31L, $2cd99e8bL, $5bdeae1dL,
$9b64c2b0L, $ec63f226L, $756aa39cL, $026d930aL, $9c0906a9L, $eb0e363fL,
$72076785L, $05005713L, $95bf4a82L, $e2b87a14L, $7bb12baeL, $0cb61b38L,
$92d28e9bL, $e5d5be0dL, $7cdcefb7L, $0bdbdf21L, $86d3d2d4L, $f1d4e242L,
$68ddb3f8L, $1fda836eL, $81be16cdL, $f6b9265bL, $6fb077e1L, $18b74777L,
$88085ae6L, $ff0f6a70L, $66063bcaL, $11010b5cL, $8f659effL, $f862ae69L,
$616bffd3L, $166ccf45L, $a00ae278L, $d70dd2eeL, $4e048354L, $3903b3c2L,
$a7672661L, $d06016f7L, $4969474dL, $3e6e77dbL, $aed16a4aL, $d9d65adcL,
$40df0b66L, $37d83bf0L, $a9bcae53L, $debb9ec5L, $47b2cf7fL, $30b5ffe9L,
$bdbdf21cL, $cabac28aL, $53b39330L, $24b4a3a6L, $bad03605L, $cdd70693L,
$54de5729L, $23d967bfL, $b3667a2eL, $c4614ab8L, $5d681b02L, $2a6f2b94L,
$b40bbe37L, $c30c8ea1L, $5a05df1bL, $2d02ef8dL
};

(*$L-,Z+*)
PROCEDURE XOR(c1,c2 : LONGCARD):LONGCARD;
BEGIN
  ASSEMBLER
    MOVE.L  -(A3),D1
    MOVE.L  -(A3),D0
    EOR.L   D1,D0
  END;
END XOR;
(*$L=*)

PROCEDURE crc32(adr: BigTextPtr; len: CARDINAL): LONGCARD;
  VAR (*$Reg*) oldcrc32 : LONGCARD;
      (*$Reg*) i        : CARDINAL;
BEGIN

    oldcrc32 := $FFFFFFFF;
    FOR i := len TO 0 BY -1 DO
        oldcrc32 := XOR(crc32tab[ SHORT(XOR(oldcrc32, LONG(ORD(adr^[0]))) MOD 256)], oldcrc32 DIV 256);
        INC (adr);
    END;
    
    RETURN $ffffffff - oldcrc32;
    (*
    RETURN ~oldcrc32;
    *)
END crc32;
*)

(*$L-,R-,S-,Z+*)
PROCEDURE crc32(adr: BigTextPtr; len: CARDINAL): LONGCARD;
  VAR (*$Reg*) oldcrc32 : LONGCARD;
      (*$Reg*) i        : LONGCARD;
BEGIN
  ASSEMBLER
    MOVE.W  -(A3),D0    ; len
    MOVE.L  -(A3),A0    ; adr
    LEA     crctab(PC),A1 ; crc-Tabelle
    MOVEQ   #-1,D1      ; oldcrc initialisieren
    MOVEQ   #0,D2       ; Zwischenregister
    SUBQ.W  #1,D0       ; -1 wegen DBRA
    
loop:
    MOVE.L  D1,D3       ; xor zwischen oldcrc und adr^ berechnen
    MOVE.B  (A0)+,D2    ; Zeichen nach D2
    EOR.L   D2,D3       ; Ergebnis in D3
    AND.W   #$FF,D3     ; MOD 256
    LSL.W   #2,D3       ; Ulong-Eintrge, *4
    MOVE.L  0(A1,D3.W),D2 ; Wert aus Tabelle nach D2
    LSR.L   #8,D1       ; oldcrc DIV 256
    EOR.L   D2,D1       ; XOR zwischen Tabellenwert und oldcrc DIV 256
    DBRA    D0,loop
    
    MOVE.L  D1,D0
    NOT.L   D0
    RTS

crctab:
DC.L    $00000000L, $77073096L, $ee0e612cL, $990951baL, $076dc419L, $706af48fL,
$e963a535L, $9e6495a3L, $0edb8832L, $79dcb8a4L, $e0d5e91eL, $97d2d988L,
$09b64c2bL, $7eb17cbdL, $e7b82d07L, $90bf1d91L, $1db71064L, $6ab020f2L,
$f3b97148L, $84be41deL, $1adad47dL, $6ddde4ebL, $f4d4b551L, $83d385c7L,
$136c9856L, $646ba8c0L, $fd62f97aL, $8a65c9ecL, $14015c4fL, $63066cd9L,
$fa0f3d63L, $8d080df5L, $3b6e20c8L, $4c69105eL, $d56041e4L, $a2677172L,
$3c03e4d1L, $4b04d447L, $d20d85fdL, $a50ab56bL, $35b5a8faL, $42b2986cL,
$dbbbc9d6L, $acbcf940L, $32d86ce3L, $45df5c75L, $dcd60dcfL, $abd13d59L,
$26d930acL, $51de003aL, $c8d75180L, $bfd06116L, $21b4f4b5L, $56b3c423L,
$cfba9599L, $b8bda50fL, $2802b89eL, $5f058808L, $c60cd9b2L, $b10be924L,
$2f6f7c87L, $58684c11L, $c1611dabL, $b6662d3dL, $76dc4190L, $01db7106L,
$98d220bcL, $efd5102aL, $71b18589L, $06b6b51fL, $9fbfe4a5L, $e8b8d433L,
$7807c9a2L, $0f00f934L, $9609a88eL, $e10e9818L, $7f6a0dbbL, $086d3d2dL,
$91646c97L, $e6635c01L, $6b6b51f4L, $1c6c6162L, $856530d8L, $f262004eL,
$6c0695edL, $1b01a57bL, $8208f4c1L, $f50fc457L, $65b0d9c6L, $12b7e950L,
$8bbeb8eaL, $fcb9887cL, $62dd1ddfL, $15da2d49L, $8cd37cf3L, $fbd44c65L,
$4db26158L, $3ab551ceL, $a3bc0074L, $d4bb30e2L, $4adfa541L, $3dd895d7L,
$a4d1c46dL, $d3d6f4fbL, $4369e96aL, $346ed9fcL, $ad678846L, $da60b8d0L,
$44042d73L, $33031de5L, $aa0a4c5fL, $dd0d7cc9L, $5005713cL, $270241aaL,
$be0b1010L, $c90c2086L, $5768b525L, $206f85b3L, $b966d409L, $ce61e49fL,
$5edef90eL, $29d9c998L, $b0d09822L, $c7d7a8b4L, $59b33d17L, $2eb40d81L,
$b7bd5c3bL, $c0ba6cadL, $edb88320L, $9abfb3b6L, $03b6e20cL, $74b1d29aL,
$ead54739L, $9dd277afL, $04db2615L, $73dc1683L, $e3630b12L, $94643b84L,
$0d6d6a3eL, $7a6a5aa8L, $e40ecf0bL, $9309ff9dL, $0a00ae27L, $7d079eb1L,
$f00f9344L, $8708a3d2L, $1e01f268L, $6906c2feL, $f762575dL, $806567cbL,
$196c3671L, $6e6b06e7L, $fed41b76L, $89d32be0L, $10da7a5aL, $67dd4accL,
$f9b9df6fL, $8ebeeff9L, $17b7be43L, $60b08ed5L, $d6d6a3e8L, $a1d1937eL,
$38d8c2c4L, $4fdff252L, $d1bb67f1L, $a6bc5767L, $3fb506ddL, $48b2364bL,
$d80d2bdaL, $af0a1b4cL, $36034af6L, $41047a60L, $df60efc3L, $a867df55L,
$316e8eefL, $4669be79L, $cb61b38cL, $bc66831aL, $256fd2a0L, $5268e236L,
$cc0c7795L, $bb0b4703L, $220216b9L, $5505262fL, $c5ba3bbeL, $b2bd0b28L,
$2bb45a92L, $5cb36a04L, $c2d7ffa7L, $b5d0cf31L, $2cd99e8bL, $5bdeae1dL,
$9b64c2b0L, $ec63f226L, $756aa39cL, $026d930aL, $9c0906a9L, $eb0e363fL,
$72076785L, $05005713L, $95bf4a82L, $e2b87a14L, $7bb12baeL, $0cb61b38L,
$92d28e9bL, $e5d5be0dL, $7cdcefb7L, $0bdbdf21L, $86d3d2d4L, $f1d4e242L,
$68ddb3f8L, $1fda836eL, $81be16cdL, $f6b9265bL, $6fb077e1L, $18b74777L,
$88085ae6L, $ff0f6a70L, $66063bcaL, $11010b5cL, $8f659effL, $f862ae69L,
$616bffd3L, $166ccf45L, $a00ae278L, $d70dd2eeL, $4e048354L, $3903b3c2L,
$a7672661L, $d06016f7L, $4969474dL, $3e6e77dbL, $aed16a4aL, $d9d65adcL,
$40df0b66L, $37d83bf0L, $a9bcae53L, $debb9ec5L, $47b2cf7fL, $30b5ffe9L,
$bdbdf21cL, $cabac28aL, $53b39330L, $24b4a3a6L, $bad03605L, $cdd70693L,
$54de5729L, $23d967bfL, $b3667a2eL, $c4614ab8L, $5d681b02L, $2a6f2b94L,
$b40bbe37L, $c30c8ea1L, $5a05df1bL, $2d02ef8dL
  END;
END crc32;
(*$L=*)

(*
VAR str : ARRAY[0..80] OF CHAR;
VAR str2 : ARRAY[0..80] OF CHAR;

BEGIN
  REPEAT
  ReadString(str); WriteLn;
  WriteString(str);WriteLn;
  WriteCard(CalcCrc(str),8); WriteLn;
  WriteCard(CalcIdCrc(str),8); WriteLn;
  Read(str[0]);
  UNTIL str[0] = ' ';
  REPEAT
  ReadString(str); WriteLn;
  WriteString(str);WriteLn;
  ReadString(str2); WriteLn;
  WriteString(str2);WriteLn;
  WriteString ('alte: '); WriteString (str); WriteLn;
  WriteString ('neue: '); WriteString (str2); WriteLn;
  IF AssFuncs.CmpId (str, str2)
  THEN
    WriteString ('sind gleich'); 
  ELSE
    WriteString ('sind nicht gleich');
  END;
  WriteLn;
  Read(str[0]);
  UNTIL str[0] = ' ';
  *)
END ZCalcCrc.
