IMPLEMENTATION MODULE ZSearchDial;

(*$H+*)
(*$Z+*)

FROM SYSTEM       IMPORT ADDRESS, ADR;
FROM Void         IMPORT v;
FROM UserInformation IMPORT UserBLK;

IMPORT MagicAES;
IMPORT MagicStrings;
IMPORT mtUtils;
IMPORT mtDials;
IMPORT mtAlerts;
IMPORT MTE;
IMPORT mtPopups;
IMPORT CatHelp;
IMPORT VDIUtil;
IMPORT SearchHelp;
IMPORT Varnames;
IMPORT ConfVars;
IMPORT CatGlobal;

IMPORT WinDials;

IMPORT CatTypes;
FROM CatTypes     IMPORT Trick;

IMPORT MausTauschrsc;
(*IMPORT InOut;*)

VAR theForm,
    smallForm   : ADDRESS;
    objPtr      : mtUtils.tObjcTree;
    smallPtr    : mtUtils.tObjcTree;
    searchwhere,
    logical     : ADDRESS;
    moreOptions : BOOLEAN;
    lastKonfig  : INTEGER;
    sBit1, sBit2, sBit3,
    sBit4, sBit5, sBit6 : BITSET;
    l                   : CARDINAL;
    scrapKonf           : SearchHelp.SearchRecordType;
    
  PROCEDURE SetItem(tree : ADDRESS; item : INTEGER; b : BOOLEAN);
  BEGIN
    IF b THEN
      mtUtils.InclState(tree, item, MagicAES.SELECTED);
    ELSE
      mtUtils.ExclState(tree, item, MagicAES.SELECTED);
    END;
  END SetItem;

VAR init : BOOLEAN;

TYPE     keyArrayType = ARRAY [0..11] OF INTEGER;

CONST    keyArray = keyArrayType{38, 33, 23, 20, 32, 37, 48, 46, 45, 47, 50, 0};
CONST    numArray = keyArrayType{2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 0, 0 };

PROCEDURE InitMenuStr():BOOLEAN;
VAR obj : mtUtils.tObjcTree;
    t   : Trick;
BEGIN
  IF init THEN
    ConfVars.GetConfDefBool(cMoreOptions, moreOptions, FALSE);
    obj := MausTauschrsc.TreeAddr^[MausTauschrsc.suchbox];
    obj^[MausTauschrsc.searchst1].obSpec.TedPtr^.tePtext^[0] := '@';
    obj^[MausTauschrsc.searchst2].obSpec.TedPtr^.tePtext^[0] := '@';
    obj^[MausTauschrsc.searchst3].obSpec.TedPtr^.tePtext^[0] := '@';
    obj^[MausTauschrsc.searchst4].obSpec.TedPtr^.tePtext^[0] := '@';

    obj := MausTauschrsc.TreeAddr^[MausTauschrsc.smallsuchbox];
    obj^[MausTauschrsc.smsearchstr].obSpec.TedPtr^.tePtext^[0] := '@';

    theForm     := MausTauschrsc.TreeAddr^[MausTauschrsc.suchbox];
    searchwhere := MausTauschrsc.TreeAddr^[MausTauschrsc.searchselecttext];
    logical     := MausTauschrsc.TreeAddr^[MausTauschrsc.searchselectlogi];
    smallForm   := MausTauschrsc.TreeAddr^[MausTauschrsc.smallsuchbox];

    init := FALSE;    
    RETURN TRUE (* mtDials.NewDial(theForm) & mtDials.NewDial(flagBox)*);
  ELSE
    RETURN TRUE
  END;
END InitMenuStr;

  PROCEDURE SetBits(tree : ADDRESS; set, clear : BITSET; start, end : CARDINAL);
  VAR z : CARDINAL;
      newState : INTEGER;
  BEGIN
    FOR z := start TO end DO
      IF (z-start IN set) THEN newState := mtUtils.SETNEW
      ELSIF (z-start IN clear) THEN newState := mtUtils.CLEAR
      ELSE newState := mtUtils.NOCHANGE
      END;
      mtUtils.SetThreeState (tree, z, newState);
    END;
  END SetBits;

  PROCEDURE SetThem(tree : ADDRESS;
                VAR set1, clear1, set2, clear2 : BITSET;
                    start1, end1, start2, end2 : INTEGER);
  BEGIN
    SetBits(tree, set1, clear1, start1, end1);
    SetBits(tree, set2, clear2, start2, end2);
(*    SetBits(tree, sBit4, sBit5, MausTauschrsc.stflgtop, MausTauschrsc.stflgbot); *)
  END SetThem;

  PROCEDURE GetBits (tree : ADDRESS; start, end : CARDINAL; state : INTEGER):BITSET;
  VAR z : CARDINAL; b : BITSET;
  BEGIN
    b := {};
    FOR z := start TO end DO
      IF mtUtils.GetThreeState (tree, z) = state THEN INCL(b, z-start) END;
    END;
    RETURN b
  END GetBits;

  PROCEDURE GetThem(tree : ADDRESS; 
                VAR set1, clear1, set2, clear2 : BITSET;
                    start1, end1, start2, end2 : INTEGER);
  BEGIN
    set1   := GetBits (tree, start1, end1, mtUtils.SETNEW);
    clear1 := GetBits (tree, start1, end1, mtUtils.CLEAR);
    set2   := GetBits (tree, start2, end2, mtUtils.SETNEW);
    clear2 := GetBits (tree, start2, end2, mtUtils.CLEAR);
  END GetThem;

TYPE searchEnv = RECORD
                    suchVar     : SearchHelp.SearchRecordType;
                    forList     : BOOLEAN;
                    exitBut     : INTEGER;
                  END;
     searchEnvPtr = POINTER TO searchEnv;

PROCEDURE GetStr(objPtr : mtUtils.tObjcTree; item : INTEGER;VAR str : ARRAY OF CHAR);
BEGIN
  mtUtils.ObjcString (objPtr, item, str);
  IF str[0] = '@'
  THEN
    MagicStrings.Assign('',str);
  END;
END GetStr;

PROCEDURE SetStr(objPtr : mtUtils.tObjcTree;item : INTEGER;VAR str : ARRAY OF CHAR);
BEGIN
  mtUtils.SetObjcString(objPtr, item, str);
END SetStr;

PROCEDURE isSelect(tree : ADDRESS; item : INTEGER):BOOLEAN;
BEGIN
  RETURN mtUtils.InState(tree, item, MagicAES.SELECTED)
END isSelect;

PROCEDURE Switch(set : INTEGER; b : BOOLEAN);
BEGIN
  SetItem(theForm, set, b);
  WinDials.WinDialDraw(theForm, set, 0, v.r, FALSE);
END Switch;

PROCEDURE SetXXString (tree  : ADDRESS; obj: INTEGER;
                       sTree : ADDRESS; idx: INTEGER);
VAR selStr  : ARRAY [0..40] OF CHAR;
BEGIN
  mtUtils.ObjcString (sTree, idx+1, selStr);
  MagicStrings.Delete(selStr, 0, 1);
  mtUtils.SetObjcString (tree, obj, selStr);
END SetXXString;

PROCEDURE SetYYString(obj: INTEGER; wo : INTEGER);
(* Ich wei, blder Name.. :-) *)
BEGIN
  SetXXString(theForm, obj, searchwhere, wo);
END SetYYString;

PROCEDURE SetZZString(obj: INTEGER; verkn : INTEGER);
(* Ich wei, auch ein blder Name.. :-) *)
BEGIN
  SetXXString(theForm, obj, logical, verkn);
END SetZZString;

PROCEDURE SetPopupStrings(VAR suchVar : SearchHelp.SearchRecordType);
(* Inhalte der Popupfelder gem der Eingabeparameter wo0..wo3 und verkn0..verkn2 setzen *)
VAR t : Trick;
BEGIN
  SetYYString(MausTauschrsc.where1, suchVar.wo[0]);
  SetYYString(MausTauschrsc.where2, suchVar.wo[1]);
  SetYYString(MausTauschrsc.where3, suchVar.wo[2]);
  SetYYString(MausTauschrsc.where4, suchVar.wo[3]);
  (* Gendert 17.8.93 by DS: Mit SetXState ist das schner und krzer *)
  VDIUtil.SetXState (objPtr, MausTauschrsc.where1, suchVar.wo[0]);
  VDIUtil.SetXState (objPtr, MausTauschrsc.where2, suchVar.wo[1]);
  VDIUtil.SetXState (objPtr, MausTauschrsc.where3, suchVar.wo[2]);
  VDIUtil.SetXState (objPtr, MausTauschrsc.where4, suchVar.wo[3]);

  SetZZString(MausTauschrsc.logical1, suchVar.verkn[0]);
  SetZZString(MausTauschrsc.logical2, suchVar.verkn[1]);
  SetZZString(MausTauschrsc.logical3, suchVar.verkn[2]);
  
  VDIUtil.SetXState (objPtr, MausTauschrsc.logical1, suchVar.verkn[0]);
  VDIUtil.SetXState (objPtr, MausTauschrsc.logical2, suchVar.verkn[1]);
  VDIUtil.SetXState (objPtr, MausTauschrsc.logical3, suchVar.verkn[2]);
END SetPopupStrings;

PROCEDURE GetPopupStrings(VAR suchVar : SearchHelp.SearchRecordType);
(* Inhalte der Popupfelder gem der Eingabeparameter wo0..wo3 und verkn0..verkn2 setzen *)
VAR t : Trick;
BEGIN
  (* Auch hier umgestellt auf GetXState, ist krzer *)
  suchVar.wo[0] := VDIUtil.GetXState (objPtr, MausTauschrsc.where1);
  suchVar.wo[1] := VDIUtil.GetXState (objPtr, MausTauschrsc.where2);
  suchVar.wo[2] := VDIUtil.GetXState (objPtr, MausTauschrsc.where3);
  suchVar.wo[3] := VDIUtil.GetXState (objPtr, MausTauschrsc.where4);
  suchVar.verkn[0] := VDIUtil.GetXState (objPtr, MausTauschrsc.logical1);
  suchVar.verkn[1] := VDIUtil.GetXState (objPtr, MausTauschrsc.logical2);
  suchVar.verkn[2] := VDIUtil.GetXState (objPtr, MausTauschrsc.logical3);
END GetPopupStrings;

PROCEDURE ValidateSearchOpts(exit: INTEGER): BOOLEAN;
BEGIN
  (* Nur bei groer Suchbox: Flageinstellungen berprfen *)
  IF moreOptions &
     ( (exit = MausTauschrsc.sok) OR
       (exit = MausTauschrsc.searchstartback) OR
       (exit = MausTauschrsc.searchstartahead)
     ) THEN
    GetThem(theForm,
            sBit1, sBit2, sBit4, sBit5,
            MausTauschrsc.sflgtop, MausTauschrsc.sflgbot,
            MausTauschrsc.stflgtop, MausTauschrsc.stflgbot);
    IF (l = 0) & ~isSelect(theForm, MausTauschrsc.sforflag) THEN
      MTE.info (MTE.emptySearchStr);
      RETURN FALSE;
    END;
    (* Anzeige und change aus?, nur meckern, falls nicht schon neue Runde verordnet *)
    IF ~isSelect(theForm, MausTauschrsc.showmess) & ~isSelect(theForm, MausTauschrsc.ssetflag) THEN
      MTE.info (MTE.noSearchAction);
      RETURN FALSE;
    END;
    IF ~isSelect (theForm, MausTauschrsc.salltext) & ~isSelect (theForm, MausTauschrsc.sforflag)
    THEN
      MTE.info (MTE.noSearchFunc);
      RETURN FALSE;
    END;
    IF isSelect(theForm, MausTauschrsc.sforflag) THEN
      sBit3 := sBit1 * sBit2;
      (* leere Suchmaske *)
      IF (sBit1 +sBit2 = {}) THEN
        MTE.info (MTE.emptySearchMask);
        RETURN FALSE;
      END;
    END;
    IF isSelect(theForm, MausTauschrsc.ssetflag) THEN
      sBit6 := sBit4 * sBit5;
     (* leere Setzmaske *)
      IF (sBit4 +sBit5 = {}) THEN
        MTE.info (MTE.emptySetMask);
        RETURN FALSE;
      END;
    END;
    
    (* Jetzt noch Suchstring prfen *)
    IF (l > 0) & (isSelect (theForm, MausTauschrsc.salltext)) (* OR ~moreOptions *)
    THEN
      (* moreOptions ausgeklammert, da der Teil hier eh nur durchlaufen wird,
       * wenn moreOptions angeschaltet ist!
       *)
      GetStr (objPtr, MausTauschrsc.searchst1, scrapKonf.searchStr[0]);
      IF ~SearchHelp.IsValidSearch (scrapKonf.searchStr[0])
      THEN
        MTE.info (MTE.noSearchStr);
        RETURN FALSE
      END;
      GetStr (objPtr, MausTauschrsc.searchst2, scrapKonf.searchStr[1]);
      IF (MagicStrings.Length (scrapKonf.searchStr[1]) > 0)
       & ~SearchHelp.IsValidSearch (scrapKonf.searchStr[1])
      THEN
        MTE.info (MTE.noSearchStr);
        RETURN FALSE
      END;
      GetStr (objPtr, MausTauschrsc.searchst3, scrapKonf.searchStr[2]);
      IF (MagicStrings.Length (scrapKonf.searchStr[2]) > 0)
       & ~SearchHelp.IsValidSearch (scrapKonf.searchStr[2])
      THEN
        MTE.info (MTE.noSearchStr);
        RETURN FALSE
      END;
      GetStr (objPtr, MausTauschrsc.searchst4, scrapKonf.searchStr[3]);
      IF (MagicStrings.Length (scrapKonf.searchStr[3]) > 0)
       & ~SearchHelp.IsValidSearch (scrapKonf.searchStr[3])
      THEN
        MTE.info (MTE.noSearchStr);
        RETURN FALSE
      END;

      (*
      (* Jetzt der eigentliche Test *)
      WHILE ((scrapKonf.searchStr[0,0] = '*') OR (scrapKonf.searchStr[0,0] = '?')) & 
            (MagicStrings.Length (scrapKonf.searchStr[0]) > 0) DO
        MagicStrings.Delete (scrapKonf.searchStr[0], 0, 1);
        IF MagicStrings.Length (scrapKonf.searchStr[0]) = 0
        THEN
          MTE.info (MTE.noSearchStr);
          RETURN FALSE
        END;
      END;
      *)
    END;
  ELSIF ~moreOptions & 
     ( (exit = MausTauschrsc.smsearchok) OR
       (exit = MausTauschrsc.smfastback) OR
       (exit = MausTauschrsc.smfastahead)
     ) 
  THEN
    (* Bei kleiner Box: berprfen, ob der Suchstring leer ist *)
    IF (l = 0) THEN
      MTE.info (MTE.emptySearchStr0);
      RETURN FALSE;
    END;
    IF (l > 0)
    THEN
      GetStr (smallPtr, MausTauschrsc.smsearchstr, scrapKonf.searchStr[0]);
      (* Jetzt der eigentliche Test *)
      WHILE ((scrapKonf.searchStr[0,0] = '*') OR (scrapKonf.searchStr[0,0] = '?')) & 
            (MagicStrings.Length (scrapKonf.searchStr[0]) > 0) DO
        MagicStrings.Delete (scrapKonf.searchStr[0], 0, 1);
        IF MagicStrings.Length (scrapKonf.searchStr[0]) = 0
        THEN
          MTE.info (MTE.noSearchStr);
          RETURN FALSE;
        END;
      END;
    END;
  END; (* # Sabbr.. *)
  RETURN TRUE;
END ValidateSearchOpts;

PROCEDURE setKonfToBox(VAR konf : SearchHelp.SearchRecordType);
BEGIN
  WITH konf DO
    (* Box initialisieren *)
    SetThem(theForm,
            sSetBits, sClearedBits, setBits, clearBits,
            MausTauschrsc.sflgtop, MausTauschrsc.sflgbot, 
            MausTauschrsc.stflgtop, MausTauschrsc.stflgbot);
    (* Bits setzen *)
  
    SetItem(theForm, MausTauschrsc.showmess, show);
    SetItem(theForm, MausTauschrsc.sforflag, statussearch);
    SetItem(theForm, MausTauschrsc.ssetflag, change);
    SetItem(theForm, MausTauschrsc.askset, ask);
    SetItem(theForm, MausTauschrsc.salltext, searchText);
    SetItem(theForm, MausTauschrsc.smignore, gross);
    SetItem(theForm, MausTauschrsc.nogroupborder, groupsearch);

    SetStr(objPtr, MausTauschrsc.searchst1, searchStr[0]);
    SetStr(objPtr, MausTauschrsc.searchst2, searchStr[1]);
    SetStr(objPtr, MausTauschrsc.searchst3, searchStr[2]);
    SetStr(objPtr, MausTauschrsc.searchst4, searchStr[3]);
  END;
  SetPopupStrings(konf);
END setKonfToBox;

PROCEDURE getKonfFromBox(exit: INTEGER; VAR konf : SearchHelp.SearchRecordType): BOOLEAN;
BEGIN
  IF ValidateSearchOpts(exit)
  THEN
    WITH konf DO
      GetThem(theForm,
              sSetBits, sClearedBits, setBits, clearBits,
              MausTauschrsc.sflgtop, MausTauschrsc.sflgbot,
              MausTauschrsc.stflgtop, MausTauschrsc.stflgbot);
      show         := isSelect(theForm, MausTauschrsc.showmess);
      gross        := isSelect(theForm, MausTauschrsc.smignore);
      change       := isSelect(theForm, MausTauschrsc.ssetflag);
      statussearch := isSelect(theForm, MausTauschrsc.sforflag);
      ask          := isSelect(theForm, MausTauschrsc.askset);
      searchText   := isSelect(theForm, MausTauschrsc.salltext);
      groupsearch  := isSelect(theForm, MausTauschrsc.nogroupborder);
      GetStr (objPtr, MausTauschrsc.searchst1, searchStr[0]);
      GetStr (objPtr, MausTauschrsc.searchst2, searchStr[1]);
      GetStr (objPtr, MausTauschrsc.searchst3, searchStr[2]);
      GetStr (objPtr, MausTauschrsc.searchst4, searchStr[3]);
      GetPopupStrings(konf);
      RETURN TRUE;
    END;
  END;
  RETURN FALSE;
END getKonfFromBox;


PROCEDURE bigBoxGetSetValues (tree: ADDRESS; private: ADDRESS; 
                              set: BOOLEAN; exit: INTEGER);
  VAR envPtr : searchEnvPtr;
      i, z   : INTEGER;
BEGIN
  envPtr := ADDRESS(private);
  IF set
  THEN
    WITH envPtr^ DO
      (* Einige Buttons zeigen oder verstecken *)
      
      mtUtils.SetFlag (tree, MausTauschrsc.showmess, MagicAES.HIDETREE, forList);
      IF forList
      THEN 
        mtUtils.InclState(tree, MausTauschrsc.showmess, MagicAES.SELECTED);
      END;
      
      FOR i := MausTauschrsc.logical1 TO MausTauschrsc.bwhere4 DO
        mtUtils.SetState (tree, i, MagicAES.DISABLED, FALSE);
        mtUtils.SetFlag  (tree, i, MagicAES.TOUCHEXIT, TRUE);
      END;
      (* Sonderbehandlung fr Strings anschlieend *)
      mtUtils.SetFlag (tree, MausTauschrsc.searchst2, MagicAES.EDITABLE, TRUE);
      mtUtils.SetFlag (tree, MausTauschrsc.searchst3, MagicAES.EDITABLE, TRUE);
      mtUtils.SetFlag (tree, MausTauschrsc.searchst4, MagicAES.EDITABLE, TRUE);
      mtUtils.SetFlag (tree, MausTauschrsc.searchst2, MagicAES.TOUCHEXIT, FALSE);
      mtUtils.SetFlag (tree, MausTauschrsc.searchst3, MagicAES.TOUCHEXIT, FALSE);
      mtUtils.SetFlag (tree, MausTauschrsc.searchst4, MagicAES.TOUCHEXIT, FALSE);
  
      (* Der braucht eine Sonderbehandlung *)
      mtUtils.SetState (tree, MausTauschrsc.nogroupborder, MagicAES.DISABLED, forList);
      
      (* User-definierte Strings fr die freien Flags setzen.. *)
      mtUtils.SetObjcString (tree, MausTauschrsc.userflg1, UserBLK.ustr1);
      mtUtils.SetObjcString (tree, MausTauschrsc.userflg2, UserBLK.ustr2);
  
      (* Userkeys fr die Flags setzen *)
      FOR z := MausTauschrsc.sflgtop TO MausTauschrsc.sflgbot DO
        mtDials.SetUserkey (tree, z, keyArray[z-MausTauschrsc.sflgtop], {MagicAES.KALT}, TRUE, TRUE);
      END;
      FOR z := MausTauschrsc.stflgtop TO MausTauschrsc.stflgbot DO
        mtDials.SetUserkey (tree, z, keyArray[z-MausTauschrsc.stflgtop], {MagicAES.KALT, MagicAES.KRSHIFT}, TRUE, TRUE);
      END;
      (* Userkeys fr die Konfigs setzen *)
      FOR z := MausTauschrsc.searchkonf1 TO MausTauschrsc.searchkonf10 DO
        mtDials.SetUserkey (tree, z, numArray[z-MausTauschrsc.searchkonf1], {MagicAES.KALT}, TRUE, TRUE);
      END;
    END;
  ELSE
    exit := INTEGER(BITSET(exit) - {15});
    envPtr^.exitBut := exit;
  END;
END bigBoxGetSetValues;

PROCEDURE bigBoxButton (tree: ADDRESS; private: ADDRESS; button: INTEGER;
                        mx, my : INTEGER; kstate: BITSET; clicks: INTEGER): BOOLEAN;
  VAR envPtr : searchEnvPtr;
      i      : INTEGER;
      exit   : INTEGER;
      x, y   : INTEGER;
      t      : Trick;
      select : INTEGER;
      z      : INTEGER;
      again  : BOOLEAN;
      scrapkonf : SearchHelp.SearchRecordType;
BEGIN
  envPtr := ADDRESS(private);
  WITH envPtr^ DO
    exit := INTEGER(BITSET(button) - {15});
    
    again := TRUE;
    CASE exit OF
      MausTauschrsc.sok,
      MausTauschrsc.sabbr,
      MausTauschrsc.searchstartahead,
      MausTauschrsc.searchstartback,
      MausTauschrsc.lessoptions : again := FALSE;
    | MausTauschrsc.showmess  :
        Switch(MausTauschrsc.showmess, ~isSelect(tree, MausTauschrsc.showmess));
        IF ~isSelect(tree, MausTauschrsc.showmess) THEN
          Switch(MausTauschrsc.askset, FALSE);
        END;
    | MausTauschrsc.askset:
        Switch(MausTauschrsc.askset, ~isSelect(tree, MausTauschrsc.askset));
        IF ~isSelect(tree, MausTauschrsc.showmess) THEN
          Switch(MausTauschrsc.showmess, ~isSelect(tree, MausTauschrsc.showmess));
        END;
    | MausTauschrsc.logical1,
      MausTauschrsc.logical2,
      MausTauschrsc.logical3 :
        MagicAES.ObjcOffset (tree, exit, x, y);
        t := ADR (objPtr^[exit].obState);
        select := mtPopups.TreePopup (logical, x, y, ORD(t^.hi))-1;
        IF select >= 0 THEN
          t^.hi := CHR(select);
          SetXXString(tree, exit, logical, select);
          WinDials.WinDialDraw (tree, exit, 0, v.r, FALSE);
        END;
    | MausTauschrsc.where1, 
      MausTauschrsc.where2, 
      MausTauschrsc.where3, 
      MausTauschrsc.where4 :
        MagicAES.ObjcOffset (tree, exit, x, y);
        t := ADR (objPtr^[exit].obState);
        select := mtPopups.TreePopup (searchwhere, x, y, ORD(t^.hi))-1;
        IF select >= 0 THEN
          t^.hi := CHR(select);
          SetXXString(tree, exit, searchwhere, select);
          WinDials.WinDialDraw (tree, exit, 0, v.r, FALSE);
        END;
    | MausTauschrsc.blogical1, 
      MausTauschrsc.blogical2,
      MausTauschrsc.blogical3:
        t := ADR (objPtr^[exit-1].obState);
        t^.hi := CHR((ORD(t^.hi)+1) MOD 2);
        select := ORD (t^.hi);
        SetXXString(tree, exit-1, logical, select);
        WinDials.WinDialDraw (tree, exit-1, 0, v.r, FALSE); 
    | MausTauschrsc.bwhere1, 
      MausTauschrsc.bwhere2, 
      MausTauschrsc.bwhere3, 
      MausTauschrsc.bwhere4 :
        t := ADR (objPtr^[exit-1].obState);
        t^.hi := CHR((ORD(t^.hi)+1) MOD 7);
        select := ORD (t^.hi);
        SetXXString(tree, exit-1, searchwhere, select);
        WinDials.WinDialDraw (tree, exit-1, 0, v.r, FALSE);
    | MausTauschrsc.searchhelp:
        CatHelp.DoHelp (CatHelp.searchdial);
        mtUtils.ExclState(tree, exit, MagicAES.SELECTED);
        WinDials.WinDialDraw (tree, exit, 0, v.r, FALSE);
    | MausTauschrsc.searchkonf1..MausTauschrsc.searchkonf10 :
        IF clicks > 1 THEN
          IF objPtr^[MausTauschrsc.searchst1].obSpec.TedPtr^.tePtext^[0] = '@' THEN
            l := 0;
          ELSE
            l := MagicStrings.Length(objPtr^[MausTauschrsc.searchst1].obSpec.TedPtr^.tePtext^);
          END;
          IF getKonfFromBox(exit, scrapkonf)
          THEN
            v.bool := SearchHelp.setKonf(exit-MausTauschrsc.searchkonf1, scrapkonf)
          END;
        ELSE
          IF SearchHelp.getKonf(exit - MausTauschrsc.searchkonf1, suchVar) THEN
            setKonfToBox(suchVar);
            IF lastKonfig # -1 THEN
              mtUtils.ExclState(tree, lastKonfig, MagicAES.SELECTED);
            END;
            lastKonfig := exit;
            mtUtils.InclState(tree, exit, MagicAES.SELECTED);
            WinDials.WinDialDraw(tree, 0, 200, v.r, FALSE);
          END;
        END;
    ELSE
      again := TRUE;
    END;
  END;
  RETURN ~again;
END bigBoxButton;  

PROCEDURE SearchDial(VAR suchVar : SearchHelp.SearchRecordType; forList: BOOLEAN):INTEGER;
(* Die Vars sind gleichzeitig Eingabeparameter, damit werden die einzelnen
   Punkte gefllt, mu dem alten Aussehen entsprechen *)

VAR exit                : INTEGER;
    again               : BOOLEAN;
    gross               : BOOLEAN;
    OptionSwitch        : BOOLEAN;

 

  PROCEDURE setKonfToSmallBox(VAR konf : SearchHelp.SearchRecordType);
  BEGIN
    WITH konf DO
      SetItem(smallForm, MausTauschrsc.smgrosseqklein, gross);
      SetStr(smallForm, MausTauschrsc.smsearchstr, searchStr[0]);
    END;
  END setKonfToSmallBox;
  
  PROCEDURE getKonfFromSmallBox(VAR konf : SearchHelp.SearchRecordType);
  BEGIN
    WITH konf DO
      (* alle Bitsets sind unverndert *)
      show         := TRUE;
      gross        := isSelect(smallForm, MausTauschrsc.smgrosseqklein);
      change       := FALSE;
      statussearch := FALSE;
      (* ask ist unverndert *)
      searchText   := TRUE;
      groupsearch  := FALSE; (* keine gruppenbergreifende Suche *)
      GetStr (smallForm, MausTauschrsc.smsearchstr, searchStr[0]);
      searchStr[1] := '';
      (* zweiten String ausschalten, damit nur nach dem ersten gesucht wird *)
      suchVar.wo[0] := SearchHelp.sUEBERALL;
      (* Die restlichen Strings sind unverndert, dto. Logik und Suchorte *)
    END;
  END getKonfFromSmallBox;
  

(*TYPE SetProc = PROCEDURE(INTEGER, BOOLEAN); *)

  PROCEDURE smallHandle(suchVar : SearchHelp.SearchRecordType):INTEGER;
  (* Kleine Suchbox bearbeiten *)
  VAR exit   : INTEGER;
  BEGIN
    REPEAT
      exit := WinDials.WinDialDo (smallForm, 0);
      exit := INTEGER(BITSET(exit) - {15});
      IF exit = MausTauschrsc.smhelp THEN
        CatHelp.DoHelp (CatHelp.smallsearch);
      END;
    UNTIL exit # MausTauschrsc.smhelp;
    RETURN exit
  END smallHandle;


  PROCEDURE FormHandle(suchVar : SearchHelp.SearchRecordType; forList: BOOLEAN):INTEGER;
  (* grosse Suchbox bearbeiten *)
  VAR search: searchEnv;
  BEGIN
    search.suchVar := suchVar;
    search.forList := forList;
    
    IF ~WinDials.OpenWinDial (theForm, TRUE, 
                              bigBoxGetSetValues,
                              bigBoxGetSetValues,
                              bigBoxButton,
                              WinDials.defDraw,
                              "",
                              ADR(search))
    THEN
      MTE.noWinDialAlert();
      RETURN -1;
    END;
    
    WinDials.WinDialHandleEvents();
    
    suchVar := search.suchVar;
    mtUtils.ExclState(theForm, search.exitBut, MagicAES.SELECTED);
    RETURN search.exitBut;
  
  END FormHandle;

BEGIN
  objPtr   := MausTauschrsc.TreeAddr^[MausTauschrsc.suchbox];
  smallPtr := MausTauschrsc.TreeAddr^[MausTauschrsc.smallsuchbox];
  ConfVars.GetConfDefBool(cMoreOptions, moreOptions, FALSE);

  scrapKonf := suchVar;
  
  (* Alten Inhalt in die Boxen kopieren *)
  setKonfToBox(scrapKonf);
  setKonfToSmallBox(scrapKonf);

  REPEAT
    again        := FALSE;
    OptionSwitch := FALSE;

    IF moreOptions THEN
      exit := FormHandle(scrapKonf, forList);
      IF exit < 0
      THEN 
        (* Fehler aufgreten *)
        again := FALSE;
      ELSIF exit = MausTauschrsc.lessoptions THEN
        again         := TRUE;
        moreOptions   := FALSE; 
        OptionSwitch  := TRUE;
        v.bool        := ConfVars.SetConfigBool (cMoreOptions, FALSE);

        IF getKonfFromBox(exit, scrapKonf)
        THEN
          setKonfToSmallBox(scrapKonf);
        END;
      ELSE
        IF objPtr^[MausTauschrsc.searchst1].obSpec.TedPtr^.tePtext^[0] = '@' THEN
          l := 0;
        ELSE
          l := MagicStrings.Length(objPtr^[MausTauschrsc.searchst1].obSpec.TedPtr^.tePtext^);
        END;
      END;
    ELSE
      exit := smallHandle(scrapKonf);
      IF exit = MausTauschrsc.smmoreoptions THEN
        again         := TRUE;
        moreOptions   := TRUE; 
        OptionSwitch  := TRUE;
        v.bool        := ConfVars.SetConfigBool (cMoreOptions, TRUE);
        scrapKonf.gross := isSelect(smallForm, MausTauschrsc.smgrosseqklein);
        GetStr (smallForm, MausTauschrsc.smsearchstr, scrapKonf.searchStr[0]);
        setKonfToBox(scrapKonf);
      ELSE
        IF smallPtr^[MausTauschrsc.smsearchstr].obSpec.TedPtr^.tePtext^[0] = '@' THEN
          l := 0;
        ELSE
          l := MagicStrings.Length(smallPtr^[MausTauschrsc.smsearchstr].obSpec.TedPtr^.tePtext^);
        END;
      END;
    END;
    
    IF ~OptionSwitch
    THEN
      again := ~ValidateSearchOpts(exit);
    END;

  UNTIL ~again OR 
        (moreOptions  & (exit = MausTauschrsc.sabbr)) OR
        (~moreOptions & (exit = MausTauschrsc.smsearchabbruch));
  IF moreOptions THEN
    IF exit = MausTauschrsc.sabbr THEN
      RETURN -1
    ELSIF (exit = MausTauschrsc.sok) OR
          (exit = MausTauschrsc.searchstartahead) OR
          (exit = MausTauschrsc.searchstartback) THEN
      v.bool := getKonfFromBox(exit, suchVar);
      IF exit = MausTauschrsc.searchstartahead THEN
        RETURN FASTAHEAD
      ELSIF exit = MausTauschrsc.searchstartback THEN
        RETURN FASTBACK
      ELSE
        RETURN MAX(INTEGER)
      END;
    END;
  ELSE
    IF exit = MausTauschrsc.smsearchabbruch THEN
      RETURN -1
    ELSIF (exit = MausTauschrsc.smsearchok) OR
          (exit = MausTauschrsc.smfastahead) OR
          (exit = MausTauschrsc.smfastback) THEN
      getKonfFromSmallBox(suchVar);
      IF exit = MausTauschrsc.smfastahead THEN
        RETURN FASTAHEAD
      ELSIF exit = MausTauschrsc.smfastback THEN
        RETURN FASTBACK
      ELSE
        RETURN MAX(INTEGER)
      END;
    ELSE
      RETURN exit;
    END;
  END;
END SearchDial;

TYPE    flagVars    = RECORD
                        possible    : DialActionSet;
                        setBits, clearBits : BITSET;
                        whatAction  : DialAction;
                        exitBut     : INTEGER;
                      END;
        flagVarPtr  = POINTER TO flagVars;

PROCEDURE flagButton (tree: ADDRESS; private: ADDRESS; button: INTEGER;
                        mx, my : INTEGER; kstate: BITSET; clicks: INTEGER): BOOLEAN;
  VAR res : INTEGER;
BEGIN
  res := INTEGER(BITSET(button) - {15});
  IF (res = MausTauschrsc.sflagsok) OR (res = MausTauschrsc.sabbruch) THEN 
    mtUtils.ExclState (tree, res, MagicAES.SELECTED);
    RETURN TRUE;
  END;
  RETURN FALSE;
END flagButton;

PROCEDURE flagGetSetValues (tree: ADDRESS; private: ADDRESS; 
                            set: BOOLEAN; exit: INTEGER);
  VAR flgPtr        : flagVarPtr;
      z, obj        : INTEGER;
      sBit1, sBit2  : BITSET;
BEGIN
  flgPtr := private;
  IF set
  THEN
    WITH flgPtr^ DO
      mtUtils.SetObjcString (tree, MausTauschrsc.fuserflag1, UserBLK.ustr1);
      mtUtils.SetObjcString (tree, MausTauschrsc.fuserflag2, UserBLK.ustr2);
      SetBits(tree, setBits, clearBits, MausTauschrsc.topflag, MausTauschrsc.botflag);
      mtUtils.SetState(tree, MausTauschrsc.sactual,   MagicAES.DISABLED, ~(ChangeMsg IN possible));
      mtUtils.SetState(tree, MausTauschrsc.streedown, MagicAES.DISABLED, ~(ChangeTreeDown IN possible));
      mtUtils.SetState(tree, MausTauschrsc.stree,     MagicAES.DISABLED, ~(ChangeTree IN possible));
      mtUtils.SetState(tree, MausTauschrsc.sselected, MagicAES.DISABLED, ~(ChangeSelected IN possible));
    
      IF ~(whatAction IN possible)
      THEN
        whatAction := ChangeMsg;
        WHILE ~(whatAction IN possible) & (whatAction < ChangeSelected) DO
          INC(whatAction)
        END;
      END;
      CASE whatAction OF
        ChangeMsg       : obj := MausTauschrsc.sactual; |
        ChangeTreeDown  : obj := MausTauschrsc.streedown; |
        ChangeTree      : obj := MausTauschrsc.stree; |
        ChangeSelected  : obj := MausTauschrsc.sselected; |
      ELSE
        obj := MausTauschrsc.sactual;
      END;
      mtUtils.InclState(tree, obj,   MagicAES.SELECTED);

      FOR z := MausTauschrsc.topflag TO MausTauschrsc.botflag DO
        mtDials.SetUserkey (tree, z, keyArray[z-MausTauschrsc.topflag], {MagicAES.KALT}, TRUE, TRUE);
      END;
      
    END;
  ELSE
    WITH flgPtr^ DO
      exit := INTEGER(BITSET(exit) - {15});
      exitBut := exit;
      IF exit=MausTauschrsc.sflagsok THEN 
        setBits   := GetBits (tree, MausTauschrsc.topflag, MausTauschrsc.botflag, mtUtils.SETNEW);
        clearBits := GetBits (tree, MausTauschrsc.topflag, MausTauschrsc.botflag, mtUtils.CLEAR);
        IF    mtUtils.InState(tree, MausTauschrsc.sactual,   MagicAES.SELECTED) THEN
          mtUtils.ExclState(tree, MausTauschrsc.sactual,   MagicAES.SELECTED);
          whatAction := ChangeMsg;
        ELSIF mtUtils.InState(tree, MausTauschrsc.streedown, MagicAES.SELECTED) THEN
          mtUtils.ExclState(tree, MausTauschrsc.streedown, MagicAES.SELECTED);
          whatAction := ChangeTreeDown;
        ELSIF mtUtils.InState(tree, MausTauschrsc.stree,     MagicAES.SELECTED) THEN
          mtUtils.ExclState(tree, MausTauschrsc.stree,   MagicAES.SELECTED);
          whatAction := ChangeTree;
        ELSIF mtUtils.InState(tree, MausTauschrsc.sselected, MagicAES.SELECTED) THEN
          mtUtils.ExclState(tree, MausTauschrsc.sselected,   MagicAES.SELECTED);
          whatAction := ChangeSelected;
        END;
      END;
      mtUtils.ExclState (tree, exit, MagicAES.SELECTED);
    
      mtUtils.ExclState(tree, MausTauschrsc.sactual,   MagicAES.DISABLED);
      mtUtils.ExclState(tree, MausTauschrsc.streedown, MagicAES.DISABLED);
      mtUtils.ExclState(tree, MausTauschrsc.stree,     MagicAES.DISABLED);
      mtUtils.ExclState(tree, MausTauschrsc.sselected, MagicAES.DISABLED);
    
      mtUtils.ExclState(tree, MausTauschrsc.sactual,   MagicAES.SELECTED);
      mtUtils.ExclState(tree, MausTauschrsc.streedown, MagicAES.SELECTED);
      mtUtils.ExclState(tree, MausTauschrsc.stree,     MagicAES.SELECTED);
      mtUtils.ExclState(tree, MausTauschrsc.sselected, MagicAES.SELECTED);
    END;
  END;
END flagGetSetValues;

PROCEDURE FlagDial(possible : DialActionSet; 
                   VAR setBits, clearBits : BITSET;
                   VAR whatAction : DialAction):BOOLEAN;
(* Fr die Flagaktionen. Gibt zurck, ob der User ok angewhlt hat und den Status   *)
(* der Bits sowie die ber die Radiobuttons gewhlte Aktion                         *)
VAR flagBox : ADDRESS;
    flags   : flagVars;
BEGIN
  flags.possible := possible;
  flags.setBits := setBits;
  flags.clearBits := clearBits;
  flags.whatAction := whatAction;
  flagBox := MausTauschrsc.TreeAddr^[MausTauschrsc.flag2box];
  IF ~WinDials.OpenWinDial (flagBox, TRUE, 
                            flagGetSetValues,
                            flagGetSetValues,
                            flagButton,
                            WinDials.defDraw,
                            "",
                            ADR(flags))
  THEN
    MTE.noWinDialAlert();
    RETURN FALSE;
  END;
  WinDials.WinDialHandleEvents();
  IF flags.exitBut = MausTauschrsc.sflagsok
  THEN
    setBits := flags.setBits;
    clearBits := flags.clearBits;
    whatAction := flags.whatAction;
    v.bool := ConfVars.SetConfigInt (cFlagSetBits, INTEGER (setBits));
    v.bool := ConfVars.SetConfigInt (cFlagClearBits, INTEGER (clearBits));
    v.bool := ConfVars.SetConfigInt (cFlagSelection, INTEGER(whatAction));
  END;
  
  RETURN flags.exitBut = MausTauschrsc.sflagsok;
END FlagDial;

(*
PROCEDURE FlagDial(possible : DialActionSet; 
                   VAR setBits, clearBits : BITSET;
                   VAR whatAction : DialAction):BOOLEAN;
(* Fr die Flagaktionen. Gibt zurck, ob der User ok angewhlt hat und den Status   *)
(* der Bits sowie die ber die Radiobuttons gewhlte Aktion                         *)
VAR but : INTEGER;
    z   : INTEGER;
    flagBox : ADDRESS;
    sBit1, sBit2 : BITSET;
BEGIN
  flagBox := MausTauschrsc.TreeAddr^[MausTauschrsc.flag2box];
  IF ~mtDials.NewDial (flagBox) THEN MTE.noMemAlert (); RETURN FALSE END;
  mtUtils.SetObjcString (flagBox, MausTauschrsc.fuserflag1, UserBLK.ustr1);
  mtUtils.SetObjcString (flagBox, MausTauschrsc.fuserflag2, UserBLK.ustr2);
  SetThem(flagBox,
          setBits, clearBits, sBit1, sBit2, 
          MausTauschrsc.topflag, MausTauschrsc.botflag, 
          1, 0);
  mtUtils.SetState(flagBox, MausTauschrsc.sactual,   MagicAES.DISABLED, ~(ChangeMsg IN possible));
  mtUtils.SetState(flagBox, MausTauschrsc.streedown, MagicAES.DISABLED, ~(ChangeTreeDown IN possible));
  mtUtils.SetState(flagBox, MausTauschrsc.stree,     MagicAES.DISABLED, ~(ChangeTree IN possible));
  mtUtils.SetState(flagBox, MausTauschrsc.sselected, MagicAES.DISABLED, ~(ChangeSelected IN possible));

  IF ~(whatAction IN possible)
  THEN
    whatAction := ChangeMsg;
    WHILE ~(whatAction IN possible) & (whatAction < ChangeSelected) DO
      INC(whatAction)
    END;
  END;
  IF    whatAction = ChangeMsg THEN
    mtUtils.InclState(flagBox, MausTauschrsc.sactual,   MagicAES.SELECTED) 
  ELSIF whatAction = ChangeTreeDown THEN
    mtUtils.InclState(flagBox, MausTauschrsc.streedown, MagicAES.SELECTED) 
  ELSIF whatAction = ChangeTree THEN
    mtUtils.InclState(flagBox, MausTauschrsc.stree,     MagicAES.SELECTED) 
  ELSIF whatAction = ChangeSelected THEN
    mtUtils.InclState(flagBox, MausTauschrsc.sselected, MagicAES.SELECTED) 
  END;

  mtDials.DialCenter (flagBox, mtDials.CSCREEN, 0, 0, v.r);
  mtDials.DialForm(flagBox, mtDials.DSTART, v.r, v.r);
  FOR z := MausTauschrsc.topflag TO MausTauschrsc.botflag DO
    mtDials.SetUserkey (flagBox, z, keyArray[z-MausTauschrsc.topflag], {MagicAES.KALT}, TRUE, TRUE);
  END;
  mtDials.DialDraw(flagBox, 0, 200, v.r, FALSE);
  LOOP
    but := mtDials.DialDo (flagBox, 0);
    but := INTEGER (BITSET(but)-{15});
    IF (but = MausTauschrsc.sflagsok) OR (but = MausTauschrsc.sabbruch) THEN EXIT END;
  END;
  IF but=MausTauschrsc.sflagsok THEN 
    GetThem(flagBox,
            setBits, clearBits, sBit1, sBit2,
            MausTauschrsc.topflag, MausTauschrsc.botflag,
            1,0);
    IF    mtUtils.InState(flagBox, MausTauschrsc.sactual,   MagicAES.SELECTED) THEN
      mtUtils.ExclState(flagBox, MausTauschrsc.sactual,   MagicAES.SELECTED);
      whatAction := ChangeMsg;
    ELSIF mtUtils.InState(flagBox, MausTauschrsc.streedown, MagicAES.SELECTED) THEN
      mtUtils.ExclState(flagBox, MausTauschrsc.streedown, MagicAES.SELECTED);
      whatAction := ChangeTreeDown;
    ELSIF mtUtils.InState(flagBox, MausTauschrsc.stree,     MagicAES.SELECTED) THEN
      mtUtils.ExclState(flagBox, MausTauschrsc.stree,   MagicAES.SELECTED);
      whatAction := ChangeTree;
    ELSIF mtUtils.InState(flagBox, MausTauschrsc.sselected, MagicAES.SELECTED) THEN
      mtUtils.ExclState(flagBox, MausTauschrsc.sselected,   MagicAES.SELECTED);
      whatAction := ChangeSelected;
    END;
  END;
  mtUtils.ExclState (flagBox, but, MagicAES.SELECTED);
  mtDials.DialForm(flagBox, mtDials.DFINISH, v.r, v.r);
  mtDials.DisposeDial (flagBox);

  mtUtils.ExclState(flagBox, MausTauschrsc.sactual,   MagicAES.DISABLED);
  mtUtils.ExclState(flagBox, MausTauschrsc.streedown, MagicAES.DISABLED);
  mtUtils.ExclState(flagBox, MausTauschrsc.stree,     MagicAES.DISABLED);
  mtUtils.ExclState(flagBox, MausTauschrsc.sselected, MagicAES.DISABLED);

  mtUtils.ExclState(flagBox, MausTauschrsc.sactual,   MagicAES.SELECTED);
  mtUtils.ExclState(flagBox, MausTauschrsc.streedown, MagicAES.SELECTED);
  mtUtils.ExclState(flagBox, MausTauschrsc.stree,     MagicAES.SELECTED);
  mtUtils.ExclState(flagBox, MausTauschrsc.sselected, MagicAES.SELECTED);

  RETURN but = MausTauschrsc.sflagsok;
END FlagDial;
*)

PROCEDURE DoSearchDial(forList: BOOLEAN):INTEGER;
(* Ruft die Suchbox auf; Rckgabe < 0 -> User hat Abbruch gedrckt *)
(* sonst noch mglich: ZSearchDial.FASTAHEAD, ZSearchDial.FASTBACK *)
VAR res : INTEGER;
BEGIN
  res := SearchDial(SearchHelp.suchVar, forList);
  RETURN res;
END DoSearchDial;

BEGIN
  init := TRUE;
  lastKonfig := -1;
END ZSearchDial.
