(*----------------------------------------------------------------------*
 *                                                                      *
 *         MAGIC   Modula's  All purpose  GEM  Interface  Cadre         *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 3.30  02.02.1992     (C)90/91/92 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus in schrift-  *
 * licher Form, insbesondere in Zeitschriften, sowie die Verbreitung    *
 * ber Public-Domain-Hndler bedarf der ausdrcklichen schriftlichen   *
 * Genehmigung des Autors!                                              *
 *                                                                      *
 * Der Autor gibt hiermit die ausdrckliche Erlaubnis, das Modul jeder- *
 * zeit auch im Quelltext weiterzugegeben, sofern dessen Text und ins-  *
 * besondere dieser Urheberrechts-Vermerk nicht verndert wird, und     *
 * durch die Weitergabe kein finanzieller Nutzen entsteht. Der Autor    *
 * behlt sich das Recht vor, diese Erlaubnis jederzeit u. ohne Angaben *
 * von Grnden zu widerrufen.                                           *
 *----------------------------------------------------------------------*)
 
(*----------------------------------------------------------------------*
 * MagicConvert         Konvertierungsroutinen fr Zahlen               *
 *----------------------------------------------------------------------*)

DEFINITION MODULE MagicConvert;

FROM MagicSys   IMPORT  Nil, Null, Bit0, Bit1, Bit2, Bit3, Bit4, Bit5, Bit6,
                        Bit7, Bit8, Bit9, Bit10, Bit11, Bit12, Bit13, Bit14,
                        Bit15, LOC, Byte, ByteSet, sWORD, sINTEGER, sCARDINAL,
                        sBITSET, lINTEGER, lCARDINAL, lWORD, lBITSET;

 



PROCEDURE NumToStr (num: lCARDINAL;  len, base: sCARDINAL;  neg: BOOLEAN;
                    VAR s: ARRAY OF CHAR);
(* Wandelt Nummer in String *)

PROCEDURE StrToNum (REF  s: ARRAY OF CHAR; base: sCARDINAL;  neg: BOOLEAN;
                    max: lCARDINAL): lCARDINAL;
(* Wandelt String in Nummer *)

PROCEDURE StrToInt      (REF  s: ARRAY OF CHAR): sINTEGER;
PROCEDURE StrToCard     (REF  s: ARRAY OF CHAR): sCARDINAL;
PROCEDURE HexToCard     (REF  s: ARRAY OF CHAR): sCARDINAL;
PROCEDURE StrToLInt     (REF  s: ARRAY OF CHAR): lINTEGER;
PROCEDURE StrToLCard    (REF  s: ARRAY OF CHAR): lCARDINAL;
PROCEDURE StrToReal     (REF  s: ARRAY OF CHAR): REAL;
PROCEDURE StrToLReal    (REF  s: ARRAY OF CHAR): LONGREAL;
(* Wandelt String in Nummer *)

PROCEDURE IntToStr      (w: sINTEGER;  n: sCARDINAL; VAR s: ARRAY OF CHAR);
PROCEDURE CardToStr     (w: sCARDINAL; n: sCARDINAL; VAR s: ARRAY OF CHAR);
PROCEDURE CardToHexStr  (w: sCARDINAL; n: sCARDINAL; VAR s: ARRAY OF CHAR);
PROCEDURE LIntToStr     (w: lINTEGER;  n: sCARDINAL; VAR s: ARRAY OF CHAR);
PROCEDURE LCardToStr    (w: lCARDINAL; n: sCARDINAL; VAR s: ARRAY OF CHAR);
PROCEDURE RealToStr     (w: REAL;      n: sCARDINAL; VAR s: ARRAY OF CHAR);
PROCEDURE LRealToStr    (w: LONGREAL;  n: sCARDINAL; VAR s: ARRAY OF CHAR);
(* Wandelt Nummer in String. n = Anzahl der Zeichen, die s mindestens 
 * umfassen soll
 *)

PROCEDURE FixRealToStr  (w: REAL; n, l: sCARDINAL; VAR s: ARRAY OF CHAR);
PROCEDURE FixLRealToStr (w: LONGREAL; n, l: sCARDINAL; VAR s: ARRAY OF CHAR);
(* Wandelt Reals in Festpunkt-Notation. l = Anzahl der Nachkommastellen *)

END MagicConvert.

