DEFINITION MODULE MintUtil;

(* Mehrere kleinere MiNT Tricks. Version 2   Karsten Isakovic / Berlin
 *
 * - Umlenken der Ausgaben eines paralellen Prozesses nach /dev/null
 * - Umlenken der Ausgaben eines paralellen Prozesses in eine Pipe
 * - Auslesen der Ausgaben aus der Pipe.
 *)

(* Version in Megamax Modula 2 von Dirk Steins unter Benutzung 
 * von Magic von Peter Hellinger
 *)


(*
 * Startet einen paralellen Prozess der nach /dev/null ausgibt.
 * Liefert den PID des neuen Prozesses.
 *)

PROCEDURE ExecDevNull(REF name, cmdline, env : ARRAY OF CHAR): INTEGER;

(*
 * Startet einen paralellen Prozess der in eine neue Pipe ausgibt.
 * Liefert den PID des neuen Prozesses und den Filehandle
 * der Pipe in 'pipe'.
 *)

PROCEDURE ExecPipe (REF name, cmdline, env : ARRAY OF CHAR; VAR pipe : INTEGER) : INTEGER;

(*
 * Liest von einer Pipe, sofern dort Daten vorhanden sind.
 * Liefert Null, wenn keine Daten da waren, -1 wenn der
 * Pipe-Prozess bendet wurde und einen positiven Wert, wenn
 * Zeichen gelesen wurden.
 *)

PROCEDURE ReadPipe (pid, pipe : INTEGER; VAR buf : ARRAY OF CHAR;
                    VAR retCode : INTEGER): LONGINT;

(*
 * Liefert 1 wenn MiNT installiert ist, sonst 0.
 *)

PROCEDURE IsMiNT() : BOOLEAN;

END MintUtil.


