(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGICTOOLS   Modula's  All purpose  GEM  Interface  Cadre  Toolbox  *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 3.30  02.02.1992     (C)90/91/92 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden zu *
 * widerrufen.                                                          *
 *----------------------------------------------------------------------*)
 
(*----------------------------------------------------------------------*
 * mtAlerts     Alertformulare mit mtDials-Features                     *
 *                                                                      *
 * Zustzlich zu den blichen Icons (1-3) knnen bei den MagicAlerts    *
 * noch weitere Alerts eingebunden werden.  Insgesamt stehen bis zu 256 *
 * (1..256) 'Iconslots' zur Verfgung, von denen die ersten 3 (1..3)    *
 * standardmig mit den blichen Icons (Note, Wait und Stop) belegt    *
 * sind. Weitere Icons knnen ber SetIconslot gesetzt und dann mit der *
 * entsprechenden Nummer angesprochen werden.  Eine Auswahl von Icons   *
 * steht mit AlertIcons zur Verfgung und kann mit Hilfe eines RCS      *
 * und des RSC-Coders einfach erweitert werden.                         *
 *                                                                      *
 * Der Vorteil des Verfahrens liegt darin, da mtAlerts nicht mehr den  *
 * ganzen Datenballast mitfhren mu, wenn ein Programm nur die b-     *
 * lichen Icons benutzt. Ausserdem ist so der Icon-Vorrat einfacher     *
 * aufzustocken...                                                      *
 *                                                                      *
 * Als Erweiterung gegenber den normalen Alerts knnen bei mtAlerts    *
 * bis zu 16 Zeilen Text und bis zu 4 Buttons angegeben werden.         *
 *----------------------------------------------------------------------*)

DEFINITION MODULE mtAlerts;

FROM MagicSys   IMPORT  Nil, Null, Bit0, Bit1, Bit2, Bit3, Bit4, Bit5, Bit6,
                        Bit7, Bit8, Bit9, Bit10, Bit11, Bit12, Bit13, Bit14,
                        Bit15, LOC, Byte, ByteSet, sWORD, sINTEGER, sCARDINAL,
                        sBITSET, lINTEGER, lCARDINAL, lWORD, lBITSET;

 



FROM MagicAES   IMPORT  PtrBITBLK;

PROCEDURE Alert (def: sINTEGER; REF  str: ARRAY OF CHAR): sINTEGER;
(* Alertbox, wie FormAlert, jedoch mit den Spezialitten von MagicDials 
 * Icon 1 - 3 sind die gewohnten Alert-Icons, andere Icons knnen mittels
 * SetIconslot gesetzt werden (siehe auch Modul AlertIcons). Besonderheiten:
 *
 * - Als Erweiterung gegenber den normalen Alerts knnen bei mtAlerts
 *   16 Zeilen Text mit bis zu 60 Zeichen und bis zu 4 Buttons angegeben
 *   werden.
 *
 * - Die Icons knnen auch ber Buchstaben addressiert werden, wie dies 
 *   bei den RCS INTERFACE gemacht wird. Die Gre des Images ist nur 
 *   durch die Bildschirmgre begrenzt.  Die Auslsetaste eines Buttons 
 *   kann wie gewohnt mit eine vorangehenden '[' angegeben werden.
 *   Beispiele:
 *
 *   '[3][Das ist ein normales|Alerticon][[Aha!]'
 *   '[C][Sollte mit SetIconslot|installiert sein...][[Genau!|[Jawoll!]'
 *   '[128][Auch Zahlen funktionieren![[Pfanntastisch!]'
 *
 * - In den Alerttexten (nicht den Buttons!!!) knnen folgende Steuer-
 *   zeichen enthalten sein:
 * 
 *   %D = Der komplette Text dieser Zeile wird doppelt unterstrichen
 *   %U = Der komplette Text dieser Zeile wird einfach unterstrichen
 *   %F = Der komplette Text dieser Zeile wird fett geschrieben.
 *
 *   Andere Steuerzeichen werden ignoriert und in den Text geschrieben.
 *   Beachten Sie bitte, da der einfache und doppelte Unterstrich schon
 *   im Bereich des nachfolgenden Textes liegen. Hier sollte man eine
 *   Leerzeile '||' lassen.  Beispiele:
 *
 *   '[3][%DProgramm-Abbruch||Mchten Sie das Programm wirklich beenden?][[Ja|[Nein]';
 *)

PROCEDURE PosAlert (x, y, def: sINTEGER; REF  str: ARRAY OF CHAR): sINTEGER;
(* Wie Alert, die Alertbox wird jedoch an Position x,y dargestellt
 * (linke obere Ecke)
 *)

PROCEDURE SetIconColor (color: sINTEGER);
(* Setzt die Farbe des Icons. Damit kann man im Farbmodus wichtige Zustnde
 * besonders hervorheben.
 *)

PROCEDURE Iconslot (slot: sINTEGER): PtrBITBLK;
(* Liefert den Inhalt des Iconslots mit Nummer slot; NIL wenn nicht belegt,
 * oder slot nicht existent.
 *)

PROCEDURE SetIconslot (slot: sINTEGER; icon: PtrBITBLK);
(* Setzt ein Icon der Nummer 4..256. icon zeigt auf einen Bitblk, wie er
 * z.B. vom RCS erzeugt wird. 
 *)

TYPE AlertMode = (left, center, right, gemicon, alticon);

PROCEDURE ConfigAlert (mode: AlertMode);
(* Konfiguriert, wie sich Alerts prsentieren.
 * left =    Buttons linksbndig
 * center =  Buttons Zentriert (wie AES, default!)
 * right =   Buttons rechtsbndig
 * gemicon = Die 'normalen' GEM-Icons benutzen (default!)
 * alticon = Die alternativen Icons (etwas Mac-Like) benutzen
 *)

PROCEDURE InitMtAlerts;
(* Initialsiert das Modul. Wird normalerweise im Modulkrper ausgefhrt
 * und braucht nicht weiter beachtet zu werden.
 *)

END mtAlerts.
                               
