(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGICTOOLS   Modula's  All purpose  GEM  Interface  Cadre  Toolbox  *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 3.30  02.02.1992     (C)90/91/92 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden zu *
 * widerrufen.                                                          *
 *----------------------------------------------------------------------*)
 
(*----------------------------------------------------------------------*
 * mtFontselector       GDOS-Fontselektion einfach gemacht              *
 *----------------------------------------------------------------------*)

DEFINITION MODULE mtFontselector;

FROM MagicSys   IMPORT  Nil, Null, Bit0, Bit1, Bit2, Bit3, Bit4, Bit5, Bit6,
                        Bit7, Bit8, Bit9, Bit10, Bit11, Bit12, Bit13, Bit14,
                        Bit15, LOC, Byte, ByteSet, sWORD, sINTEGER, sCARDINAL,
                        sBITSET, lINTEGER, lCARDINAL, lWORD, lBITSET;

 



PROCEDURE FontSelector (handle: INTEGER; REF  msg: ARRAY OF CHAR;
                        seleffekt, mono: BOOLEAN;
                        VAR font, size, width, skew: sINTEGER;
                        VAR effekt: sBITSET): BOOLEAN;
(* Bringt einen Fontselector auf den Bildschirm. In diesem Dialog kann 
 * der aktuelle Font fr die Bildschirm-Workstation handle eingestellt 
 * werden. Wird der Dialog mit OK beendet, wird der gewhlte Font fr
 * die Workstation eingestellt, ansonsten bleibt der vorher eingestellte
 * Font gltig.  Returniert TRUE, wenn OK geklickt wurde.
 *
 * handle =     Handle der Workstation, fr die Fonts eingestellt werden
 *              sollen. Fr diese Workstation mu unbedingt die Prozedur
 *              mtFonts.LoadFonts ausgefhrt sein.
 *
 * msg =        Hier kann ein String von bis zu 40 Zeichen bergeben 
 *              werden, der als Titel in den Dialog bernommen wird.
 *              Im Falle eine Leerstrings wird einfach 'Fontauswahl'
 *              in den Dialog geschrieben.
 *
 * seleffekt =  Wenn hier TRUE bergeben wird, ist es mglich im Dialog
 *              auch die Texteffekte einzustellen
 *
 * mono =       Es werden nur Monospaced-Fonts angeboten.
 *
 * font =       Enthlt nach Rckkehr den ID des gewhlten Fonts
 *
 * size =       Enthlt nach Rckkehr die Gre des gewhlten Fonts
 *              in Points
 *
 * skew =       Enthlt nach Rckkehr den Skew-Faktor in 1/10 Grad.
 *              Nur bei FSM-Fonts, wenn mtFonts als FSM-Version
 *              benutzt wurde.
 *
 * effekt =     Enthlt nach Rckkehr die Texteffekte (auch bei
 *              seleffekt = FALSE!)
 *
 * Ein Wort noch zur Bedienung:
 * Der Dialog ist vollstndig Tastatur-bedienbar. Die einzelnen
 * Komponenten werden wie folgt bedient:
 * 
 * Cursor rechts =      Nchster Font
 * Cursor links =       Vorhergehender Font
 * Cursor hoch =        Fontgre erhhen
 * Cursor runter =      Fontgre verkleinern
 * Plus-Taste =         Breitenfaktor erhhen
 * Minus-Taste =        Breitenfaktor verkleinern
 * '/'-Taste =          Neigung nach links
 * '*'-Taste =          Neigung nach rechts
 *
 * Zustzlich kann durch Klick auf die Fontgre bzw. FontSkew ein
 * Hilfsdialog gerufen werden, in dem die Gre per Hand eingestellt
 * werden kann. (Bei FSM-Fonts ist es etwas mhsam durch 'Cursor hoch'
 * einen 48Pt Font einzustellen...)
 *)

END mtFontselector.

