(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGICTOOLS   Modula's  All purpose  GEM  Interface  Cadre  Toolbox  *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 3.30  02.02.1992     (C)90/91/92 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden zu *
 * widerrufen.                                                          *
 *----------------------------------------------------------------------*)
 
(*----------------------------------------------------------------------*
 * mtHelp       Einfaches Hilfsystem                                    *
 *                                                                      *
 * Die eigentlichen Hilfstexte stehen in einem ASCII-Textfile, welches  *
 * speziell formatierten Text enthlt. Dabei knnen dem Hilfssystem     *
 * durch den Text Kommandos gegeben werden.                             *
 *                                                                      *
 * Das Format des Hilftextes:                                           *
 *                                                                      *
 * KOORDINATEN  Hier erwartet das Modul 4 Zahlen, die die Gre des     *
 *              Hilfs-Bildschirms definieren. Die ersten beiden Zahlen  *
 *              sind die X- und Y-Koordinate in Pixel, die nchsten     *
 *              beiden Breite und Hhe in Spalten und Zeilen.           *
 *                                                                      *
 * Die eigentliche Hilfe besteht aus Textgruppen von folgendem Aufbau:  *
 *                                                                      *
 * @TITEL                                                               *
 * TEXT                                                                 *
 * @                                                                    *
 * NEXTHELP                                                             *
 * @                                                                    *
 *                                                                      *
 * Der Hilfstext kann beliebig viele dieser Gruppen enthalten.          *
 * Die Einzelnen Eintrge bedeuten:                                     *
 *                                                                      *
 * @TITEL     Das ist die Kennung des Hilftextes. Sie wird eingeleitet  *
 *            durch ein '@' im ersten Zeichen der Zeile.  Anhand dieser *
 *            Kennung sucht das Modul nach dem Hilfstext.               *
 *                                                                      *
 * TEXT       Hier folgt nun der eigentliche Hilfstext, der im Fenster  *
 *            ausgegeben wird. Abgeschlossen wird der Hilfstext durch   *
 *            ein '@' in erster Position einer Zeile.                   *
 *            Innerhalb des Hilftextes sind Steuerzeichen mglich:      *
 *                                                                      *
 *              %U Unterstreichen EIN bzw. AUS                          *
 *              %F Fett EIN bzw. AUS                                    *
 *              %I Kursiv EIN bzw. AUS                                  *
 *              %H Inverse Schrift EIN bzw. AUS                         *
 *              %L Helle Schrift EIN bzw. AUS                           *
 *              %S Hochgestellte Schrift                                *
 *              %T Tiefgestellte Schrift                                *
 *              %C Hilfsfenster lschen                                 *
 *              %K Gibt ein Popup mit einem Weiter/Beenden-Text aus     *
 *              %% Prozentzeichen ausgeben                              *
 *                                                                      *
 * NEXTHELP   Hier folgt eine Liste von weiteren Hilfstiteln, wie unter *
 *            @TITEL beschrieben, jedoch OHNE FHRENDES '@'. Aus diesen *
 *            Titeln wird ein Popupmen generiert, aus welchem der      *
 *            Benutzer weitere Hilfstitel aufrufen kann. Es sind je     *
 *            Hilfstext bis zu 20 weiterfhrende Titel erlaubt. Abge-   *
 *            schlossen wird die Liste wieder mit einem separaten '@'.  *
 *                                                                      *
 * Hier ein Beispiel-Hilfstext:                                         *
 *                                                                      *
 * 100 100 300 150                                                      *
 * @HELP                                                                *
 *  %UHilfe 1%U                                                         *
 *  Das ist der Hilfsbildschirm No. 1                                   *
 *  Das ist der Hilfsbildschirm No. 1                                   *
 *  Das ist der Hilfsbildschirm No. 1                                   *
 *                                                                      *
 *  Bitte Taste drcken!%T                                              *
 *  Das ist der Hilfsbildschirm No. 1                                   *
 *  Das ist der Hilfsbildschirm No. 1                                   *
 *  Das ist der Hilfsbildschirm No. 1                                   *
 *  Das ist der Hilfsbildschirm No. 1                                   *
 * @                                                                    *
 * Hilfe No.2                                                           *
 * Hilfe No.3                                                           *
 * @Hilfe No.2                                                          *
 *  %F%UHilfe No.2%U%F                                                  *
 *  Das ist der Hilfsbildschirm No. 2                                   *
 *  Das ist der Hilfsbildschirm No. 2                                   *
 *  Das ist der Hilfsbildschirm No. 2                                   *
 *  Das ist der Hilfsbildschirm No. 2                                   *
 * @                                                                    *
 * @Hilfe No.3                                                          *
 *  %KHilfe No.3%K                                                      *
 *  Das ist der Hilfsbildschirm No. 3                                   *
 *  Das ist der Hilfsbildschirm No. 3                                   *
 *  Das ist der Hilfsbildschirm No. 3                                   *
 *  Das ist der Hilfsbildschirm No. 3                                   *
 * @                                                                    *
 * @                                                                    *
 *                                                                      *
 *----------------------------------------------------------------------*)

DEFINITION MODULE mtHelp;

PROCEDURE Help (filename, selstring: ARRAY OF CHAR);
(* Dies ist die zentrale Hilfsprozedur. filename ist der Dateiname des
 * Hilfstextes. Die Prozedur sucht mittels ShelFind auf den Standard-
 * pfaden des OS. Mit selstring wird der zu suchende Hilfstext-Titel
 * angegeben. Bitte das fhrende '@' nicht vergessen!
 *
 * Beispiel:  Help ('TEXT.HLP', '@HELP');
 *
 *)

END mtHelp.

