(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGICTOOLS   Modula's  All purpose  GEM  Interface  Cadre  Toolbox  *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 3.30  02.02.1992     (C)90/91/92 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden zu *
 * widerrufen.                                                          *
 *----------------------------------------------------------------------*)
 
(*----------------------------------------------------------------------*
 * mtPopups     Popupmens aus eine GEM-Menzeile etc. Dialogpopups     *
 *                                                                      *
 * ALLE Menus knnen auch ber die Tastatur bedient werden:             *
 *                                                                      *
 * RETURN / ENTER       Selektierten Eintrag besttigen, Men beenden   *
 * UNDO                 Men abbrechen bzw. zurck zum Hauptmen        *
 * Cursor hoch          Eintrag ber aktuellem Eintrag selektieren      *
 * Cursor runter        Eintrag unter aktuellem Eintrag selektieren     *
 *----------------------------------------------------------------------*)

DEFINITION MODULE mtPopups;

FROM MagicSys   IMPORT  Nil, Null, Bit0, Bit1, Bit2, Bit3, Bit4, Bit5, Bit6,
                        Bit7, Bit8, Bit9, Bit10, Bit11, Bit12, Bit13, Bit14,
                        Bit15, LOC, Byte, ByteSet, sWORD, sINTEGER, sCARDINAL,
                        sBITSET, lINTEGER, lCARDINAL, lWORD, lBITSET;

 



IMPORT SYSTEM;

PROCEDURE PopupMenu (menu: SYSTEM.ADDRESS; title: ARRAY OF CHAR): sINTEGER; 
(* Macht aus einer Resource-Menuzeile ein Popupmenu. Dropdown-Mens werden
 * als Submens dargestellt.  Soll ein Menu-Title kein Dropdown erhalten,
 * so mu dieser mit dem EXIT-Flag versehen werden.  Pro SubMen drfen
 * maximal 50 Eintrge verwendet werden.  Die Prozedur returniert die
 * Objektnummer des selektierten Eintrags.
 *
 * menu =       Adresse der Menuzeilen-Resource
 * title =      Titelzeile fr das Men. Submens bekommen automatisch
 *              den Mentitel als Titelzeile verpasst.
 *)


PROCEDURE StringPopup (REF  string: ARRAY OF CHAR; title: ARRAY OF CHAR): sINTEGER;
(* Generiert Popupmen aus einem String.  Keine Submens mglich! Die 
 * einzelnen Eintrge mssen durch ein | getrennt sein:
 *
 * "  Eintrag 1|  Eintrag 2|  Eintrag 3" 
 *
 * Maximal 50 Eintrge mglich.  Ist title ein Null-String wird keine Titel
 * zeile in das Popup integriert. Das Popup ist damit auch nicht verschiebbar!
 *)


PROCEDURE PosPopup (x, y: INTEGER; REF  string: ARRAY OF CHAR;
                    title: ARRAY OF CHAR): sINTEGER;
(* Wie StringPopup, jedoch an festgelegter Position (linke obere Ecke). *)


PROCEDURE TreePopup (tree: SYSTEM.ADDRESS; x, y: sINTEGER; idx: sINTEGER): sINTEGER;
(* Wie PosPopup, jedoch mit Baum, der dargestellt wird. idx kann dazu benutzt
 * werden einen bestimmten Eintrag an der x,y Position erscheinen zulassen.
 * Das Men wird dann entsprechend versetzt.
 * Idee und Realisation: Dirk Steins
 *)

PROCEDURE InitMtPopups;
(* Initialisiert die mtPopups. Wird normalerweise im Modulkrper
 * aufgerufen, und braucht nicht weiter beachtet zu werden.
 *)

END mtPopups.
