(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGICTOOLS   Modula's  All purpose  GEM  Interface  Cadre  Toolbox  *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 3.30  02.02.1992     (C)90/91/92 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden zu *
 * widerrufen.                                                          *
 *----------------------------------------------------------------------*)
 
DEFINITION MODULE mtStreams;

FROM MagicSys   IMPORT  Nil, Null, Bit0, Bit1, Bit2, Bit3, Bit4, Bit5, Bit6,
                        Bit7, Bit8, Bit9, Bit10, Bit11, Bit12, Bit13, Bit14,
                        Bit15, LOC, Byte, ByteSet, sWORD, sINTEGER, sCARDINAL,
                        sBITSET, lINTEGER, lCARDINAL, lWORD, lBITSET;

 



TYPE    StreamMode = (READ, READWRITE);

TYPE    STREAM;

PROCEDURE OpenStream (VAR s: STREAM; name: ARRAY OF CHAR;
                      kind: StreamMode): INTEGER;
(* ffnet eine Datei, die Dateinamen 'CON:', 'PRN:' und 'AUX:' ffnen 
 * eine Datei auf das zugehrige Standardhandle.
 *)

PROCEDURE CloseStream (VAR s: STREAM): INTEGER;
(* Schliesst einen Stream *)

PROCEDURE WriteStream (s: STREAM; VAR a: ARRAY OF LOC);
(* Schreibt eine Anzahl Bytes (HIGH (a)); in den Stream *)

PROCEDURE ReadStream (s: STREAM; VAR a: ARRAY OF LOC);
(* Liest eine Anzahl Bytes (HIGH (a)) aus dem Stream *)

PROCEDURE Streampos (s: STREAM): lINTEGER;
(* liefert den Dateizeiger des Streams *)

TYPE    Posmode = (Start, Relative, End);

PROCEDURE SetStreampos (s: STREAM; mode: Posmode; pos: lINTEGER);
(* Setzt den Dateizeiger des Streams relativ vom Anfang (pos in Bytes) *)

PROCEDURE StreamEnd (s: STREAM); 
(* Setzt den Dateizeiger auf das Dateiende (wichtig fr Append-Modus!) *)

PROCEDURE EndofStream (s: STREAM): BOOLEAN;
(* TRUE, wenn das Ende der (zu lesenden) Datei ereicht ist *)

PROCEDURE StreamName (s: STREAM; VAR name: ARRAY OF CHAR);
(* liefert den Namen des Streams *)

PROCEDURE StreamHandle (s: STREAM; VAR handle: sINTEGER);
(* liefert das GEMDOS-Handle des Streams *)

END mtStreams.

