(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGICTOOLS   Modula's  All purpose  GEM  Interface  Cadre  Toolbox  *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 3.30  02.02.1992     (C)90/91/92 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden zu *
 * widerrufen.                                                          *
 *----------------------------------------------------------------------*)
 
(*----------------------------------------------------------------------*
 * mtTime       Funktionen zur Zeit- und Datumsmanipulation             *
 *----------------------------------------------------------------------*)
 
DEFINITION MODULE mtTime;

FROM MagicSys   IMPORT  Nil, Null, Bit0, Bit1, Bit2, Bit3, Bit4, Bit5, Bit6,
                        Bit7, Bit8, Bit9, Bit10, Bit11, Bit12, Bit13, Bit14,
                        Bit15, LOC, Byte, ByteSet, sWORD, sINTEGER, sCARDINAL,
                        sBITSET, lINTEGER, lCARDINAL, lWORD, lBITSET;

 



(* Kalender-Datum *)

PROCEDURE EncodeDate (day, month, year: sCARDINAL): sCARDINAL;
(* Wandelt das bergebene Datum ins DOS-Format *)

PROCEDURE DecodeDate (date: sCARDINAL; VAR day, month, year: sCARDINAL);
(* Wandelt das bergebene DOS-Datum in verstndliche Werte *)

PROCEDURE DateInNum (date: sCARDINAL): lCARDINAL; 
(* Wandelt ein Datum im GEMDOS-Format in eine Seriennummer.
 * Vorteil: Mit einer Seriennummer kann man rechnen...
 * Das Format ist die Anzahl der Tage seit dem 1.1.1900
 *)

PROCEDURE NumInDate (number: lCARDINAL): sCARDINAL;
(* Wandelt eine von DateInNum erzeugte Seriennummer wieder in ein
 * GEMDOS-Datum
 *)

PROCEDURE DateString (date: CARDINAL; VAR str: ARRAY OF CHAR);
(* Wandelt eine Datumsangabe im GEMDOS-Format in einen String.
 * In der Form 'tt.mm.jjjj'
 *)

PROCEDURE DayOfWeek (date: sCARDINAL): sCARDINAL;
(* Berechnet aus dem GEMDOS-Datum den Tag der Woche.
 * 0 =  Montag, 2 = Dienstag, ... 6 = Sonntag
 *)

CONST   German =        0;
        English =       1;
        French =        2;

PROCEDURE NameOfDay (language, day: sCARDINAL; VAR name: ARRAY OF CHAR);
(* Liefert den Namen eines Tages in der jeweiligen Sprache.
 * 0 =  Sonntag, 1 = Montag, 2 = Dienstag, ... 6 = Samstag
 *)

PROCEDURE NameOfMonth (language, month: sCARDINAL; VAR name: ARRAY OF CHAR);
(* Liefert den Namen eines Monats in der jeweiligen Sprache.
 * 1 =  Januar, 12 = Dezember
 *)

(* Uhrzeit *)

PROCEDURE EncodeTime (hour, minute, second: sCARDINAL): sCARDINAL;
(* Wandelt die bergebene Zeit ins DOS-Format *)

PROCEDURE DecodeTime (time: sCARDINAL; VAR hour, minute, second: sCARDINAL);
(* Wandelt die bergebene DOS-Zeit in verstndliche Werte *)

PROCEDURE TimeInNum (time: sCARDINAL): lCARDINAL;
(* Wandelt eine DOS-Zeit in eine Seriennummer. Die Seriennummer ist die
 * Anzahl der Sekunden seit Mitternacht.
 *)

PROCEDURE NumInTime (num: lCARDINAL): sCARDINAL;
(* Wandelt eine eine Seriennummer in DOS-Zeit. *)

PROCEDURE TimeString (time: CARDINAL; VAR str: ARRAY OF CHAR);
(* Wandelt eine Zeitangabe im DOS-Format in einen String.
 * Im Format 'hh:mm:ss'
 *)

END mtTime.
