(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGICTOOLS   Modula's  All purpose  GEM  Interface  Cadre  Toolbox  *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 3.30  02.02.1992     (C)90/91/92 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden zu *
 * widerrufen.                                                          *
 *----------------------------------------------------------------------*)
 
(*----------------------------------------------------------------------*
 * mtVT52     GEMDOS basierter VT52-Treiber. Alle Ausgaben werden ber  *
 *            MagicDOS.Fwrite abgewickelt, so da einer simplen Aus-    *
 *            gabeumlenkung nichts im Wege steht.  Als Default-Ausgabe  *
 *            ist StdOut vorgesehen.                                    *
 *----------------------------------------------------------------------*)

DEFINITION MODULE mtVT52;

FROM MagicSys   IMPORT  Nil, Null, Bit0, Bit1, Bit2, Bit3, Bit4, Bit5, Bit6,
                        Bit7, Bit8, Bit9, Bit10, Bit11, Bit12, Bit13, Bit14,
                        Bit15, LOC, Byte, ByteSet, sWORD, sINTEGER, sCARDINAL,
                        sBITSET, lINTEGER, lCARDINAL, lWORD, lBITSET;

 



PROCEDURE WriteChar (c: CHAR);
(* Schreibt Zeichen *)

PROCEDURE WriteLine (REF   s: ARRAY OF CHAR); 
(* schnelle Stringausgabe, kein LF *)

PROCEDURE WriteConst (REF   s: ARRAY OF CHAR);
(* Stringausgabe fr konstante Strings *)

PROCEDURE WriteLn;
(* CR + LF *)

PROCEDURE WriteCard     (wert: sCARDINAL; len: sCARDINAL);
PROCEDURE WriteInt      (wert: sINTEGER;  len: sCARDINAL);
PROCEDURE WriteLongCard (wert: lCARDINAL; len: sCARDINAL);
PROCEDURE WriteLongInt  (wert: lINTEGER;  len: sCARDINAL);
PROCEDURE WriteReal     (wert: REAL;      len: sCARDINAL);
PROCEDURE WriteLongReal (wert: LONGREAL;  len: sCARDINAL);
(* Schreibt die entspechenden Werte mit Lnge len *)

PROCEDURE WriteFixReal  (wert: REAL;      len, fix: sCARDINAL);
PROCEDURE WriteFixLReal (wert: LONGREAL;  len, fix: sCARDINAL);
(* Schreibt die entspechenden Werte mit Lnge len und fix Nachkommastellen *)

PROCEDURE InsertLine;
(* Fgt Leerzeile bei aktueller Cursorposition ein. Alle Zeilen unterhalb
 * werden nach unten verschoben. Die unterste Zeile geht verloren.
 *)

PROCEDURE DeleteLine;
(* Lscht Zeile an aktueller Cursorposition. Alle Zeilen unterhalb
 * werden nach oben verschoben. Die unterste Zeile wird leer.
 *)

PROCEDURE WhereXY (VAR x, y: sCARDINAL);
(* Ermittelt Cursorposition. Derzeit nicht implementiert *)

PROCEDURE GotoXY (x, y: sCARDINAL);
(* Setzt Cursor auf Spalte/Zeile.  Die HOME-Position ist 0,0 *)

PROCEDURE CursorUp;
PROCEDURE CursorDown;
PROCEDURE CursorRight;
PROCEDURE CursorLeft;
PROCEDURE CursorOn;
PROCEDURE CursorOff;
(* Cursorhandling *)

PROCEDURE CursorStop;
(* Stoppt blinkenden Cursor *)

PROCEDURE CursorBlink;
(* Lt Cursor blinken *)

PROCEDURE WrapOff;
PROCEDURE WrapOn;
(* Umbruch am Zeilenende. WrapOff ist Default *)

PROCEDURE ClearLine;
(* Lscht aktuelle Zeile *)

PROCEDURE ClearStartOfLine;
(* Lscht zum Zeilenanfang *)

PROCEDURE ClearEndOfLine;
(* Lscht zum Zeilenende *)

PROCEDURE ClearScreen;
(* Lscht Bildschirm *)

PROCEDURE ClearStartOfScreen;
(* Lscht zum Anfang des Bildschirms *)

PROCEDURE ClearEndOfScreen;
(* Lscht zum Ende des Bildschirms *)

PROCEDURE ForegroundColor (color: sINTEGER);
PROCEDURE BackgroundColor (color: sINTEGER);
(* Setzt die Farben  *)

PROCEDURE InversOn;
PROCEDURE InversOff;
(* Invers ein und wieder aus *)

CONST   StdOut =  1; (* Standard-GEMDOS-Device *)
        Serial =  2;
        Printer = 3;

PROCEDURE Device (handle: sINTEGER);
(* Setzt das Ausgabegert fr die vorhergehenden Prozeduren. StdOut ist
 * als Default vorgegeben. Hier kann auch ein File-Handle einer zum
 * Schreiben erffneten Datei benutzt werden.
 *)

END mtVT52.

