IMPLEMENTATION MODULE Mintbind;

(*==============================================================*
 *                                                              *
 * Mint-Binding fr Megamax Modula-2, unter Benutzung der       *
 * MagicLib von Peter Hellinger.                                *
 *                                                              *
 * (c) 1992 Dirk Steins                                         *
 *                                                              *
 * Dieses Modul ist Freeware!                                   *
 *                                                              *
 *==============================================================*
 * Autor:               Dirk Steins                             *
 * erstellt am:         13.8.1992                               *
 * letzte nderung am:  13.8.1992                               *
 * Version:             1.0                                     *
 *==============================================================*
 * Datum    Vers. Autor     nderung (Arbeitsbericht)           *
 *==============================================================*
 *
 * 13.8.92  1.0   DS        Modul erstellt
 *
 *==============================================================*)

(*$R-*)
(*$S-*)
(*$W-*)

FROM SYSTEM IMPORT ADR, ADDRESS, CALLSYS;
FROM MagicSys   IMPORT sINTEGER, lINTEGER, sBITSET, lBITSET, 
                       sCARDINAL, lCARDINAL;

FROM FileSys    IMPORT XATTR;

PROCEDURE Syield() : sINTEGER;
BEGIN
  RETURN sINTEGER(SHORT(CALLSYS (1,$FF)));
END Syield;

PROCEDURE Fpipe (VAR usrh : ARRAY OF sINTEGER): sINTEGER;
BEGIN
  RETURN sINTEGER(SHORT (CALLSYS (1, $100, ADR(usrh))));
END Fpipe;

PROCEDURE Fcntl (f : sINTEGER; arg : ADDRESS; cmd : INTEGER): lINTEGER;
BEGIN
  RETURN lINTEGER( CALLSYS (1, $104, f, arg, cmd));
END Fcntl;

PROCEDURE Finstat (f : sINTEGER): lINTEGER;
BEGIN
  RETURN lINTEGER (CALLSYS (1,$105, f));
END Finstat;

PROCEDURE Foutstat (f : sINTEGER) : lINTEGER;
BEGIN
  RETURN lINTEGER (CALLSYS (1,$106, f));
END Foutstat;

PROCEDURE Fgetchar (f : sINTEGER; mode : sINTEGER) : lINTEGER;
BEGIN
  RETURN lINTEGER (CALLSYS (1, $107, f, mode))
END Fgetchar;

PROCEDURE Fputchar (f : sINTEGER; char: lINTEGER; mode: sINTEGER): lINTEGER;
BEGIN
  RETURN lINTEGER (CALLSYS (1, $108, f, char, mode));
END Fputchar;

PROCEDURE Pwait (): lINTEGER;
BEGIN
  RETURN lINTEGER (CALLSYS (1, $109));
END Pwait;

PROCEDURE Pnice (delta : sINTEGER) : sINTEGER;
BEGIN
  RETURN sINTEGER (SHORT(CALLSYS (1, $10A, delta)));
END Pnice;

PROCEDURE Pgetpid () : sINTEGER;
BEGIN
  RETURN sINTEGER (SHORT(CALLSYS (1, $10B)));
END Pgetpid;
  
PROCEDURE Pgetppid () : sINTEGER;
BEGIN
  RETURN sINTEGER (SHORT(CALLSYS (1, $10C)));
END Pgetppid;

PROCEDURE Pgetpgrp () : sINTEGER;
BEGIN
  RETURN sINTEGER (SHORT(CALLSYS (1, $10D)));
END Pgetpgrp;

PROCEDURE Psetpgrp (pid, grp : sINTEGER) : sINTEGER;
BEGIN
  RETURN sINTEGER (SHORT(CALLSYS (1, $10E, pid, grp)));
END Psetpgrp;

PROCEDURE Pgetuid () : sINTEGER;
BEGIN
  RETURN sINTEGER (SHORT(CALLSYS (1, $10F)));
END Pgetuid;

PROCEDURE Psetuid (id : sINTEGER) : sINTEGER;
BEGIN
  RETURN sINTEGER (SHORT(CALLSYS (1, $110, id)));
END Psetuid;

PROCEDURE Pkill (pid, sig : sINTEGER) : sINTEGER;
BEGIN
  RETURN sINTEGER (SHORT(CALLSYS (1, $111, pid, sig)))
END Pkill;

PROCEDURE Psignal (sig : sINTEGER; handler : ADDRESS) : ADDRESS;
BEGIN
  RETURN ADDRESS( CALLSYS (1, $112, sig, handler));
END Psignal;

PROCEDURE Pvfork () : sINTEGER;
BEGIN
  RETURN sINTEGER (SHORT(CALLSYS (1, $113)))
END Pvfork;

PROCEDURE Pgetgid () : sINTEGER;
BEGIN
  RETURN sINTEGER (SHORT(CALLSYS (1, $114)))
END Pgetgid;

PROCEDURE Psetgid (id : sINTEGER) : sINTEGER;
BEGIN
  RETURN sINTEGER (SHORT(CALLSYS (1, $115, id)))
END Psetgid;

PROCEDURE Psigblock (mask : lBITSET) : lBITSET;
BEGIN
  RETURN lBITSET (CALLSYS (1, $116, mask))
END Psigblock;

PROCEDURE Psigsetmask (mask : lBITSET) : lBITSET;
BEGIN
  RETURN lBITSET (CALLSYS (1, $117, mask))
END Psigsetmask;

PROCEDURE Pusrval (val : lINTEGER) : lINTEGER;
BEGIN
  RETURN lINTEGER (CALLSYS (1, $118, val))
END Pusrval;

PROCEDURE Pdomain (domain : sINTEGER) : sINTEGER;
BEGIN
  RETURN sINTEGER (SHORT(CALLSYS (1, $119, domain)))
END Pdomain;

PROCEDURE Psigreturn ();
BEGIN
  CALLSYS (1, $11a);
END Psigreturn;

PROCEDURE Pfork () : sINTEGER;
BEGIN
  RETURN sINTEGER (SHORT(CALLSYS (1, $11b)))
END Pfork;

PROCEDURE Pwait3 (flag : sINTEGER; VAR rusage : ARRAY OF lINTEGER): lINTEGER;
BEGIN
  RETURN lINTEGER (CALLSYS (1, $11c, flag, ADR (rusage)))
END Pwait3;

PROCEDURE Fselect (time : sINTEGER; VAR rfd, wfd : lBITSET; xfd : ADDRESS) : sINTEGER;
BEGIN
  RETURN sINTEGER (SHORT(CALLSYS (1, $11d, time, ADR(rfd), ADR(wfd), xfd)))
END Fselect;

PROCEDURE Prusage (VAR r : ARRAY OF LONGINT);
BEGIN
  CALLSYS (1, $11e, ADR (r))
END Prusage;

PROCEDURE Psetlimit (limit : sINTEGER; val : lINTEGER) : lINTEGER;
BEGIN
  RETURN lINTEGER (CALLSYS (1, $11f, limit, val))
END Psetlimit;

PROCEDURE Talarm (time : lINTEGER) : lINTEGER;
BEGIN
  RETURN lINTEGER (CALLSYS (1, $120, time))
END Talarm;

PROCEDURE Pause ();
BEGIN
  CALLSYS (1, $121);
END Pause;

PROCEDURE Sysconf (n : sINTEGER): lINTEGER;
BEGIN
  RETURN lINTEGER (CALLSYS (1, $122, n))
END Sysconf;

PROCEDURE Psigpending () : lBITSET;
BEGIN
  RETURN lBITSET (CALLSYS (1, $123))
END Psigpending;

PROCEDURE Dpathconf (REF name : ARRAY OF CHAR; mode : sINTEGER) : lINTEGER;
BEGIN
  RETURN lINTEGER (CALLSYS (1, $124, ADR(name), mode))
END Dpathconf;

PROCEDURE Pmsg (mode : sINTEGER; mboxid : lINTEGER; VAR msg : Msg) : lINTEGER;
BEGIN
  RETURN lINTEGER (CALLSYS (1, $125, mode, mboxid, ADR(msg)))
END Pmsg;

PROCEDURE Fmidipipe (pid, in, out : sINTEGER) : lINTEGER;
BEGIN
  RETURN lINTEGER (CALLSYS (1, $126, pid, in, out))
END Fmidipipe;

PROCEDURE Prenice (pid, delta : sINTEGER) : lINTEGER;
BEGIN
  RETURN lINTEGER (CALLSYS (1, $127, pid, delta))
END Prenice;

PROCEDURE Dopendir (REF name : ARRAY OF CHAR; flag : sINTEGER) : lINTEGER;
BEGIN
  RETURN lINTEGER (CALLSYS (1, $128, ADR (name), flag))
END Dopendir;

PROCEDURE Dreaddir (handle : lINTEGER; VAR name : ARRAY OF CHAR) : lINTEGER;
BEGIN
  RETURN lINTEGER (CALLSYS (1, $129, HIGH (name), handle, ADR(name)))
END Dreaddir;

PROCEDURE Dxreaddir (handle : lINTEGER; VAR name : ARRAY OF CHAR; 
                     VAR xattr : XATTR; VAR xr: lINTEGER) : lINTEGER;
BEGIN
  RETURN lINTEGER (CALLSYS (1, $142, HIGH (name), handle, ADR(name), ADR (xattr), ADR (xr)))
END Dxreaddir;

PROCEDURE Drewinddir (handle : lINTEGER) : lINTEGER;
BEGIN
  RETURN lINTEGER (CALLSYS (1, $12a, handle))
END Drewinddir;

PROCEDURE Dclosedir (handle : lINTEGER) : lINTEGER;
BEGIN
  RETURN lINTEGER (CALLSYS (1, $12b, handle))
END Dclosedir;

PROCEDURE Fxattr (flag : sINTEGER; REF name : ARRAY OF CHAR; VAR xattr : XATTR) : lINTEGER;
BEGIN
  RETURN lINTEGER (CALLSYS (1, $12c, flag, ADR(name), ADR (xattr)))
END Fxattr;

PROCEDURE Flink (REF oldname, newname : ARRAY OF CHAR) : lINTEGER;
BEGIN
  RETURN lINTEGER (CALLSYS (1, $12d, ADR(oldname), ADR(newname)))
END Flink;

PROCEDURE Fsymlink (REF oldname, newname : ARRAY OF CHAR) : lINTEGER;
BEGIN
  RETURN lINTEGER (CALLSYS (1, $12e, ADR(oldname), ADR(newname)))
END Fsymlink;

PROCEDURE Freadlink (REF name : ARRAY OF CHAR; VAR buf : ARRAY OF CHAR) : lINTEGER;
BEGIN
  RETURN lINTEGER (CALLSYS (1, $12f, HIGH (buf), ADR(name), ADR(buf)))
END Freadlink;

PROCEDURE Dcntl (cmd : sINTEGER; REF name : ARRAY OF CHAR; arg : lINTEGER) : lINTEGER;
BEGIN
  RETURN lINTEGER (CALLSYS (1, $130, cmd, ADR(name), arg))
END Dcntl;

PROCEDURE Fchown (REF name : ARRAY OF CHAR; uid, gid : sINTEGER) : lINTEGER;
BEGIN
  RETURN lINTEGER (CALLSYS (1, $131, ADR(name), uid, gid))
END Fchown;

PROCEDURE Fchmod (REF name : ARRAY OF CHAR; mode : sBITSET) : lINTEGER;
BEGIN
  RETURN lINTEGER (CALLSYS (1, $132, ADR(name), mode))
END Fchmod;

PROCEDURE Pumask (mode : sBITSET): sBITSET;
BEGIN
  RETURN sBITSET (SHORT(CALLSYS (1, $133, mode)))
END Pumask;

PROCEDURE Psemaphore (mode : sINTEGER; id : lCARDINAL; timeout : lINTEGER) : lINTEGER;
BEGIN
  RETURN lINTEGER (CALLSYS (1, $134, mode, id, timeout))
END Psemaphore;

PROCEDURE Dlock (mode : sINTEGER; drv : sINTEGER) : lINTEGER;
BEGIN
  RETURN lINTEGER (CALLSYS (1, $135, mode, drv))
END Dlock;

PROCEDURE Psigpause (mask : lBITSET);
BEGIN
  CALLSYS (1, $136, mask)
END Psigpause;

PROCEDURE Psigaction (sig : sINTEGER; VAR act : SigAction; VAR oact : SigAction) : lINTEGER;
BEGIN
  RETURN lINTEGER (CALLSYS (1, $137, sig, ADR(act), ADR (oact)))
END Psigaction;

PROCEDURE Pgeteuid() : sINTEGER;
BEGIN
  RETURN sINTEGER (SHORT(CALLSYS (1, $138)))
END Pgeteuid;

PROCEDURE Pgetegid() : sINTEGER;
BEGIN
  RETURN sINTEGER (SHORT(CALLSYS (1, $139)))
END Pgetegid;

END Mintbind.
