(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGICTOOLS   Modula's  All purpose  GEM  Interface  Cadre  Toolbox  *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 3.30  02.02.1992     (C)90/91/92 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden zu *
 * widerrufen.                                                          *
 *----------------------------------------------------------------------*)
 
IMPLEMENTATION MODULE mtDialHandler;
(*----------------------------------------------------------------------*
 * Int. Vers | Datum    | Name | nderung                               *
 *-----------+----------+------+----------------------------------------*
 *  3.00     | 18.01.92 |  Hp  |                                        *
 *-----------+----------+------+----------------------------------------*)



(* IMPLEMENTATION FR  >>> Megamax-Modula-2 <<< *)
(*                                              *)
(*$R-   Range-Checks                            *)
(*$S-   Stack-Check                             *)
(*                                              *)
(*----------------------------------------------*)






FROM MagicSys   IMPORT  Nil, Null, Bit0, Bit1, Bit2, Bit3, Bit4, Bit5, Bit6,
                        Bit7, Bit8, Bit9, Bit10, Bit11, Bit12, Bit13, Bit14,
                        Bit15, LOC, Byte, ByteSet, sWORD, sINTEGER, sCARDINAL,
                        sBITSET, lINTEGER, lCARDINAL, lWORD, lBITSET,
                        CastToChar, CastToByte, CastToByteset, CastToInt,
                        CastToCard, CastToBitset, CastToWord, CastToLInt,
                        CastToLCard, CastToLBitset, CastToLWord, CastToAddr,
                        TosVersion, Accessory, Basepage, SysHeader, TosDate;

 






FROM Storage IMPORT ALLOCATE, DEALLOCATE;




FROM SYSTEM     IMPORT  ADDRESS, ADR, TSIZE;
IMPORT MagicAES, mtAppl, mtDials, mtUtils;

TYPE    ACTION =        POINTER TO Action;
        Action =        RECORD
                         entry: sINTEGER;
                         proc:  DialAction;
                         next:  ACTION;
                        END;

VAR     clip:           mtUtils.tRect;

PROCEDURE InitAction (VAR actions: ACTION);
BEGIN
 actions:= NIL;
END InitAction;

PROCEDURE DisposeAction (VAR actions: ACTION);
VAR p, q: ACTION;
BEGIN
 IF actions # NIL THEN
  p:= actions;
  WHILE p # NIL DO
   q:= p;  p:= p^.next;  DEALLOCATE (q, 0);  ;
  END;
  actions:= NIL;
 END;
END DisposeAction;

PROCEDURE GetAction (entry: sINTEGER; action: ACTION): ACTION;
VAR p: ACTION;
BEGIN
 p:= action;
 WHILE p # NIL DO
  IF (p^.entry = entry) THEN  RETURN p;  END;
  IF (entry = -1) AND (p^.next = NIL) THEN  RETURN p;  END;
  p:= p^.next;
 END;
 RETURN p;
END GetAction;

 (*$H+ Lokale Prozeduren erlauben *)  
PROCEDURE SetAction (VAR actions: ACTION; entry: sINTEGER; proc: DialAction): BOOLEAN;
VAR p, q: ACTION;
BEGIN
 ALLOCATE (p,  TSIZE (Action));  ;
 IF p = NIL THEN RETURN FALSE;  END;
 p^.entry:= entry;  p^.proc:= proc;  p^.next:= NIL;
 IF actions = NIL THEN  actions:= p;
                  ELSE  q:= GetAction (-1, actions);  q^.next:= p;
 END;
 RETURN TRUE;
END SetAction;
 (*$H=*)  

PROCEDURE ResetAction (VAR actions: ACTION; entry: sINTEGER);
VAR p, q: ACTION;
BEGIN
 p:= actions;
 LOOP
  IF p = NIL THEN  EXIT;  END;
  IF p^.entry = entry THEN  EXIT;  END;
  q:= p;  p:= p^.next;
 END;
 IF p # NIL THEN
  q^.next:= p^.next;  DEALLOCATE (p, 0);  ;
 END;
END ResetAction;

PROCEDURE DialHandler (dial: ADDRESS; todo: BITSET; rect: ARRAY OF LOC;
                       edobjc: sINTEGER; actions: ACTION);
VAR objc: INTEGER;
    p: ACTION;
    b: BOOLEAN;
    s: BITSET;
BEGIN
 mtAppl.StoreMouse;
 IF DoProlog IN todo THEN
  mtDials.DialCenter (dial, mtDials.CSCREEN, 0, 0, clip);
  IF DoGraphics IN todo THEN
   mtDials.DialForm (dial, mtDials.DGROW, rect, clip);
  END;
  mtDials.DialForm (dial, mtDials.DSTART, clip, clip);
  mtDials.DialDraw (dial, 0, 8, clip, FALSE);
 END;
 LOOP
  mtAppl.MouseArrow;
  objc:= mtDials.DialDo (dial, edobjc);
  b:= mtUtils.DoubleClick (objc);
  
  IF mtUtils.InFlag (dial, objc, MagicAES.EDITABLE) THEN
   edobjc:= objc;
  END;
  
  p:= GetAction (objc, actions);
  IF p # NIL THEN

   s:= p^.proc (dial, objc, b); (* Handleprozedur aufrufen *)

   IF ResetCHECKED IN s THEN
    mtUtils.ExclState (dial, objc, MagicAES.CHECKED);
   ELSIF SetCHECKED IN s THEN
    mtUtils.InclState (dial, objc, MagicAES.CHECKED);
   END;

   IF ResetSELECTED IN s THEN
    mtUtils.ExclState (dial, objc, MagicAES.SELECTED);
   ELSIF SetSELECTED IN s THEN
    mtUtils.InclState (dial, objc, MagicAES.SELECTED);
   END;

   IF DrawObjc IN s THEN
    mtDials.DialDraw (dial, objc, 0, clip, FALSE);
   END;

   IF LeaveDial IN s THEN  EXIT;  END;

  END; (* IF p # NIL *)
  
 END; (* LOOP *)

 IF DoEpilog IN todo THEN
  IF DoGraphics IN todo THEN
   mtDials.DialForm (dial, mtDials.DSHRINK, rect, clip);
  END;
  mtDials.DialForm (dial, mtDials.DFINISH, clip, clip);
 END;
 mtAppl.RestoreMouse;
END DialHandler;

END mtDialHandler.

