(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGICTOOLS   Modula's  All purpose  GEM  Interface  Cadre  Toolbox  *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 3.30  02.02.1992     (C)90/91/92 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden zu *
 * widerrufen.                                                          *
 *----------------------------------------------------------------------*)
 
IMPLEMENTATION MODULE mtTime;

(*----------------------------------------------------------------------*
 * Int. Vers | Datum    | Name | nderung                               *
 *-----------+----------+------+----------------------------------------*
 *  3.00     | 18.01.92 |  Hp  |                                        *
 *  3.01     | 03.02.92 |  Hp  | Tagesberechnung sowie Namensauswahl    *
 *           |          |      | implementiert.                         *
 *-----------+----------+------+----------------------------------------*)



(* IMPLEMENTATION FR  >>> Megamax-Modula-2 <<< *)
(*                                              *)
(*$R-   Range-Checks                            *)
(*$S-   Stack-Check                             *)
(*                                              *)
(*----------------------------------------------*)






FROM MagicSys   IMPORT  Nil, Null, Bit0, Bit1, Bit2, Bit3, Bit4, Bit5, Bit6,
                        Bit7, Bit8, Bit9, Bit10, Bit11, Bit12, Bit13, Bit14,
                        Bit15, LOC, Byte, ByteSet, sWORD, sINTEGER, sCARDINAL,
                        sBITSET, lINTEGER, lCARDINAL, lWORD, lBITSET,
                        CastToChar, CastToByte, CastToByteset, CastToInt,
                        CastToCard, CastToBitset, CastToWord, CastToLInt,
                        CastToLCard, CastToLBitset, CastToLWord, CastToAddr,
                        TosVersion, Accessory, Basepage, SysHeader, TosDate;

 




FROM MagicStrings       IMPORT  Assign, Append, Length, Pos;
FROM MagicBitOps        IMPORT  Operation, BitOp, ShiftRight, ShiftLeft;
FROM MagicConvert       IMPORT  CardToStr;

VAR     x:        sCARDINAL;
        n:        ARRAY [0..10] OF CHAR;
        Weekdays: ARRAY [German..French],[0.. 6],[0..25] OF CHAR;
        Month:    ARRAY [German..French],[1..12],[0..25] OF CHAR;

PROCEDURE Number (num: CARDINAL; VAR str: ARRAY OF CHAR);
BEGIN
 CardToStr (num, 2, str);  IF str[0] = ' ' THEN  str[0]:= '0';  END;
END Number;

PROCEDURE EncodeDate (day, month, year: sCARDINAL): sCARDINAL;
VAR d1, d2, d3: sCARDINAL;
BEGIN
 d1:= 0;  d2:= 0;  d3:= 0;  (* Alle Bits lschen *)
 IF year > 1980 THEN  DEC (year, 1980);  END;
 IF month > 12 THEN month:= 12;  END;
 IF day > 31 THEN
  CASE month OF
   1, 3, 5, 7, 8, 10, 12:  day:= 31;|
   4, 6, 9, 11:            day:= 30;|
   ELSE  IF (year MOD 4) = 0 THEN  day:= 29;  ELSE  day:= 28;  END;
  END;
 END;
 ShiftLeft (month, 5);  ShiftLeft (year, 9);
 x:=    31;  BitOp (and, day,   x, d1);
 x:=   480;  BitOp (and, month, x, d2);
 x:= 65024;  BitOp (and, year,  x, d3);
 RETURN d1 + d2 + d3;
END EncodeDate;

PROCEDURE DecodeDate (date: sCARDINAL; VAR day, month, year: sCARDINAL);
BEGIN
 x:=    31;  BitOp (and, date, x, day);
 x:=   480;  BitOp (and, date, x, month); ShiftRight (month, 5);
 x:= 65024;  BitOp (and, date, x, year);
 ShiftRight (year, 9);  INC (year, 1980);
END DecodeDate;

PROCEDURE DateInNum (date: sCARDINAL): lCARDINAL; 
VAR t, m, j: sCARDINAL;
    l1, l2: lCARDINAL;
BEGIN
 DecodeDate (date, t, m, j);  INC (j, 80);  (* Weil, ist GEMDOS-Datum! *)
 IF (m > 2) THEN  m:= m - 3  ELSE  m:= m + 9;  DEC (j);  END;
 l1:= 1461 * LONG (j) DIV 4;  l2:= LONG ((153 * m) DIV 5);
 RETURN l1 + l2 + LONG (t);
END DateInNum; 

PROCEDURE NumInDate (number: lCARDINAL): sCARDINAL;
VAR t, m, j, x1, x2: sCARDINAL;
    l: lCARDINAL;
BEGIN
 j:= SHORT ((4 * number) DIV 1461);
 l:= 1461 * LONG(j) DIV 4;  DEC (number, l); (* Resttage *)
 m:= SHORT ((5 * number) DIV 153);
 x:= (m * 153) DIV 5;  DEC (number, LONG(x));
 t:= SHORT (number);
 INC (m, 3);
 IF m > 12 THEN  DEC (m, 12);  INC (j);  END;
 RETURN EncodeDate (t, m, j);
END NumInDate;

PROCEDURE DateString (date: CARDINAL; VAR str: ARRAY OF CHAR);
VAR t, m, j: CARDINAL;
    point: ARRAY [0..0] OF CHAR;
BEGIN
 DecodeDate (date, t, m, j);  point[0]:= '.';
 Number (t, str);  Append (point, str);
 Number (m, n);    Append (n, str);  Append (point, str);
 Number (j, n);    Append (n, str);
END DateString;

PROCEDURE DayOfWeek (date: sCARDINAL): sCARDINAL;
VAR num: lCARDINAL;
    tag, day, d, m, y: sCARDINAL;
BEGIN
 num:= DateInNum (date);  DecodeDate (date, d, m, y);
 tag:= SHORT (num - ((num DIV LONG (7)) * LONG (7)));
 CASE m OF (* Ausnahme fr Monate mit weniger als 31 Tagen *)
  2, 4, 6, 9, 11:  IF tag = 6 THEN  tag:= 0;  ELSE  INC (tag);  END;
  ELSE ;
 END;
 RETURN tag;
END DayOfWeek;

PROCEDURE NameOfDay (language, day: sCARDINAL; VAR name: ARRAY OF CHAR);
BEGIN
 IF (language <= French) AND (day < 7) THEN
  Assign (Weekdays[language, day], name);
 ELSE
  name[0]:= 0C;
 END;
END NameOfDay;

PROCEDURE NameOfMonth (language, month: sCARDINAL; VAR name: ARRAY OF CHAR);
BEGIN
 IF (language <= French) AND ((month > 0) AND (month < 13)) THEN
  Assign (Month[language, month], name);
 ELSE
  name[0]:= 0C;
 END;
END NameOfMonth;

PROCEDURE EncodeTime (hour, minute, second: sCARDINAL): sCARDINAL;
VAR t1, t2, t3: sCARDINAL;
BEGIN
 t1:= 0;  t2:= 0;  t3:= 0; (* Alle Bits lschen *)
 IF hour > 23 THEN  hour:= 0;  END;
 IF minute > 59 THEN  minute:= 0;  END;
 IF second > 59 THEN  second:= 0;  END;
 second:= second DIV 2;  ShiftLeft (minute, 5);  ShiftLeft (hour, 11);
 x:=    31;  BitOp (and, second, x, t1);
 x:=  2016;  BitOp (and, minute, x, t2);
 x:= 63488;  BitOp (and, hour, x, t3);
 RETURN t1 + t2 + t3;
END EncodeTime;

PROCEDURE DecodeTime (time: sCARDINAL; VAR hour, minute, second: sCARDINAL);
BEGIN
 x:=    31;  BitOp (and, time, x, second);  second:= second * 2;
 x:=  2016;  BitOp (and, time, x, minute);  ShiftRight (minute, 5);
 x:= 63488;  BitOp (and, time, x, hour);    ShiftRight (hour, 11);
END DecodeTime;

PROCEDURE TimeInNum (time: sCARDINAL): lCARDINAL;
VAR sec: lCARDINAL;
    h, m, s: sCARDINAL;
BEGIN
 DecodeTime (time, h, m, s);
 sec:= LONG (h) * LONG (3600);
 sec:= sec + LONG (m) * LONG (60);
 sec:= sec + LONG (s);
 RETURN sec;
END TimeInNum;

PROCEDURE NumInTime (num: lCARDINAL): sCARDINAL;
VAR h, m, s: sCARDINAL;
    l: lCARDINAL;
BEGIN
 l:= num DIV LONG (3600);  h:= SHORT (l);  DEC (num, l * LONG (3600));
 l:= num DIV LONG (60);    m:= SHORT (l);  DEC (num, l * LONG (60));
 s:= SHORT (num);
 RETURN EncodeTime (h, m, s);
END NumInTime;

PROCEDURE TimeString (time: CARDINAL; VAR str: ARRAY OF CHAR);
VAR s, m, h: CARDINAL;
    n: ARRAY [0..10] OF CHAR;
    dots: ARRAY [0..0] OF CHAR;
BEGIN
 DecodeTime (time, h, m, s);  dots[0]:= ':';
 Number (h, str);  Append (dots, str);
 Number (m, n);  Append (n, str);  Append (dots, str);
 Number (s, n);  Append (n, str);
END TimeString;

BEGIN
 (* Deutsch *)
 Weekdays[0,0]:= 'Montag';
 Weekdays[0,1]:= 'Dienstag';
 Weekdays[0,2]:= 'Mittwoch';
 Weekdays[0,3]:= 'Donnerstag';
 Weekdays[0,4]:= 'Freitag';
 Weekdays[0,5]:= 'Samstag';
 Weekdays[0,6]:= 'Sonntag';
 Month[0, 1]:= 'Januar';
 Month[0, 2]:= 'Februar';
 Month[0, 3]:= 'Mrz';
 Month[0, 4]:= 'April';
 Month[0, 5]:= 'Mai';
 Month[0, 6]:= 'Juni';
 Month[0, 7]:= 'Juli';
 Month[0, 8]:= 'August';
 Month[0, 9]:= 'September';
 Month[0,10]:= 'Oktober';
 Month[0,11]:= 'November';
 Month[0,12]:= 'Dezember';

 (* Englisch *)
 Weekdays[1,0]:= 'Monday';
 Weekdays[1,1]:= 'Tuesday';
 Weekdays[1,2]:= 'Wednesday';
 Weekdays[1,3]:= 'Thursday';
 Weekdays[1,4]:= 'Friday';
 Weekdays[1,5]:= 'Saturday';
 Weekdays[1,6]:= 'Sunday';
 Month[1, 1]:= 'January';
 Month[1, 2]:= 'February';
 Month[1, 3]:= 'March';
 Month[1, 4]:= 'April';
 Month[1, 5]:= 'May';
 Month[1, 6]:= 'Juni';
 Month[1, 7]:= 'Juli';
 Month[1, 8]:= 'August';
 Month[1, 9]:= 'September';
 Month[1,10]:= 'Oktober';
 Month[1,11]:= 'November';
 Month[1,12]:= 'December';

 (* Franzsich *)
 Weekdays[2,0]:= 'Lundi';
 Weekdays[2,1]:= 'Mardi';
 Weekdays[2,2]:= 'Mercredi';
 Weekdays[2,3]:= 'Jeudi';
 Weekdays[2,4]:= 'Vendredi';
 Weekdays[2,5]:= 'Samedi';
 Weekdays[2,6]:= 'Dimanche';
 Month[2, 1]:= 'Janvier';
 Month[2, 2]:= 'Fvrier';
 Month[2, 3]:= 'Mars';
 Month[2, 4]:= 'Avril';
 Month[2, 5]:= 'Mai';
 Month[2, 6]:= 'Juin';
 Month[2, 7]:= 'Juillet';
 Month[2, 8]:= 'Aot';
 Month[2, 9]:= 'Septembre';
 Month[2,10]:= 'Octobre';
 Month[2,11]:= 'Novembre';
 Month[2,12]:= 'Dcembre';
END mtTime.
