(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGICTOOLS   Modula's  All purpose  GEM  Interface  Cadre  Toolbox  *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 3.30  02.02.1992     (C)90/91/92 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden zu *
 * widerrufen.                                                          *
 *----------------------------------------------------------------------*)
 
IMPLEMENTATION MODULE mtVT52;

(*----------------------------------------------------------------------*
 * Int. Vers | Datum    | Name | nderung                               *
 *-----------+----------+------+----------------------------------------*
 *  3.00     | 18.01.92 |  Hp  |                                        *
 *-----------+----------+------+----------------------------------------*)



(* IMPLEMENTATION FR  >>> Megamax-Modula-2 <<< *)
(*                                              *)
(*$R-   Range-Checks                            *)
(*$S-   Stack-Check                             *)
(*                                              *)
(*----------------------------------------------*)






FROM MagicSys   IMPORT  Nil, Null, Bit0, Bit1, Bit2, Bit3, Bit4, Bit5, Bit6,
                        Bit7, Bit8, Bit9, Bit10, Bit11, Bit12, Bit13, Bit14,
                        Bit15, LOC, Byte, ByteSet, sWORD, sINTEGER, sCARDINAL,
                        sBITSET, lINTEGER, lCARDINAL, lWORD, lBITSET,
                        CastToChar, CastToByte, CastToByteset, CastToInt,
                        CastToCard, CastToBitset, CastToWord, CastToLInt,
                        CastToLCard, CastToLBitset, CastToLWord, CastToAddr,
                        TosVersion, Accessory, Basepage, SysHeader, TosDate;

 




FROM SYSTEM             IMPORT  ADDRESS, ADR, TSIZE;
FROM MagicStrings       IMPORT  Assign, Append, Length;
FROM MagicConvert       IMPORT  CardToStr, IntToStr, LCardToStr, LIntToStr,
                                LRealToStr, RealToStr, FixRealToStr, FixLRealToStr;
IMPORT  MagicXBIOS, MagicDOS;

CONST   ESC =    33C;
        CR =     15C;
        LF =     12C;

VAR     device: sINTEGER;
        str:    ARRAY [0..255] OF CHAR;
        escape: ARRAY [0..10] OF CHAR;
        crlf:   ARRAY [0..2] OF CHAR;
        Str:    ADDRESS;
        Escape: ADDRESS;
        Crlf:   ADDRESS;

PROCEDURE Schreib (len: lCARDINAL; address: ADDRESS);
BEGIN
 MagicDOS.Fwrite (device, len, address);
END Schreib;

PROCEDURE WriteChar (ch: CHAR);
BEGIN
 Schreib (LONG (1), ADR (ch));
END WriteChar;

(*$W-*)
PROCEDURE WriteLine (REF string: ARRAY OF CHAR); 
BEGIN
 Schreib (LONG (Length (string)), ADR (string));
END WriteLine;
(*$W=*)

PROCEDURE WriteConst (REF string: ARRAY OF CHAR);
BEGIN
 WriteLine(string);
END WriteConst;

PROCEDURE WriteLn;
BEGIN
 Schreib (LONG (2), Crlf);
END WriteLn;

PROCEDURE WriteCard (wert: sCARDINAL; len: sCARDINAL);
BEGIN
 CardToStr (wert, len, str);
 Schreib (LONG (Length (str)), Str);
END WriteCard;

PROCEDURE WriteInt (wert: sINTEGER; len: sCARDINAL);
BEGIN
 IntToStr (wert, len, str);
 Schreib (LONG (Length (str)), Str);
END WriteInt;

PROCEDURE WriteLongCard (wert: lCARDINAL; len: sCARDINAL);
BEGIN
 LCardToStr (wert, len, str);
 Schreib (LONG (Length (str)), Str);
END WriteLongCard;

PROCEDURE WriteLongInt (wert: lINTEGER;  len: sCARDINAL);
BEGIN
 LIntToStr (wert, len, str);
 Schreib (LONG (Length (str)), Str);
END WriteLongInt;

PROCEDURE WriteReal (wert: REAL; len: sCARDINAL);
BEGIN
 RealToStr (wert, len, str);
 Schreib (LONG (Length (str)), Str);
END WriteReal;

PROCEDURE WriteLongReal (wert: LONGREAL; len: sCARDINAL);
BEGIN
 LRealToStr (wert, len, str);
 Schreib (LONG (Length (str)), Str);
END WriteLongReal;

PROCEDURE WriteFixReal (wert: REAL; len, fix: sCARDINAL);
BEGIN
 FixRealToStr (wert, len, fix, str);
 Schreib (LONG (Length (str)), Str);
END WriteFixReal;

PROCEDURE WriteFixLReal (wert: LONGREAL; len, fix: sCARDINAL);
BEGIN
 FixLRealToStr (wert, len, fix, str);
 Schreib (LONG (Length (str)), Str);
END WriteFixLReal;

PROCEDURE InsertLine;
BEGIN
 escape[1]:= 'L';  Schreib (LONG (2), Escape);
END InsertLine;

PROCEDURE DeleteLine;
BEGIN
 escape[1]:= 'M';  Schreib (LONG (2), Escape);
END DeleteLine;

PROCEDURE WhereXY (VAR spalte, zeile: sCARDINAL);
BEGIN
 spalte:= 0;  zeile:= 0;
END WhereXY;

PROCEDURE GotoXY (spalte, zeile: sCARDINAL);
(* Die Home-Position wurde auf 0, 0 festgelegt *)
BEGIN
 escape[1]:= 'Y';
 escape[2]:= CHR (zeile + 32);
 escape[3]:= CHR (spalte + 32);
 Schreib (LONG (4), Escape);
END GotoXY;

PROCEDURE CursorUp;
BEGIN
 escape[1]:= 'A';  Schreib (LONG (2), Escape);
END CursorUp;

PROCEDURE CursorDown;
BEGIN
 escape[1]:= 'B';  Schreib (LONG (2), Escape);
END CursorDown;

PROCEDURE CursorRight;
BEGIN
 escape[1]:= 'C';  Schreib (LONG (2), Escape);
END CursorRight;

PROCEDURE CursorLeft;
BEGIN
 escape[1]:= 'F';  Schreib (LONG (2), Escape);
END CursorLeft;

PROCEDURE CursorOn;
BEGIN
 escape[1]:= 'e';  Schreib (LONG (2), Escape);
END CursorOn;

PROCEDURE CursorOff;
BEGIN
 escape[1]:= 'f';  Schreib (LONG (2), Escape);
END CursorOff;

PROCEDURE CursorStop;
VAR i: sINTEGER;
BEGIN
 i:= MagicXBIOS.Cursconf (MagicXBIOS.CURSNOBLINK, 0);
END CursorStop;

PROCEDURE CursorBlink;
VAR i: sINTEGER;
BEGIN
 i:= MagicXBIOS.Cursconf (MagicXBIOS.CURSBLINK, 0);
END CursorBlink;

PROCEDURE WrapOff;
BEGIN
 escape[1]:= 'w';  Schreib (LONG (2), Escape);
END WrapOff;

PROCEDURE WrapOn;
BEGIN
 escape[1]:= 'v';  Schreib (LONG (2), Escape);
END WrapOn;

PROCEDURE ClearLine;
BEGIN
 escape[1]:= 'l'; Schreib (LONG (2), Escape);
END ClearLine;

PROCEDURE ClearStartOfLine;
BEGIN
 escape[1]:= 'o'; Schreib (LONG (2), Escape);
END ClearStartOfLine;

PROCEDURE ClearEndOfLine;
BEGIN
 escape[1]:= 'K'; Schreib (LONG (2), Escape);
END ClearEndOfLine;

PROCEDURE ClearScreen;
BEGIN
 escape[1]:= 'E'; Schreib (LONG (2), Escape);
END ClearScreen;

PROCEDURE ClearStartOfScreen;
BEGIN
 escape[1]:= 'd'; Schreib (LONG (2), Escape);
END ClearStartOfScreen;

PROCEDURE ClearEndOfScreen;
BEGIN
 escape[1]:= 'J'; Schreib (LONG (2), Escape);
END ClearEndOfScreen;

PROCEDURE ForegroundColor (color: sINTEGER);
BEGIN
 escape[1]:= 'b';  escape[2]:= CHR (color);
 Schreib (LONG (3), Escape);
END ForegroundColor;

PROCEDURE BackgroundColor (color: sINTEGER);
BEGIN
 escape[1]:= 'c';  escape[2]:= CHR (color);
 Schreib (LONG (3), Escape);
END BackgroundColor;

PROCEDURE InversOn;
BEGIN
 escape[1]:= 'p'; Schreib (LONG (2), Escape);
END InversOn;

PROCEDURE InversOff;
BEGIN
 escape[1]:= 'q';  Schreib (LONG (2), Escape);
END InversOff;

PROCEDURE Device (handle: sINTEGER);
BEGIN
 device:= handle;
END Device;

BEGIN
 device:= StdOut;
 Str:= ADR (str);  Crlf:= ADR (crlf);  Escape:= ADR (escape);
 escape[0]:= ESC;  crlf[0]:= CR;  crlf[1]:= LF;
END mtVT52.

