IMPLEMENTATION MODULE PutzInit;

(* Modul zur Darstellung der Initialisierungsbox beim
 * Laden einer CAT.INF
 *)

FROM SYSTEM IMPORT ADDRESS, ADR, CADR, CAST, ASSEMBLER;

(* MM2-Module *)

IMPORT GrafBase;

(* CAT-Module *)
IMPORT WdwManager, CatGlobal;
FROM Void   IMPORT v;

(* Magic-Module *)
IMPORT MagicAES, mtUtils, mtAppl, mtDials;

(* Putz-Module *)
IMPORT Catputz2, PutzRsc;

VAR rect : GrafBase.Rectangle;
    inWindow: BOOLEAN;
    wdwHandle: INTEGER;
    oldNewTop: WdwManager.handleNewTopProc;
    
    actBox  : mtUtils.tObjcTree;

PROCEDURE bProc (wdw, vdi : INTEGER; env : ADDRESS; mx, my : INTEGER; kstate, buts : BITSET; clicks :INTEGER): BOOLEAN;
BEGIN
  RETURN FALSE;
END bProc;

PROCEDURE kProc (wdw, vdi : INTEGER; env: ADDRESS; taste: INTEGER; key, scan : CHAR; kstate : BITSET): BOOLEAN;
BEGIN
  RETURN FALSE
END kProc;

PROCEDURE closeP (wdw, vdi: INTEGER; env : ADDRESS; force : BOOLEAN): BOOLEAN;
BEGIN
  RETURN force
END closeP;

PROCEDURE topP (wdw, vdi: INTEGER; env: ADDRESS): BOOLEAN;
BEGIN
  RETURN TRUE
END topP;

PROCEDURE untopP (wdw, vdi: INTEGER; env: ADDRESS);
END untopP;

PROCEDURE setWork (wdw, vdi: INTEGER; env: ADDRESS; doc: GrafBase.LongRect; slided: BOOLEAN);
END setWork;

PROCEDURE getRect (wdw, vdi: INTEGER; env: ADDRESS; VAR r : GrafBase.Rectangle);
BEGIN
  rect := r;
  actBox^[0].obX := r.x;
  actBox^[0].obY := r.y;
END getRect;

PROCEDURE redrawInfo (wdw, vdi : INTEGER; env : ADDRESS; clip : GrafBase.Rectangle);
BEGIN
  mtDials.DialDraw (env, 0, 8, clip, TRUE);
END redrawInfo;
    
PROCEDURE updateP (wdw, vdi: INTEGER; env: ADDRESS; doIt: BOOLEAN);
BEGIN
  IF doIt 
  THEN 
    MagicAES.WindUpdate (MagicAES.BEGUPDATE);
  ELSE
    MagicAES.WindUpdate (MagicAES.ENDUPDATE);
  END;
END updateP;

VAR slideVars : RECORD
                  pFrame,
                  sFrame    : mtUtils.tRect;
                  lastWidth : INTEGER;
                  reinit    : BOOLEAN;
                  fullInit  : BOOLEAN;
                  Epp       : LONGINT;
                END;
    groupCount: LONGINT;
     
PROCEDURE handleBusyMouse();
BEGIN
  IF ~CatGlobal.multiTask OR ~inWindow THEN 
    IF WdwManager.IsOwnTop ()
    THEN
      CatGlobal.busyMouse; 
    END;
  END;
END handleBusyMouse;

PROCEDURE DrawObjectInWdw (tree: ADDRESS; obj, depth: INTEGER; r: GrafBase.Rectangle; clip: BOOLEAN; mouse: BOOLEAN): BOOLEAN;
BEGIN
  IF ~clip
  THEN 
    mtUtils.CalcArea (tree, obj, r);
  END;
  IF inWindow
  THEN
    IF CatGlobal.multiTask
    THEN
      MagicAES.WindUpdate (MagicAES.BEGUPDATE+$100);
    ELSE
      MagicAES.WindUpdate (MagicAES.BEGUPDATE);
    END;
    IF MagicAES.CallResult = 1
    THEN
      WdwManager.RedrawWdw (wdwHandle, r);
      IF mouse
      THEN
        handleBusyMouse();
      END;
      MagicAES.WindUpdate (MagicAES.ENDUPDATE);
    ELSE
      IF mouse THEN mtAppl.MouseArrow(); END;
      RETURN FALSE
    END;
  ELSE
    mtDials.DialDraw (tree, 0, depth, r, clip);
  END;
  RETURN TRUE;
END DrawObjectInWdw;

PROCEDURE InitInfoSlider();
  VAR tmp  : BITSET;
BEGIN
  WITH slideVars DO
    (* slider anpassen an charWidth und charHeight *)
    mtUtils.ObjcRect (actBox, Initbar, pFrame);
    mtUtils.ObjcRect (actBox, Initslid, sFrame);
    (* Space berechnen *)
    pFrame.h := mtAppl.CharHeight;
    sFrame.h := mtAppl.CharHeight;
    sFrame.w := 1;
    Epp := (groupCount * 1000L DIV LONG(pFrame.w));
    mtUtils.SetObjcRect  (actBox, Initbar, pFrame);
    mtUtils.SetObjcRect  (actBox, Initslid, sFrame);
    lastWidth := 0;
    reinit := TRUE;
    fullInit := TRUE;
  END;
  (* Fllstil auf Solid und Farbe setzen, falls Farbe *)
  IF mtAppl.Bitplanes > 1
  THEN
    tmp := actBox^[Initslid].obSpec.Box.flags;
    tmp := tmp - {0..6} + {4..6} + {1};
    actBox^[Initslid].obSpec.Box.flags := tmp;
  END;
END InitInfoSlider;

PROCEDURE CalcInfoSlider (newValue : LONGCARD);
  VAR oldW : INTEGER;
      r    : GrafBase.Rectangle;
      startOb,
      depth : INTEGER;
BEGIN
  WITH slideVars DO
    WITH sFrame DO
      IF Epp > 0
      THEN
        w := SHORT((VAL(LONGINT,newValue)*1000L) DIV Epp);
      ELSE
        w := pFrame.w
      END;
      IF x+w > pFrame.w THEN w := pFrame.w END;
      IF w<=0 THEN w := 1 END;
      IF (lastWidth # w) OR reinit THEN
        mtUtils.SetObjcRect  (actBox, Initslid, sFrame);
        mtUtils.ObjcArea (actBox, Initslid, r);
        IF ~reinit
        THEN
          r.x := r.x + lastWidth;
          r.w := r.w - lastWidth + 1;
        ELSE
          mtUtils.ObjcArea (actBox, Initbar, r);
        END;
        IF fullInit THEN
          startOb := 0;
          depth := 8;
          mtUtils.ObjcArea (actBox, 0, r);
        ELSE
          startOb := Initbar;
          depth := 1;
        END;
        IF DrawObjectInWdw  (actBox, startOb, depth, r, TRUE, TRUE)
        THEN
          lastWidth := sFrame.w;
          reinit := FALSE;
          fullInit := FALSE;
        END;
      END;
    END;
  END;
END CalcInfoSlider;

PROCEDURE checkMouse (wdw: INTEGER);
  VAR w, v : INTEGER;
BEGIN
  WdwManager.GetTopWindow (w, v);
  IF ~WdwManager.IsOwnTop() & ~CatGlobal.multiTask
  THEN
    mtAppl.MouseArrow();
  END;
END checkMouse;

PROCEDURE InitInitBox ();
(* Initialisiert die Box, bringt das Fenster auf den Bildschirm
 *)
  VAR full : GrafBase.Rectangle;
      comps: BITSET;
      oldFrame: CHAR;
BEGIN
  (* Resourceadresse holen *)
  actBox := PutzRsc.GetTreeAddr (Initbox);
  InitInfoSlider();
  (* Outlined abschalten und Rand auf 1 Pixel setzen *)
  mtUtils.ExclFlag (actBox, 0, MagicAES.OUTLINED);
  oldFrame := actBox^[0].obSpec.Box.frame;
  actBox^[0].obSpec.Box.frame := CAST(CHAR, -1);
  mtDials.DialCenter (actBox, mtDials.CSCREEN, 0, 0, rect);
  mtUtils.ObjcArea (actBox, 0, rect);
  (* Jetzt Fenster fr Box ffnen *)
  comps := {MagicAES.NAME, MagicAES.MOVE};
  MagicAES.WindCalc (MagicAES.WCBORDER, comps, rect, full);
  IF full.y < WdwManager.deskSize.y THEN full.y := WdwManager.deskSize.y END;
  IF full.x < WdwManager.deskSize.x THEN full.x := WdwManager.deskSize.x END;
  IF WdwManager.OpenWindow (bProc, kProc, WdwManager.handleTimerProc (NIL), 
                            full, full, comps, 
                            FALSE, '', 'CATPUTZ', WdwManager.snapProc (NIL),
                            closeP, redrawInfo, topP, 
                            untopP, updateP, setWork, getRect, 
                            WdwManager.hideProc(NIL), 0, actBox, 
                            TRUE, TRUE, FALSE, FALSE, wdwHandle, v.int)
  THEN
    inWindow := TRUE;
    WdwManager.FullRedrawWdw (wdwHandle);
    oldNewTop := WdwManager.handleNewTop;
    WdwManager.handleNewTop := checkMouse;
  ELSE
    inWindow := FALSE;
    mtUtils.InclFlag (actBox, 0, MagicAES.OUTLINED);
    actBox^[0].obSpec.Box.frame := oldFrame;
    MagicAES.WindUpdate (MagicAES.BEGUPDATE);
    mtDials.DialCenter (actBox, mtDials.CSCREEN, 0, 0, rect);
    mtDials.DialForm (actBox, mtDials.DSTART, rect, rect);
    mtDials.DialDraw (actBox, 0, 5, rect, FALSE);
  END;
  handleBusyMouse();
END InitInitBox;

PROCEDURE SetMaxValue (max: LONGINT);
(* Setzt den Maximalwert fr das Laden der Box
 *)
  VAR vr: GrafBase.Rectangle;
BEGIN
  groupCount := max;
  InitInfoSlider();
  v.bool := DrawObjectInWdw (actBox, 0, 8, vr, FALSE, TRUE);
END SetMaxValue;

PROCEDURE DoEvent ();
(* sieht per event_multi nach, ob eine Nachricht vorliegt *)
VAR z : CARDINAL;
    mBuff: ARRAY [0..15] OF INTEGER;
    dr   : RECORD
             CASE :BOOLEAN OF
               TRUE : x,y,w,h : INTEGER|
               FALSE: adr, dum: ADDRESS
             END
           END;
    event,
    evnt      : BITSET;
    doExit    : BOOLEAN;
    moX, moY  : INTEGER;
    moButton  : BITSET;
    kReturn   : INTEGER;
    moKState  : BITSET;
    bReturn   : INTEGER;
    sc        : INTEGER;
    char      : CHAR;
    scan      : CHAR;
BEGIN
    (* Hier bei MultiTasking noch eine kleiner EventMulti und ein paar
     * Events verarbeiten 
     *)
  LOOP
    evnt := MagicAES.EvntMulti(
               {MagicAES.MUMESAG, MagicAES.MUTIMER},
                0,{},{}, 0,dr, 0, dr, mBuff, 0, 0,
                moX, moY, moButton, kReturn, moKState, sc, char, bReturn);
    (* Den Timerevent brauchen wir nicht *)
    event := evnt;
    EXCL (event, MagicAES.MUTIMER);
    doExit := event = BITSET{};

    IF doExit THEN EXIT END;
    scan := 0C;
    MagicAES.WindUpdate(MagicAES.BEGUPDATE);
    v.bool := WdwManager.HandleEvent (evnt, mBuff, moButton, moKState, char, scan, kReturn, moX, moY, bReturn);
    MagicAES.WindUpdate(MagicAES.ENDUPDATE);
  END;
END DoEvent;

PROCEDURE SetCurrentValue (value: LONGINT);
(* Setzt den aktuellen Wert fr die Box
 *)
BEGIN
  CalcInfoSlider(value);
  DoEvent();
END SetCurrentValue;

PROCEDURE CloseInitBox ();
(* Schliet die Box wieder
 *)
BEGIN
  IF inWindow
  THEN
    inWindow := FALSE;
    v.bool := WdwManager.CloseWindow (wdwHandle, TRUE);
    wdwHandle := -1;
    WdwManager.handleNewTop := oldNewTop;
  ELSE
    mtDials.DialForm (actBox, mtDials.DFINISH, rect, rect);
    MagicAES.WindUpdate (MagicAES.ENDUPDATE);
  END;
  mtAppl.MouseArrow;
END CloseInitBox;

BEGIN
  groupCount := 1;
END PutzInit.
