IMPLEMENTATION MODULE PutzRsc; (*$M-*)

FROM SYSTEM     IMPORT  ADR, TSIZE, ASSEMBLER, ADDRESS, CADR, CAST, BYTE;

(*$R-,S-*)
(*  Graphics  *)

(* GrafBase kann ich benutzen, da keine Aufrufe der MM2 GEM-Library gemacht
 * werden
 *)

FROM GrafBase   IMPORT Rect, Point, Rectangle, FrameRects,
                       MemFormDef, BitOperation, TransRect;
                     
(* Importe aus der MagicLib: *)

FROM MagicTypes IMPORT MFORM;

FROM MagicSys   IMPORT sBITSET, sINTEGER, sCARDINAL, CastToInt;

FROM MagicAES   IMPORT
     OBJECT, SELECTABLE, SELECTED, DISABLED, SHADOWED, EDITABLE,
     Exit, DEFAULT, OUTLINED, HIDETREE,
     GBOX, GIBOX, GBOXCHAR, GIMAGE, GICON, GTEXT, GBOXTEXT,
     GFTEXT, GFBOXTEXT, GBUTTON,
     RED, BLUE, BLACK,
     AESIntIn, AESIntOut, EvntPmulti, MUKEYBD, MUTIMER,
     CallResult, BoxInfo,
     ObjcOffset,  ObjcDraw ,
     WindUpdate, ENDUPDATE, BEGUPDATE, ENDMCTRL, BEGMCTRL,
     ShelRead, ShelFind,
     RTREE, RFRSTR, RSTRING,
     Horizontal, Vertical, GrafSlidebox, GrafHandle,
     GrafMkstate, GrafMouse, USERDEF,
     WindGet, WFWORKXYWH,
     EvntTimer;
     
FROM MagicVDI   IMPORT
     TransformForm, REPLACE, CopyRasterOpaque, SetFillcolor;

FROM MagicDOS    IMPORT Dgetpath, Dgetdrv;

FROM mtAppl     IMPORT
     ApplInit, ApplTerm, ApplIdent, ApplPath, VDIHandle, MaxWidth, MaxHeight,
     MouseArrow, MouseBusy, MouseUser, UserMouse, Bitplanes;

FROM mtUtils         IMPORT SetObjcStringAdr, SetObjcString, ObjcString,
                            InclFlag, ExclFlag, InFlag, InclState, 
                            InState, ObjcStrLen, SetObjcRect, tRect,
                            CalcArea, ObjcRect;

FROM mtPopups   IMPORT TreePopup;

FROM mtAlerts IMPORT
     Alert, SetIconColor;
     
FROM mtDir      IMPORT GetDir;

IMPORT Mintbind;

IMPORT MagicStrings, mtTextfiles, MagicDOS, mtTime, mtDials, mtUtils, mtRsc;

FROM SysUtil0   IMPORT WExcl;

IMPORT Strings;

FROM StrConv    IMPORT StrToInt, IntToStr;

FROM FileNames  IMPORT SplitPath, ConcatPath, PathConc;

FROM BinOps     IMPORT LowerInt;

FROM ConvertDate        IMPORT DateOk, StrToDate, CurrentDate;

FROM PutzTypes           IMPORT delState, defaultOpts;
IMPORT PutzTypes, PutzHelp;

FROM FontSelect         IMPORT DoSelectFont, UnloadFonts;

FROM Void   IMPORT v;

IMPORT Catputz2; (* Resource-Definitions *)

IMPORT CatGlobal, ConfVars, WdwManager, WinDials, VDIUtil, Varnames;



CONST

  NoWinDial  = "[3][CATPUTZ:|Es ist kein Fenster|fr den Dialog verfgbar!|Bitte schlieen sie ein|anderes Fenster.][[OK]";

VAR
        apId            : CARDINAL;
        gemHdl          : INTEGER;
        devHdl          : INTEGER;
        
        charWidth,
        charHeight      : INTEGER;
        
        vr              : tRect;
        
        globalResButton : INTEGER;

VAR     theRSC          : mtRsc.RESOURCE;

        
        (* image und icon-konvertierung *)
                
PROCEDURE vdiFix (VAR pfd : MemFormDef; theAddr : ADDRESS;
                  wb, h : CARDINAL);
BEGIN
  WITH pfd DO
    words  := wb DIV 2;
    w      := wb * 8;
    h      := h;
    planes := 1;   (* monochrom *)
    start  := theAddr;
  END;
END vdiFix;

PROCEDURE vdiTrans (source : ADDRESS; sourceWb : CARDINAL;
                    dest   : ADDRESS; destWb   : CARDINAL;
                    h   : CARDINAL; handle : INTEGER);
                    
  VAR src, dst : MemFormDef;
BEGIN
  vdiFix (src, source, sourceWb, h);
  src.standardForm := TRUE;
  vdiFix (dst, dest, destWb, h);
  dst.standardForm := FALSE;
  TransformForm (handle, src, dst);
END vdiTrans;

PROCEDURE transBitBlk (spec : PtrBitBlock; handle : INTEGER);
  VAR tAddr : ADDRESS;
      wb, hl : CARDINAL;
BEGIN
  tAddr := spec^.biData;
  IF tAddr = ADDRESS(-1L) THEN RETURN END;
  wb := spec^.biWb;
  hl := spec^.biHl;
  vdiTrans (tAddr, wb, tAddr, wb, hl, handle);
END transBitBlk;

PROCEDURE transObj ( tree : PtrObjTree; obj : CARDINAL; handle : INTEGER);
  VAR wb, hl    : CARDINAL;
      tAddr     : ADDRESS;
      spec      : PtrIconBlock;
      type      : INTEGER;
BEGIN
  type := tree^[obj].obType MOD 255;
  spec := PtrIconBlock(tree^[obj].obSpec.IconPtr);
  
  CASE type OF
                GIMAGE   : transBitBlk (ADDRESS(spec), handle); |
                GICON    : hl := spec^.ibHicon;
                           wb := (spec^.ibWicon + 7) DIV 8;
                           tAddr := spec^.ibPdata;
                           IF tAddr # ADDRESS(-1L)
                           THEN
                             vdiTrans (tAddr, wb, tAddr, wb, hl, handle)
                           END;
                           tAddr := spec^.ibPmask;
                           IF tAddr # ADDRESS(-1L)
                           THEN
                             vdiTrans (tAddr, wb, tAddr, wb, hl, handle)
                           END;
                           
  ELSE
  END (* CASE *)
END transObj;

        (*  Routinen fr den Umgang mit Objektbumen  *)
        (*  ========================================  *)

PROCEDURE SelectButton (dial: ADDRESS; button: CARDINAL; redraw : BOOLEAN);
    VAR r1 : tRect;
  BEGIN
    mtUtils.ObjcArea (dial, button, r1);
    InclState (dial, button, SELECTED);
    IF redraw THEN WinDials.WinDialDraw (dial, button, 0, r1, TRUE) END;
  END SelectButton;
  
PROCEDURE DeselectButton (dial: ADDRESS; button: CARDINAL; redraw : BOOLEAN);
    VAR r1 : tRect;
  BEGIN
    mtUtils.ObjcArea (dial, button, r1);
    mtUtils.ExclState (dial, button, SELECTED);
    IF redraw THEN WinDials.WinDialDraw (dial, button, 0, r1, FALSE) END;
  END DeselectButton;
  
PROCEDURE DoSimpleBox (form: ADDRESS) : INTEGER;
    VAR i : INTEGER;
  BEGIN
     i:= WinDials.WinDialDo (form, 0);
     RETURN i
  END DoSimpleBox;

VAR  homePath: MaxStr;

PROCEDURE GetHomePath();
VAR applpath:   MaxStr;
    shelPath:   MaxStr;
    shelCmd:    MaxStr;
    cDrv:       INTEGER;
BEGIN
  cDrv := Dgetdrv();
  Dgetpath (applpath, cDrv+1);
  Strings.Insert ('A:',0, applpath, v.bool);
  applpath [0] := CHR(ORD('A')+CARDINAL(cDrv));
  IF applpath[LENGTH(applpath)-1] # '\'
  THEN
    Strings.Append ('\',applpath, v.bool);
  END;
(*  ApplPath (applpath); *)
  ShelRead (shelPath, shelCmd);
  (* Jetzt haben wir den aktuellen Pfad und den aus ShellRead.
   * Jetzt mssen wir nur noch testen, welches der richtige ist
   *)
  IF Strings.Pos ('PUTZ',shelPath,0) >= 0
  THEN
    (* Im ShellPfad ist PUTZ drin, also wird der wohl stimmen *)
    SplitPath (shelPath, homePath, shelCmd);
    IF Strings.Empty (homePath)
    THEN
      Strings.Assign (applpath, homePath, v.bool);
    END;
  ELSE
    (* PUTZ ist nicht im ShellPfad, dann nehmen wir lieber den aktuellen *)
    Strings.Assign (applpath, homePath, v.bool);
  END;
END GetHomePath;

CONST   parameterFile    = 'CATPUTZ.CFG';

CONST   (* catPutzFileMagic    = 28011968L + 00400000000L; *)
        (* catPutzFileMagic    = 02031991L + 00400000000L; *)
        (* catPutzFileMagic    = 30041991L + 00400000000L; *)
        (* catPutzFileMagic    = 08051991L + 00400000000L; *)
        (* catPutzFileMagic    = 14051991L + 00400000000L; *)
        (* catPutzFileMagic    = 03071991L + 00400000000L; *)
        (* catPutzFileMagic    = 19011992L + 00400000000L;*)
        (* catPutzFileMagic    = 15041992L + 00400000000L; *)
        (* Ab CatPutz 2.10 kein Magic mehr, nun Ascii-File *)

PROCEDURE ReplaceStr (VAR str : ARRAY OF CHAR; REF s1, s2 : ARRAY OF CHAR);
  VAR p : CARDINAL;
      sLen : CARDINAL;
      s1Len: CARDINAL; 
BEGIN
  sLen := LENGTH (str);
  s1Len:= LENGTH (s1);
  p := MagicStrings.Pos (s1, str, 0, FALSE);
  WHILE p <= sLen DO
    MagicStrings.Delete (str, p, s1Len);
    MagicStrings.Insert (s2, str, p);
    sLen := LENGTH (str);
    p := MagicStrings.Pos (s1, str, p, FALSE);
  END;
END ReplaceStr;

PROCEDURE writeInfo (REF inf: mtTextfiles.TEXTFILE);
  VAR z1 : CARDINAL;
      d, m, y : CARDINAL;
      mname  : ARRAY [0..3] OF CHAR;
      tstr   : ARRAY [0..12] OF CHAR;
BEGIN
  mtTextfiles.WriteLine (inf, '# ');
  mtTextfiles.WriteLine (inf, PutzTypes.whatText);
  mtTextfiles.WriteLn (inf);
  z1 := MagicDOS.Tgetdate();
  mtTime.DecodeDate (z1, d, m, y);
  mtTime.NameOfMonth (mtTime.English, m, mname);
  mname[3] := ' ';
  mtTextfiles.WriteLine (inf, '# configuration file');
  mtTextfiles.WriteLn (inf);
  mtTextfiles.WriteLine (inf, '# created ');
  mtTextfiles.WriteLine (inf, mname);
  mtTextfiles.WriteCard (inf, d, 0);
  mtTextfiles.WriteLine (inf, ' ');
  mtTextfiles.WriteCard (inf, y, 0);
  mtTextfiles.WriteLine (inf, ', ');
  mtTime.TimeString (MagicDOS.Tgettime(), tstr);
  mtTextfiles.WriteLine (inf, tstr);
  mtTextfiles.WriteLn (inf);
END writeInfo;

CONST   (* Variablennamen *)
        cWdwRect    = 'StatWindowRect';
        cWdwFont    = 'StatFont';
        cWdwFontSize= 'StatFontSize';
        cWdwTop     = 'StatWindowStart';
        cWdwOpen    = 'StatWindowOpen';
        cUseTmp     = 'UseTempPath';
        cTmpLock    = 'UseOwnTempPath';
        cDeselAfterDel = 'DeselectGroupsAfterDelete';
        cDelNoComm  = 'DeleteMsgWithoutComment';
        cTmpDir     = 'TmpDir';
        cIconify    = 'IconifyEnabled';

PROCEDURE SaveParameter (REF path: ARRAY OF CHAR);

  VAR   magic: LONGCARD;
        ok: BOOLEAN;
        fName,
        infName : PutzTypes.FileStr;
        gName,
        varName : PutzTypes.FileStr;
  BEGIN
    CatGlobal.busyMouse;
    (* Und jetzt die Default-Optionen *)
    (* Gruppennamen von Leerzeichen befreien *)
    MagicStrings.Assign ('Default', gName);
    ReplaceStr (gName, ' ','_');    (* Spaces durch Underscores ersetzen *)
    (* Variablennamen zusammenbauen *)
    (* Fr Interessant-Flag *)
    MagicStrings.Assign (gName, varName);
    MagicStrings.Append ('.delInteresting', varName);
    ok := ConfVars.SetConfigInt (varName, ORD(defaultOpts.intFlag));
    (* Fr User-Flag 1 *)
    MagicStrings.Assign (gName, varName);
    MagicStrings.Append ('.delUserflag1', varName);
    ok := ConfVars.SetConfigInt (varName, ORD(defaultOpts.usrFlg1));
    (* Fr User-Flag 2 *)
    MagicStrings.Assign (gName, varName);
    MagicStrings.Append ('.delUserflag2', varName);
    ok := ConfVars.SetConfigInt (varName, ORD(defaultOpts.usrFlg2));
    (* Fr Gelesen-Flag *)
    MagicStrings.Assign (gName, varName);
    MagicStrings.Append ('.delRead', varName);
    ok := ConfVars.SetConfigInt (varName, ORD(defaultOpts.readFlg));
    (* Fr Gefiltert-Flag *)
    MagicStrings.Assign (gName, varName);
    MagicStrings.Append ('.delFiltered', varName);
    ok := ConfVars.SetConfigInt (varName, ORD(defaultOpts.filtFlg));
    (* Fr Ungelesen-Flag *)
    MagicStrings.Assign (gName, varName);
    MagicStrings.Append ('.delUnread', varName);
    ok := ConfVars.SetConfigInt (varName, ORD(defaultOpts.noRdFlg));
    (* Lschdatum zusammensetzen *)
    MagicStrings.Assign (gName, varName);
    MagicStrings.Append ('.deleteByDate', varName);
    ok := ConfVars.SetConfigBool (varName, defaultOpts.deleteByDate);
    IF defaultOpts.deleteByDate
    THEN
      (* Lschdatum zusammensetzen *)
      MagicStrings.Assign (gName, varName);
      MagicStrings.Append ('.deleteDate', varName);
      ok := ConfVars.SetConfigString (varName, defaultOpts.dateStr);
    END;
    (* Jetzt noch die anderen Parameter *)
    WITH defaultOpts DO
      ok := ConfVars.SetConfigBool (cUseTmp, useTmp);
      ok := ConfVars.SetConfigBool (cTmpLock, tmpLock);
      ok := ConfVars.SetConfigBool (cDeselAfterDel, deselAfterDel);
      ok := ConfVars.SetConfigString (cTmpDir, tmpDir);
      ok := ConfVars.SetConfigBool (cDelNoComm, delWithoutComm);
    END;

    ConcatPath (path, parameterFile, infName);
    
    (* Und jetzt schreiben *)
    ok := ConfVars.WriteConfigFile (infName, writeInfo);

    MouseArrow;
  END SaveParameter;

PROCEDURE LoadParameter (REF path : ARRAY OF CHAR);

  VAR   ok     : BOOLEAN;
        name   : PutzTypes.FileStr;
        gName,   
        varName : PutzTypes.FileStr;
        val     : INTEGER;
        boolVal : BOOLEAN;
        delStr  : PutzTypes.FileStr;
  
  BEGIN
    CatGlobal.busyMouse;
    
    ConfVars.DeleteAllVars();
    ConcatPath (path,parameterFile, name);
    ok := ConfVars.ReadConfigFile (name);
    IF ~ok
    THEN
      Strings.Assign (parameterFile, name, v.bool);
      ShelFind (name);
      ok := ConfVars.ReadConfigFile (name);
    END;
    IF ~ok THEN
      RETURN
    END;
    
    (* Prfen, wie die Alerts aussehen sollen *)
    ConfVars.GetConfDefBool (cWinAlerts, v.bool, FALSE);
    WinDials.AlertsInWindow (v.bool);

    (* Variablennamen zusammenbauen *)
    (* Fr Interessant-Flag *)
    MagicStrings.Assign ('Default', gName);
    MagicStrings.Assign (gName, varName);
    MagicStrings.Append ('.delInteresting', varName);
    ConfVars.GetConfDefInt (varName, val, ORD(defaultOpts.intFlag));
    defaultOpts.intFlag := delState (val);
    (* Fr User-Flag 1 *)
    MagicStrings.Assign (gName, varName);
    MagicStrings.Append ('.delUserflag1', varName);
    ConfVars.GetConfDefInt (varName, val, ORD(defaultOpts.usrFlg1));
    defaultOpts.usrFlg1 := delState (val);
    (* Fr User-Flag 2 *)
    MagicStrings.Assign (gName, varName);
    MagicStrings.Append ('.delUserflag2', varName);
    ConfVars.GetConfDefInt (varName, val, ORD(defaultOpts.usrFlg2));
    defaultOpts.usrFlg2 := delState (val);
    (* Fr Gelesen-Flag *)
    MagicStrings.Assign (gName, varName);
    MagicStrings.Append ('.delRead', varName);
    ConfVars.GetConfDefInt (varName, val, ORD(defaultOpts.readFlg));
    defaultOpts.readFlg := delState (val);
    (* Fr Gefiltert-Flag *)
    MagicStrings.Assign (gName, varName);
    MagicStrings.Append ('.delFiltered', varName);
    ConfVars.GetConfDefInt (varName, val, ORD(defaultOpts.filtFlg));
    defaultOpts.filtFlg := delState (val);
    (* Fr Ungelesen-Flag *)
    MagicStrings.Assign (gName, varName);
    MagicStrings.Append ('.delUnread', varName);
    ConfVars.GetConfDefInt (varName, val, ORD(defaultOpts.noRdFlg));
    defaultOpts.noRdFlg := delState (val);
    (* Lschdatum zusammensetzen *)
    MagicStrings.Assign (gName, varName);
    MagicStrings.Append ('.deleteByDate', varName);
    ConfVars.GetConfDefBool (varName, boolVal, defaultOpts.deleteByDate);
    defaultOpts.deleteByDate := boolVal;
    IF boolVal
    THEN
      (* Datum holen *)
      (* Lschdatum zusammensetzen *)
      MagicStrings.Assign (gName, varName);
      MagicStrings.Append ('.deleteDate', varName);
      ConfVars.GetConfDefStr (varName, defaultOpts.dateStr, defaultOpts.dateStr);
      IF DateOk (defaultOpts.dateStr)
      THEN
        defaultOpts.delDate := StrToDate (defaultOpts.dateStr);
      ELSE
        (* Eventuell Alert bringen? *)
        defaultOpts.deleteByDate := FALSE;
      END;
    END;
    
    WITH defaultOpts DO
      ConfVars.GetConfDefBool (cUseTmp, useTmp, useTmp);
      ConfVars.GetConfDefBool (cTmpLock, tmpLock, tmpLock);
      ConfVars.GetConfDefBool (cDeselAfterDel, deselAfterDel, deselAfterDel);
      ConfVars.GetConfDefBool (cDelNoComm, delWithoutComm, delWithoutComm);
      ConfVars.GetConfDefStr (cTmpDir, tmpDir, tmpDir);
    END;
    
    (* Prfen, ob wir in der Mint-Domain laufen sollen *)
    ConfVars.GetConfDefBool (cMintDomain, v.bool, TRUE);
    IF v.bool
    THEN
      v.int := Mintbind.Pdomain (0);
      CatGlobal.isMintDomain := Mintbind.Pdomain (1) = 0;
    ELSE
      v.int := Mintbind.Pdomain (0);
      CatGlobal.isMintDomain := FALSE;
    END;

    MouseArrow;
  END LoadParameter;

VAR MaxBoxStrLen : INTEGER;

PROCEDURE InitResource (VAR resourceName : ARRAY OF CHAR) : BOOLEAN;
  
  CONST
        noRscAlt        = '[5][Kann das Resource-File|CATPUTZ.RSC nicht laden][ [Schade.. ]';
        
        noLowResAlt     = '[4][Die gewhlte Auflsung|ist zu niedrig|fr CatPutz!][ [OK ]';
        
  VAR success     : BOOLEAN;
      screenColumns : CARDINAL;
      box         : BoxInfo;
      rscLoaded   : BOOLEAN;
      rscString   : PutzTypes.FileStr;
  BEGIN
    
    devHdl := VDIHandle;
    GrafHandle (gemHdl, charWidth, charHeight, v.int, v.int);
    
    apId  := ApplIdent;
    
    GetHomePath();
    
    (* 80-Zeichen Bildschirm wird verlangt! *)
    screenColumns := MaxWidth DIV charWidth;
    
    IF screenColumns < 80
    THEN
      v.int := Alert(1,noLowResAlt);
      RETURN FALSE
    END;
                  (* Resource laden und Baumaddressen ermitteln *)
    rscLoaded := mtRsc.LoadRsc (resourceName, theRSC); 
    IF ~rscLoaded
    THEN
      Strings.Concat (homePath, resourceName, rscString, v.bool);
      rscLoaded := mtRsc.LoadRsc (rscString, theRSC); 
    END;
    IF ~rscLoaded
    THEN
      (* Test auf Develop-Resource *)
      Strings.Assign ('CATPUTZ2.RSC', resourceName, v.bool);
      rscLoaded := mtRsc.LoadRsc (resourceName, theRSC); 
    END;
    IF ~rscLoaded
    THEN
      SetIconColor (RED);
      v.int := Alert (1,noRscAlt);
      SetIconColor (BLACK);
      RETURN FALSE
    END;
    
    CatGlobal.busyMouse;
    
    selectBox := mtRsc.GaddrRsc (theRSC, RTREE, Selectbx);
    helpBox   := mtRsc.GaddrRsc (theRSC, RTREE, Helpbox);
    infoBox   := mtRsc.GaddrRsc (theRSC, RTREE, Infobox);
    pathBox   := mtRsc.GaddrRsc (theRSC, RTREE, Parambox);
    info2Box  := mtRsc.GaddrRsc (theRSC, RTREE, Infobox2);
    optBox    := mtRsc.GaddrRsc (theRSC, RTREE, Optionbx);
    actBox    := mtRsc.GaddrRsc (theRSC, RTREE, Actionbx);
    wdwIcon   := mtRsc.GaddrRsc (theRSC, RTREE, Putzicon);
    menu      := mtRsc.GaddrRsc (theRSC, RTREE, Menu);

    (* Versionsnummer einsetzen *)
    mtUtils.SetObjcString (infoBox, Version, PutzTypes.version);
    mtUtils.SetObjcString (infoBox, Vdate, PutzTypes.cDate);
    
    (* Bit Images anpassen *)
    
    transObj (infoBox, Thecat0, devHdl);
    transObj (infoBox, Thecat1, devHdl);
    transObj (infoBox, Thecat2, devHdl);
    transObj (infoBox, Theputz, devHdl);
    transObj (wdwIcon, 1, devHdl);
    
    (* Infoslider anpassen: Fllmuster auf solid setzen *)
    IF Bitplanes > 1
    THEN
      box := actBox^[Infoslid].obSpec.Box;
      EXCL(box.flags,0);
      EXCL(box.flags,2);
      EXCL(box.flags,3);
      INCL(box.flags,1);
      INCL(box.flags,4);
      INCL(box.flags,5);
      INCL(box.flags,6);
      actBox^[Infoslid].obSpec.Box := box;
    END;
    
    WdwManager.SetWindowIcon (wdwIcon);
    
    RETURN TRUE
  END InitResource;
  
PROCEDURE doInfo();
  VAR but : INTEGER;
BEGIN
  but := DoSimpleBox (infoBox);
  IF but = Infoinfo
  THEN
    but := DoSimpleBox (info2Box);
  END;
END doInfo;

PROCEDURE ClrRsrc();
BEGIN
  mtRsc.FreeRsc(theRSC);
END ClrRsrc;

TYPE Trick =  POINTER TO RECORD
                CASE : BOOLEAN OF
                  TRUE:  wert: sINTEGER;|
                  FALSE: hi: CHAR;
                         lo: CHAR;|
                END;
               END;
  
PROCEDURE optsGetSetValues (tree: ADDRESS; private: ADDRESS; 
                           set: BOOLEAN; exit: INTEGER);
  VAR putzOpts: POINTER TO PutzTypes.putzOptsRec;
BEGIN
  putzOpts := private;
  IF set
  THEN (* set *)
    WITH putzOpts^ DO
      mtUtils.SetState (optBox, Odeldate, SELECTED, deleteByDate);
      mtUtils.SetState (optBox, Odatestr, DISABLED, ~deleteByDate);
      mtUtils.SetFlag (optBox, Odatestr, EDITABLE, deleteByDate);
      mtUtils.SetObjcString (optBox, Odatestr, dateStr);
      VDIUtil.SetXState (optBox, Iflgsel, ORD(intFlag));
      VDIUtil.SetXState (optBox, Uflg1sl1, ORD(usrFlg1));
      VDIUtil.SetXState (optBox, Uflg2sl1, ORD(usrFlg2));
      VDIUtil.SetXState (optBox, Rdflgsl1, ORD(readFlg));
      VDIUtil.SetXState (optBox, Filtflg1, ORD(filtFlg));
      VDIUtil.SetXState (optBox, Nordflg1, ORD(noRdFlg));
      VDIUtil.SetXString (optBox, Iflgsel , selectBox, ORD(intFlag));
      VDIUtil.SetXString (optBox, Uflg1sl1, selectBox, ORD(usrFlg1));
      VDIUtil.SetXString (optBox, Uflg2sl1, selectBox, ORD(usrFlg2));
      VDIUtil.SetXString (optBox, Rdflgsl1, selectBox, ORD(readFlg));
      VDIUtil.SetXString (optBox, Filtflg1, selectBox, ORD(filtFlg));
      VDIUtil.SetXString (optBox, Nordflg1, selectBox, ORD(noRdFlg));
    END;
  ELSE
    exit := INTEGER(BITSET(exit) - {15});    
    IF exit = Ook
    THEN
     WITH putzOpts^ DO
      intFlag := delState(VDIUtil.GetXState (optBox, Iflgsel ));
      usrFlg1 := delState(VDIUtil.GetXState (optBox, Uflg1sl1));
      usrFlg2 := delState(VDIUtil.GetXState (optBox, Uflg2sl1));
      readFlg := delState(VDIUtil.GetXState (optBox, Rdflgsl1));
      filtFlg := delState(VDIUtil.GetXState (optBox, Filtflg1));
      noRdFlg := delState(VDIUtil.GetXState (optBox, Nordflg1));
      deleteByDate := InState (optBox, Odeldate, SELECTED);
      ObjcString (optBox, Odatestr, dateStr);
      delDate := StrToDate (dateStr);
     END;
    END;
  END;
END optsGetSetValues;
     
PROCEDURE optsButton (tree: ADDRESS; private: ADDRESS; button: INTEGER;
                      mx, my : INTEGER; kstate: BITSET; clicks: INTEGER): BOOLEAN;

  CONST illDate = '[3][Das Datum ist|nicht gltig!][ [Neu ]';
        dateToLarge = '[3][Das Datum ist|grer als das|aktuelle Tagesdatum!][ [Neu ]';
  
  VAR but       : INTEGER;
      dStr      : ARRAY [0..20] OF CHAR;
      allOk     : BOOLEAN;
      x, y      : INTEGER;
      select    : INTEGER;
      selStr    : ARRAY [0..40] OF CHAR;
      t         : Trick;
      dByDate   : BOOLEAN;

BEGIN
  but := INTEGER(BITSET(button) - {15});
  globalResButton := but;
  CASE but OF
    Iflgsel,
    Uflg1sl1,
    Uflg2sl1,
    Rdflgsl1,
    Filtflg1,
    Nordflg1    : ObjcOffset (optBox, but, x, y);
                  t := ADR (optBox^[but].obState);
                  select := TreePopup (selectBox, x, y, ORD(t^.hi))-1;
                  IF select >= 0 THEN
                   t^.hi := CHR(select);
                   VDIUtil.SetXString (optBox, but, selectBox, select);
                   WinDials.WinDialDraw (optBox, but, 0, vr, FALSE);
                  END;|
    Iflgsel2,
    Uflg1sl2,
    Uflg2sl2,
    Rdflgsl2,
    Filtflg2,
    Nordflg2    : t := ADR (optBox^[but-1].obState);
                  t^.hi := CHR((ORD(t^.hi)+1) MOD 4);
                  select := ORD (t^.hi);
                  ObjcString (selectBox, select+1, selStr);
                  Strings.DelLeadingBlanks (selStr);
                  mtUtils.SetObjcString (optBox, but-1, selStr);
                  WinDials.WinDialDraw (optBox, but-1, 0, vr, FALSE); |
    Odeldate    : dByDate := mtUtils.InState (optBox, Odeldate, SELECTED);
                  mtUtils.SetState (optBox, Odatestr, DISABLED, ~dByDate);
                  mtUtils.SetFlag (optBox, Odatestr, EDITABLE, dByDate);
                  WinDials.WinDialDraw (optBox, Odatestr, 0, vr, FALSE); |
    Ohilfe      : (*
                  mtDials.DialForm (optBox, mtDials.DDISABLE, vr, vr);
                  v.int := DoSimpleBox (helpBox);
                  mtDials.DialForm (optBox, mtDials.DENABLE, vr, vr);
                  *)
                  PutzHelp.DoHelp (PutzHelp.flags);
                  DeselectButton (optBox, but, TRUE); |
    Ook         : ObjcString (optBox, Odatestr, dStr);
                  IF ~InState (optBox, Odatestr, DISABLED)
                  THEN
                    IF ~DateOk (dStr)
                    THEN
                      v.int := Alert (1,illDate);
                      allOk := FALSE;
                      DeselectButton (optBox, but, TRUE);
                    ELSIF StrToDate (dStr) > CurrentDate()
                    THEN
                      v.int := Alert (1,dateToLarge);
                      allOk := FALSE;
                      DeselectButton (optBox, but, TRUE);
                    ELSE
                      allOk := TRUE;
                    END
                  ELSE
                    allOk := TRUE;
                  END;
                  mtUtils.ExclState (tree, but, SELECTED);
                  IF allOk
                  THEN
                    RETURN TRUE;
                  END; |
      Oquit     : mtUtils.ExclState (tree, but, SELECTED); 
                  RETURN TRUE;|
  ELSE
  END;
  RETURN FALSE;
END optsButton;

PROCEDURE doOptBox(oneGroup: BOOLEAN; VAR putzOpts: PutzTypes.putzOptsRec): BOOLEAN;

  VAR but       : INTEGER;
      dStr      : ARRAY [0..20] OF CHAR;
      allOk     : BOOLEAN;
      x, y      : INTEGER;
      select    : INTEGER;
      selStr    : ARRAY [0..40] OF CHAR;
      dByDate   : BOOLEAN;
      
  
BEGIN
  IF oneGroup
  THEN
    mtUtils.SetObjcString (optBox, Opttitle, 'Gruppenflags einstellen');
  ELSE
    mtUtils.SetObjcString (optBox, Opttitle, 'Defaultflags einstellen');
  END;
  mtUtils.SetFlag (optBox, Odatestr, EDITABLE, TRUE);
  IF ~WinDials.OpenWinDial (optBox, TRUE, 
                            optsGetSetValues,
                            optsGetSetValues,
                            optsButton,
                            WinDials.defDraw,
                            "",
                            ADR(putzOpts))
  THEN
    v.int := Alert (1, NoWinDial);
    RETURN FALSE;
  END;
  WinDials.WinDialHandleEvents();
  RETURN globalResButton = Ook;
END doOptBox;

(*
PROCEDURE doCheckBox() : BOOLEAN;
  VAR dateStr : ARRAY [0..39] OF CHAR;
      day, month, year,
      date    : LONGCARD;
      res     : INTEGER;
BEGIN
  IF ~putzOpts.deleteByDate THEN RETURN TRUE END;
  mtUtils.SetObjcString (confBox, Dcdeldate, putzOpts.dateStr);
(*
Das Datum hat ein etwas ungewhnliches Format (LONGCARD) :-):
aus 01.06.1990 20:23 wird 0006012023. d.h. vom Jahr wird 1990 abgezogen.
                          jjmmddhhmm

*)
  date := putzOpts.delDate DIV 10000;    (* Stunden und Minuten abschneiden *)
  day := (date - ((date DIV 100) * 100));
  month := (date - ((date DIV 10000) * 10000)) DIV 100;
  year := (date DIV 10000) + 1990;
  dateStr[0] := CHR(ORD('0')+SHORT(day DIV 10));
  dateStr[1] := CHR(ORD('0')+SHORT(day MOD 10));
  dateStr[2] := CHR(ORD('0')+SHORT(month DIV 10));
  dateStr[3] := CHR(ORD('0')+SHORT(month MOD 10));
  (* Jahr *)
  dateStr[4] := CHR(ORD('0')+SHORT(year DIV 1000));
  dateStr[5] := CHR(ORD('0')+SHORT((year DIV 100) MOD 10));
  dateStr[6] := CHR(ORD('0')+SHORT((year DIV 10) MOD 10));
  dateStr[7] := CHR(ORD('0')+SHORT(year MOD 10));
  dateStr[8] := 0C;
  mtUtils.SetObjcString (confBox, Dccalcdate, dateStr);
  res := DoSimpleBox (confBox);
  RETURN res = Dcok; 
END doCheckBox;
*)

TYPE    pathEnv     = RECORD
                        tempPath: MaxStr;
                        useTmp  : BOOLEAN;
                        exit    : INTEGER;
                      END;
        pathEnvPtr  = POINTER TO pathEnv;

PROCEDURE pathGetSetValues (tree: ADDRESS; private: ADDRESS; 
                            set: BOOLEAN; exit: INTEGER);
  VAR pEnv: pathEnvPtr;
BEGIN
  pEnv := private;
  IF set
  THEN
    mtUtils.SetObjcString (pathBox, Pbtname, pEnv^.tempPath);
    mtUtils.SetState (pathBox, Pbusetmp, SELECTED, pEnv^.useTmp);
    mtUtils.SetState (pathBox, Pblock, SELECTED, defaultOpts.tmpLock);
    mtUtils.SetState (pathBox, Pbdesel, SELECTED, defaultOpts.deselAfterDel);
    mtUtils.SetState (pathBox, Pbdelpar, SELECTED, defaultOpts.delWithoutComm);
  ELSE
    pEnv^.exit := INTEGER(BITSET(exit) - {15});;
    IF pEnv^.exit = Pbok
    THEN
      pEnv^.useTmp := InState (pathBox, Pbusetmp, SELECTED);
      defaultOpts.delWithoutComm := InState(pathBox, Pbdelpar, SELECTED);
      defaultOpts.tmpLock := InState(pathBox, Pblock, SELECTED);
      defaultOpts.deselAfterDel := InState(pathBox, Pbdesel, SELECTED);
    END;
  END;
END pathGetSetValues;

PROCEDURE pathButton (tree: ADDRESS; private: ADDRESS; button: INTEGER;
                      mx, my : INTEGER; kstate: BITSET; clicks: INTEGER): BOOLEAN;

  PROCEDURE getTmpPath (VAR s : ARRAY OF CHAR) : BOOLEAN;
    VAR targetPath : MaxStr;
        name    : ARRAY [0..20] OF CHAR;
        success : BOOLEAN;
  BEGIN
    Strings.Assign (s, targetPath, v.bool);
    Strings.Append ('*.*', targetPath, v.bool);
    name := 0C;
    success := GetDir (targetPath, name, "TMP-Pfad auswhlen");
    IF ~success THEN RETURN FALSE END;
    SplitPath(targetPath, s, name);
    RETURN TRUE
  END getTmpPath;

  VAR pEnv  : pathEnvPtr;  
      but   : INTEGER;
BEGIN
  pEnv := private;
  but := INTEGER(BITSET(button) - {15});
  CASE but OF
    Pbok,
    Pbquit     : mtUtils.ExclState (tree, but, SELECTED);
                 RETURN TRUE; |
    Pbhelp     : PutzHelp.DoHelp (PutzHelp.options); 
                 DeselectButton (tree, but, TRUE); |
    Pbtname    : IF getTmpPath(pEnv^.tempPath) THEN
                   mtUtils.SetObjcString (tree, but, pEnv^.tempPath);
                   WinDials.WinDialDraw (tree, but, 0, vr, FALSE);
                 END; |
                 (*
                 mtDials.DialDraw (pathBox, Root, MaxDepth, vr, FALSE); |
                 *)
  ELSE
  END;
  RETURN FALSE;
END pathButton;

PROCEDURE doPathBox (VAR useTmp : BOOLEAN; VAR tmp : ARRAY OF CHAR) : BOOLEAN;
  VAR pEnv:   pathEnv;
BEGIN
  MagicStrings.Assign (tmp, pEnv.tempPath);
  pEnv.useTmp := useTmp;
  IF ~WinDials.OpenWinDial (pathBox, TRUE, 
                            pathGetSetValues,
                            pathGetSetValues,
                            pathButton,
                            WinDials.defDraw,
                            "",
                            ADR(pEnv))
  THEN
    v.int := Alert (1, NoWinDial);
    RETURN FALSE;
  END;

  WinDials.WinDialHandleEvents();

  IF pEnv.exit = Pbok
  THEN
    useTmp := pEnv.useTmp;
    MagicStrings.Assign (pEnv.tempPath, tmp);
  END;
  RETURN pEnv.exit = Pbok;
END doPathBox;

PROCEDURE GetTreeAddr (tree: INTEGER): ADDRESS;
BEGIN
   RETURN mtRsc.GaddrRsc (theRSC, RTREE, tree);
END GetTreeAddr;

BEGIN
  WITH defaultOpts DO
    intFlag := ignoreFlag;
    usrFlg1 := ignoreFlag;
    usrFlg2 := ignoreFlag;
    readFlg := ignoreFlag;
    noRdFlg := ignoreFlag;
    deleteByDate := FALSE;
    tmpLock := FALSE;
    deselAfterDel := FALSE;
    delWithoutComm := TRUE;
    dateStr := '';
    useTmp  := FALSE;
    tmpDir  := 'C:\';
  END;
END PutzRsc.
