DEFINITION MODULE PutzTypes;

IMPORT dataSys, GroupSelect, Lists;

(* Versionsnummer *)
CONST   xVersion = '3.03 ';
        version = 'CatPutz V '+xVersion+0C;
        cDate    = '24.10.1997';

CONST  whatText  = '@(#)CatPutz V '+xVersion+' (c) 1992-1997 Dirk Steins'+0C;

TYPE    MaxStr    = ARRAY [0..255] OF CHAR;
        PtrMaxStr = POINTER TO MaxStr;

TYPE    FileStr     = ARRAY [0..255] OF CHAR;
        PathStr     = FileStr;

TYPE
        parArrayType  = ARRAY [0..65535] OF dataSys.pBlock;
        tabArrayType  = ARRAY [0..65535] OF CARDINAL;

        parFileType = RECORD
                        dbHeader : dataSys.FileHeaderType;
                        params   : parArrayType;
                      END;
        parFilePtr  = POINTER TO parFileType;
  
        ptrParArray = POINTER TO parArrayType;
        ptrTabArray = POINTER TO tabArrayType;

TYPE
        TextJustification = (justLeft, justCenter, justRight);
        
        delState    = (ignoreFlag, noDel, partDel, totalDel, badMess);
        
        delMode     = (dFlags, dNum, dDate, dDateAndNum);
         
        deleteProc  = PROCEDURE ( VAR (*param: *) dataSys.pBlock, 
                                      (*  idx: *) CARDINAL,
                                      (* pass: *) INTEGER) : delState;
       
        groupName   = ARRAY [0..255] OF CHAR;
  
        grListEntry = RECORD
                       info : GroupSelect.groupPtr;
                       selected : BOOLEAN;
                       badDel,
                       totalDel,
                       partDel  : LONGCARD;
                       preMsgs,
                       postMsgs,
                       preBytes,
                       postBytes  : LONGCARD;
                       tabDa,
                       parDa,
                       datDa    : BOOLEAN;
                     END;
       
        ptrGrEntry  = POINTER TO grListEntry;

        putzOptsRec = RECORD
                        intFlag,
                        usrFlg1,
                        usrFlg2,
                        readFlg,
                        filtFlg,
                        noRdFlg      : delState;
                        deleteByDate : BOOLEAN;
                        dateStr      : ARRAY [0..20] OF CHAR;
                        delDate      : LONGCARD;
                        useTmp       : BOOLEAN;
                        tmpLock      : BOOLEAN; (* festen Tmp-Pfad!! *)
                        delWithoutComm: BOOLEAN; (* Teilgelschte ohne Kommentar lschen *)
                        deselAfterDel: BOOLEAN;  (* Gruppe nach Lschen deselektiern *)
                        tmpDir       : ARRAY [0..255] OF CHAR;
                        dMode        : delMode;
                        number       : CARDINAL;
                      END;

TYPE    listEntryType   = (listHead1, listHead2, dataEntry, separatorLine);
        displayListEntry = RECORD
                             type: listEntryType;
                             data: ptrGrEntry;
                           END;

        ptrDispEntry    = POINTER TO displayListEntry;

VAR     defaultOpts : putzOptsRec;

        totalEntry  : grListEntry;

        tmpPath     : PathStr;
        
        putzList    : Lists.List;   (* Eigene Liste mit allen Daten *)

        groupList   : Lists.List;   (* Liste der Gruppen aus GroupSelect *)
      
        displayList : Lists.List;   (* Liste fr die Anzeige *)
        
        groupDeleted: BOOLEAN;

END PutzTypes.
