(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGICTOOLS   Modula's  All purpose  GEM  Interface  Cadre  Toolbox  *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 3.30  02.02.1992     (C)90/91/92 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden zu *
 * widerrufen.                                                          *
 *----------------------------------------------------------------------*)
 
(*----------------------------------------------------------------------*
 * mtCommand    Funktionen fr Kommandozeile und Environment            *
 *              Untersttzt Parameterbergabe nach ARGV                 *
 *----------------------------------------------------------------------*)

DEFINITION MODULE mtCommand;

FROM MagicSys   IMPORT  Nil, Null, Bit0, Bit1, Bit2, Bit3, Bit4, Bit5, Bit6,
                        Bit7, Bit8, Bit9, Bit10, Bit11, Bit12, Bit13, Bit14,
                        Bit15, LOC, Byte, ByteSet, sWORD, sINTEGER, sCARDINAL,
                        sBITSET, lINTEGER, lCARDINAL, lWORD, lBITSET;

 



PROCEDURE ArgV (): BOOLEAN;
(* TRUE, wenn die Parameter nach ARGV bergeben wurden *)

PROCEDURE ParamCount (): sINTEGER;
(* Anzahl der Parameter in der Kommandozeile, 0 wenn keine Parameter *)

PROCEDURE ParamString (n: sINTEGER; VAR arg: ARRAY OF CHAR);
(* Liefert das n'te Argument aus der Kommandozeile. Gibts n nicht, ist arg
 * leer.  Wurden die Argumente nach ARGV bergeben, ist das Argument mit
 * Nummer 0 der Pfad und Name des Programmes.
 *)

(* Einige bliche Environment-Variablen *)

CONST   EnvPath =       'PATH=';        (* Suchpfade *)
        EnvParent =     'PARENT=';      (* Name der aufrufenden Applikation *)
        EnvRows =       'ROWS=';        (* Anzahl der Zeilen auf dem Schirm *)
        EnvColumns =    'COLUMNS=';     (* Anzahl der Spalten auf dem Schirm *)
        EnvTempdir =    'TMPDIR=';      (* Temporres Verzeichnis *)
        EnvClipbrd =    'CLIPBRD=';     (* Clipboard-Verzeichnis *)
        EnvHome =       'HOME=';        (* Home-Path *)
        EnvEditor =     'EDITOR=';      (* Name des Default-Editors *)
        EnvShell =      'SHELL=';       (* Name der Shell *)
        EnvStderr =     'STDERR=';      (* Standard-Fehlerkanal *)

PROCEDURE EnvVar (REF  name: ARRAY OF CHAR; VAR value: ARRAY OF CHAR): BOOLEAN;
(* Sucht in einem eventuellen Environment eine Variable namens 'name' und
 * liefert deren Wert in 'value'. Returniert TRUE, wenn die Environment-
 * Variable gefunden wurde, sonst FALSE.
 *)

END mtCommand.

